/*
Dieses Modul enth"alt die Ausgabe-Funktionen sowie die Bezeichner der Funktions-Symbole aus der eingelesenen Spezifikation.
Ferner sind hier alle noch verwendbaren Daten der Spezifikation gesammelt, um ein Freigeben des vom Parser allokierten Speichers
zu erm"oglichen. (noch nicht realisiert!)

ACHTUNG : Ausgaben sind erst moeglich, nachdem mit IO_Initialisieren die internen Strukturen besetzt sind.

28.02.94 Angelegt. Arnim.
02.03.94 DruckeKopf, DruckeStatistik eingefuehrt. Arnim.
02.03.94 DruckeTerm eingefuegt. Thomas
02.03.94 DruckeKopf erweitert und IO_LF eingebaut. Arnim.
03.03.94 Funktions-Pointer und Makros fuer die Ausgaben waehrend des Systemslauf eingebaut.
         Bisher aber noch alles auskommentiert.
21.03.94 Makros fuer Ausgabe-Level-abhaengige Ausgaben eingebaut, die Sachen vom 03.03. 'rausgeworfen.
         Getestet mit und ohne Ausgaben, laeuft so wie es soll!
00.07.94 Weitere Makros eingebaut, andere geaendert bzw. geloescht.
22.02.95 Rekursion in DruckeTerm eliminiert. Thomas
20.06.96 Statistik- und Ergebnis-Kram ausgelagert (Statistiken.h) Arnim.
*/

/* Mit Hilfe zweier Konstanten aus Statistik-Parameter kann Kode ohne Aufrufe von Ausgabe-Funktionen 
   erzeugt werden! */


#ifndef AUSGABEN_H
#define AUSGABEN_H


/* -------------------------------------------------------*/
/* ------------- Includes --------------------------------*/
/* -------------------------------------------------------*/

#include "SymbolOperationen.h"
#include <stdlib.h>
#include "general.h"
#include "FehlerBehandlung.h"
#include "TermOperationen.h"
#include "Packen.h"
#include "InfoStrings.h"

#ifdef __cplusplus
extern "C" {
#endif

/* -------------------------------------------------------*/
/* ------------- IO-Konstanten und Defines ---------------*/
/* -------------------------------------------------------*/

#define IO_AUSGABEN 0                                                                        /* Alternativen: 0, 1 */

extern FILE *IO_Strom;

#define MaximaleBezeichnerLaenge 25     /* Dies ist die im Parser des RS-Praktikums vorgesehene Laenge, sie erscheint dort aber nur im Code !!! */
#define maxDrucklaengeInnererPfad 200   /* maximale Laenge des in der Prozedur IO_DruckeBaum ausgegebenen Pfades zu einem Blatt. Treten noch
                                           laengere Pfade auf, so werden fuer jedes Blatt nur die ersten 200 Zeichen des zu ihm fuehrenden
                                           Pfades ausgegeben, danach unmittelbar die Informationen aus den Blaettern. */
#define StartzahlVerkettungskuerzung 3  /* Sei s beliebiges einstelliges Funktionssymbol, t Element von Term(F,V), Topsymbol von t <> s.
					   Ein Term s(s(...s(t)...)) wird genau dann als s^n(t) ausgegeben, wenn n>=StartzahlVerkettungskuerzung. */
#define _IO_Ueberschriftenbreite 80

unsigned long int IO_AusdehnungAusgabestapel(void);

/* -------------------------------------------------------*/
/* -------------------------------------------------------*/
/* ------------- Initialisierung -------------------------*/
/* -------------------------------------------------------*/
/* -------------------------------------------------------*/

void IO_InitApriori(void);
/* Vor der ersten Ausgabe auf IO_Strom aufzurufen!!!! */

void IO_InitAposteriori(int level, char *Protokolldatei);
/* Legt die Ausgabe-relevanten Daten aus der Spezifikation als Datei-lokale Variablen ab. 
   ACHTUNG : Diese Initialisierung kann erst NACH der Initialisierung der Symbol-Operationen mit
   SO_Operationen erfolgreich durchgefuehrt werden. (siehe inits->IN_Initialisieren. *)
*/

void IO_ParamInfo(ParamInfoArtT what, int level, char* protfile);

void IO_CleanUp(void);
/* Interne Daten abraeumen. */

void IO_AusgabeLevelBesetzen(int level);
/* Stellt einen neuen Ausgabelevel ein. */

int IO_AusgabeLevel(void);
/* Liefert den aktuellen Ausgabelevel zurueck. */

void IO_AusgabenAus(void);
/* Schaltet unabhaengig vom aktuellen Ausgabelevel die Ausgaben aus.*/

void IO_AusgabenEin(void);
/* Schaltet die mit IO_AusgabenAus zuvor ausgeschalteten Ausgaben gemaess Einstellung wieder ein.*/

void IO_RingBell(void);
/* Einmal klingeln bitte. */

void IO_SpezifikationsnamenSetzen(char *Filename);
/* Setzt den Namen der bearbeiteten Spezifikation (incl. Pfad) ein.*/

char *IO_Spezifikationsname(void);
/* Gibt den Namen (und Pfad) der zu verwendeten Spez.datei zurueck.*/

/* -------------------------------------------------------*/
/* -------------- Kopf und Spezifikation -----------------*/
/* -------------------------------------------------------*/

void IO_DruckeKopf(void);
/* Druckt die Start-Meldung des Programmes. */

void IO_DruckeBeispiel(void);
/* Gibt die Parameter-Einstellungen aus */

/* -------------------------------------------------------*/
/* -------------------------------------------------------*/
/* ------------- AusgabeStrom steuern --------------------*/
/* -------------------------------------------------------*/
/* -------------------------------------------------------*/

/* Das Oeffnen eines alternativen Ausgabestroms (Protokolldatei aus Option -p) erfolgt in IO_InitAposteriori(),
   und zwar durch Umlenken von stdout in die angegebene Datei.*/

void IO_AusgabeStromUmlenken(const char *Filename);
/* Ausgabestrom temporaer umsetzen */

void IO_AusgabeStromZuruecksetzen(void);
/* Ausgabestrom auf urspruenglichen Wert zuruecksetzen */

/* void IO_AusgabeStromSchliessen(void);*/
/* Schliesst den vorhandenen Ausgabestrom und lenkt die Ausgaben wieder auf stdout. */
/* wird von IO_CleanUp uebernommen.*/

/* -------------------------------------------------------*/
/* -------------------------------------------------------*/
/* ------------- Elementare Druck-Funktionen -------------*/
/* -------------------------------------------------------*/
/* -------------------------------------------------------*/

int IO_Platzverbrauch(unsigned long int zahl);

void IO_DruckeZeile(const char *zeichen);
/* Druckt eine ganze Zeile mit dem Zeichen zeichen. */

int IO_Einruecktiefe(int bisherigeTiefe, unsigned long int maxEintrag);
/* Berechnet die Einruecktiefe, die fuer die folgenden Eintraege noetig ist.
   Dabei ist maxEintrag der groesste dieser Eintraege. Wurde bisher nicht
   eingerueckt, so ist bisherigeTiefe=0 zu setzen.
*/

#define /*void*/ IO_LF(/*void*/) fprintf(IO_Strom, "\n")
/* Druckt einen Zeilenvorschub. */

void IO_DruckeFlex(const char *fmt, ...);
/* Aehnlich 'printf', aber es werden nur die Platzhalter %s fuer Strings, %d fuer int, %f fuer double, %l fuer
   long und %u fuer unsigned long verarbeitet. Zusaetzlich kann man aber mit 
   %t einen Term vom Typ TermT,
   %p ein gepacktes Termpaar vom Typ PTermpaarT
   ausgeben.
*/

void IO_DruckeFlexStrom(FILE *Strom, const char *fmt, ...);
/* IO_DruckeFlex auf bel. Stroeme; Terme werden ungekuerzt ausgegeben.
 */

void IO_DruckeKopfZeileText(BOOLEAN Bedingung, const char *Titel, const char *Text);

void IO_DruckeKopfZeileInfoStrings(BOOLEAN Bedingung, const char *Titel, InfoStringT is1, InfoStringT is2);

void IO_DruckeKopfZeileZahl(BOOLEAN Bedingung, const char *Titel, int Zahl);
/* Diese beiden Funktionen geben eine Zeile des Programm-Kopfes aus.
   Dabei wird die Ausrichtung automatisch vorgenommen.
   Die Ausgabe erfolgt nur, wenn Bedingung erfuellt ist.*/

void IO_DruckeGanzzahl(int n);
/* Ganze Zahl ausgeben. */

void IO_DruckeAdresse(void *Adresse);
/* Adresse ausgeben */

void IO_DruckeUeberschrift(const char *text);
/* Ueberschrift drucken */

void IO_DruckeKurzUeberschrift(const char *text, const char *zeichen);

void IO_WarteAufReturnMitText(const char *text);
/* Gibt text aus und Wartet auf Druck der Return-Taste.*/

/* -------------------------------------------------------*/
/* ------------- Statistik-Ausgaben ----------------------*/
/* -------------------------------------------------------*/

void IO_StatistikModusAufLatexSetzen(void);

void IO_StatistikModusAufNormalSetzen(void);

void IO_DruckeStatistikZeile(const char *str, unsigned long Datum);

void IO_DruckeStatistikZeileString(const char *str, const char *Datum);

void IO_DruckeStatistikZeileEingerueckt(const char *str, unsigned long Datum, int einruecktiefe);

void IO_DruckeStatistikLeerZeile(void);

void IO_DruckeStatistikZeileAnteil(const char *str, unsigned long int Zaehler, unsigned long int Nenner);
/* Gibt den String und dahinter das Datum aus, falls der Nenner nicht null ist.*/

/* -------------------------------------------------------*/
/* -------------------------------------------------------*/
/* ------------- Druck-Funktionen fuer System-Strukturen +*/
/* -------------------------------------------------------*/
/* -------------------------------------------------------*/

void IO_DruckeVergleich(VergleichsT Vergleich);
/* s.Name */

void IO_DruckeSymbol(SymbolT symbol);
/* Gibt die externe Repraesentation eines Symbols aus. */

char *IO_FktSymbName(SymbolT FktSymb);
/* Zeiger auf Zeichenketten-Darstellung des Druckenamens des Funktionssymbols */

void IO_DruckeTerm(UTermT Term);
/* Gibt einen Term auf den eingestellten Ausgabestrom aus. */

void IO_DruckeSymbolStrom(FILE *Strom, SymbolT symbol);
/* Ausgabe eines Symbols auf dem angegebenen Ausgabestrom.*/

void IO_DruckeTermStrom(FILE *Strom, UTermT Term);
/* Druckt den Term Term auf den Ausgabestrom Strom aus.*/

void IO_DruckeTermPaar(UTermT term1, const char *trenner,UTermT term2);
/* Gibt ein Term-Paar mit dem String trenner als einzufuegendes Zeichen aus.
   Ist z.B. fuer Gleichungen ein " = ", fuer Regeln ein " -> ",
   fuer kritische Paare ein " !=! " etc. o.ae.*/

#define IO_MeldeAbbruchWegenUnrichtbar(/*TermT*/ links, /*TermT*/ rechts)\
 IO_DruckeFlex("Vervollstaendigung abgebrochen, weil KP unrichtbar:\n %t <<##>> %t\n", links, rechts)

/* -------------------------------------------------------*/
/* -------------------------------------------------------*/
/* -------------- Datei-Ausgabe --------------------------*/
/* -------------------------------------------------------*/
/* -------------------------------------------------------*/

void IO_DateiAusgabe(const char *name, BOOLEAN pager);
/* Gibt die Datei name am Schirm aus.*/

/* -------------------------------------------------------*/
/* -------------------------------------------------------*/
/* -------------- Ausgabelevel-Abhaengige Funktionen -----*/
/* -------------------------------------------------------*/
/* -------------------------------------------------------*/


/* -------------- Ausgabe-Levels -------------------------*/
/* -------------------------------------------------------*/

extern BOOLEAN IO_level0, IO_level1, IO_level2, IO_level3, IO_level4;

/* Level       Bedeutung
---------------------------------------------------
     0           Stumm
     1           Punkte
     2           Discount
     3           Alle Meldungen, aber ohne Terme
     4           Volle Geschwaetzigkeit
---------------------------------------------------*/


/* ------------- Ziele -----------------------------------*/

#define ThisProvesTheGoal                                                                                       \
{                                                                                                               \
   fprintf(IO_Strom,  "\n" );                                                                                   \
   fprintf(IO_Strom,  "        +----------------------------------+\n" );                                       \
   fprintf(IO_Strom,  "        |   this proves the goal.          |\n" );                                       \
   fprintf(IO_Strom,  "        +----------------------------------+\n\n" );                                     \
}

#define ThisProvesTheGoalMNF                                                                                    \
{                                                                                                               \
   fprintf(IO_Strom,  "\n" );                                                                                   \
   fprintf(IO_Strom,  "        +----------------------------------+\n" );                                       \
   fprintf(IO_Strom,  "        |   this proves the goal (MNF)     |\n" );                                       \
   fprintf(IO_Strom,  "        +----------------------------------+\n\n" );                                     \
}


#define IO_DruckeMeldungZielReduziert(/*unsigned  long*/Nummer,/*TermT*/ links,/*TermT*/ rechts)                \
{                                                                                                               \
    if (IO_level4) IO_DruckeFlex("goal no. %u simplified: %t =? %t\n\n", Nummer, links, rechts);                  \
    else if (IO_level2){  fprintf(IO_Strom, "simplify goal:   %4u  ", Nummer);                                   \
                        IO_DruckeFlex("%t =? %t\n", links, rechts);                                             \
                     }                                                                                          \
    else fprintf(IO_Strom, "Goal no. %u simplified\n\n", Nummer);                                              \
 } 

#define IO_DruckeMeldungZielZusammengefuehrt(/*void*/)                                                          \
{                                                                                                               \
    if (IO_level2) ThisProvesTheGoal                                                                              \
  else  fprintf(IO_Strom, "... and hence joined\n\n");                                                          \
 } 

#define IO_DruckeMeldungZielMNFZusammengefuehrt(/*void*/)                                                       \
{                                                                                                               \
    if (IO_level2) ThisProvesTheGoalMNF                                                                           \
  else  fprintf(IO_Strom, "... and hence MNF-joined\n\n");                                                          \
 } 

#define IO_DruckeMeldungZielSubsummiert(/*unsigned  long*/ ZielNummer, /* long in      */ GleichungsNummer,     \
                                        /*TermT*/ Zlinks,/*TermT*/ Zrechts,                                     \
                                        /*TermT*/ Glinks,/*TermT*/ Grechts)                                     \
{                                                                                                               \
    if (IO_level4){                                                                                               \
       fprintf(IO_Strom, "goal no. %u subsumed by equation no. %ld\n", ZielNummer, GleichungsNummer);          \
       IO_DruckeFlex("  (%t = %t subsumes %t ?= %t)\n\n", Glinks, Grechts, Zlinks, Zrechts);                    \
    }                                                                                                           \
    else if (IO_level2){                                                                                          \
       fprintf(IO_Strom, "goal holds true because:       %4ld  ", -GleichungsNummer);                           \
       IO_DruckeFlex("%t = %t\n", Glinks, Grechts);                                                             \
       ThisProvesTheGoal                                                                                        \
    }                                                                                                           \
    else fprintf(IO_Strom, "goal no. %u subsumed by equation no. %ld\n\n", ZielNummer, GleichungsNummer);      \
} 

#define IO_DruckeMeldungZielMNFSubsummiert(/*unsigned  long*/ ZielNummer, /*unsigned  long*/ GleichungsNummer,  \
                                        /*TermT*/ Zlinks,/*TermT*/ Zrechts,                                     \
                                        /*TermT*/ Glinks,/*TermT*/ Grechts)                                     \
{                                                                                                               \
    if (IO_level4){                                                                                               \
       fprintf(IO_Strom, "goal no. %u MNF-subsumed by equation no. %ld\n", ZielNummer, GleichungsNummer);          \
       IO_DruckeFlex("  (%t = %t subsumes %t ?= %t)\n\n", Glinks, Grechts, Zlinks, Zrechts);                    \
    }                                                                                                           \
    else if (IO_level2){                                                                                          \
       fprintf(IO_Strom, "goal holds true because:       %4ld  ", -GleichungsNummer);                           \
       IO_DruckeFlex("%t = %t\n", Glinks, Grechts);                                                             \
       ThisProvesTheGoalMNF                                                                                     \
    }                                                                                                           \
    else fprintf(IO_Strom, "goal no. %u MNF-subsumed by equation no. %ld\n\n", ZielNummer, GleichungsNummer);      \
} 

/* ------------- Normale Ausgaben ------------------------*/
/* -------------------------------------------------------*/



#if IO_AUSGABEN

/* ------------- Diverse Meldungen -----------------------*/

#define IO_DruckeMeldungInterreduktionStart(/*void*/)   \
{                                                       \
    if ((IO_level3) || (IO_level4))                         \
       fprintf(IO_Strom, ">>interreduction<<\n\n");     \
}

#define IO_DruckeMeldungInterreduktionEnde(/*void*/)            \
{                                                               \
    if ((IO_level4) || (IO_level3))                                 \
       fprintf(IO_Strom, "\n>>interreduction finished<<\n\n");     \
}


/* -------------------------------------------------------------------------------------------------------------*/
/* -------------------------------------------------------------------------------------------------------------*/
/* -------------------------------------------------------------------------------------------------------------*/
/* ------------ Kritische Paare --------------------------------------------------------------------------------*/
/* -------------------------------------------------------------------------------------------------------------*/
/* -------------------------------------------------------------------------------------------------------------*/
/* -------------------------------------------------------------------------------------------------------------*/


/* -------------------------------------------------------------------------------------------------------------*/
/* ------------ BEHANDLUNG ALLGEMEIN ---------------------------------------------------------------------------*/
/* -------------------------------------------------------------------------------------------------------------*/

#define IO_DruckeMeldungKPZusammengefuehrt(/*TermT*/ ergebnis)                                  \
{                                                                                               \
    if (IO_level3) fprintf(IO_Strom, "... joined.\n\n");                  \
    else if(IO_level4) IO_DruckeFlex("... joined into %t.\n\n", ergebnis);  \
} 

#define IO_DruckeMeldungKPMNFZusammengefuehrt(/*TermT*/ ergebnis)         \
{                                                                         \
    if (IO_level3) fprintf(IO_Strom, "... mnf-joined.\n\n");                    \
    else if(IO_level4) IO_DruckeFlex("... mnf-joined into %t.\n\n", ergebnis);  \
} 


#define IO_DruckeMeldungKPSubsummiert()                 \
{                                                       \
    if ((IO_level3) || (IO_level4))                         \
       fprintf(IO_Strom, "... subsumed.\n");      \
}

#define IO_DruckeMeldungKPMNFSubsummiert()                 \
{                                                       \
    if ((IO_level3) || (IO_level4))                         \
       fprintf(IO_Strom, "... MNF-subsumed.\n");      \
}

#define IO_DruckeMeldungKPPermSubsummiert()                 \
{                                                       \
    if ((IO_level3) || (IO_level4))                         \
       fprintf(IO_Strom, "... perm-subsumed.\n");      \
}

#define IO_DruckeMeldungKPMNFPermSubsummiert()          \
{                                                       \
    if ((IO_level3) || (IO_level4))                     \
       fprintf(IO_Strom, "...MNF-perm-subsumed.\n");    \
}

#define IO_DruckeMeldungMeldungKPnichtZusammengefuehrt(/*TermT*/ links, /*TermT*/ rechts)       \
{                                                                                               \
    if ((IO_level3) || (!IO_level4))                                                                \
       IO_DruckeFlex("couldn't be joined!\n %t # %t\n",links,rechts);         \
} 

/* -------------------------------------------------------------------------------------------------------------*/
/* ------------ SELECTION --------------------------------------------------------------------------------------*/
/* -------------------------------------------------------------------------------------------------------------*/

#define IO_DruckeMeldungKPwirdBehandelt(/* long */ VaterNr, /* long */ MutterNr, /* TermT */ links, /* TermT */ rechts)     \
{                                                                                                                                                       \
    if (IO_level1)                                                                                                                                        \
       fprintf(IO_Strom, ".");                                                                                                                          \
    else if (IO_level3)                                                                                                                                   \
       fprintf(IO_Strom, "\n************************************\nue (%ld, %ld) touched.\n", VaterNr, MutterNr);                      \
    else if (IO_level4){                                                                                                                                  \
       fprintf(IO_Strom, "\n************************************\nue (%ld, %ld) touched:\n", VaterNr, MutterNr);                     \
       IO_DruckeFlex("       %t # %t\n",links, rechts);                                                                                                 \
    }                                                                                                                                                   \
 } 
       
       
#define IO_DruckeMeldungKPZurueckgestellt()                                           \
{                                                                                                               \
    if (IO_level1)                                                                                                \
       fprintf(IO_Strom, "\nKritisches Paar war nicht richtbar, wird zurueckgestellt.\n");                      \
    else if ((IO_level3) || (IO_level4))                                                                            \
       fprintf(IO_Strom, " ... war nicht richtbar, wird zurueckgestellt.\n");                                   \
}
       


/* -------------------------------------------------------------------------------------------------------------*/
/* ------------ ORPHAN MURDER ----------------------------------------------------------------------------------*/
/* -------------------------------------------------------------------------------------------------------------*/

/* Meldet Beginn und Ende des Waisenmordes */
#define IO_DruckeMeldungWaisenmordStart(/*void*/) \
{ \
    if ((IO_level4) || (IO_level3)) \
       fprintf(IO_Strom, "\n>>orphan murder<<\n\n"); \
}

#define IO_DruckeMeldungWaisenmordEnde(/*void*/) \
{ \
    if ((IO_level4) || (IO_level3))\
       fprintf(IO_Strom, ">>orphan murder finished<<\n\n"); \
}


#define IO_DruckeMeldungKPGeloeschtWegenElternTot(Nummer, /* long */ VaterNr, /* long */ MutterNr)                                              \
{                                                                                                                                               \
    if (IO_level3 || IO_level4)                                                                                                                     \
       fprintf(IO_Strom, "**ues %lu with parents %ld and %ld removed (orphan).\n\n", Nummer, VaterNr, MutterNr);      \
 } 



/* -------------------------------------------------------------------------------------------------------------*/
/* ------------ WALKTHROUGH ------------------------------------------------------------------------------------*/
/* -------------------------------------------------------------------------------------------------------------*/
extern unsigned long int IO_AnzAng;

#define IO_DruckeMeldungKPIRStart(/*char **/ strength, /*unsigned long int*/ toGo)                              \
{                                                                                                               \
    if ((IO_level4) || (IO_level3))                                                                                 \
       fprintf(IO_Strom, "\n>>intermediate reprocessing (%s, %ld to go)<<\n\n", strength, toGo);                 \
    else if (IO_level2) {fprintf(IO_Strom, "intermediate reprocessing (%s, %ld to go)\n", strength, toGo);IO_AnzAng=0;}\
}

#define IO_DruckeMeldungKPIREnde(/*void*/)                                                                      \
{                                                                                                               \
    if (IO_level2 || (IO_level4) || (IO_level3))                                                                      \
       fprintf(IO_Strom, "\n>>intermediate reprocessing finished<<\n\n");                                       \
}

#define IO_DruckeMeldungKPInIRBehandelt()                                                                       \
{                                                                                                               \
   if ((IO_level2||IO_level3||IO_level4) && PA_InteraktionAn())                                                       \
       fprintf(stdout,"%lu\r", ++IO_AnzAng);fflush(stdout);                                                                              \
 } 


/* -------------------------------------------------------------------------------------------------------------*/
/* ------------ GENERATION -------------------------------------------------------------------------------------*/
/* -------------------------------------------------------------------------------------------------------------*/


extern BOOLEAN IO_GUeberschrift, IO_TWUeberschrift;

#define IO_DruckeMeldungSpezGleichungZuKPGemacht(/* unsigned long */ SpezNummer,/* unsigned long */ KPNummer,/* TermT */ links, /* TermT */ rechts)     \
{                                                                                                                                                       \
    if (IO_level3)                                                                                                                                        \
       fprintf(IO_Strom, "initial equation %lu turned into ues %lu.\n", SpezNummer, KPNummer);                                              \
    else if (IO_level4){                                                                                                                                  \
       fprintf(IO_Strom, "initial equation %lu turned into ues %lu.\n", SpezNummer, KPNummer);                                              \
       IO_DruckeFlex("       %t # %t\n",links, rechts);                                                                                                 \
    }                                                                                                                                                   \
    else if (IO_level2){                                                                                                                                  \
       if (!IO_GUeberschrift){                                                                                                                            \
          fprintf(IO_Strom, "initial equations:\n" );                                                                                            \
          fprintf(IO_Strom, "------------------\n\n" );                                                                                          \
          IO_GUeberschrift = TRUE;                                                                                                                        \
       }                                                                                                                                                \
       fprintf(IO_Strom, "(%4ld)  ", SpezNummer);                                                                                                       \
       IO_DruckeFlex("%t = %t\n", links, rechts);                                                                                                       \
    }                                                                                                                                                   \
 } 

#define IO_DruckeMeldungTWGleichungZuKPGemacht(/* unsigned long */ KPNummer,/* TermT */ links, /* TermT */ rechts)     \
{                                                                                                                                                       \
    if (IO_level3)                                                                                                                                        \
       fprintf(IO_Strom, "TW:received equation turned into ues %lu.\n", KPNummer);                                              \
    else if (IO_level4){                                                                                                                                  \
       fprintf(IO_Strom, "TW:received equation turned into ues %lu.\n", KPNummer);                                              \
       IO_DruckeFlex("       %t # %t\n",links, rechts);                                                                                                 \
    }                                                                                                                                                   \
    else if (IO_level2){                                                                                                                                  \
       if (!IO_TWUeberschrift){                                                                                                                            \
          fprintf(IO_Strom, "received equations:\n" );                                                                                            \
          fprintf(IO_Strom, "-------------------\n\n" );                                                                                          \
          IO_TWUeberschrift = TRUE;                                                                                                                        \
       }                                                                                                                                                \
       IO_DruckeFlex("%t = %t\n", links, rechts);                                                                                                       \
    }                                                                                                                                                   \
 } 

#define IO_DruckeMeldungKPgebildet(/* unsigned long */ Nummer, /* long */ VaterNr, /* long */ MutterNr, /* TermT */ links, /* TermT */ rechts)  \
{                                                                                                                                               \
    if (IO_level3)                                                                                                                                \
       fprintf(IO_Strom, "critical pair %lu built with parents %ld and %ld.\n", Nummer, VaterNr, MutterNr);                            \
    else if (IO_level4){                                                                                                                          \
       fprintf(IO_Strom, "critical pair %lu built with parents %ld and %ld:\n", Nummer, VaterNr, MutterNr);                            \
       IO_DruckeFlex("       %t # %t\n",links, rechts);                                                                                         \
    }                                                                                                                                           \
 } 

#define IO_DruckeMeldungZuKPgemacht(/* unsigned long */ Nummer, /* TermT */ links, /* TermT */ rechts)  \
{                                                                                                       \
    if (IO_level3)                                                                                        \
       fprintf(IO_Strom, "... made ues %lu.\n",Nummer);                                            \
    else if (IO_level4)                                                                                   \
       IO_DruckeFlex("... made ues %lu: %t # %t\n",Nummer, links, rechts);                          \
 } 

#define IO_DruckeMeldungAlsKPaufgenommen(/*void*/)                      \
{                                                                       \
    if ((IO_level4) || (IO_level3))                                         \
       fprintf(IO_Strom, "... added to SUE.\n\n");       \
} 

#define IO_DruckeMeldungKPWeggeworfen(/*void*/)                      \
{                                                                       \
    if ((IO_level4) || (IO_level3))                                         \
       fprintf(IO_Strom, "... too big - thrown away.\n\n");       \
} 



/* ------------- Regeln ----------------------------------*/

#define IO_DruckeMeldungNeueRegelAufgenommen(/* unsigned long */ Nummer, /* TermT */ links, /* TermT */ rechts)  \
{                                                                                                       \
    if (IO_level2){                                                                                       \
       fprintf(IO_Strom, "new rule:           %4lu  ", Nummer);                                         \
       IO_DruckeFlex("%t --> %t\n", links, rechts);                                                     \
    }                                                                                                   \
    else if (IO_level3)                                                                                   \
       fprintf(IO_Strom, "... and added as new rule %lu.\n\n", Nummer);                         \
    else if (IO_level4){                                                                                  \
       fprintf(IO_Strom, "... and added as new rule %lu:\n", Nummer);                           \
       IO_DruckeFlex("       %t -> %t\n\n",links, rechts);                                              \
    }                                                                                                   \
 } 

#define IO_DruckeMeldungRegelRechtsReduziert(/* long */ Nummer, /* TermT */ links, /* TermT */ rechts)  \
{                                                                                                       \
    if (IO_level2)                                                                                        \
       fprintf(IO_Strom, "simplify rhs of rule %4ld\n", Nummer);                                         \
    else if (IO_level3)                                                                                   \
       fprintf(IO_Strom, "simplify rhs of rule %4ld.\n", Nummer);                                  \
    else if (IO_level4){                                                                                  \
       fprintf(IO_Strom, "simplify rhs of rule %4ld:\n", Nummer);                                  \
       IO_DruckeFlex("       %t -> %t\n",links, rechts);                                                \
    }                                                                                                   \
 } 

#define IO_DruckeMeldungRegelLinksReduziert(/* long */ Nummer)                                          \
{                                                                                                       \
    if (IO_level2)                                                                                        \
       fprintf(IO_Strom, "remove rule:        %4ld\n", Nummer);  /* Eigentlich "Reduziere Regel" */     \
    else if ((IO_level3) || (IO_level4))                                                                    \
       fprintf(IO_Strom, "simplify lhs of rule %ld, removed from R.\n", Nummer);       \
 } 

#define IO_DruckeMeldungRegelGeloescht(/* long */ Nummer)                       \
{                                                                               \
    if ((IO_level4) || (IO_level3))                                                 \
       fprintf(IO_Strom, "rule %ld removed from R.\n", Nummer); \
 } 

/* ------------- Gleichungen -----------------------------*/

extern long IO_Nr;

#define IO_DruckeMeldungNeueGleichungGebildet(/* long */ Nummer, /* TermT */ links, /* TermT */ rechts) \
{                                                                                                       \
    if (IO_level2) IO_Nr = Nummer;                                                                          \
    if (IO_level3 || IO_level4){                                                                            \
       IO_Nr = Nummer;                                                                                    \
       fprintf(IO_Strom, "not orientable, added to E-selected\n");                                \
    }                                                                                                   \
 }


#define IO_DruckeMeldungGleichungInGMAufgenommen(/* TermT */ links, /* TermT */ rechts, /*BOOLEAN*/ IstMonoG)                           \
{                                                                                                                                       \
    if (IO_level2){                                                                                                                       \
       fprintf(IO_Strom, "new equation:       %4ld  ", IO_Nr);                                                                            \
       IO_DruckeFlex("%t = %t\n", links, rechts);                                                                                       \
    }                                                                                                                                   \
    else if (IO_level3)                                                                                                                   \
       fprintf(IO_Strom, "...and added to E as %s with number %ld.\n\n",IstMonoG?"mono equation":"such", IO_Nr);   \
    else if (IO_level4){                                                                                                                  \
       fprintf(IO_Strom, "...and added to E as %s with number %ld:\n",IstMonoG?"mono equation":"such", IO_Nr);     \
       IO_DruckeFlex("       %t = %t\n", links, rechts);                                                                                \
    }                                                                                                                                   \
 }


#define IO_DruckeMeldungGleichungReduziert(/* long */ Nummer)           \
{                                                                       \
    if (IO_level2)                                                        \
       fprintf(IO_Strom, "remove equations:   %4ld\n", -Nummer);        \
    else if ((IO_level4) || (IO_level3))                                    \
       fprintf(IO_Strom, "equation no. %ld removed.\n", Nummer);     \
} 
 
#define IO_DruckeMeldungGleichungGeloescht(/* long */ Nummer)                           \
{                                                                                       \
    if ((IO_level4) || (IO_level3))                                                         \
       fprintf(IO_Strom, "equation no. %ld removed.\n", Nummer);  \
 } 

#define IO_DruckeMeldungGleichungWirdSubsummiertVon(/* long */ Nummer, /* TermT */ links, /* TermT */ rechts)   \
{                                                                                                               \
    if (IO_level3)                                                                                                \
       fprintf(IO_Strom, "... subsumed by equation no. %ld.\n", Nummer);                              \
    else if (IO_level4){                                                                                          \
       fprintf(IO_Strom, "... subsumed by equation no. %ld:\n", Nummer);                              \
       IO_DruckeFlex("       %t = %t\n",links, rechts);                                                         \
    }                                                                                                           \
 } 

#define IO_DruckeMeldungGleichungWirdPermSubsummiert(/*unsigned short*/ Grad)                                   \
{                                                                                                               \
    if (IO_level3)                                                                                                \
       fprintf(IO_Strom, "... perm-subsumed (deg. %u).\n", Grad);                                       \
    else if (IO_level4)                                                                                           \
       fprintf(IO_Strom, "... perm-subsumed (deg. %u).\n", Grad);                                       \
 } 

#define IO_DruckeMeldungNeueGleichungSubsummiertAlte(/* long */ Nummer, /* TermT */ links, /* TermT */ rechts)  \
{                                                                                                               \
    if (IO_level2)                                                                                                \
       fprintf(IO_Strom, "remove equation:    %4ld\n", -Nummer);                                                \
    else if (IO_level3)                                                                                           \
       fprintf(IO_Strom, "... the new equation subsumes equation no. %ld.\n", Nummer);                        \
    else if (IO_level4){                                                                                          \
       fprintf(IO_Strom, "... the new equation subsumes equation no. %ld:\n", Nummer);                        \
       IO_DruckeFlex("       %t = %t\n",links, rechts);                                                         \
    }                                                                                                           \
 } 


#else   /* Aufruf der Ausgabe-Makros durch Kommentare ersetzen -> ungehemmter Lauf */

/* ------------- Diverse Meldungen -----------------------*/

#define IO_DruckeMeldungInterreduktionStart()   /* nix tun */
#define IO_DruckeMeldungInterreduktionEnde(/*void*/)    /* nix tun */

/* ------------- Kritische Paare: Behandlung -------------*/

#define IO_DruckeMeldungKPZusammengefuehrt(/*TermT*/ ergebnis)
#define IO_DruckeMeldungKPMNFZusammengefuehrt(/*TermT*/ ergebnis)
#define IO_DruckeMeldungKPSubsummiert()
#define IO_DruckeMeldungKPMNFSubsummiert()
#define IO_DruckeMeldungKPPermSubsummiert()
#define IO_DruckeMeldungKPMNFPermSubsummiert()

#define IO_DruckeMeldungKPwirdBehandelt(/*long*/ VaterNr, /*long*/ MutterNr, /*TermT*/ links, /* TermT*/ rechts) /* nix tun */
#define IO_DruckeMeldungKPZurueckgestellt() /* nix tun */

#define IO_DruckeMeldungWaisenmordStart(/*void*/) /* nix tun */
#define IO_DruckeMeldungWaisenmordEnde(/*void*/) /* nix tun */
#define IO_DruckeMeldungKPGeloeschtWegenElternTot(Nummer, /* long */ VaterNr, /* long */ MutterNr) /* nix tun */

#define IO_DruckeMeldungKPIRStart(/*char **/ strength, nr) /* nix tun */
#define IO_DruckeMeldungKPIREnde(/*void*/) /* nix tun */
#define IO_DruckeMeldungKPInIRBehandelt()

#define IO_DruckeMeldungSpezGleichungZuKPGemacht(/*unsigned long*/ SpezNummer,/*unsigned long*/ KPNummer,/*TermT*/ links, /*TermT*/ rechts) /* nix tun */
#define IO_DruckeMeldungTWGleichungZuKPGemacht(/* unsigned long */ KPNummer,/* TermT */ links, /* TermT */ rechts)
#define IO_DruckeMeldungKPgebildet(/*unsigned long*/ Nummer, /*long*/ VaterNr, /*long*/ MutterNr, /*TermT*/ links, /*TermT*/ rechts) /* nix tun */
#define IO_DruckeMeldungZuKPgemacht(/* unsigned long */ Nummer, /* TermT */ links, /* TermT */ rechts) /* nix tun */
#define IO_DruckeMeldungAlsKPaufgenommen(/*void*/) /* nix tun */
#define IO_DruckeMeldungKPWeggeworfen(/*void*/)

#define IO_DruckeMeldungMeldungKPnichtZusammengefuehrt(/*TermT*/ links, /*TermT*/ rechts) /* nix tun */
#define IO_DruckeMeldungKPbeiIRZusammengefuehrt() /* nix tun */
#define IO_DruckeMeldungKPbeiIRSubsummiert() /* nix tun */
#define IO_DruckeMeldungAktKPZusammengefuehrt(/*TermT*/ ergebnis) /* nix tun */
#define IO_DruckeMeldungAktKPSubsummiert(/*void*/) /* nix tun */
#define IO_DruckeMeldungKPGeloeschtWegenElternTotGepackt(/* unsigned long */ Nummer, /* long */ VaterNr, /* long */ MutterNr, /*PTermpaarT*/ p) /* nix tun */
#define IO_DruckeMeldungMeldungKPnichtZusammengefuehrt(/*TermT*/ links, /*TermT*/ rechts) /* nix tun */
/*------------- Regeln ----------------------------------*/

#define IO_DruckeMeldungNeueRegelAufgenommen(/*long*/ Nummer, /*TermT*/ links, /*TermT*/ rechts) /* nix tun */
#define IO_DruckeMeldungRegelRechtsReduziert(/*long*/ Nummer, /*TermT*/ links, /*TermT*/ rechts) /* nix tun */
#define IO_DruckeMeldungRegelLinksReduziert(/*long*/ Nummer) /* nix tun */
#define IO_DruckeMeldungRegelGeloescht(/*long*/ Nummer) /* nix tun */

/*------------- Gleichungen -----------------------------*/

#define IO_DruckeMeldungNeueGleichungGebildet(/*long*/ Nummer, /*TermT*/ links, /*TermT*/ rechts) /* nix tun */
#define IO_DruckeMeldungGleichungInGMAufgenommen(/* TermT */ links, /* TermT */ rechts, /*BOOLEAN*/ IstMono) /* nix tun */
#define IO_DruckeMeldungGleichungReduziert(/*long*/ Nummer) /* nix tun */
#define IO_DruckeMeldungGleichungGeloescht(/*long*/ Nummer) /* nix tun */
#define IO_DruckeMeldungGleichungWirdSubsummiertVon(/*long*/ Nummer, /*TermT*/ links, /*TermT*/ rechts) /* nix tun */
#define IO_DruckeMeldungGleichungWirdPermSubsummiert(/*unsigned short*/ Grad) /* nix tun */
#define IO_DruckeMeldungNeueGleichungSubsummiertAlte(/*long*/ Nummer, /*TermT*/ links, /*TermT*/ rechts) /* nix tun */

#endif

/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/*+++++++++++++++++++++ Sonstiges +++++++++++++++++++++++*/
/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++*/

unsigned int IO_SymbAusgabelaenge(SymbolT Symbol);     /*ermittelt die Laenge der zugehorigen Ausgabezeichenkette*/

BOOLEAN IO_SymbolErkannt(char *str, SymbolT *Symbol);
/* Liefert TRUE, wenn str dem Ausgabe-String eines Symbols aus der Spezifikation entspricht. */


#ifdef __cplusplus
}
#endif

#endif
