/**********************************************************************
* Filename : CritGoals.h
*
* Kurzbeschreibung : Verwalten der Kritischen Ziele
*
* Autoren : WEC
*
* 08.12.96: Erstellung aus SUEM.c heraus
*
*
* Benoetigt folgende Module:
*
* Benutzte Globale Variablen aus anderen Modulen:
*
**********************************************************************/

#ifndef CRITGOALS_H
#define CRITGOALS_H

#include "general.h"
#include "TermpairRepresentation.h"
#include "InfoStrings.h"

#ifdef __cplusplus
extern "C" {
#endif


void CG_Collect(TermpairT tp, WeightEntryT wt, RegelOderGleichungsT aP, RegelOderGleichungsT oP);

void CG_AddCollected(void);

BOOLEAN CG_Select(TermpairT *tpPtr, RegelOderGleichungsT *aPPtr, RegelOderGleichungsT *oPPtr, void **addrefPtr);

void CG_KillParent(RegelOderGleichungsT re);

void CG_CleanUp (void);

void CG_SoftCleanUp(void);

void CG_Statistics (InfoStringT IS);

BOOLEAN CG_InitAposteriori (void);


#ifdef __cplusplus
}
#endif

#endif /* CRITGOALS_H */
