#ifndef HOH_H
#define HOH_H


#include "general.h"
#include "InfoStrings.h"

#include "TermpairRepresentation.h"
#include "SUEBasis.h"

#include "RUndEVerwaltung.h"

#ifdef __cplusplus
extern "C" {
#endif


/* -------------------------------------------------------------------------------------------------------------*/
/* ------- Initialize ------------------------------------------------------------------------------------------*/
/* -------------------------------------------------------------------------------------------------------------*/

BOOLEAN HOH_INITIALIZE(InfoStringT DEF, InfoStringT USR, int WeightEntryType);


/* -------------------------------------------------------------------------------------------------------------*/
/* ------- Insert ----------------------------------------------------------------------------------------------*/
/* -------------------------------------------------------------------------------------------------------------*/

extern void (* HOH_INSERT)   (TermpairT, WeightEntryT, RegelOderGleichungsT, RegelOderGleichungsT);
extern void (* HOH_INSERTImmortal)   (TermpairT, WeightEntryT, RegelOderGleichungsT, RegelOderGleichungsT);

BOOLEAN HOH_POSTPONE (TermpairT, WeightEntryT, RegelOderGleichungsT, RegelOderGleichungsT);


/* -------------------------------------------------------------------------------------------------------------*/
/* ------- Select ----------------------------------------------------------------------------------------------*/
/* -------------------------------------------------------------------------------------------------------------*/

extern BOOLEAN (* HOH_SELECT) (TermpairT *, RegelOderGleichungsT *, RegelOderGleichungsT *, void **);


/* -------------------------------------------------------------------------------------------------------------*/
/* ------- Parents ---------------------------------------------------------------------------------------------*/
/* -------------------------------------------------------------------------------------------------------------*/

extern void (* HOH_NEWPARENT) (RegelOderGleichungsT re);

extern void (* HOH_KILLPARENT) (RegelOderGleichungsT re);

extern void (* HOH_REDIRECTPARENT) (void);

extern void (* HOH_FINISHPARENT) (void);

/* -------------------------------------------------------------------------------------------------------------*/
/* ------- Walkthrough -----------------------------------------------------------------------------------------*/
/* -------------------------------------------------------------------------------------------------------------*/

unsigned long int HOH_AnzKPsToGo(void);

extern void (* HOH_WALKTHROUGH) (PQ_WalkthroughProcedureT AP, BOOLEAN NeedsTerms);

void HOH_WATCHINGWALKTHROUGH(PQ_WatchingWalkthroughProcedureT AP);

void HOH_TermVerfolgung(void (* OperationAufTermen) (TermT, TermT));

/* -------------------------------------------------------------------------------------------------------------*/
/* ------- Statistics ------------------------------------------------------------------------------------------*/
/* -------------------------------------------------------------------------------------------------------------*/

void HOH_STATISTICS(InfoStringT is);
/* output    -- Ausgabe der KP-Menge
   limit=... -- dieser bis hoechstens Gewicht ...
*/
void HOH_ActSize(unsigned long int *AktKPZahl, unsigned long int *AktGueltigeKPZahl);

/* -------------------------------------------------------------------------------------------------------------*/
/* ------- Clean up --------------------------------------------------------------------------------------------*/
/* -------------------------------------------------------------------------------------------------------------*/

void HOH_SoftAbraeumen(void);
void HOH_Abraeumen(void);
/* Alles loeschen*/

#ifdef __cplusplus
}
#endif

#endif
