/* -------------------------------------------------------------------------------------------------------------*/
/* ------- Immergleiche Statistik-Variablen und Funktionen -----------------------------------------------------*/
/* -------------------------------------------------------------------------------------------------------------*/
#ifndef PQSTATISTIK_H
#define PQSTATISTIK_H


#include "InfoStrings.h"

#ifdef __cplusplus
extern "C" {
#endif


extern BOOLEAN PQStatisticsAn;

void PQStatistikInitialisieren(void);
void PQStatistik(InfoStringT IS, long int AnzGueltigeKPsInMenge);

extern unsigned long        AnzKPSpaeterWaisenmord;            /* Bei erreichen der Top-Position der PQ als Waisen gekillte KPs */
extern unsigned long        AnzKPFrueherWaisenmord;            /* Vorzeitig als Waisen gekillte KPs */

extern unsigned long        AnzKPIRBetrachtet;                 /* Bei der KPM-IR insgesamt betrachtete KPs */
extern unsigned long        AnzKPIRWaisenmord;                 /* Bei der KPM-IR als Waisen geloeschte KPs */
extern unsigned long        AnzKPIRGeloescht;                  /* Bei der KPM-IR von der Anwendungsprozedur geloeschte KPs */
extern unsigned long        AnzKPIRVeraendert;                 /* Bei der KPM-IR reduzierte und deshalb ggf. verschobene KPs */
extern unsigned long        AnzKPIRVorgezogen;                 /* Bei der KPM-IR red. und gewichtsverkleinerte KPs */
extern unsigned long        AnzKPIRZurueckgeschoben;           /* Bei der KPM-IR red. und gewichtsvergroesserte KPs */

extern unsigned long        AnzKPBlaeh;                        /* Maximal gleichzeitig gespeicherte KP's */
extern unsigned long        AnzKPEingefuegt;                   /* Anzahl der insgesamt eingefuegten KPs */
extern unsigned long        AnzKPGeloescht;                    /* Anzahl der insgesamt (incl. Waisenmord) entfernten KPs */

#define IncAnzKPSpaeterWaisenmord_Stat() (AnzKPSpaeterWaisenmord++)
#define IncAnzKPFrueherWaisenmord_Stat() (AnzKPFrueherWaisenmord++)

#define IncAnzKPIRBetrachtet_Stat() (AnzKPIRBetrachtet++)
#define IncAnzKPIRWaisenmord_Stat() (AnzKPIRWaisenmord++)
#define IncAnzKPIRGeloescht_Stat() (AnzKPIRGeloescht++)
#define IncAnzKPIRVeraendert_Stat() (AnzKPIRVeraendert++)
#define IncAnzKPIRVorgezogen_Stat() (AnzKPIRVorgezogen++)
#define IncAnzKPIRZurueckgeschoben_Stat() (AnzKPIRZurueckgeschoben++)

#define IncAnzKPEingefuegt_Stat()(AnzKPEingefuegt++,AnzKPBlaeh =((AnzKPEingefuegt-AnzKPGeloescht)>AnzKPBlaeh)?(AnzKPEingefuegt-AnzKPGeloescht):AnzKPBlaeh)
#define IncAnzKPEntfernt_Stat()   (AnzKPGeloescht++)

#define IncAnzInitialerKPs_Stat(condition, ToIncrement) (ToIncrement += condition? 1:0)




#define IncAnzKPSpaeterWaisenmord_NoStat()                     /* Nix Tun */
#define IncAnzKPFrueherWaisenmord_NoStat()                     /* Nix Tun */

#define IncAnzKPIRBetrachtet_NoStat()                          /* Nix Tun */
#define IncAnzKPIRWaisenmord_NoStat()                          /* Nix Tun */
#define IncAnzKPIRGeloescht_NoStat()                           /* Nix Tun */
#define IncAnzKPIRVeraendert_NoStat()                          /* Nix Tun */
#define IncAnzKPIRVorgezogen_NoStat()                          /* Nix Tun */
#define IncAnzKPIRZurueckgeschoben_NoStat()                    /* Nix Tun */

#define IncAnzKPEingefuegt_NoStat()                            /* Nix Tun */
#define IncAnzKPEntfernt_NoStat()                              /* Nix Tun */

#define IncAnzInitialerKPs_NoStat(condition, ToIncrement)      /* Nix Tun */


#ifdef __cplusplus
}
#endif

#endif
