#ifndef    REFEREE_H
#define    REFEREE_H

#ifdef __cplusplus
extern "C" {
#endif


#include "general.h"
#include "RUndEVerwaltung.h"
#include "InfoStrings.h"
/*
//-----------------------------------------------------------------------------
//      Typdefinitionen
//-----------------------------------------------------------------------------
*/

#define         MAXREFRULE   10         /* Maximale Anzahl von Regeln   */
                                        /*   die ein Referee auswaehlt. */
#define         MAXREFEQU    10         /* Maximale Anzahl von Gleichungen */
                                        /*   die ein Referee auswaehlt. */


typedef struct  { BOOLEAN       master;     /* ?? */
                  int           config;     /* ?? */
                  long int    result;     /* Ist wohl 'short-report' */
                  unsigned long int    masterflag; /* ?? */
                  unsigned int    rule_count; /* Anz Regeln im Longreport  */
                  unsigned int    equ_count;  /* Anz Gleichungen im Longreport  */
                  unsigned int    goal_count; /* Anz Ziele im Longreport  */
                  RegelOderGleichungsT rule [MAXREFRULE]; /* Regeln */
                  RegelOderGleichungsT equ  [MAXREFEQU];  /* Gleichungen */
/*                RegelOderGleichungsT goal [MAXREFEQU];  Ziele */
                  unsigned long int    runtime;
                  unsigned long int    cputime;
} report;

/*
//-----------------------------------------------------------------------------
//      Datendefinitionen
//-----------------------------------------------------------------------------
*/

/* Diese Variable ist (noch) global */

extern report   REF_referee_report;

/*
//-----------------------------------------------------------------------------
//      Funktiondefinitionen
//-----------------------------------------------------------------------------
*/

void REF_myReferee(report *rep);

void REF_InitAposteriori(InfoStringT DEF, InfoStringT USR);

/*
//-----------------------------------------------------------------------------
//      neue Funktiondefinitionen
//-----------------------------------------------------------------------------
*/

long int REF_StatReferee(long int sizeR,
                         long int sizeE,
                         long int sizeCP,
                         long int sizeG,
                         long int sizeCG,
                         long int newR,
                         long int redR,
                         long int remR,
                         long int newE,
                         long int redE,
                         long int remE,
                         long int newCP,
                         long int newG,
                         long int redG,
                         long int newCG,
                         long int red);
/* Dokumentation wie Diss von Joerg, S.115 */
                     
long int REF_GenericReferee(InfoStringT DEF, InfoStringT USR);
/* Liest die Groessen aus den Strings und fuellt damit die
   Parameterliste der vorstehenden Funktion(en).
   Syntax: [refstat]:sizeR=...:...
   Nichtbesetzte Groessen werden mit 0 initialisiert.
*/



void REF_LastSelect(unsigned int         AnzRegeln, 
                    unsigned int         AnzGleichungen,
                    unsigned int         *rule_count,
                    RegelOderGleichungsT *rules,
                    unsigned int         *equ_count,
                    RegelOderGleichungsT *equs);
/* Liefert die letzten hoechstens AnzRegeln Regeln und hoechstens AnzGleichungen Gleichungen in
   rules[0..rule_count] bzw. equs[0..equ_count].
   Die Arrays rules bzw. equs. muessen mit der Groesse AnzRegeln bzw. AnzGleichungen
   bereits angelegt sein.
*/

void REF_StatSelect(unsigned int AnzRegeln, 
                    unsigned int AnzGleichungen,
                    unsigned int    *rule_count,
                    RegelOderGleichungsT *rules,
                    unsigned int    *equ_count,
                    RegelOderGleichungsT *equs,
                    long int anzRed,
                    long int anzRedrhsR,
                    long int anzRedlhsR,
                    long int anzRedE,
                    long int anzRedG,
                    long int anzSub,
                    long int anzKPs,
                    long int anzCGs,
                    long int schwellwert);
/* Liefert wie LastSelect hoechstens .....
   Dabei findet die Auswahl aber ueber speziellere Bewertungen statt (Diss von Joerg, S. 122),
   wobei schwellwert nicht unterschritten werden darf.
   */

void REF_GenericSelect(unsigned int         AnzRegeln, 
                       unsigned int         AnzGleichungen,
                       unsigned int         *rule_count,
                       RegelOderGleichungsT *rules,
                       unsigned int         *equ_count,
                       RegelOderGleichungsT *equs,
                       InfoStringT DEF, 
                       InfoStringT USR);
/* Waehlt eine der vorstehenden Select-Funktionen aus und bestueckt die Parameter entsprechend.
   Syntax: [sellast|selstat]:anzRed=...:schwellwert=....
   */

void REF_SetzeStartPunkt(void);

#ifdef __cplusplus
}
#endif

#endif
