#ifdef __cplusplus
extern "C" {
#endif

/* =================================================*/
/* ==                                             ==*/
/* ==                                             ==*/
/* ==    Konstanten fuer Speicherverwaltung       ==*/
/* ==                                             ==*/
/* ==                                             ==*/
/* =================================================*/

/* Fuer alle Module, die die Speicherverwaltung verwenden,
   sind in dieser Datei die Element- und Block-Groessen
   abzulegen.
   Nach Inkludieren von SpeicherVerwaltung.h sind diese
   Daten automatisch sichtbar. */


/*--------- Uebergeordnete Groessen------------------------*/

#define SPP_AnzErsterVariablen 32


/*--------- KP-Verwaltung ---------------------------------*/

#define PQ_AnzahlInfoBloeckeJeBlock 1000
#define PQ_AnzahlKPZellenJeBlock 1000


/*--------- KP-/RE-Puffer ---------------------------------*/

#define PU_REPufferGroesse 30
#define PU_TPPufferGroesse 100


/*--------- Term-Operationen ------------------------------*/

#define TO_AnzahlTermZellenJeBlock 30000 /* statt 4*65500 */
/* #define TO_AnzahlTermZellenJeBlockBeiGepackterDarstellung 65500*/
#define TO_AnzahlBaumTermZellenJeBlock 16000
#define TO_AnzErsterVariablenterme SPP_AnzErsterVariablen
#define TO_AnzVLZellenJeBlock 52


/*--------- Term-Iteration --------------------------------*/

#define TI_ErsteKopierstapelhoehe 200


/*--------- KBO -------------------------------------------*/

#define KB_AnzErsterVariablen SPP_AnzErsterVariablen


/*--------- LPO-Vortests ----------------------------------*/

#define LV_AnzListenzellenJeBlock 32


/*--------- VariablenMengen -------------------------------*/

#define VM_AnzListenzellenJeBlock BK_AnzInnereKnotenJeBlock+20


/*--------- DSBaumKnoten ----------------------------------*/

#define BK_VariablenZahlFuerAnzulegendeKnoten 16
#define BK_AnzahlNachfolgerArraysJeBlock 80
#define BK_AnzInnereKnotenJeBlock 100
#define BK_AnzBlaetterJeBlock 1000
#define BK_AnzSprungeintraegeJeBlock 1000
#define BK_AnzPraefixeintraegeJeBlock 500
#define BK_AnzahlErsterTieferBlaetter 50


/*--------- DSBaumOperationen -----------------------------*/

#define BO_AnzErsterVariablen SPP_AnzErsterVariablen
#define BO_ErsteSprungstapelhoehe 100
  /* proportional zur maximalen Termtiefe */


/*--------- Termpaare -------------------------------------*/

#define TP_AnzRegelnJeBlock 1000


/*--------- DSBaumAusgaben --------------------------------*/

#define BA_AnzErsterZeilen 100
  /* fuer Ausgabe-Koordinatensystem */
#define BA_maxAusgabelaengeVariable 12
#define BA_maxAusgabelaengeAdressenassoziation 12
#define BA_maxAusgabelaengeRegelnr 12



/*--------- DSBaumTest ------------------------------------*/

#define BT_ErsteStapelhoehe 32



/*--------- MatchOperationen ------------------------------*/

#define MO_AnzErsterVariablen SPP_AnzErsterVariablen


/*--------- Normalformbildung -----------------------------*/

#define NF_PfadArrayGroesse 200


/*--------- Unifikation1 ----------------------------------*/

#define U1_AnzErsterVariablen (2*SPP_AnzErsterVariablen)


/*--------- Speicherverwaltung ----------------------------*/

#define SV_maxLaengeNameNestedManager 52


/*--------- Packen ----------------------------------------*/

#define PK_BlocksizeInBytes 16000 
  /* Unabhaengig von der Groesse der jeweiligen Elemente 
     werden immer 4K allokiert. */


/*--------- SymbolOperationen -----------------------------*/

#define SO_AnzErsterVariablen SPP_AnzErsterVariablen


/*--------- RUndEVerwaltung -------------------------------*/

#define RE_ErstePermArgDimension BO_AnzErsterVariablen


/*--------- MNF -------------------------------------------*/

#define MNF_ColTermBlock 100
#define MNF_MengeSpeicherBlock 5


/*--------- MNF_CPs ---------------------------------------*/

#define MNF_NFSetBlock 100


/*--------- ZielVerwaltung --------------------------------*/

#define Z_SpeicherBlock 2


/*--------- Hash ------------------------------------------*/

#define HA_SpeicherBlock 200


/*--------- Deque -----------------------------------------*/

#define DQ_SpeicherBlock 50


/*--------- SelectClassify --------------------------------*/

#define SC_PairsBlock 100


/*--------- Heap of Heaps ---------------------------------*/

#define HOH_Domaenenstart 0x6 /* mal 0x10000000 */
#define HOH_Domaenenende  0x9 /* mal 0x10000000 */


/*--------- KPHeap ----------------------------------------*/

#define KPH_Domaenenstart HOH_Domaenenstart
#define KPH_Domaenenende  HOH_Domaenenende


/*--------- SpeicherVerwaltung ----------------------------*/

#define SV_Domaenenstart 0x1 /* mal 0x10000000 */
#if defined (LINUX)
#define SV_Domaenenende  0x3 /* mal 0x10000000 */
#else
#define SV_Domaenenende  0x4 /* mal 0x10000000 */
#endif


/*-------- Waldmeister-TW ---------------------------------*/

#if COMP_WMTW
#define TW_Domaenenstart 0x5
#define TW_Domaenenende  0x5 
#define TW_Granularitaet 8
#endif


/*-------- Ordnungsgenerator ------------------------------*/

#define OG_Blockgroesse 1000

#ifdef __cplusplus
}
#endif
