#ifdef __cplusplus
extern "C" {
#endif

#ifndef STATISTIKEN_H
#define STATISTIKEN_H

/* ----------------------------------------------------------------------------------------------------------
   Statistiken.h
  
   Diese Modul ist zustaendig fuer die Ausgabe von Statistiken, genauer:

   Fuer den Aufruf der Statistik-Funktionen der einzelnen Module,
   fuer Ergebnis-Ausgabe, und fuer Ergebnis- und Zwischen-Menues.

   20.06.96 Ausgelagert aus Ausgaben

*/

#include "InfoStrings.h"
#include "general.h"

/* -------------------------------------------------------*/
/* -------------- Initialisierung ------------------------*/
/* -------------------------------------------------------*/

void ST_InitAposteriori(InfoStringT KeDEF, InfoStringT KeUSR);

/* -------------------------------------------------------*/
/* -------------- Statistik ------------------------------*/
/* -------------------------------------------------------*/
/* Bei eingeschalteter Interaktion: Interaktives Ergebnis-Menue.
   Sonst Ausgabe diverser Daten gemaess Aufruf.

   In den Modi convergence und termination, wo der Terminationstest auf der Regelmenge ausgefuehrt wird,
   gibt der Wert von Resultat an, ob alle Ausgangsgleichungen richtbar waren.
*/

void ST_SuccessStatistik(const char *Bemerkung, BOOLEAN Resultat);
void ST_ErrorStatistik(const char *Bemerkung, BOOLEAN Resultat);
void ST_TimeoutStatistik(const char *Bemerkung, BOOLEAN Resultat);
void ST_SignalUsrStatistik(const char *Bemerkung, BOOLEAN Resultat);

/* -------------------------------------------------------*/
/* -------------- Interne Statistik ----------------------*/
/* -------------------------------------------------------*/

void ST_InterneStatistik(void);
/* Ausgabe von internen Daten (zB. Pfad-Ausdehnungen etc.) */

/* -------------------------------------------------------*/
/* -------------- Prozess-Statistik ----------------------*/
/* -------------------------------------------------------*/

void ST_ProzessStatistik(void);
/* Ausgabe von Prozess-Daten (aus getrusage)  */

/* -------------------------------------------------------*/
/* -------------- Konfiguration --------------------------*/
/* -------------------------------------------------------*/

void ST_DruckeKonfiguration(void);

/* -------------------------------------------------------*/
/* -------------- Ergebnis-Menue -------------------------*/
/* -------------------------------------------------------*/

void ST_IRMenue(const char *where);
/* Menuegesteuerte Ausgabe von Statistiken und Ergebnissen, Mengen
   sowie Anstossen der KPM-IR.
*/


#endif

#ifdef __cplusplus
}
#endif
