/****************************************************************************************
 * Schnittstelle fuer Prozeduren und Typen, die in allen Komponenten benoetigt werden.
 ****************************************************************************************
 * Autor:    Arnim (kopiert von madprak1)
 * Stand:    16.03.94
 * 16.03.94  Funktions-Kopf von SpeicherLeerRaeumen eingebaut (passiert noch nix drin.)
 ****************************************************************************************/
#ifndef GENERAL_H
#define GENERAL_H

#include "antiwarnings.h"

#ifdef __cplusplus
extern "C" {
#endif

/* unsigned long int maekmaek(void);
   void maekmaekplusplus(void); */

#define /*unsigned long int*/ maekmaek(/*void*/) 0L
#define /*void*/ maekmaekplusplus(/*void*/)


/*********************************  KONSTANTEN *******************************************/

/* Strings, die mit fgets gelesen werden, haben die Laenge INPUT_STRLEN */
#define INPUT_STRLEN 100

#ifndef FILENAME_MAX
#define FILENAME_MAX 1024
#endif

/*********************************  TYPEN  **********************************************/


#ifdef __LCLINT__
typedef bool BOOLEAN;
# define __volatile
#elif defined(__APOGEE__)
# define FALSE 0
# define TRUE  1
typedef int BOOLEAN;
#else
typedef enum { FALSE = 0,
               TRUE = 1 
} BOOLEAN;
#endif


typedef enum { Groesser, Kleiner, Gleich, Unvergleichbar} VergleichsT;

typedef char *STRING;

typedef char *ADDRESS;

typedef signed char  byte;      /* Wie in DISCOUNT */

/* Parameter fuer ParamInfo */
typedef enum {
   ParamEvaluate, ParamExplain
} ParamInfoArtT;

#if 0
#if defined (__GNUC__)
typedef unsigned long long int CounterT;
#else
typedef unsigned long int CounterT;
#endif
#endif
/* Vorerst, bis alles auf CounterT umgeschrieben ist: */
typedef unsigned long int CounterT;


/*********************************  MAKROS**********************************************/


#define /*BOOLEAN*/ AdresseKleiner(/*void**/ Adresse1, /*void **/ Adresse2) \
  ((ADDRESS) Adresse1 < (ADDRESS) Adresse2)


#define forListe(Liste,Index,Block)                                                                                 \
  Index = Liste;                                                                                                    \
  while (Index) {                                                                                                   \
    Block                                                                                                           \
    Index = Index->Nachf;                                                                                           \
  }
/* Makro fuer elementweises Durchlaufen einer linearen Liste mit Hilfe einer abweisenden Schleife. Die Listenzel-
   len muessen mit Eintraegen namens "Nachf" verzeigert sein.                                                      */


#define min(x,y)                                                                                                    \
  ( ((x)<(y)) ? (x) : (y) )


#define max(x,y)                                                                                                    \
  ( ((x)>=(y)) ? (x) : (y) )

#define /*VergleichsT*/ IntegerVergleich(/*int*/ a, /*int*/ b)                                                       \
  ((a)>(b) ? Groesser : ((a)==(b) ? Gleich : Kleiner))
/* Vergleicht a und b und liefert das Ergebnis als VergleichsT zurueck */


/*********************************  PROZEDUREN  *****************************************/

unsigned int LaengeNatZahl(unsigned long int n);

void Maximieren(unsigned int *AltesMaximum, unsigned int KandidatNeuesMaximum);
/* *AltesMaximum := max(*AltesMaximum,KandidatNeuesMaximum) */

void MaximierenLong(unsigned long int *AltesMaximum, unsigned long int KandidatNeuesMaximum);
/* *AltesMaximum := max(*AltesMaximum,KandidatNeuesMaximum) */

void MaximumAddieren(unsigned int *AlteSumme, unsigned int KandidatMaximum1, unsigned int KandidatMaximum2);
/* *AlteSumme := *AlteSumme + max(KandidatMaximum1,KandidatMaximum2) */

unsigned long int Maximum(int anz, ...);
/* Berechnet das Maximum der Argumentliste. Dabei muss das erste Argument die Anzahl der folgenden Argumente angeben,
   die Argumente selbst muessen unsigned long int sein. */

unsigned int fac(unsigned int n);
/* Fakultaet */

BOOLEAN WerteDa(int anz, ...);
/* Gibt TRUE zurueck, wenn einer der anz uebergebenen Werte > 0 ist.
   Die Werte sind vom Typ unsigned long int. */

void chop (char *str);
/* Loeschen des letzten Zeichens */

BOOLEAN IstPrim(unsigned int n);
/* Ist n eine Primzahl? */

unsigned int PrimzahlNr(unsigned int n);
/* Liefert die Primzahl Nr. n, gezaehlt ab 0. Daher PrimzahlNr(0)=2. */


/********************************** PCL ******************************************/

typedef unsigned long int PCL_ObjektNummerT;
typedef enum{linkeSeite, rechteSeite} PCL_SeitenT;
typedef enum{Regel, Gleichung, Ziel, KP} PCL_ObjektT;
typedef enum{VonLinksNachRechts, UeberKreuz} PCL_RichtungsRichtungT;

#if COMP_PCL
#define if_pcl(Action) Action                                   /* Abkuerzung fuer Abfrage #if COMP_PCL ... #endif */
#else
#define if_pcl(Action) /* nix tun */
#endif


#define REFEREES_NEEDED
#ifdef REFEREES_NEEDED
#define if_ref(Action) Action
#else
#define if_ref(Action) /* nix tun */
#endif

#ifdef __cplusplus
}
#endif

#endif /* GENERAL_H */
