/****************************************************************************************
 * Prozeduren die in allen Komponenten benoetigt werden.
 ****************************************************************************************
 * Autor:    Arnim (von madprak1 kopiert)
 * Stand:    28.02.1994
 ****************************************************************************************/

#include "antiwarnings.h"
#include "general.h"
#include <math.h>
#include <stdarg.h>
#include <string.h>

#include "FehlerBehandlung.h"

/*
static unsigned long int maekmaekmaek = 0;
unsigned long int maekmaek()
{
  return maekmaekmaek;
}
void maekmaekplusplus()
{
  maekmaekmaek++;
}
*/

/******************************  GLOBALE PROZEDUREN  ************************************/ 

unsigned int LaengeNatZahl(unsigned long int n)
{
  unsigned int Laenge=1;
  while ((n /= 10))
    Laenge++;
  return Laenge;
}


void Maximieren(unsigned int *AltesMaximum, unsigned int KandidatNeuesMaximum)
{
  if (KandidatNeuesMaximum>*AltesMaximum)
    *AltesMaximum = KandidatNeuesMaximum;
}

void MaximierenLong(unsigned long int *AltesMaximum, unsigned long int KandidatNeuesMaximum)
{
  if (KandidatNeuesMaximum>*AltesMaximum)
    *AltesMaximum = KandidatNeuesMaximum;
}

void MaximumAddieren(unsigned int *AlteSumme, unsigned int KandidatMaximum1, unsigned int KandidatMaximum2)
{
    *AlteSumme += max(KandidatMaximum1,KandidatMaximum2);
}

unsigned long int Maximum(int anz, ...)
/* Berechnet das Maximum der Argumentliste. Dabei muss das erste Argument die Anzahl der folgenden Argumente angeben,
   die Argumente selbst muessen unsigned long int sein. */
{
   va_list ap;
   int i;
   unsigned long int ulival, max = 0;

   va_start(ap, anz);
   for (i=0; i<anz; i++){
      ulival = va_arg(ap, unsigned long int);
      if (ulival>max)
         max = ulival;
   }
   va_end(ap);
   return max;
}

unsigned int fac(unsigned int n)
{
  unsigned int Ergebnis = 1;
  while (n>1)
    Ergebnis *= n--;
  return Ergebnis;
}


BOOLEAN WerteDa(int anz, ...)
/* Gibt TRUE zurueck, wenn einer der uebergebenen Werte > 0 ist
   Die Werte sind vom Typ unsigned long int. */
{
   va_list ap;
   int i;
   unsigned long int ulival;
   BOOLEAN ok=FALSE;

   va_start(ap, anz);
   for (i=0; i<anz; i++){
      ulival = va_arg(ap, unsigned long int);
      if (ulival>0){
         ok=TRUE;
         break;
      }
   }
   va_end(ap);
   return ok;
}


void chop (char *str)
/* Loeschen des letzten Zeichens */
{
   size_t len = strlen (str);

   if (len > 0)
      str[len-1] = '\0';
}

 BOOLEAN IstPrim(unsigned int n)
{
  if (n<2)
    return FALSE;
  else if (!(n%2))
    return n==2;
  else {
    unsigned int i,
                 N = floor(sqrt(n));
    for(i=3; i<=N; i += 2)
      if (!(n%i))
        return FALSE;
    return TRUE;
  }
}

unsigned int PrimzahlNr(unsigned int n)
{ /* Liefert - unter Vernachlaessigung mehrerer Jahrhunderte Zahlentheorie - die Primzahl Nr. n,
     gezaehlt ab 0. Daher PrimzahlNr(0)=2. */
  if (n) {
    unsigned int i = 3;
    while (--n)
      while (!IstPrim(i += 2));                            /* terminiert, da unendlich viele Primzahlen existieren */
    return i;
  }
  else
    return 2;
}
