#include "compiler-extra.h"
#include "Hauptkomponenten.h"
#include "StandardHeuristiken.h"
#include "RUndEVerwaltung.h"
#include "TermOperationen.h"
#include "SymbolOperationen.h"
#include "general.h"
#include "Ordnungen.h"
#include "SUEBasis.h"
#include "InfoStrings.h"
#include "SymbolGewichte.h"
#include <stdlib.h>
#include <string.h>
#include "Ausgaben.h"
#include "Zielverwaltung.h"
#include "TermOperationen.h"
#include "NFBildung.h"
#include "CStatistics.h"
#include "OccNest.h"
#include "CGHeuristiken.h"
#include "Unifikation1.h"

/* ------------------------------------------------------------------------*/
/* -------- globale Variablen (siehe CGHeuristiken.h) ---------------------*/
/* ------------------------------------------------------------------------*/
void (* CGH_100) (WeightEntryT *, TermT, TermT, RegelOderGleichungsT, RegelOderGleichungsT, UTermT);
void (* CGH_PrintProc) (WeightEntryT *, RegelOderGleichungsT, RegelOderGleichungsT);



typedef long int (* W_CombinatorT) (TermT, TermT, RegelOderGleichungsT, RegelOderGleichungsT, UTermT);
typedef long int (* W_EntryT) (long int, long int);
typedef void (* TermweightComputationT) (TermT, TermT, RegelOderGleichungsT, RegelOderGleichungsT, UTermT);

static long int length_left, length_right, depth_left, depth_right, rmatches_right, rmatches_left, ematches_left, ematches_right, CPNr = 0, unif;


static TermweightComputationT ComputeTermWeights;
static W_CombinatorT          W1_Combinator1, W1_Combinator2, W2_Combinator1, W2_Combinator2;
static W_EntryT               W1_Entry, W2_Entry;


/* ----------------------------------------------------------------------------------------------------------- */
/* ----------------------------Term-Gewichte------------------------------------------------------------------ */
/* ----------------------------------------------------------------------------------------------------------- */

#define LengthFlex                                                                                              \
{                                                                                                               \
    SymbolT symb;                                                                                               \
    length_left = length_right = 0;                                                                             \
    TO_doSymbole(lhs, symb,{                                                                                    \
      length_left  += SG_SymbolGewichtCG(symb);                                                                   \
    });                                                                                                         \
    TO_doSymbole(rhs, symb,{                                                                                    \
      length_right  += SG_SymbolGewichtCG(symb);                                                                  \
    });                                                                                                         \
}
#define LengthFix                                                                                               \
{length_left = TO_Termlaenge(lhs); length_right = TO_Termlaenge(rhs);}
#define LengthOff

#define DepthOn \
{depth_left = TO_Termtiefe(lhs); depth_right = TO_Termtiefe(rhs);}
#define DepthOff

#define RMatchesOn \
{rmatches_left = NF_AnzReduziblerStellenR(lhs); rmatches_right = NF_AnzReduziblerStellenR(rhs);}
#define RMatchesOff

#define EMatchesOn \
{ematches_left = NF_AnzReduziblerStellenE(lhs); ematches_right = NF_AnzReduziblerStellenE(rhs);}
#define EMatchesOff

#define NumbersOn {CPNr++;}
#define NumbersOff

#define UnifOn											\
{												\
  unif = U1_Unifikationsmass(lhs, rhs);				\
}
#define UnifOff

#define ComputeTermWeights(_LENGTH_, _DEPTH_, _RMATCHES_, _EMATCHES_, _NUMBER_, _UNIF_)                                     \
static void _LENGTH_## _DEPTH_## _RMATCHES_## _EMATCHES_## _NUMBER_ ## _UNIF_ (TermT lhs MAYBE_UNUSEDPARAM,                 \
                                                                               TermT rhs MAYBE_UNUSEDPARAM,                 \
                                                                               RegelOderGleichungsT aP MAYBE_UNUSEDPARAM,   \
                                                                               RegelOderGleichungsT oP MAYBE_UNUSEDPARAM,   \
                                                                               UTermT actPos MAYBE_UNUSEDPARAM)             \
{Length ## _LENGTH_; Depth ## _DEPTH_; RMatches ## _RMATCHES_; EMatches ## _EMATCHES_; Numbers ## _NUMBER_; Unif ## _UNIF_}

#define DeclareCTW_1(_1_, _2_, _3_)                                                             \
ComputeTermWeights(_1_, _2_, _3_, On, On, On)                                                       \
ComputeTermWeights(_1_, _2_, _3_, On, On, Off)                                                      \
ComputeTermWeights(_1_, _2_, _3_, On, Off, On)                                                      \
ComputeTermWeights(_1_, _2_, _3_, On, Off, Off)                                                       \
ComputeTermWeights(_1_, _2_, _3_, Off, On, On)                                                       \
ComputeTermWeights(_1_, _2_, _3_, Off, On, Off)                                                      \
ComputeTermWeights(_1_, _2_, _3_, Off, Off, On)                                                      \
ComputeTermWeights(_1_, _2_, _3_, Off, Off, Off)

#define DeclareCTW_2(_1_)                                                                       \
DeclareCTW_1(_1_, On, On)                                                                       \
DeclareCTW_1(_1_, On, Off)                                                                      \
DeclareCTW_1(_1_, Off, On)                                                                      \
DeclareCTW_1(_1_, Off, Off)

DeclareCTW_2(Flex)
DeclareCTW_2(Fix)
DeclareCTW_2(Off)

#define LENGTHleft    length_left
#define LENGTHright   length_right
#define DEPTHleft     depth_left
#define DEPTHright    depth_right
#define FLATNESSleft  (-depth_left)
#define FLATNESSright (-depth_right)
#define EMATCHESleft  ematches_left
#define EMATCHESright ematches_right
#define RMATCHESleft  rmatches_left
#define RMATCHESright rmatches_right
#define REMATCHESleft  (rmatches_left + ematches_left)
#define REMATCHESright (rmatches_right + ematches_right)
#define UNIFleft       (unif)
#define UNIFright      (0)

/* ----------------------------------------------------------------------------------------------------------- */
/* --------------------------Combinators---------------------------------------------------------------------- */
/* ----------------------------------------------------------------------------------------------------------- */

/* term-weight ----(combinator)----> equation-weight */

#define PLUS(x,y,lhs,rhs,aP,oP,actPos)    return (x+y)
#define MAX(x,y,lhs,rhs,aP,oP,actPos)     return (x>y?x:y)
#define MIN(x,y,lhs,rhs,aP,oP,actPos)     return (x<y?x:y)
#define PROD(x,y,lhs,rhs,aP,oP,actPos)    return (x*y)
#define PRODSUM(x,y,lhs,rhs,aP,oP,actPos) return (x*y+x+y)
#define GT(x,y,lhs,rhs,aP,oP,actPos)                                                                            \
{                                                                                                               \
   switch (ORD_VergleicheTerme(lhs, rhs)){                                                                       \
   case Groesser:                                                                                               \
      return x;                                                                                                 \
      break;                                                                                                    \
   case Kleiner:                                                                                                \
      return y;                                                                                                 \
      break;                                                                                                    \
   default:                                                                                                     \
      return x+y;                                                                                               \
      break;                                                                                                    \
   }                                                                                                            \
}

/* ----------------------------------------------------------------------------------------------------------- */
/* --------------------------Equation-Weights----------------------------------------------------------------- */
/* ----------------------------------------------------------------------------------------------------------- */
#define Combination_Body(WEIGHT, _Combinator_)                                                                                                    \
static long int _Combinator_ ## WEIGHT(TermT lhs MAYBE_UNUSEDPARAM,                                                                               \
                                       TermT rhs MAYBE_UNUSEDPARAM,                                                                               \
                                       RegelOderGleichungsT actualParent MAYBE_UNUSEDPARAM,                                                       \
                                       RegelOderGleichungsT otherParent MAYBE_UNUSEDPARAM,                                                        \
                                       UTermT actualPosition MAYBE_UNUSEDPARAM)                                                                   \
{_Combinator_(WEIGHT ## left, WEIGHT ## right, lhs, rhs, actualParent, otherParent, actualPosition);}

#define AllCombinators(WEIGHT)                                                                                  \
Combination_Body(WEIGHT, PLUS)                                                                                  \
Combination_Body(WEIGHT, MAX)                                                                                   \
Combination_Body(WEIGHT, MIN)                                                                                   \
Combination_Body(WEIGHT, PROD)                                                                                  \
Combination_Body(WEIGHT, PRODSUM)                                                                               \
Combination_Body(WEIGHT, GT)

AllCombinators(LENGTH)
AllCombinators(DEPTH)
AllCombinators(FLATNESS)
AllCombinators(EMATCHES)
AllCombinators(RMATCHES)
AllCombinators(REMATCHES)
AllCombinators(UNIF)

/* ----------------------------------------------------------------------------------------------------------- */
/* ---------------------------Big-Entries--------------------------------------------------------------------- */
/* ----------------------------------------------------------------------------------------------------------- */

#define WEPLUS(x,y)(x+y)
#define WEMINUS(x,y)(x-y)
#define WEMAX(x,y)(x>y?x:y)
#define WEMIN(x,y)(x<y?x:y)
#define WEPROD(x,y)(x*y)
#define WEPRODSUM(x,y)(x*y+x+y)
#define WEFIFO(x,y)(CPNr)
#define WELIFO(x,y)(-CPNr)

#define WE_BODY(_we_)                                                   \
static long int ComputeWE ## _we_(long int x MAYBE_UNUSEDPARAM,         \
                                       long int y MAYBE_UNUSEDPARAM)    \
{return (WE##_we_(x,y));}

WE_BODY(PLUS)
WE_BODY(MINUS)
WE_BODY(MAX)
WE_BODY(MIN)
WE_BODY(PROD)
WE_BODY(PRODSUM)
WE_BODY(FIFO)
WE_BODY(LIFO)

/* ----------------------------------------------------------------------------------------------------------- */
/* ----------------------------Deklarationen------------------------------------------------------------------ */
/* ----------------------------------------------------------------------------------------------------------- */

#define Computation_wi_Body_Typ1(_i_)                                                                      \
{                                                                                                               \
   wt->w## _i_ = (*W##_i_##_Entry)(0,0);                                                           \
}

#define Computation_wi_Body_Typ2(_i_)                                                                      \
{                                                                                                               \
   wt->w## _i_ = (* W## _i_ ##_Combinator1)(lhs, rhs, actualParent, otherParent, actualPosition);               \
}

#define Computation_wi_Body_Typ3(_i_)                                                                      \
{                                                                                                               \
   long int c1, c2;                                                                                             \
                                                                                                                \
   c1 = (* W## _i_ ##_Combinator1)(lhs, rhs, actualParent, otherParent, actualPosition);                        \
   c2 = (* W## _i_ ##_Combinator2)(lhs, rhs, actualParent, otherParent, actualPosition);                        \
                                                                                                                \
   wt->w## _i_ = (*W##_i_##_Entry)(c1, c2);                                                        \
}

#define Computation_wi_Body_Typ4(_i_)                                                                      \
{                                                                                                               \
   wt->w## _i_ = ON_OccNest(lhs, rhs, (* W## _i_ ##_Combinator1)                                                \
                            (lhs, rhs, actualParent, otherParent, actualPosition));                             \
}

#define OneWeight(TYP1)                                                                                                                                             \
static void Classification1Weight_ ## TYP1(WeightEntryT *wt, TermT lhs, TermT rhs, RegelOderGleichungsT actualParent, RegelOderGleichungsT otherParent, UTermT actualPosition) \
{                                                                                                                                                                                          \
   (* ComputeTermWeights)(lhs, rhs, actualParent, otherParent, actualPosition);                                                                                                            \
   Computation_wi_Body_Typ ## TYP1(1);                                                                                                                                            \
   CS_BerechnetesGewichtIst(wt->w1);                                                                                                                                          \
}

#define TwoWeights(TYP1, TYP2)                                                                                                                                              \
static void Classification2Weights_ ## TYP1 ## TYP2(WeightEntryT *wt, TermT lhs, TermT rhs, RegelOderGleichungsT actualParent, RegelOderGleichungsT otherParent, UTermT actualPosition) \
{                                                                                                                                                                                                  \
   (* ComputeTermWeights)(lhs, rhs, actualParent, otherParent, actualPosition);                                                                                                                    \
   Computation_wi_Body_Typ ## TYP1(1);                                                                                                                                                 \
   Computation_wi_Body_Typ ## TYP2(2);                                                                                                                                                            \
   CS_BerechnetesGewichtIst(wt->w1);                                                                                                                                                  \
}

#define DECLARE(_TYP1_)                                                                                \
OneWeight(_TYP1_)                                                                                      \
TwoWeights(_TYP1_, 1)                                                                                  \
TwoWeights(_TYP1_, 2)                                                                                  \
TwoWeights(_TYP1_, 3)                                                                                  \
TwoWeights(_TYP1_, 4)

DECLARE(1)                                                                                                  \
DECLARE(2)                                                                                                  \
DECLARE(3)                                                                                                  \
DECLARE(4)

/* 
   Funktions-Pattern:
   Classification1Weight_1
   Classification2Weights_11, ..., Classification2Weights_14
   Classification1Weight_1
   ...
 */

/* -------------------------------------------------------------------------------------------------------------*/
/* ------- Output ----------------------------------------------------------------------------------------------*/
/* -------------------------------------------------------------------------------------------------------------*/

static void PrintProc_0(WeightEntryT *wt,
                        RegelOderGleichungsT aP MAYBE_UNUSEDPARAM,
                        RegelOderGleichungsT oP MAYBE_UNUSEDPARAM)
{
   fprintf(IO_Strom, "%11ld", wt->w1);
}

static void PrintProc_1(WeightEntryT *wt,
                        RegelOderGleichungsT aP MAYBE_UNUSEDPARAM,
                        RegelOderGleichungsT oP MAYBE_UNUSEDPARAM)
{
   fprintf(IO_Strom, "%11ld.%11ld.", wt->w1, wt->w2);
}


/* ----------------------------------------------------------------------------------------------------------- */
/* --------------------------------Initialisierung------------------------------------------------------------ */
/* ----------------------------------------------------------------------------------------------------------- */

static const char *SymbolicWeightAR[2] = {"lifo","fifo"},
            *occnestAR[1]        = {"occnest"},
            *combAR[6]           = {"plus", "max", "min", "prod", "prodsum", "gt"},
            *weightAR[7]         = {"length", "depth", "flat", "ematches", "rmatches", "rematches", "unif"},
            *entryAR[6]          = {"plus", "minus", "max", "min", "prod", "prodsum"};

#define FunktionZuWeight(_COMB_)                                                                                \
switch(w){                                                                                                      \
 case 0: Funktion = _COMB_ ## LENGTH; break;                                                                    \
 case 1: Funktion = _COMB_ ## DEPTH; break;                                                                     \
 case 2: Funktion = _COMB_ ## FLATNESS; break;                                                                  \
 case 3: Funktion = _COMB_ ## EMATCHES; break;                                                                  \
 case 4: Funktion = _COMB_ ## RMATCHES; break;                                                                  \
 case 5: Funktion = _COMB_ ## REMATCHES; break;                                                                 \
 case 6: Funktion = _COMB_ ## UNIF; break;                                                                      \
 default: fprintf(IO_Strom, "FEHLER! Weight-Nummer nicht gefunden\n\n");break;                                             \
}

static W_CombinatorT FunktionspointerAusCombinatorUndGewicht(int comb, int w)
{
   W_CombinatorT Funktion = (W_CombinatorT) 0;
   switch(comb){
   case 0:
      FunktionZuWeight(PLUS);
      break;
   case 1:
      FunktionZuWeight(MAX);
      break;
   case 2:
      FunktionZuWeight(MIN);
      break;
   case 3:
      FunktionZuWeight(PROD);
      break;
   case 4:
      FunktionZuWeight(PRODSUM);
      break;
   case 5:
      FunktionZuWeight(GT);
      break;
   default: fprintf(IO_Strom, "FEHLER! Kombinator-Nummer nicht gefunden\n\n");break;
   }
   return Funktion;
}

static int StringInFeld(const char *String, const char *Feld[], int Elemente)
{
   int i;
   
   if (!String) return FALSE;

   for (i=0; i<Elemente; i++)
      if (strcmp(String, Feld[i]) == 0)
         return i;
   return -1;
}

#define IstSymbolicWeight(str) StringInFeld(str, SymbolicWeightAR, 2)
#define IstOccnest(str) StringInFeld(str, occnestAR, 1)
#define IstCombinator(str) StringInFeld(str, combAR,6)
#define IstWeight(str) StringInFeld(str, weightAR,7)
#define IstEntry(str) StringInFeld(str, entryAR,6)

static BOOLEAN GewichtsTupel[6] = {FALSE, FALSE, FALSE, FALSE, FALSE, FALSE};
                                 /*length,depth,ematches,rmatches,fifo,unif */
static void MeldeGewicht(int w)
/* w enthaelt Position aus Gewichtsarray; -1 bedeutet Fifo/Lifo */
{
   switch(w){
   case -1: GewichtsTupel[4] = TRUE;break;
   case 0: GewichtsTupel[0] = TRUE; break;
   case 1: GewichtsTupel[1] = TRUE; break;
   case 2: GewichtsTupel[1] = TRUE; break;
   case 3: GewichtsTupel[3] = TRUE; break;
   case 4: GewichtsTupel[2] = TRUE; break;
   case 5: GewichtsTupel[2] = TRUE; GewichtsTupel[3] = TRUE; break;
   case 6: GewichtsTupel[5] = TRUE; break;
   default:  fprintf(IO_Strom, "FEHLER! Gewicht nicht gefunden bei MeldeGewicht\n\n");break;
   }
}

static void SymbolicWeightInit(int nr, W_EntryT *E)
{
   /* Entry-Funktion besetzen */
   if (nr == 0)      *E = ComputeWELIFO;
   else              *E = ComputeWEFIFO;
   MeldeGewicht(-1);
   fprintf(IO_Strom, "%s\n", SymbolicWeightAR[nr]);
}

static void OccNestInit(int comb, int w, W_CombinatorT *C1)
{
   *C1 = FunktionspointerAusCombinatorUndGewicht(comb, w);
   MeldeGewicht(w);
   ON_Init();
   fprintf(IO_Strom, "OccNest(%s(%s))\n", combAR[comb], weightAR[w]);
}

static void CombinatorInit(int comb, int w, W_CombinatorT *C1)
{
   *C1 = FunktionspointerAusCombinatorUndGewicht(comb, w);
   MeldeGewicht(w);
   fprintf(IO_Strom, "%s(%s)\n", combAR[comb], weightAR[w]);
}

static void BigInit(int e, int c1, int w1, int c2, int w2, W_CombinatorT *C1, W_CombinatorT *C2, W_EntryT *E)
{
   *C1 = FunktionspointerAusCombinatorUndGewicht(c1, w1);
   *C2 = FunktionspointerAusCombinatorUndGewicht(c2, w2);
   switch(e){
   case 0: *E = ComputeWEPLUS; break;
   case 1: *E = ComputeWEMINUS; break;
   case 2: *E = ComputeWEMAX; break;
   case 3: *E = ComputeWEMIN; break;
   case 4: *E = ComputeWEPROD; break;
   case 5: *E = ComputeWEPRODSUM; break;
   default: fprintf(IO_Strom, "FEHLER! Entry-Nummer nicht gefunden\n\n");break;
   }
   MeldeGewicht(w1);
   MeldeGewicht(w2);
   fprintf(IO_Strom, "%s(%s(%s), %s(%s))\n", entryAR[e], combAR[c1], weightAR[w1], combAR[c2], weightAR[w2]);
}

static void StringAnalyzis(const char *STR, W_CombinatorT *C1, W_CombinatorT *C2, W_EntryT *E, int *Typ)
{
   char *s[5];
   int i = 0;
   
   char *kopie, *token, *kopieDummy;
    
   /* 1) Teilstrings berechnen */

   if (!STR) {*Typ = 0; return;}          /* String ist leer -> Fehler */

   kopie = (char *) our_alloc(sizeof(char)*(strlen(STR)+1));
   strcpy(kopie, STR);
   kopieDummy = kopie;

   while((token = strtok(kopieDummy, "."))){
      kopieDummy = NULL;             /* gemaess Spezifikation von strtok */
      s[i++]=token;
   }

   /* 2) Eintraege w1 ... w5 bestimmen */
   
   if (IstSymbolicWeight(s[0])!=-1){
      SymbolicWeightInit(IstSymbolicWeight(s[0]), E);
      *Typ = 1;
   }
   /* kein Symbolic Weight */
   else if ((IstOccnest(s[0]) != -1) && (IstCombinator(s[1]) !=-1) && (IstWeight(s[2])!= -1)){
      OccNestInit(IstCombinator(s[1]),IstWeight(s[2]), C1);
      *Typ=4;
   }
   else if ((IstCombinator(s[0]) !=-1) && (IstWeight(s[1])!= -1)){
      CombinatorInit(IstCombinator(s[0]), IstWeight(s[1]), C1);
      *Typ = 2;
   }
   else if ((IstEntry(s[0])!=-1) && 
       (IstCombinator(s[1]) !=-1) && 
       (IstWeight(s[2])!= -1) && (IstCombinator(s[3]) !=-1) && (IstWeight(s[4])!= -1)){
      BigInit(IstEntry(s[0]),IstCombinator(s[1]),IstWeight(s[2]),IstCombinator(s[3]),IstWeight(s[4]),
              C1, C2, E);
      *Typ = 3;
   }
   else {
      *Typ = 0;                    /* Fehlerfall! */
   }
   our_dealloc(kopieDummy);
}

#define Besetze(_FIXFLEXOFF_)                                                                                   \
_FIXFLEXOFF_[0]  = _FIXFLEXOFF_##OffOffOffOffOff;                                                                   \
_FIXFLEXOFF_[1]  = _FIXFLEXOFF_##OffOffOffOffOn;                                                                    \
_FIXFLEXOFF_[2]  = _FIXFLEXOFF_##OffOffOffOnOff;                                                                    \
_FIXFLEXOFF_[3]  = _FIXFLEXOFF_##OffOffOffOnOn;                                                                     \
_FIXFLEXOFF_[4]  = _FIXFLEXOFF_##OffOffOnOffOff;                                                                    \
_FIXFLEXOFF_[5]  = _FIXFLEXOFF_##OffOffOnOffOn;                                                                     \
_FIXFLEXOFF_[6]  = _FIXFLEXOFF_##OffOffOnOnOff;                                                                     \
_FIXFLEXOFF_[7]  = _FIXFLEXOFF_##OffOffOnOnOn;                                                                      \
_FIXFLEXOFF_[8]  = _FIXFLEXOFF_##OffOnOffOffOff;                                                                    \
_FIXFLEXOFF_[9]  = _FIXFLEXOFF_##OffOnOffOffOn;                                                                     \
_FIXFLEXOFF_[10] = _FIXFLEXOFF_##OffOnOffOnOff;                                                                    \
_FIXFLEXOFF_[11] = _FIXFLEXOFF_##OffOnOffOnOn;                                                                     \
_FIXFLEXOFF_[12] = _FIXFLEXOFF_##OffOnOnOffOff;                                                                    \
_FIXFLEXOFF_[13] = _FIXFLEXOFF_##OffOnOnOffOn;                                                                     \
_FIXFLEXOFF_[14] = _FIXFLEXOFF_##OffOnOnOnOff;                                                                     \
_FIXFLEXOFF_[15] = _FIXFLEXOFF_##OffOnOnOnOn;                                                                     \
_FIXFLEXOFF_[16] = _FIXFLEXOFF_##OnOffOffOffOff;                                                                   \
_FIXFLEXOFF_[17] = _FIXFLEXOFF_##OnOffOffOffOn;                                                                    \
_FIXFLEXOFF_[18] = _FIXFLEXOFF_##OnOffOffOnOff;                                                                    \
_FIXFLEXOFF_[19] = _FIXFLEXOFF_##OnOffOffOnOn;                                                                     \
_FIXFLEXOFF_[20] = _FIXFLEXOFF_##OnOffOnOffOff;                                                                    \
_FIXFLEXOFF_[21] = _FIXFLEXOFF_##OnOffOnOffOn;                                                                     \
_FIXFLEXOFF_[22] = _FIXFLEXOFF_##OnOffOnOnOff;                                                                     \
_FIXFLEXOFF_[23] = _FIXFLEXOFF_##OnOffOnOnOn;                                                                      \
_FIXFLEXOFF_[24] = _FIXFLEXOFF_##OnOnOffOffOff;                                                                    \
_FIXFLEXOFF_[25] = _FIXFLEXOFF_##OnOnOffOffOn;                                                                     \
_FIXFLEXOFF_[26] = _FIXFLEXOFF_##OnOnOffOnOff;                                                                    \
_FIXFLEXOFF_[27] = _FIXFLEXOFF_##OnOnOffOnOn;                                                                     \
_FIXFLEXOFF_[28] = _FIXFLEXOFF_##OnOnOnOffOff;                                                                    \
_FIXFLEXOFF_[29] = _FIXFLEXOFF_##OnOnOnOffOn;                                                                     \
_FIXFLEXOFF_[30] = _FIXFLEXOFF_##OnOnOnOnOff;                                                                     \
_FIXFLEXOFF_[31] = _FIXFLEXOFF_##OnOnOnOnOn;
             
#define EinsBesetzen(T1)                                                                                        \
CGH_100     = Classification1Weight_##T1;                                                                   \
                              
#define AllesFuerEinTypPaarBesetzen(T1, T2)                                                                     \
CGH_100     = Classification2Weights_##T1##T2;                                                               \

#define ZweiBesetzen(T1)                                                                                        \
switch (Typ2){                                                                                                  \
 case 1: AllesFuerEinTypPaarBesetzen(T1, 1);break;                                                              \
 case 2: AllesFuerEinTypPaarBesetzen(T1, 2);break;                                                              \
 case 3: AllesFuerEinTypPaarBesetzen(T1, 3);break;                                                              \
 case 4: AllesFuerEinTypPaarBesetzen(T1, 4);break;                                                              \
 default:                                                                                                       \
    fprintf(IO_Strom, "Fehler! Typ2 ist 0 (oder schlimmer)\n\n");                                                          \
}


static void InitializeBody(InfoStringT DEF, InfoStringT USR,
                           int WeightEntryType,
                           BOOLEAN SymbolWeightsChanged)
/*  Aufgaben: 
     a) Zu berechnende Daten bestimmen
     b) Formeln fuer w1 und w2 auswerten (ganz stur!)
     c) Funktionspointer besetzen
     d) Sub-Initialisierungen (u.a. fuer Occnest) vornehmen

    Syntax:

      (1)  w1=SymbolicWeight
      (2)  w1=comb.weight
      (3)  w1=entry.comb.weight1.comb.weight2
      (4)  w1=occnest.comb.weight
      
      mit

      SymbolicWeight=[lifo|fifo]
      comb=[plus|max|min|prod|prodsum|gt]
      weight=[length|depth|flat|ematches|rmatches|rematches]
      entry=[plus|minus|max|min|prod|prodsum]

    Interpretieren:
      - strtok, trenner ist '.' (bis Ende oder  ':')
      - jeden einzelnen Teilstring lesen und mit Liste vergleichen
      - falls gefunden ==> weiter
      - nicht gefunden ==> abbruch
      - jetzt bekannt: 
        Gewichte ==> Berechnungsfunktion besetzen
        Kombinatoren und Gewichte ==> Kombinatorfunktionen besetzen (Achtung: Zusatz-Init)
        Entries ==> Entryfunktionen besetzen

      if (SymbolicWeight)
         ==> fertig, symbolicWeight als Entry 
      else if (Combinator || Entry){
         merken;
         if (Weight)
           gemerktes war Combinator ==> fertig
         else if (Combinator){
           gemerktes war Entry;
           Weight lesen;
           Combinator2 lesen;
           Weight2 lesen;
         }
         else
           Abbruch
       else
         Abbruch
                        
    Zum Besetzen der Funktionsvariablen noch Makros noetig!
    
*/
{
   int Typ1, Typ2, i, index;
   const char *w1Str=NULL, *w2Str=NULL;
   const char *tupel[6]={"length","depth","rmatches","ematches","numbers", "unif"};
   TermweightComputationT Fix[32], Flex[32], Off[32];

   for (i=0;i<6;i++) GewichtsTupel[i]=FALSE;

   Besetze(Fix);
   Besetze(Flex);
   Besetze(Off);

   /* 1) Bestimme Strings zur Definition von w1 und w2 */

   w1Str = IS_ValueOfOption(DEF, USR, "g1");
   w2Str = IS_ValueOfOption(DEF, USR, "g2");
   
   if (!w1Str) {w1Str = w2Str; w2Str=NULL;}
   if (!w1Str) w1Str = "plus.length";
   
   /* 2) Analysiere Strings */

   fprintf(IO_Strom, "  g1 = ");
   StringAnalyzis(w1Str, &W1_Combinator1, &W1_Combinator2, &W1_Entry, &Typ1);

   if (Typ1 == 0){             /* Fehler */
      if (w2Str){
         w1Str = w2Str;
         w2Str = NULL;
      }
      else
         w1Str = "plus.length";

      StringAnalyzis(w1Str, &W1_Combinator1, &W1_Combinator2, &W1_Entry, &Typ1);
   }

   /* Jetzt ist auf jeden Fall fuer das w1-Gewicht gesorgt! */

   fprintf(IO_Strom, "  g2 = ");
   StringAnalyzis(w2Str, &W2_Combinator1, &W2_Combinator2, &W2_Entry, &Typ2);

   if (Typ2==0){
      fprintf(IO_Strom, "---");
      w2Str=NULL;
   }
   
   /* Jetzt: E, C1, C2 und BerechneGewichte besetzt */
   
   fprintf(IO_Strom, "  Typ1 = %d, Typ2 = %d. Weights computed: ", Typ1, Typ2);

   for (i=0; i<6;i++)
      if (GewichtsTupel[i])fprintf(IO_Strom, "%s ", tupel[i]);

   /* Funktionspointer zur Berechnung der Termgewichte besetzen */
   
   index = 8*((int)GewichtsTupel[1])+4*((int)GewichtsTupel[2])+2*((int)GewichtsTupel[3])+((int)GewichtsTupel[4]);

   if (GewichtsTupel[0])
      if (SymbolWeightsChanged){
         fprintf(IO_Strom, "Flex\n");
         ComputeTermWeights = Flex[index];
       }
      else{
         fprintf(IO_Strom, "Fix\n");
         ComputeTermWeights = Fix[index];
      }
   else
      ComputeTermWeights = Off[index];
   

   /* Gemaess Typ1 und Typ2 die Overall-Berechnungs-Funktionen besetzen  (Classify und ReClassify)*/
   
   if (Typ2 == 0)
      switch (Typ1){
      case 1: EinsBesetzen(1);break;
      case 2: EinsBesetzen(2);break;
      case 3: EinsBesetzen(3);break;
      case 4: EinsBesetzen(4);break;
      default:
         fprintf(IO_Strom, "Fehler! Typ1 ist 0 (oder schlimmer)\n\n");
      }
   else
      switch(Typ1){
      case 1: ZweiBesetzen(1);break;
      case 2: ZweiBesetzen(2);break;
      case 3: ZweiBesetzen(3);break;
      case 4: ZweiBesetzen(4);break;
      default:
         fprintf(IO_Strom, "Fehler! Typ1 ist 0 (oder schlimmer)\n\n");
      }
   
   fprintf(IO_Strom, "\n");
}

BOOLEAN CGH_INITIALIZE(InfoStringT DEF, InfoStringT USR, int WeightEntryType)
{
  BOOLEAN Changed = SG_SymbGewichteEintragen(DEF, USR, FALSE);

  InitializeBody(DEF, USR, WeightEntryType, Changed);
  
  if (WeightEntryType == 0) CGH_PrintProc = PrintProc_0;
  else                      CGH_PrintProc = PrintProc_1;
  
  return TRUE;
}
   
   
void CGH_ParamInfo(ParamInfoArtT what, InfoStringT clasDEF, InfoStringT clasUSR)
{
   if (what == ParamEvaluate){
     BOOLEAN Changed = SG_ParamInfo(0, clasDEF, clasUSR, FALSE);
     InitializeBody(clasDEF, clasUSR, 0, Changed);
   }
   else{
      fprintf(IO_Strom,
      "w[1|2]=[[lifo|fifo]|comb.weight|occnest.comb.weight|\n"
      "        entry.comb1.weight1.comb2.weight2]\n");
      SG_ParamInfo(1, clasDEF, clasUSR, FALSE);
   }
}

/* -------------------------------------------------------------------------------------------------------------*/
/* ------------ CLEANING WOMAN ---------------------------------------------------------------------------------*/
/* -------------------------------------------------------------------------------------------------------------*/

void CGH_CleanUp(void)
{;}

/* -------------------------------------------------------------------------------------------------------------*/
/* ------- Statistics ------------------------------------------------------------------------------------------*/
/* -------------------------------------------------------------------------------------------------------------*/

void CGH_Statistics(InfoStringT StatisticsIS MAYBE_UNUSEDPARAM)
{;}

