#include <stdlib.h>
#include <string.h>
#include "compiler-extra.h"

#include "general.h"
#include "Ausgaben.h"
#include "CStatistics.h"
#include "DSBaumOperationen.h"
#include "Hauptkomponenten.h"
#include "Ordnungen.h"
#include "InfoStrings.h"
#include "MNF_Classify.h"
#include "MNF_CPs.h"
#include "NFBildung.h"
#include "OccNest.h"
#include "RUndEVerwaltung.h"
#include "SH2.h"
#include "SUEBasis.h"
#include "StandardHeuristiken.h"
#include "SymbolGewichte.h"
#include "SymbolOperationen.h"
#include "TermOperationen.h"
#include "TermOperationen.h"
#include "Zielverwaltung.h"

/* ------------------------------------------------------------------------*/
/* ---------- globale Variablen (siehe SH2.h)  ----------------------------*/
/* ------------------------------------------------------------------------*/
void (* SH2_0)(WeightEntryT *, TermT, TermT, RegelOderGleichungsT, RegelOderGleichungsT, UTermT);

void (* SH2_50) (WeightEntryT *, TermT, TermT, RegelOderGleichungsT, RegelOderGleichungsT, UTermT);

void (* SH2_100) (WeightEntryT *, TermT, TermT, RegelOderGleichungsT, RegelOderGleichungsT, UTermT);

void (* SH2_200) (WeightEntryT *, TermT, TermT, RegelOderGleichungsT, RegelOderGleichungsT, UTermT);

void (* SH2_pen)(WeightEntryT *, TermT, TermT, RegelOderGleichungsT, RegelOderGleichungsT, UTermT);

int (* SH2_0_Re)(WeightEntryT *, TermT, TermT, RegelOderGleichungsT, RegelOderGleichungsT);

int (* SH2_50_Re) (WeightEntryT *, TermT, TermT, RegelOderGleichungsT, RegelOderGleichungsT);

int (* SH2_100_Re) (WeightEntryT *, TermT, TermT, RegelOderGleichungsT, RegelOderGleichungsT);

int (* SH2_200_Re) (WeightEntryT *, TermT, TermT, RegelOderGleichungsT, RegelOderGleichungsT);

int (* SH2_pen_Re)(WeightEntryT *, TermT, TermT, RegelOderGleichungsT, RegelOderGleichungsT);

void (* SH2_PrintProc) (WeightEntryT *, RegelOderGleichungsT, RegelOderGleichungsT);



typedef long int (* W_CombinatorT) (TermT, TermT, RegelOderGleichungsT, RegelOderGleichungsT, UTermT);
typedef long int (* W_EntryT) (long int, long int);
typedef void (* TermweightComputationT) (TermT, TermT, RegelOderGleichungsT, RegelOderGleichungsT, UTermT);
typedef long int (* SimilarityT) (TermT, TermT, long int);
typedef long int (* W_CIGICT) (TermT, TermT, long int, long int, long int);

static long int length_left, length_right, depth_left, depth_right, rmatches_right, rmatches_left, ematches_left, ematches_right, CPNr = 0;

static long int CIGIC_single_match_1, CIGIC_no_match_1, CIGIC_single_match_2, CIGIC_no_match_2, 
  CIGIC_min_struct_1, CIGIC_min_struct_2;

static TermweightComputationT ComputeTermWeights;
static W_CombinatorT          W1_Combinator1, W1_Combinator2, W2_Combinator1, W2_Combinator2;
static W_EntryT               W1_Entry, W2_Entry;
static SimilarityT            W1_Similarity, W2_Similarity;
static W_CIGICT               W1_CIGIC, W2_CIGIC;

/* ----------------------------------------------------------------------------------------------------------- */
/* ----------------------------Term-Gewichte------------------------------------------------------------------ */
/* ----------------------------------------------------------------------------------------------------------- */

#define LengthFlex                                                                                              \
{                                                                                                               \
    SymbolT symb;                                                                                               \
    length_left = length_right = 0;                                                                             \
    TO_doSymbole(lhs, symb,{                                                                                    \
      length_left  += SG_SymbolGewichtCP(symb);                                                                   \
    });                                                                                                         \
    TO_doSymbole(rhs, symb,{                                                                                    \
      length_right  += SG_SymbolGewichtCP(symb);                                                                  \
    });                                                                                                         \
}

#define LengthFix                                                                                               \
{length_left = TO_Termlaenge(lhs); length_right = TO_Termlaenge(rhs);}
#define LengthOff

#define DepthOn \
{depth_left = TO_Termtiefe(lhs); depth_right = TO_Termtiefe(rhs);}
#define DepthOff

#define RMatchesOn \
{rmatches_left = NF_AnzReduziblerStellenR(lhs); rmatches_right = NF_AnzReduziblerStellenR(rhs);}
#define RMatchesOff

#define EMatchesOn \
{ematches_left = NF_AnzReduziblerStellenE(lhs); ematches_right = NF_AnzReduziblerStellenE(rhs);}
#define EMatchesOff

#define NumbersOn {CPNr++;}
#define NumbersOff

#define ComputeTermWeights(_LENGTH_, _DEPTH_, _RMATCHES_, _EMATCHES_, _NUMBER_)\
static void _LENGTH_## _DEPTH_## _RMATCHES_## _EMATCHES_## _NUMBER_                                    \
(TermT lhs MAYBE_UNUSEDPARAM, TermT rhs MAYBE_UNUSEDPARAM, RegelOderGleichungsT aP MAYBE_UNUSEDPARAM,\
 RegelOderGleichungsT oP MAYBE_UNUSEDPARAM, UTermT actPos MAYBE_UNUSEDPARAM)\
{Length ## _LENGTH_; Depth ## _DEPTH_; RMatches ## _RMATCHES_; EMatches ## _EMATCHES_; Numbers ## _NUMBER_;}

#define DeclareCTW_1(_1_, _2_, _3_)                                                             \
ComputeTermWeights(_1_, _2_, _3_, On, On)                                                       \
ComputeTermWeights(_1_, _2_, _3_, On, Off)                                                      \
ComputeTermWeights(_1_, _2_, _3_, Off, On)                                                      \
ComputeTermWeights(_1_, _2_, _3_, Off, Off)

#define DeclareCTW_2(_1_)                                                                       \
DeclareCTW_1(_1_, On, On)                                                                       \
DeclareCTW_1(_1_, On, Off)                                                                      \
DeclareCTW_1(_1_, Off, On)                                                                      \
DeclareCTW_1(_1_, Off, Off)

DeclareCTW_2(Flex)
DeclareCTW_2(Fix)
DeclareCTW_2(Off)

#define LENGTHleft    length_left
#define LENGTHright   length_right
#define DEPTHleft     depth_left
#define DEPTHright    depth_right
#define FLATNESSleft  (-depth_left)
#define FLATNESSright (-depth_right)
#define EMATCHESleft  ematches_left
#define EMATCHESright ematches_right
#define RMATCHESleft  rmatches_left
#define RMATCHESright rmatches_right
#define REMATCHESleft  (rmatches_left + ematches_left)
#define REMATCHESright (rmatches_right + ematches_right)
#define MNFWeightleft  MNFC_WeightLeft
#define MNFWeightright MNFC_WeightRight
#define MNFIrredleft   MNFC_IrredLeft
#define MNFIrredright   MNFC_IrredRight
#define MNFWeightHleft  MNFC_WeightHarmLeft
#define MNFWeightHright MNFC_WeightHarmRight
#define MNFWeightGleft  MNFC_WeightGeoLeft
#define MNFWeightGright MNFC_WeightGeoRight     
#define MNFMinWeightleft  MNFC_MinWeightLeft
#define MNFMinWeightright MNFC_MinWeightRight
#define MNFMaxWeightleft  MNFC_MaxWeightLeft
#define MNFMaxWeightright MNFC_MaxWeightRight
     
static long int phi(TermT term)
{
  SymbolT symb;
  long int weight = 0;
  TO_doSymbole(term, symb,{
    weight  += SG_SymbolGewichtCP(symb);
  });
  return weight;
}

static TermT KPLinks,
             KPRechts;
static long int SingleMatchFactor, NoMatchFactor, MinStruct;

typedef enum {Nullmatch, Einfachmatch, Doppelmatch} LevelT;

typedef struct {
  LevelT Level;
  signed int Masse;
  BOOLEAN schonErgebnisse;
} ErgebnisT;

/* Die Teilminimierung erfolgt lexikographisch ueber Level und Masse.
   Level wird dabei umgekehrt minimiert ("je hoeher, desto minimaler").
   Die Gesamtminimierung erfolgt nur ueber Masse. */

static ErgebnisT GesamtErgebnis,
                 TeilErgebnis;

static void GesamtminimierungBeginnen(void)
{
  GesamtErgebnis.schonErgebnisse = FALSE;
}

static void TeilminimierungBeginnen(void)
{
  TeilErgebnis.schonErgebnisse = FALSE;
}

static void TeilMinimieren(LevelT Level, signed int Masse)
{
  if (TeilErgebnis.schonErgebnisse) {
    if (TeilErgebnis.Level<Level) {
      TeilErgebnis.Level = Level;
      TeilErgebnis.Masse = Masse;
    }
    else if (TeilErgebnis.Level==Level && TeilErgebnis.Masse>Masse) 
      TeilErgebnis.Masse = Masse;
  }
  else {
    TeilErgebnis.schonErgebnisse = TRUE;
    TeilErgebnis.Level = Level;
    TeilErgebnis.Masse = Masse;
  }
}

static void GesamtMinimieren(void)
{
  if (GesamtErgebnis.schonErgebnisse) {
    if (GesamtErgebnis.Masse>TeilErgebnis.Masse)
      GesamtErgebnis.Masse = TeilErgebnis.Masse;
  }
  else {
    GesamtErgebnis.schonErgebnisse = TRUE;
    GesamtErgebnis.Masse = TeilErgebnis.Masse;
  }
}

static BOOLEAN NochKeinDoppelmatch(void)
{
  return !TeilErgebnis.schonErgebnisse || TeilErgebnis.Level<Doppelmatch;
}

#define Matching_KP(/*Bezeichner*/ Index, /*{Links; Rechts}*/ SenkeSeite, /*{"Sigma"; ""}*/ Sigma)                  \
  MO_ ## Sigma ## TermIstGeneralisierung(KP ## SenkeSeite, Index)               /* KP ist Senke -> Ziel gibt Index */

#define Matching_Ziel(/*Bezeichner*/ Index, /*{Links; Rechts}*/ SenkeSeite, /*{"Sigma"; ""}*/ Sigma)                \
  (phi(Index)>=MinStruct &&                                                                                         \
    MO_ ## Sigma ## TermIstGeneralisierung(Index, Ziel ## SenkeSeite))          /* Ziel ist Senke -> KP gibt Index */
  /* Mit Ziel als Senke ist KP Quelle, d. h. Index durchlaeuft KP, also Experte GoalInCP.
     Dafuer Matchpraedikat erweitert um Bedingung AddWeight(Index)>=MinStruct */


#define Matching(/*Bezeichner*/ Index, /*{"KP"; "Ziel"}*/ Senke, /*{Links; Rechts}*/ SenkeSeite)                    \
  Matching_ ## Senke(Index, SenkeSeite, )

#define SigmaMatching(/*Bezeichner*/ Index, /*{"KP"; "Ziel"}*/ Senke, /*{Links; Rechts}*/ SenkeSeite)               \
  Matching_ ## Senke(Index, SenkeSeite, Sigma)            
            
            
#define RumpfXinYDurchlauffunktion(/*{"KP"; "Ziel"}*/ Quelle, /*{"KP"; "Ziel"}*/ Senke)                             \
{                                                                                                                   \
  UTermT IndexLinks = Quelle ## Links;                                                                              \
  signed long int GewichtLinks = phi(Quelle ## Links),                                                              \
                  GewichtRechts = phi(Quelle ## Rechts);                                                            \
  TeilminimierungBeginnen();                                                                                        \
  do {                                                                                                              \
    if (Matching(IndexLinks,Senke,Links)) {                                                                         \
      UTermT IndexRechts = Quelle ## Rechts;                                                                        \
      signed int TeilgewichtLinks = GewichtLinks-phi(IndexLinks);                                                   \
      TeilMinimieren(Einfachmatch,(TeilgewichtLinks+GewichtRechts)*SingleMatchFactor);                              \
      do {                                                                                                          \
        if (SigmaMatching(IndexRechts,Senke,Rechts))                                                                \
          TeilMinimieren(Doppelmatch,TeilgewichtLinks+GewichtRechts-phi(IndexRechts));                              \
      } while ((IndexRechts = TO_Schwanz(IndexRechts)));                                                            \
    }                                                                                                               \
    if (Matching(IndexLinks,Senke,Rechts)) {                                                                        \
      UTermT IndexRechts = Quelle ## Rechts;                                                                        \
      signed int TeilgewichtLinks = GewichtLinks-phi(IndexLinks);                                                   \
      TeilMinimieren(Einfachmatch,(TeilgewichtLinks+GewichtRechts)*SingleMatchFactor);                              \
      do {                                                                                                          \
        if (SigmaMatching(IndexRechts,Senke,Links))                                                                 \
          TeilMinimieren(Doppelmatch,TeilgewichtLinks+GewichtRechts-phi(IndexRechts));                              \
      } while ((IndexRechts = TO_Schwanz(IndexRechts)));                                                            \
    }                                                                                                               \
  } while ((IndexLinks = TO_Schwanz(IndexLinks)));                                                                  \
  if (NochKeinDoppelmatch()) {                                                                                      \
    UTermT IndexRechts = Quelle ## Rechts;                                                                          \
    do {                                                                                                            \
      if (Matching(IndexRechts,Senke,Links) || Matching(IndexRechts,Senke,Rechts))                                  \
        TeilMinimieren(Einfachmatch,(GewichtRechts-phi(IndexRechts)+GewichtLinks)*SingleMatchFactor);               \
    } while ((IndexRechts = TO_Schwanz(IndexRechts)));                                                              \
  }                                                                                                                 \
  TeilMinimieren(Nullmatch,(phi(KPLinks)+phi(KPRechts))*NoMatchFactor);                                             \
  GesamtMinimieren();                                                                                               \
}


static void CPinGoalDurchlauffunktion(TermT ZielLinks, TermT ZielRechts, unsigned long Zielnummer)
  RumpfXinYDurchlauffunktion(Ziel, KP)


static void GoalinCPDurchlauffunktion(TermT ZielLinks, TermT ZielRechts, unsigned long Zielnummer)
  RumpfXinYDurchlauffunktion(KP, Ziel)


#define DefiniereXinY(/*{CPinGoal, GoalinCP}*/ XinY)                                                              \
  static long int XinY(TermT KPLinks_, TermT KPRechts_, long int SMfactor, long int NMfactor, long int MSfactor)  \
  {                                                                                                               \
    BO_TermpaarNormierenAlsKP(KPLinks = KPLinks_, KPRechts = KPRechts_);                                          \
    GesamtminimierungBeginnen();                                                                                  \
    SingleMatchFactor = SMfactor;                                                                                 \
    NoMatchFactor = NMfactor;                                                                                     \
    MinStruct = MSfactor;                                                                                         \
    Z_ZielmengenBeobachtungsDurchlauf(XinY ## Durchlauffunktion);                                                 \
    return GesamtErgebnis.Masse;                                                                                  \
  }

DefiniereXinY(CPinGoal)

DefiniereXinY(GoalinCP)

/* ----------------------------------------------------------------------------------------------------------- */
/* --------------------------Combinators---------------------------------------------------------------------- */
/* ----------------------------------------------------------------------------------------------------------- */

/* term-weight ----(combinator)----> equation-weight */

#define PLUS(x,y,lhs,rhs,aP,oP,actPos)    return (x+y)
#define MAX(x,y,lhs,rhs,aP,oP,actPos)     return (x>y?x:y)
#define MIN(x,y,lhs,rhs,aP,oP,actPos)     return (x<y?x:y)
#define PROD(x,y,lhs,rhs,aP,oP,actPos)    return (x*y)
#define PRODSUM(x,y,lhs,rhs,aP,oP,actPos) return (x*y+x+y)
#define GT(x,y,lhs,rhs,aP,oP,actPos)                                                                            \
{                                                                                                               \
   switch (ORD_VergleicheTerme(lhs, rhs)){                                                                       \
   case Groesser:                                                                                               \
      return x;                                                                                                 \
      break;                                                                                                    \
   case Kleiner:                                                                                                \
      return y;                                                                                                 \
      break;                                                                                                    \
   default:                                                                                                     \
      return x+y;                                                                                               \
      break;                                                                                                    \
   }                                                                                                            \
}


/* ----------------------------------------------------------------------------------------------------------- */
/* --------------------------Equation-Weights----------------------------------------------------------------- */
/* ----------------------------------------------------------------------------------------------------------- */
#define Combination_Body(WEIGHT, _Combinator_)                                                                  \
static long int _Combinator_ ## WEIGHT                                                                                 \
(TermT lhs MAYBE_UNUSEDPARAM, TermT rhs MAYBE_UNUSEDPARAM, RegelOderGleichungsT actualParent MAYBE_UNUSEDPARAM, \
 RegelOderGleichungsT otherParent MAYBE_UNUSEDPARAM, UTermT actualPosition MAYBE_UNUSEDPARAM)                   \
{_Combinator_(WEIGHT ## left, WEIGHT ## right, lhs, rhs, actualParent, otherParent, actualPosition);}

#define AllCombinators(WEIGHT)                                                                                  \
Combination_Body(WEIGHT, PLUS)                                                                                  \
Combination_Body(WEIGHT, MAX)                                                                                   \
Combination_Body(WEIGHT, MIN)                                                                                   \
Combination_Body(WEIGHT, PROD)                                                                                  \
Combination_Body(WEIGHT, PRODSUM)                                                                               \
Combination_Body(WEIGHT, GT)

AllCombinators(LENGTH)
AllCombinators(DEPTH)
AllCombinators(FLATNESS)
AllCombinators(EMATCHES)
AllCombinators(RMATCHES)
AllCombinators(REMATCHES)
AllCombinators(MNFWeight)  
AllCombinators(MNFWeightH)
AllCombinators(MNFWeightG)
AllCombinators(MNFIrred)
AllCombinators(MNFMinWeight)
AllCombinators(MNFMaxWeight)
     
/* ----------------------------------------------------------------------------------------------------------- */
/* ---------------------------Big-Entries--------------------------------------------------------------------- */
/* ----------------------------------------------------------------------------------------------------------- */

#define WEPLUS(x,y)(x+y)
#define WEMINUS(x,y)(x-y)
#define WEMAX(x,y)(x>y?x:y)
#define WEMIN(x,y)(x<y?x:y)
#define WEPROD(x,y)(x*y)
#define WEPRODSUM(x,y)(x*y+x+y)
#define WEFIFO(x,y)(CPNr)
#define WELIFO(x,y)(-CPNr)

#define WE_BODY(_we_)                                                                                           \
static long int ComputeWE ## _we_(long int x MAYBE_UNUSEDPARAM, long int y MAYBE_UNUSEDPARAM)                          \
{return (WE##_we_(x,y));}

WE_BODY(PLUS)
WE_BODY(MINUS)
WE_BODY(MAX)
WE_BODY(MIN)
WE_BODY(PROD)
WE_BODY(PRODSUM)
WE_BODY(FIFO)
WE_BODY(LIFO)

/* ----------------------------------------------------------------------------------------------------------- */
/* ----------------------------Deklarationen------------------------------------------------------------------ */
/* ----------------------------------------------------------------------------------------------------------- */

#define cut_min(x) (LONG_MIN)
#define cut_50(x) (x/2)
#define cut_100(x) (x)
#define cut_200(x) (2*x)
#define cut_pen(x) (LONG_MAX)

#define Computation_wi_Body_Typ1(_i_, CUT)              \
{                                                       \
   wt->w## _i_ = cut_ ## CUT((*W##_i_##_Entry)(0,0));   \
}

#define Computation_wi_Body_Typ2(_i_, CUT)                                                              \
{                                                                                                       \
  wt->w##_i_=cut_ ## CUT((* W## _i_ ##_Combinator1)(lhs, rhs,actualParent,otherParent,actualPosition)); \
}

#define Computation_wi_Body_Typ3(_i_, CUT)                                                      \
{                                                                                               \
   long int c1, c2;                                                                             \
                                                                                                \
   c1 = (* W## _i_ ##_Combinator1)(lhs, rhs, actualParent, otherParent, actualPosition);        \
   c2 = (* W## _i_ ##_Combinator2)(lhs, rhs, actualParent, otherParent, actualPosition);        \
                                                                                                \
   wt->w## _i_ = cut_ ## CUT((*W##_i_##_Entry)(c1, c2));                                        \
}

#define Computation_wi_Body_Typ4(_i_, CUT)                                                      \
{                                                                                               \
   wt->w## _i_ = cut_ ## CUT((* W## _i_ ##_Similarity) (lhs, rhs, (* W## _i_ ##_Combinator1)    \
                            (lhs, rhs, actualParent, otherParent, actualPosition)));            \
}

#define Computation_wi_Body_Typ5(_i_, CUT)                                                                      \
{                                                                                                               \
  wt->w## _i_ = cut_ ## CUT((*W##_i_##_CIGIC) (lhs, rhs, CIGIC_single_match_##_i_, CIGIC_no_match_##_i_,        \
                                               CIGIC_min_struct_##_i_));                                        \
  IO_DruckeFlex("Bewertetes CP: %t = %t,", lhs, rhs);                                                           \
  printf("errechnetes Gewicht: %ld\n", wt->w## _i_);                                                            \
}

#define OneWeight(firstWeight, TYP1)                                                                                                                                             \
static void Classification1Weight_ ## firstWeight ## _ ## TYP1(WeightEntryT *wt, TermT lhs, TermT rhs, RegelOderGleichungsT actualParent, RegelOderGleichungsT otherParent, UTermT actualPosition) \
{                                                                                                                                                                                          \
   (* ComputeTermWeights)(lhs, rhs, actualParent, otherParent, actualPosition);                                                                                                            \
   Computation_wi_Body_Typ ## TYP1(1, firstWeight);                                                                                                                                            \
   CS_BerechnetesGewichtIst(wt->w1);                                                                                                                                          \
}

#define TwoWeights(firstWeight, TYP1, TYP2)                                                                                                                                              \
static void Classification2Weights_ ## firstWeight ## _ ## TYP1 ## TYP2(WeightEntryT *wt, TermT lhs, TermT rhs, RegelOderGleichungsT actualParent, RegelOderGleichungsT otherParent, UTermT actualPosition) \
{                                                                                                                                                                                                  \
   (* ComputeTermWeights)(lhs, rhs, actualParent, otherParent, actualPosition);                                                                                                                    \
   Computation_wi_Body_Typ ## TYP1(1, firstWeight);                                                                                                                                                 \
   Computation_wi_Body_Typ ## TYP2(2, 100);                                                                                                                                                            \
   CS_BerechnetesGewichtIst(wt->w1);                                                                                                                                                  \
}

/* Achtung: Reclassification erhaelt _keine_ actualPosition uebergeben,
            daher wird ein NULL-Pointer durchgereicht!
*/

#define ReclasOneWeight(firstWeight, TYP1)                                                                                                               \
static int ReClassification1Weight_ ## firstWeight ## _ ## TYP1 (WeightEntryT *wt, TermT lhs, TermT rhs, RegelOderGleichungsT actualParent, RegelOderGleichungsT otherParent) \
{                                                                                                                                                        \
   long int save = (wt->w1);                                                                                                                             \
   UTermT actualPosition = NULL;                                                                                                                         \
   (* ComputeTermWeights)(lhs, rhs, actualParent, otherParent, actualPosition);                                                                          \
   Computation_wi_Body_Typ ## TYP1(1, firstWeight);                                                                                                          \
   if ((wt->w1) == save) return 0;          /* gleichbleibend */                                                                                         \
   else if ((wt->w1) < save) return 1;      /* besser */                                                                                                 \
   else return 2;                           /* schlechter */                                                                                             \
}

#define ReclasTwoWeights(firstWeight, TYP1, TYP2)                                                                                                         \
static int ReClassification2Weights_ ## firstWeight ## _ ## TYP1 ## TYP2(WeightEntryT *wt, TermT lhs, TermT rhs, RegelOderGleichungsT actualParent, RegelOderGleichungsT otherParent) \
{                                                                                                                                                         \
   long int save = (wt->w1);                                                                                                                              \
   UTermT actualPosition = NULL;                                                                                                                          \
   (* ComputeTermWeights)(lhs, rhs, actualParent, otherParent, actualPosition);                                                                           \
   Computation_wi_Body_Typ ## TYP1(1, firstWeight);                                                                                                           \
   Computation_wi_Body_Typ ## TYP2(2, 100);                                                                                                                   \
   if ((wt->w1) == save) return 0;          /* gleichbleibend */                                                                                          \
   else if ((wt->w1) < save) return 1;      /* besser */                                                                                                  \
   else return 2;                           /* schlechter */                                                                                              \
}

#define DECLARE(__CUT__, _TYP1_)                \
OneWeight(__CUT__, _TYP1_)                      \
TwoWeights(__CUT__, _TYP1_, 1)                  \
TwoWeights(__CUT__, _TYP1_, 2)                  \
TwoWeights(__CUT__, _TYP1_, 3)                  \
TwoWeights(__CUT__, _TYP1_, 4)                  \
TwoWeights(__CUT__, _TYP1_, 5)                  \
ReclasOneWeight(__CUT__, _TYP1_)                \
ReclasTwoWeights(__CUT__, _TYP1_, 1)            \
ReclasTwoWeights(__CUT__, _TYP1_, 2)            \
ReclasTwoWeights(__CUT__, _TYP1_, 3)            \
ReclasTwoWeights(__CUT__, _TYP1_, 4)            \
ReclasTwoWeights(__CUT__, _TYP1_, 5)

#define DECLARE_CUT(_TYP1_)                     \
DECLARE(min, _TYP1_)                            \
DECLARE(50,  _TYP1_)                            \
DECLARE(100, _TYP1_)                            \
DECLARE(200, _TYP1_)                            \
DECLARE(pen, _TYP1_)

DECLARE_CUT(1)
DECLARE_CUT(2)
DECLARE_CUT(3)
DECLARE_CUT(4)
DECLARE_CUT(5)

/* 
   Funktions-Pattern:
   Classification1Weight_min_1
   Classification2Weights_min_11, ..., Classification2Weights_minStat14
   ReClassification1Weight_min_1
   ReClassification2Weights_min_11 ...
   Classification1Weight_50_1
   ...
 */

/* -------------------------------------------------------------------------------------------------------------*/
/* ------- Output ----------------------------------------------------------------------------------------------*/
/* -------------------------------------------------------------------------------------------------------------*/

static void PrintProc_0(WeightEntryT *wt,
                        RegelOderGleichungsT aP MAYBE_UNUSEDPARAM,
                        RegelOderGleichungsT oP MAYBE_UNUSEDPARAM)
{
   fprintf(IO_Strom, "%11ld", wt->w1);
}

static void PrintProc_1(WeightEntryT *wt,
                        RegelOderGleichungsT aP MAYBE_UNUSEDPARAM,
                        RegelOderGleichungsT oP MAYBE_UNUSEDPARAM)
{
   fprintf(IO_Strom, "%11ld.%11ld.", wt->w1, wt->w2);
}


/* ----------------------------------------------------------------------------------------------------------- */
/* --------------------------------Initialisierung------------------------------------------------------------ */
/* ----------------------------------------------------------------------------------------------------------- */
#define COUNT_SYMBOLIC_AR 2
#define COUNT_SIMILARITY_AR 1
#define COUNT_COMBINATOR_AR 6
#define COUNT_WEIGHTAR 12
#define COUNT_ENTRY_AR 6
#define COUNT_CIGIC_AR 2

static int StringInFeld(const char *String, const char *Feld[], int Elemente)
{
   int i;
   
   if (!String) return FALSE;

   for (i=0; i<Elemente; i++)
      if (strcmp(String, Feld[i]) == 0)
         return i;
   return -1;
}

static const char
     *SymbolicWeightAR[COUNT_SYMBOLIC_AR] = {"lifo","fifo"},
     *similarityAR[COUNT_SIMILARITY_AR]   = {"occnest"},
     *combAR[COUNT_COMBINATOR_AR]         = {"plus", "max", "min", "prod", "prodsum", "gt"},
     *weightAR[COUNT_WEIGHTAR]            = {"length", "depth", "flat", "ematches", "rmatches", "rematches",
                                             "mnfweight", "mnfirred", "mnfweighth", "mnfmin", "mnfmax",
                                             "mnfweightg"},
     *entryAR[COUNT_ENTRY_AR]             = {"plus", "minus", "max", "min", "prod", "prodsum"},
     *CIGICAR[COUNT_CIGIC_AR]             = {"cig", "gic"};

#define IstSymbolicWeight(str) StringInFeld(str, SymbolicWeightAR, COUNT_SYMBOLIC_AR)
#define IstSimilarity(str) StringInFeld(str, similarityAR, COUNT_SIMILARITY_AR)
#define IstCombinator(str) StringInFeld(str, combAR,COUNT_COMBINATOR_AR)
#define IstWeight(str) StringInFeld(str, weightAR, COUNT_WEIGHTAR)
#define IstEntry(str) StringInFeld(str, entryAR,COUNT_ENTRY_AR)
#define IstCIGIC(str) StringInFeld(str, CIGICAR,COUNT_CIGIC_AR)


#define FunktionZuWeight(_COMB_)                                                                                \
switch(w){                                                                                                      \
 case 0: Funktion = _COMB_ ## LENGTH; break;                                                                    \
 case 1: Funktion = _COMB_ ## DEPTH; break;                                                                     \
 case 2: Funktion = _COMB_ ## FLATNESS; break;                                                                  \
 case 3: Funktion = _COMB_ ## EMATCHES; break;                                                                  \
 case 4: Funktion = _COMB_ ## RMATCHES; break;                                                                  \
 case 5: Funktion = _COMB_ ## REMATCHES; break;                                                                 \
 case 6: Funktion = _COMB_ ## MNFWeight; break;                                                                \
 case 7: Funktion = _COMB_ ## MNFIrred; break;                                                                \
 case 8: Funktion = _COMB_ ## MNFWeightH; break;                                                                \
 case 9: Funktion = _COMB_ ## MNFMinWeight; break;                                                                \
 case 10: Funktion = _COMB_ ## MNFMaxWeight; break;                                                                \
 case 11: Funktion = _COMB_ ## MNFWeightG; break;                                                                \
 default: fprintf(IO_Strom, "FEHLER! Weight-Nummer nicht gefunden\n\n");break;                                  \
}

static W_CombinatorT FunktionspointerAusCombinatorUndGewicht(int comb, int w)
{
   W_CombinatorT Funktion;
   switch(comb){
   case 0: FunktionZuWeight(PLUS); break;
   case 1: FunktionZuWeight(MAX); break;
   case 2: FunktionZuWeight(MIN); break;
   case 3: FunktionZuWeight(PROD); break;
   case 4: FunktionZuWeight(PRODSUM); break;
   case 5: FunktionZuWeight(GT); break;
   default: fprintf(IO_Strom, "FEHLER! Kombinator-Nummer nicht gefunden\n\n");break;
   }
   return Funktion;
}

static BOOLEAN GewichtsTupel[6] = {FALSE, FALSE, FALSE, FALSE, FALSE, FALSE};
                                /* length,depth,ematches,rmatches,fifo,mnf  */
static void MeldeGewicht(int w)
/* w enthaelt Position aus Gewichtsarray; -1 bedeutet Fifo/Lifo */
{
   switch(w){
   case -1: GewichtsTupel[4] = TRUE;break;
   case 0: GewichtsTupel[0] = TRUE; break;
   case 1: GewichtsTupel[1] = TRUE; break;
   case 2: GewichtsTupel[1] = TRUE; break;
   case 3: GewichtsTupel[3] = TRUE; break;
   case 4: GewichtsTupel[2] = TRUE; break;
   case 5: GewichtsTupel[2] = TRUE; GewichtsTupel[3] = TRUE; break;
   case 6:
   case 7:
   case 8:
   case 9:
   case 10:
   case 11:
      GewichtsTupel[5] = TRUE;
      break;
   default:  fprintf(IO_Strom, "FEHLER! Gewicht nicht gefunden bei MeldeGewicht\n\n");break;
   }
}

static void SymbolicWeightInit(int nr, W_EntryT *E)
{
   /* Entry-Funktion besetzen */
   if (nr == 0) *E = ComputeWELIFO;
   else         *E = ComputeWEFIFO;

   MeldeGewicht(-1);
   fprintf(IO_Strom, "%s\n", SymbolicWeightAR[nr]);
}

static void SimilarityInit(int nr, int comb, int w, W_CombinatorT *C1, SimilarityT *S1)
{
   MeldeGewicht(w);
   *C1 = FunktionspointerAusCombinatorUndGewicht(comb, w);
   if (nr==0){
     ON_Init();
     *S1 = ON_OccNest;
     fprintf(IO_Strom, "OccNest(%s(%s))\n", combAR[comb], weightAR[w]);
   }
}

static void CIGICInit(int nr, char *single_match, char *no_match, char *min_struct, 
                      W_CIGICT *C, long int *Csm, long int *Cnm, long int *Cms)
{
  *Csm = atoi(single_match);
  *Cnm = atoi(no_match);

  if (nr ==0){                   /* cig */
    *C = CPinGoal;
    fprintf(IO_Strom, "CIG(sm=%ld, nm=%ld)\n", *Csm, *Cnm);
  }
  else{                         /* gic */
    *C = GoalinCP;
    if (min_struct){
      *Cms = atoi(min_struct);
      fprintf(IO_Strom, "GIC(sm=%ld, nm=%ld, ms=%ld)\n", *Csm, *Cnm, *Cms);
    }
    else{
      *Cms = 4;
      fprintf(IO_Strom, "GIC(sm=%ld, nm=%ld, ms=4 (default))\n", *Csm, *Cnm);
    }
  }
}

static void CombinatorInit(int comb, int w, W_CombinatorT *C1)
{
   *C1 = FunktionspointerAusCombinatorUndGewicht(comb, w);
   MeldeGewicht(w);
   fprintf(IO_Strom, "%s(%s)\n", combAR[comb], weightAR[w]);
}

static void BigInit(int e, int c1, int w1, int c2, int w2, W_CombinatorT *C1, W_CombinatorT *C2, W_EntryT *E)
{
   *C1 = FunktionspointerAusCombinatorUndGewicht(c1, w1);
   *C2 = FunktionspointerAusCombinatorUndGewicht(c2, w2);
   switch(e){
   case 0: *E = ComputeWEPLUS; break;
   case 1: *E = ComputeWEMINUS; break;
   case 2: *E = ComputeWEMAX; break;
   case 3: *E = ComputeWEMIN; break;
   case 4: *E = ComputeWEPROD; break;
   case 5: *E = ComputeWEPRODSUM; break;
   default: fprintf(IO_Strom, "FEHLER! Entry-Nummer nicht gefunden\n\n");break;
   }
   MeldeGewicht(w1);
   MeldeGewicht(w2);
   fprintf(IO_Strom, "%s(%s(%s), %s(%s))\n", entryAR[e], combAR[c1], weightAR[w1], combAR[c2], weightAR[w2]);
}

static void StringAnalyzis(const char *STR, W_CombinatorT *C1, W_CombinatorT *C2, W_EntryT *E, 
                           SimilarityT *S, 
                           W_CIGICT *CIGIC, int *Typ, long int *Csm, long int *Cnm, long int *Cms)
{
   char *s[5];
   int i = 0;
   
   char *kopie,  *token, *kopieDummy;
   
   /* 1) Teilstrings berechnen */

   if (!STR) {*Typ = 0; return;}          /* String ist leer -> Fehler */

   kopie = (char *) our_alloc(sizeof(char)*(strlen(STR)+1));
   strcpy(kopie, STR);
   kopieDummy = kopie;

   while((token = strtok(kopieDummy, "."))){
      kopieDummy = NULL;             /* gemaess Spezifikation von strtok */
      s[i++]=token;
   }


   /* 2) Eintraege w1 ... w5 bestimmen */
   
   if ((i>0) && (IstSymbolicWeight(s[0])!=-1)){
      SymbolicWeightInit(IstSymbolicWeight(s[0]), E);
      *Typ = 1;
   }
   /* kein Symbolic Weight */
   else if ((i>2) && (IstSimilarity(s[0]) != -1) && (IstCombinator(s[1]) !=-1) && (IstWeight(s[2])!= -1)){
      SimilarityInit(IstSimilarity(s[0]),IstCombinator(s[1]),IstWeight(s[2]), C1, S);
      *Typ=4;
   }
   else if ((i>1) && (IstCombinator(s[0]) !=-1) && (IstWeight(s[1])!= -1)){
      CombinatorInit(IstCombinator(s[0]), IstWeight(s[1]), C1);
      *Typ = 2;
   }
   else if ((i>1) && (IstEntry(s[0])!=-1) && 
       (IstCombinator(s[1]) !=-1) && 
       (IstWeight(s[2])!= -1) && (IstCombinator(s[3]) !=-1) && (IstWeight(s[4])!= -1)){
      BigInit(IstEntry(s[0]),IstCombinator(s[1]),IstWeight(s[2]),IstCombinator(s[3]),IstWeight(s[4]),
              C1, C2, E);
      *Typ = 3;
   }
   else if ((i>2) && (IstCIGIC(s[0])!=-1)){
     CIGICInit(IstCIGIC(s[0]), s[1], s[2], (i>3)?s[3]:NULL, CIGIC, Csm, Cnm, Cms);
     *Typ = 5;
   }
   else {
      *Typ = 0;                    /* Fehlerfall! */
   }
   
   our_dealloc(kopieDummy);
}

#define Besetze(_FIXFLEXOFF_)                                                                                   \
_FIXFLEXOFF_[0] = _FIXFLEXOFF_##OffOffOffOff;                                                                   \
_FIXFLEXOFF_[1] = _FIXFLEXOFF_##OffOffOffOn;                                                                    \
_FIXFLEXOFF_[2] = _FIXFLEXOFF_##OffOffOnOff;                                                                    \
_FIXFLEXOFF_[3] = _FIXFLEXOFF_##OffOffOnOn;                                                                     \
_FIXFLEXOFF_[4] = _FIXFLEXOFF_##OffOnOffOff;                                                                    \
_FIXFLEXOFF_[5] = _FIXFLEXOFF_##OffOnOffOn;                                                                     \
_FIXFLEXOFF_[6] = _FIXFLEXOFF_##OffOnOnOff;                                                                     \
_FIXFLEXOFF_[7] = _FIXFLEXOFF_##OffOnOnOn;                                                                      \
_FIXFLEXOFF_[8] = _FIXFLEXOFF_##OnOffOffOff;                                                                    \
_FIXFLEXOFF_[9] = _FIXFLEXOFF_##OnOffOffOn;                                                                     \
_FIXFLEXOFF_[10] = _FIXFLEXOFF_##OnOffOnOff;                                                                    \
_FIXFLEXOFF_[11] = _FIXFLEXOFF_##OnOffOnOn;                                                                     \
_FIXFLEXOFF_[12] = _FIXFLEXOFF_##OnOnOffOff;                                                                    \
_FIXFLEXOFF_[13] = _FIXFLEXOFF_##OnOnOffOn;                                                                     \
_FIXFLEXOFF_[14] = _FIXFLEXOFF_##OnOnOnOff;                                                                     \
_FIXFLEXOFF_[15] = _FIXFLEXOFF_##OnOnOnOn;
             
#define EinsBesetzen(T1)                                                                                        \
SH2_0       = Classification1Weight_min_##T1;                                                                   \
SH2_50      = Classification1Weight_50_##T1;                                                                    \
SH2_100     = Classification1Weight_100_##T1;                                                                   \
SH2_200     = Classification1Weight_200_##T1;                                                                   \
SH2_pen     = Classification1Weight_pen_##T1;                                                                   \
SH2_0_Re    = ReClassification1Weight_min_##T1;                                                                 \
SH2_50_Re   = ReClassification1Weight_50_##T1;                                                                  \
SH2_100_Re  = ReClassification1Weight_100_##T1;                                                                 \
SH2_200_Re  = ReClassification1Weight_200_##T1;                                                                 \
SH2_pen_Re  = ReClassification1Weight_pen_##T1;
                              
#define AllesFuerEinTypPaarBesetzen(T1, T2)                                                                     \
SH2_0       = Classification2Weights_min_##T1##T2;                                                               \
SH2_50      = Classification2Weights_50_##T1##T2;                                                                \
SH2_100     = Classification2Weights_100_##T1##T2;                                                               \
SH2_200     = Classification2Weights_200_##T1##T2;                                                               \
SH2_pen     = Classification2Weights_pen_##T1##T2;                                                               \
SH2_0_Re    = ReClassification2Weights_min_##T1##T2;                                                             \
SH2_50_Re   = ReClassification2Weights_50_##T1##T2;                                                              \
SH2_100_Re  = ReClassification2Weights_100_##T1##T2;                                                             \
SH2_200_Re  = ReClassification2Weights_200_##T1##T2;                                                             \
SH2_pen_Re  = ReClassification2Weights_pen_##T1##T2;

#define ZweiBesetzen(T1)                                                                                        \
switch (Typ2){                                                                                                  \
 case 1: AllesFuerEinTypPaarBesetzen(T1, 1);break;                                                              \
 case 2: AllesFuerEinTypPaarBesetzen(T1, 2);break;                                                              \
 case 3: AllesFuerEinTypPaarBesetzen(T1, 3);break;                                                              \
 case 4: AllesFuerEinTypPaarBesetzen(T1, 4);break;                                                              \
 case 5: AllesFuerEinTypPaarBesetzen(T1, 5);break;                                                              \
 default:                                                                                                       \
    fprintf(IO_Strom, "Fehler! Typ2 ist 0 (oder schlimmer)\n\n");                                                          \
}


static void InitializeBody(InfoStringT DEF, InfoStringT USR, int *WeightEntryType, BOOLEAN SymbolWeightsChanged)
/*  Aufgaben: 
     a) Zu berechnende Daten bestimmen
     b) Formeln fuer w1 und w2 auswerten (ganz stur!)
     c) Funktionspointer besetzen
     d) Sub-Initialisierungen (u.a. fuer Occnest) vornehmen

    Syntax:

      (1)  w1=SymbolicWeight
      (2)  w1=comb.weight
      (3)  w1=entry.comb.weight1.comb.weight2
      (4)  w1=occnest.comb.weight
      
      mit

      SymbolicWeight=[lifo|fifo]
      comb=[plus|max|min|prod|prodsum|gt]
      weight=[length|depth|flat|ematches|rmatches|rematches|mnfweight|mnfirred]
      entry=[plus|minus|max|min|prod|prodsum]

    Interpretieren:
      - strtok, Trenner ist '.' (bis Ende oder  ':')
      - jeden einzelnen Teilstring lesen und mit Liste vergleichen
      - falls gefunden ==> weiter
      - nicht gefunden ==> abbruch
      - jetzt bekannt: 
        Gewichte ==> Berechnungsfunktion besetzen
        Kombinatoren und Gewichte ==> Kombinatorfunktionen besetzen (Achtung: Zusatz-Init)
        Entries (w1 und w2) ==> Entryfunktionen besetzen

      Durchlauf:

      if (SymbolicWeight)
         ==> fertig, symbolicWeight als Entry 
      else if (Combinator || Entry){
         merken;
         if (naechstes==Weight)
           gemerktes war Combinator ==> fertig
         else if (naechstes==Combinator){
           gemerktes war Entry;
           Weight lesen;
           Combinator2 lesen;
           Weight2 lesen;
         }
         else
           Abbruch
       else
         Abbruch

    Zum Besetzen der Funktionsvariablen noch Makros noetig!
    
*/
{
   int Typ1, Typ2, i, index;
   const char *w1Str=NULL, *w2Str=NULL;
   const char *tupel[6]={"length","depth","rmatches","ematches","numbers", "mnf"};
   TermweightComputationT Fix[16], Flex[16], Off[16];
   
   for (i=0;i<6;i++) GewichtsTupel[i]=FALSE;

   Besetze(Fix);
   Besetze(Flex);
   Besetze(Off);

   /* 1) Bestimme Strings zur Definition von w1 und w2 */

   w1Str = IS_ValueOfOption(DEF, USR, "w1");
   w2Str = IS_ValueOfOption(DEF, USR, "w2");
   
   if (!w1Str) {w1Str = w2Str; w2Str=NULL;} /* Falls keine Angabe fuer w1: w2 als w1 nehmen */
   if (!w1Str) w1Str = "plus.length";       /* Falls w1 immer noch leer, addweight als Default */
   
   /* 2) Analysiere Strings */

   fprintf(IO_Strom, "  w1 = ");
   StringAnalyzis(w1Str, &W1_Combinator1, &W1_Combinator2, &W1_Entry, 
                  &W1_Similarity, &W1_CIGIC, &Typ1, &CIGIC_single_match_1, &CIGIC_no_match_1,
                  &CIGIC_min_struct_1);

   if (Typ1 == 0){             /* Fehler */
      if (w2Str){
         w1Str = w2Str;
         w2Str = NULL;
      }
      else
         w1Str = "plus.length";

      StringAnalyzis(w1Str, &W1_Combinator1, &W1_Combinator2, &W1_Entry, 
                     &W1_Similarity, &W1_CIGIC, &Typ1, &CIGIC_single_match_1, &CIGIC_no_match_1,
                  &CIGIC_min_struct_1);
   }

   /* Jetzt ist auf jeden Fall fuer das w1-Gewicht gesorgt! */

   fprintf(IO_Strom, "  w2 = ");
   StringAnalyzis(w2Str, &W2_Combinator1, &W2_Combinator2, &W2_Entry, 
                  &W2_Similarity, &W2_CIGIC, &Typ2, &CIGIC_single_match_2, &CIGIC_no_match_2,
                  &CIGIC_min_struct_2);

   if (Typ2==0){
      fprintf(IO_Strom, "---\n");
      w2Str=NULL;
   }
   
   /* Jetzt: E, C1, C2 und BerechneGewichte besetzt */
   
   fprintf(IO_Strom, "  Typ1 = %d, Typ2 = %d. Weights computed: ", Typ1, Typ2);

   for (i=0; i<6;i++)
      if (GewichtsTupel[i])fprintf(IO_Strom, "%s ", tupel[i]);

   /* 3) Funktionspointer zur Berechnung der Termgewichte besetzen */
   
   index = 8*((int)GewichtsTupel[1])+4*((int)GewichtsTupel[2])+2*((int)GewichtsTupel[3])+((int)GewichtsTupel[4]);

   if (GewichtsTupel[0])
      if (SymbolWeightsChanged){
         fprintf(IO_Strom, "Flex\n");
         ComputeTermWeights = Flex[index];
       }
      else{
         fprintf(IO_Strom, "Fix\n");
         ComputeTermWeights = Fix[index];
      }
   else{
      fprintf(IO_Strom, "Off\n");
      ComputeTermWeights = Off[index];
    }

   if (GewichtsTupel[5]) {
      /* Initialisieren der Werte fuer MNF */
      MNF_InitClassifyAposteriori (&MNF_ClassifyInitFunc, &MNF_ClassifyTraverseFunc, &MNF_ClassifyExitFunc);
      
   }

   /* 4) Gemaess Typ1 und Typ2 die Overall-Berechnungs-Funktionen besetzen  (Classify und ReClassify)*/
   
   if (Typ1==0)
     fprintf(IO_Strom, "Fehler! Typ1 ist 0 (oder schlimmer)\n\n");
   else
     if (Typ2 == 0)
       switch (Typ1){           /* Nicht schoen aber noetig wegen Makros!!!! */
       case 1: EinsBesetzen(1);break;
       case 2: EinsBesetzen(2);break;
       case 3: EinsBesetzen(3);break;
       case 4: EinsBesetzen(4);break;
       case 5: EinsBesetzen(5);break;
       default: fprintf(IO_Strom, "Unbekannter Gewichtstyp!!!!!\n");
       }
     else                   
       switch (Typ1){       
       case 1: ZweiBesetzen(1);break;
       case 2: ZweiBesetzen(2);break;
       case 3: ZweiBesetzen(3);break;
       case 4: ZweiBesetzen(4);break;
       case 5: ZweiBesetzen(5);break;
       default: fprintf(IO_Strom, "Unbekannter Gewichtstyp!!!!!\n");
       }
   
   *WeightEntryType = (Typ2 == 0)? 0:1;

   fprintf(IO_Strom, "\n");

}

BOOLEAN SH2_INITIALIZE(InfoStringT DEF, InfoStringT USR, int *WeightEntryType)
{
  BOOLEAN SymbolWeightsChanged = SG_SymbGewichteEintragen(DEF, USR, TRUE);
  InitializeBody(DEF, USR, WeightEntryType, SymbolWeightsChanged);
  
  if (*WeightEntryType == 0) SH2_PrintProc = PrintProc_0;
  else                       SH2_PrintProc = PrintProc_1;
  
  return TRUE;
}
   
   
void SH2_ParamInfo(ParamInfoArtT what, InfoStringT clasDEF, InfoStringT clasUSR)
{
   if (what == ParamEvaluate){
      int localWeightEntryType;
      BOOLEAN SymbolWeightsChanged = SG_ParamInfo(ParamEvaluate, clasDEF, clasUSR, TRUE);
      
      InitializeBody(clasDEF, clasUSR, &localWeightEntryType, SymbolWeightsChanged);
   }
   else{
      fprintf(IO_Strom,
      "The weight computation follows the syntax:\n"
      "\nw[1|2]=[[lifo|fifo]|<comb>.<weight>|occnest.<comb>.<weight>|<entry>.<comb1>.<weight1>.<comb2>.<weight2>]|\n"
        "       cig.<single_match>.<no_match>|gic.<single_match>.<no_match>[.<min_struct>]\n\n"
      "<weight>,<weight1>,<weight2>=length|depth|flat|ematches|rmatches|rematches|mnfweight|mnfirred|mnfweighth|mnfmin|mnfmax|mnfweightg\n"
      "<comb>,<comb1>,<comb2> = plus|min|max|prod|prodsum|gt\n"
      "<entry>=plus|minus|max|min|prod|prodsum\n\n"
      "As an example, consider the weight computation for prodsum.gt.length.plus.depth:\n\n"
      "1. Compute the individual term-weights according to the <weight>s:\n"
      "   lhs_weight_1 = length(lhs); rhs_weight_1 = length(rhs);\n"
      "   lhs_weight_1 = depth(lhs); rhs_weight_1 = depth(rhs);\n"
      "2. Combine these weights according to <comb> to single numbers\n"
      "   comb_weight_1 = gt(lhs,rhs,lhs_weight_1,rhs_weight_1);\n"
      "   comb_weight_2 = gt(lhs,rhs,lhs_weight_2,rhs_weight_2);\n"
      "3. Combine these numbers into the final weight\n"
      "   weight = prodsum(comb_weight_1, comb_weight_2);\n\n"
      "prodsum(a,b)=a*b+a+b;\n\n"
      "gt(lhs,rhs,lw,rw) = lhs > rhs ? lw : \n"
      "                       rhs > lhs ? rw :\n"
      "                          lw+rw;\n\n"
      "cig = CP-In-Goal; gic = Goal-In-CP\n\n"
              );

      SG_ParamInfo(ParamExplain, clasDEF, clasUSR, TRUE);
   }
}

/* -------------------------------------------------------------------------------------------------------------*/
/* ------------ CLEANING WOMAN ---------------------------------------------------------------------------------*/
/* -------------------------------------------------------------------------------------------------------------*/

void SH2_CleanUp(void){;}

/* -------------------------------------------------------------------------------------------------------------*/
/* ------- Statistics ------------------------------------------------------------------------------------------*/
/* -------------------------------------------------------------------------------------------------------------*/

void SH2_Statistics(InfoStringT StatisticsIS){;}

