#include "SymbolOperationen.h"
#include "general.h"
#include "InfoStrings.h"
#include "SymbolGewichte.h"
#include "SpeicherVerwaltung.h"
#include "Ausgaben.h"
#include <ctype.h>
/* ------------------------------------------------------------------------*/
/* -------- globale Variablen (siehe SymbolGewichte.h) --------------------*/
/* ------------------------------------------------------------------------*/
long int *FlexGewichtsArrayCG, *FlexGewichtsArrayCP;
long int varCP, varCG;


#define AuswertungsMakro()                                                                                              \
  /* 1. def und var raussammeln */                                                                                      \
                                                                                                                        \
  def = IS_ValueOfOption(DEF, USR, "DEF")? atoi(IS_ValueOfOption(DEF, USR, "DEF")):1;                                   \
                                                                                                                        \
  var = IS_ValueOfOption(DEF, USR, "VAR")? atoi(IS_ValueOfOption(DEF, USR, "VAR")):1;                                   \
                                                                                                                        \
  ValueChanged = (def != 1) || (var != 1);                                                                              \
                                                                                                                        \
  /* 2. Identifizieren der Eintraege */                                                                                 \
  /* - Eintraege sind durch ':' getrennt */                                                                             \
  /* - Jeder Eintrag enthaelt den Bezeichner, ein Zuweisungssymbol (vorerst '=') und das Gewicht (Symbol klaeren) */    \
  /*   - Der Bezeichner ist entweder ein Funktionssymbol der Spezifikation oder eines der beiden Schluesselworte*/      \
  /*     VAR fuer Variablengewichte bzw. DEF fuer den Defaultwert nicht-angegebener Fkts-Symbole */                     \
                                                                                                                        \
  SO_forFktSymbole(i){                                                                                                  \
     char *wert;                                                                                                        \
     if ((wert=IS_ValueOfOption(DEF, USR, IO_FktSymbName(i))) && (isdigit(*wert))){                                     \
       ActArray[i] = atoi(wert);                                                                                        \
       ValueChanged = TRUE;                                                                                             \
     }                                                                                                                  \
     else{                                                                                                              \
        ActArray[i] =  def;                                                                                             \
     }                                                                                                                  \
  }                                                                                                                     \
                                                                                                                        \
  /* 4. Test-Ausgabe */                                                                                                 \
                                                                                                                        \
  fprintf(IO_Strom, "  Symbol-Weights (%s): ", fuerCPs?"CP":"CG");                                                      \
  SO_forFktSymbole(i){                                                                                                  \
     IO_DruckeSymbol(i); fprintf(IO_Strom, "=%ld, ", ActArray[i]);                                                      \
  }                                                                                                                     \
  fprintf(IO_Strom, "Vars=%ld\n", var);                                                                                 \
                                                                                                                        \


BOOLEAN SG_ParamInfo(ParamInfoArtT what, InfoStringT DEF, InfoStringT USR, BOOLEAN fuerCPs)
{
   if (what == ParamEvaluate){
      long int *ActArray = our_alloc(SO_AnzahlFunktionen()*sizeof(long int));
      BOOLEAN ValueChanged = FALSE;
      
      long int def, var;
      SymbolT i;

      AuswertungsMakro();

      our_dealloc(ActArray);
      return ValueChanged;
   }
   else{
      fprintf(IO_Strom, "Symbol-Weights\n**************\n\n"
              "Assign each symbol a different individual weight (default is 1). This works for\n"
              "both critical pairs and critical goals. Variables cannot be assigned\n"
              "individual weights, but can be assigned a value different from 1 by VAR=<value>.\n"
              "The default value for non-variable symbols can be changed by DEF=<value>.\n"
              "Other symbols can be assigned values by <symbol>=<value>.\n\n"
              "Example: DEF=2:VAR=5:f=5:g=0\n\n");
      return TRUE;
   }
}


BOOLEAN SG_SymbGewichteEintragen(InfoStringT DEF, InfoStringT USR, BOOLEAN fuerCPs)
/* Aufdroeseln des Aufruf-Parameters nach Default-, Variablen- und den einzelnen Funktionsgewichten */
{
   long int *ActArray;
   BOOLEAN ValueChanged = FALSE;

   long int def, var;
   SymbolT i;

   /* Flex-Gewichts-Array anlegen */

   if (fuerCPs)  ActArray = FlexGewichtsArrayCP = our_alloc(SO_AnzahlFunktionen()*sizeof(long int));
   else          ActArray = FlexGewichtsArrayCG = our_alloc(SO_AnzahlFunktionen()*sizeof(long int));

   AuswertungsMakro();

   if (fuerCPs) varCP = var;
   else varCG = var;

   return ValueChanged;
}
