#define GL_TEST 1
/* Alternativen: 0 fuer aus, 1 fuer an */

#include "codegen.h"

#define INITIAL_P_SIZE 256
#define DELTA_P_SIZE   256


Toutp newOutp (){
  Toutp out;
  out        = (Toutp) malloc (sizeof(OutpRec));
  out->psize = INITIAL_P_SIZE;
  out->P     = (glam_c *) malloc(sizeof(glam_c) * out->psize);
  out->pc    = 0;
  return out;
}

void deleteOutp(Toutp out){
  free(out->P);
  free(out);
}

void emit(Toutp out, Op op, Val val){
#if GL_TEST
  printf("%3d: EMIT %s %d\n", out->pc,OpStr[op],val);
#endif
  if (out->pc >= out->psize){/* expand Program-space */
    out->psize = out->psize + DELTA_P_SIZE;
    out->P     = (glam_c *) realloc(sizeof(glam_c) * out->psize);
  }
  out->P[out->pc] = mkCode(op,val);
  out->pc++;
}

void emitConst(Toutp out, Val val){
  if ((val > maxPosVal)||(val < minNegVal)){
    emit(out,LDC,loVal(val));
    emit(out,LDH,hiVal(val));
  }
  else {
    emit(out,LDC,val);
  }
}

void patch(Toutp out, int adr, Op op, Val val){
#if GL_TEST
  printf("PATCH: %d: %s %d\n", adr, OpStr[op],val);
#endif
  if(adr >= out->pc){
    printf("Unexpected patch adress: PATCH: %d: %s %d\n", adr, OpStr[op],val);
    exit(9);
  }
  out->P[adr] = mkCode(op,val);
}

void printOutp(Toutp out){
  int i;

  printf("\npsize = %d\n", out->psize);
  printf("pc     = %d\n", out->pc);
  printf("PROGRAM:\n");
 
  for(i = 0; i< out->pc; i++){
    printf("%3d: %-4s %ld\n", i, OpStr[getOp(out->P[i])], getVal(out->P[i]));
  }
}

void phopt(Toutp out){
  int p = 0, i = 0;
  int rep;
  int m; /* Anzahl der zu deallokierenden Variablen */
  int n; /* Anzahl der zu allokierenden Variablen beim tailcall */
  
  for(p = 0; p < out->pc; p++){
    m = 0;
    switch (getOp(out->P[p])){
    case DAV:
      m = getVal(out->P[p]);
    case JMP:
    case JSR:
      i = p+1;
      rep = 1;
      while(rep == 1){
        switch(getOp(out->P[i])){
        case NOP:
          i++; 
          break;
        case JMP:
          i = getVal(out->P[i]);
          break;
        case DAV:
          m = m + getVal(out->P[i]);
          i++;
          break;
        case RET:
          m = m + getVal(out->P[i]);
          rep = 2;
          break;
        default:
          rep = 0;
          break;
        }
      }
      if(rep == 2){
        if((getOp(out->P[p])==JMP)||(getOp(out->P[p])==DAV)){
          patch(out,p,RET,m);
        }
        else { /* also JSR ... */
          n = getVal(out->P[p]);
          patch(out,p,TCL,comb2Val(m,n));
        }
      }
      break;
    default:
      break;
    }
  }
}
