/* CHECKS EINBAUEN !!!*/
#include <stdio.h>
#include "glam.h"

#define Stacksize 256
#define Recursionsize 100

#define PopS()   S[--tos]
#define PushS(v) S[tos++]=(v)
#define TopS(i)  S[tos-(i+1)]

#define PopR()     R[--tor]
#define PushR(v)   R[tor++]=(v)
#define TopR(i)    R[tor-(i+1)]
#define TushR(i,v) R[tor-(i+1)]=(v)

glam_t runGLAM (Program P, Memory M){
  glam_t S[Stacksize];
  glam_t R[Recursionsize];
  int pc = 0, tos = 0, tor = 0;
  int finish = 0;
  Op op;
  Val val;
  glam_t t, t1, t2, t3;
  int i;

  pc = 0;
  tos = 0;
  tor = 0;

  while (!finish) {
    op  = getOp (P[pc]);
    val = getVal(P[pc]);
    pc++;

    switch (op){
    case LDM:  t=PopS(); PushS(M[t]);                            break;
    case STM:  t=PopS(); M[t]=PopS();                            break;
    case LDMA: PushS(M[val]);                                    break;
    case STMA: M[val]=PopS();                                    break;
                                                                 
    case LDV:  t=TopR(val);PushS(t);                             break;
    case STV:  t=PopS(); TushR(val,t);                           break;
                                                                 
    case LDC:  PushS(val);                                       break;
    case LDH:  t=PopS(); PushS(t|(val<<opBits));                 break;
                                                                 
    case DUP:  t=TopS(0);PushS(t);                               break;
    case DUP2: PushS(TopS(1)); PushS(TopS(1));                   break;
    case DUP3: PushS(TopS(2)); PushS(TopS(2)); PushS(TopS(2));   break;
    case SWP:  t=PopS();t1=PopS();PushS(t);PushS(t1);            break;
    case POP:  t=PopS();                                         break;

    case ADD:  t=PopS();t1=PopS();PushS(t1+t);                   break;
    case SUB:  t=PopS();t1=PopS();PushS(t1-t);                   break;
    case MUL:  t=PopS();t1=PopS();PushS(t1*t);                   break;
    case DIV:  t=PopS();t1=PopS();PushS(t1/t);                   break;
    case MOD:  t=PopS();t1=PopS();PushS(t1%t);                   break;
    case MAX:  t=PopS();t1=PopS();PushS((t<t1)?t1:t);            break;
    case MIN:  t=PopS();t1=PopS();PushS((t<t1)?t:t1);            break;
 
    case ABS:  t=PopS();PushS((t<0)?-t:t);                       break;
    case NEG:  t=PopS();PushS(-t);                               break;

    case LNOT: t=PopS();PushS(!t);                               break;
    case LAND: t=PopS();t1=PopS();PushS(t&&t1);                  break;
    case LOR:  t=PopS();t1=PopS();PushS(t||t1);                  break;
    case LXOR: t=PopS();t1=PopS();PushS((!t&&t1)||(t&&!t1));     break;
      
    case BNOT: t=PopS();PushS(~t);                               break;
    case BAND: t=PopS();t1=PopS();PushS(t1&t);                   break;
    case BOR:  t=PopS();t1=PopS();PushS(t1|t);                   break;
    case BXOR: t=PopS();t1=PopS();PushS(t1^t);                   break;
      
    case EQ:   t=PopS();t1=PopS();PushS(t1==t);                  break;
    case NEQ:  t=PopS();t1=PopS();PushS(t1!=t);                  break;
    case LEQ:  t=PopS();t1=PopS();PushS(t1<=t);                  break;
    case LT:   t=PopS();t1=PopS();PushS(t1< t);                  break;
    case GEQ:  t=PopS();t1=PopS();PushS(t1>=t);                  break;
    case GT:   t=PopS();t1=PopS();PushS(t1> t);                  break;

    case JMP:  pc = val;                                         break;
    case BRT:  t=PopS();if(t) pc=pc+val-1;                       break;
    case BRF:  t=PopS();if(!t)pc=pc+val-1;                       break;

    case ALV:  tor = tor + val;/*for(i=0;i<val;i++){PushR(0);};*/                    break;
    case DAV:  tor = tor - val;                                  break;
    case TCL:  
      tor = tor - (get1of2Val(val)+1);
      pc = R[tor];
      val = get2of2Val(val);
      
    case JSR:  
      t = TopS(val);
      if(glam_fIspc(t)){
        PushR(pc);
        for(i=tos-val;i<tos;i++){
          PushR(S[i]);
        }
        tos = tos - (val+1);
        pc = glam_f2pc(t); 
      }
      else {
        switch (val) {
        case 0: t=((glam_f)t)();                                                               break;
        case 1: t=((glam_f)t)(TopS(0));                                                        break;
        case 2: t=((glam_f)t)(TopS(1),TopS(0));                                                break;
        case 3: t=((glam_f)t)(TopS(2),TopS(1),TopS(0));                                        break;
        case 4: t=((glam_f)t)(TopS(3),TopS(2),TopS(1),TopS(0));                                break;
        case 5: t=((glam_f)t)(TopS(4),TopS(3),TopS(2),TopS(1),TopS(0));                        break;
        case 6: t=((glam_f)t)(TopS(5),TopS(4),TopS(3),TopS(2),TopS(1),TopS(0));                break;
        case 7: t=((glam_f)t)(TopS(6),TopS(5),TopS(4),TopS(3),TopS(2),TopS(1),TopS(0));        break;
        case 8: t=((glam_f)t)(TopS(7),TopS(6),TopS(5),TopS(4),TopS(3),TopS(2),TopS(1),TopS(0));break;
        default: printf("Implementation limit!\n"); exit(9);                                   break;
        }
        tos = tos - (val+1);
        PushS(t);
      }
                                                                 break;
    case RET:  tor = tor - (val+1);pc = R[tor];                  break;
    case STP:  finish = 1;                                       break;

    case PRT:  t=PopS(); printf("%ld\n",t);                      break;
    case NOP:                                                    break;
/*  default:                                                     break;*/
    }
  }

  return TopS(0);
}


