#include <stdio.h>
#include "antiwarnings.h"
#include <unistd.h>

unsigned long int *array;

unsigned long int L, maxIndex, WichtigMin, WichtigMax, Pos;

int IstWichtig(unsigned long int Nr)
/* Binaere Suche nach Nr im Bereich [WichtigMin+1, WichtigMax]
   in array.
*/
{
   if (Nr==0)
      return 0;
   else{
      unsigned long int lB = WichtigMin+1, uB=WichtigMax, pos;
      
      while(lB <= uB){
         pos = (lB+uB)/2;
         if (array[pos]>Nr)
            uB = pos-1;
         else if (array[pos]<Nr)
            lB = pos+1;
         else                      /* == */
            return 1;
      }
      return 0;
   }
}

void WichtigIst(unsigned long int Nr)
{
   if (Nr && (!IstWichtig(Nr))){
      unsigned long int i = WichtigMin+1;
   
      while( (i <= WichtigMax) && (Nr > array[i])){
         array[i-1] = array[i];
         i++;
      }
      array[i-1]=Nr;
      WichtigMin--;
   }
}



int main(int argc, char *argv[])
{
   FILE *file;
   
   unsigned long nr1, nr2, line=0, i, pos;

   if (argc==1){
      printf("\n\nuextract    (C) 1996 by A.Buch & Th. Hillenbrand\n\n"
             "Extraktion eines uPCL-Files\n"
             "***************************\n\n"
             "Extrahiert aus einer im Mikro-Pcl-Format vorliegenden Datei\n"
             "die Nummern der relevanten PCL-Fakten. Diese koennen in einem\n"
             "weiteren Waldmeister-Lauf dann im regulaeren PCL-Format erzeugt werden.\n\n"
             "Usage: uextract <Source-File> <Extracted-File>\n\n");
      exit(0);
   }
   

   if (argc!=3){
      printf("Usage: uextract <Source-File> <Extracted-File>\n\n");
      exit(-1);
   }
   
   if (!(file = fopen(argv[1], "r"))){
      printf("Could not open source-file %s.\n", argv[1]);
      exit(-1);
   }

   fseek(file, 0, SEEK_END);
   
   nr1 = ftell(file);

   printf("Length of File : %ld bytes\n", nr1);
   
   L = nr1 + 2*sizeof(unsigned long int);
   
   maxIndex = L / 4;

   WichtigMin=WichtigMax=maxIndex;
   
   printf("L              : %ld\n", L);
   
   printf("maxIndex       : %ld\n", maxIndex);
   
   if (!(array = (unsigned long int *) malloc(L))){
      printf("Source-File too large. Special algorithms for large files not yet implemented (if ever)\n\n");
      exit(0);
   }
   
   fseek(file, 0, SEEK_SET);

   fread(array, sizeof(unsigned long int), maxIndex-2, file);
   perror(ferror(file));
   i=0;

   while (i<maxIndex-2){
      nr1 = array[i];
      nr2 = array[i+1];
      i+=2;
      if (nr1+nr2==0)
         i+=2;
      ++line;
   }
   
   printf("Number of input-facts: %ld\n", line);
   
   pos = maxIndex-2;

   while(pos>1){
      pos -= 2;
      if ((pos>1) && (array[pos-2]+array[pos-1]==0)){ /* Ziel */
         WichtigIst(line);
         WichtigIst(array[pos]);
         WichtigIst(array[pos+1]);
         pos-=2;
      }
      else if (IstWichtig(line)){
         WichtigIst(array[pos]);
         WichtigIst(array[pos+1]);
      }
      line--;
   }
   
   fclose(file);
   
   printf("Number of extracted Facts: %ld\n", WichtigMax-WichtigMin);

   /* Ausgabe der als relevant erkannten Fakten */

   if (!(file = fopen(argv[2], "w"))){
      printf("Could not open target-file %s.\n", argv[2]);
      exit(-1);
   }
   
   fwrite(&array[WichtigMin+1], sizeof(unsigned long int), WichtigMax-WichtigMin, file);
   
   fclose(file);
   exit(0);
}
