#include "Ausgaben.h"
#include "PQStatistik.h"
#include "InfoStrings.h"

/* ------------------------------------------------------------------------*/
/* ---------- globale Variablen (siehe PQStatistik.h) ---------------------*/
/* ------------------------------------------------------------------------*/

BOOLEAN PQStatisticsAn;

unsigned long        AnzKPSpaeterWaisenmord;            /* Bei erreichen der Top-Position der PQ als Waisen gekillte KPs */
unsigned long        AnzKPFrueherWaisenmord;            /* Vorzeitig als Waisen gekillte KPs */

unsigned long        AnzKPIRBetrachtet;                 /* Bei der KPM-IR insgesamt betrachtete KPs */
unsigned long        AnzKPIRWaisenmord;                 /* Bei der KPM-IR als Waisen geloeschte KPs */
unsigned long        AnzKPIRGeloescht;                  /* Bei der KPM-IR von der Anwendungsprozedur geloeschte KPs */
unsigned long        AnzKPIRVeraendert;                 /* Bei der KPM-IR reduzierte und deshalb ggf. verschobene KPs */
unsigned long        AnzKPIRVorgezogen;                 /* Bei der KPM-IR red. und gewichtsverkleinerte KPs */
unsigned long        AnzKPIRZurueckgeschoben;           /* Bei der KPM-IR red. und gewichtsvergroesserte KPs */

unsigned long        AnzKPBlaeh;                        /* Maximal gleichzeitig gespeicherte KP's */
unsigned long        AnzKPEingefuegt;                   /* Anzahl der insgesamt eingefuegten KPs */
unsigned long        AnzKPGeloescht;                    /* Anzahl der insgesamt (incl. Waisenmord) entfernten KPs */

/* -------------------------------------------------------------------------------------------------------------*/
/* ------- Immergleiche Statistik-Variablen und Funktionen -----------------------------------------------------*/
/* -------------------------------------------------------------------------------------------------------------*/

void PQStatistikInitialisieren(void)
{
   AnzKPSpaeterWaisenmord = 0;            
   AnzKPFrueherWaisenmord = 0;         

   AnzKPIRBetrachtet = 0;              
   AnzKPIRWaisenmord = 0; 
   AnzKPIRGeloescht = 0;               
   AnzKPIRVeraendert = 0;               
   AnzKPIRVorgezogen = 0;              
   AnzKPIRZurueckgeschoben = 0;        
   
   AnzKPBlaeh = 0;                   
   AnzKPEingefuegt = 0;
   AnzKPGeloescht = 0;
}




void PQStatistik(InfoStringT IS, long int AnzGueltigeKPsInMenge)
{
   if (IS_IsIn("latex-head", IS))
      fprintf(IO_Strom, "$>$PQ & $<$PQ & frWM & spWM & in PQ: act & alive & max &KPIR: angef. & beh. & WM & gel & geaend. & vorg. & zur. & ");
   else{
      int tiefe1, tiefe2, tiefe3;
      
      IO_DruckeStatistikZeile("ues inserted into PQ", AnzKPEingefuegt);
      IO_DruckeStatistikZeile("ues removed from PQ", AnzKPGeloescht);
      IO_DruckeStatistikZeileEingerueckt("of them because of early orphan murder", AnzKPFrueherWaisenmord, 
                                         IO_Einruecktiefe(0, Maximum(2, AnzKPFrueherWaisenmord, AnzKPSpaeterWaisenmord)));
      IO_DruckeStatistikZeileEingerueckt("of them because of late orphan murder", AnzKPSpaeterWaisenmord, 
                                         IO_Einruecktiefe(0, Maximum(2, AnzKPFrueherWaisenmord, AnzKPSpaeterWaisenmord)));
      IO_DruckeStatistikLeerZeile();
      IO_DruckeStatistikZeile("ues currently in PQ", AnzKPEingefuegt - AnzKPGeloescht);
      IO_DruckeStatistikZeileEingerueckt("of them still valid", AnzGueltigeKPsInMenge, IO_Einruecktiefe(0, AnzGueltigeKPsInMenge));
      IO_DruckeStatistikLeerZeile();
      IO_DruckeStatistikZeile("Max. No. of ues in PQ", AnzKPBlaeh);
      
      IO_DruckeStatistikLeerZeile();
      IO_DruckeStatistikZeile("ues touched during IRP", AnzKPIRBetrachtet);
      tiefe1 = IO_Einruecktiefe(0, Maximum(2, AnzKPIRWaisenmord, AnzKPIRBetrachtet-AnzKPIRWaisenmord));
      tiefe2 = IO_Einruecktiefe(tiefe1, Maximum(2, AnzKPIRGeloescht, AnzKPIRVeraendert));
      tiefe3 = IO_Einruecktiefe(tiefe2, Maximum(2, AnzKPIRVorgezogen, AnzKPIRZurueckgeschoben));
      
      IO_DruckeStatistikZeileEingerueckt("of them removed as orphans", AnzKPIRWaisenmord, tiefe1);
      IO_DruckeStatistikZeileEingerueckt("of them reprocessed", AnzKPIRBetrachtet-AnzKPIRWaisenmord, tiefe1);
      IO_DruckeStatistikZeileEingerueckt("of them removed", AnzKPIRGeloescht, tiefe2);
      IO_DruckeStatistikZeileEingerueckt("of them changed", AnzKPIRVeraendert, tiefe2);
      IO_DruckeStatistikZeileEingerueckt("of them prefered", AnzKPIRVorgezogen, tiefe3);
      IO_DruckeStatistikZeileEingerueckt("of them defered", AnzKPIRZurueckgeschoben, tiefe3);
   }
}

