#!/bin/sh
exec perl -Sx $0 ${1:+"$@"}
#! perl -w

#
#  Eingabe: setheo.p BASENAME PROBLEMDIR SETHEOHOME PVM MAXTIME
#           (PVM ist /usr/local/dist/DIR/pvm3)
#  weiterer Input: File BASENAME.cfg (im aufrufenden Verzeichnis) mit Zeilen:
#     - competitors NUMBER (irgendwo, letztes gueltig, 
#       Anzahl der gleichzeitig aktiven Tasks)
#     - inwasm Aufruf Kommandozeilenparameter (Definition der
#       Compilerscripte)
#     - select nn (gueltig bis zum naechsten Statement, 
#       default 1)
#     - timelimit TIMELIMIT (cpu-limit pro sam, gueltig bis zum 
#       naechsten Statement, default 120s) !! nicht fuer CADE !!
#     - sam KOMMANDOZEILENPARAMETERLISTE 
#       (nach Wunsch, -cons -batch -cputime nnn werden 
#       hinzugefuegt)
#  Ausagbe: BASENAME.log, BASENAME.tree, wenn Beweis gefunden
#  Returncodes: >0 Nummer des erfolgreichen Wettbewerbers
#                0 total failure oder limit
#               -1 Fehler
#  Autor: Andreas Wolf, Ortrun Ibens
#  Version: 7.07.97 AR
#


print "\n************   p-SETHEO   ************\n";
print "(c) 1997 Munich University of Technology\n"; 
$BASENAME = shift(@ARGV) or terminator( "missing basename.", $BASENAME, -1 );
$PROBLEMDIR = shift(@ARGV) or terminator( "missing problemdir.", $BASENAME, -1 );
$SETHEOHOME = shift(@ARGV) or terminator( "missing setheohome.", $BASENAME, -1 );
$ENV{PVM_ROOT} = shift(@ARGV) or terminator( "missing pvmdir.", $BASENAME, -1 );
$ENV{PVM_ARCH} = "SUN4SOL2";
$PVM = "$ENV{PVM_ROOT}/lib/SUN4SOL2/pvmd3";
$MAXTIME = shift(@ARGV) or terminator( "missing maxtime.", $BASENAME, -1 );

$SUCCESSTASK = 0;
print "Dealing with problem: $BASENAME.\n\n";
sub terminator;
$SIG{INT} = sub { 
  terminator("signal received.", $BASENAME, -1);
  };


#
# Defaultwerte der sam-Einstellungen
#
$INWASMTAG = 1;
$SINSTANT = 0;
$IINSTANT = 0;
$BINDIR = "$SETHEOHOME/bin";
$WORKDIR = "$SETHEOHOME/workdir";
#use Cwd;
#$WORKDIR = cwd();
$COMPET_TASKS = 5;
$CONFIGFILE = "$WORKDIR/$BASENAME.cfg"; 
$GLOBAL_LOG = "$WORKDIR/$BASENAME.glog";
open(PVM_INI, ">$WORKDIR/pvm_initfile") or terminator( "cannot open pvm_initfile.", $BASENAME, -1 );
print PVM_INI "* wd=$WORKDIR ep=$WORKDIR";
close PVM_INI;
system "$PVM $WORKDIR/pvm_initfile &";
system "echo PVM established";

#
# Generating .lop-file and computing statistics:
#
system "cp $PROBLEMDIR/$BASENAME.p $WORKDIR/$BASENAME.p";
system "$BINDIR/stexposu -tptpin -stat -rel -sig c h -replnum $PROBLEMDIR/$BASENAME.p > $WORKDIR/$BASENAME.lop";

$ishorn = 0;
$witheq = 1;
$withlongcl = 1;
open(STATLOP, "<$WORKDIR/$BASENAME.lop") or terminator( "cannot open $BASENAME.lop.", $BASENAME, -1 );
while (<STATLOP>) {
  @_=split;
  if (scalar(@_) >= 12  &&  "$_[1]" =~ /Syntax/) {
    $NR_CLAUSES	= $_[7];
    system "echo Number of clauses: $NR_CLAUSES > $GLOBAL_LOG";
    $NR_NONHORN_CLAUSES = $_[9];	
    system "echo Number of nonhorn clauses: $NR_NONHORN_CLAUSES >> $GLOBAL_LOG";	
    $NR_UNIT_CLAUSES = $_[11];
    system "echo Number of clauses: $NR_UNIT_CLAUSES >> $GLOBAL_LOG";

    if ($NR_NONHORN_CLAUSES == 0) {
        $ishorn = 1;
    }
    next;
  }
  if (scalar(@_) >= 6  &&  "$_[3]" =~ /literals/) {
    $NR_LITERALS = $_[5];
    system "echo Number of literals: $NR_LITERALS >> $GLOBAL_LOG";

    $NR_RULES = $NR_CLAUSES - $NR_UNIT_CLAUSES;
    system "echo Number of rules: $NR_RULES >> $GLOBAL_LOG";
    $NR_RULE_LITERALS = $NR_LITERALS - $NR_UNIT_CLAUSES;
    system "echo Number of literals in rules: $NR_RULE_LITERALS >> $GLOBAL_LOG";
    $RULE_BRANCHING_FACTOR = int ($NR_RULE_LITERALS / $NR_RULES);
    system "echo Branching factor of rules: $RULE_BRANCHING_FACTOR >> $GLOBAL_LOG";
    $RULE_BRF_100 = int (( 100 * $NR_RULE_LITERALS ) / $NR_RULES);
    system "echo Branching factor of rules 100 times = $RULE_BRF_100 >> $GLOBAL_LOG";
    
    if ($_[7] == 0) {
        $witheq = 0;
    }
    next;
  }
  if (scalar(@_) >= 6   &&  "$_[3]" =~ /size/  &&  $_[5] <= 3) {
    $withlongcl = 0;
    next;
  }
  if (scalar(@_) >= 3   &&  "$_[2]" =~ /conjecture\./) {
    $line = <STATLOP>;
    @commaline = split /,/ , $line;
    $SIGNATURE = scalar(@commaline) - 1;
    system "echo SIGNATURE = $SIGNATURE >> $GLOBAL_LOG";
  }
}
close STATLOP;


# Generating .cfg file:
open(CFGFILE, ">$WORKDIR/$BASENAME.cfg") or terminator( "cannot open $BASENAME.cfg.", $BASENAME, -1 );


#
# HORN WITH EQUALITY
#
if ($ishorn == 1  &&  $witheq == 1) {
				     
    print CFGFILE "competitors 5\n";
				     
    print CFGFILE "inwasm inwasm_EQ-HORN-ste-fu\n";
    print CFGFILE "inwasm inwasm_MIX-ax-fu-nofu\n";
    print CFGFILE "inwasm inwasm_EQ-ord-4-inf-reflnocost\n";
    print CFGFILE "inwasm inwasm_EQ-ste-fu-nofu-sig\n";
    print CFGFILE "inwasm inwasm_MIX-ax-fu-nofu-sig\n";
    print CFGFILE "inwasm inwasm_EQ-ord-6-depth\n";
    print CFGFILE "inwasm inwasm_EQ-HORN-ax-fu\n";

				     
#   Computing parameters for wdrmod2:
#
    $WD1=100;
    system "echo WD1 = $WD1 >> $GLOBAL_LOG";
    $WD2= 50 + int ( 5000 / ( ( $RULE_BRF_100 - 100 ) * ( 1 + $NR_NONHORN_CLAUSES ) ) );
    system "echo WD2 = $WD2 >> $GLOBAL_LOG";
    $WD3_EXPR = 80 + ( 10 *  int ( $NR_UNIT_CLAUSES / ( 1 + ( $NR_CLAUSES / 50 ) ) ) ) - ( 40 * int ( $NR_NONHORN_CLAUSES / ( 1 + ( $NR_CLAUSES / 20 ) ) ) );
    system "echo WD3_EXPR = $WD3_EXPR >> $GLOBAL_LOG";
    if ($WD3_EXPR >= 0) {
	$WD3 = $WD3_EXPR;
    }
    elsif ($WD3_EXPR < 0) {
	$WD3 = 0;
    }
    system "echo WD3 = $WD3 >> $GLOBAL_LOG";
    $WD4=0;
    system "echo WD4 = $WD4 >> $GLOBAL_LOG";


#   EQ-HORN-ste-fu
    print CFGFILE "select 1\n";
    $time = int ($MAXTIME * 10 / 790 + 0.5);
    print CFGFILE "sam -cons -wdr -eq -multidelay -forcegr -forcedl -dynsgreord 2 -trail 2000000 -cstack 4000000 -stack 2000000 -batch -cputime $time\n";
				     

#   MIX-ax-fu-nofu-ir3
    print CFGFILE "select 2\n";
    $time = int ($MAXTIME * 10 / 790 + 0.5);
    print CFGFILE "sam -cons -ir -singledelay 2 -forcegr -dynsgreord 2 -trail 2000000 -cstack 4000000 -stack 2000000 -batch -cputime $time\n";

				     
#   EQ-ord-4-inf-reflnocost
    print CFGFILE "select 3\n";
    $time = int ($MAXTIME * 10 / 790 + 0.5);
    print CFGFILE "sam -cons -ir -multidelay -forcegr -forcedl -dynsgreord 2 -trail 2000000 -cstack 4000000 -stack 2000000 -batch -cputime $time\n";

				     
#   EQ-ste-fu-nofu-sig-0-100-wdrmod2
    print CFGFILE "select 4\n";
    $time = int ($MAXTIME * 130 / 790 + 0.5);
    $SIGD = int (100 / $SIGNATURE);
    print CFGFILE "sam -cons -wdr -wd1 $WD1 -wd2 $WD2 -wd3 $WD3 -wd4 $WD4 -eq -sigd1 0 -sigd2 $SIGD -multidelay -forcegr -forcedl -dynsgreord 2 -trail 2000000 -cstack 4000000 -stack 2000000 -batch -cputime $time\n";


#   MIX-ax-fu-nofu-sig-0-50-wdrmod2
    print CFGFILE "select 5\n";
    $time = int ($MAXTIME * 240 / 790 + 0.5);
    $SIGD = int (50 / $SIGNATURE);
    print CFGFILE "sam -cons -wdr -wd1 $WD1 -wd2 $WD2 -wd3 $WD3 -wd4 $WD4 -sigd1 0 -sigd2 $SIGD -singledelay 2 -forcegr -dynsgreord 2 -trail 2000000 -cstack 4000000 -stack 2000000 -batch -cputime $time\n";


#   EQ-ord-6-depth
    print CFGFILE "select 6\n";
    $time = int ($MAXTIME * 110 / 790 + 0.5);
    print CFGFILE "sam -cons -wdr -eq -multidelay -forcegr -forcedl -dynsgreord 2 -trail 2000000 -cstack 4000000 -stack 2000000 -batch -cputime $time\n";


#   EQ-HORN-ax-fu
    print CFGFILE "select 7\n";
    $time = int ($MAXTIME * 280 / 790 + 0.5);
    print CFGFILE "sam -cons -wdr -singledelay 2 -forcegr -dynsgreord 2 -trail 2000000 -cstack 4000000 -stack 2000000 -batch -cputime $time\n";


#   Default: EQ-ste-fu-nofu
    print CFGFILE "select 4\n";
    $time = int ($MAXTIME + 0.5);
    print CFGFILE "sam -cons -wdr -eq -multidelay -forcegr -forcedl -dynsgreord 2 -trail 2000000 -cstack 4000000 -stack 2000000 -batch -cputime $time\n";
}



#
# HORN WITHOUT EQUALITY
#
if ($ishorn == 1  &&  $witheq == 0) {
				     
    print CFGFILE "competitors 3\n";
				     
    print CFGFILE "inwasm inwasm_MIX-ax-fu-nofu\n";
    print CFGFILE "inwasm inwasm_MIX-ax-fu-nofu-sig\n";

				     
#   Computing parameters for wdrmod2:
#
    $WD1=100;
    system "echo WD1 = $WD1 >> $GLOBAL_LOG";
    $WD2= 50 + int ( 5000 / ( ( $RULE_BRF_100 - 100 ) * ( 1 + $NR_NONHORN_CLAUSES ) ) );
    system "echo WD2 = $WD2 >> $GLOBAL_LOG";
    $WD3_EXPR = 80 + ( 10 *  int ( $NR_UNIT_CLAUSES / ( 1 + ( $NR_CLAUSES / 50 ) ) ) ) - ( 40 * int ( $NR_NONHORN_CLAUSES / ( 1 + ( $NR_CLAUSES / 20 ) ) ) );
    system "echo WD3_EXPR = $WD3_EXPR >> $GLOBAL_LOG";
    if ($WD3_EXPR >= 0) {
	$WD3 = $WD3_EXPR;
    }
    elsif ($WD3_EXPR < 0) {
	$WD3 = 0;
    }
    system "echo WD3 = $WD3 >> $GLOBAL_LOG";
    $WD4=0;
    system "echo WD4 = $WD4 >> $GLOBAL_LOG";


#   Computing parameters for delay:
#
    if ($withlongcl == 0) {
	system "echo Without equality theory and without long clauses: >> $GLOBAL_LOG";
	system "echo restricted reordering and no delay! >> $GLOBAL_LOG";
	$delay = " ";
    }
    elsif ($withlongcl == 1) {
	system "echo Without equality theory and with long clauses: >> $GLOBAL_LOG";
	system "echo restricted reordering and multidelay! >> $GLOBAL_LOG";
	$delay = " -multidelay -spred1 -forcegr ";
    }


#   MIX-ax-fu-nofu-wdrmod2
    print CFGFILE "select 1\n";
    $time = int ($MAXTIME * 80 / 400 + 0.5);
    print CFGFILE "sam -cons -wdr -wd1 $WD1 -wd2 $WD2 -wd3 $WD3 -wd4 $WD4 $delay -dynsgreord 5 -trail 2000000 -cstack 4000000 -stack 2000000 -batch -cputime $time\n";
				     

#   MIX-ax-fu-nofu-ir2
    print CFGFILE "select 1\n";
    $time = int ($MAXTIME * 20 / 400 + 0.5);
    print CFGFILE "sam -cons -ir 2 $delay -dynsgreord 5 -trail 2000000 -cstack 4000000 -stack 2000000 -batch -cputime $time\n";


#   MIX-ax-fu-nofu-sig-0-50
    print CFGFILE "select 2\n";
    $time = int ($MAXTIME * 300 / 400 + 0.5);
    $SIGD = int (50 / $SIGNATURE);
    print CFGFILE "sam -cons -wdr -sigd1 0 -sigd2 $SIGD $delay -dynsgreord 5 -trail 2000000 -cstack 4000000 -stack 2000000 -batch -cputime $time\n";

#   Default: MIX-ax-fu-nofu-wdr
    print CFGFILE "select 1\n";
    $time = int ($MAXTIME + 0.5);
    print CFGFILE "sam -cons -wdr $delay -dynsgreord 5 -trail 2000000 -cstack 4000000 -stack 2000000 -batch -cputime $time\n";
}


   
#
# NONHORN WITH EQUALITY
#
if ($ishorn == 0  &&  $witheq == 1) {
				     
    print CFGFILE "competitors 5\n";
				     
    print CFGFILE "inwasm inwasm_MIX-ax-fu-nofu\n";
    print CFGFILE "inwasm inwasm_EQ-ord-6-inf-reflnocost\n";
    print CFGFILE "inwasm inwasm_EQ-ste-fu-nofu-sig\n";
    print CFGFILE "inwasm inwasm_EQ-ord-5-inf\n";
    print CFGFILE "inwasm inwasm_MIX-ax-fu-nofu-sig\n";

				     
#   Computing parameters for wdrmod:
#
    $WD1 = 100;
    system "echo WD1 = $WD1 >> $GLOBAL_LOG";
				     
    $WD2_mod1 = 100 + int ( 5000 / ( ( $RULE_BRF_100 - 100 ) * ( 1 + $NR_NONHORN_CLAUSES ) ) );
    system "echo WD2_mod1 = $WD2_mod1 >> $GLOBAL_LOG";
				     
    $WD2_mod2 = 50 + int ( 5000 / ( ( $RULE_BRF_100 - 100 ) * ( 1 + $NR_NONHORN_CLAUSES ) ) );
    system "echo WD2_mod2 = $WD2_mod2 >> $GLOBAL_LOG";
				     
    $WD3_EXPR = 120 + ( 10 *  int ( $NR_UNIT_CLAUSES / ( 1 + ( $NR_CLAUSES / 50 ) ) ) ) - ( 40 * int ( $NR_NONHORN_CLAUSES / ( 1 + ( $NR_CLAUSES / 20 ) ) ) );
    system "echo WD3_EXPR = $WD3_EXPR >> $GLOBAL_LOG";
    if ($WD3_EXPR >= 0) {
	$WD3_mod1 = $WD3_EXPR;
    }
    elsif ($WD3_EXPR < 0) {
	$WD3_mod1 = 0;
    }
    system "echo WD3_mod1 = $WD3_mod1 >> $GLOBAL_LOG";
				     
    $WD3_EXPR = 80 + ( 10 *  int ( $NR_UNIT_CLAUSES / ( 1 + ( $NR_CLAUSES / 50 ) ) ) ) - ( 40 * int ( $NR_NONHORN_CLAUSES / ( 1 + ( $NR_CLAUSES / 20 ) ) ) );
    system "echo WD3_EXPR = $WD3_EXPR >> $GLOBAL_LOG";
    if ($WD3_EXPR >= 0) {
	$WD3_mod2 = $WD3_EXPR;
    }
    elsif ($WD3_EXPR < 0) {
	$WD3_mod2 = 0;
    }
    system "echo WD3_mod2 = $WD3_mod2 >> $GLOBAL_LOG";

    $WD4=0;
    system "echo WD4 = $WD4 >> $GLOBAL_LOG";


#   MIX-ax-fu-nofu-wdrmod2
    print CFGFILE "select 1\n";
    $time = int ($MAXTIME * 20 / 820 + 0.5);
    $delay = " -singledelay 2 -forcegr ";
    $dynsgreord = " -dynsgreord 5 ";
    $bound = " -wdr -wd1 $WD1 -wd2 $WD2_mod2 -wd3 $WD3_mod2 -wd4 $WD4 ";
    $sig = " ";
    print CFGFILE "sam -cons $bound $delay $dynsgreord $sig -trail 2000000 -cstack 4000000 -stack 2000000 -batch -cputime $time\n"; 

				     
#   EQ-ord-6-inf-reflnocost
    print CFGFILE "select 2\n";
    $time = int ($MAXTIME * 60 / 820 + 0.5);
    $delay = " -multidelay -forcegr -forcedl ";
    $dynsgreord = " -dynsgreord 2 ";
    $bound = " -ir ";
    $sig = " ";
    print CFGFILE "sam -cons $bound $delay $dynsgreord $sig -trail 2000000 -cstack 4000000 -stack 2000000 -batch -cputime $time\n"; 


#   EQ-ste-fu-nofu-sig-0-100
    print CFGFILE "select 3\n";
    $time = int ($MAXTIME * 20 / 820 + 0.5);
    $delay = " -multidelay -forcegr -forcedl ";
    $dynsgreord = " -dynsgreord 2 ";
    $bound = " -wdr -eq ";
    $SIGD = int (100 / $SIGNATURE);
    $sig = " -sigd1 0 -sigd2 $SIGD ";
    print CFGFILE "sam -cons $bound $delay $dynsgreord $sig -trail 2000000 -cstack 4000000 -stack 2000000 -batch -cputime $time\n";

				     
#   EQ-ste-fu-nofu-sig-0-50-wdrmod1
    print CFGFILE "select 3\n";
    $time = int ($MAXTIME * 60 / 820 + 0.5);
    $delay = " -multidelay -forcegr -forcedl ";
    $dynsgreord = " -dynsgreord 2 ";
    $bound = " -wdr -wd1 $WD1 -wd2 $WD2_mod1 -wd3 $WD3_mod1 -wd4 $WD4 -eq ";
    $SIGD = int (50 / $SIGNATURE);
    $sig = " -sigd1 0 -sigd2 $SIGD ";
    print CFGFILE "sam -cons $bound $delay $dynsgreord $sig -trail 2000000 -cstack 4000000 -stack 2000000 -batch -cputime $time\n"; 
				     

#   EQ-ord-5-inf
    print CFGFILE "select 4\n";
    $time = int ($MAXTIME * 120 / 820 + 0.5);
    $delay = " -multidelay -forcegr -forcedl ";
    $dynsgreord = " -dynsgreord 2 ";
    $bound = " -ir ";
    $sig = " ";
    print CFGFILE "sam -cons $bound $delay $dynsgreord $sig -trail 2000000 -cstack 4000000 -stack 2000000 -batch -cputime $time\n"; 

				     
#   MIX-ax-fu-nofu-wdrmod1
    print CFGFILE "select 1\n";
    $time = int ($MAXTIME * 20 / 820 + 0.5);
    $delay = " -singledelay 2 -forcegr ";
    $dynsgreord = " -dynsgreord 5 ";
    $bound = " -wdr -wd1 $WD1 -wd2 $WD2_mod1 -wd3 $WD3_mod1 -wd4 $WD4 -eq ";
    $sig = " ";
    print CFGFILE "sam -cons $bound $delay $dynsgreord $sig -trail 2000000 -cstack 4000000 -stack 2000000 -batch -cputime $time\n"; 

				     
#   MIX-ax-fu-nofu-sig-0-50-wdrmod2
    print CFGFILE "select 5\n";
    $time = int ($MAXTIME * 20 / 820 + 0.5);
    $delay = " -singledelay 2 -forcegr ";
    $dynsgreord = " -dynsgreord 5 ";
    $bound = " -wdr -wd1 $WD1 -wd2 $WD2_mod2 -wd3 $WD3_mod2 -wd4 $WD4 -eq ";
    $SIGD = int (50 / $SIGNATURE);
    $sig = " -sigd1 0 -sigd2 $SIGD ";
    print CFGFILE "sam -cons $bound $delay $dynsgreord $sig -trail 2000000 -cstack 4000000 -stack 2000000 -batch -cputime $time\n"; 

				     
#   EQ-ste-fu-nofu-sig-0-50
    print CFGFILE "select 3\n";
    $time = int ($MAXTIME * 80 / 820 + 0.5);
    $delay = " -multidelay -forcegr -forcedl ";
    $dynsgreord = " -dynsgreord 2 ";
    $bound = " -wdr -eq ";
    $SIGD = int (50 / $SIGNATURE);
    $sig = " -sigd1 0 -sigd2 $SIGD ";
    print CFGFILE "sam -cons $bound $delay $dynsgreord $sig -trail 2000000 -cstack 4000000 -stack 2000000 -batch -cputime $time\n"; 

				     
#   MIX-ax-fu-nofu-sig-200-30
    print CFGFILE "select 5\n";
    $time = int ($MAXTIME * 120 / 820 + 0.5);
    $delay = " -singledelay 2 -forcegr ";
    $bound = " -wdr ";
    $dynsgreord = " -dynsgreord 5 ";
    $SIGD = int (30 / $SIGNATURE);
    $sig = " -sigd1 200 -sigd2 $SIGD ";
    print CFGFILE "sam -cons $bound $delay $dynsgreord $sig -trail 2000000 -cstack 4000000 -stack 2000000 -batch -cputime $time\n"; 

				     
#   EQ-ste-fu-nofu-sig-0-100-wdrmod2
    print CFGFILE "select 3\n";
    $time = int ($MAXTIME * 300 / 820 + 0.5);
    $bound = " -wdr -wd1 $WD1 -wd2 $WD2_mod2 -wd3 $WD3_mod2 -wd4 $WD4 -eq ";
    $SIGD = int (100 / $SIGNATURE);
    $sig = " -sigd1 0 -sigd2 $SIGD ";
    print CFGFILE "sam -cons $bound $delay $dynsgreord $sig -trail 2000000 -cstack 4000000 -stack 2000000 -batch -cputime $time\n"; 
				     

#   Default: MIX-ax-fu-nofu-wdr
    print CFGFILE "select 1\n";
    $time = int ($MAXTIME + 0.5);
    $delay = " -singledelay 2 -forcegr ";
    $dynsgreord = " -dynsgreord 5 ";
    $bound = " -wdr ";
    $sig = " ";
    print CFGFILE "sam -cons $bound $delay $dynsgreord $sig -trail 2000000 -cstack 4000000 -stack 2000000 -batch -cputime $time\n";			     
}


   
#
# NONHORN WITHOUT EQUALITY
#
if ($ishorn == 0  &&  $witheq == 0) {
				     
    print CFGFILE "competitors 3\n";
				     
    print CFGFILE "inwasm inwasm_MIX-ax-fu-nofu-sig\n";
    print CFGFILE "inwasm inwasm_MIX-ax-fu-nofu\n";

				     
#   Computing parameters for wdrmod2:
#
    $WD1=100;
    system "echo WD1 = $WD1 >> $GLOBAL_LOG";
    $WD2= 50 + int ( 5000 / ( ( $RULE_BRF_100 - 100 ) * ( 1 + $NR_NONHORN_CLAUSES ) ) );
    system "echo WD2 = $WD2 >> $GLOBAL_LOG";
    $WD3_EXPR = 80 + ( 10 *  int ( $NR_UNIT_CLAUSES / ( 1 + ( $NR_CLAUSES / 50 ) ) ) ) - ( 40 * int ( $NR_NONHORN_CLAUSES / ( 1 + ( $NR_CLAUSES / 20 ) ) ) );
    system "echo WD3_EXPR = $WD3_EXPR >> $GLOBAL_LOG";
    if ($WD3_EXPR >= 0) {
	$WD3 = $WD3_EXPR;
    }
    elsif ($WD3_EXPR < 0) {
	$WD3 = 0;
    }
    system "echo WD3 = $WD3 >> $GLOBAL_LOG";
    $WD4=0;
    system "echo WD4 = $WD4 >> $GLOBAL_LOG";


#   Computing parameters for delay:
#
    if ($withlongcl == 0) {
	system "echo Without equality theory and without long clauses: >> $GLOBAL_LOG";
	system "echo restricted reordering and no delay! >> $GLOBAL_LOG";
	$delay = " ";
    }
    elsif ($withlongcl == 1) {
	system "echo Without equality theory and with long clauses: >> $GLOBAL_LOG";
	system "echo restricted reordering and multidelay! >> $GLOBAL_LOG";
	$delay = " -multidelay -spred1 -forcegr ";
    }
				     

#   MIX-ax-fu-nofu-sig-200-30
    print CFGFILE "select 1\n";
    $time = int ($MAXTIME * 25 / 110 + 0.5);
    $SIGD = int (30 / $SIGNATURE);
    print CFGFILE "sam -cons -wdr -sigd1 200 -sigd2 $SIGD $delay -dynsgreord 5 -trail 2000000 -cstack 4000000 -stack 2000000 -batch -cputime $time\n";

				     
#   MIX-ax-fu-nofu-sig-200-30-wdrmod2
    print CFGFILE "select 1\n";
    $time = int ($MAXTIME * 5 / 110 + 0.5);
    $SIGD = int (30 / $SIGNATURE);
    print CFGFILE "sam -cons -wdr -wd1 $WD1 -wd2 $WD2 -wd3 $WD3 -wd4 $WD4 -sigd1 200 -sigd2 $SIGD $delay -dynsgreord 5 -trail 2000000 -cstack 4000000 -stack 2000000 -batch -cputime $time\n";

				     
#   MIX-ax-fu-nofu-wdrmod2
    print CFGFILE "select 2\n";
    $time = int ($MAXTIME * 80 / 110 + 0.5);
    print CFGFILE "sam -cons -wdr -wd1 $WD1 -wd2 $WD2 -wd3 $WD3 -wd4 $WD4 $delay -dynsgreord 5 -trail 2000000 -cstack 4000000 -stack 2000000 -batch -cputime $time\n";


#   Default: MIX-ax-fu-nofu-wdr
    print CFGFILE "select 2\n";
    $time = int ($MAXTIME + 0.5);
    print CFGFILE "sam -cons -wdr $delay -dynsgreord 5 -trail 2000000 -cstack 4000000 -stack 2000000 -batch -cputime $time\n";
}
close CFGFILE;


#
# generating configuration for psam
#
open(CONFIGURATION, "<$CONFIGFILE") or terminator( "cannot open $CONFIGFILE for read.", $BASENAME, -1 ); 
open(PSAM_CONF, ">$WORKDIR/$BASENAME.psam") or terminator( "cannot create $BASENAME.psam.", $BASENAME, -1 );
open(PINWASM_CONF, ">$WORKDIR/$BASENAME.pinwasm") or terminator( "cannot create $BASENAME.pinwasm.", $BASENAME, -1 );
while (<CONFIGURATION>) {
  @_=split;
  if ("$_[0]" =~ /inwasm/) {
    shift @_;
    $IINSTANT++;
    system "touch $WORKDIR/$BASENAME.inwasm_$IINSTANT.hex";
    symlink "$WORKDIR/$BASENAME.p", "$WORKDIR/$BASENAME.inwasm_$IINSTANT.p";
    symlink "$WORKDIR/$BASENAME.lop", "$WORKDIR/$BASENAME.inwasm_$IINSTANT.lop";
    print PINWASM_CONF "auto $BINDIR/@_ $BASENAME.inwasm_$IINSTANT $BINDIR\n";
    next;
    } 
  if ("$_[0]" =~ /select/) {
    $INWASMTAG = $_[1];
    next;
    }
  if ("$_[0]" =~ /competitors/) {
    $COMPET_TASKS = "$_[1]"; 
    next;
    } 
  if ("$_[0]" =~ /sam/) {
    shift @_;
    $SINSTANT++;
    symlink "$WORKDIR/$BASENAME.inwasm_$INWASMTAG.hex", "$WORKDIR/$BASENAME.$SINSTANT.hex";
#    print PSAM_CONF "auto $BINDIR/sam -cons -batch -cputime $TIMELIMIT -trail 2000000 -cstack 4000000 -stack 2000000 @_ $BASENAME.$SINSTANT\n";
    print PSAM_CONF "auto $BINDIR/sam -cons -batch -trail 2000000 -cstack 4000000 -stack 2000000 @_ $BASENAME.$SINSTANT\n";
    next;
    } 
  }
close CONFIGURATION;
close PSAM_CONF;
close PINWASM_CONF;
system "cat $WORKDIR/$BASENAME.pinwasm $WORKDIR/$BASENAME.psam >> $GLOBAL_LOG";
 
#
# compiling the lop
#
print "compiling ...\n"; 
system "$BINDIR/launcher $WORKDIR/$BASENAME.pinwasm $COMPET_TASKS nokill";
#sleep 1;
system "cat $WORKDIR/$BASENAME.inwasm_*.log >> $GLOBAL_LOG";
terminator( "inwasm error.", $BASENAME, -1 ) if $?!=0;

#
# calling psam
#
print "starting the parallel proof attempt ...\n"; 
system "$BINDIR/launcher $WORKDIR/$BASENAME.psam $COMPET_TASKS";
$SUCCESSTASK=($? >> 8); 
system "cat $WORKDIR/$BASENAME.[0-9]*.log >> $GLOBAL_LOG";
terminator( "sam error.", $BASENAME, -1 ) if $SUCCESSTASK > $SINSTANT;
terminator( "no proof found.", $BASENAME, 0 ) if $SUCCESSTASK == 0;
print "competitor $SUCCESSTASK found proof.\n";

#
# renaming the files
#
rename "$WORKDIR/$BASENAME.$SUCCESSTASK.tree", "$WORKDIR/$BASENAME.tree";
rename "$WORKDIR/$BASENAME.$SUCCESSTASK.log", "$WORKDIR/$BASENAME.log";
system "echo 'successtask '$SUCCESSTASK >> $WORKDIR/$BASENAME.log";

#
# that's all
#
terminator( "\n*****  Thank you for using p-SETHEO.  *****\n", $BASENAME, $SUCCESSTASK );

#
# error routine
#
sub terminator { # 1st argument message to print, 2nd basename, 3rd exitcode
#  sleep 1;
#  unlink <$WORKDIR/$_[1].*.*>;
#  unlink <$WORKDIR/$_[1].inwasm_*.*>;
#  unlink "$WORKDIR/$_[1].psam";
#  unlink "$WORKDIR/$_[1].pinwasm";
#  unlink "$WORKDIR/$_[1].tree";
#  unlink "$WORKDIR/pvm_initfile";
#  unlink "core";
  print "$_[0] exiting.\n";
  system "$BINDIR/pvm_kill";
  exit $_[2]; 
  }
