
/**************************************************************************
;;; MODULE NAME : sg_reordering.c
;;;
;;; PARENT      : main.c
;;;
;;; PROJECT     : MPLOP
;;;
;;; SCCS        : @(#)sg_reordering.c	15.1 01 Apr 1996
;;;
;;; AUTHOR      : Mohamed Salah, Hamdi
;;;
;;; DATE        : 27.01.94 
;;;
;;; DESCRIPTION : process subgoal reordering 
;;;
;;; REMARKS     :
;;;
***************************************************************************/



/*********************** INCLUDE ******************************************/

#include "extern.h" 
#define DELETED (-9999)

/*********************** DEFINE *******************************************/


/*********************** EXTERNE DATEN ************************************/


/*********************** EXTERNE FUNKTIONEN *******************************/

extern symbollist *get_all_var();          /* oconstr.c */

/*********************** GLOBALE DATEN ************************************/


/*********************** PROTOTYPEN ***************************************/


/*********************** FUNKTIONEN ***************************************/


/*---------------------- sg_reordering -----------------------------------*/

   /* F"uhrt subgoal reordering f"ur die ganze Formel durch. 
      wird gleich vor der Codegenerierung aufgerufen. 
   */

sg_reordering(cll)
claustype *cll;
{
   claustype *fann;

   while (cll)
    {
      /* sg reordering f"ur die deklarativen Klauseln und 
         eventuell auch fuer die prozeduralen Klauseln */
      if (cll->del != DELETED &&
      	    (inwasm_flags.sgreord == 1 &&
               cll->parsed_rule_type != PRULE && 
	       cll->parsed_rule_type != PQUERY ||
      	     inwasm_flags.sgreord == 2))
         clause_sg_reordering(cll);

       if (cll->fann)
        {
          fann = cll->fann;
          while (fann)
           {
              /* sg reordering f"ur Kontrapositive */
              if (fann->del != DELETED) 
                 clause_sg_reordering(fann);

             fann = fann->next;
           }
        }

      cll = cll->next;
    }
}

/*---------------------- clause_sg_reordering ----------------------------*/

   /* 
      F"uhrt subgoalreordering f"ur eine Klausel durch:

      Literale nach 'Termkomplexit"at' 'Variablenabhaengigkeit' und
      	Konnektionen.
   */

clause_sg_reordering(clause)
claustype *clause;
{
   predtype * aktpr;
   predtype * hlppr,*hpr;
   predtype * prev_aktpr;
   predtype * best;
   int result, conn1, conn2,weight1,weight2;

   if (clause->nr_lits > 2 && 
          clause->p_list->next->next->litnr < 100)
     /* mindestens 2 Lit. im Tail */
    {
      aktpr = clause->p_list->next;
      prev_aktpr = clause->p_list;
      while (aktpr && aktpr->next)
       {
         hlppr = aktpr->next;
         best = aktpr;

         while (hlppr)
          {
	   if (hlppr->symb < nrbuilt || best->symb < nrbuilt) 
	   {
	       if (hlppr->symb < nrbuilt && best->symb < nrbuilt &&
	           hlppr->litnr < best->litnr)
	         best = hlppr;
	       if (hlppr->symb < nrbuilt && !(best->symb < nrbuilt))
	         best = hlppr;
           }
	   else if (hlppr->complexity > best->complexity) 
	      best = hlppr;
           hlppr = hlppr->next;
         } 
        
         if (best == aktpr) /* das beste steht schon vorn */ 
          {
            prev_aktpr = prev_aktpr->next;
            aktpr = aktpr->next;
          }
         else /* vertauschen */   
          {
            hpr = aktpr;
            while (hpr && hpr->next != best) 
	      hpr = hpr->next; 

            /* best aushaengen */
            hpr->next = best->next;

            /* best vorne einhaengen */
            prev_aktpr->next = best;
            best->next = aktpr;  

            /* akt_pr und prev_aktpr weiterschalten */
            prev_aktpr = best;
	    aktpr = best->next;
	    
          }
       } 
   }
}


/*---------------------- conn_in_fact ------------------------------------*/

   /* Berechnet die Anzahl der Konnektionen in Fakten f"ur ein gegebenes
      Literal
   */

int conn_in_fact(lit)
predtype *lit;
{
   int erg = 0;
   predlist *wul = lit->wu;

   for (; wul; wul = wul->next)
     if (wul->pr->claus->nr_lits == 1) erg++;

   return(erg);
}



/*########################################################################*/
