/*----------------------------------------------------------------------------*/
/* Programm: FindeConstraints                                                 */
/* Datei:    Tautologie-Funktionen                                            */
/* Autor:    Martin Ziegenaus                                                 */
/* Datum:    13.09.91                                                         */
/* SCCS:     @(#)tconstr.c	13.2 07 Apr 1995
/* Modif:    12.11.92  tconstr.c             Hamdi                            */
/*           12.01.94  bug,extern.h          Hamdi                            */
/*                                                                            */
/*----------------------------------------------------------------------------*/


#include "extern.h"
 
#define DELETED (-9999)

/*----------------------------------------------------------------------------*/
/* externe Funktionen							      */
/*----------------------------------------------------------------------------*/
extern predtype *ErzeugeConstr(); 		/* hlpfkt.c */
extern int FuegeConstraintHinzu();		/* hlpfkt.c */




/*----------------------------------------------------------------------------*/
/* Hauptfunktion 							      */
/*----------------------------------------------------------------------------*/
claustype *gen_taut_constr( Gesamtstruktur)
	claustype *Gesamtstruktur;	/* Pointer auf die Formel */
{
	claustype *hpClause,*first; 
	int res;
	int deleted_print;

nr_gen_constr = 0;
first = Gesamtstruktur;

/******************************************************/
/* ueberpruefe, ob ueberhaupt Datenstruktur vorhanden */
/******************************************************/
if ( first == NULL )
	return(NULL);
/***************************************************/
/* ueberpruefe, ob erste Klausel default-query ist */
/***************************************************/
if ( ! first->p_list->symb )
	first = first->next;
/*********************************/
/* Tautologie-constraints bilden */
/*********************************/
hpClause = first;
deleted_print = 0;

while ( hpClause != NULL )
   {
      res = FindeTautologie( hpClause );
      if (res == 1) 
      	/************************/
      	/* Klausel tautologisch */ 
      	/************************/
       {
	if (!deleted_print){
		printf("  Deleted clauses: ");
		deleted_print = 1;
		}
        printf("%d ",hpClause->clnr);
	hpClause->del = DELETED; 
       }
      hpClause = hpClause->next;
   }

printf("  Generated constraints: %d\n", nr_gen_constr);
if (deleted_print){
	printf("\n");
	}

return(Gesamtstruktur); 
}


/*----------------------------------------------------------------------------*/
/* FindeTautologie							      */
/*----------------------------------------------------------------------------*/
int FindeTautologie( Clausel )
	claustype *Clausel;
	/***********************************************************/
	/* Clausel wird auf tautologische Instanzen hin untersucht */
        /* Return-Wert:  0: kein Constraint, keine Tautologie      */
        /*               1: Tautologie                             */
        /*               2: Constraint: potentielle Tautologie     */
        /***********************************************************/
{
predtype *pp, *hpp;	
predtype *constr = NULL;	/* das generierte Constraint */
int cons_gen = 0;               /* = 1 falls Constraint generiert wurde */

pp = Clausel->p_list;

while ( pp != NULL ) {
      hpp = pp->next;
      /******************************************************/	
      /* suche in aktueller Klausel komplementaeres Literal */
      /******************************************************/	
      while ( hpp != NULL ) {
	    if ( ( pp->symb == hpp->symb ) && ( pp->sign != hpp->sign ) ) {	
        	/*********************************/	
		/* und versuche, zu unifizieren. */
       		/*********************************/	
		rearrange();

               	switch (unify(hpp->t_list,pp->t_list)) {
               		case SUCCESS: 
			     constr = ErzeugeConstr(Clausel);
       	       		     if (constr) {
       		                FuegeConstraintHinzu( constr, Clausel );
                                constr->sign = TAUT_CONSTR;
                                cons_gen = 1; 
			     }
                             else 
			     /****************************/
			     /* Klausel ist tautologisch */
			     /****************************/
			     return(1);
                             break;
                	case FAIL:
			/*****************/
                        /* no constraint */
			/*****************/
                        break;
                	default:
                        fprintf(stderr," weak unify: return error");
                }

            } /* if */
	    /**********************/
	    /* Schalte hpp weiter */
	    /**********************/
	    hpp = hpp->next;		
	}
	/*********************/
	/* Schalte pp weiter */	
	/*********************/
	pp = pp->next;
	}

if (cons_gen) 
 return(2);
else return(0);
}


/*############################################################################*/
