/*#########################################################################
# File:			proto_unify.h
# SCCS-Info:		11/23/92, @(#)proto_unify.h	1.1
# Author:		Ch. Mueller
# Date:			23.12.87
# Context:		SETHEO
#
# Contents:		This file is a merge of unify.h, unifyred.h, and
#				full.c. Unification and protocol unification are
#				seperated now, using macros PU_**** or function
#				full_proto_unify() now instead of including 
#				file unifyred.h and full_unify().
#
# Modifications:
#	(when)		(who)		(what)
#	11.3.93	Mueller,Goller neue Constraints, Statistics
#	29.6.93		jsc		include-defines
#
# Bugs:
#
# 		--- Forschungsgruppe KI --- Intellektik ---
# Lehrstuhl fuer Rechnerarchitektur, Inst. fuer Informatik, TU Muenchen 
#########################################################################*/

#ifndef PROTO_UNIFY_H
#define PROTO_UNIFY_H

#include "unifyt.h"
#include "full.h"

#define PU_STRVAR(harg, hbp, garg, gbp)\
\
			switch ((unsigned char)(GETTAG(*garg))) {\
\
				case T_CONST:\
\
					trail_var(harg);\
					GENOBJ(*harg, (WORD)garg, T_BVAR);\
					break; \
\
\
				case T_STRVAR:\
\
					if (harg == garg) \
							break; \
\
					if (harg > garg)\
					   { \
						trail_var(harg);\
						GENOBJ(*harg,(WORD)garg,T_BVAR); \
					   }\
					else\
					   { \
						trail_var(garg);\
						GENOBJ(*garg,(WORD)harg,T_BVAR); \
					   }\
					break; \
\
        \
				case T_FVAR:\
\
					trail_var(harg);\
					GENOBJ(*harg, (WORD)garg, T_BVAR);\
					break;\
\
\
				case T_GTERM:\
\
					trail_var(harg);\
					GENOBJ(*harg,(WORD)garg,T_BVAR); \
					break; \
\
\
				case T_CRTERM:\
\
					if (occ_ck(harg,garg,gbp)) FAIL_U;\
					trail_var(harg); \
					GENOBJ(*harg,(WORD)garg,T_BVAR); \
					break; \
\
\
				case T_NGTERM:\
\
					garg = copy_struct(garg,gbp,harg); \
					if (!garg) FAIL_U;\
						trail_var(harg);\
					GENOBJ(*harg,(WORD)garg ,T_BVAR); \
					break; \
\
\
				default:\
					FAIL_U;\
					break;\
\
				}	/* end of switch tag of goal within case ha == T_STRVAR */\
			break;


#define PU_CONST(harg, hbp, garg, gbp)\
\
			switch ((unsigned char)(GETTAG(*garg))) {\
\
				case T_STRVAR:\
\
					trail_var(garg);\
					GENOBJ(*garg, (WORD)harg, T_BVAR);\
					break; \
\
\
				case T_CONST:\
					if (GETVAL(*garg) != GETVAL(*harg)) \
						FAIL_U;\
					break; \
\
\
				case T_FVAR:\
\
					c_trail(garg);\
					GENOBJ(*garg, (WORD)harg, T_BVAR);\
					break; \
\
\
				default:\
					FAIL_U;\
					break;\
\
				}	/* end of switch tag of goal within case ha == T_CONST */\
			break;

#define PU_FVAR(harg, hbp, garg, gbp)\
\
			switch ((unsigned char)(GETTAG(*garg))) {\
\
				case T_STRVAR:\
\
					trail_var(garg);\
					GENOBJ(*garg, (WORD)harg, T_BVAR);\
					break;\
\
               \
				case T_CONST:\
\
					c_trail(harg);\
					GENOBJ(*harg, (WORD)garg, T_BVAR);\
					break; \
\
\
				case T_FVAR:\
\
					if (harg == garg) \
						break; \
\
					if (harg > garg) { \
						c_trail(harg);\
						GENOBJ(*harg,(WORD)garg,T_BVAR); \
						} \
					else\
						{ \
						c_trail(garg); \
						GENOBJ(*garg,(WORD)harg,T_BVAR); \
						} \
					break; \
\
\
				case T_CRTERM:\
\
					if (occ_ck(harg,garg,gbp)) FAIL_U;\
					c_trail(harg);\
					GENOBJ(*harg,(WORD)garg,T_BVAR); \
					break; \
\
\
				case T_GTERM:\
\
					c_trail(harg);\
					GENOBJ(*harg,(WORD)garg,T_BVAR); \
					break; \
\
\
				case T_NGTERM:\
\
					garg = copy_struct(garg,gbp,harg); \
					if (!garg) FAIL_U;\
					c_trail(harg);\
					GENOBJ(*harg,(WORD)garg ,T_BVAR); \
					break; \
\
\
				default:\
					FAIL_U;\
					break;\
\
				}	/* end of switch tag of goal within case ha == T_FVAR */\
			break;


#define PU_CRTERM(harg, hbp, garg, gbp)\
\
			switch ((unsigned char)(GETTAG(*garg))) {\
\
				case T_STRVAR:\
\
					if (occ_ck(garg,harg,hbp)) FAIL_U;\
					trail_var(garg); \
					GENOBJ(*garg,(WORD)harg,T_BVAR); \
					break; \
\
\
				case T_FVAR:\
\
					if (occ_ck(garg,harg,hbp)) FAIL_U;\
					c_trail(garg); \
					GENOBJ(*garg,(WORD)harg,T_BVAR); \
					break; \
\
\
				case T_CRTERM:\
				case T_GTERM:\
				case T_NGTERM:\
\
					if (full_proto_unify(garg,harg,gbp,hbp)) /* do copy */ \
						FAIL_U; \
					break; \
\
\
				default:\
					FAIL_U;\
					break;\
\
				}	/* end of switch tag of goal within case ha == T_CRTERM */\
			break;


#define PU_GTERM(harg, hbp, garg, gbp)\
\
			switch ((unsigned char)(GETTAG(*garg))) {\
\
				case T_STRVAR:\
\
					trail_var(garg); \
					GENOBJ(*garg,(WORD)harg,T_BVAR); \
					break; \
\
\
				case T_FVAR:\
\
					c_trail(garg); \
					GENOBJ(*garg,(WORD)harg,T_BVAR); \
					break; \
\
\
				case T_CRTERM:\
				case T_GTERM:\
				case T_NGTERM:\
\
					if (full_proto_unify(garg,harg,gbp,hbp)) /* do not copy */ \
						FAIL_U; \
					break; \
\
\
				default:\
					FAIL_U;\
					break;\
\
				}	/* end of switch tag of goal within case ha == T_GTERM */\
			break;


#define PU_NGTERM(harg, hbp, garg, gbp)\
\
			switch ((unsigned char)(GETTAG(*garg))) {\
\
				case T_STRVAR:\
\
					harg = copy_struct(harg,hbp,garg); \
					if (!harg) FAIL_U ;\
						trail_var(garg);\
					GENOBJ(*garg,(WORD)harg ,T_BVAR); \
					break; \
\
\
				case T_FVAR:\
\
					harg = copy_struct(harg,hbp,garg); \
					if (!harg) FAIL_U ;\
						c_trail(garg);\
					GENOBJ(*garg,(WORD)harg ,T_BVAR); \
					break; \
\
\
				case T_GTERM:\
				case T_CRTERM:\
				case T_NGTERM:\
					if (full_proto_unify(garg,harg,gbp,hbp)) /* do copy */ \
						FAIL_U; \
					break; \
\
\
				default:\
					FAIL_U;\
					break;\
\
				}	/* end of switch tag of goal within case ha == T_NGTERM */\
			break;

#endif
