% I-THOP  (A first-order theorem prover based on PTTP technology)
% 
%      version 1.01
%      July 2, 1997
%      Copyright (C) 1997, Koji Iwanuma (iwanuma@esi.yamanashi.ac.jp)
% 
% This program is free software; you can redistribute it or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation; either versions 1, or (at your option)
% any later version.
%  
% This program is distributed in the hope that it will be useful but
% WITHOUT ANY WARRANTY.  See the GNU General Public License for more
% details.
% ---------------
%
%   call_c.pl 
%
% ---------------
%  Declaration for predicates for check_tool.c


% ---------------
% The below is for SICStus V3 #3 or the older
%
% cc -c check_tool.c
%foreign_file('check_tool.o',[
% ---------------
% The below is for SICStus V3 #5

foreign_resource(check_tool,[
	           signal_init,
		   %
	           reset_carray,inc_carray,call_carray,
		   set_flag_number,reset_all_flag_number,
		   reset_flag_number,call_flag_number,
		   %
		   set_flag_atom,reset_all_flag_atom,
		   call_flag_atom,
		   %
		   reset_all_lemma_number,
		   inc_lemma_number,call_lemma_number,
		   inc_lemma_total_number,call_lemma_total_number,
		   %
		   reset_tmp_number,inc_tmp_number,call_tmp_number,
		   reset_anti,inc_anti,dec_anti,call_anti_number
             ]).

%---------

foreign(signal_init, c, signal_init).

%---------
foreign(reset_carray, c, reset_carray).
foreign(inc_carray, c, inc_carray(+integer)).
foreign(call_carray, c, call_carray(+integer,[-integer])).

%---------
foreign(set_flag_number, c, set_flag_number(+integer,+integer)).
foreign(reset_all_flag_number, c, reset_all_flag_number).
foreign(reset_flag_number, c, reset_flag_number(+integer)).
foreign(call_flag_number, c, call_flag_number(+integer,[-integer])).

%---------
foreign(set_flag_atom, c, set_flag_atom(+integer,+atom)).
foreign(reset_all_flag_atom, c, reset_all_flag_atom(+atom)).
foreign(call_flag_atom, c, call_flag_atom(+integer,[-atom])).

%---------
foreign(reset_all_lemma_number, c, reset_all_lemma_number).
foreign(inc_lemma_number, c, inc_lemma_number(+integer)).
foreign(call_lemma_number, c, call_lemma_number(+integer,[-integer])).
foreign(inc_lemma_total_number, c, inc_lemma_total_number).
foreign(call_lemma_total_number, c, call_lemma_total_number([-integer])).

%---------
foreign(reset_tmp_number, c, reset_tmp_number).
foreign(inc_tmp_number, c, inc_tmp_number).
foreign(call_tmp_number, c, call_tmp_number([-integer])).

%---------
foreign(reset_anti, c, reset_anti).
foreign(inc_anti, c, inc_anti).
foreign(dec_anti, c, dec_anti).
foreign(call_anti_number, c, call_anti_number([-integer])).

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%  reset flat_atom
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

reset_all_flag_atom :- reset_all_flag_atom('@initial_data').
reset_flag_atom(X) :- set_flag_atom(X,'@initial_data').
