#ifndef _CLOCK_
#define _CLOCK_

#include </usr/include/sys/times.h>

#if defined(TICKS_PER_SEC)
#undef TICKS_PER_SEC
#endif
#if ( defined(SOLARIS) || defined(LINUX) )
#define TICKS_PER_SEC 100
#elif defined(SUNOS)
#define TICKS_PER_SEC 60
#endif

typedef struct tms CLOCK_TMS;

extern float      accumseconds;
extern CLOCK_TMS  myclock,newclock;


#define Clock_Reset  ({  accumseconds = 0;                             })
#define Clock_Start  ({  times(&(myclock));                            })
#define Clock_Print  ({  printf(" %f seconds.\n",accumseconds);  })
#define Clock_Stop   ({  times(&newclock);\
  accumseconds += (newclock.tms_utime - myclock.tms_utime)/(float)TICKS_PER_SEC; \
		       })

#endif
