% I-THOP  (A first-order theorem prover based on PTTP technology)
% 
%      version 1.01
%      July 2, 1997
%      Copyright (C) 1997, Koji Iwanuma (iwanuma@esi.yamanashi.ac.jp)
% 
% This program is free software; you can redistribute it or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation; either versions 1, or (at your option)
% any later version.
%  
% This program is distributed in the hope that it will be useful but
% WITHOUT ANY WARRANTY.  See the GNU General Public License for more
% details.
% ---------------
%
%   comSORT.pl
%
% ---------------
%
%  The sort program contained in this file is fundamentally
%  based on a stupid algorithm.  Also this file contains several
%  dull codes.  It is necessary to improve these codes in a near
%  future.  June 15, 1997
%

sorting :-
	%
	nl,write('Sorting goals in clauses ...'),nl,
	make_tmp_file,
	%
	read_tmp_file,
	%
	%listing(pseudo_horn_clause),
	!,
	retract_clause(unit,UnitClause),
	assert_clause(unit,UnitClause),
	%
	retract_clause(non_unit,NonUnitClause),
	(sort_clause_mode(off) ->
	   NonUnitClause = NewNonUnitClause ;
	 sort_clause_mode(on) ->
	   quick_sort(NonUnitClause,NewNonUnitClause) ;
        %true ->
	   nl,write('Error: sort_clause_mode 5555 !'),nl
	),
	assert_clause(non_unit,NewNonUnitClause),
	%
	%listing(sorted_pseudo_horn_clause),
	%
	!,
	(sort_bliteral_mode([0,0,0,0,0,0]) ->
	   true ;
	   (call(head_u(U)),length(U,UL),
	    call(head1(NU)),length(NU,NUL),
	    nl,
	    write('Unit = '),write(UL),nl,
	    write('Non Unit = '),write(NUL),nl,
	    write('Unit / (Unit + Non Unit) = '),
	    U_NU is UL / (UL + NUL),
	    write(U_NU),nl,nl
	   )
	),
	(write_sorted_literal_mode(on) ->
	    write_select_criteria ;
	%true ->
	    true
	).

write_select_criteria :-
	   nl, write('selected_criteria = '),
	   write_selection_number.

write_selection_number :-
	   call(select_criterion(L,N)),
	   write([L,N]),write(' '),
	   fail.
write_selection_number :- 
	   nl.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

make_tmp_file :-
	
	initialize_make_tmp_file,
	%----------------------------------------------
	% system depending predicate ???
	%
	prolog_flag(unknown,Current,fail),
	( call(axiom_temp_data_file(DATA)) -> 
	       true ;
	  % true ->
	       mktemp(theDATAXXXXXX,DATA),      
	       assert(axiom_temp_data_file(DATA))
	),
	prolog_flag(unknown,_,Current),
	%----------------------------------------------

	tell(DATA),
	write_file,
	told.

initialize_make_tmp_file :-
        retractall(each_head_u(_)), 
        retractall(each_head1(_)),
	retractall(select_criterion(_,_)),
	assert(select_criterion(1,0)),
	assert(select_criterion(2,0)),
	assert(select_criterion(3,0)),
	assert(select_criterion(4,0)),
	assert(select_criterion(5,0)),
	assert(select_criterion(6,0)),
	assert(select_criterion(d,0)).

write_file :-
	write_unit_clause,nl,
	write_Horn_clause,nl,
	write_Non_Horn_clause,nl,
	write_goal,nl,
	write_axiom_attribute.


write_unit_clause :- 
	retract(contrapositive(unit,Unit,true,ID)),
	(call(axiom_att(horn,horn)),is_Negative(Unit) ->
	      true ;
	%true ->
	      write(me_clause(unit,ID,Unit)),write('.'),nl,
	      %-----
	(sort_bliteral_mode([XB1,XB2,XB3,XB4,XB5,XB6]);
           sort_bliteral_mode(auto)),
	 ( (XB1 \== 0; XB2 \== 0; XB3 \== 0; XB4 \== 0;XB5 \== 0;
	      XB6 \==0; sort_bliteral_mode(auto)) ->
	        assert_head(unit,Unit) ;
	  (XB1 == 0,XB2 == 0, XB3 == 0,XB4 == 0,XB5 == 0, XB6 == 0) ->
	        true
	 )
	),
	fail.
write_unit_clause.

write_Horn_clause :-
	retract(contrapositive(horn,Head,Body,ID)),
	write(me_clause(non_unit,ID,(Head :- Body))),write('.'),nl,
	%--------
	(sort_bliteral_mode([XB1,XB2,XB3,XB4,XB5,XB6]);
          sort_bliteral_mode(auto)),
        ( (XB1 \== 0;XB2 \== 0; XB3 \== 0;XB4 \== 0;XB5 \== 0;
	      XB6 \== 0; sort_bliteral_mode(auto)) ->
	        assert_head(non_unit,(Head :- Body)) ;
	  (XB1 == 0,XB2 == 0, XB3 == 0, XB4 == 0,XB5 == 0, XB6 == 0) ->
	        true
	),
	fail.
write_Horn_clause.

write_Non_Horn_clause :-
	retract(contrapositive(clause,Flag,CList,ID)),
	(call(axiom_att(horn,horn)) ->
	    (Flag == negative ->
	         true ;
	     Flag == non_nega ->		
	         collect_head_and_body(CList,Head,BList-BList),
		 list_to_conjunction(BList,Body),
		 write(me_clause(non_unit,ID,(Head :- Body))),write('.'),nl,
		 %--------
	     (sort_bliteral_mode([XB1,XB2,XB3,XB4,XB5,XB6]);
		 sort_bliteral_mode(auto)),
	     ( (XB1 \== 0;XB2 \== 0; XB3 \== 0; XB4 \== 0;XB5 \== 0;
		   XB6 \== 0;  sort_bliteral_mode(auto)) ->
	             assert_head(non_unit,(Head :- Body)) ;
	        (XB1 == 0,XB2 == 0,XB3 == 0, XB4 == 0,XB5 == 0,XB6 == 0) -> 
		     true
	     )
	    );
	 call(axiom_att(horn,non_horn_existed)) ->
	    write_contrapositives(CList,ID) ;
	%true ->		
            nl,write('Error in write_Non_Horn_clause !!!!'),nl
	),
	fail.
write_Non_Horn_clause.

write_goal :-
	retract(contrapositive(query,query,Goals,ID)),
	write(me_clause(query,ID,(query :- Goals))),write('.'),nl,
	%
	(sort_bliteral_mode([XB1,XB2,XB3,XB4,XB5,XB6]);
	    sort_bliteral_mode(auto)),
	 ( (XB1 \== 0;XB2 \== 0; XB3 \== 0; XB4 \== 0;XB5 \== 0;
	      XB6 \== 0; sort_bliteral_mode(auto)) ->
	        assert_head(query,(query :- Goals)) ;
	   (XB1 == 0,XB2 == 0, XB3 == 0, XB4 == 0,XB5 == 0,XB6 == 0) ->
	         true
	 ),
	fail.
write_goal.

write_axiom_attribute :-
	call(axiom_att(Item,Data)),   %%% axiom_att$B$O!$(Bsort_bliteral(auto)$B$G(B
	write(me_axiom_att(Item,Data)),write('.'),nl,%% $B;H$&$N$G;D$7$F$*$/(B
	fail. 
write_axiom_attribute.

%%%%%%%%%% 
%collect_head_and_body([],_,_) :-
%	nl,write('Error in get_head_and_body !!!'),nl.
%
%collect_head_and_body([Car|Cdr],Head,BodyList-End) :-
%	functor(Car,F,_),name(F,FList),
%	(append("not_",_,FList) -> 
%	       add_string_to_literal(Car,CarComp,"not_"),
%	       End = [CarComp|NewEnd],
%	       collect_head_and_body(Cdr,Head,BodyList-NewEnd) ;
%	 %true ->
%	       Head = Car, End=Cdr
%	).
%%%%%%%%%

collect_head_and_body([],_,_BodyList-[]).

collect_head_and_body([Car|Cdr],Head,BodyList-End) :-
        functor(Car,F,_),name(F,FList),
        (append("not_",_,FList) -> 
               add_string_to_literal(Car,CarComp,"not_"),
               End = [CarComp|NewEnd],
               collect_head_and_body(Cdr,Head,BodyList-NewEnd) ;
         %true ->
               Head = Car, 
               collect_head_and_body(Cdr,Head,BodyList-End)
        ).

write_contrapositives(List,ID) :-
	complemented_list(List,CompList),
	write_contra_clauses(List,ID,CompList,X-X).

write_contra_clauses([],_,[],_).
write_contra_clauses([Car|Cdr],ID,[CCar|CCdr],PHead-PTail) :-
	\+ \+ (
           PTail = CCdr,
	   list_to_conjunction(PHead,Body),
           write(me_clause(non_unit,ID,(Car :- Body))),write('.'),nl,
	   %
	   (sort_bliteral_mode([XB1,XB2,XB3,XB4,XB5,XB6]);
	       sort_bliteral_mode(auto)),
	   ( (XB1 \== 0;XB2 \== 0; XB3 \== 0 ;XB4 \== 0;XB5 \== 0;
	      XB6 \== 0; sort_bliteral_mode(auto)) ->
	        assert_head(non_unit,(Car :- Body)) ;
	      (XB1 == 0,XB2 == 0, XB3 == 0,XB4 == 0,XB5 == 0,XB6 == 0) ->
	        true
	   )
        ),
	PTail = [CCar|NewPTail],
	write_contra_clauses(Cdr,ID,CCdr,PHead-NewPTail).

complemented_list([],[]) :- !.
complemented_list([Car|Cdr],[CarComp|CompCdr]) :-
	add_string_to_literal(Car,CarComp,"not_"),
	complemented_list(Cdr,CompCdr).

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

read_tmp_file :-
	initialize_read_tmp_file,
	%
	call(axiom_temp_data_file(DATA)),
	see(DATA),!,
	%
	repeat,
	read(ITEM),
	(ITEM==end_of_file ->
	    !;
	 ITEM = me_clause(Sort,ClauseID,PRG) ->
	    make_program_list(Sort,ClauseID,PRG),
	    fail ;
	 ITEM = me_axiom_att(Item,Data) ->
	    assert(axiom_att_in_compiling(Item,Data)),
	    fail
	),
	%
	seen.

initialize_read_tmp_file :-
        retractall(head_u(_)), 
        retractall(head1(_)),
	collect_head_data,
	%
        %listing(head_u),
	%listing(head1),
	true.

collect_head_data :-
	h111([]),h333([]).

h111(X) :- retract(each_head_u(L)),!,h111([L|X]).
h111(X) :- assert(head_u(X)).
 
h333(X) :- retract(each_head1(H,N)),!,h333([(H,N)|X]).
h333(X) :- assert(head1(X)).
       

make_program_list(unit,ClauseID,UNIT) :-
	!,
	make_predicate_name(UNIT,unit),
	%
	(write_sorted_literal_mode(on) ->
	   write(ClauseID),write(' '),write(UNIT),nl,nl ;
	 write_sorted_literal_mode(off) ->
	   true
	),
	sort_clause_all(0,List),!,
	assertz(pseudo_horn_clause(unit,UNIT,[ClauseID],List)).

make_program_list(non_unit,ClauseID,(HEAD :- BODY)) :-
	!,
	make_predicate_name(HEAD,non_unit),
	conjunction_to_list(BODY,BLIST),
	%
	%nl,write('Start Sort: a Non-Unit ....'),nl,
	%
	sort_bodies(HEAD,BLIST,NewBLIST), 
	%
	%nl,write('End Sort: a Non-Unit ....'),nl,
	%
	list_to_conjunction(NewBLIST,NewBODY),
	(write_sorted_literal_mode(on) ->
	   write(ClauseID),write(' '),
	   write_lettervars( ((HEAD :- BODY) --> (HEAD :- NewBODY)) ),nl,nl ;
	 write_sorted_literal_mode(off) ->
	   true
	),
        length(NewBLIST,NewBL),
        sort_clause_all(NewBL,List),!,
	assertz(pseudo_horn_clause(non_unit,[HEAD|NewBLIST],[ClauseID],List)).

make_program_list(query,ClauseID,(query :- GOAL)) :-
	!,
	conjunction_to_list(GOAL,GLIST),
	inc_id_number(goal),call_id_number(goal,Id),
	(Id == 1 ->
	       sort_goals(GLIST,NewGLIST),
	       list_to_conjunction(NewGLIST,NewGOAL),
	       (write_sorted_literal_mode(on) ->
		  write(ClauseID),write(' '),
		  write_lettervars( ((query :- GOAL) --> (query :- NewGOAL)) ),nl,nl ; 
	        write_sorted_literal_mode(off) ->
		  true
	       ),!,
	       assertz(pseudo_horn_clause(goal,NewGLIST,Id,[ClauseID])) ;
        %true ->
              nl,write('**** Error: Several goals exists !! ****'),nl,nl,
              abort
        ).

%%%%%%%%%%%%%%%%%%%%%%%%%%%

make_predicate_name(Head,UnitFlag) :-
	functor(Head,Name,Arity),
	(Arity == 0 ->
	     nl,write('*** The proposition '),write(Name),
	           write(' is included ... Compilation aborted !! ***'),nl,nl,
	     abort ;
	%true ->
	     true 
	),
	(retract(predicate_name(Name,Arity,Id,UF,CompUF,NUF)) ->
	     (UnitFlag == unit ->
		   assert(predicate_name(Name,Arity,Id,'@unit_exist',CompUF,NUF)) ;
	     UnitFlag == non_unit ->
		   assert(predicate_name(Name,Arity,Id,UF,CompUF,'@non_unit_exist')) ;
             %true ->
		   nl,write('Error 1 in make_predicate_name !!'),nl,nl
	     ) ;
	%true ->
	     inc_id_number(predicate),call_id_number(predicate,Id),
	     (UnitFlag == unit ->
	           assert(predicate_name(Name,Arity,Id,'@unit_exist','@comp_unit_none','@non_unit_none'));
              UnitFlag == non_unit ->
	           assert(predicate_name(Name,Arity,Id,'@unit_none','@comp_unit_none','@non_unit_exist'));
	      %true ->
		   nl,write('Error 2 in make_predicate_name !!'),nl,nl
	      )
	),
	add_string_to_name(Name,CompName,"not_"),
	(UnitFlag == unit ->
	     (retract(predicate_name(CompName,Arity,Id2,UF2,_,NUF2)) ->	
		   assert(predicate_name(CompName,Arity,Id2,UF2,'@comp_unit_exist',NUF2)) ;
	     %true ->
	           inc_id_number(predicate),call_id_number(predicate,Id2),
	           assert(predicate_name(CompName,Arity,Id2,'@unit_none','@comp_unit_exist','@non_unit_none'))
	     ) ;
	%true ->
	    true 
	).

%---------------------------
% make_zero_list(L,[],List).
% L$B8D$N#0$N%j%9%H$r:n$k!%(B

make_zero_list(0,ZeroList,ZeroList) :- !.

make_zero_list(Length,Tmp,ZeroList) :-
	Length1 is Length - 1,
	make_zero_list(Length1,[0|Tmp],ZeroList).

%%%%%
% plus_list(L1,L2,L3).
% L1 + L2 -> L3

plus_list([],[],[]) :- !.
plus_list([F1|R1],[F2|R2],[F3|R3]) :-
	F3 is F1 + F2,
	plus_list(R1,R2,R3).

%%%%%
% List1 - List2 -> List3

subtraction_list([],[],[]) :- !.
subtraction_list([F|R],[F1|R1],[F2|R2]) :-
	F2 is F - F1,
	subtraction_list(R,R1,R2).

%%%%%
% $B%j%9%H$r(BNum$BG\$9$k(B

mul_list(_,[],[]) :- !.
mul_list(Num,[F|R],[F2|R2]) :-
	F2 is F * Num,
	mul_list(Num,R,R2).

%%%%%

list_add([],L,L) :- !.
list_add([F|R],Tmp,Last) :-
        Tmp1 is Tmp + F,
        list_add(R,Tmp1,Last).

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% ?- ass_quick_sort([1,4,2],L,[p,q,r],S).
% L = [4,2,1],S = [q,r,p] ? ;
% ass_quick_sort(L,S,L1,S1)
% $B%j%9%H(BL1 $B$r%j%9%H(BL$B$NCM$NBg$-$$=g$KJB$S49$($k(B

ass_quick_sort(L1,S1,L2,S2) :-
	ass_pairwise(L1,L2,AssL),
	ass_qsort(AssL,OutL,[]),
        ass_separate(OutL,S1,S2).

ass_pairwise([],[],[]) :- !.
ass_pairwise([Ca1|Cd1],[Ca2|Cd2],[(Ca1,Ca2)|Cdr]) :-
	ass_pairwise(Cd1,Cd2,Cdr).

ass_qsort([],X,X).
ass_qsort([(Ca1,Ca2)|R],X,M) :-
	ass_split(Ca1,R,L,G),
	ass_qsort(L,X,[(Ca1,Ca2)|U]),ass_qsort(G,U,M).

ass_split(_,[],[],[]).
ass_split(N,[(Ca1,Ca2)|R],[(Ca1,Ca2)|L1],G) :- 
	N < Ca1, ass_split(N,R,L1,G).
ass_split(N,[(Ca1,Ca2)|R],L,[(Ca1,Ca2)|G1]) :- 
	N >= Ca1, ass_split(N,R,L,G1).

ass_separate([],[],[]).
ass_separate([(Ca1,Ca2)|Cdr],[Ca1|Cd1],[Ca2|Cd2]) :-
	ass_separate(Cdr,Cd1,Cd2).

%%%%%%%%%%%%%%%%%%%%%%%%%%%
% assert_head head$B$r%j%9%H$K$7$F(Bassert$B$9$k(B

assert_head(query,(query :- _GOAL)) :-
	!.

assert_head(unit,PRG) :- 
	!,
	(sort_bliteral_mode([XB1,XB2,XB3,XB4,XB5,XB6]) ; 
	    sort_bliteral_mode(auto)),
	(XB1==0, XB2==0, XB3==0, XB4==0, XB5==0, XB6==0 ->
	          true ;
	 (XB1\== 0; XB2\==0; XB3\==0; XB4\==0;
	     XB5\==0; XB6\==0; sort_bliteral_mode(auto))  ->
		    assertz(each_head_u(PRG))
	).

assert_head(non_unit,(HEAD :- BODY)) :-
	!,
	(sort_bliteral_mode([XB1,XB2,XB3,XB4,XB5,XB6]) ;
	    sort_bliteral_mode(auto)) ,
	(XB1 == 0,XB2 == 0,XB3 == 0,XB4 == 0, XB5 == 0,XB6 == 0 ->
	        true ;
         (XB1\== 0; XB2\==0; XB3\==0; XB4\==0;
	     XB5\==0; XB6\==0; sort_bliteral_mode(auto))  ->
	        conjunction_to_list(BODY,BLIST),
		length(BLIST,BLISTL),
		assertz(each_head1(HEAD,BLISTL))
	).

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% sort_blist12(BLIST,[],Last)
% BLIST$B$N3F%4!<%k$H(Bunify$B$9$k%X%C%I$N?t$,!"(BList$B$KF~$k!#(B

sort_blist12(Sort,Blist,NumList) :-
	Blist == [] ->
	    nl,write('Error 1:  in sort_blist12 !'),nl ;
	Sort == b_u ->
	   call(head_u(Hlist)),
	   s_blist12(Sort,Blist,Hlist,X-X,NumList) ;
	Sort == b_nu ->
	   call(head1(Hlist)),
	   s_blist12(Sort,Blist,Hlist,X-X,NumList) ;
	%true ->
	    nl,write('Error 2:  in sort_blist12 !'),nl.

s_blist12(_,[],_,H-[],H).
s_blist12(Sort,[F|R],Hlist,H-T,NL) :-
	(Sort == b_u ->
	      count_unifiable_unit(F,0,Num,Hlist) ;
	 Sort == b_nu ->
	      count_unifiable_non_unit(F,0,Num,Hlist)
	),
	T=[Num|NewT],
	s_blist12(Sort,R,Hlist,H-NewT,NL).

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

count_unifiable_unit(_,L,L,[]) :- !.
count_unifiable_unit(F,N,Result,[L|LR]) :-
	(\+ \+ unify(F,L)) ->
	    NewN is N + 1,
	    count_unifiable_unit(F,NewN,Result,LR) ;
	%true ->
	    count_unifiable_unit(F,N,Result,LR).

%%%%%%%%%%%%%

count_unifiable_non_unit(_,L,L,[]) :- !.
count_unifiable_non_unit(F,N,Result,[(L,_)|LR]) :-
	(\+ \+ unify(F,L)) ->
	    NewN is N + 1,
	    count_unifiable_non_unit(F,NewN,Result,LR) ;
	%true ->
	    count_unifiable_non_unit(F,N,Result,LR).
	
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% ground $B$H(Bnon ground$B$KJ,$1$k!%(B

separate_ground_nonground([],GH-[],GH,NH-[],NH).
separate_ground_nonground([F|R],GH-GT,Ground,NH-NT,NonGro) :-
	(ground(F) ->
	     GT=[F|NewGT], NewNT = NT ;
	%true ->
	     NewGT = GT, NT=[F|NewNT]
        ),
	separate_ground_nonground(R,GH-NewGT,Ground,NH-NewNT,NonGro).

%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 6$BHV$NJB$Y49$((B
% $B%X%C%I$NJQ?t$N<oN`$N?t(B(var_list) $B"*(B
% $B%X%C%I$NJQ?t$N?t(B(var_list1)

sort_blist6(_HEADvarlist,[],L,L) :- !.
sort_blist6(HEADvarlist,[BF|BR],L1t,L1) :-
	var_list1(BF,BFvarlist),
	not_member(BFvarlist,HEADvarlist,[],F1),
	%
        % Body$BIt$K$"$C$F%X%C%I$K$J$$JQ?t$r(BF1$B$K<h$j=P$9!%(B
	%
	delete_list(F1,BFvarlist,BFvarlist1),
	length(BFvarlist1,BFvarlist1L),
	append(L1t,[BFvarlist1L],NewL1t),
	sort_blist6(HEADvarlist,BR,NewL1t,L1).

%%%%%%%%%%%%
% not_member([F|R],BlistVariable,NowVal,FinalVal)
% [F|R]$B$N$&$A(BBlistVariable$B$K$J$$$b$N$r(BFinalVal$B$K<h$j=P$9!%(B

not_member([],_,NewVal,NewVal) :- !.  

not_member([F|R],BlistVariable,NowVal,FinalVal) :-      
	(\+ identical_member(F,BlistVariable) ->        
            NewVal = [F|NowVal] 
        ;
            NewVal = NowVal 
        ),
        not_member(R,BlistVariable,NewVal,FinalVal).

delete_list([],N,N) :- !.
delete_list([F|R],BLIST,FinalBlist) :-
        delete(F,BLIST,NewBlist),
        delete_list(R,NewBlist,FinalBlist).

delete(_,[],[]) :- !.    
delete(A,[B|R],R) :- A == B,!.    % Notice !!  Is this a bug ??
delete(A,[F|R],[F|S]) :- 
        delete(A,R,S).


%%%%%%%%%%%%%%%%%%%%%%%%%%
% 5$BHV$NJB$Y49$($G;H$&(B

sort_blist5(ArgL,NumList) :- 
	s_blist5(ArgL,X-X,NumList).

s_blist5([],H-[],H) :- !.

s_blist5([F|R],H-T,NumList) :-
	measure_tdepth1(F,0,Size), 
	Size1 is Size - 1,
        % DepthF$B$K$O!$=R8l5-9f$NJ,$N(B1$B$,F~$k$N$G!"0z$$$F$*$/!%(B
	%
	T=[Size1|NewT],
	s_blist5(R,H-NewT,NumList).

%%%

measure_tdepth1(X,L,L):-
	var(X),!.
measure_tdepth1(X,L1,L2) :-
	atom(X),!,L2 is L1 + 1 .
measure_tdepth1(Term,L1,L2) :-
	functor(Term,_,S),
	L3 is L1 + 1,
	measure_tdepth1_args(S,Term,L3,L2).

measure_tdepth1_args(0,_,L,L):- !.
measure_tdepth1_args(S,Term,L1,L2) :-
        arg(S,Term,Arg),
        measure_tdepth1(Arg,L1,L3),
        S1 is S-1, measure_tdepth1_args(S1,Term,L3,L2).

%%%%%%%%%%%%%%%%%%%%%%%%%

sort_blist3(Blist,NumList) :-
	Blist == [] ->
	    nl,write('Error 1:  in sort_blist3 !'),nl ;
	%true ->
            call(head1(Hlist)),
	    s_blist3(Blist,Hlist,X-X,NumList).

s_blist3([],_,H-[],H).
s_blist3([F|R],Hlist,H-T,NL) :-
        s_blist3_min(F,Hlist,100000,Mini),
	T=[Mini|NewT],
	s_blist3(R,Hlist,H-NewT,NL).

s_blist3_min(_,[],L,L) :- !.
s_blist3_min(F,[(F1,NL)|R1],Tmp,Mini) :-
       ((\+ \+ unify(F,F1)) ->
	     (Tmp > NL ->
                   Tmp1 is NL ;
             %true ->
	           Tmp1 is Tmp
	     ) ;
        %true ->
             Tmp1 is Tmp
        ),
        s_blist3_min(F,R1,Tmp1,Mini).

%%%%%%%%%%%%%%%%%%%%%%%%%

sort_blist4(Blist,NumList) :-
	Blist == [] ->
	    nl,write('Error 1:  in sort_blist4 !'),nl ;
	%true ->
            call(head1(Hlist1)),
            call(head_u(Hlist2)),
	    s_blist4(Blist,Hlist1,Hlist2,X-X,NumList).

s_blist4([],_,_,H-[],H).
s_blist4([F|R],Hlist1,Hlist2,H-T,NL) :-
        s_blist4_weight(F,Hlist1,Hlist2,W),
	T=[W|NewT],
	s_blist4(R,Hlist1,Hlist2,H-NewT,NL).

s_blist4_weight(F,Hlist1,Hlist2,W) :-
        s_blist4_H1(F,Hlist1,0,W1),
	s_blist4_H2(F,Hlist2,W1,W).

s_blist4_H1(_,[],L,L) :- !.
s_blist4_H1(F,[(F1,NL)|R1],Tmp,Last) :-
	((\+ \+ unify(F,F1)) ->
	    Tmp1 is Tmp + 1/(NL+1)
	  ;
	    Tmp1 is Tmp
	),
        s_blist4_H1(F,R1,Tmp1,Last).

s_blist4_H2(F,Hlist2,W1,W) :-
	count_unifiable_unit(F,0,Num,Hlist2),
	W is W1 + Num.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

sort_bodies(HEAD,BLIST,NewBLIST) :-
	sort_bliteral_mode([0,0,0,0,0,0]) ->
	        NewBLIST = BLIST ;
	%true ->    
	        sort_blist12(b_u,BLIST,E_1u),
		sort_blist12(b_nu,BLIST,E_1nu),
		%
		%write('1st blist12 '),write(E_1u),write('  '),write(E_1nu),nl,
		%
		plus_list(E_1u,E_1nu,E_1),
		(identical_member(0,E_1) ->
		       %
		       %nl,write('Start: delete_0'),nl,
		       %write(delete_0(E_1,BLIST,X11-X11,ZeroL,Y11-Y11,BLIST1)),nl,
		       %
	               delete_0_literal(E_1,BLIST,X11-X11,ZeroL,Y11-Y11,BLIST1),
		       %
		       %nl,write('End: delete_0'),nl,
		       %write(delete_0(E_1,BLIST,X11-X11,ZeroL,Y11-Y11,BLIST1)),nl,

		       (sort_bliteral_mode(auto) ->
			     check_select_criterion(1);
                       %true ->
		             true
		       ) ;
		%true ->    
	               ZeroL = [],
		       BLIST1 = BLIST
		),
		%
		separate_ground_nonground(BLIST1,X00-X00,GBLIST,Y00-Y00,NGBLIST),
		length(GBLIST,GBLISTL),
	        (GBLISTL > 1 ->
	              sort_bliteral_all(HEAD,GBLISTL,GBLIST,NewGBLIST) ; 
		%true ->
	              NewGBLIST = GBLIST
		),
		length(NGBLIST,NGBLISTL),
	        (NGBLISTL > 1 ->
	              sort_bliteral_all(HEAD,NGBLISTL,NGBLIST,NewNGBLIST) ; 
	              NewNGBLIST = NGBLIST
		),
		append(ZeroL,NewGBLIST,NewBLISTtmp),
		append(NewBLISTtmp,NewNGBLIST,NewBLIST).

sort_goals(GLIST,NewGLIST) :-
	sort_bliteral_mode([0,0,0,0,0,0]) ->
	      NewGLIST = GLIST ;
	%true  ->
              sort_blist12(b_u,GLIST,E_1u),
	      sort_blist12(b_nu,GLIST,E_1nu),
	      plus_list(E_1u,E_1nu,E_1),
	      (identical_member(0,E_1) ->
	             delete_0_literal(E_1,GLIST,X00-X00,ZeroL,Y00-Y00,GLIST1) ;
              %true ->
	             ZeroL = [],
		     GLIST1 = GLIST
	      ),
	      %
	      separate_ground_nonground(GLIST1,X-X,GGLIST,Y-Y,NGGLIST),
	      length(GGLIST,GGLISTL),
	      (GGLISTL > 1 ->
	             sort_bliteral_all([],GGLISTL,GGLIST,NewGGLIST) ;
	      %true ->
		     NewGGLIST = GGLIST
	      ),
	      length(NGGLIST,NGGLISTL),
	      (NGGLISTL > 1 ->
	              sort_bliteral_all([],NGGLISTL,NGGLIST,NewNGGLIST) ;
	      %true ->
	             NewNGGLIST = NGGLIST
	      ),
	      append(ZeroL,NewGGLIST,NewGLISTtmp),
	      append(NewGLISTtmp,NewNGGLIST,NewGLIST).

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% $BI>2ACM$NBg$-$$=g$KJB$S49$((B
sort_clause_all(Length,List) :-
	!,
	(sort_clause_mode(on) ->
	        List is (-1) * Length;
	sort_clause_mode(off) ->
	        List = 0 ;
	%true -> 
	        nl,write('Error:  cc1 !'),nl
	).

%%%%%%%%%%%%%%%%%%%%%%%%%%
%  Sort == unit or non_unit

retract_clause(Sort,List) :-
	retract_cl(Sort,X-X,List).

retract_cl(Sort,H-T,List) :-
	(retract(pseudo_horn_clause(Sort,Clause,B,Num)) ->
	   T=[pseudo_horn_clause(Sort,Clause,B,Num)|NewT],
	   retract_cl(Sort,H-NewT,List) ;
	%true ->
	   H-T  = List-[]
	).

%%%%%%%%%%%%%%%%%%%%%%%%%
assert_clause(_Sort,[]) :- !.

assert_clause(Sort,[pseudo_horn_clause(Sort,ClauseF,B,_Num)|R]) :-
	inc_id_number(Sort),
	call_id_number(Sort,Id),
	assertz(sorted_pseudo_horn_clause(Sort,ClauseF,Id,B)),
	assert_clause(Sort,R).

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

sort_bliteral_all(HEAD,Length,BLIST,NewBLIST) :-
	!,
	(sort_bliteral_mode([X1,X2,X3,X4,X5,X6]) ->
	        %
		sort_blist1234(BLIST,E_1nu,E_2,E_3,E_4),
		%
		plus_list(E_1nu,E_2,E_1),
		normalization_list(E_1,E_1s),
		normalization_list(E_2,E_2s),
		XXX1 is -X1, XXX2 is -X2,
		mul_list(XXX1,E_1s,E_1New),
		mul_list(XXX2,E_2s,E_2New),
		%
                normalization_list(E_3,E_3s),
		mul_list(X3,E_3s,E_3New),
	        %
                normalization_list(E_4,E_4st),
		XXX4 is -X4,
		mul_list(XXX4,E_4st,E_4New),
		%
		(X5 \== 0 ->
		       sort_blist5(BLIST,E_5),
		       normalization_list(E_5,E_5s),
		       mul_list(X5,E_5s,E_5New) ;
		 X5 == 0 ->
		       make_zero_list(Length,[],E_5New)
                ),
		(HEAD \== [] ->
		       var_list(HEAD,HEADvarlist),
		       (X6 \== 0 ->
                               sort_blist6(HEADvarlist,BLIST,[],E_6),
			       normalization_list(E_6,E_6s),
			       mul_list(X6,E_6s,E_6New) ;
                        X6 == 0 ->
			       make_zero_list(Length,[],E_6New)
		       ) ;
		%true ->
		       make_zero_list(Length,[],E_6New)
		),
		%
		plus_list(E_1New,E_2New,E_1_2New),
		plus_list(E_5New,E_6New,E_56New),
		plus_list(E_3New,E_4New,E_34New),
		%
		plus_list(E_1_2New,E_56New,E_1_256New),
		E_34New = E_3478New,

		plus_list(E_1_256New,E_3478New,E_1_2563478New),

		ass_quick_sort(E_1_2563478New,E_1_2563478New1,BLIST,NewBLIST1),
		%
                (sort_identical_value_mode(on) ->
		        identical_list(E_1_2563478New1,NewBLIST1,U1-U1,_E_1_2563478New2,U2-U2,NewBLIST2),
			identical_list_sort(NewBLIST2,NewBLIST3),
			d_flatten(NewBLIST3,NewBLIST);
		sort_identical_value_mode(off) ->   
		        NewBLIST1 = NewBLIST
		);
	sort_bliteral_mode(auto) ->       
	        sort_bliteral_auto(HEAD,Length,BLIST,Result),
		ass_quick_sort(Result,Result1,BLIST,NewBLIST1),
		(sort_identical_value_mode(on) ->
		       %
		       %nl,write('Start: identical_list'),nl,
		       %write(id_list(Result1,NewBLIST1,U3-U3,_Result2,U4-U4,NewBLIST2)),nl,
		       %
	               identical_list(Result1,NewBLIST1,U3-U3,_Result2,U4-U4,NewBLIST2),
		       %
		       %nl,write('End: identical_list'),nl,
		       %write(id_list(Result1,NewBLIST1,U3-U3,_Result2,U4-U4,NewBLIST2)),nl,
		       %
		       identical_list_sort(NewBLIST2,NewBLIST3),
		       d_flatten(NewBLIST3,NewBLIST) ;
		 sort_identical_value_mode(off) ->
		        NewBLIST1 = NewBLIST
		)
	 ).

%%%%%%%%%%%%%%%%%%%%%%%%%
large_member(N,[F|R]) :-
	(N =< F ->
	   true
	;
	   large_member(N,R)
	).

max_min([],Max,Max,Min,Min) :- !.

max_min([F|R],TMax,Max,TMin,Min) :-
	(F > TMax ->
	   TMaxNew = F
	;
	   TMaxNew = TMax
	),
	(F < TMin ->
	   TMinNew = F
	;
	   TMinNew = TMin
	),
	max_min(R,TMaxNew,Max,TMinNew,Min).

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

sort_blist1234(Blist,E_1nu,E_2,E_3,E_4) :-
	sort_blist12(b_u,Blist,E_2),
	sort_blist_nu134(Blist,E_1nu,E_3,E_444),
	plus_list(E_2,E_444,E_4).

sort_blist_nu134(Blist,E1,E3,E4) :-
	call(head1(Hlist)),
	s_blist134(Blist,Hlist,X-X,E1,Y-Y,E3,Z-Z,E4).

s_blist134([],_,X-[],X,Y-[],Y,Z-[],Z) :-!.
s_blist134([F|R],Hlist,XH-XT,E1,YH-YT,E3,ZH-ZT,E4) :-
	%
	s_blist134_chk(F,Hlist,0,E11,10000,E33,0,E44),
	%
	XT=[E11|XT2],YT=[E33|YT2],ZT=[E44|ZT2],
	s_blist134(R,Hlist,XH-XT2,E1,YH-YT2,E3,ZH-ZT2,E4).

s_blist134_chk(_,[],T1,T1,T3,T3,T4,T4) :- !.
s_blist134_chk(F,[(A,L)|R],T1,E1,T3,E3,T4,E4) :-
	(\+ \+ unify(F,A) ->
	         T11 is T1+1,
		 (T3 > L ->
		       T33 = L ;
		 %true ->
		       T33 = T3
		 ),
		 T44 is T4+ 1/(L+1) ;
	%true ->    
	         T11 = T1, T33 = T3, T44 = T4
	),
	s_blist134_chk(F,R,T11,E1,T33,E3,T44,E4).

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

sort_bliteral_auto(HEAD,Length,BLIST,Result) :-
	call(axiom_att(horn,XX)),
	%
	sort_blist5(BLIST,E_5),%%% 5$BHV$NJB$Y49$((B
	(HEAD \== [] -> %%% 6$BHV$NJB$Y49$((B
	   var_list(HEAD,HEADvarlist),
	   sort_blist6(HEADvarlist,BLIST,[],E_6) 
	;
	   make_zero_list(Length,[],E_6)
	),
	%
	sort_blist1234(BLIST,E_1nu,E_2,E_3,E_4),
	%
	plus_list(E_2,E_1nu,E_1),    %%% $B#1HV$NJB$Y49$((B

	call(head_u(Unit)),length(Unit,UnitL),
	call(head1(NonUnit)),length(NonUnit,NonUnitL),
	U_NU is UnitL / (UnitL + NonUnitL),

	max_min(E_5,-100,Max5,100,_Min5),
	max_min(E_3,-100,Max3,100,Min3),
	Sa3 is Max3 - Min3,

	normalization_list(E_1,E_1st),
	mul_list(-1,E_1st,E_1s),      %$B@55,2=$7$F$+$i(B -1 $BG\$9$k(B
	normalization_list(E_2,E_2st),%
	mul_list(-1,E_2st,E_2s),
	normalization_list(E_5,E_5s),
	normalization_list(E_6,E_6s),
	normalization_list(E_3,E_3s),
	normalization_list(E_4,E_4ts),
	mul_list(-1,E_4ts,E_4s),
	
	max_min(E_1s,-100,Max1s,100,Min1s),
	Sa1s is Max1s - Min1s,
	max_min(E_2s,-100,Max2s,100,Min2s),
	Sa2s is Max2s - Min2s,
	max_min(E_5s,-100,Max5s,100,Min5s),
	Sa5s is Max5s - Min5s,
	max_min(E_6s,-100,Max6s,100,Min6s),  
	Sa6s is Max6s - Min6s,
	max_min(E_3s,-100,Max3s,100,Min3s),
	Sa3s is Max3s - Min3s,
	                         
        call(depth_bound_measure_data(DepthCheck)),

	(large_member(2,E_3), U_NU =< 0.5, Sa3 >= 1, DepthCheck == all ->
	     Result = E_3s,check_select_criterion(3),! ;
	 %true ->   
	      !,
	      (XX == horn,identical_member(0,E_6),(\+ ground(HEAD))  ->
		     Result = E_6s,check_select_criterion(6),
		     ! ;
	      %true ->
	             !,
		     (XX == horn, identical_member(0,E_2), 
		      UnitL \== 0, U_NU > 0.3 ->
			     Result = E_2s,check_select_criterion(2),
			     ! ;
                     %true -> 
		             !,
			     (XX == horn ->
			           (Max5 >= 3 ->
				          (U_NU > 0.5 ->
					        % ass_quick_sort([Sa1s,Sa2s,Sa5s,Sa6s],[Sa|_SaR],[1,2,5,6],[TmpC|_TmpCR]),
					        ass_quick_sort([Sa1s,Sa2s,Sa5s,Sa6s],[Sa|_SaR],
						               [E_1s,E_2s,E_5s,E_6s],[RT00|_RTR]) ;

					   U_NU =< 0.5, U_NU > 0.3 ->
					        %ass_quick_sort([Sa1s,Sa2s,Sa3s,Sa5s,Sa6s],[Sa|_SaR],[1,2,3,5,6],[TmpC|_TmpCR]),
					        ass_quick_sort([Sa1s,Sa2s,Sa3s,Sa5s,Sa6s],[Sa|_SaR],
						               [E_1s,E_2s,E_3s,E_5s,E_6s],[RT00|_RTR]) ;
					   U_NU =< 0.3 ->
					        %ass_quick_sort([Sa1s,Sa3s,Sa5s,Sa6s],[Sa|_SaR],[1,3,5,6],[TmpC|_TmpCR]) 
					        ass_quick_sort([Sa1s,Sa3s,Sa5s,Sa6s],[Sa|_SaR],
 						               [E_1s,E_3s,E_5s,E_6s],[RT00|_RTR])
					  );
				    Max5 < 3 ->
				           (U_NU > 0.5 ->
					        %ass_quick_sort([Sa1s,Sa2s,Sa6s],[Sa|_SaR],[1,2,6],[TmpC|_TmpCR]),
					        ass_quick_sort([Sa1s,Sa2s,Sa6s],[Sa|_SaR],
						               [E_1s,E_2s,E_6s],[RT00|_RTR]) ;
					   U_NU =< 0.5, U_NU > 0.3 ->
					        %ass_quick_sort([Sa1s,Sa2s,Sa3s,Sa6s],[Sa|_SaR],[1,2,3,6],[TmpC|_TmpCR]),
					        ass_quick_sort([Sa1s,Sa2s,Sa3s,Sa6s],[Sa|_SaR],
						               [E_1s,E_2s,E_3s,E_6s],[RT00|_RTR]) ;
					   U_NU =< 0.3 ->
					        %ass_quick_sort([Sa1s,Sa3s,Sa6s],[Sa|_SaR],[1,3,6],[TmpC|_TmpCR]),
					        ass_quick_sort([Sa1s,Sa3s,Sa6s],[Sa|_SaR],
						               [E_1s,E_3s,E_6s],[RT00|_RTR]) 
					   )
				      );
				XX == non_horn_existed ->
                                     (Max5 >= 3 ->
				           (U_NU > 0.5 ->
					        %ass_quick_sort([Sa1s,Sa2s,Sa5s],[Sa|_SaR],[1,2,5],[TmpC|_TmpCR]),
					        ass_quick_sort([Sa1s,Sa2s,Sa5s],[Sa|_SaR],
						               [E_1s,E_2s,E_5s],[RT00|_RTR]) ;
					    U_NU =< 0.5, U_NU > 0.3 ->
					        %ass_quick_sort([Sa1s,Sa2s,Sa3s,Sa5s],[Sa|_SaR],[1,2,3,5],[TmpC|_TmpCR]) ;
					        ass_quick_sort([Sa1s,Sa2s,Sa3s,Sa5s],[Sa|_SaR],
						               [E_1s,E_2s,E_3s,E_5s],[RT00|_RTR]) ;
					    U_NU =< 0.3 ->
					       %ass_quick_sort([Sa1s,Sa3s,Sa5s],[Sa|_SaR],[1,3,5],[TmpC|_TmpCR]),
					        ass_quick_sort([Sa1s,Sa3s,Sa5s],[Sa|_SaR],
						               [E_1s,E_3s,E_5s],[RT00|_RTR]) 

					   );
				      Max5 < 3 ->
				           (U_NU > 0.5 ->
					         %ass_quick_sort([Sa1s,Sa2s],[Sa|_SaR], [1,2],[TmpC|_TmpCR]),
					         ass_quick_sort([Sa1s,Sa2s],[Sa|_SaR],
						                [E_1s,E_2s],[RT00|_RTR]) ;
					    U_NU =< 0.5 , U_NU > 0.3 ->
					         %ass_quick_sort([Sa1s,Sa2s,Sa3s],[Sa|_SaR],[1,2,3],[TmpC|_TmpCR]),
					         ass_quick_sort([Sa1s,Sa2s,Sa3s],[Sa|_SaR],
						                [E_1s,E_2s,E_3s],[RT00|_RTR]) ;
					    U_NU =< 0.3 ->
					         %ass_quick_sort([Sa1s,Sa3s],[Sa|_SaR],[1,3],[TmpC|_TmpCR]), 
					         ass_quick_sort([Sa1s,Sa3s],[Sa|_SaR],
						                [E_1s,E_3s],[RT00|_RTR]) 
					   )
				     )
			     ),

%%% ass_quick_sort([Sa1,Sa2,Sa5,Sa6,Sa4],[Sa|_SaR],[E_1,E_2,E_5,E_6],[TmpC|_TmpCR])
%%% Sa $B$K:GBg$N:9$,F~$j!$JB$S49$($N%b!<%I$NA*Br$r$9$k(B 
	
 (Sa >= 0.2 -> 
    	    Result = RT00,check_select_criterion(TmpC) ;
  XX == horn ->          %%% $B$=$NB>$N>l9g(B (S7)
       	       (sort_clause_mode(on),sort_identical_value_mode(on) -> 
       		    mul_list(4,E_3s,E_3x4),
       		    plus_list(E_2s,E_6s,E_2E_6),	
       		    plus_list(E_2E_6,E_3x4,Result) ;
       		sort_clause_mode(off),sort_identical_value_mode(on) ->
       		    mul_list(4,E_3s,E_3x4),
       		    plus_list(E_2s,E_6s,E_2E_6),	
       		    plus_list(E_2E_6,E_3x4,Result) ;     		   
       		sort_clause_mode(on),sort_identical_value_mode(off) ->
       		    mul_list(3,E_2s,E_2x3),
       		    mul_list(4,E_3s,E_3x4),
       		    mul_list(3,E_4s,E_4x3),
       		    plus_list(E_2x3,E_3x4,E_2E_3),	
       		    plus_list(E_2E_3,E_4x3,Result) ;
       		sort_clause_mode(off),sort_identical_value_mode(off) ->
       		    mul_list(5,E_3s,E_3x5),
       		    plus_list(E_2s,E_6s,E_2E_6),	
       		    plus_list(E_2E_6,E_3x5,Result);
                %true ->
       		    mul_list(5,E_3s,E_3x5),
       		    plus_list(E_2s,E_6s,E_2E_6),
       		    plus_list(E_2E_6,E_3x5,Result)
       		   
	       ),
	       (value_check(Result) ->
       		     true ;
               %true ->
		      check_select_criterion(d)
	       ) ;
   XX == non_horn_existed ->
       	     (sort_clause_mode(on),sort_identical_value_mode(on) ->
       		   mul_list(4,E_3s,E_3x4),
       		   mul_list(2,E_4s,E_4x2),
       		   plus_list(E_2s,E_5s,E_2E_5),
       		   plus_list(E_3x4,E_4x2,E_3E_4),
       		   plus_list(E_2E_5,E_3E_4,Result);
       	      sort_clause_mode(off),sort_identical_value_mode(on) ->
       		   mul_list(4,E_3s,E_3x4),
       		   mul_list(2,E_4s,E_4x2),
       		   plus_list(E_2s,E_5s,E_2E_5),
       		   plus_list(E_3x4,E_4x2,E_3E_4),
       		   plus_list(E_2E_5,E_3E_4,Result) ;
       	      sort_clause_mode(on),sort_identical_value_mode(off) ->
       		   mul_list(5,E_1s,E_1x5),
       		   mul_list(2,E_5s,E_5x2),
       		   mul_list(2,E_3s,E_3x2),
       		   plus_list(E_1x5,E_5x2,E_1E_5),
       		   plus_list(E_2s,E_3x2,E_2E_3),
       		   plus_list(E_1E_5,E_2E_3,Result) ;
       	      sort_clause_mode(off),sort_identical_value_mode(off) ->
       		   mul_list(4,E_3s,E_3x4),
       		   mul_list(2,E_4s,E_4x2),
       		   plus_list(E_2s,E_5s,E_2E_5),
       		   plus_list(E_3x4,E_4x2,E_3E_4),
       		   plus_list(E_2E_5,E_3E_4,Result) ;
             %true ->
       		   mul_list(5,E_1s,E_1x5),
       		   plus_list(E_1x5,E_2s,E_1E_2),
       		   mul_list(2,E_5s,E_5x2),        
       		   plus_list(E_1E_2,E_5x2,Result)
	     ),
	     (value_check(Result) ->
       		   true ;
       	     %true ->;
       		   check_select_criterion(d)
	     )
 )
 )  
 )
 ).
	
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
var_list1(Term,VList) :-
        var_list1(Term,[],VList).

var_list1(Term,VIn,VIn) :-
        atomic(Term),!.

var_list1(Term,VIn,VOut) :-
        var(Term), !,
        VOut = [Term|VIn].

var_list1(Term,VIn,VOut) :-
        functor(Term,_,A),
        var_list1_args(A,Term,VIn,VOut).

var_list1_args(0,_,VIn,VIn) :- !.
var_list1_args(A,Term,VIn,VOut) :- 
        arg(A,Term,Arg),var_list1(Arg,VIn,VTT),
        A1 is A-1, var_list1_args(A1,Term,VTT,VOut).



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

normalization_list(L1,Last) :-
	list_add(L1,0,Wa),
	(Wa \== 0 ->
	   Wa1 is 1 / Wa ;
	   Wa1 is 0
	),
	mul_list(Wa1,L1,Last).

%%%%%%%%%%%%%%%%%%%%%%%%%%

delete_0_literal([],[],H1-[],H1,H2-[],H2) :- !.
delete_0_literal([F|R],[BF|BR],H1-T1,ZeroL,H2-T2,BLIST1) :-
	(F == 0 ->
	    T1=[BF|NewT1], NewT2=T2;
	%true ->
	    NewT1=T1,T2=[BF|NewT2]
	),
	delete_0_literal(R,BR,H1-NewT1,ZeroL,H2-NewT2,BLIST1).

%%%%%%%%%%%%%%%%%%%%%%%%%%

identical_list([],[],H1-[],H1,H2-[],H2) :- !.
identical_list([F1|R1],[BF|BR],H1-T1,E,H2-T2,L) :-
	member1(F1,R1,A1-A1,L1,BR,B1-B1,L2),%%L2$B$K$O(BF1$B$HF1$8I>2ACM$N%j%F%i%k(B
	(L2 == [] ->
	   NewR1 = R1, T1 =[[F1]|NewT1],
	   NewBR = BR, T2 =[[BF]|NewT2] ;
	%true ->
	   T1=[[F1|L1]|NewT1], T2=[[BF|L2]|NewT2],
	   delete_list(L1,R1,NewR1), 
	   delete_list(L2,BR,NewBR)
	),
	identical_list(NewR1,NewBR,H1-NewT1,E,H2-NewT2,L).

%%%%%%%%%%%%%%%%%%%%%%%%%%

member1(_,[],H1-[],H1,[],H2-[],H2) :- !.
member1(F,[F1|R1],H1-T1,L1,[BF|BR],H2-T2,L2) :-
	(F == F1 ->
	   T1 = [F|NewT1], T2 = [BF|NewT2] ;
	%true ->
	   NewT1 = T1, NewT2=T2
	),
	member1(F,R1,H1-NewT1,L1,BR,H2-NewT2,L2).

%%%%%%%%%%%%%%%%%%%%%%%%%%%	   
d_flatten(X,Y) :- d_fl(X, Y-[]).

d_fl([], U-U) :- !.
d_fl([X|Y], U-V) :- !, d_fl(X, U-UV), d_fl(Y, UV-V).
d_fl(X,[X|V]-V).

%%%%%%%%%%%%%%%%%%%%%%%%%%%
identical_list_sort([],[]) :- !.

identical_list_sort([F|R],[NewF|NewR]) :-
	length(F,LengthF),
	(LengthF > 1 -> 
	   sort(F,NewF)
	;
	   NewF = F
	),
	identical_list_sort(R,NewR).

%%%%%%%%%%%%%%%%%%%%%%%%%%%

write_body([F|R]) :-
	write(F),
	(R == [] -> 
	      write('.') ;
	%true ->
	      write(','), write_body(R)
	).
	
%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 1/18 
% select_criterion(N,X)
% N $B$OJB$S49$(4p=`(B  X$B$O!$A*Br$7$?2s?t(B

check_select_criterion(C) :-
	write_sorted_literal_mode(on) ->
	     	retract(select_criterion(C,N)),
		NN is N+1,
		assert(select_criterion(C,NN));
	write_sorted_literal_mode(off) ->
	        true ;
        %true ->
	        nl,write('Error: write_sorted_literal_mode !'),nl.


%% $B$9$Y$FF1$8$+$I$&$+$N%A%'%C%/(B
value_check([F,F1|R]) :-
      (F == F1 ->
           value_check([F1|R]) ;
      %true ->	   
           !,fail
      ).
value_check([_F]) :- !.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
quick_sort(I,X) :- quick_sort(I,X,[]),!.

quick_sort([],X,X) .
quick_sort([pseudo_horn_clause(_SortK,_ClauseK,_BK,F)|R],X,M) :- 
       sss_split(F,R,L,G),
       quick_sort(L,X,[pseudo_horn_clause(_SortK,_ClauseK,_BK,F)|U]),quick_sort(G,U,M).

sss_split(_,[],[],[]) .
sss_split(N,[pseudo_horn_clause(_SortK,_ClauseK,_BK,F)|R],[pseudo_horn_clause(_SortK,_ClauseK,_BK,F)|L1],G) :- 
	N < F, sss_split(N,R,L1,G).
sss_split(N,[pseudo_horn_clause(_SortK,_ClauseK,_BK,F)|R],L,[pseudo_horn_clause(_SortK,_ClauseK,_BK,F)|G1]) :- 
	N >= F, sss_split(N,R,L,G1).
