/**************************************************************/
/* ********************************************************** */
/* *                                                        * */
/* *              TOP MODULE OF SPASS                       * */
/* *                                                        * */
/* *  $Module:   TOP                                        * */ 
/* *                                                        * */
/* *                                                        * */
/* $Revision: 0.58 $                                        * */
/* $State: Exp $                                            * */
/* $Date: 1997/06/20 09:12:34 $                             * */
/* $Author: weidenb $                                       * */
/* *                                                        * */
/* *             Contact:                                   * */
/* *             Christoph Weidenbach                       * */
/* *             MPI fuer Informatik                        * */
/* *             Im Stadtwald                               * */
/* *             66123 Saarbruecken                         * */
/* *             Email: weidenb@mpi-sb.mpg.de               * */
/* *             Germany                                    * */
/* *                                                        * */
/* ********************************************************** */
/**************************************************************/


/* $RCSfile: dfg2otter.c,v $ */

/*** MAINLOOP *************************************************/


/**************************************************************/
/* Includes                                                   */
/**************************************************************/

#include "dfgparser.h"


/**************************************************************/
/* Main Function                                              */
/**************************************************************/

void main(int argc, char* argv[])
{
  LIST    Clauses;
  FILE    *Output;
  char    *Filename;

  memory_Init(-1);
  symbol_Init(TRUE);
  stack_Init();
  term_Init();
  flag_Init();
  fol_Init(TRUE);
  clause_Init();

  if (argc < 3) {
    printf("\n\t          dfg2otter Version 0.55");
    printf("\n\t       Usage: dfg2otter <input-file> <output-fule>\n\n");
    return;
  }

  Clauses = dfg_ClauseParser(*++argv);

  Filename = *++argv;
  Output = misc_OpenFile(Filename,"w");
  clause_FPrintCnfOtter(Output, Clauses);
  misc_CloseFile(Output,Filename);


  list_DeleteWithElement(Clauses,clause_Delete);
  /*symbol_Dump();*/
  fol_Free();
  symbol_FreeAllSymbols();
  dfg_Free();
#ifdef DEBUG
  memory_Print();
#endif
}
