/**************************************************************/
/* ********************************************************** */
/* *                                                        * */
/* *               INPUT OF SPASS CLAUSES                   * */
/* *                                                        * */
/* *  $Module:   DFGPARSER                                  * */ 
/* *                                                        * */
/* *                                                        * */
/* $Revision: 0.51 $                                        * */
/* $State: Exp $                                            * */
/* $Date: 1997/05/26 12:33:47 $                             * */
/* $Author: weidenb $                                       * */
/* *                                                        * */
/* *             Contact:                                   * */
/* *             Christoph Weidenbach                       * */
/* *             MPI fuer Informatik                        * */
/* *             Im Stadtwald                               * */
/* *             66123 Saarbruecken                         * */
/* *             Email: weidenb@mpi-sb.mpg.de               * */
/* *             Germany                                    * */
/* *                                                        * */
/* ********************************************************** */
/**************************************************************/


/* $RCSfile: dfgparser.h,v $ */

#ifndef _DFGPARSER_
#define _DFGPARSER_

/**************************************************************/
/* Includes                                                   */
/**************************************************************/

#include "dfgscanner.h"
#include "term.h"
#include "clause.h"
#include "foldfg.h"
#include "flags.h"

/**************************************************************/
/* Type Definitions                                           */
/**************************************************************/

typedef enum { SATISFIABLE, UNSATISFIABLE, UNKNOWN } DFG_STATE;

/**************************************************************/
/* Prototypes                                                 */
/**************************************************************/

void dfg_Free(void);

void dfg_Parser(char*, LIST*, LIST*);
LIST dfg_ClauseParser(char*);
LIST dfg_ProofParser(char*);
LIST dfg_DFGParser(char*, LIST*, LIST*);

/* Functions for accessing desription information */
const char* dfg_ProblemName(void);
const char* dfg_ProblemAuthor(void);
const char* dfg_ProblemVersion(void);
const char* dfg_ProblemLogic(void);
DFG_STATE   dfg_ProblemStatus(void);
const char* dfg_ProblemStatusString(void);
const char* dfg_ProblemDescription(void);
const char* dfg_ProblemDate(void);
NAT         dfg_DescriptionLength(void);

void  dfg_FPrintDescription(FILE*);
char* dfg_SPrintDescription(char*);

/**************************************************************/
/* Inline Functions                                           */
/**************************************************************/

static __inline__ void dfg_PrintDescription(void) {
  dfg_FPrintDescription(stdout);
}

#endif
