/**************************************************************/
/* ********************************************************** */
/* *                                                        * */
/* *                 PROOF DOCUMENTATION                    * */
/* *                                                        * */
/* *  $Module:   DOCPROOF                                   * */ 
/* *                                                        * */
/* *                                                        * */
/* $Revision: 0.47 $                                        * */
/* $State: Exp $                                            * */
/* $Date: 1997/06/12 12:08:45 $                             * */
/* $Author: weidenb $                                       * */
/* *                                                        * */
/* *             Contact:                                   * */
/* *             Christoph Weidenbach                       * */
/* *             MPI fuer Informatik                        * */
/* *             Im Stadtwald                               * */
/* *             66123 Saarbruecken                         * */
/* *             Email: weidenb@mpi-sb.mpg.de               * */
/* *             Germany                                    * */
/* *                                                        * */
/* ********************************************************** */
/**************************************************************/


/* $RCSfile: doc-proof.h,v $ */

#ifndef _DOC_PROOF_
#define _DOC_PROOF_

/**************************************************************/
/* Includes                                                   */
/**************************************************************/

#include "clause.h"
#include "st.h"
#include "sharing.h"
#include "search.h"

/**************************************************************/
/* Data Structures and Constants                              */
/**************************************************************/

extern int dp_DEPTH;


/**************************************************************/
/* Macros                                                     */
/**************************************************************/ 

static __inline__ int dp_ProofDepth(void)
{
  return dp_DEPTH;
}

static __inline__ void dp_SetProofDepth(int Depth)
{
  dp_DEPTH = Depth;
}


/**************************************************************/
/* Functions                                                  */
/**************************************************************/        

void dp_Init(void);
void dp_PrintProof(PROOFSEARCH, LIST, char*);

#endif
