/* Scanner for Dedam */

%{

int yywrap()
{
return 1;
}

%}

DIGIT      [0-9]
UPPER      [A-Z_]
LOWER      [a-z]
LETTER     [A-Za-z_]
%%

\%([^\n])*\n          { /* comment */ }

"("|")"|","|"."   { return(*yytext); }

"--"          { return(NOT); }
"++"          { return(POS); }

"Equal"  { return(EQ); }
"Eq"     { return(EQ); }
"="      { return(EQ); }

"+"  { strcpy(yylval.ident,yytext); return(SYMBOL); }
"-"  { strcpy(yylval.ident,yytext); return(SYMBOL); }
"*"  { strcpy(yylval.ident,yytext); return(SYMBOL); }
"/"  { strcpy(yylval.ident,yytext); return(SYMBOL); }

{DIGIT}|{LOWER}({LETTER}|{DIGIT})*  { strcpy(yylval.ident, yytext); return(SYMBOL); }

{UPPER}({LETTER}|{DIGIT})*  { strcpy(yylval.ident, yytext); return(VAR); }

[ \t]+        { /* jump over blanks */ }
\n            { /* ignore newlines */ }
.             { fprintf(stderr, 
               "Lexical error: symbol '%c' ignored!\n", *yytext); }
%%

