%{
#include "declarations.h"
#include "heap.h"


typedef struct
  {
  int        numargs;
  _HeapAddr  args[50];
  } _AtribListTerms;

_Ident       VarTable[200];
int          numvars;


short int VarTableCheckVar(_Ident name)
Proc
Var
  short int i;
EndVar
  i=0;
  While i<numvars Do
    If strcmp( VarTable[i], name)==0 Then
      Return(i);
    Else
      i++;
    EndIf
  EndWhile
  strcpy(VarTable[i], name);
  numvars++;
  Return(i);
EndProc



%}

%union{ 
        _Ident           ident;
        _HeapAddr        heapaddr;
        _AtribListTerms  atriblist;
      }

%token NOT POS EQ
%token <ident>     SYMBOL
%token <ident>     VAR

%type <heapaddr>     term
%type <heapaddr>     equation
%type <atriblist>    listterms

%start lterms

%%

lterms
  :
    POS
        { numvars = 0; }
    equation
        { terms[numterms++]=$3; }
    '.'
    lterms
  |
        { numvars = 0; }
    equation
        { terms[numterms++]=$2; }
    '.'
    lterms
  |
    NOT
        { numvars = 0; }
    equation
        { teorema=$3; }
    '.'
    lterms
  |
  ;


term
  : SYMBOL
        { $$ = HeapCreateStruct( STCheckSymbol($1,0) ); }
  |
    VAR
        { $$ = VBHeapAddr( 0, VarTableCheckVar($1)); }
  |
    SYMBOL
    '('    
    listterms
    ')'
        { int i; 
          $$ = HeapCreateStruct( STCheckSymbol($1,($3.numargs)) );
          For i=1;i<=($3.numargs);i++ Do
            HeapSetAddr( HeapIthArg($$,i), ($3.args)[i]);
          EndFor
        }
  |
    '('
    term
    SYMBOL
    term
    ')'
        {
          $$ = HeapCreateStruct( STCheckSymbol($3,2) );
          HeapSetAddr( HeapIthArg($$,1),$2);
          HeapSetAddr( HeapIthArg($$,2),$4);
        }
  ;

equation
  : 
    EQ
    '('    
    listterms
    ')'
        { int i;
          $$ = HeapCreateStruct( STCheckSymbol("Eq",($3.numargs)) );
          For i=1;i<=($3.numargs);i++ Do
            HeapSetAddr( HeapIthArg($$,i), ($3.args)[i]);
          EndFor
        }
  |
    '('
    term
    EQ
    term
    ')'
        {
          $$ = HeapCreateStruct( STCheckSymbol("Eq",2) );
          HeapSetAddr( HeapIthArg($$,1),$2);
          HeapSetAddr( HeapIthArg($$,2),$4);
        }
  |
    term
    EQ
    term
        {
          $$ = HeapCreateStruct( STCheckSymbol("Eq",2) );
          HeapSetAddr( HeapIthArg($$,1),$1);
          HeapSetAddr( HeapIthArg($$,2),$3);
        }
  ;


listterms
  : listterms
    ','
    term
        { ($1.numargs)++; ($1.args)[$1.numargs]=$3; $$ = $1; }
  |
    term
        { $$.numargs=1; ($$.args)[1]=$1; }
  ;

%%
#include "lex.yy.c"
void yyerror(s) char *s;
{
  fprintf(stderr, "%s\n", s);
}


