/**************************************************************/
/* ********************************************************** */
/* *                                                        * */
/* *                MISCELLANEOUS                           * */
/* *                                                        * */
/* *  $Module:   MISC                                       * */ 
/* *                                                        * */
/* *                                                        * */
/* $Revision: 0.45 $                                        * */
/* $State: Exp $                                            * */
/* $Date: 1997/06/20 09:17:39 $                             * */
/* $Author: weidenb $                                       * */
/* *                                                        * */
/* *             Contact:                                   * */
/* *             Christoph Weidenbach                       * */
/* *             MPI fuer Informatik                        * */
/* *             Im Stadtwald                               * */
/* *             66123 Saarbruecken                         * */
/* *             Email: weidenb@mpi-sb.mpg.de               * */
/* *             Germany                                    * */
/* *                                                        * */
/* ********************************************************** */
/**************************************************************/


/* $RCSfile: misc.c,v $ */

/**************************************************************/
/* Includes                                                   */
/**************************************************************/

#include "misc.h"


/**************************************************************/
/* Functions                                                  */
/**************************************************************/

void misc_DumpCoreOut(const char* String)
/**************************************************************
  INPUT:   A  string.
  RETURNS: Nothing.
  EFFECT:  Prints <String> and then dumps a core.
***************************************************************/
{
  printf("\n %s \n", String);
  misc_DumpCore();
}


BOOL misc_StringIsNumber(const char* String)
/**************************************************************
  INPUT:   A string.
  RETURNS: TRUE iff the string solely consists of number characters.
  EFFECT:  None.
***************************************************************/
{
  int i;
  
  if (String == NULL || String[0] == '\0')
    return FALSE;
  
  i = 0;

  while (String[i] != '\0')
    if (String[i] >= '0' && String[i] <= '9')
      i++;
    else
      return FALSE;

  return TRUE;  
}


int misc_ReturnValue(void)
{
  return 0;
}


int misc_Max(int a, int b)
{
  if (a > b)
    return a;
  else
    return b;
}

FILE* misc_OpenFile(char* Name, char* Mode)
{
  FILE* File;

  File = fopen(Name,Mode);

  if (File == (FILE*)NULL) {
    printf("\n\tError in opening file %s for %s !\n\n", Name, 
	   (strcmp(Mode,"r") == 0 ? "reading" : (strcmp(Mode,"w") == 0 ? "writing" : "i/o operations")));
    misc_Error();
  }  

  return File;
}

void misc_CloseFile(FILE* File, char* Name)
{
  int Result;

  Result = fclose(File);

  if (Result != 0) {
    printf("\n\tError in closing file %s !\n\n", Name);
    misc_Error();
  }  
}



