/**************************************************************/
/* ********************************************************** */
/* *                                                        * */
/* *                MISCELLANEOUS                           * */
/* *                                                        * */
/* *  $Module:   MISC                                       * */ 
/* *                                                        * */
/* *                                                        * */
/* $Revision: 0.48 $                                        * */
/* $State: Exp $                                            * */
/* $Date: 1997/06/20 09:17:39 $                             * */
/* $Author: weidenb $                                       * */
/* *                                                        * */
/* *             Contact:                                   * */
/* *             Christoph Weidenbach                       * */
/* *             MPI fuer Informatik                        * */
/* *             Im Stadtwald                               * */
/* *             66123 Saarbruecken                         * */
/* *             Email: weidenb@mpi-sb.mpg.de               * */
/* *             Germany                                    * */
/* *                                                        * */
/* ********************************************************** */
/**************************************************************/


/* $RCSfile: misc.h,v $ */

#ifndef _MISC_
#define _MISC_

/**************************************************************/
/* Includes                                                   */
/**************************************************************/

#include <limits.h>
#include "define.h"


/**************************************************************/
/* More basic types and macros                                */
/**************************************************************/

#if defined(TRUE)
#undef TRUE
#endif

#if defined(FALSE)
#undef FALSE
#endif

typedef enum { FALSE=0, TRUE=1 } BOOL;


typedef void*           POINTER;
typedef unsigned int    NAT;

/* Limits for EARL data types */
static const NAT NAT_MAX = UINT_MAX;


/**************************************************************/
/* Inline Functions                                           */
/**************************************************************/

static __inline__ void misc_Error(void)
{
  fflush(stdout);
  exit(3);
}


static __inline__ void misc_DumpCore(void)
{
  abort();
}


static __inline__ void misc_PrintChar(NAT Number, char Character)
{
  NAT Counter;
  for (Counter = 1; Counter <= Number; Counter++)
    printf("%c", Character);
}

static __inline__ BOOL misc_SmallerThan(int i, int j)
{
  return (i < j);
}


/**************************************************************/
/* Functions                                                  */
/**************************************************************/

void  misc_DumpCoreOut(const char*);
BOOL  misc_StringIsNumber(const char*);
int   misc_ReturnValue(void);
int   misc_Max(int, int);

FILE* misc_OpenFile(char* , char*);
void  misc_CloseFile(FILE*, char*);


#endif
