/**************************************************************/
/* ********************************************************** */
/* *                                                        * */
/* *             SPASS OPTIONS HANDLING                     * */
/* *                                                        * */
/* *  $Module:   OPTIONS                                    * */ 
/* *                                                        * */
/* *                                                        * */
/* $Revision: 0.61 $                                        * */
/* $State: Exp $                                            * */
/* $Date:                              * */
/* $Author: weidenb $                                       * */
/* *                                                        * */
/* *             Contact:                                   * */
/* *             Christoph Weidenbach                       * */
/* *             MPI fuer Informatik                        * */
/* *             Im Stadtwald                               * */
/* *             66123 Saarbruecken                         * */
/* *             Email: weidenb@mpi-sb.mpg.de               * */
/* *             Germany                                    * */
/* *                                                        * */
/* ********************************************************** */
/**************************************************************/


/* $RCSfile: options.h,v $ */


#ifndef _OPTIONS_
#define _OPTIONS_

#include <string.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>

#include "flags.h"
#include "list.h"


/**************************************************************/
/* Data Structures and Constants                              */
/**************************************************************/

/* from the getopt.h file */
struct OPTION
{
  char *name;

  /* has_arg can't be an enum because some compilers complain about
     type mismatches in all the code that assumes it is an int.  */
  int has_arg;
  int *flag;
  int val;
};

typedef enum {opts_RemoveFile, opts_MaxOpts} OPTS_OPTS;


/**************************************************************/
/* Macros                                                     */
/**************************************************************/

/* double hyphen: marks end of all options */
#define opts_ENDMARKER "--" 

/* default value of options with optional arguments */
#define opts_DEFAULTOPTARG  "1"

/* Name for the value of the `has_arg' field of `struct option'.  */

#define	opts_NoArgument		0
#define opts_RequiredArgument	1
#define opts_OptionalArgument	2

/**************************************************************/
/* Functions                                                  */
/**************************************************************/

void opts_Init();
void opts_Free();
BOOL opts_Read(int argc, char* argv[]);
void opts_Transfer();
void opts_PrintNames();
int  opts_Indicator();
BOOL opts_IsSet(OPTS_OPTS);

#endif



