/**************************************************************/
/* ********************************************************** */
/* *                                                        * */
/* *                RESOLUTION                              * */
/* *                                                        * */
/* *  $Module:   RESOLUTION                                 * */ 
/* *                                                        * */
/* *                                                        * */
/* $Revision: 0.44 $                                        * */
/* $State: Exp $                                            * */
/* $Date: 1996/09/16 13:42:19 $                             * */
/* $Author: weidenb $                                       * */
/* *                                                        * */
/* *             Contact:                                   * */
/* *             Christoph Weidenbach                       * */
/* *             MPI fuer Informatik                        * */
/* *             Im Stadtwald                               * */
/* *             66123 Saarbruecken                         * */
/* *             Email: weidenb@mpi-sb.mpg.de               * */
/* *             Germany                                    * */
/* *                                                        * */
/* ********************************************************** */
/**************************************************************/

/* $RCSfile: resolution.h,v $ */

#ifndef _RESOLUTION_
#define _RESOLUTION_

/**************************************************************/
/* Includes                                                   */
/**************************************************************/

#include "misc.h"
#include "unify.h"
#include "symbol.h"
#include "foldfg.h"
#include "st.h"
#include "subsumption.h"
#include "condensing.h"


/**************************************************************/
/* Functions                                                  */
/**************************************************************/

void    res_Res(LIST*, int);
LIST    res_ResSubs(LIST, LIST, int);
LIST    res_ResSubsIndex(LIST, LIST, int, int, BOOL*);
LIST    res_BuildAllResolvents(CLAUSE, st_INDEX);
void    res_InsertClauseIndex(CLAUSE, st_INDEX);
void    res_DeleteClauseIndex(CLAUSE, st_INDEX);
void    res_ClauseTermNormalize(CLAUSE);
SYMBOL  res_GetMaxVarTerm(TERM);
SYMBOL  res_GetMaxVarClause(CLAUSE);
CLAUSE  res_SelectLightestClause(LIST);
CLAUSE  res_CondenseClause(CLAUSE, LIST);
BOOL    res_BackSubWithLength(CLAUSE, st_INDEX);
BOOL    res_HasTautology(CLAUSE);


#endif
