/**************************************************************/
/* ********************************************************** */
/* *                                                        * */
/* *                INFERENCE RULES                         * */
/* *                                                        * */
/* *  $Module:   INFRULES                                   * */ 
/* *                                                        * */
/* *                                                        * */
/* $Revision: 0.48 $                                        * */
/* $State: Exp $                                            * */
/* $Date: 1997/07/02 14:25:21 $                             * */
/* $Author: weidenb $                                       * */
/* *                                                        * */
/* *             Contact:                                   * */
/* *             Christoph Weidenbach                       * */
/* *             MPI fuer Informatik                        * */
/* *             Im Stadtwald                               * */
/* *             66123 Saarbruecken                         * */
/* *             Email: weidenb@mpi-sb.mpg.de               * */
/* *             Germany                                    * */
/* *                                                        * */
/* ********************************************************** */
/**************************************************************/


/* $RCSfile: rules-inf.h,v $ */

#ifndef _INFRULES_
#define _INFRULES_

/**************************************************************/
/* Includes                                                   */
/**************************************************************/

#include "search.h"
#include "rules-split.h"
#include "rules-sort.h"
#include "subst.h"
#include "unify.h"
#include "st.h"

/**************************************************************/
/* Functions                                                  */
/**************************************************************/        

LIST inf_DerivableClauses(PROOFSEARCH, CLAUSE);

LIST inf_EqualityResolution(CLAUSE);
LIST inf_EqualityFactoring(CLAUSE);

LIST inf_MergingParamodulation(CLAUSE, SHARED_INDEX);

LIST inf_SuperpositionLeft(CLAUSE, SHARED_INDEX);
LIST inf_SuperpositionRight(CLAUSE, SHARED_INDEX);
LIST inf_BoundedDepthUnitResolution(CLAUSE, SHARED_INDEX);
LIST inf_UnitResolution(CLAUSE, SHARED_INDEX);
LIST inf_GeneralResolution(CLAUSE, SHARED_INDEX);

LIST inf_GeneralFactoring(CLAUSE);

#endif

