/**************************************************************/
/* ********************************************************** */
/* *                                                        * */
/* *                REDUCTION RULES                         * */
/* *                                                        * */
/* *  $Module:   REDRULES                                   * */ 
/* *                                                        * */
/* *                                                        * */
/* $Revision: 0.50 $                                        * */
/* $State: Exp $                                            * */
/* $Date: 1997/07/02 14:31:51 $                             * */
/* $Author: weidenb $                                         * */
/* *                                                        * */
/* *             Contact:                                   * */
/* *             Christoph Weidenbach                       * */
/* *             MPI fuer Informatik                        * */
/* *             Im Stadtwald                               * */
/* *             66123 Saarbruecken                         * */
/* *             Email: weidenb@mpi-sb.mpg.de               * */
/* *             Germany                                    * */
/* *                                                        * */
/* ********************************************************** */
/**************************************************************/


/* $RCSfile: rules-red.h,v $ */

#ifndef _REDRULES_
#define _REDRULES_

#include "sort.h"
#include "subsumption.h"
#include "condensing.h"
#include "rules-split.h"
#include "rules-inf.h"
#include "doc-proof.h"

/**************************************************************/
/* Constants                                                  */
/**************************************************************/

extern const NAT red_USABLE;
extern const NAT red_WORKEDOFF;
extern const NAT red_ALL;


/**************************************************************/
/* Functions                                                  */
/**************************************************************/

static __inline__ BOOL red_WorkedOffMode(NAT Mode)
{
  return (Mode == red_WORKEDOFF || Mode == red_ALL);
}

static __inline__ BOOL red_OnlyWorkedOffMode(NAT Mode)
{
  return (Mode == red_WORKEDOFF);
}

static __inline__ BOOL red_UsableMode(NAT Mode)
{
  return (Mode == red_USABLE || Mode == red_ALL);
}

static __inline__ BOOL red_AllMode(NAT Mode)
{
  return (Mode == red_ALL);
}


void   red_Init();        


LIST   red_ReductionOnDerivedClauses(PROOFSEARCH,LIST,BOOL, NAT);
LIST   red_CompleteReductionOnDerivedClauses(PROOFSEARCH, LIST, BOOL, NAT *);
CLAUSE red_ReductionOnDerivedClause(PROOFSEARCH , CLAUSE , BOOL , NAT);
CLAUSE red_CompleteReductionOnDerivedClause(PROOFSEARCH , CLAUSE , BOOL);
LIST   red_BackReduction(PROOFSEARCH, CLAUSE, BOOL, NAT);
LIST   red_SatUnit(PROOFSEARCH, LIST, BOOL);
LIST   red_SatInput(PROOFSEARCH, LIST, BOOL, NAT *);
BOOL   red_ClauseDeletion(SORTTHEORY, CLAUSE);


#endif
