/**************************************************************/
/* ********************************************************** */
/* *                                                        * */
/* *               SPLITTING OF CLAUSES                     * */
/* *                                                        * */
/* *  $Module:   SPLIT                                      * */ 
/* *                                                        * */
/* *                                                        * */
/* $Revision: 0.49 $                                        * */
/* $State: Exp $                                            * */
/* $Date: 1997/06/12 12:08:45 $                             * */
/* $Author: weidenb $                                       * */
/* *                                                        * */
/* *             Contact:                                   * */
/* *             Christoph Weidenbach                       * */
/* *             MPI fuer Informatik                        * */
/* *             Im Stadtwald                               * */
/* *             66123 Saarbruecken                         * */
/* *             Email: weidenb@mpi-sb.mpg.de               * */
/* *             Germany                                    * */
/* *                                                        * */
/* ********************************************************** */
/**************************************************************/


/* $RCSfile: rules-split.h,v $ */

#ifndef _RULES_SPLIT_
#define _RULES_SPLIT_

/**************************************************************/
/* Includes                                                   */
/**************************************************************/

#include "clause.h"
#include "st.h"
#include "rules-red.h"
#include "search.h"

/**************************************************************/
/* Data Structures and Constants                              */
/**************************************************************/

/*extern int  split_VALID_LEVEL_COUNTER, split_COUNTER;
extern LIST split_STACK; */



/**************************************************************/
/* Function Prototypes                                        */
/**************************************************************/        

CLAUSE split_DoSplitting(PROOFSEARCH, CLAUSE, LIST);
LIST   split_Backtrack(PROOFSEARCH, CLAUSE);
LIST   split_DeleteInvalidClausesFromList(PROOFSEARCH, int, LIST);
void   split_KeepClauseAtLevel(PROOFSEARCH, CLAUSE, int);
void   split_DeleteClauseAtLevel(PROOFSEARCH, CLAUSE, int);
LIST   split_ExtractEmptyClauses(LIST, LIST*);
CLAUSE split_SmallestSplitLevelClause(LIST);
LIST   split_GetSplitLiterals(PROOFSEARCH, CLAUSE);


/**************************************************************/
/* Inline Functions                                           */
/**************************************************************/

static __inline__ int split_TopLevel(void)
{
  return 0;
}

static __inline__ int split_Level(SPLIT Sp)
{
  return Sp->splitlevel;
}

static __inline__ BOOL split_IsDirty(SPLIT Sp)
{
  return Sp->dirty == TRUE;
}

static __inline__ void split_CleanedUp(SPLIT Sp)
{
  Sp->dirty = FALSE;
}

static __inline__ LIST split_BlockedClauses(SPLIT Sp)
{
  return Sp->blockedClauses;
}

static __inline__ LIST split_DeletedClauses(SPLIT Sp)
{
  return Sp->deletedClauses;
}

static __inline__ void split_SetBlockedClauses(SPLIT Sp, LIST L)
{
  Sp->blockedClauses = L;
}

static __inline__ void split_AddBlockedClause(SPLIT Sp, CLAUSE C)
{
  Sp->blockedClauses = list_Cons(C, Sp->blockedClauses);
}

static __inline__ void split_SetDeletedClauses(SPLIT Sp, LIST L)
{
  Sp->deletedClauses = L;
}

static __inline__ void split_FreeOneNode(SPLIT Sp)
{
  memory_Free(Sp, sizeof(SPLIT_NODE));
}

static __inline__ BOOL split_IsClauseValid(CLAUSE C, int L)
{
  return clause_SplitLevel(C) <= L;
}

static __inline__ void split_KeepCopyAtLevel(PROOFSEARCH PS, CLAUSE C, int L)
{
  CLAUSE Copy;
  Copy = clause_Copy(C);
  clause_OrientAndReInit(Copy);
  split_KeepClauseAtLevel(PS, Copy, L);
}


#endif
