#include "ttest.h"

SCM section(args)
SCM args;
{
  display(const_1,cur_output_port());
  lwrite(args,cur_output_port());
  newline(cur_output_port());
  GLOBAL(cur_section)=args;
  return BOOL_T;
}

SCM record_error(e)
SCM e;
{
  return GLOBAL(errs)=cons(cons(GLOBAL(cur_section),cons(e,EOL)),GLOBAL(errs));
}

SCM test(expect,fun,args)
SCM expect,fun,args;
{
  lwrite(cons(fun,args),cur_output_port());
  display(const_2,cur_output_port());
  return test_fn2(fun,args,expect,(NFALSEP(procedurep(fun)) ? apply(GLOBAL(apply_nonkeyword),fun,cons(args,listofnull)) : CAR(args)));
}

SCM test_fn2(fun,args,expect,res)
SCM fun,args,expect,res;
{
  lwrite(res,cur_output_port());
  newline(cur_output_port());
  if(!(NFALSEP(equal(expect,res)))) {
    record_error(cons(res,cons(expect,cons(cons(fun,args),EOL))));
    display(const_3,cur_output_port());
    lwrite(expect,cur_output_port());
    newline(cur_output_port());
    return BOOL_F;
  }
  else
    return BOOL_T;
}

SCM report_errs()
{
  newline(cur_output_port());
  if(NULL_P(GLOBAL(errs)))
    display(const_4,cur_output_port());
  else {
    display(const_5,cur_output_port());
    newline(cur_output_port());
    display(const_6,cur_output_port());
    newline(cur_output_port());
    for_each1(report_errs_fn4,GLOBAL(errs));
  }
  return newline(cur_output_port());
}

SCM report_errs_fn4(l)
SCM l;
{
  lwrite(l,cur_output_port());
  return newline(cur_output_port());
}

SCM check_test_file(name)
SCM name;
{
  SCM new_var2,new_var3,test_file__1;

  test_file__1=open_file(name,const_7);
  test(BOOL_T,input_port_pred__symb,cons((new_var2=open_file(name,const_8),new_var3=check_test_file_fn6(new_var2),close_port(new_var2),new_var3),EOL));
  test(MAKICHR(';'),GLOBAL(read_char_nonkeyword),cons(test_file__1,EOL));
  test(GLOBAL(display_test_obj),GLOBAL(read),cons(test_file__1,EOL));
  test(GLOBAL(load_test_obj),GLOBAL(read),cons(test_file__1,EOL));
  return close_port(test_file__1);
}

SCM check_test_file_fn6(test_file__2)
SCM test_file__2;
{
  test(GLOBAL(load_test_obj),GLOBAL(read),cons(test_file__2,EOL));
  test(BOOL_T,GLOBAL(eof_object_pred_),cons(peek_char(test_file__2),EOL));
  test(BOOL_T,GLOBAL(eof_object_pred_),cons(read_char(test_file__2),EOL));
  return input_portp(test_file__2);
}

SCM top_actions_ttest()
{
  GLOBAL(cur_section)=EOL;
  GLOBAL(errs)=EOL;
  make_subr((unsigned char *)"section",tc7_lsubr,section);
  make_subr((unsigned char *)"record-error",tc7_subr_1,record_error);
  make_subr((unsigned char *)"test",tc7_lsubr,test_wrapper);
  make_subr((unsigned char *)"report-errs",tc7_subr_0,report_errs);
  section(cons(MAKINUM(6),cons(MAKINUM(10),cons(MAKINUM(1),EOL))));
  test(BOOL_T,GLOBAL(input_port_pred_),cons(cur_input_port(),EOL));
  test(BOOL_T,GLOBAL(output_port_pred_),cons(cur_output_port(),EOL));
  test(BOOL_T,GLOBAL(call_with_input_file),cons(const_9,cons(GLOBAL(input_port_pred_),EOL)));
  GLOBAL(this_file)=open_file(const_10,const_11);
  test(BOOL_T,GLOBAL(input_port_pred_),cons(GLOBAL(this_file),EOL));
  section(cons(MAKINUM(6),cons(MAKINUM(10),cons(MAKINUM(2),EOL))));
  test(MAKICHR(';'),GLOBAL(peek_char_nonkeyword),cons(GLOBAL(this_file),EOL));
  test(MAKICHR(';'),GLOBAL(read_char_nonkeyword),cons(GLOBAL(this_file),EOL));
  test(const_12,GLOBAL(read),cons(GLOBAL(this_file),EOL));
  test(MAKICHR('('),GLOBAL(peek_char_nonkeyword),cons(GLOBAL(this_file),EOL));
  test(const_13,GLOBAL(read),cons(GLOBAL(this_file),EOL));
  close_port(GLOBAL(this_file));
  close_port(GLOBAL(this_file));
  make_subr((unsigned char *)"check-test-file",tc7_subr_1,check_test_file);
  section(cons(MAKINUM(6),cons(MAKINUM(10),cons(MAKINUM(3),EOL))));
  GLOBAL(write_test_obj)=const_14;
  GLOBAL(display_test_obj)=const_19;
  GLOBAL(load_test_obj)=cons(define_symb,cons(foo_symb,cons(cons(quote_symb,cons(GLOBAL(write_test_obj),EOL)),EOL)));
  test(BOOL_T,GLOBAL(call_with_output_file),cons(const_23,cons(top_actions_ttest_cl1_clproc0,EOL)));
  check_test_file(const_24);
  GLOBAL(test_file)=open_file(const_25,const_26);
  write_char(MAKICHR(';'),GLOBAL(test_file));
  display(GLOBAL(write_test_obj),GLOBAL(test_file));
  newline(GLOBAL(test_file));
  lwrite(GLOBAL(load_test_obj),GLOBAL(test_file));
  test(BOOL_T,GLOBAL(output_port_pred_),cons(GLOBAL(test_file),EOL));
  close_port(GLOBAL(test_file));
  check_test_file(const_27);
  report_errs();
  return const_28;
}

SCM top_actions_ttest_cl1(test_file__1)
SCM test_file__1;
{
  write_char(MAKICHR(';'),test_file__1);
  display(GLOBAL(write_test_obj),test_file__1);
  newline(test_file__1);
  lwrite(GLOBAL(load_test_obj),test_file__1);
  return output_portp(test_file__1);
}

SCM for_each1(fn,lst)
SCM (*fn)();
SCM lst;
{
  for(;PAIR_P(lst);) {
    (*fn)(CAR(lst));
    lst=CDR(lst);
  }
  return EOL;
}

SCM test_wrapper(x)
SCM x;
{
  return test(CAR(x),CAR(CDR(x)),CDR(CDR(x)));
}

SCM init_ttest()
{
  top_actions_ttest_cl1_clproc0=make_subr((unsigned char *)"top_actions_ttest_cl1",tc7_subr_1,top_actions_ttest_cl1);
  call_with_output_file=&CDR(intern((unsigned char *)"call-with-output-file",21));
  peek_char_nonkeyword=&CDR(intern((unsigned char *)"peek-char",9));
  call_with_input_file=&CDR(intern((unsigned char *)"call-with-input-file",20));
  output_port_pred_=&CDR(intern((unsigned char *)"output-port?",12));
  input_port_pred_=&CDR(intern((unsigned char *)"input-port?",11));
  eof_object_pred_=&CDR(intern((unsigned char *)"eof-object?",11));
  read=&CDR(intern((unsigned char *)"read",4));
  read_char_nonkeyword=&CDR(intern((unsigned char *)"read-char",9));
  apply_nonkeyword=&CDR(intern((unsigned char *)"apply",5));
  test_file=&CDR(intern((unsigned char *)"test-file",9));
  load_test_obj=&CDR(intern((unsigned char *)"load-test-obj",13));
  display_test_obj=&CDR(intern((unsigned char *)"display-test-obj",16));
  write_test_obj=&CDR(intern((unsigned char *)"write-test-obj",14));
  this_file=&CDR(intern((unsigned char *)"this-file",9));
  errs=&CDR(intern((unsigned char *)"errs",4));
  cur_section=&CDR(intern((unsigned char *)"cur-section",11));
  input_port_pred__symb=CAR(intern((unsigned char *)"input-port?",11));
  define_symb=CAR(intern((unsigned char *)"define",6));
  cur_section_symb=CAR(intern((unsigned char *)"cur-section",11));
  quote_symb=CAR(intern((unsigned char *)"quote",5));
  errs_symb=CAR(intern((unsigned char *)"errs",4));
  test_symb=CAR(intern((unsigned char *)"test",4));
  b_symb=CAR(intern((unsigned char *)"b",1));
  c_symb=CAR(intern((unsigned char *)"c",1));
  a_symb=CAR(intern((unsigned char *)"a",1));
  te_symb=CAR(intern((unsigned char *)"te",2));
  st_symb=CAR(intern((unsigned char *)"st",2));
  foo_symb=CAR(intern((unsigned char *)"foo",3));
  protect_constants_ttest=&CDR(intern((unsigned char *)"protect_constants_ttest",23));
  GLOBAL(protect_constants_ttest)=EOL;
  const_1=makfromstr((unsigned char *)"SECTION",7);
  GLOBAL(protect_constants_ttest)=cons(const_1,GLOBAL(protect_constants_ttest));
  const_2=makfromstr((unsigned char *)"  ==> ",6);
  GLOBAL(protect_constants_ttest)=cons(const_2,GLOBAL(protect_constants_ttest));
  const_3=makfromstr((unsigned char *)" BUT EXPECTED ",14);
  GLOBAL(protect_constants_ttest)=cons(const_3,GLOBAL(protect_constants_ttest));
  const_4=makfromstr((unsigned char *)"Passed all tests",16);
  GLOBAL(protect_constants_ttest)=cons(const_4,GLOBAL(protect_constants_ttest));
  const_5=makfromstr((unsigned char *)"errors were:",12);
  GLOBAL(protect_constants_ttest)=cons(const_5,GLOBAL(protect_constants_ttest));
  const_6=makfromstr((unsigned char *)"(SECTION (got expected (call)))",31);
  GLOBAL(protect_constants_ttest)=cons(const_6,GLOBAL(protect_constants_ttest));
  const_7=makfromstr((unsigned char *)"r",1);
  GLOBAL(protect_constants_ttest)=cons(const_7,GLOBAL(protect_constants_ttest));
  const_8=makfromstr((unsigned char *)"r",1);
  GLOBAL(protect_constants_ttest)=cons(const_8,GLOBAL(protect_constants_ttest));
  const_9=makfromstr((unsigned char *)"test.scm",8);
  GLOBAL(protect_constants_ttest)=cons(const_9,GLOBAL(protect_constants_ttest));
  const_10=makfromstr((unsigned char *)"test.scm",8);
  GLOBAL(protect_constants_ttest)=cons(const_10,GLOBAL(protect_constants_ttest));
  const_11=makfromstr((unsigned char *)"r",1);
  GLOBAL(protect_constants_ttest)=cons(const_11,GLOBAL(protect_constants_ttest));
  const_12=cons(define_symb,cons(cur_section_symb,cons(cons(quote_symb,cons(EOL,EOL)),EOL)));
  GLOBAL(protect_constants_ttest)=cons(const_12,GLOBAL(protect_constants_ttest));
  const_13=cons(define_symb,cons(errs_symb,cons(cons(quote_symb,cons(EOL,EOL)),EOL)));
  GLOBAL(protect_constants_ttest)=cons(const_13,GLOBAL(protect_constants_ttest));
  const_16=makfromstr((unsigned char *)"te \" \" st",9);
  GLOBAL(protect_constants_ttest)=cons(const_16,GLOBAL(protect_constants_ttest));
  const_17=makfromstr((unsigned char *)"",0);
  GLOBAL(protect_constants_ttest)=cons(const_17,GLOBAL(protect_constants_ttest));
  const_18=vector(EOL);
  GLOBAL(protect_constants_ttest)=cons(const_18,GLOBAL(protect_constants_ttest));
  const_15=vector(cons(cons(test_symb,EOL),cons(const_16,cons(const_17,cons(test_symb,cons(const_18,cons(b_symb,cons(c_symb,EOL))))))));
  GLOBAL(protect_constants_ttest)=cons(const_15,GLOBAL(protect_constants_ttest));
  const_14=cons(BOOL_T,cons(BOOL_F,cons(MAKICHR('a'),cons(EOL,cons(MAKINUM(9739),cons(MAKINUM(-3),const_15))))));
  GLOBAL(protect_constants_ttest)=cons(const_14,GLOBAL(protect_constants_ttest));
  const_21=makfromstr((unsigned char *)" ",1);
  GLOBAL(protect_constants_ttest)=cons(const_21,GLOBAL(protect_constants_ttest));
  const_22=vector(EOL);
  GLOBAL(protect_constants_ttest)=cons(const_22,GLOBAL(protect_constants_ttest));
  const_20=vector(cons(cons(test_symb,EOL),cons(te_symb,cons(const_21,cons(st_symb,cons(test_symb,cons(const_22,cons(b_symb,cons(c_symb,EOL)))))))));
  GLOBAL(protect_constants_ttest)=cons(const_20,GLOBAL(protect_constants_ttest));
  const_19=cons(BOOL_T,cons(BOOL_F,cons(a_symb,cons(EOL,cons(MAKINUM(9739),cons(MAKINUM(-3),const_20))))));
  GLOBAL(protect_constants_ttest)=cons(const_19,GLOBAL(protect_constants_ttest));
  const_23=makfromstr((unsigned char *)"tmp1",4);
  GLOBAL(protect_constants_ttest)=cons(const_23,GLOBAL(protect_constants_ttest));
  const_24=makfromstr((unsigned char *)"tmp1",4);
  GLOBAL(protect_constants_ttest)=cons(const_24,GLOBAL(protect_constants_ttest));
  const_25=makfromstr((unsigned char *)"tmp2",4);
  GLOBAL(protect_constants_ttest)=cons(const_25,GLOBAL(protect_constants_ttest));
  const_26=makfromstr((unsigned char *)"w",1);
  GLOBAL(protect_constants_ttest)=cons(const_26,GLOBAL(protect_constants_ttest));
  const_27=makfromstr((unsigned char *)"tmp2",4);
  GLOBAL(protect_constants_ttest)=cons(const_27,GLOBAL(protect_constants_ttest));
  const_28=makfromstr((unsigned char *)"last item in file",17);
  GLOBAL(protect_constants_ttest)=cons(const_28,GLOBAL(protect_constants_ttest));
  top_actions_ttest();
}

