/*		Definitions of symbolic constants etc for FINDER */

        /****************************************************************
        *                                                               *
        *                          FINDER 3.0                           *
        *                                                               *
        *           (C) 1993 Australian National University             *
        *                                                               *
        *                      All rights reserved                      *
        *                                                               *
        * The information in this software is subject to change without *
        * notice and should not be construed as a commitment by the     *
        * Australian National University. The Australian National Uni-  *
        * versity makes no representations about the suitability of     *
        * this software for any purpose. It is supplied "as is" without *
        * express or implied warranty.  If the software is modified in  *
        * a manner creating derivative copyright rights, appropriate    *
        * legends may be placed on the derivative work in addition to   *
        * that set forth above.                                         *
        *                                                               *
        * Permission to use, copy, modify and distribute this software  *
        * and its documentation for any purpose and without fee is      *
        * hereby granted, provided that both the above copyright notice *
        * and this permission notice appear in all copies and sup-      *
        * porting documentation, and that the name of the Australian    *
        * National University not be used in advertising or publicity   *
        * pertaining to distribution of the software without specific,  *
        * written prior permission.                                     *
        *                                                               *
        ****************************************************************/

#define WF_MAX 1024
/* Number of [sub]expressions		*/

#define JL_MAX 2048
/* Length of input line			*/

#define CL_MAX 256
/* Number of clauses			*/

#define ST_MAX 16
/* Number of sorts			*/

#define FN_MAX 256
/* Number of function symbols		*/

#define ARGMAX 10
/* Number of argument places            */

#define LEXMAX 512
/* Number of meaningful strings		*/

#define VARMAX 64
/* Number of differenct variables	*/

#define LEXLENGTH 64
/* Number of characters in a name	*/

#define VCMAX 8
/* Number of variables easy to test	*/

#define PRE_MAX 6
/* Weight of clauses it makes sense to pre-test */

#define S_ITSY 1
#define S_BITSY 2
#define S_TINY 4
#define S_SMALL 8
#define S_MEDIUM 16
#define S_LARGE 32
#define S_VERYLARGE 64
#define S_HUGE 128
#define S_MAXIMAL (REF_MAX-1)
/* Stack sizes				*/


#define Bool sort
#define Integer (sort+1)

#define pbmodels 1
#define pfmodels 2
#define pmodels 3
#define pbjob 4
#define pfjob 8
#define pjob 12
#define pbstats 16
#define pfstats 32
#define pstats 48
#define pugly 5

/* The above are used for bit-coding print modes */

