/*	External variables used in the FINDER sources */

        /****************************************************************
        *                                                               *
        *                          FINDER 3.0                           *
        *                                                               *
        *           (C) 1993 Australian National University             *
        *                                                               *
        *                      All rights reserved                      *
        *                                                               *
        * The information in this software is subject to change without *
        * notice and should not be construed as a commitment by the     *
        * Australian National University. The Australian National Uni-  *
        * versity makes no representations about the suitability of     *
        * this software for any purpose. It is supplied "as is" without *
        * express or implied warranty.  If the software is modified in  *
        * a manner creating derivative copyright rights, appropriate    *
        * legends may be placed on the derivative work in addition to   *
        * that set forth above.                                         *
        *                                                               *
        * Permission to use, copy, modify and distribute this software  *
        * and its documentation for any purpose and without fee is      *
        * hereby granted, provided that both the above copyright notice *
        * and this permission notice appear in all copies and sup-      *
        * porting documentation, and that the name of the Australian    *
        * National University not be used in advertising or publicity   *
        * pertaining to distribution of the software without specific,  *
        * written prior permission.                                     *
        *                                                               *
        ****************************************************************/

#ifdef MAINFILE
#define GLOBAL
#else
#define GLOBAL extern
#endif


GLOBAL LEXITEM lexicon[LEXMAX];		/* All the defined symbols	*/
GLOBAL KIND sort[ST_MAX];		/* The actual sorts (of course)	*/
GLOBAL FUNCTOR fn[FN_MAX];		/* The defined functions	*/
GLOBAL WFF form[WF_MAX];		/* The well-formed expressions	*/
GLOBAL CLAUSE theory[CL_MAX];		/* That which is true in models	*/
GLOBAL PARAMETERS setting;		/* The optional settings	*/
GLOBAL TRIN tr_parameters;		/* Info passed to transref	*/
GLOBAL TRIN ttr_par;			/* Ditto for better testing	*/

GLOBAL int	
	id[SZ][SZ],			/* Constant function =		*/
	less[SZ][SZ],			/* Constant function <		*/
	greater[SZ][SZ],		/* Constant function >		*/
	lastsizes[ST_MAX],		/* Last good siz values		*/
        lastvlength,                    /* Last vector length           */
	SZto[ARGMAX],			/* Powers of SZ 		*/
	first_change,			/* Most significant update	*/
	zero,				/* A dummy integer, value 0	*/
	input_point,			/* Offset of next input char	*/
	thmax,				/* Maximal clause in theory	*/
	tot,				/* Number of tests made		*/
	good;				/* Number of models found	*/

GLOBAL boolean
	line_input,			/* Using command line for input	*/
	piping,				/* Structures to be piped	*/
	pipe_open,			/* Definitions now being piped	*/
	negative,			/* Print models that fail test	*/
	clauses_fail,			/* New clauses are always false	*/
	cc_badguy,			/* Current clause is a bad guy	*/
	firstmodel,			/* No model yet in this search	*/
	single_model,			/* Generate one model at most	*/
	forbidden[V_LENGTH],		/* Can't bactrack from here	*/
	first_newval;

GLOBAL char
	command_line[256],		/* argv	in one dimension	*/
	varlex[VARMAX][LEXLENGTH];	/* Lexicon of variable names	*/

GLOBAL unsigned
	lastgood[V_LENGTH],		/* Most recent model found	*/
	thisvector[V_LENGTH];		/* Copy of vector being tested	*/	

GLOBAL clause TH;			/* The theory in test order	*/
GLOBAL CLAUSE latest_clause;		/* Most recently parsed clause	*/

GLOBAL functor
	FN,				/* The functions that matter	*/
	dummy_symbol;			/* Not really a function symbol	*/

