/*	Prototypes of FINDER functions.
*	Functions in TR.c are not listed here.
*/

        /****************************************************************
        *                                                               *
        *                          FINDER 3.0                           *
        *                                                               *
        *           (C) 1993 Australian National University             *
        *                                                               *
        *                      All rights reserved                      *
        *                                                               *
        * The information in this software is subject to change without *
        * notice and should not be construed as a commitment by the     *
        * Australian National University. The Australian National Uni-  *
        * versity makes no representations about the suitability of     *
        * this software for any purpose. It is supplied "as is" without *
        * express or implied warranty.  If the software is modified in  *
        * a manner creating derivative copyright rights, appropriate    *
        * legends may be placed on the derivative work in addition to   *
        * that set forth above.                                         *
        *                                                               *
        * Permission to use, copy, modify and distribute this software  *
        * and its documentation for any purpose and without fee is      *
        * hereby granted, provided that both the above copyright notice *
        * and this permission notice appear in all copies and sup-      *
        * porting documentation, and that the name of the Australian    *
        * National University not be used in advertising or publicity   *
        * pertaining to distribution of the software without specific,  *
        * written prior permission.                                     *
        *                                                               *
        ****************************************************************/




/*
*	The following are in file FINDER.c
*/

int is_good(char s[]);
int found( char s[], int add_old, int add_new, int seek_model );
int init_finder(char s[]);
int is_bad( char c[], char g, boolean verbose );
int init_goal_finder( char filename[] );
int update_size( boolean new );
void refute_current();
int theory_size();
void go(int x);



/*
*	The following are in file initial.c
*/

void initialize();
void canon( kind k, char nn[] );
int lex_pos( char s[], boolean kind_expected );
kind newkind( char s[] );
functor newfunctor( char s[], syntype t, int a );


/*
*	The following are in file input.c
*/

char get_a_char();
char Getchar();
void getword( char w[] );
statement_type get_st();
void read_job( FILE *infil );
void get_incl();
void get_item( void (*item)(), kind k, functor f );
void get_sort( kind k, functor f, char s[], int x );
void de_enumerate( kind k );
void free_canon( strls lp );
void sort_spec( kind k, functor f, char s[], int x );
void get_func( kind k, functor f, char s[], int x );
void get_const( kind k, functor f, char s[], int x );
kind set_up_type( char s[] );
void func_spec( kind k, functor f, char s[], int x );
void getclause( kind k, functor f, char s[], int x );
void Get_clause( char s[], int x );
void addclause(char s[]);
void get_set( kind k, functor f, char s[], int x );
void verb_spec( kind k, functor f, char s[], int x );
unsigned verb_spec_spec( unsigned vb, unsigned mask );
boolean got_partial();
boolean got_function();
void inerror( char *s1, char *s2 );
void inwarning(char *s1, char *s2);

/*
*	The following are in file output.c
*/

void print_the_job();
void fprint_the_job( FILE *fil );
void print_job();
void fprint_job( FILE *fil );
void print_sorts( FILE *fil );
void print_one_sort( FILE *fil, kind k );
void print_functions( FILE *fil );
void print_one_function( FILE *fil, functor f );
void print_clauses( FILE *fil );
void print_one_clause( FILE *fil, clause c );
void outwff( FILE *fil, wff w );
void print_setting( FILE *fil );
void prints_int( FILE *fil, char *s, int x );
void prints_bool( FILE *fil, char *strue, char *sfalse, boolean b );
void prints_verb( FILE *fil, char *s, unsigned mask );
boolean print_the_model();
boolean fprint_the_model( FILE *fil );
boolean print_model();
boolean fprint_model( FILE *fil );
void zeroprint( FILE *fil, functor f );
void oneprint( FILE *fil, functor f );
void twoprint( FILE *fil, functor f );
int canonlength( kind k );
void printvalue( FILE *fil, kind k, int x, int len );
void printarg( FILE *fil, kind k, int x, int len );
void printstats();



/*
*	The following are in file prepare.c
*/

int vec_pos(functor f, int argument[]);
void normalize();
void get_weight();
boolean is_after( clause c1, clause c2 );
void set_up_cc();
void set_up_for( functor f );
void rec_set_up_for(functor f, int x);
void set_SZto();
void set_fats(functor f);
void set_sum();
void set_E();
void set_cc();


/*
*	The following are in file parser.c
*/

void begin_parse();
void free_wff_list( wls ptr );
wff parse( char s[] );
wff sparse( char s[] );
wff locate( functor mn, wff subform[] );
void typecheck();
functor newvar( char s[], kind k );
void type_complete( wff w );
void type_adds( wff w );
void AT_plus( wff w );
void AT_up( wff w, char *s );
void add_type( wff w, kind k );
void type_consistent( wff w );
void end_parse();
void set_valptrs( wff wf );
void positive_last();
wff corr( wff wf );
void add_to_theory();


/*
*	The following are in file set_up_space.c
*/

int setposs( unsigned info[], TRS *T );
void set_possval( unsigned info[], functor f, TRS *T );
boolean good_one( unsigned info[], clause c );
boolean setposs_test( unsigned info[], clause c, wls tf );
boolean another_argument(functor f, int argument[]);


/*
*	The following are in file pretest.c
*/

int do_smallrefs( unsigned info[], TRS *T );
boolean twt_test( unsigned info[], clause c, int lwt, wff plit, TRS *T );
boolean alive( clause c, wls *tf, wls *ltf, int *maximum, wls wf,
	unsigned info[], wff plit, TRS *T );
boolean good_all( clause c, wls tf[], wff plit, TRS *T);
boolean poss_val( wff w, unsigned info[] );
void correct_order( wls tf[] );
void do_injectives( TRS *T );
boolean do_surjectives( TRS *T );
int localweight( unsigned info[], clause c, wff *plit, TRS *T );
struct wfflist *firstopen( unsigned info[], struct wfflist *wfl, int opens );
boolean is_open( functor f );
boolean occurs_in_list( wff fmla, wls wfl );
boolean occurs_inside( wff little, wff big );
void set_dinfo(functor f, int x, int argument[], unsigned dinfo[]);



/*
*	The following are in file test.c
*/

int model( unsigned info[], TRS *T );
void vect_into_model( unsigned info[] );
void set_lastgood();
boolean isgood( clause c );
boolean clause_fails( clause c );
boolean next_assignment( clause c );
void record_refutation( clause c, TRS *T );



/*
*	The following are in file newtest.c
*/

int tisgood( clause c );
int tset_cc();
void untset_cc();
int model_t( unsigned info[], TRS *T );
int single_t( unsigned info[], TRS *T );
int tuple_t( unsigned info[], TRS *T );
boolean next_instance(wff w, int subvalues[]);
