/*	Type definitions for FINDER */

        /****************************************************************
        *                                                               *
        *                          FINDER 3.0                           *
        *                                                               *
        *           (C) 1993 Australian National University             *
        *                                                               *
        *                      All rights reserved                      *
        *                                                               *
        * The information in this software is subject to change without *
        * notice and should not be construed as a commitment by the     *
        * Australian National University. The Australian National Uni-  *
        * versity makes no representations about the suitability of     *
        * this software for any purpose. It is supplied "as is" without *
        * express or implied warranty.  If the software is modified in  *
        * a manner creating derivative copyright rights, appropriate    *
        * legends may be placed on the derivative work in addition to   *
        * that set forth above.                                         *
        *                                                               *
        * Permission to use, copy, modify and distribute this software  *
        * and its documentation for any purpose and without fee is      *
        * hereby granted, provided that both the above copyright notice *
        * and this permission notice appear in all copies and sup-      *
        * porting documentation, and that the name of the Australian    *
        * National University not be used in advertising or publicity   *
        * pertaining to distribution of the software without specific,  *
        * written prior permission.                                     *
        *                                                               *
        ****************************************************************/

typedef enum	{ None, Func, Var, Const } syntype;
/*typedef enum	{ false, true } boolean;*/
typedef enum	{ null, brief, full } prints;
typedef enum	{ nul, srt, fcn, fcn0, cls, prm, inc } statement_type;

typedef struct listptr {
    char *name;
    struct listptr *nextname;
} STRLS, *strls;

typedef struct {
	char	*sname;		/* The identifier for this sort		*/
	int	sizmin,		/* Least number of things of this sort	*/
		sizmax,		/* Greatest ditto			*/
		siz;		/* Current number of such things	*/
	int	sum[SZ][SZ];	/* Addition is a built-in function	*/
	strls	canonical;	/* List of names, for enumerated sort	*/
	int	Ex[SZ],		/* "Exists" is a predicate after all!	*/
		len[SZ];	/* Name lengths of the elements		*/
	boolean	piped;		/* Sort "siz" comes via the pipe	*/
	unsigned sizmask;	/* Bit mask for range 0..siz		*/
} KIND, *kind;


typedef struct FNCT {
	
    char *fname;	/* The identifier for this symbol	*/
    syntype category;	/* Syntactic type (func, pred, etc)	*/
    int scope,		/* For parsing purposes			*/
        adicity,	/* Number of argument places		*/
        *table,		/* Start of matrix for this function	*/
        fcc,		/* Index: start of portion of vector	*/
        old_fcc,	/* Was fcc on last good model		*/
        fats[ARGMAX];   /* For use in matrix lookup             */
    boolean total,		/* Function may not have null value	*/
        injective,	/* Function is one-one			*/
        leftin,		/* Each row is one-one			*/
        rightin,	/* Each column is one-one		*/
        surjective,	/* Function is onto			*/
        leftsur,	/* Each row is onto			*/
        rightsur,	/* Each column is onto			*/
        comm,		/* Function is binary and commutative	*/
        piped,		/* Function values come via the pipe	*/
        nop,		/* No decrease in change-order priority	*/
        cut_it;		/* Prohibit backtracking on function	*/
    kind arg_type[ARGMAX], /* The types of the argument(s)      	*/
        val_type;	/* The type of this function's value	*/
        prints	pmode;		/* What kind of print display		*/
        struct FNCT *nextfunct;	/* Linking the list of "real" functors	*/
} FUNCTOR, *functor;
		

typedef struct wffstr {
	functor	sym;		/* Main predicate or function symbol	*/
	struct wffstr *sb[ARGMAX];	/* Offsets of the subformulae	*/
	int	val,		/* Value currently assigned		*/
		*matrix,	/* Start of the relevant value table	*/
		*sbval[ARGMAX],	/* Pointers to values of subformulae	*/
		wcc;		/* Offset in info vector for t-testing	*/
	struct wffstr *nextwff;	/* Linking the list of testables	*/
} WFF, *wff;


typedef struct {
	int	max_models,
		maxref,
		test_maxref,
		max_backtracks,
		test_point,
		latest_priority,
		pretest_limit,
		batches,
		extra_batches;
	logical	maxtime;
	boolean	Nosecs,
		invert_change,
		vars_over_wt,
		topsoff,
		report_breaks,
		noisy,
		timestamps;
	struct	printmode {
		unsigned verbosity;
		boolean pretty;
	}	pm;
} PARAMETERS;


typedef struct wfflist {
	wff	w;
	struct wfflist *nxt;
} WLS, *wls;


typedef struct CLS {
	wls	prem,
		conc,
		varlist,
		testlist;
	int	weight,
		priority,
		varcount;
	struct CLS *nextclause,
		*lastclause;
} CLAUSE, *clause;


typedef struct {
	char	word[LEXLENGTH];
	boolean	iskind;
	int	offset;
} LEXITEM;

