#ifndef STACK_H
#define STACK_H


#include "heap.h"

#define STACKMAX         (5000)

typedef struct
           {
           _HeapAddr     v[STACKMAX+1];
           int           sp;
           } _Stack;


extern _Stack refStack;
extern _Stack demodRefStack;


#if DEBUG
#define EmptyP          (  printf("\n\n Pop in Empty Stack!\n\n"), exit(1), 1 )
#define EmptyT          (  printf("\n\n Top in Empty Stack!\n\n"), exit(1), 1 )
#define Over            ({ printf("Stack Overflow! \n\n");  exit(1); })
#define StackFlush(s)   ( (s).sp = 0 )
#define StackIsEmpty(s) ( (s).sp == 0 )
#define StackPush(s,n)  ( {If (s).sp==STACKMAX Then Over; printf("n\n\n"); \
                          Else (s).v[++(s).sp]=(_HeapAddr)(n); EndIf} )
#define StackPop(s)     ( {If (s).sp == 0 Then EmptyP; Else (s).sp--; EndIf} )
#define StackTop(s)     ( (s).sp == 0 ? (_HeapAddr)(EmptyT) : (s).v[(s).sp] )
#define StackTopPop(s)  ( (s).sp == 0 ? (_HeapAddr)(EmptyT) : (s).v[((s).sp)--] )
#define StackHeight(s)  ( (s).sp )

#else
#define StackFlush(s)   ( (s).sp = 0 )
#define StackIsEmpty(s) ( (s).sp == 0 )
#define StackPush(s,n)  ( (s).v[++(s).sp] =(_HeapAddr)(n) )
#define StackPop(s)     ( ((s).sp)-- )
#define StackTop(s)     ( (s).v[(s).sp] )
#define StackTopPop(s)  ( (s).v[((s).sp)--] )
#define StackHeight(s)  ( (s).sp )
#endif

#endif


