/*------------------------------------------------------------------*/
/*      tptpi.c
/*
/*  A routine that converts tptp-formated theorems to
/*  tgtp-formated theorems.
/*------------------------------------------------------------------*/


#include <stdio.h> 
#include <strings.h>
#include <ctype.h>

#include "const.h"
 
#define inputtptp()   getc(infile)
#define CMAX  500L
 
extern FILE *infile;

/*-----------------------------------*/
/* internally defined functions      */
/*-----------------------------------*/

void readtptp();
void converttptp();
void InsertChar();
void DeleteChar();
void CheckClauseType();
int CompareStrings();
void SetPtrToNextLine();
void dumptptp();
void DumpClause();
void OutString();
void finalsort();
void compile_tptp();

/*----------------------------------*/
/* internally defined constants     */
/*----------------------------------*/

char tptpCodeBuffer[60000];
char *tptpCodePtr;
char *tptpCodeEndPtr;

char tgtpCodeBuffer[60000];
char *tgtpCodePtr;

long ClauseCount;
long CharCount;

long ClauseType[CMAX];
long LitCount[CMAX];
long ClauseLength[CMAX];
long ClauseHead[CMAX];

/*-----------------------------------------------------------------*/
/*      readtptp()                   .......................#1
/*-----------------------------------------------------------------*/
 
void readtptp()
{
long InChar;
long i;

CharCount = 0L;
ClauseCount = 0L;

for(i = 0L; i < CMAX ; i++) {
      ClauseType[i] = LitCount[i] = 0L;}

tptpCodePtr = tptpCodeBuffer;

/*------------------------------------------*/
/* read theorem                             */
/*------------------------------------------*/

for(;;) {
      InChar = inputtptp(); 
      *tptpCodePtr = InChar;
      CharCount++;
      if(InChar == -1L) {break;}
      tptpCodePtr++;}
tptpCodeEndPtr = tptpCodePtr;
/*printf("Character Count = %ld.  ",CharCount);*/
return;
}

/*-------------------------------------------------------------------*/
/*  converttptp()        ........................... #2
/*-------------------------------------------------------------------*/

void converttptp()
{
char *j, *jj, *jjj, *k;
int bracket_count;

tptpCodePtr = tptpCodeBuffer;
STATE1: 
if(*tptpCodePtr == 'i') {
      ClauseHead[ClauseCount] = (long) tptpCodePtr;
      LitCount[ClauseCount++] = 1L;
      CheckClauseType();
      *tptpCodePtr++ = ';';
      DeleteChar(12);
      SetPtrToNextLine();
      goto STATE2;}
if(*tptpCodePtr == -1L) {   /* -1 = EOF */
      return;}
if(*tptpCodePtr == 10L) {   /* 10 = CR */
      SetPtrToNextLine();
      goto STATE1;}
if(*tptpCodePtr == '%') {
      *tptpCodePtr = ';';
      SetPtrToNextLine();
      goto STATE1;}
else {
      SetPtrToNextLine();
      goto STATE1;}

STATE2:
if(*tptpCodePtr == ' ') {
      DeleteChar(1);
      goto STATE2;}
if(*tptpCodePtr == '.') { 
      DeleteChar(1);
      ClauseLength[ClauseCount - 1L] = 
         (long) tptpCodePtr - (long) ClauseHead[ClauseCount - 1L]; 
      goto STATE1;}
if(*tptpCodePtr == '[') { 
      DeleteChar(1);
      goto STATE2;}
if(*tptpCodePtr ==  '+') {  /* 43L = + */
      tptpCodePtr++;
      if(*tptpCodePtr ==  '+' ) {
            tptpCodePtr--;
            DeleteChar(2); 
            goto STATE2;}
      tptpCodePtr--;
      goto STATE2;}
           
if(*tptpCodePtr == '-') {
      tptpCodePtr++;
      if(*tptpCodePtr == '-') {
            tptpCodePtr--;
            DeleteChar(1);
            *tptpCodePtr++ = '~';
            goto STATE2;}
      tptpCodePtr--;
      goto STATE2;}

if(*tptpCodePtr == ',') {
      tptpCodePtr++;
      if(*tptpCodePtr == 10L) {
            LitCount[ClauseCount - 1L]++;
            tptpCodePtr--;
            *tptpCodePtr = ' ';
            tptpCodePtr++;
            *tptpCodePtr++ = '|';
            goto STATE2;}
      goto STATE2;}
/*
if(*tptpCodePtr == 'c') {
      while(*tptpCodePtr != ')' && *tptpCodePtr != ',') {
            tptpCodePtr++;}
      InsertChar('^');  /* insert a marker for () 
      tptpCodePtr++;
      goto STATE2;}
*/
if(isalpha(*tptpCodePtr)) {
   j = tptpCodePtr;
   j--;
   k = tptpCodePtr;
   while(*tptpCodePtr != ')' && *tptpCodePtr != ',' &&
	 *tptpCodePtr != ' ' && *tptpCodePtr != '(') {
      tptpCodePtr++;}
   if(*tptpCodePtr == ' ') {
      *tptpCodePtr = '(';
      bracket_count = 0;
      tptpCodePtr++;
      for(jj = tptpCodePtr ; ; jj++) {
	 if(*jj == '(') {bracket_count++;}
	 if(bracket_count == 0 && (*jj == ',' || *jj == ')')) {
	    jjj = tptpCodePtr;
	    tptpCodePtr = jj;
	    InsertChar(')'); 
	    tptpCodePtr = --jjj;
	    break;}
	 if(*jj == ')') {
	    bracket_count--;}}}

   if(*j == '+' || *j == '-' || isupper(*k) || *tptpCodePtr ==
           '(' || *tptpCodePtr == ' ') { 
      goto STATE2;}
   InsertChar('^');
   tptpCodePtr++;
   goto STATE2;}

if(*tptpCodePtr == ']') { 
      DeleteChar(2);
      goto STATE2;}
else {
      tptpCodePtr++;
      goto STATE2;}
}

/*------------------------------------------------------------------*/
/*  InsertChar()           ...................... #3
/*------------------------------------------------------------------*/

void InsertChar(s)
char s;
{
char *tptpCodeEndPtr1;
char *tptpCodeEndPtr2;

tptpCodeEndPtr++;
tptpCodeEndPtr1 = tptpCodeEndPtr;
tptpCodeEndPtr2 = tptpCodeEndPtr1;
tptpCodeEndPtr2--;

while(tptpCodeEndPtr2 >= tptpCodePtr) {
      *tptpCodeEndPtr1 = *tptpCodeEndPtr2;
      tptpCodeEndPtr2--;
      tptpCodeEndPtr1--;}

*tptpCodePtr = s;
return;
}

/*------------------------------------------------------------------*/
/*  DeleteChar()          ..................  #4
/*------------------------------------------------------------------*/

void DeleteChar(d)
int d;
{
int i;

for(i = d; i > 0; i--) {
      *tptpCodePtr++ = -2L;}
return;
}

/*------------------------------------------------------------------*/
/*  CheckClauseType()        ................  #5
/*------------------------------------------------------------------*/

void CheckClauseType()
{
char *ccp;

ccp = tptpCodePtr;
while(*ccp != 10L) {
      if(CompareStrings(ccp,"conjecture",10L)) {
            ClauseType[ClauseCount - 1L] = 1L; return;}
      if(CompareStrings(ccp,"hypothesis",10L)) {
            ClauseType[ClauseCount - 1L] = 2L; return;}
      ccp++;}
ClauseType[ClauseCount - 1L] = 3L;
return;
}

/*------------------------------------------------------------------*/
/*  CompareStrings(s,t,n)       .................  #6
/*------------------------------------------------------------------*/

int CompareStrings(s,t,n)
char s[],t[];
long n;
{
long i;

i = 0L;
while(s[i] == t[i]) {
      i++;
      if(i == n) {return(1);}}
return(0);
}

/*------------------------------------------------------------------*/
/*  SetPtrToNextLine()      ....................  #7
/*------------------------------------------------------------------*/

void SetPtrToNextLine()
{
while(*tptpCodePtr != 10L) { 
      tptpCodePtr++;}
tptpCodePtr++;
return;
}

/*------------------------------------------------------------------*/
/*  dumptptp()            .......................  #8
/*------------------------------------------------------------------*/

void dumptptp()
{
long i;

/*printf("Clause Count = %ld.  ",ClauseCount);*/ 
for(i= 0L; i < ClauseCount; i++) {
       LitCount[i] =
          100000L*ClauseType[i] + 1000L*LitCount[i] + ClauseLength[i];}
return;
}

/*------------------------------------------------------------------*/
/*  DumpClause()         .....................  #9
/*------------------------------------------------------------------*/

void DumpClause(Imax)
long Imax;
{
long CRctr;

CRctr = 0L;
tptpCodePtr = (char *) ClauseHead[Imax];

for( ; ; ) {
      if(*tptpCodePtr == -2L) {
            tptpCodePtr++;
            continue;}
      *tgtpCodePtr = *tptpCodePtr;
      if(*tgtpCodePtr == 10L && CRctr++ == 1L) break;
      if(*tgtpCodePtr == '^') {
            *tgtpCodePtr++ = '(';
            *tgtpCodePtr = ')';}
      if(*tgtpCodePtr == '|') {
            tgtpCodePtr++;
            *tgtpCodePtr = ' ';}
      tptpCodePtr++;
      tgtpCodePtr++;}
tgtpCodePtr++;
*tgtpCodePtr++ = 10L;
return;
}

/*------------------------------------------------------------------*/
/*  OutString()       ....................  #10
/*------------------------------------------------------------------*/

void OutString(s,Length)
char s[];
long Length;
{
long i;

for(i = 0L; i < Length ; i++) {
      *tgtpCodePtr++ = s[i];}
*tgtpCodePtr++ = 10L;
return;
}

/*------------------------------------------------------------------*/
/*  finalsort()          ..................... #11
/*------------------------------------------------------------------*/

void finalsort()
{
long IndexMax, LitMax, i, NegConclusion, Hypothess;
int ii;
char *OutputCodePtr;

tgtpCodePtr = tgtpCodeBuffer;
NegConclusion = Hypothess = 0L;

for( ; ;   ) {
      IndexMax = 0L;
      LitMax = 0L;
      for(i = 0L; i < ClauseCount; i++) {
            if(LitCount[i] > LitMax) {
                  LitMax = LitCount[i];
                  IndexMax = i;}}
      if(LitMax == 0L) {goto finaldump;}
      LitCount[IndexMax] = 0L;
/*      if(Hypothess == 0L && LitMax < 300000L) {
            Hypothess++;
            OutString("hypothesis",10L);} */
      if(NegConclusion == 0L && LitMax < 300000L) {
            NegConclusion++;
            OutString("negated_conclusion",18L);}
      DumpClause(IndexMax);}

finaldump:
*tgtpCodePtr = -1L;
/*
for(OutputCodePtr = tgtpCodeBuffer; ; OutputCodePtr++) {
   printf("%c",*OutputCodePtr);
   if(*OutputCodePtr == -1L) {break;}}
getchar(); */
return;
}
 
/*------------------------------------------------------------------*/ 
/*      compile_tptp()         .......................#12
/*
/*      called by:  main()                  tgtp.c
/*
/*      calls:      readtptp
/*------------------------------------------------------------------*/
 
void compile_tptp()
{
readtptp();
converttptp();
dumptptp();
finalsort();
return;
}
