/**************************************************************/
/* ********************************************************** */
/* *                                                        * */
/* *             GLOBAL SYSTEM VECTOR                       * */
/* *                                                        * */
/* *  $Module:   VECTOR                                     * */ 
/* *                                                        * */
/* *                                                        * */
/* $Revision: 0.43 $                                        * */
/* $State: Exp $                                            * */
/* $Date: 1996/09/16 13:42:19 $                             * */
/* $Author: weidenb $                                       * */
/* *                                                        * */
/* *             Contact:                                   * */
/* *             Christoph Weidenbach                       * */
/* *             MPI fuer Informatik                        * */
/* *             Im Stadtwald                               * */
/* *             66123 Saarbruecken                         * */
/* *             Email: weidenb@mpi-sb.mpg.de               * */
/* *             Germany                                    * */
/* *                                                        * */
/* ********************************************************** */
/**************************************************************/


/* $RCSfile: vector.c,v $ */

#include "vector.h"

/**************************************************************/
/* Global Variables                                           */
/**************************************************************/

VECTOR vec_VECTOR;
int    vec_MAX;


/**************************************************************/
/* Functions                                                  */
/**************************************************************/

void vec_Swap(int i, int j)
/**********************************************************
  INPUT:   Two integers i and j which designate the i-th and
           the j-th cell of the vector.
  RETURNS: None.
  CAUTION: The values in the i-th and the j-th cell in the
            vector are interchanged.
********************************************************/
{
  POINTER help;

  help  = vec_GetNth(i);
  vec_PutNth(i, vec_GetNth(j));
  vec_PutNth(j, help);
 
}


void vec_PrintSel(int beg, int end, void (*ElementPrint)())
/**********************************************************
  INPUT:   None.
  RETURNS: Writes the vector from beg to end to stdout.
  CAUTION: None.
********************************************************/
{
  int i;

  if (vec_ActMax() > 0) {
    for (i = beg; i < end; i++){
      printf("Entry %d:\t",i);
      ElementPrint(vec_GetNth(i));
      printf("\n");
    }
  } else
    printf("Vector is empty\n");
}


void vec_PrintAll(void (*ElementPrint)())
/**********************************************************
  INPUT:   A print function for the elements of the vector.
  RETURNS: Writes the vector to stdout.
  CAUTION: None.
********************************************************/
{
  int i;

  if (vec_ActMax() > 0) {
    for (i = 0; i < vec_ActMax(); i++) {
      printf("Entry %d:\t", i);
      ElementPrint(vec_GetNth(i));
      printf("\n");
    }
  } else
    printf("Vector is empty\n");
}
