#include "resbase.h"

SCM shiftleft(x,y)
SCM x,y;
{
  return MAKINUM(INUM(x)<<INUM(y));
}

SCM shiftright(x,y)
SCM x,y;
{
  return MAKINUM(INUM(x)>>INUM(y));
}

SCM clinfo_history_sublist(inf)
SCM inf;
{
  return CDR(CDR(CDR(CDR(CDR(inf)))));
}

SCM clinfo_clnumber_sublist(inf)
SCM inf;
{
  return CDR(CDR(CDR(CDR(inf))));
}

SCM get_litinfo_ordernr(inf)
SCM inf;
{
  return MAKINUM(INUM(GLOBAL(litinf_ordernr_mask_global)&inf)>>16);
}

SCM put_litinfo_ordernr(nr,inf)
SCM nr,inf;
{
  return MAKINUM(INUM(nr)<<16)|MAKINUM(INUM(GLOBAL(litinf_ordernr_mask_global)&inf)^INUM(inf));
}

SCM get_litinfo_classnr(inf)
SCM inf;
{
  return MAKINUM(INUM(GLOBAL(litinf_classnr_mask_global)&inf)>>24);
}

SCM put_litinfo_classnr(nr,inf)
SCM nr,inf;
{
  return MAKINUM(INUM(nr)<<24)|MAKINUM(INUM(GLOBAL(litinf_classnr_mask_global)&inf)^INUM(inf));
}

SCM composite_pred_(x)
SCM x;
{
  return NOT(SBOOL(NUMBER_P(x)));
}

SCM non_composite_pred_(x)
SCM x;
{
  return SBOOL(NUMBER_P(x));
}

SCM var_pred_(x)
SCM x;
{
  if(NUMBER_P(x))
    return SBOOL(x<=MAKINUM(65535));
  else
    return BOOL_F;
}

SCM non_composite_colon__var_pred_(x)
SCM x;
{
  return SBOOL(MAKINUM(65535)>x);
}

SCM const_pred_(x)
SCM x;
{
  if(NUMBER_P(x))
    return SBOOL(x>MAKINUM(65535));
  else
    return BOOL_F;
}

SCM single_occ_lit_var_pred_(x)
SCM x;
{
  return NOT(SBOOL(ZERO_P(MAKINUM(32768)&x)));
}

SCM repeated_occ_lit_var_pred_(x)
SCM x;
{
  return SBOOL(ZERO_P(MAKINUM(32768)&x));
}

SCM later_occurrences_var_pred_(x)
SCM x;
{
  return SBOOL(ZERO_P(MAKINUM(8192)&x));
}

SCM term_may_cont_vars_pred_(x)
SCM x;
{
  return SBOOL(ZERO_P(MAKINUM(65536)&CAR(x)));
}

SCM fun_may_cont_vars_pred_(x)
SCM x;
{
  return SBOOL(ZERO_P(MAKINUM(65536)&x));
}

SCM fun_may_cont_repeatedvars_pred_(x)
SCM x;
{
  return NOT(SBOOL(ZERO_P(MAKINUM(131072)&x)));
}

SCM pure_fun(x)
SCM x;
{
  return MAKINUM(534773760)&x;
}

SCM pure_unsigned_fun(x)
SCM x;
{
  return MAKINUM(266338304)&x;
}

SCM fun_depth_strength(fun)
SCM fun;
{
  return MAKINUM(65535)&fun;
}

SCM fun_depth(fun)
SCM fun;
{
  return MAKINUM(63488)&fun;
}

SCM fun_real_depth(fun)
SCM fun;
{
  return MAKINUM(INUM(MAKINUM(63488)&fun)>>11);
}

SCM neg_fun_pred_(x)
SCM x;
{
  return NOT(SBOOL(ZERO_P(MAKINUM(268435456)&x)));
}

SCM pos_fun_pred_(x)
SCM x;
{
  return SBOOL(ZERO_P(MAKINUM(268435456)&x));
}

SCM complementary_fun_pred_(x)
SCM x;
{
  return MAKINUM(0-INUM(MAKINUM(534773760)&x));
}

SCM fun_can_subsume_pred_(sf,gf)
SCM sf,gf;
{
  if((MAKINUM(534773760)&sf)==(MAKINUM(534773760)&gf)) {
    if((MAKINUM(131071)&sf)>=(MAKINUM(131071)&gf)) {
      if((MAKINUM(65535)&sf)>=(MAKINUM(65535)&gf)) {
        if((MAKINUM(2047)&sf)>=(MAKINUM(2047)&gf))
          return SBOOL((MAKINUM(31)&sf)>=(MAKINUM(31)&gf));
        else
          return BOOL_F;
      }
      else
        return BOOL_F;
    }
    else
      return BOOL_F;
  }
  else
    return BOOL_F;
}

SCM ground_lit_equal_pred_(xlit,ylit)
SCM xlit,ylit;
{
  return composite_equal_pred_(xlit,ylit);
}

SCM term_equal_pred_(xterm,yterm)
SCM xterm,yterm;
{
  SCM xel,yel;

  if(xterm==yterm)
    return BOOL_T;
  else
  if(NUMBER_P(xterm)||(NUMBER_P(yterm)||!(CAR(xterm)==CAR(yterm))))
    return BOOL_F;
  else {
    xterm=CDR(xterm);
    yterm=CDR(yterm);
    for(;!(NULL_P(xterm));) {
      xel=CAR(xterm);
      yel=CAR(yterm);
      if((xel==yel)||(!(NUMBER_P(xel))&&(!(NUMBER_P(yel))&&NFALSEP(composite_equal_pred_(xel,yel))))) {
        xterm=CDR(xterm);
        yterm=CDR(yterm);
      }
      else {
        xterm=EOL;
        yterm=BOOL_T;
      }
    }
    return SBOOL(NULL_P(yterm));
  }
}

SCM composite_equal_pred_(xcomp,ycomp)
SCM xcomp,ycomp;
{
  SCM xel,yel;

  if(CAR(xcomp)==CAR(ycomp)) {
    xcomp=CDR(xcomp);
    ycomp=CDR(ycomp);
    for(;!(NULL_P(xcomp));) {
      xel=CAR(xcomp);
      yel=CAR(ycomp);
      if((xel==yel)||(!(NUMBER_P(xel))&&(!(NUMBER_P(yel))&&NFALSEP(composite_equal_pred_(xel,yel))))) {
        xcomp=CDR(xcomp);
        ycomp=CDR(ycomp);
      }
      else {
        xcomp=EOL;
        ycomp=BOOL_T;
      }
    }
    return SBOOL(NULL_P(ycomp));
  }
  else
    return BOOL_F;
}

SCM term_equal_strong_pred_(xterm,yterm)
SCM xterm,yterm;
{
  if(NUMBER_P(xterm)) {
    if(NUMBER_P(yterm)) {
      if(MAKINUM(65535)>xterm)
        return SBOOL((MAKINUM(8191)&xterm)==(MAKINUM(8191)&yterm));
      else
        return SBOOL(xterm==yterm);
    }
    else
      return BOOL_F;
  }
  else
  if(!(NUMBER_P(yterm)))
    return composite_equal_strong_pred_(xterm,yterm);
  else
    return BOOL_F;
}

SCM composite_equal_strong_pred_(xcomp,ycomp)
SCM xcomp,ycomp;
{
  SCM xel,yel;

  if((MAKINUM(534904831)&CAR(xcomp))==(MAKINUM(534904831)&CAR(ycomp))) {
    xcomp=CDR(xcomp);
    ycomp=CDR(ycomp);
    for(;!(NULL_P(xcomp));) {
      xel=CAR(xcomp);
      yel=CAR(ycomp);
      if(NUMBER_P(xel)) {
        if(NUMBER_P(yel)) {
          if(MAKINUM(65535)>xel) {
            if((MAKINUM(8191)&xel)==(MAKINUM(8191)&yel)) {
              xcomp=CDR(xcomp);
              ycomp=CDR(ycomp);
            }
            else {
              xcomp=EOL;
              ycomp=BOOL_T;
            }
          }
          else
          if(xel==yel) {
            xcomp=CDR(xcomp);
            ycomp=CDR(ycomp);
          }
          else {
            xcomp=EOL;
            ycomp=BOOL_T;
          }
        }
        else {
          xcomp=EOL;
          ycomp=BOOL_T;
        }
      }
      else
      if(!(NUMBER_P(yel))&&NFALSEP(composite_equal_strong_pred_(xel,yel))) {
        xcomp=CDR(xcomp);
        ycomp=CDR(ycomp);
      }
      else {
        xcomp=EOL;
        ycomp=BOOL_T;
      }
    }
    return SBOOL(NULL_P(ycomp));
  }
  else
    return BOOL_F;
}

SCM term_list_equal_pred_(xlst,ylst)
SCM xlst,ylst;
{
  for(;!(NULL_P(xlst));)
    if(NFALSEP(term_equal_pred_(CAR(xlst),CAR(ylst)))) {
      xlst=CDR(xlst);
      ylst=CDR(ylst);
    }
    else {
      xlst=EOL;
      ylst=BOOL_T;
    }
  return SBOOL(NULL_P(ylst));
}

SCM swapped_term_list_equal_pred_(xlst,ylst)
SCM xlst,ylst;
{
  if(NFALSEP(term_equal_pred_(CAR(xlst),CAR(CDR(ylst))))) {
    if(NFALSEP(term_equal_pred_(CAR(CDR(xlst)),CAR(ylst))))
      return term_list_equal_pred_(CDR(CDR(xlst)),CDR(CDR(ylst)));
    else
      return BOOL_F;
  }
  else
    return BOOL_F;
}

SCM term_list_equal_strong_pred_(xlst,ylst)
SCM xlst,ylst;
{
  for(;!(NULL_P(xlst));)
    if(NFALSEP(term_equal_strong_pred_(CAR(xlst),CAR(ylst)))) {
      xlst=CDR(xlst);
      ylst=CDR(ylst);
    }
    else {
      xlst=EOL;
      ylst=BOOL_T;
    }
  return SBOOL(NULL_P(ylst));
}

SCM swapped_term_list_equal_strong_pred_(xlst,ylst)
SCM xlst,ylst;
{
  if(NFALSEP(term_equal_strong_pred_(CAR(xlst),CAR(CDR(ylst))))) {
    if(NFALSEP(term_equal_strong_pred_(CAR(CDR(xlst)),CAR(ylst))))
      return term_list_equal_strong_pred_(CDR(CDR(xlst)),CDR(CDR(ylst)));
    else
      return BOOL_F;
  }
  else
    return BOOL_F;
}

SCM clause_can_subsume_pred_(sclstrength,sclpreds,gclinfo)
SCM sclstrength,sclpreds,gclinfo;
{
  SCM gclpreds,gclstrength;

  gclstrength=CAR(gclinfo);
  if(((MAKINUM(8388607)&sclstrength)>=(MAKINUM(8388607)&gclstrength))&&(((MAKINUM(131071)&sclstrength)>=(MAKINUM(131071)&gclstrength))&&(((MAKINUM(65535)&sclstrength)>=(MAKINUM(65535)&gclstrength))&&(((MAKINUM(2047)&sclstrength)>=(MAKINUM(2047)&gclstrength))&&((MAKINUM(31)&sclstrength)>=(MAKINUM(31)&gclstrength)))))) {
    gclpreds=CAR(CDR(gclinfo));
    return SBOOL(gclpreds==(gclpreds&sclpreds));
  }
  else
    return BOOL_F;
}

SCM pure_clause_may_cont_vars_pred_(cl)
SCM cl;
{
  SCM res;

  res=BOOL_F;
  for(;!(NULL_P(cl)||NFALSEP(res));)
    if(ZERO_P(MAKINUM(65536)&CAR(CAR(cl)))) {
      res=BOOL_T;
    }
    else {
      cl=CDR(cl);
    }
  return res;
}

SCM var_nr(var)
SCM var;
{
  return MAKINUM(8191)&var;
}

SCM y_var_pred_(var)
SCM var;
{
  return NOT(SBOOL(ZERO_P(MAKINUM(256)&var)));
}

SCM x_var_pred_(var)
SCM var;
{
  return SBOOL(ZERO_P(MAKINUM(256)&var));
}

SCM unassigned_val_pred_(x)
SCM x;
{
  return SBOOL(x==MAKINUM(99999999));
}

SCM touched_var_pred_(var)
SCM var;
{
  return STBL_VECTOR_REF(_star_var_touched_table_star__velts0,var);
}

SCM set_var_touched_excl_(var,val)
SCM var,val;
{
  STBL_VECTOR_SET(_star_var_touched_table_star__velts0,var,val);
  return UNSPECIFIED;
}

SCM var_ref(var)
SCM var;
{
  return STBL_VECTOR_REF(_star_var_val_table_star__velts0,var);
}

SCM set_var_ref_excl_(var,val)
SCM var,val;
{
  STBL_VECTOR_SET(_star_var_val_table_star__velts0,var,val);
  return UNSPECIFIED;
}

SCM var_val(var)
SCM var;
{
  SCM var1,var2;

  for(var1=var,var2=STBL_VECTOR_REF(_star_var_val_table_star__velts0,MAKINUM(8191)&var);
      NUMBER_P(var2)&&(var2<=MAKINUM(65535));
      var1=var2,var2=STBL_VECTOR_REF(_star_var_val_table_star__velts0,MAKINUM(8191)&var2)) ;
  if(var2==MAKINUM(99999999))
    return var1;
  else
    return var2;
}

SCM dereference_var(var)
SCM var;
{
  SCM ref;

  ref=STBL_VECTOR_REF(_star_var_val_table_star__velts0,var);
  if(ref==MAKINUM(99999999))
    return var;
  else
  if(NFALSEP(STBL_VECTOR_REF(_star_var_touched_table_star__velts0,var))) {
    if(NUMBER_P(ref))
      return ref;
    else
      return dereference_copy_term(ref);
  }
  else {
    STBL_VECTOR_SET(_star_var_touched_table_star__velts0,var,BOOL_T);
    ref=subst_deco_term(ref,BOOL_F);
    STBL_VECTOR_SET(_star_var_val_table_star__velts0,var,ref);
    return ref;
  }
}

SCM dereference_copy_term(term)
SCM term;
{
  SCM fun;

  fun=CAR(term);
  if(ZERO_P(MAKINUM(65536)&fun))
    return cons(fun,map1(dereference_copy_aux,CDR(term)));
  else
    return term;
}

SCM dereference_copy_aux(term)
SCM term;
{
  SCM fun;

  if(NUMBER_P(term))
    return term;
  else {
    fun=CAR(term);
    if(ZERO_P(MAKINUM(65536)&fun))
      return cons(fun,map1(dereference_copy_aux,CDR(term)));
    else
      return term;
  }
}

SCM clear_x_vars_excl_(var)
SCM var;
{
  for(;!(ZERO_P(var));) {
    STBL_VECTOR_SET(_star_var_val_table_star__velts0,var,MAKINUM(99999999));
    var=MAKINUM(INUM(var)-1);
  }
  return UNSPECIFIED;
}

SCM clear_x_vars_and_touched_excl_(var)
SCM var;
{
  for(;!(ZERO_P(var));) {
    STBL_VECTOR_SET(_star_var_val_table_star__velts0,var,MAKINUM(99999999));
    STBL_VECTOR_SET(_star_var_touched_table_star__velts0,var,BOOL_F);
    var=MAKINUM(INUM(var)-1);
  }
  return UNSPECIFIED;
}

SCM clear_y_vars_excl_(var)
SCM var;
{
  var=(MAKINUM(256)|var);
  for(;!(MAKINUM(256)==var);) {
    STBL_VECTOR_SET(_star_var_val_table_star__velts0,var,MAKINUM(99999999));
    var=MAKINUM(INUM(var)-1);
  }
  return UNSPECIFIED;
}

SCM clear_y_vars_and_touched_excl_(var)
SCM var;
{
  var=(MAKINUM(256)|var);
  for(;!(MAKINUM(256)==var);) {
    STBL_VECTOR_SET(_star_var_val_table_star__velts0,var,MAKINUM(99999999));
    STBL_VECTOR_SET(_star_var_touched_table_star__velts0,var,BOOL_F);
    var=MAKINUM(INUM(var)-1);
  }
  return UNSPECIFIED;
}

SCM clear_z_vars_excl_(var)
SCM var;
{
  var=(MAKINUM(512)|var);
  for(;!(MAKINUM(512)==var);) {
    STBL_VECTOR_SET(_star_var_val_table_star__velts0,var,MAKINUM(99999999));
    var=MAKINUM(INUM(var)-1);
  }
  return UNSPECIFIED;
}

SCM clear_z_vars_and_touched_excl_(var)
SCM var;
{
  var=(MAKINUM(512)|var);
  for(;!(MAKINUM(512)==var);) {
    STBL_VECTOR_SET(_star_var_val_table_star__velts0,var,MAKINUM(99999999));
    STBL_VECTOR_SET(_star_var_touched_table_star__velts0,var,BOOL_F);
    var=MAKINUM(INUM(var)-1);
  }
  return UNSPECIFIED;
}

SCM set_x_vars_selfref_touched_excl_(var)
SCM var;
{
  for(;!(ZERO_P(var));) {
    STBL_VECTOR_SET(_star_var_val_table_star__velts0,var,var);
    STBL_VECTOR_SET(_star_var_touched_table_star__velts0,var,BOOL_T);
    var=MAKINUM(INUM(var)-1);
  }
  return UNSPECIFIED;
}

SCM clear_gcl_vars()
{
  return clear_x_vars_excl_(gcl_maxvar_global);
}

SCM restore_gcl_vars()
{
  SCM var,frame;

  for(var=MAKINUM(1),frame=CAR(GLOBAL(gcl_varsstack_global));
      !(NULL_P(frame));
      var=MAKINUM(1+INUM(var)),frame=CDR(frame)) {
    STBL_VECTOR_SET(_star_var_val_table_star__velts0,var,CAR(frame));
  }
  GLOBAL(gcl_varsstack_global)=CDR(GLOBAL(gcl_varsstack_global));
  return UNSPECIFIED;
}

SCM save_gcl_vars()
{
  SCM var,res;

  res=EOL;
  for(var=gcl_maxvar_global;!(ZERO_P(var));var=MAKINUM(INUM(var)-1)) {
    res=cons(STBL_VECTOR_REF(_star_var_val_table_star__velts0,var),res);
  }
  GLOBAL(gcl_varsstack_global)=cons(res,GLOBAL(gcl_varsstack_global));
  return UNSPECIFIED;
}

SCM pop_gcl_vars_stack()
{
  GLOBAL(gcl_varsstack_global)=CDR(GLOBAL(gcl_varsstack_global));
  return UNSPECIFIED;
}

SCM copy_nonground_term(term)
SCM term;
{
  if(PAIR_P(term)) {
    if(ZERO_P(MAKINUM(65536)&CAR(term)))
      return cons(CAR(term),map1(copy_nonground_term,CDR(term)));
    else
      return term;
  }
  else
    return term;
}

SCM rename_x_to_y_term(term)
SCM term;
{
  SCM fun;

  if(NUMBER_P(term)) {
    if(MAKINUM(65535)>term)
      return MAKINUM(256)|term;
    else
      return term;
  }
  else {
    fun=CAR(term);
    if(ZERO_P(MAKINUM(65536)&fun))
      return cons(fun,map1(rename_x_to_y_term,CDR(term)));
    else
      return term;
  }
}

SCM rename_y_to_x_term(term)
SCM term;
{
  SCM fun;

  if(NUMBER_P(term)) {
    if(MAKINUM(65535)>term)
      return MAKINUM(256^INUM(term));
    else
      return term;
  }
  else {
    fun=CAR(term);
    if(ZERO_P(MAKINUM(65536)&fun))
      return cons(fun,map1(rename_y_to_x_term,CDR(term)));
    else
      return term;
  }
}

SCM rename_x_to_z_term(term)
SCM term;
{
  SCM fun;

  if(NUMBER_P(term)) {
    if(MAKINUM(65535)>term)
      return MAKINUM(512)|term;
    else
      return term;
  }
  else {
    fun=CAR(term);
    if(ZERO_P(MAKINUM(65536)&fun))
      return cons(fun,map1(rename_x_to_z_term,CDR(term)));
    else
      return term;
  }
}

SCM rename_x_to_y_term_excl_(cterm)
SCM cterm;
{
  SCM el,part;

  if(ZERO_P(MAKINUM(65536)&CAR(cterm))) {
    for(part=CDR(cterm);!(NULL_P(part));part=CDR(part)) {
      el=CAR(part);
      if(!(NUMBER_P(el)))
        rename_x_to_y_term_excl_(el);
      else
      if(MAKINUM(65535)>el) {
        SET_CAR(part,MAKINUM(256)|el);
      }
    }
    return UNSPECIFIED;
  }
  else
    return UNSPECIFIED;
}

SCM rename_y_to_x_term_excl_(cterm)
SCM cterm;
{
  SCM el,part;

  if(ZERO_P(MAKINUM(65536)&CAR(cterm))) {
    for(part=CDR(cterm);!(NULL_P(part));part=CDR(part)) {
      el=CAR(part);
      if(!(NUMBER_P(el)))
        rename_y_to_x_term_excl_(el);
      else
      if(MAKINUM(65535)>el) {
        SET_CAR(part,MAKINUM(256^INUM(el)));
      }
    }
    return UNSPECIFIED;
  }
  else
    return UNSPECIFIED;
}

SCM subst_deco_term(term,litflag)
SCM term,litflag;
{
  SCM new,part,res,resend,str,fun;

  if(NUMBER_P(term)) {
    if(MAKINUM(65535)>term)
      return dereference_var(MAKINUM(8191)&term);
    else
    if(NFALSEP(GLOBAL(demodulate_constants_flag_global)))
      return demodulate_constant(term);
    else
      return term;
  }
  else {
    fun=CAR(term);
    if(NFALSEP(GLOBAL(new_demodulators_flag_global))||ZERO_P(MAKINUM(65536)&fun)) {
      if(GLOBAL(case_fun_nr_global)==(MAKINUM(534773760)&fun))
        return subst_deco_case_term(term);
      else {
        res=cons(EOL,EOL);
        resend=res;
        str=MAKINUM(65536);
        for(part=CDR(term);!(NULL_P(part));part=CDR(part)) {
          new=subst_deco_term(CAR(part),BOOL_F);
          SET_CDR(resend,cons(new,EOL));
          if(resend==res) {
            if(NUMBER_P(new)) {
              if(MAKINUM(65535)>new) {
                str=GLOBAL(var_strength_global);
              }
              else {
                str=GLOBAL(const_strength_global);
              }
            }
            else {
              str=CAR(new);
            }
          }
          else
          if(NUMBER_P(new)) {
            if(MAKINUM(65535)>new) {
              str=sum_fun_strengths(GLOBAL(var_strength_global),str);
            }
            else {
              str=sum_fun_strengths(GLOBAL(const_strength_global),str);
            }
          }
          else {
            str=sum_fun_strengths(CAR(new),str);
          }
          resend=CDR(resend);
        }
        SET_CAR(res,create_new_fun_pos_object(fun,str));
        if(NFALSEP(GLOBAL(demodulate_flag_global))&&!(NFALSEP(litflag)))
          return demodulate_composite(res);
        else
        if(NFALSEP(litflag)&&NFALSEP(GLOBAL(demodulate_lit_flag_global)))
          return demodulate_lit(res);
        else
          return res;
      }
    }
    else
      return term;
  }
}

SCM deco_leading_fun(term)
SCM term;
{
  SCM part,fun,new,str;

  fun=CAR(term);
  new=EOL;
  str=MAKINUM(65536);
  for(part=CDR(term);!(NULL_P(part));part=CDR(part)) {
    new=CAR(part);
    if(part==CDR(term)) {
      if(NUMBER_P(new)) {
        if(MAKINUM(65535)>new) {
          str=GLOBAL(var_strength_global);
        }
        else {
          str=GLOBAL(const_strength_global);
        }
      }
      else {
        str=CAR(new);
      }
    }
    else
    if(NUMBER_P(new)) {
      if(MAKINUM(65535)>new) {
        str=sum_fun_strengths(GLOBAL(var_strength_global),str);
      }
      else {
        str=sum_fun_strengths(GLOBAL(const_strength_global),str);
      }
    }
    else {
      str=sum_fun_strengths(CAR(new),str);
    }
  }
  return cons(create_new_fun_pos_object(fun,str),CDR(term));
}

SCM subst_deco_term_nodemodulate(term,litflag)
SCM term,litflag;
{
  SCM tmp1,tmp2,tmp3,tmp4,res;

  tmp1=GLOBAL(demodulate_flag_global);
  tmp2=GLOBAL(demodulate_lit_flag_global);
  tmp3=GLOBAL(demodulate_constants_flag_global);
  tmp4=GLOBAL(new_demodulators_flag_global);
  res=EOL;
  GLOBAL(demodulate_flag_global)=BOOL_F;
  GLOBAL(demodulate_lit_flag_global)=BOOL_F;
  GLOBAL(demodulate_constants_flag_global)=BOOL_F;
  GLOBAL(new_demodulators_flag_global)=BOOL_F;
  res=subst_deco_term(term,litflag);
  GLOBAL(demodulate_flag_global)=tmp1;
  GLOBAL(demodulate_lit_flag_global)=tmp2;
  GLOBAL(demodulate_constants_flag_global)=tmp3;
  GLOBAL(new_demodulators_flag_global)=tmp4;
  return res;
}

SCM subst_deco_case_term(caseterm)
SCM caseterm;
{
  SCM caselist,value,successres,tmp;

  value=subst_deco_term(CAR(CDR(caseterm)),BOOL_F);
  successres=BOOL_F;
  tmp=EOL;
  for(caselist=CAR(CDR(CDR(caseterm)));!(!(!(NUMBER_P(caselist)))||NFALSEP(successres));caselist=CAR(CDR(CDR(CDR(caselist))))) {
    tmp=subst_deco_term(CAR(CDR(caselist)),BOOL_F);
    tmp=subsumed_term_ordinary_collectvars_pred_(value,tmp);
    if(NFALSEP(CAR(tmp))) {
      successres=subst_deco_term(CAR(CDR(CDR(caselist))),BOOL_F);
      clear_varlist(CDR(tmp));
    }
    else
      clear_varlist(CDR(tmp));
  }
  if(NFALSEP(successres))
    return successres;
  else
    return deco_leading_fun(cons(GLOBAL(case_fun_nr_global),cons(value,cons(subst_deco_term(CAR(CDR(CDR(caseterm))),BOOL_F),EOL))));
}

SCM clear_varlist(lst)
SCM lst;
{
  SCM lstpart;

  for(lstpart=lst;!(NULL_P(lstpart));lstpart=CDR(lstpart)) {
    STBL_VECTOR_SET(_star_var_val_table_star__velts0,MAKINUM(8191)&CAR(lstpart),MAKINUM(99999999));
  }
  return UNSPECIFIED;
}

SCM subst_deco_term_nodemodulate_spec(term)
SCM term;
{
  SCM new,part,res,resend,str,fun;

  if(NUMBER_P(term)) {
    if(MAKINUM(65535)>term)
      return dereference_var(MAKINUM(8191)&term);
    else
      return term;
  }
  else {
    fun=CAR(term);
    if(ZERO_P(MAKINUM(65536)&fun)) {
      res=cons(EOL,EOL);
      resend=res;
      str=MAKINUM(65536);
      for(part=CDR(term);!(NULL_P(part));part=CDR(part)) {
        new=subst_deco_term_nodemodulate_spec(CAR(part));
        SET_CDR(resend,cons(new,EOL));
        if(resend==res) {
          if(NUMBER_P(new)) {
            if(MAKINUM(65535)>new) {
              str=GLOBAL(var_strength_global);
            }
            else {
              str=GLOBAL(const_strength_global);
            }
          }
          else {
            str=CAR(new);
          }
        }
        else
        if(NUMBER_P(new)) {
          if(MAKINUM(65535)>new) {
            str=sum_fun_strengths(GLOBAL(var_strength_global),str);
          }
          else {
            str=sum_fun_strengths(GLOBAL(const_strength_global),str);
          }
        }
        else {
          str=sum_fun_strengths(CAR(new),str);
        }
        resend=CDR(resend);
      }
      SET_CAR(res,create_new_fun_pos_object(fun,str));
      return res;
    }
    else
      return term;
  }
}

SCM subst_deco_replace_term(term,path,replterm,litflag)
SCM term,path,replterm,litflag;
{
  SCM part,nrpart,fun,nr,res,resend,new,str;

  if(NULL_P(path))
    return subst_deco_term(replterm,litflag);
  else
  if(NUMBER_P(term)) {
    if(MAKINUM(65535)>term)
      return dereference_var(MAKINUM(8191)&term);
    else
    if(NFALSEP(GLOBAL(demodulate_constants_flag_global)))
      return demodulate_constant(term);
    else
      return term;
  }
  else {
    fun=CAR(term);
    nr=CAR(path);
    res=cons(EOL,EOL);
    resend=res;
    new=EOL;
    str=MAKINUM(65536);
    for(part=CDR(term),nrpart=MAKINUM(INUM(nr)-1);
        !(NULL_P(part));
        part=CDR(part),nrpart=MAKINUM(INUM(nrpart)-1)) {
      if(ZERO_P(nrpart)) {
        new=subst_deco_replace_term(CAR(part),CDR(path),replterm,BOOL_F);
      }
      else {
        new=subst_deco_term(CAR(part),BOOL_F);
      }
      SET_CDR(resend,cons(new,EOL));
      if(resend==res) {
        if(NUMBER_P(new)) {
          if(MAKINUM(65535)>new) {
            str=GLOBAL(var_strength_global);
          }
          else {
            str=GLOBAL(const_strength_global);
          }
        }
        else {
          str=CAR(new);
        }
      }
      else
      if(NUMBER_P(new)) {
        if(MAKINUM(65535)>new) {
          str=sum_fun_strengths(GLOBAL(var_strength_global),str);
        }
        else {
          str=sum_fun_strengths(GLOBAL(const_strength_global),str);
        }
      }
      else {
        str=sum_fun_strengths(CAR(new),str);
      }
      resend=CDR(resend);
    }
    SET_CAR(res,create_new_fun_pos_object(fun,str));
    if(NFALSEP(GLOBAL(demodulate_flag_global))&&!(NFALSEP(litflag)))
      return demodulate_composite(res);
    else
    if(NFALSEP(litflag)&&NFALSEP(GLOBAL(demodulate_lit_flag_global)))
      return demodulate_lit(res);
    else
      return res;
  }
}

SCM subst_deco_replace_term_nodemodulate(term,path,replterm,litflag)
SCM term,path,replterm,litflag;
{
  SCM tmp1,tmp2,tmp3,tmp4,res;

  tmp1=GLOBAL(demodulate_flag_global);
  tmp2=GLOBAL(demodulate_lit_flag_global);
  tmp3=GLOBAL(demodulate_constants_flag_global);
  tmp4=GLOBAL(new_demodulators_flag_global);
  res=EOL;
  GLOBAL(demodulate_flag_global)=BOOL_F;
  GLOBAL(demodulate_lit_flag_global)=BOOL_F;
  GLOBAL(demodulate_constants_flag_global)=BOOL_F;
  GLOBAL(new_demodulators_flag_global)=BOOL_F;
  res=subst_deco_replace_term(term,path,replterm,litflag);
  GLOBAL(demodulate_flag_global)=tmp1;
  GLOBAL(demodulate_lit_flag_global)=tmp2;
  GLOBAL(demodulate_constants_flag_global)=tmp3;
  GLOBAL(new_demodulators_flag_global)=tmp4;
  return res;
}

SCM replace_subterm(term,path,replterm)
SCM term,path,replterm;
{
  SCM part,nrpart,fun,nr,res,resend,new,str;

  if(NULL_P(path))
    return replterm;
  else
  if(NUMBER_P(term))
    return term;
  else {
    fun=CAR(term);
    nr=CAR(path);
    res=cons(EOL,EOL);
    resend=res;
    new=EOL;
    str=MAKINUM(65536);
    for(part=CDR(term),nrpart=MAKINUM(INUM(nr)-1);
        !(NULL_P(part));
        part=CDR(part),nrpart=MAKINUM(INUM(nrpart)-1)) {
      if(ZERO_P(nrpart)) {
        new=replace_subterm(CAR(part),CDR(path),replterm);
      }
      else {
        new=CAR(part);
      }
      SET_CDR(resend,cons(new,EOL));
      if(resend==res) {
        if(NUMBER_P(new)) {
          if(MAKINUM(65535)>new) {
            str=GLOBAL(var_strength_global);
          }
          else {
            str=GLOBAL(const_strength_global);
          }
        }
        else {
          str=CAR(new);
        }
      }
      else
      if(NUMBER_P(new)) {
        if(MAKINUM(65535)>new) {
          str=sum_fun_strengths(GLOBAL(var_strength_global),str);
        }
        else {
          str=sum_fun_strengths(GLOBAL(const_strength_global),str);
        }
      }
      else {
        str=sum_fun_strengths(CAR(new),str);
      }
      resend=CDR(resend);
    }
    SET_CAR(res,create_new_fun_pos_object(fun,str));
    return res;
  }
}

SCM subterm_at_path(term,path)
SCM term,path;
{
  SCM tmp_var1,tmp_var2,termpart,nrpart;

tailrecursion:
  if(NULL_P(path))
    return term;
  else {
    for(termpart=term,nrpart=CAR(path);
        !(ZERO_P(nrpart));
        termpart=CDR(termpart),nrpart=MAKINUM(INUM(nrpart)-1)) ;
    tmp_var1=CAR(termpart);
    tmp_var2=CDR(path);
    term=tmp_var1;
    path=tmp_var2;
    goto tailrecursion;
  }
}

SCM subst_deco_weight_term(term,depth,scope)
SCM term,depth,scope;
{
  SCM newpair,new,weight__3,res__1,resend,part,weight__2,str,fun,failflag,res,weight;

  if(NUMBER_P(term)) {
    if(MAKINUM(65535)>term)
      res=dereference_var(MAKINUM(8191)&term);
    else
      res=term;
    weight=compute_term_weight(res,depth,scope);
    if(INTEGER_P(weight))
      return cons(weight,res);
    else
      return BOOL_F;
  }
  else {
    fun=CAR(term);
    failflag=BOOL_F;
    if(ZERO_P(MAKINUM(65536)&fun)) {
      res__1=cons(EOL,EOL);
      resend=res__1;
      part=CDR(term);
      weight__2=MAKINUM(0);
      str=MAKINUM(65536);
      for(;!(NULL_P(part));) {
        newpair=subst_deco_weight_term(CAR(part));
        new=CDR(newpair);
        weight__3=CAR(newpair);
        if(INTEGER_P(weight__3)) {
          SET_CDR(resend,cons(new,EOL));
          if(resend==res__1) {
            if(NUMBER_P(new)) {
              if(MAKINUM(65535)>new) {
                str=GLOBAL(var_strength_global);
              }
              else {
                str=GLOBAL(const_strength_global);
              }
            }
            else {
              str=CAR(new);
            }
          }
          else
          if(NUMBER_P(new)) {
            if(MAKINUM(65535)>new) {
              str=sum_fun_strengths(GLOBAL(var_strength_global),str);
            }
            else {
              str=sum_fun_strengths(GLOBAL(const_strength_global),str);
            }
          }
          else {
            str=sum_fun_strengths(CAR(new),str);
          }
          resend=CDR(resend);
          part=CDR(part);
        }
        else {
          part=EOL;
          failflag=BOOL_T;
        }
      }
      if(NFALSEP(failflag))
        return BOOL_F;
      else {
        SET_CAR(res__1,create_new_fun_pos_object(fun,str));
        return cons(weight__2,res__1);
      }
    }
    else
      return UNSPECIFIED;
  }
}

SCM compute_term_weight(x,y,z)
SCM x,y,z;
{
  return MAKINUM(0);
}

SCM sum_fun_strengths(fnx,fny)
SCM fnx,fny;
{
  SCM newmaxplusnr__1,newmaxplusnr;

  return ((MAKINUM(65536)&fnx)&(MAKINUM(65536)&fny))|((((MAKINUM(63488)&fnx)>(MAKINUM(63488)&fny)) ? (MAKINUM(63488)&fnx) : (MAKINUM(63488)&fny))|((newmaxplusnr=MAKINUM(INUM(MAKINUM(2047)&fnx)+INUM(MAKINUM(2047)&fny)),((newmaxplusnr>MAKINUM(2016)) ? MAKINUM(2016) : newmaxplusnr))|(newmaxplusnr__1=MAKINUM(INUM(MAKINUM(31)&fnx)+INUM(MAKINUM(31)&fny)),((newmaxplusnr__1>MAKINUM(31)) ? MAKINUM(31) : newmaxplusnr__1))));
}

SCM create_new_fun_pos_object(oldfun,argsstrn)
SCM oldfun,argsstrn;
{
  SCM newmaxplusnr__1,newmaxplusnr;

  return (MAKINUM(534773760)&oldfun)|(((newmaxplusnr=MAKINUM(2048+INUM(MAKINUM(63488)&argsstrn)),((newmaxplusnr>MAKINUM(63488)) ? MAKINUM(63488) : newmaxplusnr))|(newmaxplusnr__1=MAKINUM(32+INUM(MAKINUM(2016)&argsstrn)),((newmaxplusnr__1>MAKINUM(2016)) ? MAKINUM(2016) : newmaxplusnr__1)))|((MAKINUM(65536)|MAKINUM(31))&argsstrn));
}

SCM collect_vars_composite_excl_(composite)
SCM composite;
{
  SCM elvars,el,comppart,fun,repeating,vars;

  fun=CAR(composite);
  repeating=EOL;
  vars=EOL;
  for(comppart=CDR(composite);!(NULL_P(comppart));comppart=CDR(comppart)) {
    el=CAR(comppart);
    if(NUMBER_P(el)) {
      if(MAKINUM(65535)>el) {
        el=(MAKINUM(8191)&el);
        if(!(NFALSEP(memq(el,repeating)))) {
          if(NFALSEP(memq(el,vars))) {
            repeating=cons(el,repeating);
          }
          else {
            vars=cons(el,vars);
          }
        }
      }
    }
    else
    if(ZERO_P(MAKINUM(65536)&CAR(el))) {
      elvars=collect_vars_composite_excl_(el);
      vars=intersection_union(CAR(elvars),CDR(elvars),repeating,vars);
      repeating=GLOBAL(intersection_tmp_global);
    }
  }
  if(!(NULL_P(repeating))) {
    SET_CAR(composite,MAKINUM(131072)|fun);
  }
  return cons(repeating,vars);
}

SCM intersection_union(xrep,xvars,yrep,yvars)
SCM xrep,xvars,yrep,yvars;
{
  SCM tmprep;

  if(NULL_P(yvars)) {
    GLOBAL(intersection_tmp_global)=xrep;
    return xvars;
  }
  else {
    tmprep=union_nonkeyword(xrep,yrep);
    GLOBAL(intersection_tmp_global)=tmprep;
    return intersection_union_aux(xvars,yvars);
  }
}

SCM intersection_union_aux(xvars,yvars)
SCM xvars,yvars;
{
tailrecursion:
  if(NULL_P(xvars))
    return yvars;
  else
  if(NFALSEP(memq(CAR(xvars),yvars))) {
    if(!(NFALSEP(memq(CAR(xvars),GLOBAL(intersection_tmp_global))))) {
      GLOBAL(intersection_tmp_global)=cons(CAR(xvars),GLOBAL(intersection_tmp_global));
    }
    xvars=CDR(xvars);
    goto tailrecursion;
  }
  else
    return cons(CAR(xvars),intersection_union_aux(CDR(xvars),yvars));
}

SCM decorate_vars_lit_excl_(lit,rep_lit_vars,lit_vars,other_lit_vars,foll_lit_vars)
SCM lit,rep_lit_vars,lit_vars,other_lit_vars,foll_lit_vars;
{
  SCM el,renamed,new,varspart;

  if(!(NULL_P(lit_vars))) {
    for(varspart=reverse(lit_vars);!(NULL_P(varspart));varspart=CDR(varspart)) {
      el=CAR(varspart);
      renamed=assq(el,GLOBAL(new_var_names_global));
      new=EOL;
      if(NFALSEP(renamed)) {
        new=(MAKINUM(8191)&CDR(renamed));
      }
      else {
        clause_var_nr_global=MAKINUM(1+INUM(clause_var_nr_global));
        if(clause_var_nr_global>MAKINUM(255)) {
          GLOBAL(too_many_vars_flag_global)=BOOL_T;
        }
        new=clause_var_nr_global;
      }
      if(!(NFALSEP(memq(el,rep_lit_vars)))) {
        new=(MAKINUM(32768)|new);
      }
      if(!(NFALSEP(member_memq_pred_(el,other_lit_vars)))) {
        new=(MAKINUM(16384)|new);
      }
      if(!(NFALSEP(member_memq_pred_(el,foll_lit_vars)))) {
        new=(MAKINUM(8192)|new);
      }
      if(NFALSEP(renamed)) {
        SET_CDR(renamed,new);
      }
      else {
        GLOBAL(new_var_names_global)=cons(cons(el,new),GLOBAL(new_var_names_global));
      }
    }
    return decorate_vars_composite_excl_(lit,GLOBAL(new_var_names_global));
  }
  else
    return UNSPECIFIED;
}

SCM decorate_vars_composite_excl_(composite,alist)
SCM composite,alist;
{
  SCM el,comppart;

  for(comppart=CDR(composite);!(NULL_P(comppart));comppart=CDR(comppart)) {
    el=CAR(comppart);
    if(NUMBER_P(el)) {
      if(MAKINUM(65535)>el) {
        SET_CAR(comppart,CDR(assq(MAKINUM(8191)&el,alist)));
      }
    }
    else
    if(ZERO_P(MAKINUM(65536)&CAR(el)))
      decorate_vars_composite_excl_(el,alist);
  }
  return UNSPECIFIED;
}

SCM resolve_unify_ordinary(xfun,yfun,xlit,ylit)
SCM xfun,yfun,xlit,ylit;
{
  SCM new_var2,xpart,ypart,fail_flag;

  if(ZERO_P(MAKINUM(65536)&xfun)) {
    if(ZERO_P(MAKINUM(65536)&yfun)) {
      fail_flag=BOOL_F;
      if(!(ZERO_P(MAKINUM(131072)&xfun)))
        repeatedvars_flag_global=NOT(SBOOL(ZERO_P(MAKINUM(131072)&yfun)));
      else
        repeatedvars_flag_global=BOOL_F;
      occurcheck_flag_global=BOOL_F;
      xvars_set_flag_global=BOOL_F;
      yvars_set_flag_global=BOOL_F;
      for(xpart=CDR(xlit),ypart=CDR(ylit);
          !(NFALSEP(fail_flag)||NULL_P(xpart));
          xpart=CDR(xpart),ypart=CDR(ypart))
        if(!(NFALSEP(resolve_unify_ordinary_aux(CAR(xpart),CAR(ypart))))) {
          fail_flag=BOOL_T;
        }
      return NOT(fail_flag);
    }
    else {
      yvars_set_flag_global=BOOL_F;
      if((MAKINUM(65535)&xfun)>(MAKINUM(65535)&yfun)) {
        xvars_set_flag_global=BOOL_F;
        return BOOL_F;
      }
      else {
        var_set_flag_global=BOOL_F;
        alt_var_set_flag_global=BOOL_F;
        if(NFALSEP(subsumed_term_list_ordinary_pred_(CDR(ylit),CDR(xlit)))) {
          xvars_set_flag_global=BOOL_T;
          return BOOL_T;
        }
        else {
          if(NFALSEP(var_set_flag_global)||NFALSEP(alt_var_set_flag_global)) {
            xvars_set_flag_global=BOOL_T;
          }
          else {
            xvars_set_flag_global=BOOL_F;
          }
          return BOOL_F;
        }
      }
    }
  }
  else
  if(ZERO_P(MAKINUM(65536)&yfun)) {
    xvars_set_flag_global=BOOL_F;
    if((MAKINUM(65535)&yfun)>(MAKINUM(65535)&xfun)) {
      yvars_set_flag_global=BOOL_F;
      return BOOL_F;
    }
    else {
      var_set_flag_global=BOOL_F;
      alt_var_set_flag_global=BOOL_F;
      if(NFALSEP(subsumed_term_list_ordinary_pred_(CDR(xlit),CDR(ylit)))) {
        yvars_set_flag_global=BOOL_T;
        return BOOL_T;
      }
      else {
        if(NFALSEP(var_set_flag_global)||NFALSEP(alt_var_set_flag_global)) {
          yvars_set_flag_global=BOOL_T;
        }
        else {
          yvars_set_flag_global=BOOL_F;
        }
        return BOOL_F;
      }
    }
  }
  else {
    xvars_set_flag_global=BOOL_F;
    yvars_set_flag_global=BOOL_F;
    new_var2=SBOOL(CDR(xlit)==CDR(ylit));
    if(NFALSEP(new_var2))
      return new_var2;
    else
    if(NFALSEP(GLOBAL(compare_ground_litcdr_equal_flag_global))) {
      if((MAKINUM(65535)&xfun)==(MAKINUM(65535)&yfun))
        return term_list_equal_pred_(CDR(xlit),CDR(ylit));
      else
        return BOOL_F;
    }
    else
      return BOOL_F;
  }
}

SCM resolve_unify_cutoff(xfun,yfun,xlit,ylit)
SCM xfun,yfun,xlit,ylit;
{
  SCM xpart,ypart,fail_flag;

  if(ZERO_P(MAKINUM(65536)&xfun)) {
    fail_flag=BOOL_F;
    if(!(ZERO_P(MAKINUM(131072)&xfun)))
      repeatedvars_flag_global=NOT(SBOOL(ZERO_P(MAKINUM(131072)&yfun)));
    else
      repeatedvars_flag_global=BOOL_F;
    occurcheck_flag_global=BOOL_F;
    xvars_set_flag_global=BOOL_F;
    yvars_set_flag_global=BOOL_F;
    for(xpart=CDR(xlit),ypart=CDR(ylit);
        !(NFALSEP(fail_flag)||NULL_P(xpart));
        xpart=CDR(xpart),ypart=CDR(ypart))
      if(!(NFALSEP(resolve_unify_cutoff_aux(CAR(xpart),CAR(ypart))))) {
        fail_flag=BOOL_T;
      }
    return NOT(fail_flag);
  }
  else {
    xvars_set_flag_global=BOOL_F;
    if((MAKINUM(65535)&yfun)>(MAKINUM(65535)&xfun)) {
      yvars_set_flag_global=BOOL_F;
      return BOOL_F;
    }
    else {
      var_set_flag_global=BOOL_F;
      alt_var_set_flag_global=BOOL_F;
      if(NFALSEP(subsumed_term_list_ordinary_pred_(CDR(xlit),CDR(ylit)))) {
        yvars_set_flag_global=BOOL_T;
        return BOOL_T;
      }
      else {
        if(NFALSEP(var_set_flag_global)||NFALSEP(alt_var_set_flag_global)) {
          yvars_set_flag_global=BOOL_T;
        }
        else {
          yvars_set_flag_global=BOOL_F;
        }
        return BOOL_F;
      }
    }
  }
}

SCM factor_unify_ordinary(xlit,ylit)
SCM xlit,ylit;
{
  SCM xpart,ypart,xfun,yfun,fail_flag;

  xfun=CAR(xlit);
  yfun=CAR(ylit);
  fail_flag=BOOL_F;
  if((MAKINUM(534773760)&xfun)==(MAKINUM(534773760)&yfun)) {
    if(ZERO_P(MAKINUM(65536)&xfun)) {
      if(ZERO_P(MAKINUM(65536)&yfun)) {
        for(xpart=CDR(xlit),ypart=CDR(ylit);
            !(NFALSEP(fail_flag)||NULL_P(xpart));
            xpart=CDR(xpart),ypart=CDR(ypart))
          if(!(NFALSEP(factor_unify_ordinary_aux(CAR(xpart),CAR(ypart))))) {
            fail_flag=BOOL_T;
          }
        return NOT(fail_flag);
      }
      else
      if((MAKINUM(65535)&xfun)<=(MAKINUM(65535)&yfun))
        return subsumed_term_list_ordinary_pred_(CDR(ylit),CDR(xlit));
      else
        return BOOL_F;
    }
    else
    if(ZERO_P(MAKINUM(65536)&yfun)) {
      if((MAKINUM(65535)&yfun)<=(MAKINUM(65535)&xfun))
        return subsumed_term_list_ordinary_pred_(CDR(xlit),CDR(ylit));
      else
        return BOOL_F;
    }
    else
    if(xfun==yfun)
      return term_list_equal_pred_(CDR(xlit),CDR(ylit));
    else
      return BOOL_F;
  }
  else
    return BOOL_F;
}

SCM resolve_unify_ordinary_aux(xterm,yterm)
SCM xterm,yterm;
{
  SCM xpart,ypart,xfun,yfun,fail_flag;

  if(NUMBER_P(xterm)&&(xterm<=MAKINUM(65535))) {
    xterm=var_val(xterm);
  }
  if(NUMBER_P(yterm)&&(yterm<=MAKINUM(65535))) {
    yterm=var_val(yterm);
  }
  if(NUMBER_P(xterm)) {
    if(NUMBER_P(yterm)) {
      if(xterm==yterm)
        return BOOL_T;
      else
      if(MAKINUM(65535)>yterm) {
        STBL_VECTOR_SET(_star_var_val_table_star__velts0,MAKINUM(8191)&yterm,xterm);
        if(ZERO_P(MAKINUM(256)&yterm)) {
          xvars_set_flag_global=BOOL_T;
        }
        else {
          yvars_set_flag_global=BOOL_T;
        }
        if(NFALSEP(repeatedvars_flag_global)&&((MAKINUM(65535)>xterm)&&ZERO_P(MAKINUM(32768)&yterm))) {
          occurcheck_flag_global=BOOL_T;
        }
        return BOOL_T;
      }
      else
      if(MAKINUM(65535)>xterm) {
        STBL_VECTOR_SET(_star_var_val_table_star__velts0,MAKINUM(8191)&xterm,yterm);
        if(ZERO_P(MAKINUM(256)&xterm)) {
          xvars_set_flag_global=BOOL_T;
        }
        else {
          yvars_set_flag_global=BOOL_T;
        }
        return BOOL_T;
      }
      else
        return BOOL_F;
    }
    else
    if(MAKINUM(65535)>xterm) {
      if(NFALSEP(occurcheck_flag_global)&&ZERO_P(MAKINUM(65536)&CAR(yterm))) {
        if(NFALSEP(occur_check_pred_(xterm,yterm)))
          return BOOL_F;
        else {
          STBL_VECTOR_SET(_star_var_val_table_star__velts0,MAKINUM(8191)&xterm,yterm);
          if(ZERO_P(MAKINUM(256)&xterm)) {
            xvars_set_flag_global=BOOL_T;
          }
          else {
            yvars_set_flag_global=BOOL_T;
          }
          return BOOL_T;
        }
      }
      else {
        STBL_VECTOR_SET(_star_var_val_table_star__velts0,MAKINUM(8191)&xterm,yterm);
        if(ZERO_P(MAKINUM(256)&xterm)) {
          xvars_set_flag_global=BOOL_T;
        }
        else {
          yvars_set_flag_global=BOOL_T;
        }
        if(NFALSEP(repeatedvars_flag_global)&&(ZERO_P(MAKINUM(32768)&xterm)&&ZERO_P(MAKINUM(65536)&CAR(yterm)))) {
          occurcheck_flag_global=BOOL_T;
        }
        return BOOL_T;
      }
    }
    else
      return BOOL_F;
  }
  else
  if(NUMBER_P(yterm)) {
    if(MAKINUM(65535)>yterm) {
      if(NFALSEP(occurcheck_flag_global)&&ZERO_P(MAKINUM(65536)&CAR(xterm))) {
        if(NFALSEP(occur_check_pred_(yterm,xterm)))
          return BOOL_F;
        else {
          STBL_VECTOR_SET(_star_var_val_table_star__velts0,MAKINUM(8191)&yterm,xterm);
          if(ZERO_P(MAKINUM(256)&yterm)) {
            xvars_set_flag_global=BOOL_T;
          }
          else {
            yvars_set_flag_global=BOOL_T;
          }
          return BOOL_T;
        }
      }
      else {
        STBL_VECTOR_SET(_star_var_val_table_star__velts0,MAKINUM(8191)&yterm,xterm);
        if(ZERO_P(MAKINUM(256)&yterm)) {
          xvars_set_flag_global=BOOL_T;
        }
        else {
          yvars_set_flag_global=BOOL_T;
        }
        if(NFALSEP(repeatedvars_flag_global)&&(ZERO_P(MAKINUM(32768)&yterm)&&ZERO_P(MAKINUM(65536)&CAR(xterm)))) {
          occurcheck_flag_global=BOOL_T;
        }
        return BOOL_T;
      }
    }
    else
      return BOOL_F;
  }
  else {
    xfun=CAR(xterm);
    yfun=CAR(yterm);
    fail_flag=BOOL_F;
    if((MAKINUM(534773760)&xfun)==(MAKINUM(534773760)&yfun)) {
      if(ZERO_P(MAKINUM(65536)&xfun)||ZERO_P(MAKINUM(65536)&yfun)) {
        for(xpart=CDR(xterm),ypart=CDR(yterm);
            !(NFALSEP(fail_flag)||NULL_P(xpart));
            xpart=CDR(xpart),ypart=CDR(ypart))
          if(!(NFALSEP(resolve_unify_ordinary_aux(CAR(xpart),CAR(ypart))))) {
            fail_flag=BOOL_T;
          }
        return NOT(fail_flag);
      }
      else
        return term_list_equal_pred_(CDR(xterm),CDR(yterm));
    }
    else
      return BOOL_F;
  }
}

SCM resolve_unify_cutoff_aux(xterm,yterm)
SCM xterm,yterm;
{
  SCM xpart,ypart,xfun,yfun,fail_flag;

  if(NUMBER_P(xterm)&&(xterm<=MAKINUM(65535))) {
    xterm=var_val(xterm);
  }
  if((NUMBER_P(yterm)&&(yterm<=MAKINUM(65535)))&&!(ZERO_P(MAKINUM(16384)&yterm))) {
    yterm=var_val(yterm);
  }
  if(NUMBER_P(xterm)) {
    if(NUMBER_P(yterm)) {
      if(xterm==yterm)
        return BOOL_T;
      else
      if((MAKINUM(65535)>yterm)&&!(ZERO_P(MAKINUM(16384)&yterm))) {
        STBL_VECTOR_SET(_star_var_val_table_star__velts0,MAKINUM(8191)&yterm,xterm);
        if(ZERO_P(MAKINUM(256)&yterm)) {
          xvars_set_flag_global=BOOL_T;
        }
        else {
          yvars_set_flag_global=BOOL_T;
        }
        if(NFALSEP(repeatedvars_flag_global)&&((MAKINUM(65535)>xterm)&&ZERO_P(MAKINUM(32768)&yterm))) {
          occurcheck_flag_global=BOOL_T;
        }
        return BOOL_T;
      }
      else
      if((MAKINUM(65535)>xterm)&&!(ZERO_P(MAKINUM(16384)&xterm))) {
        STBL_VECTOR_SET(_star_var_val_table_star__velts0,MAKINUM(8191)&xterm,yterm);
        if(ZERO_P(MAKINUM(256)&xterm)) {
          xvars_set_flag_global=BOOL_T;
        }
        else {
          yvars_set_flag_global=BOOL_T;
        }
        return BOOL_T;
      }
      else
        return BOOL_F;
    }
    else
    if((MAKINUM(65535)>xterm)&&!(ZERO_P(MAKINUM(16384)&xterm))) {
      if(NFALSEP(occurcheck_flag_global)&&ZERO_P(MAKINUM(65536)&CAR(yterm))) {
        if(NFALSEP(occur_check_pred_(xterm,yterm)))
          return BOOL_F;
        else {
          STBL_VECTOR_SET(_star_var_val_table_star__velts0,MAKINUM(8191)&xterm,yterm);
          if(ZERO_P(MAKINUM(256)&xterm)) {
            xvars_set_flag_global=BOOL_T;
          }
          else {
            yvars_set_flag_global=BOOL_T;
          }
          return BOOL_T;
        }
      }
      else {
        STBL_VECTOR_SET(_star_var_val_table_star__velts0,MAKINUM(8191)&xterm,yterm);
        if(ZERO_P(MAKINUM(256)&xterm)) {
          xvars_set_flag_global=BOOL_T;
        }
        else {
          yvars_set_flag_global=BOOL_T;
        }
        if(NFALSEP(repeatedvars_flag_global)&&(ZERO_P(MAKINUM(32768)&xterm)&&ZERO_P(MAKINUM(65536)&CAR(yterm)))) {
          occurcheck_flag_global=BOOL_T;
        }
        return BOOL_T;
      }
    }
    else
      return BOOL_F;
  }
  else
  if(NUMBER_P(yterm)) {
    if((MAKINUM(65535)>yterm)&&!(ZERO_P(MAKINUM(16384)&yterm))) {
      if(NFALSEP(occurcheck_flag_global)&&ZERO_P(MAKINUM(65536)&CAR(xterm))) {
        if(NFALSEP(occur_check_pred_(yterm,xterm)))
          return BOOL_F;
        else {
          STBL_VECTOR_SET(_star_var_val_table_star__velts0,MAKINUM(8191)&yterm,xterm);
          if(ZERO_P(MAKINUM(256)&yterm)) {
            xvars_set_flag_global=BOOL_T;
          }
          else {
            yvars_set_flag_global=BOOL_T;
          }
          return BOOL_T;
        }
      }
      else {
        STBL_VECTOR_SET(_star_var_val_table_star__velts0,MAKINUM(8191)&yterm,xterm);
        if(ZERO_P(MAKINUM(256)&yterm)) {
          xvars_set_flag_global=BOOL_T;
        }
        else {
          yvars_set_flag_global=BOOL_T;
        }
        if(NFALSEP(repeatedvars_flag_global)&&(ZERO_P(MAKINUM(32768)&yterm)&&ZERO_P(MAKINUM(65536)&CAR(xterm)))) {
          occurcheck_flag_global=BOOL_T;
        }
        return BOOL_T;
      }
    }
    else
      return BOOL_F;
  }
  else {
    xfun=CAR(xterm);
    yfun=CAR(yterm);
    fail_flag=BOOL_F;
    if((MAKINUM(534773760)&xfun)==(MAKINUM(534773760)&yfun)) {
      if(ZERO_P(MAKINUM(65536)&xfun)||ZERO_P(MAKINUM(65536)&yfun)) {
        for(xpart=CDR(xterm),ypart=CDR(yterm);
            !(NFALSEP(fail_flag)||NULL_P(xpart));
            xpart=CDR(xpart),ypart=CDR(ypart))
          if(!(NFALSEP(resolve_unify_cutoff_aux(CAR(xpart),CAR(ypart))))) {
            fail_flag=BOOL_T;
          }
        return NOT(fail_flag);
      }
      else
        return term_list_equal_pred_(CDR(xterm),CDR(yterm));
    }
    else
      return BOOL_F;
  }
}

SCM factor_unify_ordinary_aux(xterm,yterm)
SCM xterm,yterm;
{
  SCM xpart,ypart,xfun,yfun,fail_flag;

  if(NUMBER_P(xterm)&&(xterm<=MAKINUM(65535))) {
    xterm=var_val(xterm);
  }
  if(NUMBER_P(yterm)&&(yterm<=MAKINUM(65535))) {
    yterm=var_val(yterm);
  }
  if(NUMBER_P(xterm)) {
    if(NUMBER_P(yterm)) {
      if(xterm==yterm)
        return BOOL_T;
      else
      if(MAKINUM(65535)>xterm) {
        if((MAKINUM(65535)>yterm)&&((MAKINUM(8191)&xterm)==(MAKINUM(8191)&yterm)))
          return BOOL_T;
        else {
          fac_vars_set_global=BOOL_T;
          STBL_VECTOR_SET(_star_var_val_table_star__velts0,MAKINUM(8191)&xterm,yterm);
          return BOOL_T;
        }
      }
      else
      if(MAKINUM(65535)>yterm) {
        fac_vars_set_global=BOOL_T;
        STBL_VECTOR_SET(_star_var_val_table_star__velts0,MAKINUM(8191)&yterm,xterm);
        return BOOL_T;
      }
      else
        return BOOL_F;
    }
    else
    if(MAKINUM(65535)>xterm) {
      if(ZERO_P(MAKINUM(65536)&CAR(yterm))) {
        if(NFALSEP(factor_occur_check_pred_(MAKINUM(8191)&xterm,yterm)))
          return BOOL_F;
        else {
          fac_vars_set_global=BOOL_T;
          STBL_VECTOR_SET(_star_var_val_table_star__velts0,MAKINUM(8191)&xterm,yterm);
          return BOOL_T;
        }
      }
      else {
        fac_vars_set_global=BOOL_T;
        STBL_VECTOR_SET(_star_var_val_table_star__velts0,MAKINUM(8191)&xterm,yterm);
        return BOOL_T;
      }
    }
    else
      return BOOL_F;
  }
  else
  if(NUMBER_P(yterm)) {
    if(MAKINUM(65535)>yterm) {
      if(ZERO_P(MAKINUM(65536)&CAR(xterm))) {
        if(NFALSEP(factor_occur_check_pred_(MAKINUM(8191)&yterm,xterm)))
          return BOOL_F;
        else {
          fac_vars_set_global=BOOL_T;
          STBL_VECTOR_SET(_star_var_val_table_star__velts0,MAKINUM(8191)&yterm,xterm);
          return BOOL_T;
        }
      }
      else {
        fac_vars_set_global=BOOL_T;
        STBL_VECTOR_SET(_star_var_val_table_star__velts0,MAKINUM(8191)&yterm,xterm);
        return BOOL_T;
      }
    }
    else
      return BOOL_F;
  }
  else {
    xfun=CAR(xterm);
    yfun=CAR(yterm);
    fail_flag=BOOL_F;
    if((MAKINUM(534773760)&xfun)==(MAKINUM(534773760)&yfun)) {
      if(ZERO_P(MAKINUM(65536)&xfun)||ZERO_P(MAKINUM(65536)&yfun)) {
        for(xpart=CDR(xterm),ypart=CDR(yterm);
            !(NFALSEP(fail_flag)||NULL_P(xpart));
            xpart=CDR(xpart),ypart=CDR(ypart))
          if(!(NFALSEP(factor_unify_ordinary_aux(CAR(xpart),CAR(ypart))))) {
            fail_flag=BOOL_T;
          }
        return NOT(fail_flag);
      }
      else
        return term_list_equal_pred_(CDR(xterm),CDR(yterm));
    }
    else
      return BOOL_F;
  }
}

SCM occur_check_pred_(var,composite)
SCM var,composite;
{
  SCM el;

  composite=CDR(composite);
  for(;!(NULL_P(composite));) {
    el=CAR(composite);
    if(NUMBER_P(el)) {
      if(MAKINUM(65535)>el) {
        el=var_val(el);
        if((var==el)||(!(NUMBER_P(el))&&(ZERO_P(MAKINUM(65536)&CAR(el))&&NFALSEP(occur_check_pred_(var,el))))) {
          composite=EOL;
          var=BOOL_T;
        }
        else {
          composite=CDR(composite);
        }
      }
      else {
        composite=CDR(composite);
      }
    }
    else
    if(ZERO_P(MAKINUM(65536)&CAR(el))&&NFALSEP(occur_check_pred_(var,el))) {
      composite=EOL;
      var=BOOL_T;
    }
    else {
      composite=CDR(composite);
    }
  }
  return SBOOL(var==BOOL_T);
}

SCM factor_occur_check_pred_(var,composite)
SCM var,composite;
{
  SCM el;

  composite=CDR(composite);
  for(;!(NULL_P(composite));) {
    el=CAR(composite);
    if(NUMBER_P(el)) {
      if(MAKINUM(65535)>el) {
        el=var_val(el);
        if(((NUMBER_P(el)&&(el<=MAKINUM(65535)))&&(var==(MAKINUM(8191)&el)))||(!(NUMBER_P(el))&&(ZERO_P(MAKINUM(65536)&CAR(el))&&NFALSEP(factor_occur_check_pred_(var,el))))) {
          composite=EOL;
          var=BOOL_T;
        }
        else {
          composite=CDR(composite);
        }
      }
      else {
        composite=CDR(composite);
      }
    }
    else
    if(ZERO_P(MAKINUM(65536)&CAR(el))&&NFALSEP(factor_occur_check_pred_(var,el))) {
      composite=EOL;
      var=BOOL_T;
    }
    else {
      composite=CDR(composite);
    }
  }
  return SBOOL(var==BOOL_T);
}

SCM havealready_clause_pred_(clauseinf,cl)
SCM clauseinf,cl;
{
  SCM part1,part,new_var2,strengthint,predsymbsint,len,strength,pure_strength,foundflag,tmp_subs_list,tmp,glen;

  strengthint=CAR(clauseinf);
  predsymbsint=CAR(CDR(clauseinf));
  len=MAKINUM(INUM(MAKINUM(8257536)&strengthint)>>17);
  strength=(MAKINUM(131071)&strengthint);
  pure_strength=(MAKINUM(65535)&strengthint);
  foundflag=BOOL_F;
  tmp_subs_list=CDR(GLOBAL(subsumption_list_global));
  tmp=BOOL_F;
  glen=MAKINUM(0);
  GLOBAL(havealready_timecounter_global)=MAKINUM(1+INUM(GLOBAL(havealready_timecounter_global)));
  if(!(NFALSEP(GLOBAL(classical_synth_stratflag_global)))) {
    cl=remove_ans_literals(cl);
  }
  GLOBAL(gcl_varsstack_global)=EOL;
  tmp=check_nonunit_discr_tree(GLOBAL(nonunit_discr_tree_global),cl);
  if(NFALSEP(tmp)) {
    GLOBAL(forward_subsumed_double_nr_global)=MAKINUM(1+INUM(GLOBAL(forward_subsumed_double_nr_global)));
    foundflag=BOOL_T;
    GLOBAL(subsuming_clause_global)=CAR(tmp);
  }
  else {
    new_var2=SBOOL(len<=MAKINUM(2));
    if(NFALSEP(new_var2)) ;
    else {
      for(part=GLOBAL(nonunit_res_global);!(NULL_P(part)||NFALSEP(foundflag));part=CDR(part))
        for(part1=CAR(part);!(NULL_P(part1)||NFALSEP(foundflag));part1=CDR(part1))
          if(!(CAR(CAR(part1))==GLOBAL(havealready_timecounter_global))) {
            SET_CAR(CAR(part1),GLOBAL(havealready_timecounter_global));
            if(NFALSEP(GLOBAL(prohibit_subs_clnr_global))&&(CAR(CDR(CDR(CDR(CDR(CAR(CDR(CAR(part1))))))))==GLOBAL(prohibit_subs_clnr_global)))
              BOOL_F;
            else {
              foundflag=subsumed_clause_aux_pred_(cl,CDR(CAR(part1)),MAKINUM(INUM(MAKINUM(8257536)&CAR(CAR(CDR(CAR(part1)))))>>17),len,strength,predsymbsint,CDR(CDR(CDR(CDR(CAR(part1))))));
            }
          }
      if(NFALSEP(foundflag)) {
        GLOBAL(forward_subsumed_overdouble_nr_global)=MAKINUM(1+INUM(GLOBAL(forward_subsumed_overdouble_nr_global)));
      }
    }
  }
  return foundflag;
}

SCM subsumed_clause_pred_(scl,gcl)
SCM scl,gcl;
{
  SCM part,glit,foundflag,gmaxvar,len,glen;

  len=MAKINUM(INUM(MAKINUM(8257536)&CAR(CAR(scl)))>>17);
  glen=MAKINUM(INUM(MAKINUM(8257536)&CAR(CAR(gcl)))>>17);
  if(glen==MAKINUM(1)) {
    glit=CAR(CDR(gcl));
    foundflag=BOOL_F;
    gmaxvar=give_cl_maxvar(CAR(gcl));
    for(part=CDR(scl);!(NULL_P(part)||NFALSEP(foundflag));part=CDR(part))
      if(NFALSEP(subsumed_literal_pred_(CAR(part),glit,gmaxvar))) {
        foundflag=BOOL_T;
      }
    return foundflag;
  }
  else
    return subsumed_clause_aux_pred_(CDR(scl),gcl,glen,len,MAKINUM(131071)&CAR(CAR(scl)),CAR(CDR(CAR(scl))),CDR(gcl));
}

SCM subsumed_literal_pred_(slit,glit,gmaxvar)
SCM slit,glit,gmaxvar;
{
  SCM new_var2,gfun,foundflag;

  gfun=CAR(glit);
  foundflag=BOOL_F;
  if(((MAKINUM(534773760)&CAR(slit))==(MAKINUM(534773760)&gfun))&&(((MAKINUM(131071)&CAR(slit))>=(MAKINUM(131071)&gfun))&&(((MAKINUM(65535)&CAR(slit))>=(MAKINUM(65535)&gfun))&&(((MAKINUM(2047)&CAR(slit))>=(MAKINUM(2047)&gfun))&&((MAKINUM(31)&CAR(slit))>=(MAKINUM(31)&gfun)))))) {
    if(ZERO_P(MAKINUM(65536)&gfun)) {
      var_set_flag_global=BOOL_F;
      alt_var_set_flag_global=BOOL_F;
      if(NFALSEP(subsumed_term_list_ordinary_pred_(CDR(slit),CDR(glit)))) {
        foundflag=BOOL_T;
      }
      else
      if(NFALSEP(commutative_fun_pred_(MAKINUM(534773760)&gfun))) {
        clear_x_vars_excl_(gmaxvar);
        if(NFALSEP(swapped_subsumed_term_list_ordinary_pred_(CDR(slit),CDR(glit)))) {
          foundflag=BOOL_T;
        }
      }
      if(NFALSEP(var_set_flag_global)||NFALSEP(alt_var_set_flag_global)) {
        clear_x_vars_excl_(gmaxvar);
        var_set_flag_global=BOOL_F;
        alt_var_set_flag_global=BOOL_F;
      }
    }
    else {
      new_var2=term_list_equal_pred_(CDR(slit),CDR(glit));
      if(NFALSEP(new_var2)) ;
      else
      if(NFALSEP(commutative_fun_pred_(MAKINUM(534773760)&gfun)))
        swapped_term_list_equal_pred_(CDR(slit),CDR(glit));
      else
        BOOL_F;
    }
  }
  return foundflag;
}

SCM subsumed_clause_aux_pred_(cl,gfcl,glen,len,strength,predsymbsint,gcl_fastlits)
SCM cl,gfcl,glen,len,strength,predsymbsint,gcl_fastlits;
{
  SCM ginf,gstrength,gclpreds,foundflag;

  ginf=CAR(gfcl);
  gstrength=(MAKINUM(131071)&CAR(ginf));
  gclpreds=CAR(CDR(ginf));
  foundflag=BOOL_F;
  GLOBAL(subs_tried_nr_global)=MAKINUM(1+INUM(GLOBAL(subs_tried_nr_global)));
  if(len==glen) {
    if(gstrength>strength) {
      GLOBAL(subs_length_fail_nr_global)=MAKINUM(1+INUM(GLOBAL(subs_length_fail_nr_global)));
      GLOBAL(stopsubsuming_flag_global)=BOOL_T;
    }
    else
    if(!(gclpreds==predsymbsint)) {
      GLOBAL(subs_gclpreds_fail_nr_global)=MAKINUM(1+INUM(GLOBAL(subs_gclpreds_fail_nr_global)));
    }
    else
    if(!(NFALSEP(bigger_strength_aux_pred_(strength,gstrength)))) {
      GLOBAL(subs_aux_strength_fail_nr_global)=MAKINUM(1+INUM(GLOBAL(subs_aux_strength_fail_nr_global)));
    }
    else
    if(NFALSEP(funlist_can_subsume_pred_(cl,gcl_fastlits,len,glen))) {
      if(ZERO_P(MAKINUM(65536)&gstrength)) {
        GLOBAL(subs_reg_subs_tried_nr_global)=MAKINUM(1+INUM(GLOBAL(subs_reg_subs_tried_nr_global)));
        gcl_maxvar_global=give_cl_maxvar(ginf);
        if(!(NFALSEP(subsumed_pure_clause_aux_pred_(cl,CDR(gfcl),BOOL_F,EOL,BOOL_F)))) {
          GLOBAL(subs_reg_subs_fail_nr_global)=MAKINUM(1+INUM(GLOBAL(subs_reg_subs_fail_nr_global)));
        }
        else {
          foundflag=BOOL_T;
          GLOBAL(subsuming_clause_global)=gfcl;
          GLOBAL(stopsubsuming_flag_global)=BOOL_T;
          clear_gcl_vars();
          GLOBAL(gcl_varsstack_global)=EOL;
        }
      }
      else {
        foundflag=BOOL_T;
        GLOBAL(subsuming_clause_global)=gfcl;
        GLOBAL(stopsubsuming_flag_global)=BOOL_T;
      }
    }
  }
  else
  if((MAKINUM(65535)&gstrength)>(MAKINUM(65535)&strength)) {
    GLOBAL(subs_strength_fail_nr_global)=MAKINUM(1+INUM(GLOBAL(subs_strength_fail_nr_global)));
    if(!(ZERO_P(MAKINUM(65536)&gstrength))) {
      GLOBAL(stopsubsuming_flag_global)=BOOL_T;
    }
  }
  else
  if(!(gclpreds==(gclpreds&predsymbsint))) {
    GLOBAL(subs_gclpreds_fail_nr_global)=MAKINUM(1+INUM(GLOBAL(subs_gclpreds_fail_nr_global)));
  }
  else
  if(!(NFALSEP(bigger_strength_aux_aux_pred_(strength,gstrength)))) {
    GLOBAL(subs_aux_strength_fail_nr_global)=MAKINUM(1+INUM(GLOBAL(subs_aux_strength_fail_nr_global)));
  }
  else
  if(!(NFALSEP(funlist_can_subsume_pred_(cl,gcl_fastlits,len,glen)))) {
    GLOBAL(subs_funlist_fail_nr_global)=MAKINUM(1+INUM(GLOBAL(subs_funlist_fail_nr_global)));
  }
  else
  if(ZERO_P(MAKINUM(65536)&gstrength)) {
    GLOBAL(subs_reg_subs_tried_nr_global)=MAKINUM(1+INUM(GLOBAL(subs_reg_subs_tried_nr_global)));
    gcl_maxvar_global=give_cl_maxvar(ginf);
    if(!(NFALSEP(subsumed_pure_clause_aux_pred_(cl,CDR(gfcl),BOOL_F,EOL,BOOL_F)))) {
      GLOBAL(subs_reg_subs_fail_nr_global)=MAKINUM(1+INUM(GLOBAL(subs_reg_subs_fail_nr_global)));
    }
    else {
      foundflag=BOOL_T;
      GLOBAL(subsuming_clause_global)=gfcl;
      GLOBAL(stopsubsuming_flag_global)=BOOL_T;
      clear_gcl_vars();
      GLOBAL(gcl_varsstack_global)=EOL;
    }
  }
  else {
    foundflag=BOOL_T;
    GLOBAL(subsuming_clause_global)=gfcl;
    GLOBAL(stopsubsuming_flag_global)=BOOL_T;
  }
  return foundflag;
}

SCM back_subsume(clauseinf,cl)
SCM clauseinf,cl;
{
  SCM scl__2,sclinf,part__1,scl,slit,sfun,part,purefn,littail,new_var2,subs_part,strengthint,predsymbsint,len,strength,pure_strength,clmaxvar,foundflag,tmp_subs_list,slen,tmp_part,last_part;

  strengthint=CAR(clauseinf);
  predsymbsint=CAR(CDR(clauseinf));
  len=MAKINUM(INUM(MAKINUM(8257536)&strengthint)>>17);
  strength=(MAKINUM(131071)&strengthint);
  pure_strength=(MAKINUM(65535)&strengthint);
  clmaxvar=give_cl_maxvar(clauseinf);
  foundflag=BOOL_F;
  tmp_subs_list=CDR(GLOBAL(subsumption_list_global));
  slen=MAKINUM(0);
  tmp_part=EOL;
  last_part=EOL;
  if(!(NFALSEP(GLOBAL(classical_synth_stratflag_global)))) {
    cl=remove_ans_literals(cl);
  }
  gcl_maxvar_global=clmaxvar;
  GLOBAL(subsumed_clauses_global)=EOL;
  GLOBAL(gcl_varsstack_global)=EOL;
  for(;!(NULL_P(tmp_subs_list)||(CAR(CAR(tmp_subs_list))>=len));) {
    tmp_subs_list=CDR(tmp_subs_list);
  }
  for(subs_part=tmp_subs_list;!(NULL_P(subs_part));subs_part=CDR(subs_part)) {
    slen=CAR(CAR(subs_part));
    last_part=CAR(subs_part);
    tmp_part=CDR(last_part);
    var_set_flag_global=BOOL_F;
    alt_var_set_flag_global=BOOL_F;
    clear_x_vars_excl_(clmaxvar);
    GLOBAL(gcl_varsstack_global)=EOL;
    if(slen==MAKINUM(1)) {
      purefn=(MAKINUM(534773760)&CAR(CAR(cl)));
      littail=CDR(CAR(cl));
      for(part=tmp_part;!(NULL_P(part)||(pure_strength>(MAKINUM(65535)&CAR(CAR(CAR(part))))));part=CDR(part)) {
        scl=CAR(part);
        slit=CAR(CDR(scl));
        sfun=CAR(slit);
        if((purefn==(MAKINUM(534773760)&sfun))&&NFALSEP(bigger_strength_pred_(sfun,strengthint))) {
          if(NFALSEP(subsumed_term_list_ordinary_pred_(CDR(slit),littail))) {
            SET_CDR(last_part,CDR(part));
            GLOBAL(subsumed_clauses_global)=cons(scl,GLOBAL(subsumed_clauses_global));
            if(NFALSEP(commutative_fun_pred_(purefn))) {
              if(NFALSEP(var_set_flag_global)||NFALSEP(alt_var_set_flag_global)) {
                clear_x_vars_excl_(clmaxvar);
                var_set_flag_global=BOOL_F;
                alt_var_set_flag_global=BOOL_F;
              }
              if(NFALSEP(swapped_subsumed_term_list_ordinary_pred_(CDR(slit),littail))) {
                SET_CDR(last_part,CDR(part));
                GLOBAL(subsumed_clauses_global)=cons(scl,GLOBAL(subsumed_clauses_global));
              }
            }
          }
          if(NFALSEP(var_set_flag_global)||NFALSEP(alt_var_set_flag_global)) {
            clear_x_vars_excl_(clmaxvar);
            var_set_flag_global=BOOL_F;
            alt_var_set_flag_global=BOOL_F;
          }
        }
        if(CDR(last_part)==part) {
          last_part=part;
        }
      }
    }
    else
      for(part__1=tmp_part;!(NULL_P(part__1)||(pure_strength>(MAKINUM(65535)&CAR(CAR(CAR(part__1))))));part__1=CDR(part__1)) {
        scl__2=CAR(part__1);
        sclinf=CAR(scl__2);
        if(NFALSEP(((len==slen) ? bigger_strength_pred_(CAR(sclinf),strength) : bigger_strength_aux_pred_(CAR(sclinf),strength)))) {
          if(NFALSEP(((len==slen) ? SBOOL(predsymbsint==CAR(CDR(sclinf))) : SBOOL(predsymbsint==(CAR(CDR(sclinf))&predsymbsint))))) {
            if(NFALSEP(funlist_can_subsume_pred_(CDR(scl__2),cl,slen,len))) {
              if(ZERO_P(MAKINUM(65536)&strengthint)) {
                if(NFALSEP(subsumed_pure_clause_aux_pred_(CDR(scl__2),cl,BOOL_F,EOL,BOOL_F))) {
                  SET_CDR(last_part,CDR(part__1));
                  GLOBAL(subsumed_clauses_global)=cons(scl__2,GLOBAL(subsumed_clauses_global));
                  clear_gcl_vars();
                  GLOBAL(gcl_varsstack_global)=EOL;
                }
              }
              else {
                SET_CDR(last_part,CDR(part__1));
                GLOBAL(subsumed_clauses_global)=cons(scl__2,GLOBAL(subsumed_clauses_global));
              }
            }
          }
        }
        if(CDR(last_part)==part__1) {
          last_part=part__1;
        }
      }
  }
  new_var2=SBOOL(NULL_P(GLOBAL(subsumed_clauses_global)));
  if(NFALSEP(new_var2)) ;
  else
  if(GLOBAL(display_info_level_global)>=MAKINUM(63)) {
    newline(cur_output_port());
    display(const_1,cur_output_port());
    newline(cur_output_port());
    for_each1(back_subsume_fn3,GLOBAL(subsumed_clauses_global));
    newline(cur_output_port());
  }
  else
  if(NFALSEP(GLOBAL(display_info_char_flag_global)))
    display(const_2,cur_output_port());
  for_each1(back_subsume_fn4,GLOBAL(subsumed_clauses_global));
  GLOBAL(subsumed_clauses_global)=EOL;
  return UNSPECIFIED;
}

SCM back_subsume_fn4(x)
SCM x;
{
  GLOBAL(back_subsumed_nr_global)=MAKINUM(1+INUM(GLOBAL(back_subsumed_nr_global)));
  SET_CAR(CAR(x),MAKINUM(65535^INUM(MAKINUM(65535)|CAR(CAR(x)))));
  return UNSPECIFIED;
}

SCM back_subsume_fn3(x)
SCM x;
{
  print_full_clause(x);
  return newline(cur_output_port());
}

SCM bigger_strength_pred_(sclstrength,gclstrength)
SCM sclstrength,gclstrength;
{
  if((MAKINUM(131071)&sclstrength)>=(MAKINUM(131071)&gclstrength)) {
    if((MAKINUM(65535)&sclstrength)>=(MAKINUM(65535)&gclstrength)) {
      if((MAKINUM(2047)&sclstrength)>=(MAKINUM(2047)&gclstrength))
        return SBOOL((MAKINUM(31)&sclstrength)>=(MAKINUM(31)&gclstrength));
      else
        return BOOL_F;
    }
    else
      return BOOL_F;
  }
  else
    return BOOL_F;
}

SCM bigger_strength_aux_pred_(sclstrength,gclstrength)
SCM sclstrength,gclstrength;
{
  if((MAKINUM(65535)&sclstrength)>=(MAKINUM(65535)&gclstrength)) {
    if((MAKINUM(2047)&sclstrength)>=(MAKINUM(2047)&gclstrength))
      return SBOOL((MAKINUM(31)&sclstrength)>=(MAKINUM(31)&gclstrength));
    else
      return BOOL_F;
  }
  else
    return BOOL_F;
}

SCM bigger_strength_aux_aux_pred_(sclstrength,gclstrength)
SCM sclstrength,gclstrength;
{
  if((MAKINUM(2047)&sclstrength)>=(MAKINUM(2047)&gclstrength))
    return SBOOL((MAKINUM(31)&sclstrength)>=(MAKINUM(31)&gclstrength));
  else
    return BOOL_F;
}

SCM funlist_can_subsume_pred_(scl,gcl,slen,glen)
SCM scl,gcl,slen,glen;
{
  SCM slit1,sfun1,glit1,gfun1;

  if(NFALSEP(GLOBAL(classical_synth_stratflag_global))) {
    glit1=CAR(gcl);
    gfun1=CAR(glit1);
    if(NFALSEP(answer_pred_pred_(gfun1))) {
      slit1=CAR(scl);
      sfun1=CAR(slit1);
      if(NFALSEP(answer_pred_pred_(sfun1))) {
        if(ZERO_P(MAKINUM(65536)&gfun1)) {
          if(((MAKINUM(534773760)&sfun1)==(MAKINUM(534773760)&gfun1))&&(((MAKINUM(131071)&sfun1)>=(MAKINUM(131071)&gfun1))&&(((MAKINUM(65535)&sfun1)>=(MAKINUM(65535)&gfun1))&&(((MAKINUM(2047)&sfun1)>=(MAKINUM(2047)&gfun1))&&((MAKINUM(31)&sfun1)>=(MAKINUM(31)&gfun1))))))
            return funlist_can_subsume_aux_pred_(CDR(scl),CDR(gcl));
          else
            return BOOL_F;
        }
        else
        if(NFALSEP(composite_equal_pred_(glit1,slit1)))
          return funlist_can_subsume_aux_pred_(CDR(scl),CDR(gcl));
        else
          return BOOL_F;
      }
      else
        return BOOL_F;
    }
    else
    if(NFALSEP(answer_pred_pred_(CAR(CAR(scl))))) {
      if(slen==glen)
        return BOOL_F;
      else
        return funlist_can_subsume_aux_pred_(CDR(scl),gcl);
    }
    else
      return funlist_can_subsume_aux_pred_(scl,gcl);
  }
  else
    return funlist_can_subsume_aux_pred_(scl,gcl);
}

SCM funlist_can_subsume_aux_pred_(scl,gcl)
SCM scl,gcl;
{
  SCM slit,sfun,glit,gfun,success_flag,spart;

  spart=scl;
  for(;!(NULL_P(spart)||NULL_P(gcl));) {
    glit=CAR(gcl);
    gfun=CAR(glit);
    success_flag=BOOL_F;
    spart=scl;
    for(;!(NULL_P(spart)||NFALSEP(success_flag));) {
      slit=CAR(spart);
      sfun=CAR(slit);
      if(NFALSEP(_grtr__fun_ordering_aux_pred_(gfun,sfun))) {
        spart=EOL;
      }
      else
      if(ZERO_P(MAKINUM(65536)&gfun)) {
        if(((MAKINUM(534773760)&sfun)==(MAKINUM(534773760)&gfun))&&(((MAKINUM(131071)&sfun)>=(MAKINUM(131071)&gfun))&&(((MAKINUM(65535)&sfun)>=(MAKINUM(65535)&gfun))&&(((MAKINUM(2047)&sfun)>=(MAKINUM(2047)&gfun))&&((MAKINUM(31)&sfun)>=(MAKINUM(31)&gfun)))))) {
          gcl=CDR(gcl);
          success_flag=BOOL_T;
        }
        else {
          spart=CDR(spart);
        }
      }
      else
      if(NFALSEP(composite_equal_pred_(slit,glit))) {
        gcl=CDR(gcl);
        success_flag=BOOL_T;
      }
      else {
        spart=CDR(spart);
      }
    }
  }
  return SBOOL(NULL_P(gcl));
}

SCM _grtr__fun_ordering_pred_(xfun,yfun)
SCM xfun,yfun;
{
  if(NFALSEP(answer_pred_pred_(xfun))) {
    if(NFALSEP(answer_pred_pred_(yfun))) {
      if((MAKINUM(131071)&xfun)>=(MAKINUM(131071)&yfun))
        return BOOL_T;
      else
        return BOOL_F;
    }
    else
      return BOOL_T;
  }
  else
  if(NFALSEP(answer_pred_pred_(yfun)))
    return BOOL_F;
  else
  if(((MAKINUM(131071)&xfun)>(MAKINUM(131071)&yfun))||(((MAKINUM(131071)&xfun)==(MAKINUM(131071)&yfun))&&((MAKINUM(534773760)&xfun)>(MAKINUM(534773760)&yfun))))
    return BOOL_T;
  else
    return BOOL_F;
}

SCM _grtr__fun_ordering_aux_pred_(xfun,yfun)
SCM xfun,yfun;
{
  if(((MAKINUM(131071)&xfun)>(MAKINUM(131071)&yfun))||(((MAKINUM(131071)&xfun)==(MAKINUM(131071)&yfun))&&((MAKINUM(534773760)&xfun)>(MAKINUM(534773760)&yfun))))
    return BOOL_T;
  else
    return BOOL_F;
}

SCM subsumed_pure_clause_ans_pred_(scl,gcl)
SCM scl,gcl;
{
  SCM slit1,glit1;

  glit1=CAR(gcl);
  if(NFALSEP(answer_pred_pred_(CAR(glit1)))) {
    slit1=CAR(scl);
    if(!(ZERO_P(MAKINUM(65536)&CAR(glit1))))
      return subsumed_pure_clause_aux_pred_(CDR(scl),CDR(gcl),BOOL_F,EOL,BOOL_F);
    else {
      var_set_flag_global=BOOL_F;
      if(NFALSEP(subsumed_term_list_ordinary_pred_(CDR(slit1),CDR(glit1)))) {
        if(NFALSEP(subsumed_pure_clause_aux_pred_(CDR(scl),CDR(gcl),BOOL_T,EOL,BOOL_F))) {
          clear_gcl_vars();
          return BOOL_T;
        }
        else {
          clear_gcl_vars();
          return BOOL_F;
        }
      }
      else {
        if(NFALSEP(var_set_flag_global))
          clear_gcl_vars();
        return BOOL_F;
      }
    }
  }
  else
  if(NFALSEP(answer_pred_pred_(CAR(CAR(scl)))))
    return subsumed_pure_clause_aux_pred_(CDR(scl),gcl,BOOL_F,EOL,BOOL_F);
  else
    return subsumed_pure_clause_aux_pred_(scl,gcl,BOOL_F,EOL,BOOL_F);
}

SCM subsumed_pure_clause_aux_pred_(scl,gcl,var_set_before,done_scl_parts,swapped_flag)
SCM scl,gcl,var_set_before,done_scl_parts,swapped_flag;
{
  SCM grest__5,grest__3,tmp_var_set_flag__4,grest__2,tmp_var_set_flag,grest__1,grest,slit,spart,glit,gfun,success_flag;

  glit=CAR(gcl);
  gfun=CAR(glit);
  success_flag=BOOL_F;
  for(spart=scl;!(NULL_P(spart)||NFALSEP(success_flag));spart=(NULL_P(spart) ? EOL : CDR(spart)))
    if(NULL_P(done_scl_parts)||!(NFALSEP(memq(spart,done_scl_parts)))) {
      slit=CAR(spart);
      if(((MAKINUM(534773760)&CAR(slit))==(MAKINUM(534773760)&gfun))&&(((MAKINUM(131071)&CAR(slit))>=(MAKINUM(131071)&gfun))&&(((MAKINUM(65535)&CAR(slit))>=(MAKINUM(65535)&gfun))&&(((MAKINUM(2047)&CAR(slit))>=(MAKINUM(2047)&gfun))&&((MAKINUM(31)&CAR(slit))>=(MAKINUM(31)&gfun)))))) {
        if(ZERO_P(MAKINUM(65536)&gfun)) {
          if(NFALSEP(var_set_before))
            save_gcl_vars();
          var_set_flag_global=BOOL_F;
          alt_var_set_flag_global=BOOL_F;
          swapped_flag=BOOL_F;
          if(NFALSEP(subsumed_term_list_ordinary_pred_(CDR(slit),CDR(glit)))||(NFALSEP(commutative_fun_pred_(gfun))&&(NFALSEP((((NFALSEP(var_set_flag_global)||NFALSEP(alt_var_set_flag_global)) ? ((NFALSEP(var_set_before) ? restore_gcl_vars() : clear_gcl_vars()),var_set_flag_global=BOOL_F,UNSPECIFIED,alt_var_set_flag_global=BOOL_F,UNSPECIFIED) : UNSPECIFIED),BOOL_T))&&(NFALSEP(swapped_subsumed_term_list_ordinary_pred_(CDR(slit),CDR(glit)))&&NFALSEP((swapped_flag=BOOL_T,UNSPECIFIED,BOOL_T)))))) {
            if(NFALSEP(var_set_flag_global)) {
              grest=CDR(gcl);
              if(NULL_P(grest)) {
                success_flag=BOOL_T;
              }
              else
              if(NFALSEP(subsumed_pure_clause_aux_pred_(scl,grest,BOOL_T,cons(spart,done_scl_parts),swapped_flag))) {
                success_flag=BOOL_T;
              }
              else
              if(NFALSEP(var_set_before))
                restore_gcl_vars();
              else
                clear_gcl_vars();
              if(!(NFALSEP(success_flag))&&(NFALSEP(commutative_fun_pred_(gfun))&&(!(NFALSEP(swapped_flag))&&NFALSEP(swapped_subsumed_term_list_ordinary_pred_(CDR(slit),CDR(glit)))))) {
                if(NFALSEP(var_set_flag_global)) {
                  grest__1=CDR(gcl);
                  if(NULL_P(grest__1)) {
                    success_flag=BOOL_T;
                  }
                  else
                  if(NFALSEP(subsumed_pure_clause_aux_pred_(scl,grest__1,BOOL_T,cons(spart,done_scl_parts),swapped_flag))) {
                    success_flag=BOOL_T;
                  }
                  else
                  if(NFALSEP(var_set_before))
                    restore_gcl_vars();
                  else
                    clear_gcl_vars();
                }
                else {
                  grest__2=CDR(gcl);
                  tmp_var_set_flag=alt_var_set_flag_global;
                  if(NULL_P(grest__2)) {
                    success_flag=BOOL_T;
                  }
                  else
                  if(NFALSEP(subsumed_pure_clause_aux_pred_(scl,grest__2,BOOL_T,cons(spart,done_scl_parts),swapped_flag))) {
                    success_flag=BOOL_T;
                  }
                  else {
                    if(NFALSEP(tmp_var_set_flag)) {
                      if(NFALSEP(var_set_before))
                        restore_gcl_vars();
                      else
                        clear_gcl_vars();
                    }
                    else
                    if(NFALSEP(var_set_before))
                      pop_gcl_vars_stack();
                    spart=EOL;
                  }
                }
              }
            }
            else {
              grest__3=CDR(gcl);
              tmp_var_set_flag__4=alt_var_set_flag_global;
              if(NULL_P(grest__3)) {
                success_flag=BOOL_T;
              }
              else
              if(NFALSEP(subsumed_pure_clause_aux_pred_(scl,grest__3,BOOL_T,cons(spart,done_scl_parts),swapped_flag))) {
                success_flag=BOOL_T;
              }
              else {
                if(NFALSEP(tmp_var_set_flag__4)) {
                  if(NFALSEP(var_set_before))
                    restore_gcl_vars();
                  else
                    clear_gcl_vars();
                }
                else
                if(NFALSEP(var_set_before))
                  pop_gcl_vars_stack();
                spart=EOL;
              }
            }
          }
          else
          if(NFALSEP(var_set_flag_global)||NFALSEP(alt_var_set_flag_global)) {
            if(NFALSEP(var_set_before))
              restore_gcl_vars();
            else
              clear_gcl_vars();
          }
          else
          if(NFALSEP(var_set_before))
            pop_gcl_vars_stack();
        }
        else
        if(NFALSEP(composite_equal_pred_(glit,slit))) {
          grest__5=CDR(gcl);
          if(NULL_P(grest__5)) {
            success_flag=BOOL_T;
          }
          else
          if(NFALSEP(subsumed_pure_clause_aux_pred_(scl,grest__5,var_set_before,cons(spart,done_scl_parts),swapped_flag))) {
            success_flag=BOOL_T;
          }
          else {
            spart=EOL;
          }
        }
      }
    }
  return success_flag;
}

SCM same_or_nonground_fun_pred_(xfun,yfun)
SCM xfun,yfun;
{
  SCM new_var2;

  new_var2=SBOOL(ZERO_P(MAKINUM(65536)&yfun));
  if(NFALSEP(new_var2))
    return new_var2;
  else
    return SBOOL(xfun==yfun);
}

SCM subsumed_term_ordinary_pred_(sterm,gterm)
SCM sterm,gterm;
{
  SCM spart,gpart,gfun,sfun,gval;

  if(NUMBER_P(gterm)) {
    if(MAKINUM(65535)>gterm) {
      gval=STBL_VECTOR_REF(_star_var_val_table_star__velts0,MAKINUM(8191)&gterm);
      if(gval==MAKINUM(99999999)) {
        STBL_VECTOR_SET(_star_var_val_table_star__velts0,MAKINUM(8191)&gterm,sterm);
        if(ZERO_P(MAKINUM(8192)&gterm)) {
          var_set_flag_global=BOOL_T;
        }
        else {
          alt_var_set_flag_global=BOOL_T;
        }
        return BOOL_T;
      }
      else
      if(NUMBER_P(sterm)) {
        if(MAKINUM(65535)>sterm) {
          if(NUMBER_P(gval)&&(gval<=MAKINUM(65535)))
            return SBOOL((MAKINUM(8191)&sterm)==(MAKINUM(8191)&gval));
          else
            return BOOL_F;
        }
        else
          return SBOOL(sterm==gval);
      }
      else
      if(NUMBER_P(gval))
        return BOOL_F;
      else
      if(sterm==gval)
        return BOOL_T;
      else
      if(NFALSEP(composite_equal_strong_pred_(sterm,gval)))
        return BOOL_T;
      else
        return BOOL_F;
    }
    else
      return SBOOL(sterm==gterm);
  }
  else
  if(NUMBER_P(sterm))
    return BOOL_F;
  else {
    gfun=CAR(gterm);
    sfun=CAR(sterm);
    if(((MAKINUM(534773760)&sfun)==(MAKINUM(534773760)&gfun))&&(((MAKINUM(131071)&sfun)>=(MAKINUM(131071)&gfun))&&(((MAKINUM(65535)&sfun)>=(MAKINUM(65535)&gfun))&&(((MAKINUM(2047)&sfun)>=(MAKINUM(2047)&gfun))&&((MAKINUM(31)&sfun)>=(MAKINUM(31)&gfun)))))) {
      if(ZERO_P(MAKINUM(65536)&gfun)) {
        for(spart=CDR(sterm),gpart=CDR(gterm);
            !(NULL_P(spart)||!(NFALSEP(subsumed_term_ordinary_pred_(CAR(spart),CAR(gpart)))));
            spart=CDR(spart),gpart=CDR(gpart)) ;
        return SBOOL(NULL_P(spart));
      }
      else
        return term_list_equal_pred_(CDR(gterm),CDR(sterm));
    }
    else
      return BOOL_F;
  }
}

SCM subsumed_term_ordinary_collectvars_pred_(sterm,gterm)
SCM sterm,gterm;
{
  SCM res;

  GLOBAL(collected_vars_global)=EOL;
  res=subsumed_term_ordinary_collectvars_aux_pred_(sterm,gterm);
  return cons(res,GLOBAL(collected_vars_global));
}

SCM subsumed_term_ordinary_collectvars_aux_pred_(sterm,gterm)
SCM sterm,gterm;
{
  SCM spart,gpart,gfun,sfun,gval;

  if(NUMBER_P(gterm)) {
    if(MAKINUM(65535)>gterm) {
      gval=STBL_VECTOR_REF(_star_var_val_table_star__velts0,MAKINUM(8191)&gterm);
      if(gval==MAKINUM(99999999)) {
        STBL_VECTOR_SET(_star_var_val_table_star__velts0,MAKINUM(8191)&gterm,sterm);
        GLOBAL(collected_vars_global)=cons(gterm,GLOBAL(collected_vars_global));
        if(ZERO_P(MAKINUM(8192)&gterm)) {
          var_set_flag_global=BOOL_T;
        }
        else {
          alt_var_set_flag_global=BOOL_T;
        }
        return BOOL_T;
      }
      else
      if(NUMBER_P(sterm)) {
        if(MAKINUM(65535)>sterm) {
          if(NUMBER_P(gval)&&(gval<=MAKINUM(65535)))
            return SBOOL((MAKINUM(8191)&sterm)==(MAKINUM(8191)&gval));
          else
            return BOOL_F;
        }
        else
          return SBOOL(sterm==gval);
      }
      else
      if(NUMBER_P(gval))
        return BOOL_F;
      else
      if(sterm==gval)
        return BOOL_T;
      else
      if(NFALSEP(composite_equal_strong_pred_(sterm,gval)))
        return BOOL_T;
      else
        return BOOL_F;
    }
    else
      return SBOOL(sterm==gterm);
  }
  else
  if(NUMBER_P(sterm))
    return BOOL_F;
  else {
    gfun=CAR(gterm);
    sfun=CAR(sterm);
    if(((MAKINUM(534773760)&sfun)==(MAKINUM(534773760)&gfun))&&(((MAKINUM(131071)&sfun)>=(MAKINUM(131071)&gfun))&&(((MAKINUM(65535)&sfun)>=(MAKINUM(65535)&gfun))&&(((MAKINUM(2047)&sfun)>=(MAKINUM(2047)&gfun))&&((MAKINUM(31)&sfun)>=(MAKINUM(31)&gfun)))))) {
      if(ZERO_P(MAKINUM(65536)&gfun)) {
        for(spart=CDR(sterm),gpart=CDR(gterm);
            !(NULL_P(spart)||!(NFALSEP(subsumed_term_ordinary_collectvars_aux_pred_(CAR(spart),CAR(gpart)))));
            spart=CDR(spart),gpart=CDR(gpart)) ;
        return SBOOL(NULL_P(spart));
      }
      else
        return term_list_equal_pred_(CDR(gterm),CDR(sterm));
    }
    else
      return BOOL_F;
  }
}

SCM subsumed_term_list_ordinary_pred_(sterm,gterm)
SCM sterm,gterm;
{
  SCM spart,gpart;

  for(spart=sterm,gpart=gterm;
      !(NULL_P(spart)||!(NFALSEP(subsumed_term_ordinary_pred_(CAR(spart),CAR(gpart)))));
      spart=CDR(spart),gpart=CDR(gpart)) ;
  return SBOOL(NULL_P(spart));
}

SCM swapped_subsumed_term_list_ordinary_pred_(sterm,gterm)
SCM sterm,gterm;
{
  SCM spart,gpart;

  if(NFALSEP(subsumed_term_ordinary_pred_(CAR(sterm),CAR(CDR(gterm))))) {
    if(NFALSEP(subsumed_term_ordinary_pred_(CAR(CDR(sterm)),CAR(gterm)))) {
      for(spart=CDR(CDR(sterm)),gpart=CDR(CDR(gterm));
          !(NULL_P(spart)||!(NFALSEP(subsumed_term_ordinary_pred_(CAR(spart),CAR(gpart)))));
          spart=CDR(spart),gpart=CDR(gpart)) ;
      return SBOOL(NULL_P(spart));
    }
    else
      return BOOL_F;
  }
  else
    return BOOL_F;
}

SCM not_zero_pred_(x)
SCM x;
{
  return NOT(SBOOL(ZERO_P(x)));
}

SCM mymax(x,y)
SCM x,y;
{
  if(x>y)
    return x;
  else
    return y;
}

SCM maxplus(max__1,x,y)
SCM max__1,x,y;
{
  SCM newmaxplusnr;

  newmaxplusnr=MAKINUM(INUM(x)+INUM(y));
  if(newmaxplusnr>max__1)
    return max__1;
  else
    return newmaxplusnr;
}

SCM rassq(key,lst)
SCM key,lst;
{
tailrecursion:
  if(NULL_P(lst))
    return BOOL_F;
  else
  if(key==CDR(CAR(lst)))
    return CAR(lst);
  else {
    lst=CDR(lst);
    goto tailrecursion;
  }
}

SCM adjoin(x,lst)
SCM x,lst;
{
  if(NFALSEP(memq(x,lst)))
    return lst;
  else
    return cons(x,lst);
}

SCM union_nonkeyword(xset,yset)
SCM xset,yset;
{
tailrecursion:
  if(NULL_P(xset))
    return yset;
  else
  if(NFALSEP(memq(CAR(xset),yset))) {
    xset=CDR(xset);
    goto tailrecursion;
  }
  else
    return cons(CAR(xset),union_nonkeyword(CDR(xset),yset));
}

SCM list_union(lst)
SCM lst;
{
  if(NULL_P(lst))
    return EOL;
  else
  if(NULL_P(CDR(lst)))
    return CAR(lst);
  else
    return union_nonkeyword(CAR(lst),list_union(CDR(lst)));
}

SCM member_memq_pred_(x,lst)
SCM x,lst;
{
tailrecursion:
  if(NULL_P(lst))
    return BOOL_F;
  else
  if(NFALSEP(memq(x,CAR(lst))))
    return BOOL_T;
  else {
    lst=CDR(lst);
    goto tailrecursion;
  }
}

SCM assoc_memq(x,lst)
SCM x,lst;
{
tailrecursion:
  if(NULL_P(lst))
    return BOOL_F;
  else
  if(NFALSEP(memq(x,CAR(CAR(lst)))))
    return CAR(lst);
  else {
    lst=CDR(lst);
    goto tailrecursion;
  }
}

SCM nth_cdr(n,lst)
SCM n,lst;
{
  SCM tmp_var1,tmp_var2;

tailrecursion:
  if(ZERO_P(n))
    return lst;
  else {
    tmp_var1=MAKINUM(INUM(n)-1);
    tmp_var2=CDR(lst);
    n=tmp_var1;
    lst=tmp_var2;
    goto tailrecursion;
  }
}

SCM pos_in_list(x,lst)
SCM x,lst;
{
  return pos_in_list_aux(x,lst,MAKINUM(1));
}

SCM pos_in_list_aux(x,lst,nr)
SCM x,lst,nr;
{
  SCM tmp_var1,tmp_var2;

tailrecursion:
  if(PAIR_P(lst)) {
    if(CAR(lst)==x)
      return nr;
    else {
      tmp_var1=CDR(lst);
      tmp_var2=MAKINUM(1+INUM(nr));
      lst=tmp_var1;
      nr=tmp_var2;
      goto tailrecursion;
    }
  }
  else
    return MAKINUM(-1);
}

SCM split_list(l,n)
SCM l,n;
{
  SCM lpart,res,resend;

  res=cons(EOL,EOL);
  resend=res;
  for(lpart=l;!(ZERO_P(n));lpart=CDR(lpart)) {
    SET_CDR(resend,cons(CAR(lpart),CDR(resend)));
    resend=CDR(resend);
    n=MAKINUM(INUM(n)-1);
  }
  return cons(CDR(res),lpart);
}

SCM split_if_exporthof(fn,lst)
SCM fn,lst;
{
  SCM lstpart,yeslst,nolst;

  yeslst=EOL;
  nolst=EOL;
  for(lstpart=lst;!(NULL_P(lstpart));lstpart=CDR(lstpart))
    if(NFALSEP(apply(fn,CAR(lstpart),listofnull))) {
      yeslst=cons(CAR(lstpart),yeslst);
    }
    else {
      nolst=cons(CAR(lstpart),nolst);
    }
  return cons(reverse(yeslst),reverse(nolst));
}

SCM split_if(fn,lst)
SCM (*fn)();
SCM lst;
{
  SCM lstpart,yeslst,nolst;

  yeslst=EOL;
  nolst=EOL;
  for(lstpart=lst;!(NULL_P(lstpart));lstpart=CDR(lstpart))
    if(NFALSEP((*fn)(CAR(lstpart)))) {
      yeslst=cons(CAR(lstpart),yeslst);
    }
    else {
      nolst=cons(CAR(lstpart),nolst);
    }
  return cons(reverse(yeslst),reverse(nolst));
}

SCM my_last_pair(x)
SCM x;
{
  if(PAIR_P(x))
    return my_last_pair_aux(x);
  else
    return x;
}

SCM my_last_pair_aux(x)
SCM x;
{
tailrecursion:
  if(PAIR_P(CDR(x))) {
    x=CDR(x);
    goto tailrecursion;
  }
  else
    return x;
}

SCM my_append_excl_(x,y)
SCM x,y;
{
  SCM z;

  z=my_last_pair(x);
  if(PAIR_P(z)) {
    SET_CDR(z,y);
    return x;
  }
  else
    return y;
}

SCM but_last(lst)
SCM lst;
{
  if(!(PAIR_P(lst)))
    return EOL;
  else
  if(!(PAIR_P(CDR(lst))))
    return EOL;
  else
    return cons(CAR(lst),but_last(CDR(lst)));
}

SCM map_excl__exporthof(fn,lst)
SCM fn,lst;
{
tailrecursion:
  if(NULL_P(lst))
    return lst;
  else {
    SET_CAR(lst,apply(fn,CAR(lst),listofnull));
    lst=CDR(lst);
    goto tailrecursion;
  }
}

SCM map_excl_(fn,lst)
SCM (*fn)();
SCM lst;
{
tailrecursion:
  if(NULL_P(lst))
    return lst;
  else {
    SET_CAR(lst,(*fn)(CAR(lst)));
    lst=CDR(lst);
    goto tailrecursion;
  }
}

SCM some_pred__exporthof(fn,lst)
SCM fn,lst;
{
  SCM new_var2;

tailrecursion:
  if(PAIR_P(lst)) {
    new_var2=apply(fn,CAR(lst),listofnull);
    if(NFALSEP(new_var2))
      return new_var2;
    else {
      lst=CDR(lst);
      goto tailrecursion;
    }
  }
  else
    return BOOL_F;
}

SCM some_pred_(fn,lst)
SCM (*fn)();
SCM lst;
{
  SCM new_var2;

tailrecursion:
  if(PAIR_P(lst)) {
    new_var2=(*fn)(CAR(lst));
    if(NFALSEP(new_var2))
      return new_var2;
    else {
      lst=CDR(lst);
      goto tailrecursion;
    }
  }
  else
    return BOOL_F;
}

SCM some_pred__inst2(npar__2,fn,lst)
SCM (*fn)();
SCM npar__2,lst;
{
  SCM new_var2;

tailrecursion:
  if(PAIR_P(lst)) {
    new_var2=(*fn)(npar__2,CAR(lst));
    if(NFALSEP(new_var2))
      return new_var2;
    else {
      lst=CDR(lst);
      goto tailrecursion;
    }
  }
  else
    return BOOL_F;
}

SCM some_pred__inst1(npar__1,fn,lst)
SCM *npar__1;
SCM (*fn)();
SCM lst;
{
  SCM new_var2;

tailrecursion:
  if(PAIR_P(lst)) {
    new_var2=(*fn)(npar__1,CAR(lst));
    if(NFALSEP(new_var2))
      return new_var2;
    else {
      lst=CDR(lst);
      goto tailrecursion;
    }
  }
  else
    return BOOL_F;
}

SCM every_pred__exporthof(fn,lst)
SCM fn,lst;
{
tailrecursion:
  if(PAIR_P(lst)) {
    if(NFALSEP(apply(fn,CAR(lst),listofnull))) {
      lst=CDR(lst);
      goto tailrecursion;
    }
    else
      return BOOL_F;
  }
  else
    return BOOL_T;
}

SCM every_pred_(fn,lst)
SCM (*fn)();
SCM lst;
{
tailrecursion:
  if(PAIR_P(lst)) {
    if(NFALSEP((*fn)(CAR(lst)))) {
      lst=CDR(lst);
      goto tailrecursion;
    }
    else
      return BOOL_F;
  }
  else
    return BOOL_T;
}

SCM every_pred__inst1(npar__4,fn,lst)
SCM (*fn)();
SCM npar__4,lst;
{
tailrecursion:
  if(PAIR_P(lst)) {
    if(NFALSEP((*fn)(npar__4,CAR(lst)))) {
      lst=CDR(lst);
      goto tailrecursion;
    }
    else
      return BOOL_F;
  }
  else
    return BOOL_T;
}

SCM member_if_exporthof(fn,lst)
SCM fn,lst;
{
tailrecursion:
  if(PAIR_P(lst)) {
    if(NFALSEP(apply(fn,CAR(lst),listofnull)))
      return lst;
    else {
      lst=CDR(lst);
      goto tailrecursion;
    }
  }
  else
    return BOOL_F;
}

SCM member_if(fn,lst)
SCM (*fn)();
SCM lst;
{
tailrecursion:
  if(PAIR_P(lst)) {
    if(NFALSEP((*fn)(CAR(lst))))
      return lst;
    else {
      lst=CDR(lst);
      goto tailrecursion;
    }
  }
  else
    return BOOL_F;
}

SCM member_if_inst1(npar__5,fn,lst)
SCM (*fn)();
SCM npar__5,lst;
{
tailrecursion:
  if(PAIR_P(lst)) {
    if(NFALSEP((*fn)(npar__5,CAR(lst))))
      return lst;
    else {
      lst=CDR(lst);
      goto tailrecursion;
    }
  }
  else
    return BOOL_F;
}

SCM remove_if_exporthof(fn,lst)
SCM fn,lst;
{
tailrecursion:
  if(!(PAIR_P(lst)))
    return lst;
  else
  if(NFALSEP(apply(fn,CAR(lst),listofnull))) {
    lst=CDR(lst);
    goto tailrecursion;
  }
  else
    return cons(CAR(lst),remove_if_exporthof(fn,CDR(lst)));
}

SCM remove_if(fn,lst)
SCM (*fn)();
SCM lst;
{
tailrecursion:
  if(!(PAIR_P(lst)))
    return lst;
  else
  if(NFALSEP((*fn)(CAR(lst)))) {
    lst=CDR(lst);
    goto tailrecursion;
  }
  else
    return cons(CAR(lst),remove_if(fn,CDR(lst)));
}

SCM remove_if_inst1(npar__3,fn,lst)
SCM (*fn)();
SCM npar__3,lst;
{
tailrecursion:
  if(!(PAIR_P(lst)))
    return lst;
  else
  if(NFALSEP((*fn)(npar__3,CAR(lst)))) {
    lst=CDR(lst);
    goto tailrecursion;
  }
  else
    return cons(CAR(lst),remove_if_inst1(npar__3,fn,CDR(lst)));
}

SCM filter_map_exporthof(f,lst)
SCM f,lst;
{
  SCM res;

tailrecursion:
  if(PAIR_P(lst)) {
    res=apply(f,CAR(lst),listofnull);
    if(NFALSEP(res))
      return cons(res,filter_map_exporthof(f,CDR(lst)));
    else {
      lst=CDR(lst);
      goto tailrecursion;
    }
  }
  else
    return EOL;
}

SCM filter_map(f,lst)
SCM (*f)();
SCM lst;
{
  SCM res;

tailrecursion:
  if(PAIR_P(lst)) {
    res=(*f)(CAR(lst));
    if(NFALSEP(res))
      return cons(res,filter_map(f,CDR(lst)));
    else {
      lst=CDR(lst);
      goto tailrecursion;
    }
  }
  else
    return EOL;
}

SCM copy_list(lst)
SCM lst;
{
  if(NULL_P(lst))
    return lst;
  else
    return cons(CAR(lst),copy_list(CDR(lst)));
}

SCM sum_list(lst)
SCM lst;
{
  if(PAIR_P(lst))
    return MAKINUM(INUM(CAR(lst))+INUM(sum_list(CDR(lst))));
  else
    return MAKINUM(0);
}

SCM remove_one_equal(what,lst)
SCM what,lst;
{
  if(NULL_P(lst))
    return lst;
  else
  if(NFALSEP(equal(what,CAR(lst))))
    return CDR(lst);
  else
    return cons(CAR(lst),remove_one_equal(what,CDR(lst)));
}

SCM remove_eq(el,lst)
SCM el,lst;
{
tailrecursion:
  if(NULL_P(lst))
    return lst;
  else
  if(CAR(lst)==el) {
    lst=CDR(lst);
    goto tailrecursion;
  }
  else
    return cons(CAR(lst),remove_eq(el,CDR(lst)));
}

SCM remove_at_place(place,lst)
SCM place,lst;
{
  if(NULL_P(lst))
    return lst;
  else
  if(place==lst)
    return CDR(lst);
  else
    return cons(CAR(lst),remove_at_place(place,CDR(lst)));
}

SCM replace_one_eq(what,with,lst)
SCM what,with,lst;
{
  if(NULL_P(lst))
    return EOL;
  else
  if(what==CAR(lst))
    return cons(with,CDR(lst));
  else
    return cons(CAR(lst),replace_one_eq(what,with,CDR(lst)));
}

SCM replace_nth(where,nr,with)
SCM where,nr,with;
{
  if(MAKINUM(1)==nr)
    return cons(with,CDR(where));
  else
    return cons(CAR(where),replace_nth(CDR(where),MAKINUM(INUM(nr)-1),with));
}

SCM remove_at_place_excl_(place,lst)
SCM place,lst;
{
  SCM lstpart;

  if(NULL_P(lst))
    return EOL;
  else
  if(NULL_P(CDR(lst)))
    return EOL;
  else {
    for(lstpart=lst;!(PAIR_P(CDR(lstpart))&&(place==CDR(lstpart)));lstpart=CDR(lstpart)) ;
    SET_CDR(lstpart,CDR(CDR(lstpart)));
    return UNSPECIFIED;
  }
}

SCM make_inside_subset(lst,where)
SCM lst,where;
{
  GLOBAL(make_inside_subset_tmp_global)=EOL;
  GLOBAL(make_inside_subset_tmp_lst_global)=lst;
  make_inside_subset_aux_excl_(where);
  return GLOBAL(make_inside_subset_tmp_global);
}

SCM make_inside_subset_aux_excl_(where)
SCM where;
{
  SCM lstpart;

  if(!(NULL_P(GLOBAL(make_inside_subset_tmp_lst_global)))) {
    if(PAIR_P(where))
      return for_each1(make_inside_subset_aux_excl_,where);
    else {
      for(lstpart=GLOBAL(make_inside_subset_tmp_lst_global);!(NULL_P(lstpart));lstpart=CDR(lstpart))
        if(CAR(lstpart)==where) {
          GLOBAL(make_inside_subset_tmp_global)=cons(CAR(lstpart),GLOBAL(make_inside_subset_tmp_global));
          GLOBAL(make_inside_subset_tmp_lst_global)=remove_at_place(lstpart,GLOBAL(make_inside_subset_tmp_lst_global));
        }
      return UNSPECIFIED;
    }
  }
  else
    return UNSPECIFIED;
}

SCM display_kept_nr()
{
  newline(cur_output_port());
  display(const_3,cur_output_port());
  display(GLOBAL(checkpoint_keptnrs_global),cur_output_port());
  display(const_4,cur_output_port());
  return newline(cur_output_port());
}

SCM given_clause_slow_loop()
{
  SCM given_cl_place,given_cl,tmp;

  GLOBAL(last_best_weight_global)=MAKINUM(0);
  GLOBAL(foundflag_global)=BOOL_F;
  GLOBAL(answer_cl_global)=EOL;
  GLOBAL(new_demodulators_list_global)=EOL;
  GLOBAL(answer_history_global)=EOL;
  GLOBAL(slow_start_time_global)=get_check_time(MAKINUM(0));
  store_time_checkpoint_excl_(MAKINUM(0));
  if(!(NFALSEP(GLOBAL(int_logic_flag_global)))) {
    GLOBAL(sos_clauses_list_end_global)=my_last_pair(GLOBAL(sos_clauses_list_global));
  }
  GLOBAL(usable_clauses_list_global)=cons(EOL,GLOBAL(usable_clauses_list_global));
  GLOBAL(usable_clauses_list_end_global)=my_last_pair(GLOBAL(usable_clauses_list_global));
  clear_x_vars_and_touched_excl_(MAKINUM(255));
  clear_y_vars_and_touched_excl_(MAKINUM(255));
  clear_z_vars_and_touched_excl_(MAKINUM(255));
  GLOBAL(one_step_hyper_phase_global)=BOOL_F;
  GLOBAL(sos_preference_cur_ratio_global)=GLOBAL(sos_preference_ratio_global);
  if(NFALSEP(GLOBAL(factors_stratflag_global)))
    factor_sos(GLOBAL(sos_clauses_list_global));
  for(;!(NULL_P(GLOBAL(sos_clauses_list_global))||(NFALSEP(GLOBAL(foundflag_global))||((INUM(get_check_time(MAKINUM(1)))-INUM(GLOBAL(slow_start_time_global)))>INUM(GLOBAL(one_pass_time_global)))));) {
    if((NFALSEP(GLOBAL(one_pass_time_global))||!(NULL_P(GLOBAL(given_checkpoint_keptnrs_global))))&&(NFALSEP(GLOBAL(unit_equality_strat_global))&&((GLOBAL(sos_preference_ratio_global)<MAKINUM(5))&&((100*(INUM(get_check_time(MAKINUM(2)))-INUM(GLOBAL(slow_start_time_global))))>(20*INUM(GLOBAL(one_pass_time_global))))))) {
      store_time_checkpoint_excl_(MAKINUM(55));
      if(GLOBAL(display_info_level_global)>=MAKINUM(50)) {
        newline(cur_output_port());
        display(const_7,cur_output_port());
        newline(cur_output_port());
      }
      GLOBAL(sos_preference_ratio_global)=MAKINUM(5);
    }
    if((NFALSEP(GLOBAL(one_pass_time_global))||!(NULL_P(GLOBAL(given_checkpoint_keptnrs_global))))&&(NFALSEP(GLOBAL(unit_equality_strat_global))&&((GLOBAL(sos_preference_ratio_global)<MAKINUM(100))&&((100*(INUM(get_check_time(MAKINUM(2)))-INUM(GLOBAL(slow_start_time_global))))>(50*INUM(GLOBAL(one_pass_time_global))))))) {
      store_time_checkpoint_excl_(MAKINUM(45));
      if(GLOBAL(display_info_level_global)>=MAKINUM(50)) {
        newline(cur_output_port());
        display(const_8,cur_output_port());
        newline(cur_output_port());
      }
      GLOBAL(sos_preference_ratio_global)=MAKINUM(100000);
    }
    if((NFALSEP(GLOBAL(one_pass_time_global))||!(NULL_P(GLOBAL(given_checkpoint_keptnrs_global))))&&(!(NFALSEP(GLOBAL(unit_equality_strat_global)))&&(NFALSEP(GLOBAL(binary_hyper_sos_strategy_global))&&(!(NFALSEP(GLOBAL(hyper_strategy_flag_global)))&&((100*(INUM(get_check_time(MAKINUM(2)))-INUM(GLOBAL(slow_start_time_global))))>(50*INUM(GLOBAL(one_pass_time_global)))))))) {
      store_time_checkpoint_excl_(MAKINUM(2));
      if(GLOBAL(display_info_level_global)>=MAKINUM(50)) {
        newline(cur_output_port());
        display(const_9,cur_output_port());
        newline(cur_output_port());
      }
      GLOBAL(unit_strategy_flag_global)=BOOL_F;
      GLOBAL(name_order_strategy_flag_global)=BOOL_F;
      GLOBAL(hyper_strategy_flag_global)=BOOL_T;
      GLOBAL(para_pos_unit_strategy_global)=BOOL_T;
      GLOBAL(hyper_strategy_flag_global)=BOOL_T;
    }
    if((NFALSEP(GLOBAL(one_pass_time_global))||!(NULL_P(GLOBAL(given_checkpoint_keptnrs_global))))&&(!(NFALSEP(GLOBAL(unit_equality_strat_global)))&&((!(NFALSEP(GLOBAL(unit_strategy_flag_global)))||(GLOBAL(sos_preference_ratio_global)<MAKINUM(100)))&&(!(NFALSEP(GLOBAL(binary_hyper_sos_strategy_global)))&&(!(NFALSEP(GLOBAL(hyper_contradiction_strategy_global)))&&(!(NFALSEP(GLOBAL(hyper_strategy_flag_global)))&&((100*(INUM(get_check_time(MAKINUM(3)))-INUM(GLOBAL(slow_start_time_global))))>(50*INUM(GLOBAL(one_pass_time_global)))))))))) {
      store_time_checkpoint_excl_(MAKINUM(3));
      if(GLOBAL(display_info_level_global)>=MAKINUM(50)) {
        newline(cur_output_port());
        display(const_10,cur_output_port());
        newline(cur_output_port());
      }
      GLOBAL(sos_preference_ratio_global)=MAKINUM(100000);
      GLOBAL(unit_strategy_flag_global)=BOOL_T;
    }
    if((NFALSEP(GLOBAL(one_pass_time_global))||!(NULL_P(GLOBAL(given_checkpoint_keptnrs_global))))&&(!(NFALSEP(GLOBAL(unit_equality_strat_global)))&&(!(NFALSEP(GLOBAL(binary_hyper_sos_strategy_global)))&&(!(NFALSEP(GLOBAL(hyper_contradiction_strategy_global)))&&((100*(INUM(get_check_time(MAKINUM(4)))-INUM(GLOBAL(slow_start_time_global))))>(75*INUM(GLOBAL(one_pass_time_global)))))))) {
      store_time_checkpoint_excl_(MAKINUM(4));
      if(NFALSEP(GLOBAL(hyper_strategy_flag_global))) {
        if(GLOBAL(display_info_level_global)>=MAKINUM(50)) {
          newline(cur_output_port());
          display(const_11,cur_output_port());
          newline(cur_output_port());
        }
        start_backward_hyper_analysis();
        GLOBAL(usable_clauses_list_global)=cons(EOL,GLOBAL(usable_clauses_list_global));
        GLOBAL(usable_clauses_list_end_global)=my_last_pair(GLOBAL(usable_clauses_list_global));
        GLOBAL(sos_preference_cur_ratio_global)=GLOBAL(sos_preference_ratio_global);
      }
      else {
        if(GLOBAL(display_info_level_global)>=MAKINUM(50)) {
          newline(cur_output_port());
          display(const_12,cur_output_port());
          newline(cur_output_port());
        }
        start_binary_hypercheck_strategy();
        if(GLOBAL(display_info_level_global)>=MAKINUM(50)) {
          newline(cur_output_port());
          display(const_13,cur_output_port());
          newline(cur_output_port());
        }
      }
    }
    given_cl_place=select_given_cl_place(GLOBAL(sos_clauses_list_global));
    given_cl=CAR(given_cl_place);
    tmp=EOL;
    if(given_cl_place==GLOBAL(sos_clauses_list_global)) {
      GLOBAL(sos_clauses_list_global)=CDR(GLOBAL(sos_clauses_list_global));
    }
    else
    if(NULL_P(CDR(given_cl_place))) {
      remove_at_place_excl_(given_cl_place,GLOBAL(sos_clauses_list_global));
      GLOBAL(sos_clauses_list_end_global)=my_last_pair(GLOBAL(sos_clauses_list_global));
    }
    else {
      remove_at_place_excl_(given_cl_place,GLOBAL(sos_clauses_list_global));
    }
    if(!(ZERO_P(MAKINUM(65535)&CAR(CAR(given_cl))))&&(!(NFALSEP(GLOBAL(foundflag_global)))&&(NFALSEP((!(NFALSEP(GLOBAL(back_demodulate_flag_global))) ? BOOL_T : (GLOBAL(special_insertion_place_global)=cons(EOL,EOL),UNSPECIFIED,tmp=demodulate_clause(given_cl),UNSPECIFIED,GLOBAL(special_insertion_place_global)=EOL,UNSPECIFIED,(!(NFALSEP(tmp)) ? BOOL_T : (given_cl=CDR(tmp),UNSPECIFIED)),BOOL_T)))&&(0||!(NFALSEP(given_cl_havealready_pred_(given_cl))))))) {
      GLOBAL(given_clause_nr_global)=MAKINUM(1+INUM(GLOBAL(given_clause_nr_global)));
      SET_CDR(GLOBAL(usable_clauses_list_end_global),cons(given_cl,EOL));
      GLOBAL(usable_clauses_list_end_global)=CDR(GLOBAL(usable_clauses_list_end_global));
      insert_to_subsumption_list_excl_(MAKINUM(INUM(MAKINUM(8257536)&CAR(CAR(given_cl)))>>17),MAKINUM(65535)&CAR(CAR(given_cl)),given_cl);
      if(GLOBAL(display_info_level_global)>=MAKINUM(50)) {
        newline(cur_output_port());
        display(const_14,cur_output_port());
        display(GLOBAL(given_clause_nr_global),cur_output_port());
        display(const_15,cur_output_port());
        newline(cur_output_port());
        print_pure_clause(CDR(given_cl));
        newline(cur_output_port());
        if(NFALSEP(GLOBAL(display_debug_info_flag_global))) {
          newline(cur_output_port());
          display(const_16,cur_output_port());
          newline(cur_output_port());
          debug_print_clause(given_cl);
          newline(cur_output_port());
        }
      }
      GLOBAL(stop_fast_loop_flag_global)=BOOL_F;
      if(NFALSEP(GLOBAL(back_demodulate_flag_global))&&!(NULL_P(GLOBAL(new_demodulators_list_global))))
        back_demodulate_usable();
      GLOBAL(new_demodulators_list_global)=EOL;
      if(NFALSEP(GLOBAL(int_logic_flag_global)))
        apply(GLOBAL(int_usable_clauses_fast_loop),given_cl,cons(BOOL_T,listofnull));
      else
        usable_clauses_fast_loop(given_cl,BOOL_T);
    }
  }
  if(!(NULL_P(GLOBAL(sos_clauses_list_global)))&&!(NFALSEP(GLOBAL(foundflag_global)))) {
    store_time_checkpoint_excl_(MAKINUM(1));
    if(GLOBAL(display_info_level_global)>MAKINUM(38)) {
      newline(cur_output_port());
      display(const_5,cur_output_port());
      newline(cur_output_port());
    }
    GLOBAL(answer_history_global)=not_enough_time_symb;
  }
  else
  if(NULL_P(GLOBAL(sos_clauses_list_global))&&(GLOBAL(display_info_level_global)>MAKINUM(38))) {
    newline(cur_output_port());
    display(const_6,cur_output_port());
    newline(cur_output_port());
  }
  return GLOBAL(foundflag_global);
}

SCM select_given_cl_place(lst)
SCM lst;
{
  SCM lstpart__1,lstpart,bestpl,bestweight;

  if(NULL_P(lst)) {
    lst=apply(GLOBAL(copy_tree),const_17,listofnull);
  }
  if(GLOBAL(sos_preference_cur_ratio_global)<=MAKINUM(0)) {
    GLOBAL(sos_preference_cur_ratio_global)=GLOBAL(sos_preference_ratio_global);
    return lst;
  }
  else {
    bestpl=lst;
    bestweight=(MAKINUM(2047)&CAR(CAR(CAR(lst))));
    GLOBAL(last_best_weight_global)=MAKINUM(9999999);
    GLOBAL(sos_preference_cur_ratio_global)=MAKINUM(INUM(GLOBAL(sos_preference_cur_ratio_global))-1);
    if(NFALSEP(GLOBAL(split_strategy_flag_global))) {
      for(lstpart=lst;!(NULL_P(lstpart));lstpart=CDR(lstpart))
        if(((MAKINUM(2047)&CAR(CDR(CDR(CDR(CAR(CAR(lstpart)))))))<bestweight)&&!(ZERO_P(MAKINUM(2047)&CAR(CAR(CAR(lstpart)))))) {
          bestpl=lstpart;
          GLOBAL(last_best_weight_global)=bestweight;
          bestweight=(MAKINUM(2047)&CAR(CDR(CDR(CDR(CAR(CAR(lstpart)))))));
        }
      if(NFALSEP(equal(GLOBAL(last_best_weight_global),MAKINUM(9999999)))) {
        GLOBAL(last_best_weight_global)=bestweight;
      }
      return bestpl;
    }
    else {
      for(lstpart__1=lst;!(NULL_P(lstpart__1));lstpart__1=CDR(lstpart__1))
        if(((MAKINUM(2047)&CAR(CAR(CAR(lstpart__1))))<bestweight)&&!(ZERO_P(MAKINUM(2047)&CAR(CAR(CAR(lstpart__1)))))) {
          bestpl=lstpart__1;
          GLOBAL(last_best_weight_global)=bestweight;
          bestweight=(MAKINUM(2047)&CAR(CAR(CAR(lstpart__1))));
        }
      if(NFALSEP(equal(GLOBAL(last_best_weight_global),MAKINUM(9999999)))) {
        GLOBAL(last_best_weight_global)=bestweight;
      }
      return bestpl;
    }
  }
}

SCM given_cl_havealready_pred_(given_cl)
SCM given_cl;
{
  SCM tmp,res;

  tmp=BOOL_F;
  res=BOOL_F;
  GLOBAL(subsuming_clause_global)=BOOL_F;
  GLOBAL(prohibit_subs_clnr_global)=CAR(CDR(CDR(CDR(CDR(CAR(given_cl))))));
  if(NULL_P(CDR(CDR(given_cl)))) {
    tmp=check_discr_tree(GLOBAL(discr_tree_global),CAR(CDR(given_cl)));
    if(NFALSEP(tmp)&&(!(NULL_P(CDR(tmp)))&&(!(NULL_P(CDR(CDR(tmp))))&&((MAKINUM(268435456)&CAR(CAR(CDR(given_cl))))==(MAKINUM(268435456)&CAR(CAR(CDR(CAR(CDR(CDR(tmp))))))))))) {
      res=CAR(CDR(CDR(tmp)));
    }
    else {
      res=BOOL_F;
    }
  }
  else {
    res=some_pred__inst1(&tmp,given_cl_havealready_pred__fn6,CDR(given_cl));
    if(!(NFALSEP(res))) {
      res=havealready_clause_pred_(CAR(given_cl),CDR(given_cl));
    }
  }
  GLOBAL(prohibit_subs_clnr_global)=BOOL_F;
  if(NFALSEP(res)) {
    GLOBAL(back_subsumed_nr_global)=MAKINUM(1+INUM(GLOBAL(back_subsumed_nr_global)));
    SET_CAR(CAR(given_cl),MAKINUM(65535^INUM(MAKINUM(65535)|CAR(CAR(given_cl)))));
  }
  if(NFALSEP(res)&&(GLOBAL(display_info_level_global)>=MAKINUM(50))) {
    newline(cur_output_port());
    display(const_18,cur_output_port());
    newline(cur_output_port());
    print_pure_clause(CDR(given_cl));
    display(const_19,cur_output_port());
    newline(cur_output_port());
    if(NFALSEP(GLOBAL(subsuming_clause_global)))
      print_pure_clause(CDR(GLOBAL(subsuming_clause_global)));
    else
      print_pure_clause(CDR(res));
    newline(cur_output_port());
  }
  return res;
}

SCM given_cl_havealready_pred__fn6(tmp,lit)
SCM *tmp;
SCM lit;
{
  *tmp=check_discr_tree(GLOBAL(discr_tree_global),lit);
  if(NFALSEP(*tmp)&&(!(NULL_P(CDR(*tmp)))&&(!(NULL_P(CDR(CDR(*tmp))))&&((MAKINUM(268435456)&CAR(lit))==(MAKINUM(268435456)&CAR(CAR(CDR(CAR(CDR(CDR(*tmp)))))))))))
    return CAR(CDR(CDR(*tmp)));
  else
    return BOOL_F;
}

SCM usable_clauses_fast_loop(given_cl,full_nucleus_flag)
SCM given_cl,full_nucleus_flag;
{
  SCM usable_cl,xcl,xinf,usable_clauses_list_part,results_part,one_step_results,ycl,yinf,ylitinf,yclmaxvar,given_cl_is_nuc_flag,given_cl_is_neg_flag,given_cl_is_final_nuc_flag,given_final_nuc_premiss_lit,given_final_nuc_complfunpure,given_cl_contains_eq_flag,given_is_unit_flag;

  ycl=CDR(given_cl);
  yinf=CAR(given_cl);
  ylitinf=CAR(CDR(CDR(yinf)));
  yclmaxvar=give_cl_maxvar(yinf);
  given_cl_is_nuc_flag=BOOL_F;
  given_cl_is_neg_flag=BOOL_F;
  given_cl_is_final_nuc_flag=BOOL_F;
  given_final_nuc_premiss_lit=EOL;
  given_final_nuc_complfunpure=EOL;
  given_cl_contains_eq_flag=BOOL_F;
  given_is_unit_flag=BOOL_F;
  GLOBAL(used_demodulators_global)=EOL;
  if(NFALSEP(full_nucleus_flag)) {
    ycl=map1(rename_x_to_y_term,ycl);
  }
  else {
    ycl=map1(rename_x_to_y_term,ycl);
  }
  if(NFALSEP(unit_cl_pred_(ycl))) {
    given_is_unit_flag=BOOL_T;
  }
  if(NFALSEP(GLOBAL(hyper_strategy_flag_global))) {
    if(NFALSEP((NFALSEP(GLOBAL(neg_hyper_strategy_flag_global)) ? negative_cl_pred_(ycl) : positive_cl_pred_(ycl)))) {
      given_cl_is_nuc_flag=BOOL_F;
      if(NFALSEP(contains_eqlit_cl_pred_(ycl))) {
        given_cl_contains_eq_flag=BOOL_T;
      }
      else {
        given_cl_contains_eq_flag=BOOL_F;
      }
    }
    else {
      if(NFALSEP(has_single_hyper_premiss_pred_(ycl))) {
        given_cl_is_final_nuc_flag=BOOL_T;
        given_final_nuc_premiss_lit=first_hyper_premiss_lit(ycl);
        given_final_nuc_complfunpure=MAKINUM(268435456^INUM(MAKINUM(534773760)&CAR(given_final_nuc_premiss_lit)));
      }
      if(NFALSEP(negative_cl_pred_(ycl))) {
        given_cl_is_neg_flag=BOOL_T;
      }
      given_cl_is_nuc_flag=BOOL_T;
    }
  }
  if(NFALSEP(GLOBAL(hyper_strategy_flag_global))&&(NFALSEP(given_cl_is_nuc_flag)&&!(NFALSEP(given_cl_is_final_nuc_flag)))) {
    one_step_results=one_step_for_hyper(cons(CAR(given_cl),ycl));
    for(results_part=one_step_results;!(NULL_P(results_part)||NFALSEP(GLOBAL(foundflag_global)));results_part=CDR(results_part)) {
      GLOBAL(stop_fast_loop_flag_global)=BOOL_F;
      usable_clauses_fast_loop(CAR(results_part),BOOL_F);
    }
  }
  if(!(NFALSEP(GLOBAL(hyper_strategy_flag_global)))||(!(NFALSEP(given_cl_is_nuc_flag))||NFALSEP(given_cl_is_final_nuc_flag))) {
    for(usable_clauses_list_part=CDR(GLOBAL(usable_clauses_list_global));!(NULL_P(usable_clauses_list_part)||(NFALSEP(GLOBAL(foundflag_global))||NFALSEP(GLOBAL(stop_fast_loop_flag_global))));usable_clauses_list_part=CDR(usable_clauses_list_part)) {
      usable_cl=CAR(usable_clauses_list_part);
      xcl=CDR(usable_cl);
      xinf=CAR(usable_cl);
      if(GLOBAL(display_info_level_global)>=MAKINUM(90)) {
        newline(cur_output_port());
        display(const_20,cur_output_port());
        newline(cur_output_port());
        print_pure_clause(CDR(usable_cl));
        newline(cur_output_port());
        if(NFALSEP(GLOBAL(display_debug_info_flag_global))) {
          display(const_21,cur_output_port());
          newline(cur_output_port());
          debug_print_clause(usable_cl);
          newline(cur_output_port());
        }
      }
      if(!(ZERO_P(MAKINUM(65535)&CAR(xinf)))) {
        if(NFALSEP(GLOBAL(hyper_strategy_flag_global))) {
          if(NFALSEP(GLOBAL(neg_hyper_strategy_flag_global))) {
            if(!(NFALSEP(given_cl_is_nuc_flag)&&(!(NFALSEP(given_cl_is_neg_flag))&&NFALSEP(mixed_cl_pred_(xcl)))))
              two_clause_binres_loop(xcl,ycl,xinf,yinf,ylitinf,yclmaxvar);
          }
          else
          if(NFALSEP(given_cl_is_nuc_flag)) {
            if(NFALSEP(positive_cl_pred_(xcl))) {
              if(NULL_P(CDR(xcl))) {
                if(given_final_nuc_complfunpure==(MAKINUM(534773760)&CAR(CAR(xcl))))
                  unit_and_final_nuc_res(xcl,ycl,CAR(xcl),given_final_nuc_premiss_lit,xinf,yinf,ylitinf,yclmaxvar,MAKINUM(1),CAR(CAR(CDR(CDR(xinf)))));
              }
              else
                final_nuc_res(xcl,ycl,given_final_nuc_premiss_lit,xinf,yinf,ylitinf,yclmaxvar,given_final_nuc_complfunpure);
            }
          }
          else
          if(NFALSEP(GLOBAL(type_theory_stratflag_global))) {
            if(NFALSEP(positive_cl_pred_(xcl))) {
              if(NFALSEP(GLOBAL(paramodulation_strategy_flag_global)))
                two_posunits_typet_para(xcl,ycl,xinf,yinf,ylitinf,yclmaxvar);
            }
            else
              two_clause_binres_loop(xcl,ycl,xinf,yinf,ylitinf,yclmaxvar);
          }
          else
          if(NFALSEP(given_cl_contains_eq_flag))
            two_clause_binres_loop(xcl,ycl,xinf,yinf,ylitinf,yclmaxvar);
          else
          if(NFALSEP(contains_eqorneg_cl_pred_(xcl)))
            two_clause_binres_loop(xcl,ycl,xinf,yinf,ylitinf,yclmaxvar);
        }
        else
        if(NFALSEP(GLOBAL(neg_hyper_strategy_flag_global))) {
          if((NFALSEP(given_cl_is_neg_flag)&&!(NFALSEP(negative_cl_pred_(xcl))))||(NFALSEP(negative_cl_pred_(xcl))&&!(NFALSEP(given_cl_is_neg_flag))))
            two_clause_binres_loop(xcl,ycl,xinf,yinf,ylitinf,yclmaxvar);
        }
        else
        if(!(NFALSEP(GLOBAL(unit_strategy_flag_global)))||(NFALSEP(given_is_unit_flag)||NFALSEP(unit_cl_pred_(xcl)))) {
          two_clause_binres_loop(xcl,ycl,xinf,yinf,ylitinf,yclmaxvar);
          if(NFALSEP(GLOBAL(type_theory_stratflag_global))&&(NFALSEP(GLOBAL(paramodulation_strategy_flag_global))&&(NFALSEP(given_is_unit_flag)&&(NFALSEP(unit_cl_pred_(xcl))&&(NFALSEP(positive_cl_pred_(xcl))&&NFALSEP(positive_cl_pred_(ycl)))))))
            two_posunits_typet_para(xcl,ycl,xinf,yinf,ylitinf,yclmaxvar);
        }
      }
    }
    return UNSPECIFIED;
  }
  else
    return UNSPECIFIED;
}

SCM two_clause_binres_loop(xcl,ycl,xinf,yinf,ylitinf,yclmaxvar)
SCM xcl,ycl,xinf,yinf,ylitinf,yclmaxvar;
{
  SCM condlit,unused,ytmp,xtmp,res,xlit,xfun,xpart,xlitinfpart,xlitnr,compl_yfunpure,ylit,yfun,ylitcurinf,ypart,ylitinfpart,ylitnr,xlitinf,history,ans_inf;

  xlitinf=CAR(CDR(CDR(xinf)));
  history=EOL;
  ans_inf=BOOL_F;
  GLOBAL(used_demodulators_global)=EOL;
  for(ypart=ycl,ylitinfpart=ylitinf,ylitnr=MAKINUM(1);
      !(NULL_P(ypart)||NFALSEP(GLOBAL(foundflag_global)));
      ypart=CDR(ypart),ylitinfpart=CDR(ylitinfpart),ylitnr=MAKINUM(1+INUM(ylitnr))) {
    ylit=CAR(ypart);
    yfun=CAR(ylit);
    ylitcurinf=CAR(ylitinfpart);
    if(!(litinf_nobinrespara_mask_global==(litinf_nobinrespara_mask_global&CAR(ylitcurinf)))) {
      compl_yfunpure=MAKINUM(268435456^INUM(MAKINUM(534773760)&yfun));
      if(NFALSEP(GLOBAL(paramodulation_strategy_flag_global))&&((GLOBAL(eq_pred_nr_global)==(MAKINUM(534773760)&yfun))&&(!(NFALSEP(GLOBAL(para_pos_unit_strategy_global)))||(NFALSEP(unit_cl_pred_(ycl))&&(NFALSEP(unit_cl_pred_(xcl))&&!(!(ZERO_P(MAKINUM(268435456)&CAR(first_nonans_lit(xcl)))))))))) {
        GLOBAL(used_demodulators_global)=EOL;
        GLOBAL(param_eqlit_global)=ylit;
        GLOBAL(param_tocl_global)=xcl;
        GLOBAL(param_fromcl_global)=ycl;
        GLOBAL(param_left_arg_global)=CAR(CDR(ylit));
        GLOBAL(param_right_arg_global)=CAR(CDR(CDR(ylit)));
        GLOBAL(param_toinf_global)=xlitinf;
        GLOBAL(param_frominf_global)=ylitinf;
        GLOBAL(param_from_is_y_flag_global)=BOOL_T;
        GLOBAL(param_yclmaxvar_global)=yclmaxvar;
        GLOBAL(param_xclmaxvar_global)=give_cl_maxvar(xinf);
        GLOBAL(param_fromhist_global)=CAR(CDR(CDR(CDR(CDR(CDR(yinf))))));
        GLOBAL(param_tohist_global)=CAR(CDR(CDR(CDR(CDR(CDR(xinf))))));
        GLOBAL(param_fromlitnr_global)=ylitnr;
        param_use_left_flag_global=SBOOL(ZERO_P(MAKINUM(16)&CAR(ylitcurinf)));
        param_use_right_flag_global=SBOOL(ZERO_P(MAKINUM(32)&CAR(ylitcurinf)));
      }
      else {
        GLOBAL(param_eqlit_global)=BOOL_F;
      }
      for(xpart=xcl,xlitinfpart=xlitinf,xlitnr=MAKINUM(1);
          !(NULL_P(xpart)||NFALSEP(GLOBAL(foundflag_global)));
          xpart=CDR(xpart),xlitinfpart=CDR(xlitinfpart),xlitnr=MAKINUM(1+INUM(xlitnr))) {
        xlit=CAR(xpart);
        xfun=CAR(xlit);
        if(!(litinf_nobinrespara_mask_global==(litinf_nobinrespara_mask_global&CAR(CAR(xlitinfpart))))) {
          if(NFALSEP(GLOBAL(param_eqlit_global))&&(ZERO_P(MAKINUM(8)&CAR(CAR(xlitinfpart)))&&(NFALSEP(param_use_left_flag_global)||NFALSEP(param_use_right_flag_global)))) {
            GLOBAL(param_tolit_global)=xlit;
            GLOBAL(param_tolitnr_global)=xlitnr;
            paramodulate_into_term(xlit,EOL,BOOL_T);
          }
          if(NFALSEP(GLOBAL(paramodulation_strategy_flag_global))&&((GLOBAL(eq_pred_nr_global)==(MAKINUM(534773760)&xfun))&&(ZERO_P(MAKINUM(8)&CAR(ylitcurinf))&&((!(NFALSEP(GLOBAL(para_pos_unit_strategy_global)))||(NFALSEP(unit_cl_pred_(ycl))&&(NFALSEP(unit_cl_pred_(xcl))&&!(!(ZERO_P(MAKINUM(268435456)&yfun))))))&&((ZERO_P(MAKINUM(16)&CAR(CAR(xlitinfpart)))||ZERO_P(MAKINUM(32)&CAR(CAR(xlitinfpart))))&&!(NFALSEP(GLOBAL(foundflag_global))))))))
            paramodulate_into_ycl(ylit,xlit,ycl,xcl,ylitinf,xlitinf,CAR(xlitinfpart),give_cl_maxvar(xinf),yclmaxvar,CAR(CDR(CDR(CDR(CDR(CDR(yinf)))))),CAR(CDR(CDR(CDR(CDR(CDR(xinf)))))),ylitnr,xlitnr);
          if(compl_yfunpure==(MAKINUM(534773760)&xfun)) {
            if(NFALSEP(resolve_unify_ordinary(xfun,yfun,xlit,ylit))&&!(NFALSEP(GLOBAL(foundflag_global)))) {
              GLOBAL(used_demodulators_global)=EOL;
              unused=UNSPECIFIED;
              ytmp=make_rest_inf_cl(ycl,ylit,CAR(CDR(CDR(yinf))));
              xtmp=make_rest_inf_cl(xcl,xlit,CAR(CDR(CDR(xinf))));
              res=make_raw_inf_cl_pair(CDR(xtmp),CDR(ytmp),CAR(xtmp),CAR(ytmp));
              if(NFALSEP(GLOBAL(classical_synth_stratflag_global))&&(NFALSEP(res)&&NFALSEP(several_answer_literals_pred_(CDR(res))))) {
                if(NFALSEP(xvars_set_flag_global)&&ZERO_P(MAKINUM(65536)&CAR(xlit)))
                  condlit=subst_deco_term_nodemodulate(xlit,BOOL_T);
                else
                  condlit=xlit;
                ans_inf=cons(condlit,cons(MAKINUM(1),cons(give_cl_maxvar(xinf),cons(yclmaxvar,EOL))));
              }
              if(NFALSEP(GLOBAL(hyper_strategy_flag_global))) {
                history=make_hyper_history(xcl,ycl,CAR(CDR(CDR(CDR(CDR(CDR(xinf)))))),CAR(CDR(CDR(CDR(CDR(CDR(yinf)))))),CAR(xlitinfpart),ylitcurinf,xlitnr,ylitnr);
              }
              else {
                if(NULL_P(GLOBAL(used_demodulators_global)))
                  history=cons(binres_symb,cons(MAKINUM(0),cons(cons(literal_symb,cons(CAR(CDR(CDR(CDR(CDR(CDR(xinf)))))),cons(xlitnr,EOL))),cons(cons(literal_symb,cons(CAR(CDR(CDR(CDR(CDR(CDR(yinf)))))),cons(ylitnr,EOL))),EOL))));
                else
                  history=cons(binres_symb,cons(MAKINUM(0),cons(cons(literal_symb,cons(CAR(CDR(CDR(CDR(CDR(CDR(xinf)))))),cons(xlitnr,EOL))),cons(cons(literal_symb,cons(CAR(CDR(CDR(CDR(CDR(CDR(yinf)))))),cons(ylitnr,EOL))),cons(cons(demod_symb,GLOBAL(used_demodulators_global)),EOL)))));
              }
              if(GLOBAL(display_info_level_global)>=MAKINUM(70)) {
                newline(cur_output_port());
                display(const_22,cur_output_port());
                newline(cur_output_port());
                print_pure_clause(xcl);
                newline(cur_output_port());
                print_pure_clause(ycl);
                newline(cur_output_port());
                print_pure_clause(CDR(res));
                newline(cur_output_port());
              }
              clear_y_vars_and_touched_excl_(yclmaxvar);
              clear_x_vars_and_touched_excl_(give_cl_maxvar(xinf));
              res=handle_derived_inf_cl_pair(res,history,BOOL_F,ans_inf);
              ans_inf=BOOL_F;
              if(NFALSEP(res)&&(NFALSEP(GLOBAL(factors_stratflag_global))&&!(NFALSEP(GLOBAL(foundflag_global)))))
                factor(CAR(res),CDR(res));
            }
            else {
              if(NFALSEP(yvars_set_flag_global))
                clear_y_vars_excl_(yclmaxvar);
              if(NFALSEP(xvars_set_flag_global))
                clear_x_vars_excl_(give_cl_maxvar(xinf));
            }
          }
        }
      }
    }
  }
  return UNSPECIFIED;
}

SCM final_nuc_res(xcl,ycl,yneglit,xinf,yinf,ylitinf,yclmaxvar,given_final_nuc_complfunpure)
SCM xcl,ycl,yneglit,xinf,yinf,ylitinf,yclmaxvar,given_final_nuc_complfunpure;
{
  SCM xpart,xlitinfpart,xlitnr;

  for(xpart=xcl,xlitinfpart=CAR(CDR(CDR(xinf))),xlitnr=MAKINUM(1);
      !(NULL_P(xpart)||NFALSEP(GLOBAL(foundflag_global)));
      xpart=CDR(xpart),xlitinfpart=CDR(xlitinfpart),xlitnr=MAKINUM(1+INUM(xlitnr)))
    if((given_final_nuc_complfunpure==(MAKINUM(534773760)&CAR(CAR(xpart))))&&!(litinf_nobinrespara_mask_global==(litinf_nobinrespara_mask_global&CAR(CAR(xlitinfpart)))))
      unit_and_final_nuc_res(xcl,ycl,CAR(xpart),yneglit,xinf,yinf,ylitinf,yclmaxvar,xlitnr,CAR(xlitinfpart));
  return UNSPECIFIED;
}

SCM unit_and_final_nuc_res(xcl,ycl,xlit,yneglit,xinf,yinf,ylitinf,yclmaxvar,xlitnr,xcurinf)
SCM xcl,ycl,xlit,yneglit,xinf,yinf,ylitinf,yclmaxvar,xlitnr,xcurinf;
{
  SCM ypart,ylitinfpart,ylitnr,unused,ytmp,xtmp,res,history,ycurnr,ycurinf;

  if(NFALSEP(resolve_unify_ordinary(CAR(xlit),CAR(yneglit),xlit,yneglit))) {
    GLOBAL(used_demodulators_global)=EOL;
    unused=UNSPECIFIED;
    ytmp=make_rest_inf_cl(ycl,yneglit,CAR(CDR(CDR(yinf))));
    xtmp=make_rest_inf_cl(xcl,xlit,CAR(CDR(CDR(xinf))));
    res=make_raw_inf_cl_pair(CDR(xtmp),CDR(ytmp),CAR(xtmp),CAR(ytmp));
    history=EOL;
    ycurnr=MAKINUM(0);
    ycurinf=EOL;
    for(ypart=ycl,ylitinfpart=ylitinf,ylitnr=MAKINUM(1);
        !(CAR(ypart)==yneglit);
        ypart=CDR(ypart),ylitinfpart=CDR(ylitinfpart),ylitnr=MAKINUM(1+INUM(ylitnr))) ;
    ycurnr=ylitnr;
    ycurinf=CAR(ylitinfpart);
    history=make_hyper_history(xcl,ycl,CAR(CDR(CDR(CDR(CDR(CDR(xinf)))))),CAR(CDR(CDR(CDR(CDR(CDR(yinf)))))),xcurinf,ycurinf,xlitnr,ycurnr);
    if(GLOBAL(display_info_level_global)>=MAKINUM(70)) {
      newline(cur_output_port());
      display(const_23,cur_output_port());
      newline(cur_output_port());
      print_pure_clause(xcl);
      newline(cur_output_port());
      print_pure_clause(ycl);
      newline(cur_output_port());
      print_pure_clause(CDR(res));
      newline(cur_output_port());
    }
    clear_y_vars_and_touched_excl_(yclmaxvar);
    clear_x_vars_and_touched_excl_(give_cl_maxvar(xinf));
    res=handle_derived_inf_cl_pair(res,history,BOOL_F,BOOL_F);
    if(NFALSEP(res)&&(NFALSEP(GLOBAL(factors_stratflag_global))&&!(NFALSEP(GLOBAL(foundflag_global)))))
      return factor(CAR(res),CDR(res));
    else
      return UNSPECIFIED;
  }
  else {
    if(NFALSEP(yvars_set_flag_global))
      clear_y_vars_excl_(yclmaxvar);
    if(NFALSEP(xvars_set_flag_global))
      return clear_x_vars_excl_(give_cl_maxvar(xinf));
    else
      return UNSPECIFIED;
  }
}

SCM two_posunits_typet_para(xcl,ycl,xinf,yinf,ylitinf,yclmaxvar)
SCM xcl,ycl,xinf,yinf,ylitinf,yclmaxvar;
{
  SCM xlitinf,history,ylitnr,ylit,ylitcurinf,xlitnr,xlit,xlitcurinf;

  xlitinf=CAR(CDR(CDR(xinf)));
  history=EOL;
  ylitnr=MAKINUM(1);
  ylit=CAR(ycl);
  ylitcurinf=CAR(ylitinf);
  xlitnr=MAKINUM(1);
  xlit=CAR(xcl);
  xlitcurinf=CAR(xlitinf);
  if(!(NUMBER_P(CAR(CDR(ylit))))&&((GLOBAL(eq_fun_nr_global)==(MAKINUM(534773760)&CAR(CAR(CDR(ylit)))))&&(ZERO_P(MAKINUM(8)&CAR(xlitcurinf))&&(ZERO_P(MAKINUM(16)&CAR(ylitcurinf))||ZERO_P(MAKINUM(32)&CAR(ylitcurinf)))))) {
    GLOBAL(param_tolit_global)=xlit;
    GLOBAL(param_eqlit_global)=ylit;
    GLOBAL(param_tocl_global)=xcl;
    GLOBAL(param_fromcl_global)=ycl;
    GLOBAL(param_left_arg_global)=CAR(CDR(CAR(CDR(ylit))));
    GLOBAL(param_right_arg_global)=CAR(CDR(CDR(CAR(CDR(ylit)))));
    GLOBAL(param_toinf_global)=xlitinf;
    GLOBAL(param_frominf_global)=ylitinf;
    GLOBAL(param_from_is_y_flag_global)=BOOL_T;
    GLOBAL(param_yclmaxvar_global)=yclmaxvar;
    GLOBAL(param_xclmaxvar_global)=give_cl_maxvar(xinf);
    GLOBAL(param_fromhist_global)=CAR(CDR(CDR(CDR(CDR(CDR(yinf))))));
    GLOBAL(param_tohist_global)=CAR(CDR(CDR(CDR(CDR(CDR(xinf))))));
    GLOBAL(param_fromlitnr_global)=ylitnr;
    GLOBAL(param_tolitnr_global)=xlitnr;
    param_use_left_flag_global=SBOOL(ZERO_P(MAKINUM(16)&CAR(ylitcurinf)));
    param_use_right_flag_global=SBOOL(ZERO_P(MAKINUM(32)&CAR(ylitcurinf)));
    paramodulate_into_term(xlit,EOL,BOOL_T);
  }
  if(!(NUMBER_P(CAR(CDR(xlit))))&&((GLOBAL(eq_fun_nr_global)==(MAKINUM(534773760)&CAR(CAR(CDR(xlit)))))&&(ZERO_P(MAKINUM(8)&CAR(ylitcurinf))&&(ZERO_P(MAKINUM(16)&CAR(xlitcurinf))||ZERO_P(MAKINUM(32)&CAR(xlitcurinf)))))) {
    GLOBAL(param_tolit_global)=ylit;
    GLOBAL(param_eqlit_global)=xlit;
    GLOBAL(param_tocl_global)=ycl;
    GLOBAL(param_fromcl_global)=xcl;
    GLOBAL(param_left_arg_global)=CAR(CDR(CAR(CDR(xlit))));
    GLOBAL(param_right_arg_global)=CAR(CDR(CDR(CAR(CDR(xlit)))));
    GLOBAL(param_toinf_global)=ylitinf;
    GLOBAL(param_frominf_global)=xlitinf;
    GLOBAL(param_from_is_y_flag_global)=BOOL_F;
    GLOBAL(param_yclmaxvar_global)=yclmaxvar;
    GLOBAL(param_xclmaxvar_global)=give_cl_maxvar(xinf);
    GLOBAL(param_fromhist_global)=CAR(CDR(CDR(CDR(CDR(CDR(xinf))))));
    GLOBAL(param_tohist_global)=CAR(CDR(CDR(CDR(CDR(CDR(yinf))))));
    GLOBAL(param_fromlitnr_global)=xlitnr;
    GLOBAL(param_tolitnr_global)=ylitnr;
    param_use_left_flag_global=SBOOL(ZERO_P(MAKINUM(16)&CAR(xlitcurinf)));
    param_use_right_flag_global=SBOOL(ZERO_P(MAKINUM(32)&CAR(xlitcurinf)));
    return paramodulate_into_term(ylit,EOL,BOOL_T);
  }
  else
    return UNSPECIFIED;
}

SCM one_step_for_hyper(fullycl)
SCM fullycl;
{
  SCM unused,ytmp,xtmp,res__1,history,xclpart,xlitinfpart,xlitnr,usable_list_part,ypart,ylitinfpart,ylitnr,min_nr,results,locresults,ylit,negfun,ycl,yinf,fullxcl,xcl,xinf,ylitinf,yclmaxvar,yfun,ynegpurefun,res,tmp,success_nr;

  GLOBAL(one_step_hyper_phase_global)=BOOL_T;
  min_nr=MAKINUM(999999);
  results=EOL;
  locresults=EOL;
  ylit=EOL;
  negfun=EOL;
  ycl=CDR(fullycl);
  yinf=CAR(fullycl);
  fullxcl=EOL;
  xcl=EOL;
  xinf=EOL;
  ylitinf=CAR(CDR(CDR(yinf)));
  yclmaxvar=give_cl_maxvar(yinf);
  yfun=EOL;
  ynegpurefun=EOL;
  res=EOL;
  tmp=EOL;
  success_nr=MAKINUM(0);
  yvars_set_flag_global=BOOL_F;
  xvars_set_flag_global=BOOL_F;
  for(ypart=ycl,ylitinfpart=CAR(CDR(CDR(yinf))),ylitnr=MAKINUM(1);
      !(NULL_P(ypart)||(NFALSEP(GLOBAL(foundflag_global))||ZERO_P(min_nr)));
      ypart=CDR(ypart),ylitinfpart=CDR(ylitinfpart),ylitnr=MAKINUM(1+INUM(ylitnr)))
    if(NFALSEP(GLOBAL(unit_clash_flag_global))||!(ZERO_P(MAKINUM(268435456)&CAR(CAR(ypart))))) {
      success_nr=MAKINUM(0);
      ylit=CAR(ypart);
      yfun=CAR(ylit);
      ynegpurefun=MAKINUM(268435456^INUM(MAKINUM(534773760)&yfun));
      for(usable_list_part=(NFALSEP(GLOBAL(unit_clash_flag_global)) ? (tmp=assq(ynegpurefun,GLOBAL(unit_alist_global)),UNSPECIFIED,(NFALSEP(tmp) ? CDR(tmp) : EOL)) : CDR(GLOBAL(usable_clauses_list_global)));!(NULL_P(usable_list_part)||(NFALSEP(GLOBAL(foundflag_global))||(success_nr>=min_nr)));usable_list_part=CDR(usable_list_part)) {
        fullxcl=CAR(usable_list_part);
        xinf=CAR(fullxcl);
        xcl=CDR(fullxcl);
        if(!(ZERO_P(MAKINUM(63488)&CAR(xinf)))&&(NFALSEP(GLOBAL(unit_clash_flag_global))||NFALSEP(positive_cl_pred_(xcl)))) {
          for(xclpart=xcl,xlitinfpart=CAR(CDR(CDR(xinf))),xlitnr=MAKINUM(1);
              !(NULL_P(xclpart)||NFALSEP(GLOBAL(foundflag_global)));
              xclpart=CDR(xclpart),xlitinfpart=CDR(xlitinfpart),xlitnr=MAKINUM(1+INUM(xlitnr)))
            if(((MAKINUM(534773760)&CAR(CAR(xclpart)))==ynegpurefun)&&(!(litinf_nobinrespara_mask_global==(litinf_nobinrespara_mask_global&CAR(CAR(xlitinfpart))))&&NFALSEP(resolve_unify_ordinary(CAR(CAR(xclpart)),yfun,CAR(xclpart),ylit)))) {
              GLOBAL(used_demodulators_global)=EOL;
              unused=UNSPECIFIED;
              ytmp=make_rest_inf_cl(ycl,ylit,CAR(CDR(CDR(yinf))));
              xtmp=make_rest_inf_cl(xcl,CAR(xclpart),CAR(CDR(CDR(xinf))));
              res__1=make_raw_inf_cl_pair(CDR(xtmp),CDR(ytmp),CAR(xtmp),CAR(ytmp));
              history=EOL;
              if(NFALSEP(GLOBAL(unit_clash_flag_global))) {
                if(NULL_P(GLOBAL(used_demodulators_global)))
                  history=cons(binres_symb,cons(MAKINUM(0),cons(cons(literal_symb,cons(CAR(CDR(CDR(CDR(CDR(CDR(xinf)))))),cons(xlitnr,EOL))),cons(cons(literal_symb,cons(CAR(CDR(CDR(CDR(CDR(CDR(yinf)))))),cons(ylitnr,EOL))),EOL))));
                else
                  history=cons(binres_symb,cons(MAKINUM(0),cons(cons(literal_symb,cons(CAR(CDR(CDR(CDR(CDR(CDR(xinf)))))),cons(xlitnr,EOL))),cons(cons(literal_symb,cons(CAR(CDR(CDR(CDR(CDR(CDR(yinf)))))),cons(ylitnr,EOL))),cons(cons(demod_symb,GLOBAL(used_demodulators_global)),EOL)))));
              }
              else
                history=make_hyper_history(xcl,ycl,CAR(CDR(CDR(CDR(CDR(CDR(xinf)))))),CAR(CDR(CDR(CDR(CDR(CDR(yinf)))))),CAR(xlitinfpart),CAR(ylitinfpart),xlitnr,ylitnr);
              if(GLOBAL(display_info_level_global)>=MAKINUM(110)) {
                newline(cur_output_port());
                display(const_24,cur_output_port());
                newline(cur_output_port());
                debug_print_yvars(yclmaxvar);
                debug_print_xvars(give_cl_maxvar(xinf));
                newline(cur_output_port());
                display(const_25,cur_output_port());
                newline(cur_output_port());
                print_pure_clause(xcl);
                newline(cur_output_port());
                print_pure_clause(ycl);
                newline(cur_output_port());
                print_pure_clause(CDR(res__1));
                newline(cur_output_port());
              }
              clear_y_vars_and_touched_excl_(yclmaxvar);
              clear_x_vars_and_touched_excl_(give_cl_maxvar(xinf));
              res__1=handle_derived_inf_cl_pair(res__1,history,BOOL_F,BOOL_F);
              if(NFALSEP(res__1)) {
                success_nr=MAKINUM(1+INUM(success_nr));
                locresults=cons(res__1,locresults);
              }
            }
            else {
              if(NFALSEP(yvars_set_flag_global))
                clear_y_vars_excl_(yclmaxvar);
              if(NFALSEP(xvars_set_flag_global))
                clear_x_vars_excl_(give_cl_maxvar(xinf));
            }
        }
      }
      if(success_nr<min_nr) {
        min_nr=success_nr;
        results=locresults;
      }
    }
  GLOBAL(one_step_hyper_phase_global)=BOOL_F;
  return results;
}

SCM make_hyper_history(xcl,ycl,xhist,yhist,xlitcurinf,ylitcurinf,xlitnr,ylitnr)
SCM xcl,ycl,xhist,yhist,xlitcurinf,ylitcurinf,xlitnr,ylitnr;
{
  SCM x,tmp;

  x=EOL;
  tmp=make_hyper_history_aux(xcl,ycl,xhist,yhist,xlitcurinf,ylitcurinf,xlitnr,ylitnr);
  if(!(NULL_P(GLOBAL(used_demodulators_global)))) {
    x=apply(GLOBAL(last_pair),tmp,listofnull);
    SET_CDR(x,cons(cons(demod_symb,GLOBAL(used_demodulators_global)),EOL));
    return tmp;
  }
  else
    return tmp;
}

SCM make_hyper_history_aux(xcl,ycl,xhist,yhist,xlitcurinf,ylitcurinf,xlitnr,ylitnr)
SCM xcl,ycl,xhist,yhist,xlitcurinf,ylitcurinf,xlitnr,ylitnr;
{
  if(NFALSEP(positive_cl_pred_(xcl))) {
    if(ZERO_P(MAKINUM(INUM(GLOBAL(litinf_ordernr_mask_global)&CAR(ylitcurinf))>>16))) {
      if(NFALSEP(fresh_nucleus_hist_pred_(yhist)))
        return cons(hyper_symb,cons(MAKINUM(0),cons(yhist,cons(cons(literal_symb,cons(xhist,cons(xlitnr,EOL))),EOL))));
      else {
        SET_CDR(CDR(CDR(yhist)),cons(cons(literal_symb,cons(xhist,cons(xlitnr,EOL))),CDR(CDR(CDR(yhist)))));
        return yhist;
      }
    }
    else
      return replace_nth((NFALSEP(fresh_nucleus_hist_pred_(yhist)) ? cons(hyper_symb,cons(MAKINUM(0),cons(yhist,make_null_neg_list(ycl)))) : yhist),MAKINUM(3+(INUM(GLOBAL(litinf_ordernr_mask_global)&CAR(ylitcurinf))>>16)),cons(literal_symb,cons(xhist,cons(xlitnr,EOL))));
  }
  else {
    if(ZERO_P(MAKINUM(INUM(GLOBAL(litinf_ordernr_mask_global)&CAR(xlitcurinf))>>16))) {
      if(NFALSEP(fresh_nucleus_hist_pred_(xhist)))
        return cons(hyper_symb,cons(MAKINUM(0),cons(xhist,cons(cons(literal_symb,cons(yhist,cons(ylitnr,EOL))),EOL))));
      else {
        SET_CDR(CDR(CDR(xhist)),cons(cons(literal_symb,cons(yhist,cons(ylitnr,EOL))),CDR(CDR(CDR(xhist)))));
        return yhist;
      }
    }
    else
      return replace_nth((NFALSEP(fresh_nucleus_hist_pred_(xhist)) ? cons(hyper_symb,cons(MAKINUM(0),cons(xhist,make_null_neg_list(xcl)))) : xhist),MAKINUM(3+(INUM(GLOBAL(litinf_ordernr_mask_global)&CAR(xlitcurinf))>>16)),cons(literal_symb,cons(yhist,cons(ylitnr,EOL))));
  }
}

SCM make_binres_history(xcl,ycl,xhist,yhist,xlitnr,ylitnr)
SCM xcl,ycl,xhist,yhist,xlitnr,ylitnr;
{
  if(NULL_P(GLOBAL(used_demodulators_global)))
    return cons(binres_symb,cons(MAKINUM(0),cons(cons(literal_symb,cons(xhist,cons(xlitnr,EOL))),cons(cons(literal_symb,cons(yhist,cons(ylitnr,EOL))),EOL))));
  else
    return cons(binres_symb,cons(MAKINUM(0),cons(cons(literal_symb,cons(xhist,cons(xlitnr,EOL))),cons(cons(literal_symb,cons(yhist,cons(ylitnr,EOL))),cons(cons(demod_symb,GLOBAL(used_demodulators_global)),EOL)))));
}

SCM fresh_nucleus_hist_pred_(hist)
SCM hist;
{
  if(PAIR_P(hist))
    return SBOOL(input_symb==CAR(hist));
  else
    return BOOL_F;
}

SCM make_null_neg_list(nuc)
SCM nuc;
{
  SCM nucpart,res;

  res=EOL;
  for(nucpart=nuc;!(NULL_P(nucpart));nucpart=CDR(nucpart))
    if(!(ZERO_P(MAKINUM(268435456)&CAR(CAR(nucpart))))) {
      res=cons(EOL,res);
    }
  return res;
}

SCM paramodulate_into_ycl(tolit,eqlit,tocl,fromcl,toinf,frominf,curfrominf,xclmaxvar,yclmaxvar,yhist,xhist,ylitnr,xlitnr)
SCM tolit,eqlit,tocl,fromcl,toinf,frominf,curfrominf,xclmaxvar,yclmaxvar,yhist,xhist,ylitnr,xlitnr;
{
  SCM tmp_tolit,tmp_eqlit,tmp_tocl,tmp_fromcl,tmp_left_arg,tmp_right_arg,tmp_use_left_flag,tmp_use_right_flag,tmp_toinf,tmp_frominf,tmp_from_is_y_flag,tmp_fromhist,tmp_tohist,tmp_fromlitnr,tmp_tolitnr;

  tmp_tolit=GLOBAL(param_tolit_global);
  tmp_eqlit=GLOBAL(param_eqlit_global);
  tmp_tocl=GLOBAL(param_tocl_global);
  tmp_fromcl=GLOBAL(param_fromcl_global);
  tmp_left_arg=GLOBAL(param_left_arg_global);
  tmp_right_arg=GLOBAL(param_right_arg_global);
  tmp_use_left_flag=param_use_left_flag_global;
  tmp_use_right_flag=param_use_right_flag_global;
  tmp_toinf=GLOBAL(param_toinf_global);
  tmp_frominf=GLOBAL(param_frominf_global);
  tmp_from_is_y_flag=GLOBAL(param_from_is_y_flag_global);
  tmp_fromhist=GLOBAL(param_fromhist_global);
  tmp_tohist=GLOBAL(param_tohist_global);
  tmp_fromlitnr=GLOBAL(param_fromlitnr_global);
  tmp_tolitnr=GLOBAL(param_tolitnr_global);
  GLOBAL(used_demodulators_global)=EOL;
  GLOBAL(param_tolit_global)=tolit;
  GLOBAL(param_eqlit_global)=eqlit;
  GLOBAL(param_tocl_global)=tocl;
  GLOBAL(param_fromcl_global)=fromcl;
  GLOBAL(param_left_arg_global)=CAR(CDR(eqlit));
  GLOBAL(param_right_arg_global)=CAR(CDR(CDR(eqlit)));
  param_use_left_flag_global=SBOOL(ZERO_P(MAKINUM(16)&CAR(curfrominf)));
  param_use_right_flag_global=SBOOL(ZERO_P(MAKINUM(32)&CAR(curfrominf)));
  GLOBAL(param_toinf_global)=toinf;
  GLOBAL(param_frominf_global)=frominf;
  GLOBAL(param_xclmaxvar_global)=xclmaxvar;
  GLOBAL(param_yclmaxvar_global)=yclmaxvar;
  GLOBAL(param_from_is_y_flag_global)=BOOL_F;
  GLOBAL(param_fromhist_global)=xhist;
  GLOBAL(param_tohist_global)=yhist;
  GLOBAL(param_fromlitnr_global)=xlitnr;
  GLOBAL(param_tolitnr_global)=ylitnr;
  paramodulate_into_term(tolit,EOL,BOOL_T);
  GLOBAL(param_tolit_global)=tmp_tolit;
  GLOBAL(param_eqlit_global)=tmp_eqlit;
  GLOBAL(param_tocl_global)=tmp_tocl;
  GLOBAL(param_fromcl_global)=tmp_fromcl;
  GLOBAL(param_left_arg_global)=tmp_left_arg;
  GLOBAL(param_right_arg_global)=tmp_right_arg;
  param_use_left_flag_global=tmp_use_left_flag;
  param_use_right_flag_global=tmp_use_right_flag;
  GLOBAL(param_toinf_global)=tmp_toinf;
  GLOBAL(param_frominf_global)=tmp_frominf;
  GLOBAL(param_from_is_y_flag_global)=tmp_from_is_y_flag;
  GLOBAL(param_fromhist_global)=tmp_fromhist;
  GLOBAL(param_tohist_global)=tmp_tohist;
  GLOBAL(param_fromlitnr_global)=tmp_fromlitnr;
  GLOBAL(param_tolitnr_global)=tmp_tolitnr;
  return UNSPECIFIED;
}

SCM paramodulate_into_term(term,path,litflag)
SCM term,path,litflag;
{
  SCM termpart,nr,new_var2;

  if(!(NUMBER_P(term))) {
    if(NFALSEP(param_use_left_flag_global)) {
      new_var2=litflag;
      if(NFALSEP(new_var2)) ;
      else
      if(!(NUMBER_P(GLOBAL(param_left_arg_global)))) {
        if((MAKINUM(534773760)&CAR(term))==(MAKINUM(534773760)&CAR(GLOBAL(param_left_arg_global)))) {
          GLOBAL(compare_ground_litcdr_equal_flag_global)=BOOL_T;
          if(NFALSEP((NFALSEP(GLOBAL(param_from_is_y_flag_global)) ? resolve_unify_ordinary(CAR(term),CAR(GLOBAL(param_left_arg_global)),term,GLOBAL(param_left_arg_global)) : resolve_unify_ordinary(CAR(GLOBAL(param_left_arg_global)),CAR(term),GLOBAL(param_left_arg_global),term))))
            paramodulate_into_term_aux(path,GLOBAL(param_right_arg_global),BOOL_T);
          else {
            GLOBAL(compare_ground_litcdr_equal_flag_global)=BOOL_F;
            if(NFALSEP(yvars_set_flag_global))
              clear_y_vars_and_touched_excl_(GLOBAL(param_yclmaxvar_global));
            if(NFALSEP(xvars_set_flag_global))
              clear_x_vars_and_touched_excl_(GLOBAL(param_xclmaxvar_global));
          }
        }
      }
      else
      if(NFALSEP(GLOBAL(paramodulate_from_vars_stratflag_global))&&(MAKINUM(65535)>GLOBAL(param_left_arg_global))) {
        STBL_VECTOR_SET(_star_var_val_table_star__velts0,MAKINUM(8191)&GLOBAL(param_left_arg_global),term);
        if(ZERO_P(MAKINUM(256)&GLOBAL(param_left_arg_global))) {
          xvars_set_flag_global=BOOL_T;
          yvars_set_flag_global=BOOL_F;
        }
        else {
          xvars_set_flag_global=BOOL_F;
          yvars_set_flag_global=BOOL_T;
        }
        paramodulate_into_term_aux(path,GLOBAL(param_right_arg_global),BOOL_T);
      }
    }
    if(NFALSEP(param_use_right_flag_global)) {
      new_var2=litflag;
      if(NFALSEP(new_var2)) ;
      else {
        new_var2=GLOBAL(foundflag_global);
        if(NFALSEP(new_var2)) ;
        else
        if(!(NUMBER_P(GLOBAL(param_right_arg_global)))) {
          if((MAKINUM(534773760)&CAR(term))==(MAKINUM(534773760)&CAR(GLOBAL(param_right_arg_global)))) {
            GLOBAL(compare_ground_litcdr_equal_flag_global)=BOOL_T;
            if(NFALSEP((NFALSEP(GLOBAL(param_from_is_y_flag_global)) ? resolve_unify_ordinary(CAR(term),CAR(GLOBAL(param_right_arg_global)),term,GLOBAL(param_right_arg_global)) : resolve_unify_ordinary(CAR(GLOBAL(param_right_arg_global)),CAR(term),GLOBAL(param_right_arg_global),term))))
              paramodulate_into_term_aux(path,GLOBAL(param_left_arg_global),BOOL_F);
            else {
              GLOBAL(compare_ground_litcdr_equal_flag_global)=BOOL_F;
              if(NFALSEP(yvars_set_flag_global))
                clear_y_vars_and_touched_excl_(GLOBAL(param_yclmaxvar_global));
              if(NFALSEP(xvars_set_flag_global))
                clear_x_vars_and_touched_excl_(GLOBAL(param_xclmaxvar_global));
            }
          }
        }
        else
        if(NFALSEP(GLOBAL(paramodulate_from_vars_stratflag_global))&&(MAKINUM(65535)>GLOBAL(param_right_arg_global))) {
          STBL_VECTOR_SET(_star_var_val_table_star__velts0,MAKINUM(8191)&GLOBAL(param_right_arg_global),term);
          if(ZERO_P(MAKINUM(256)&GLOBAL(param_right_arg_global))) {
            xvars_set_flag_global=BOOL_T;
            yvars_set_flag_global=BOOL_F;
          }
          else {
            xvars_set_flag_global=BOOL_F;
            yvars_set_flag_global=BOOL_T;
          }
          paramodulate_into_term_aux(path,GLOBAL(param_left_arg_global),BOOL_F);
        }
      }
    }
    if(!(NFALSEP(GLOBAL(foundflag_global)))) {
      for(termpart=CDR(term),nr=MAKINUM(1);
          !(NULL_P(termpart));
          termpart=CDR(termpart),nr=MAKINUM(1+INUM(nr)))
        paramodulate_into_term(CAR(termpart),cons(nr,path),BOOL_F);
      return UNSPECIFIED;
    }
    else
      return UNSPECIFIED;
  }
  else {
    new_var2=SBOOL(MAKINUM(65535)>term);
    if(NFALSEP(new_var2))
      return new_var2;
    else {
      if(NFALSEP(param_use_left_flag_global)) {
        if(NFALSEP(GLOBAL(paramodulate_from_vars_stratflag_global))&&(NUMBER_P(GLOBAL(param_left_arg_global))&&(GLOBAL(param_left_arg_global)<=MAKINUM(65535)))) {
          STBL_VECTOR_SET(_star_var_val_table_star__velts0,MAKINUM(8191)&GLOBAL(param_left_arg_global),term);
          if(ZERO_P(MAKINUM(256)&GLOBAL(param_left_arg_global))) {
            xvars_set_flag_global=BOOL_T;
            yvars_set_flag_global=BOOL_F;
          }
          else {
            xvars_set_flag_global=BOOL_F;
            yvars_set_flag_global=BOOL_T;
          }
          paramodulate_into_term_aux(path,GLOBAL(param_right_arg_global),BOOL_T);
        }
        else
        if(GLOBAL(param_left_arg_global)==term) {
          xvars_set_flag_global=BOOL_F;
          yvars_set_flag_global=BOOL_F;
          paramodulate_into_term_aux(path,GLOBAL(param_right_arg_global),BOOL_T);
        }
      }
      if(NFALSEP(param_use_right_flag_global)) {
        new_var2=GLOBAL(foundflag_global);
        if(NFALSEP(new_var2))
          return new_var2;
        else
        if(NFALSEP(GLOBAL(paramodulate_from_vars_stratflag_global))&&(NUMBER_P(GLOBAL(param_right_arg_global))&&(GLOBAL(param_right_arg_global)<=MAKINUM(65535)))) {
          STBL_VECTOR_SET(_star_var_val_table_star__velts0,MAKINUM(8191)&GLOBAL(param_right_arg_global),term);
          if(ZERO_P(MAKINUM(256)&GLOBAL(param_right_arg_global))) {
            xvars_set_flag_global=BOOL_T;
            yvars_set_flag_global=BOOL_F;
          }
          else {
            xvars_set_flag_global=BOOL_F;
            yvars_set_flag_global=BOOL_T;
          }
          return paramodulate_into_term_aux(path,GLOBAL(param_left_arg_global),BOOL_F);
        }
        else
        if(GLOBAL(param_right_arg_global)==term) {
          xvars_set_flag_global=BOOL_F;
          yvars_set_flag_global=BOOL_F;
          return paramodulate_into_term_aux(path,GLOBAL(param_left_arg_global),BOOL_F);
        }
        else
          return UNSPECIFIED;
      }
      else
        return UNSPECIFIED;
    }
  }
}

SCM paramodulate_into_term_aux(path,replterm,left_used_flag)
SCM path,replterm,left_used_flag;
{
  SCM condlit,newlit,tmpto,tmpfrom,res,history,ans_inf;

  GLOBAL(compare_ground_litcdr_equal_flag_global)=BOOL_F;
  GLOBAL(used_demodulators_global)=EOL;
  newlit=subst_deco_replace_term(GLOBAL(param_tolit_global),reverse(path),replterm,BOOL_T);
  tmpto=make_rest_inf_cl(GLOBAL(param_tocl_global),GLOBAL(param_tolit_global),GLOBAL(param_toinf_global));
  tmpfrom=make_rest_inf_cl(GLOBAL(param_fromcl_global),GLOBAL(param_eqlit_global),GLOBAL(param_frominf_global));
  res=EOL;
  history=EOL;
  ans_inf=BOOL_F;
  if(!(NFALSEP(newlit)))
    return BOOL_F;
  else {
    if(NFALSEP(GLOBAL(param_from_is_y_flag_global))) {
      res=make_raw_inf_cl_pair(CDR(tmpto),CDR(tmpfrom),CAR(tmpto),CAR(tmpfrom));
    }
    else {
      res=make_raw_inf_cl_pair(CDR(tmpfrom),CDR(tmpto),CAR(tmpfrom),CAR(tmpto));
    }
    if(NFALSEP(GLOBAL(classical_synth_stratflag_global))&&(NFALSEP(res)&&NFALSEP(several_answer_literals_pred_(CDR(res))))) {
      if((NFALSEP(GLOBAL(param_from_is_y_flag_global))&&(NFALSEP(xvars_set_flag_global)&&ZERO_P(MAKINUM(65536)&CAR(GLOBAL(param_tolit_global)))))||(!(NFALSEP(GLOBAL(param_from_is_y_flag_global)))&&(NFALSEP(yvars_set_flag_global)&&ZERO_P(MAKINUM(65536)&CAR(GLOBAL(param_tolit_global))))))
        condlit=subst_deco_term_nodemodulate(GLOBAL(param_tolit_global),BOOL_T);
      else
        condlit=GLOBAL(param_tolit_global);
      if(NFALSEP(GLOBAL(param_from_is_y_flag_global))) {
        ans_inf=cons(condlit,cons(MAKINUM(1),cons(GLOBAL(param_xclmaxvar_global),cons(GLOBAL(param_yclmaxvar_global),EOL))));
      }
      else {
        ans_inf=cons(condlit,cons(MAKINUM(1),cons(GLOBAL(param_xclmaxvar_global),cons(GLOBAL(param_yclmaxvar_global),EOL))));
      }
    }
    clear_y_vars_and_touched_excl_(GLOBAL(param_yclmaxvar_global));
    clear_x_vars_and_touched_excl_(GLOBAL(param_xclmaxvar_global));
    if(!(NFALSEP(res)))
      return BOOL_F;
    else {
      res=cons(cons(cons(BOOL_T,cons(BOOL_F,cons(MAKINUM(0),EOL))),CAR(res)),cons(newlit,CDR(res)));
      if(NULL_P(GLOBAL(used_demodulators_global))) {
        history=cons(para_symb,cons(MAKINUM(0),cons(GLOBAL(param_fromhist_global),cons(GLOBAL(param_tohist_global),cons(GLOBAL(param_fromlitnr_global),cons(GLOBAL(param_tolitnr_global),cons(left_used_flag,cons(reverse(path),EOL))))))));
      }
      else {
        history=cons(para_symb,cons(MAKINUM(0),cons(GLOBAL(param_fromhist_global),cons(GLOBAL(param_tohist_global),cons(GLOBAL(param_fromlitnr_global),cons(GLOBAL(param_tolitnr_global),cons(left_used_flag,cons(reverse(path),cons(cons(demod_symb,GLOBAL(used_demodulators_global)),EOL)))))))));
      }
      if(GLOBAL(display_info_level_global)>=MAKINUM(70)) {
        display(const_26,cur_output_port());
        display(const_27,cur_output_port());
        newline(cur_output_port());
        print_pure_clause(GLOBAL(param_tocl_global));
        newline(cur_output_port());
        print_pure_clause(GLOBAL(param_fromcl_global));
        newline(cur_output_port());
        if(NFALSEP(GLOBAL(type_theory_stratflag_global)))
          print_lit(GLOBAL(param_eqlit_global));
        else
          print_lit(GLOBAL(param_eqlit_global));
        newline(cur_output_port());
        print_pure_clause(CDR(res));
        newline(cur_output_port());
      }
      res=handle_derived_inf_cl_pair(res,history,BOOL_F,ans_inf);
      if(NFALSEP(res)&&(NFALSEP(GLOBAL(factors_stratflag_global))&&!(NFALSEP(GLOBAL(foundflag_global)))))
        return factor(CAR(res),CDR(res));
      else
        return UNSPECIFIED;
    }
  }
}

SCM give_cl_maxvar(clinf)
SCM clinf;
{
  SCM clmaxvar;

  clmaxvar=MAKINUM(INUM(MAKINUM(528482304)&CAR(clinf))>>23);
  if(clmaxvar==MAKINUM(63))
    return MAKINUM(255);
  else
    return clmaxvar;
}

SCM handle_derived_inf_cl_pair(pr,history,fac_gen_flag,ans_inf)
SCM pr,history,fac_gen_flag,ans_inf;
{
  SCM kept_cl,new_var2,tmp_pr,tmp_triple,cl,inf,clauseinf,tmp_fullcl;

  if(GLOBAL(display_info_level_global)>MAKINUM(110)) {
    newline(cur_output_port());
    display(const_28,cur_output_port());
    display(CAR(pr),cur_output_port());
    newline(cur_output_port());
    debug_print_pure_clause(CDR(pr));
    newline(cur_output_port());
    display(fac_gen_flag,cur_output_port());
    newline(cur_output_port());
  }
  GLOBAL(derived_clauses_nr_global)=MAKINUM(1+INUM(GLOBAL(derived_clauses_nr_global)));
  if(NFALSEP(ans_inf)) {
    pr=make_unique_answer_pair(pr,history,ans_inf);
  }
  cl=CDR(pr);
  inf=CAR(pr);
  clauseinf=EOL;
  tmp_fullcl=EOL;
  if(!(NFALSEP(cl))||(NFALSEP(GLOBAL(classical_synth_stratflag_global))&&(!(NFALSEP(ans_inf))&&NFALSEP(some_pred_(handle_derived_inf_cl_pair_fn14,cl)))))
    return BOOL_F;
  else
  if(NFALSEP(empty_cl_pred_(cl))) {
    if(GLOBAL(display_info_level_global)>=MAKINUM(20)) {
      newline(cur_output_port());
      display(const_29,cur_output_port());
      newline(cur_output_port());
    }
    GLOBAL(answer_cl_global)=cl;
    GLOBAL(answer_history_global)=history;
    GLOBAL(foundflag_global)=BOOL_T;
    return UNSPECIFIED;
  }
  else {
    tmp_pr=EOL;
    tmp_triple=EOL;
    tmp_pr=remove_double_lits_excl_(inf,cl,GLOBAL(hyper_strategy_flag_global));
    if(NFALSEP(removable_tautology_pr_pred_(tmp_pr))||(NFALSEP(GLOBAL(int_logic_flag_global))&&NFALSEP(apply(GLOBAL(int_prohibited_pr_pred_),tmp_pr,listofnull))))
      return BOOL_F;
    else {
      if(NFALSEP(GLOBAL(user_criterias_post_flag_global))&&!(NFALSEP(clause_pass_user_crit_post_pred_(CAR(tmp_pr),CDR(tmp_pr),history)))) {
        tmp_pr=BOOL_F;
      }
      if(NFALSEP(tmp_pr)) {
        tmp_triple=unit_handle_cl_excl_(CAR(tmp_pr),CDR(tmp_pr),history);
      }
      else {
        tmp_triple=BOOL_F;
      }
      if(!(NFALSEP(GLOBAL(stop_fast_loop_flag_global)))&&((INUM(get_check_time(MAKINUM(5)))-INUM(GLOBAL(slow_start_time_global)))>INUM(GLOBAL(one_pass_time_global)))) {
        store_time_checkpoint_excl_(MAKINUM(5));
        GLOBAL(stop_fast_loop_flag_global)=BOOL_T;
      }
      if(GLOBAL(display_info_level_global)>MAKINUM(110)) {
        if(NFALSEP(tmp_pr)) {
          newline(cur_output_port());
          display(const_30,cur_output_port());
          display(CAR(tmp_pr),cur_output_port());
          newline(cur_output_port());
          debug_print_pure_clause(CDR(tmp_pr));
          newline(cur_output_port());
        }
      }
      if(NFALSEP(tmp_triple)&&!(NFALSEP(clause_pass_user_limits_post_pred_(CDR(CDR(tmp_triple)))))) {
        tmp_triple=BOOL_F;
        if(GLOBAL(display_info_level_global)>=MAKINUM(80)) {
          newline(cur_output_port());
          display(const_31,cur_output_port());
          newline(cur_output_port());
        }
      }
      if(!(NFALSEP(tmp_triple)))
        return BOOL_F;
      else {
        history=CAR(tmp_triple);
        tmp_pr=CDR(tmp_triple);
        new_var2=BOOL_F;
        if(NFALSEP(new_var2))
          return new_var2;
        else
        if(NFALSEP(empty_cl_pred_(CDR(tmp_pr)))) {
          GLOBAL(answer_cl_global)=CDR(tmp_pr);
          GLOBAL(answer_history_global)=history;
          GLOBAL(foundflag_global)=BOOL_T;
          if(GLOBAL(display_info_level_global)>=MAKINUM(20)) {
            newline(cur_output_port());
            display(const_32,cur_output_port());
            return newline(cur_output_port());
          }
          else
            return UNSPECIFIED;
        }
        else {
          tmp_pr=sort_clause(handle_derived_inf_cl_pair_aux289(tmp_pr),BOOL_T);
          tmp_pr=cons(map1(handle_derived_inf_cl_pair_fn15,tmp_pr),map1(handle_derived_inf_cl_pair_fn16,tmp_pr));
          clauseinf=make_clause_info(CDR(tmp_pr),history);
          tmp_fullcl=cons(clauseinf,CDR(tmp_pr));
          new_var2=BOOL_F;
          if(NFALSEP(new_var2))
            return new_var2;
          else
          if(NFALSEP(fac_gen_flag)&&(NFALSEP(some_pred__inst2(tmp_fullcl,handle_derived_inf_cl_pair_fn17,GLOBAL(locfactorpool_global)))||NFALSEP(some_pred__inst2(tmp_fullcl,handle_derived_inf_cl_pair_fn18,GLOBAL(factorpool_global)))))
            return BOOL_F;
          else
          if(!(NFALSEP(fac_gen_flag))&&(!(NFALSEP(unit_cl_pred_(CDR(tmp_pr))))&&NFALSEP(havealready_clause_pred_(clauseinf,CDR(tmp_pr)))))
            return BOOL_F;
          else {
            kept_cl=make_kept_clause(clauseinf,tmp_pr);
            if(GLOBAL(display_info_level_global)>=MAKINUM(70)) {
              newline(cur_output_port());
              display(const_33,cur_output_port());
              newline(cur_output_port());
              print_clause(kept_cl);
              newline(cur_output_port());
              if(NFALSEP(GLOBAL(display_debug_info_flag_global))) {
                debug_print_clause(kept_cl);
                newline(cur_output_port());
              }
            }
            else
            if(NFALSEP(GLOBAL(display_info_char_flag_global)))
              display(MAKICHR('+'),cur_output_port());
            tmp_pr=full_unit_cutoff_excl_(CAR(tmp_pr),kept_cl);
            kept_cl=CDR(tmp_pr);
            if(NFALSEP(empty_cl_pred_(CDR(kept_cl)))) {
              GLOBAL(answer_cl_global)=CDR(kept_cl);
              GLOBAL(answer_history_global)=CAR(CDR(CDR(CDR(CDR(CDR(CAR(kept_cl)))))));
              GLOBAL(foundflag_global)=BOOL_T;
              if(GLOBAL(display_info_level_global)>=MAKINUM(20)) {
                newline(cur_output_port());
                display(const_34,cur_output_port());
                return newline(cur_output_port());
              }
              else
                return UNSPECIFIED;
            }
            else
            if(!(NFALSEP(fac_gen_flag)))
              return handle_derived_inf_cl_pair_aux(tmp_pr,BOOL_F);
            else {
              GLOBAL(locfactorpool_global)=remove_if_inst1(kept_cl,handle_derived_inf_cl_pair_fn19,GLOBAL(locfactorpool_global));
              GLOBAL(factorpool_global)=remove_if_inst1(kept_cl,handle_derived_inf_cl_pair_fn20,GLOBAL(factorpool_global));
              return tmp_pr;
            }
          }
        }
      }
    }
  }
}

SCM handle_derived_inf_cl_pair_aux289(tmp_pr)
SCM tmp_pr;
{
  SCM new_var6,new_var7,new_var3,new_var4,new_var5;

  for(new_var6=CAR(tmp_pr),new_var7=CDR(tmp_pr),new_var3=EOL,new_var4=EOL,new_var5=EOL;
      PAIR_P(new_var6)&&PAIR_P(new_var7);
      new_var6=CDR(new_var6),new_var7=CDR(new_var7)) {
    new_var5=cons(CAR(new_var6),CAR(new_var7));
    if(NULL_P(new_var3)) {
      new_var3=cons(new_var5,EOL);
      new_var4=new_var3;
    }
    else {
      SET_CDR(new_var4,cons(new_var5,EOL));
      new_var4=CDR(new_var4);
    }
  }
  return new_var3;
}

SCM handle_derived_inf_cl_pair_fn20(kept_cl,x)
SCM kept_cl,x;
{
  return subsumed_clause_pred_(CDR(x),kept_cl);
}

SCM handle_derived_inf_cl_pair_fn19(kept_cl,x)
SCM kept_cl,x;
{
  return subsumed_clause_pred_(CDR(x),kept_cl);
}

SCM handle_derived_inf_cl_pair_fn18(tmp_fullcl,x)
SCM tmp_fullcl,x;
{
  return subsumed_clause_pred_(tmp_fullcl,CDR(x));
}

SCM handle_derived_inf_cl_pair_fn17(tmp_fullcl,x)
SCM tmp_fullcl,x;
{
  return subsumed_clause_pred_(tmp_fullcl,CDR(x));
}

SCM handle_derived_inf_cl_pair_fn16(x)
SCM x;
{
  return CDR(x);
}

SCM handle_derived_inf_cl_pair_fn15(x)
SCM x;
{
  return CAR(x);
}

SCM handle_derived_inf_cl_pair_fn14(x)
SCM x;
{
  return SBOOL(NFALSEP(answer_lit_pred_(x))&&!(NFALSEP(ans_computable_lit_pred_(x))));
}

SCM too_many_kept_pred_(tmp_pr,fac_gen_flag)
SCM tmp_pr,fac_gen_flag;
{
  if((INUM(GLOBAL(kept_clauses_nr_global))>((INUM(GLOBAL(one_pass_kept_clauses_firstnr_global))+INUM(GLOBAL(max_kept_clauses_nr_global)))-1500))&&(!((INUM(GLOBAL(kept_clauses_nr_global))<((INUM(GLOBAL(one_pass_kept_clauses_firstnr_global))+INUM(GLOBAL(max_kept_clauses_nr_global)))-500))&&((MAKINUM(2047)&CAR(CAR(CDR(tmp_pr))))<=GLOBAL(last_best_weight_global)))&&!((INUM(GLOBAL(kept_clauses_nr_global))<(INUM(GLOBAL(one_pass_kept_clauses_firstnr_global))+INUM(GLOBAL(max_kept_clauses_nr_global))))&&((MAKINUM(2047)&CAR(CAR(CDR(tmp_pr))))<GLOBAL(last_best_weight_global)))))
    return BOOL_T;
  else
    return BOOL_F;
}

SCM handle_derived_inf_cl_pair_aux(tmp_pr,fac_gen_flag)
SCM tmp_pr,fac_gen_flag;
{
  SCM kept_cl__1,litinfolst__2,strengthint,len,strength,kept_cl,litinfolst;

  if((NFALSEP(GLOBAL(hyper_strategy_flag_global))&&(!(NFALSEP(fac_gen_flag))&&!(NFALSEP(positive_cl_pred_(CDR(CDR(tmp_pr)))))))||NFALSEP(GLOBAL(unit_clash_flag_global))) {
    kept_cl=CDR(tmp_pr);
    litinfolst=map1(handle_derived_inf_cl_pair_aux_fn24,CAR(tmp_pr));
    GLOBAL(kept_mid_nucleus_nr_global)=MAKINUM(1+INUM(GLOBAL(kept_mid_nucleus_nr_global)));
    SET_CAR(CDR(CDR(CAR(kept_cl))),litinfolst);
    if(NFALSEP(GLOBAL(unit_clash_flag_global)))
      insert_clause_discr_tree_excl_(GLOBAL(discr_tree_global),CDR(tmp_pr),CAR(tmp_pr),BOOL_F);
    else
      insert_clause_discr_tree_excl_(GLOBAL(discr_tree_global),CDR(tmp_pr),CAR(tmp_pr),BOOL_F);
    if(GLOBAL(display_info_level_global)>=MAKINUM(100)) {
      newline(cur_output_port());
      display(const_35,cur_output_port());
      newline(cur_output_port());
      print_pure_clause(CDR(kept_cl));
      newline(cur_output_port());
      debug_print_xvars(MAKINUM(3));
      debug_print_yvars(MAKINUM(3));
      if(NFALSEP(GLOBAL(display_debug_info_flag_global))) {
        newline(cur_output_port());
        display(const_36,cur_output_port());
        newline(cur_output_port());
        debug_print_clause(kept_cl);
      }
    }
    else
    if(NFALSEP(GLOBAL(display_info_char_flag_global)))
      display(MAKICHR('$'),cur_output_port());
    if(NFALSEP(GLOBAL(one_step_hyper_phase_global)))
      return kept_cl;
    else {
      GLOBAL(stop_fast_loop_flag_global)=BOOL_F;
      usable_clauses_fast_loop(kept_cl,BOOL_F);
      return BOOL_F;
    }
  }
  else
  if(NFALSEP(too_many_kept_pred_(tmp_pr,fac_gen_flag)))
    return BOOL_F;
  else {
    kept_cl__1=CDR(tmp_pr);
    if(NFALSEP(GLOBAL(order_strategy_flag_global))||(NFALSEP(GLOBAL(poslitpref_order_strategy_flag_global))||(NFALSEP(GLOBAL(name_order_strategy_flag_global))||(NFALSEP(GLOBAL(firstlitpref_order_strategy_flag_global))||(NFALSEP(GLOBAL(posweight_order_strategy_flag_global))||NFALSEP(GLOBAL(ordered_paramodulation_flag_global)))))))
      litinfolst__2=map1(handle_derived_inf_cl_pair_aux_fn25,order_prohibit_litinfos(CAR(tmp_pr),CDR(kept_cl__1)));
    else
      litinfolst__2=map1(handle_derived_inf_cl_pair_aux_fn26,CAR(tmp_pr));
    strengthint=CAR(CAR(kept_cl__1));
    len=MAKINUM(INUM(MAKINUM(8257536)&strengthint)>>17);
    strength=(MAKINUM(131071)&strengthint);
    GLOBAL(kept_clauses_nr_global)=MAKINUM(1+INUM(GLOBAL(kept_clauses_nr_global)));
    SET_CAR(CDR(CDR(CAR(kept_cl__1))),litinfolst__2);
    insert_clause_discr_tree_excl_(GLOBAL(discr_tree_global),CDR(tmp_pr),CAR(tmp_pr),BOOL_T);
    if(len==MAKINUM(1))
      insert_unit_alist(kept_cl__1);
    if(NFALSEP(GLOBAL(back_subsume_stratflag_global)))
      back_subsume(CAR(kept_cl__1),CDR(kept_cl__1));
    if(GLOBAL(display_info_level_global)>=MAKINUM(60)) {
      newline(cur_output_port());
      display(const_37,cur_output_port());
      newline(cur_output_port());
      print_pure_clause(CDR(kept_cl__1));
      newline(cur_output_port());
      if(NFALSEP(GLOBAL(display_debug_info_flag_global))) {
        newline(cur_output_port());
        display(const_38,cur_output_port());
        newline(cur_output_port());
        display(kept_cl__1,cur_output_port());
        newline(cur_output_port());
        debug_print_clause(kept_cl__1);
      }
    }
    else
    if(NFALSEP(GLOBAL(display_info_char_flag_global)))
      display(MAKICHR('+'),cur_output_port());
    if(!(NULL_P(GLOBAL(special_insertion_place_global)))) {
      SET_CDR(GLOBAL(special_insertion_place_global),cons(kept_cl__1,CDR(GLOBAL(special_insertion_place_global))));
    }
    else
    if(NULL_P(GLOBAL(sos_clauses_list_global))) {
      GLOBAL(sos_clauses_list_global)=cons(kept_cl__1,EOL);
      GLOBAL(sos_clauses_list_end_global)=GLOBAL(sos_clauses_list_global);
    }
    else {
      SET_CDR(GLOBAL(sos_clauses_list_end_global),cons(kept_cl__1,EOL));
      GLOBAL(sos_clauses_list_end_global)=CDR(GLOBAL(sos_clauses_list_end_global));
    }
    if(NFALSEP(GLOBAL(dynamic_demodulation_flag_global)))
      attempt_to_make_a_demodulator(kept_cl__1);
    if(NFALSEP(GLOBAL(int_logic_flag_global)))
      apply(GLOBAL(use_all_single_premiss_rules),kept_cl__1,listofnull);
    if(NFALSEP(GLOBAL(hyper_contradiction_strategy_global))&&!(NFALSEP(unit_cl_pred_(CDR(kept_cl__1)))))
      hyper_contradiction_pred_(kept_cl__1);
    if(NFALSEP(GLOBAL(one_step_hyper_phase_global)))
      return BOOL_F;
    else
      return tmp_pr;
  }
}

SCM handle_derived_inf_cl_pair_aux_fn26(x)
SCM x;
{
  return CDR(CDR(x));
}

SCM handle_derived_inf_cl_pair_aux_fn25(x)
SCM x;
{
  return CDR(CDR(x));
}

SCM handle_derived_inf_cl_pair_aux_fn24(x)
SCM x;
{
  return CDR(CDR(x));
}

SCM attempt_to_make_a_demodulator(fullcl)
SCM fullcl;
{
  SCM inf,cl,lit,litinfnr,eqlit;

  inf=CAR(fullcl);
  cl=CDR(fullcl);
  lit=CAR(cl);
  litinfnr=CAR(CAR(CAR(CDR(CDR(inf)))));
  eqlit=EOL;
  if(NULL_P(CDR(cl))&&(((MAKINUM(534773760)&CAR(lit))==GLOBAL(eq_pred_nr_global))&&((!(ZERO_P(MAKINUM(16)&litinfnr))||!(ZERO_P(MAKINUM(32)&litinfnr)))&&!(!(ZERO_P(MAKINUM(16)&litinfnr))&&!(ZERO_P(MAKINUM(32)&litinfnr)))))) {
    GLOBAL(new_demodulators_flag_global)=BOOL_T;
    if(!(ZERO_P(MAKINUM(16)&litinfnr))) {
      eqlit=cons(CAR(lit),cons(CAR(CDR(CDR(lit))),cons(CAR(CDR(lit)),CDR(CDR(CDR(lit))))));
    }
    else {
      eqlit=lit;
    }
    if(NUMBER_P(CAR(CDR(eqlit)))&&(CAR(CDR(eqlit))>MAKINUM(65535))) {
      GLOBAL(demodulate_constants_flag_global)=BOOL_T;
    }
    GLOBAL(cur_lit_global)=rename_x_to_z_term(eqlit);
    GLOBAL(cur_clause_global)=cons(inf,cons(GLOBAL(cur_lit_global),EOL));
    if(GLOBAL(display_info_level_global)>=MAKINUM(60)) {
      newline(cur_output_port());
      display(const_39,cur_output_port());
      newline(cur_output_port());
      print_pure_clause(CDR(GLOBAL(cur_clause_global)));
      newline(cur_output_port());
      if(NFALSEP(GLOBAL(display_debug_info_flag_global))) {
        newline(cur_output_port());
        display(const_40,cur_output_port());
        newline(cur_output_port());
        debug_print_clause(GLOBAL(cur_clause_global));
      }
    }
    else
    if(NFALSEP(GLOBAL(display_info_char_flag_global)))
      display(MAKICHR('+'),cur_output_port());
    GLOBAL(new_demodulators_list_global)=cons(GLOBAL(cur_clause_global),GLOBAL(new_demodulators_list_global));
    GLOBAL(kept_new_demodulators_nr_global)=MAKINUM(1+INUM(GLOBAL(kept_new_demodulators_nr_global)));
    return insert_discr_tree_excl_(GLOBAL(discr_tree_demod_terms_global),CAR(CDR(GLOBAL(cur_lit_global))),BOOL_T,BOOL_T,BOOL_T);
  }
  else
    return UNSPECIFIED;
}

SCM make_kept_clause(clinfo,inflist_cl_pair)
SCM clinfo,inflist_cl_pair;
{
  SCM cl,tmp;

  cl=CDR(inflist_cl_pair);
  tmp=EOL;
  clause_var_nr_global=MAKINUM(0);
  if(NFALSEP(pure_clause_may_cont_vars_pred_(cl))) {
    cl=copy_list(cl);
    make_varinfo_lst_excl_(cl,const_41);
    GLOBAL(new_var_names_global)=EOL;
    make_fulldeco_clause_excl_(cl);
  }
  if(clause_var_nr_global>MAKINUM(63)) {
    clause_var_nr_global=MAKINUM(63);
  }
  SET_CAR(clinfo,MAKINUM(INUM(clause_var_nr_global)<<23)|CAR(clinfo));
  GLOBAL(kept_cl_nr_global)=MAKINUM(1+INUM(GLOBAL(kept_cl_nr_global)));
  SET_CAR(CDR(CDR(clinfo)),make_kept_litinflist(CAR(inflist_cl_pair),cl));
  SET_CAR(CDR(CDR(CDR(CDR(clinfo)))),GLOBAL(kept_cl_nr_global));
  tmp=CDR(CDR(CDR(CDR(CDR(clinfo)))));
  if(!(PAIR_P(CAR(tmp)))) {
    SET_CAR(tmp,cons(unknown_symb,cons(GLOBAL(kept_cl_nr_global),CAR(tmp))));
  }
  else {
    SET_CAR(tmp,cons(CAR(CAR(tmp)),cons(GLOBAL(kept_cl_nr_global),CDR(CDR(CAR(tmp))))));
  }
  return cons(clinfo,cl);
}

SCM make_kept_litinflist(litinf,newcl)
SCM litinf,newcl;
{
  return map1(make_kept_litinflist_fn28,litinf);
}

SCM make_kept_litinflist_fn28(x)
SCM x;
{
  return CDR(CDR(x));
}

SCM litinf_binrespara_pred_(inf)
SCM inf;
{
  return NOT(SBOOL(litinf_nobinrespara_mask_global==(litinf_nobinrespara_mask_global&inf)));
}

SCM litinf_use_pred_(inf)
SCM inf;
{
  return SBOOL(ZERO_P(litinf_nouse_mask_global&inf));
}

SCM litinf_left_para_pred_(inf)
SCM inf;
{
  return SBOOL(ZERO_P(MAKINUM(16)&inf));
}

SCM litinf_right_para_pred_(inf)
SCM inf;
{
  return SBOOL(ZERO_P(MAKINUM(32)&inf));
}

SCM litinf_parainto_pred_(inf)
SCM inf;
{
  return SBOOL(ZERO_P(MAKINUM(8)&inf));
}

SCM modify_to_demod_inf_excl_(fullcl)
SCM fullcl;
{
  SCM inflist,res;

  inflist=CAR(CDR(CDR(CAR(fullcl))));
  res=CAR(inflist);
  res=cons(MAKINUM(0)|(MAKINUM(32)|CAR(res)),CDR(res));
  SET_CAR(inflist,res);
  return UNSPECIFIED;
}

SCM make_clause_info(cl,history)
SCM cl,history;
{
  SCM clpart__1,lit,fun,clpart,strengthint,len,predsymbsint,litinfolst,weight,clinfo,minw,tmp;

  strengthint=MAKINUM(0);
  len=MAKINUM(0);
  predsymbsint=MAKINUM(0);
  litinfolst=map1(make_clause_info_fn34,cl);
  weight=MAKINUM(0);
  clinfo=EOL;
  minw=MAKINUM(0);
  tmp=EOL;
  for(clpart=cl;!(NULL_P(clpart));clpart=CDR(clpart)) {
    lit=CAR(clpart);
    fun=CAR(lit);
    if(NFALSEP(countable_pred_pred_(fun))) {
      if(ZERO_P(strengthint)) {
        strengthint=(MAKINUM(131071)&fun);
      }
      else {
        strengthint=sum_fun_strengths(fun,strengthint);
      }
      if(!(ZERO_P(predsymb_bit(fun)&predsymbsint))) {
        predsymbsint=(MAKINUM(134217728)|predsymbsint);
      }
      predsymbsint=(predsymb_bit(fun)|predsymbsint);
      len=MAKINUM(1+INUM(len));
      weight=MAKINUM(INUM(weight)+INUM(lit_weight(lit)));
    }
  }
  if(NFALSEP(GLOBAL(split_strategy_flag_global))) {
    weight=strengthint;
  }
  if(NFALSEP(GLOBAL(split_strategy_flag_global))&&!(NULL_P(CDR(cl)))) {
    weight=strengthint;
    tmp=map1(make_clause_info_fn35,cl);
    if(NFALSEP(every_pred__inst1(tmp,make_clause_info_fn36,tmp))) {
      if(GLOBAL(display_info_level_global)>MAKINUM(70)) {
        newline(cur_output_port());
        display(const_42,cur_output_port());
        print_pure_clause(cl);
        newline(cur_output_port());
      }
      for(clpart__1=cl;!(NULL_P(clpart__1));clpart__1=CDR(clpart__1))
        if(ZERO_P(minw)) {
          minw=(MAKINUM(131071)&CAR(CAR(clpart__1)));
        }
        else
        if((MAKINUM(131071)&CAR(CAR(clpart__1)))>minw) {
          minw=(MAKINUM(131071)&CAR(CAR(clpart__1)));
        }
      weight=minw;
    }
  }
  if(len>MAKINUM(63)) {
    len=MAKINUM(63);
  }
  strengthint=(MAKINUM(INUM(len)<<17)|strengthint);
  clinfo=cons(strengthint,cons(predsymbsint,cons(litinfolst,cons(weight,cons(EOL,cons(history,EOL))))));
  return clinfo;
}

SCM make_clause_info_fn36(tmp,el)
SCM tmp,el;
{
  return SBOOL(NULL_P(el)||NFALSEP(every_pred__inst1(el,make_clause_info_fn37,tmp)));
}

SCM make_clause_info_fn37(el,el2)
SCM el,el2;
{
  return SBOOL((el2==el)||NFALSEP(every_pred__inst1(el2,make_clause_info_fn38,el)));
}

SCM make_clause_info_fn38(el2,v)
SCM el2,v;
{
  return SBOOL(!(NFALSEP(assq(CAR(v),el2))));
}

SCM make_clause_info_fn35(x)
SCM x;
{
  return make_var_depth_info(x);
}

SCM make_clause_info_fn34(x)
SCM x;
{
  return cons(MAKINUM(0),EOL);
}

SCM intern_fullclause(cl)
SCM cl;
{
  SCM strengthint,len,strength;

  insert_clause_discr_tree_excl_(GLOBAL(discr_tree_global),cl,map1(intern_fullclause_fn40,CDR(cl)),BOOL_T);
  strengthint=CAR(CAR(cl));
  len=MAKINUM(INUM(MAKINUM(8257536)&strengthint)>>17);
  strength=(MAKINUM(131071)&strengthint);
  if(len==MAKINUM(1))
    insert_unit_alist(cl);
  return insert_to_subsumption_list_excl_(len,strength,cl);
}

SCM intern_fullclause_fn40(x)
SCM x;
{
  return cons(BOOL_T,EOL);
}

SCM back_demodulate_usable()
{
  SCM part,tmp,given_cl,new,newlist;

  if(GLOBAL(display_info_level_global)>=MAKINUM(60)) {
    newline(cur_output_port());
    display(const_43,cur_output_port());
    newline(cur_output_port());
  }
  tmp=EOL;
  given_cl=EOL;
  new=EOL;
  newlist=EOL;
  for(part=GLOBAL(usable_clauses_list_global);!(NULL_P(part));part=CDR(part)) {
    given_cl=CAR(part);
    if(PAIR_P(given_cl)&&!(ZERO_P(MAKINUM(65535)&CAR(CAR(given_cl))))) {
      tmp=demodulate_clause(given_cl);
      if(NFALSEP(tmp)) {
        new=CDR(tmp);
        newlist=cons(new,newlist);
        SET_CAR(CAR(given_cl),MAKINUM(65535^INUM(MAKINUM(65535)|CAR(CAR(given_cl)))));
        insert_to_subsumption_list_excl_(MAKINUM(INUM(MAKINUM(8257536)&CAR(CAR(new)))>>17),MAKINUM(65535)&CAR(CAR(new)),new);
      }
    }
  }
  if(GLOBAL(display_info_level_global)>=MAKINUM(60)) {
    newline(cur_output_port());
    display(const_44,cur_output_port());
    newline(cur_output_port());
  }
  return for_each1(back_demodulate_usable_fn42,newlist);
}

SCM back_demodulate_usable_fn42(cl)
SCM cl;
{
  SET_CDR(GLOBAL(usable_clauses_list_end_global),cons(cl,EOL));
  GLOBAL(usable_clauses_list_end_global)=CDR(GLOBAL(usable_clauses_list_end_global));
  return UNSPECIFIED;
}

SCM demodulate_clause(cl)
SCM cl;
{
  SCM inf,purecl,part,newlitinf,history,res,demods,new;

  inf=CAR(cl);
  purecl=CDR(cl);
  part=EOL;
  newlitinf=EOL;
  history=EOL;
  res=EOL;
  demods=EOL;
  new=EOL;
  GLOBAL(used_demodulators_global)=EOL;
  new=map1(demodulate_clause_fn46,purecl);
  if(NULL_P(GLOBAL(used_demodulators_global)))
    return BOOL_F;
  else {
    demods=GLOBAL(used_demodulators_global);
    newlitinf=map1(demodulate_clause_fn47,CAR(CDR(CDR(CAR(cl)))));
    history=cons(backdemod_symb,cons(MAKINUM(0),cons(cons(literal_symb,cons(CAR(CDR(CDR(CDR(CDR(CDR(inf)))))),cons(MAKINUM(1),EOL))),cons(cons(demod_symb,GLOBAL(used_demodulators_global)),EOL))));
    res=handle_derived_inf_cl_pair(cons(newlitinf,new),history,BOOL_F,BOOL_F);
    if(NFALSEP(res)&&((GLOBAL(display_info_level_global)>=MAKINUM(60))&&!(NFALSEP(GLOBAL(foundflag_global))))) {
      newline(cur_output_port());
      display(const_45,cur_output_port());
      newline(cur_output_port());
      print_pure_clause(CDR(cl));
      newline(cur_output_port());
      display(const_46,cur_output_port());
      newline(cur_output_port());
      print_pure_clause(CDR(CDR(res)));
      newline(cur_output_port());
      display(const_47,cur_output_port());
      newline(cur_output_port());
      for_each1(demodulate_clause_fn48,demods);
      if(NFALSEP(GLOBAL(display_debug_info_flag_global))) {
        newline(cur_output_port());
        display(const_48,cur_output_port());
        newline(cur_output_port());
        debug_print_clause(CDR(res));
      }
    }
    if(NFALSEP(GLOBAL(foundflag_global))) {
      res=BOOL_F;
    }
    return res;
  }
}

SCM demodulate_clause_fn48(x)
SCM x;
{
  print_pure_clause(CDR(x));
  return newline(cur_output_port());
}

SCM demodulate_clause_fn47(inf__1)
SCM inf__1;
{
  return cons(BOOL_T,cons(MAKINUM(1),inf__1));
}

SCM demodulate_clause_fn46(lit)
SCM lit;
{
  return demodulate_fully_lit(lit);
}

SCM demodulate_composite(comp)
SCM comp;
{
  SCM nr,tmp1,tmp2,demodcl,demodlit,maxdemodvar,checkres;

  checkres=check_discr_tree(GLOBAL(discr_tree_demod_terms_global),comp);
  if(!(NFALSEP(checkres))) {
    if(GLOBAL(case_fun_nr_global)==(MAKINUM(534773760)&CAR(comp)))
      return subst_deco_case_term(comp);
    else
      return comp;
  }
  else {
    demodcl=CAR(CDR(CDR(checkres)));
    demodlit=CAR(CDR(demodcl));
    maxdemodvar=give_cl_maxvar(CAR(demodcl));
    if(!(NFALSEP(memq(demodcl,GLOBAL(used_demodulators_global))))) {
      GLOBAL(used_demodulators_global)=cons(demodcl,GLOBAL(used_demodulators_global));
    }
    subsumed_term_list_ordinary_pred_(CDR(comp),CDR(CAR(CDR(demodlit))));
    tmp1=EOL;
    tmp2=EOL;
    comp=subst_deco_term_nodemodulate_spec(CAR(CDR(CDR(demodlit))));
    tmp2=EOL;
    for(nr=(MAKINUM(512)|maxdemodvar);!(nr<=MAKINUM(512));nr=MAKINUM(INUM(nr)-1)) {
      tmp1=STBL_VECTOR_REF(_star_var_val_table_star__velts0,nr);
      if(!(NUMBER_P(tmp1))&&1) {
        tmp2=cons(tmp1,tmp2);
      }
    }
    clear_z_vars_and_touched_excl_(maxdemodvar);
    var_set_flag_global=BOOL_F;
    alt_var_set_flag_global=BOOL_F;
    return demodulate_fully(comp,tmp2,BOOL_F);
  }
}

SCM demodulate_lit(lit)
SCM lit;
{
  SCM nr,tmp0,tmp1,tmp2,new,demodcl,demodatom,maxdemodvar,atom,checkres;

  if(!(ZERO_P(MAKINUM(268435456)&CAR(lit))))
    atom=cons(MAKINUM(268435456^INUM(CAR(lit))),CDR(lit));
  else
    atom=lit;
  checkres=check_discr_tree(GLOBAL(discr_tree_demod_atoms_global),atom);
  if(!(NFALSEP(checkres)))
    return lit;
  else {
    demodcl=CAR(CDR(CDR(checkres)));
    demodatom=CAR(CDR(demodcl));
    maxdemodvar=give_cl_maxvar(CAR(demodcl));
    if(!(NFALSEP(memq(demodcl,GLOBAL(used_demodulators_global))))) {
      GLOBAL(used_demodulators_global)=cons(demodcl,GLOBAL(used_demodulators_global));
    }
    subsumed_term_list_ordinary_pred_(CDR(atom),CDR(demodatom));
    tmp0=GLOBAL(demodulate_flag_global);
    tmp1=GLOBAL(demodulate_constants_flag_global);
    tmp2=GLOBAL(new_demodulators_flag_global);
    new=EOL;
    GLOBAL(demodulate_flag_global)=BOOL_F;
    GLOBAL(demodulate_constants_flag_global)=BOOL_F;
    GLOBAL(new_demodulators_flag_global)=BOOL_F;
    GLOBAL(demodulate_lit_flag_global)=BOOL_F;
    new=subst_deco_term(CAR(CDR(CDR(demodcl))),BOOL_T);
    if(atom==lit) {
      new=cons(MAKINUM(268435456^INUM(CAR(new))),CDR(new));
    }
    GLOBAL(demodulate_flag_global)=tmp0;
    GLOBAL(demodulate_constants_flag_global)=tmp1;
    GLOBAL(new_demodulators_flag_global)=tmp2;
    GLOBAL(demodulate_lit_flag_global)=BOOL_T;
    tmp2=EOL;
    for(nr=(MAKINUM(512)|maxdemodvar);!(nr<=MAKINUM(512));nr=MAKINUM(INUM(nr)-1)) {
      tmp1=STBL_VECTOR_REF(_star_var_val_table_star__velts0,nr);
      if(!(NUMBER_P(tmp1))&&1) {
        tmp2=cons(tmp1,tmp2);
      }
    }
    clear_z_vars_and_touched_excl_(maxdemodvar);
    var_set_flag_global=BOOL_F;
    alt_var_set_flag_global=BOOL_F;
    return demodulate_fully(new,tmp2,BOOL_T);
  }
}

SCM demodulate_constant(const_nonkeyword)
SCM const_nonkeyword;
{
  SCM demodcl,demodlit,checkres;

  GLOBAL(nonunit_discr_flag_global)=BOOL_T;
  checkres=check_discr_tree_part(GLOBAL(discr_tree_demod_terms_global),cons(const_nonkeyword,EOL),EOL);
  if(!(NFALSEP(checkres)))
    return const_nonkeyword;
  else {
    demodcl=CAR(CDR(CDR(checkres)));
    demodlit=CAR(CDR(demodcl));
    return CAR(CDR(CDR(demodlit)));
  }
}

SCM demodulate_fully(term,done_terms,litflag)
SCM term,done_terms,litflag;
{
  SCM new,part,res,resend,str;

  if(NUMBER_P(term)) {
    if(MAKINUM(65535)>term)
      return term;
    else
    if(NFALSEP(GLOBAL(demodulate_constants_flag_global)))
      return demodulate_constant(term);
    else
      return term;
  }
  else
  if(NFALSEP(memq(term,done_terms)))
    return term;
  else
  if(!(1))
    return term;
  else {
    res=cons(EOL,EOL);
    resend=res;
    str=MAKINUM(65536);
    for(part=CDR(term);!(NULL_P(part));part=CDR(part)) {
      new=demodulate_fully(CAR(part),done_terms,BOOL_F);
      SET_CDR(resend,cons(new,EOL));
      if(resend==res) {
        if(NUMBER_P(new)) {
          if(MAKINUM(65535)>new) {
            str=GLOBAL(var_strength_global);
          }
          else {
            str=GLOBAL(const_strength_global);
          }
        }
        else {
          str=CAR(new);
        }
      }
      else
      if(NUMBER_P(new)) {
        if(MAKINUM(65535)>new) {
          str=sum_fun_strengths(GLOBAL(var_strength_global),str);
        }
        else {
          str=sum_fun_strengths(GLOBAL(const_strength_global),str);
        }
      }
      else {
        str=sum_fun_strengths(CAR(new),str);
      }
      resend=CDR(resend);
    }
    SET_CAR(res,create_new_fun_pos_object(CAR(term),str));
    if(NFALSEP(litflag))
      return demodulate_lit(res);
    else
      return demodulate_composite(res);
  }
}

SCM may_be_demodulated_pred_(term)
SCM term;
{
  return BOOL_T;
}

SCM eq_lit_arg1(lit)
SCM lit;
{
  return CAR(CDR(lit));
}

SCM eq_lit_arg2(lit)
SCM lit;
{
  return CAR(CDR(CDR(lit)));
}

SCM eq_lit_type(lit)
SCM lit;
{
  return CAR(CDR(CDR(CDR(lit))));
}

SCM demodulate_fully_lit(term)
SCM term;
{
  SCM new,part,res,resend,str;

  res=cons(EOL,EOL);
  resend=res;
  str=MAKINUM(65536);
  for(part=CDR(term);!(NULL_P(part));part=CDR(part)) {
    new=demodulate_fully(CAR(part),EOL,BOOL_F);
    SET_CDR(resend,cons(new,EOL));
    if(resend==res) {
      if(NUMBER_P(new)) {
        if(MAKINUM(65535)>new) {
          str=GLOBAL(var_strength_global);
        }
        else {
          str=GLOBAL(const_strength_global);
        }
      }
      else {
        str=CAR(new);
      }
    }
    else
    if(NUMBER_P(new)) {
      if(MAKINUM(65535)>new) {
        str=sum_fun_strengths(GLOBAL(var_strength_global),str);
      }
      else {
        str=sum_fun_strengths(GLOBAL(const_strength_global),str);
      }
    }
    else {
      str=sum_fun_strengths(CAR(new),str);
    }
    resend=CDR(resend);
  }
  SET_CAR(res,create_new_fun_pos_object(CAR(term),str));
  return res;
}

SCM factor_sos(soslist)
SCM soslist;
{
  SCM sospart,cl,purecl,litinflist,newlitinflist;

  cl=EOL;
  purecl=EOL;
  litinflist=EOL;
  newlitinflist=EOL;
  if(GLOBAL(display_info_level_global)>=MAKINUM(50)) {
    newline(cur_output_port());
    display(const_49,cur_output_port());
    newline(cur_output_port());
  }
  for(sospart=soslist;!(NULL_P(sospart));sospart=CDR(sospart)) {
    cl=CAR(sospart);
    purecl=CDR(cl);
    litinflist=CAR(CDR(CDR(CAR(cl))));
    if(!(NFALSEP(GLOBAL(hyper_strategy_flag_global)))||NFALSEP(positive_cl_pred_(purecl))) {
      newlitinflist=map1(factor_sos_fn50,litinflist);
      factor(newlitinflist,cl);
    }
  }
  if(GLOBAL(display_info_level_global)>=MAKINUM(50)) {
    newline(cur_output_port());
    display(const_50,cur_output_port());
    return newline(cur_output_port());
  }
  else
    return UNSPECIFIED;
}

SCM factor_sos_fn50(inf)
SCM inf;
{
  return cons(BOOL_T,cons((NFALSEP(GLOBAL(ordered_factor_flag_global)) ? NOT(SBOOL(ZERO_P(MAKINUM(2)&CAR(inf)))) : BOOL_F),inf));
}

SCM factor(infolist,fullcl)
SCM infolist,fullcl;
{
  SCM inf_fullcl_pr,fullcl__1,infolist__2;

  if(!(NULL_P(CDR(CDR(fullcl))))&&(!(NFALSEP(GLOBAL(hyper_strategy_flag_global)))||((!(NFALSEP(GLOBAL(neg_hyper_strategy_flag_global)))&&NFALSEP(positive_cl_pred_(CDR(fullcl))))||(NFALSEP(GLOBAL(neg_hyper_strategy_flag_global))&&NFALSEP(negative_cl_pred_(CDR(fullcl))))))) {
    GLOBAL(locfactorpool_global)=EOL;
    GLOBAL(factorpool_global)=EOL;
    GLOBAL(subs_factor_derived_flag_global)=BOOL_F;
    factor_aux(infolist,fullcl);
    for(;!(NULL_P(GLOBAL(factorpool_global))||NFALSEP(GLOBAL(foundflag_global)));) {
      if(!(NULL_P(CDR(GLOBAL(factorpool_global))))) {
        GLOBAL(factorpool_global)=filter_map(factor_fn53,GLOBAL(factorpool_global));
      }
      inf_fullcl_pr=CAR(GLOBAL(factorpool_global));
      fullcl__1=CDR(inf_fullcl_pr);
      infolist__2=CAR(inf_fullcl_pr);
      GLOBAL(factorpool_global)=CDR(GLOBAL(factorpool_global));
      if(0) {
        handle_derived_inf_cl_pair_aux(inf_fullcl_pr,BOOL_T);
        factor_aux(infolist__2,fullcl__1);
      }
      else
      if(NULL_P(CDR(CDR(fullcl__1)))||!(NFALSEP(havealready_clause_pred_(CAR(fullcl__1),CDR(fullcl__1))))) {
        handle_derived_inf_cl_pair_aux(inf_fullcl_pr,BOOL_T);
        factor_aux(infolist__2,fullcl__1);
      }
    }
    return UNSPECIFIED;
  }
  else
    return UNSPECIFIED;
}

SCM factor_fn53(cl1)
SCM cl1;
{
  if(NFALSEP(member_if_inst1(cl1,factor_fn54,GLOBAL(factorpool_global))))
    return BOOL_F;
  else
    return cl1;
}

SCM factor_fn54(cl1,cl2)
SCM cl1,cl2;
{
  return SBOOL(!(cl1==cl2)&&NFALSEP(subsumed_clause_pred_(CDR(cl1),CDR(cl2))));
}

SCM factor_aux(infolist,fullclause)
SCM infolist,fullclause;
{
  SCM new_var2,res,ylit,ylitinf,cl_part,inf_part,lit_ordnr,xlit,xlitinf,xlitnr,slow_cl_part,slow_info_part,slow_lit_ordnr,clause,clinf,maxvar,history,slow_list_ordnr;

  clause=CDR(fullclause);
  clinf=CAR(fullclause);
  maxvar=give_cl_maxvar(clinf);
  history=CAR(CDR(CDR(CDR(CDR(CDR(CAR(fullclause)))))));
  slow_list_ordnr=MAKINUM(0);
  GLOBAL(subs_factor_derived_flag_global)=BOOL_F;
  GLOBAL(locfactorpool_global)=EOL;
  for(slow_cl_part=clause,slow_info_part=infolist,slow_lit_ordnr=MAKINUM(1);
      !(NULL_P(slow_cl_part));
      slow_cl_part=CDR(slow_cl_part),slow_info_part=CDR(slow_info_part),slow_lit_ordnr=MAKINUM(1+INUM(slow_lit_ordnr))) {
    xlit=CAR(slow_cl_part);
    xlitinf=CAR(slow_info_part);
    xlitnr=CAR(CDR(xlitinf));
    if(!(BOOL_T==xlitnr))
      for(cl_part=CDR(slow_cl_part),inf_part=CDR(slow_info_part),lit_ordnr=MAKINUM(1);
          !(NULL_P(cl_part));
          cl_part=CDR(cl_part),inf_part=CDR(inf_part),lit_ordnr=MAKINUM(1+INUM(lit_ordnr))) {
        ylit=CAR(cl_part);
        ylitinf=CAR(inf_part);
        if(!(xlitnr==CAR(CDR(ylitinf)))||((xlitnr==BOOL_F)||NFALSEP(GLOBAL(hyper_strategy_flag_global)))) {
          GLOBAL(used_demodulators_global)=EOL;
          if(NFALSEP(factor_unify_ordinary(ylit,xlit))) {
            res=subst_deco_cl(remove_at_place(cl_part,clause),merge_infos(slow_info_part,inf_part,infolist),BOOL_F,BOOL_T);
            clear_x_vars_and_touched_excl_(maxvar);
            fac_vars_set_global=BOOL_F;
            var_set_flag_global=BOOL_F;
            alt_var_set_flag_global=BOOL_F;
            if(NULL_P(GLOBAL(used_demodulators_global))) {
              history=cons(factor_symb,cons(MAKINUM(0),cons(history,cons(slow_list_ordnr,cons(lit_ordnr,EOL)))));
            }
            else {
              history=cons(factor_symb,cons(MAKINUM(0),cons(history,cons(slow_list_ordnr,cons(lit_ordnr,cons(cons(demod_symb,GLOBAL(used_demodulators_global)),EOL))))));
            }
            res=handle_derived_inf_cl_pair(res,history,BOOL_T,BOOL_F);
            if(NFALSEP(GLOBAL(foundflag_global))) {
              slow_cl_part=GLOBAL(listofnull_global);
              cl_part=GLOBAL(listofnull_global);
            }
            else {
              new_var2=NOT(res);
              if(NFALSEP(new_var2)) ;
              else
              if(NFALSEP(subsumed_clause_pred_(fullclause,CDR(res)))) {
                GLOBAL(subs_factor_derived_flag_global)=BOOL_T;
                fac_vars_set_global=BOOL_F;
                var_set_flag_global=BOOL_F;
                GLOBAL(locfactorpool_global)=EOL;
                GLOBAL(factorpool_global)=cons(res,GLOBAL(factorpool_global));
                slow_cl_part=GLOBAL(listofnull_global);
                cl_part=GLOBAL(listofnull_global);
              }
              else {
                GLOBAL(locfactorpool_global)=cons(res,GLOBAL(locfactorpool_global));
              }
            }
          }
          else {
            if(NFALSEP(fac_vars_set_global)||(NFALSEP(var_set_flag_global)||NFALSEP(alt_var_set_flag_global))) {
              clear_x_vars_and_touched_excl_(maxvar);
              fac_vars_set_global=BOOL_F;
              var_set_flag_global=BOOL_F;
              alt_var_set_flag_global=BOOL_F;
            }
          }
        }
      }
  }
  GLOBAL(factorpool_global)=append2(GLOBAL(factorpool_global),GLOBAL(locfactorpool_global));
  return UNSPECIFIED;
}

SCM merge_infos(kept_infolist_place,removed_infolist_place,infolist)
SCM kept_infolist_place,removed_infolist_place,infolist;
{
  SCM new_var2,ipart,new_orig,res,resend;

  new_orig=append2(CAR(kept_infolist_place),CDR(CDR(CAR(removed_infolist_place))));
  res=cons(EOL,EOL);
  resend=res;
  for(ipart=infolist;!(NULL_P(ipart));ipart=CDR(ipart)) {
    new_var2=SBOOL(ipart==removed_infolist_place);
    if(NFALSEP(new_var2)) ;
    else
    if(ipart==kept_infolist_place) {
      SET_CDR(resend,cons(new_orig,EOL));
      resend=CDR(resend);
    }
    else {
      SET_CDR(resend,cons(CAR(ipart),EOL));
      resend=CDR(resend);
    }
  }
  return CDR(res);
}

SCM make_unique_answer_pair(pr,history,ans_inf)
SCM pr,history,ans_inf;
{
  SCM part,infpart,cl,inf,alit1inf,caseans,case_pr,tmp_pr1,tmp_pr,fact_pr,alit1pl,alit2pl;

  alit1pl=member_if(make_unique_answer_pair_fn57,CDR(pr));
  alit2pl=member_if(make_unique_answer_pair_fn58,CDR(alit1pl));
  if(!(NFALSEP(alit1pl)))
    return pr;
  else
  if(!(NFALSEP(ans_computable_lit_pred_(CAR(alit1pl)))))
    return const_51;
  else
  if(!(NFALSEP(alit2pl)))
    return pr;
  else
  if(!(NFALSEP(ans_computable_lit_pred_(CAR(alit2pl)))))
    return const_52;
  else
  if(NFALSEP(term_list_equal_strong_pred_(CDR(CAR(alit1pl)),CDR(CAR(alit2pl)))))
    return pr;
  else {
    cl=CDR(pr);
    inf=CAR(pr);
    alit1inf=EOL;
    caseans=EOL;
    case_pr=BOOL_F;
    tmp_pr1=EOL;
    tmp_pr=EOL;
    fact_pr=BOOL_F;
    if(!(NFALSEP(ans_computable_term_pred_(CAR(ans_inf),BOOL_T)))) {
      case_pr=const_53;
    }
    else {
      tmp_pr1=make_rest_inf_cl(cl,CAR(alit1pl),inf);
      tmp_pr=make_rest_inf_cl(CDR(tmp_pr1),CAR(alit2pl),CAR(tmp_pr1));
      for(part=cl,infpart=inf;
          !(part==alit1pl);
          part=CDR(part),infpart=CDR(infpart)) ;
      alit1inf=CAR(infpart);
      caseans=subst_deco_term_nodemodulate(((CAR(CDR(alit1inf))==CAR(CDR(ans_inf))) ? cons(GLOBAL(ans_pred_nr_global),cons(cons(GLOBAL(if_fun_nr_global),cons(CAR(ans_inf),cons(CAR(CDR(CAR(alit2pl))),cons(CAR(CDR(CAR(alit1pl))),EOL)))),EOL)) : cons(GLOBAL(ans_pred_nr_global),cons(cons(GLOBAL(if_fun_nr_global),cons(CAR(ans_inf),cons(CAR(CDR(CAR(alit1pl))),cons(CAR(CDR(CAR(alit2pl))),EOL)))),EOL))),BOOL_T);
      case_pr=cons(cons(alit1inf,CAR(tmp_pr)),cons(caseans,CDR(tmp_pr)));
    }
    if(NFALSEP(factor_unify_ordinary(CAR(alit1pl),CAR(alit2pl)))) {
      fact_pr=subst_deco_cl(CDR(tmp_pr1),CAR(tmp_pr1),BOOL_F,fac_vars_set_global);
    }
    if(NFALSEP(fac_vars_set_global)) {
      clear_x_vars_and_touched_excl_(CAR(CDR(CDR(ans_inf))));
      clear_y_vars_and_touched_excl_(CAR(CDR(CDR(CDR(ans_inf)))));
    }
    if(NFALSEP(case_pr)&&NFALSEP(fact_pr)) {
      GLOBAL(res)=handle_derived_inf_cl_pair(case_pr,history,BOOL_F,BOOL_F);
      return fact_pr;
    }
    else
    if(NFALSEP(case_pr))
      return case_pr;
    else
    if(NFALSEP(fact_pr))
      return fact_pr;
    else
      return const_54;
  }
}

SCM make_unique_answer_pair_fn58(x)
SCM x;
{
  return answer_lit_pred_(x);
}

SCM make_unique_answer_pair_fn57(x)
SCM x;
{
  return answer_lit_pred_(x);
}

SCM several_answer_literals_pred_(purecl)
SCM purecl;
{
  SCM part,nr;

  nr=MAKINUM(0);
  for(part=purecl;!(NULL_P(part)||(nr==MAKINUM(2)));part=CDR(part))
    if(NFALSEP(answer_lit_pred_(CAR(part)))) {
      nr=MAKINUM(1+INUM(nr));
    }
  return SBOOL(nr==MAKINUM(2));
}

SCM ans_computable_lit_pred_(lit)
SCM lit;
{
  SCM new_var2;

  if(NULL_P(GLOBAL(ans_prohibited_funnrs_global))) {
    if(NULL_P(GLOBAL(ans_prohibited_prednrs_global)))
      new_var2=SBOOL(NULL_P(GLOBAL(ans_prohibited_constnrs_global)));
    else
      new_var2=BOOL_F;
  }
  else
    new_var2=BOOL_F;
  if(NFALSEP(new_var2))
    return new_var2;
  else
    return ans_computable_term_pred_(CAR(CDR(lit)),BOOL_F);
}

SCM ans_computable_term_pred_(x,litflag)
SCM x,litflag;
{
  SCM new_var2,tmp_var1,tmp_var2;

tailrecursion:
  if(PAIR_P(x)) {
    if(GLOBAL(if_fun_nr_global)==(MAKINUM(534773760)&CAR(x))) {
      if(NFALSEP(ans_computable_term_pred_(CAR(x),BOOL_T))) {
        if(NFALSEP(ans_computable_term_pred_(CAR(CDR(x)),BOOL_F))) {
          tmp_var1=CAR(CDR(CDR(x)));
          tmp_var2=BOOL_F;
          x=tmp_var1;
          litflag=tmp_var2;
          goto tailrecursion;
        }
        else
          return BOOL_F;
      }
      else
        return BOOL_F;
    }
    else
    if(!(NFALSEP(memq(MAKINUM(266338304)&CAR(x),(NFALSEP(litflag) ? GLOBAL(ans_prohibited_prednrs_global) : GLOBAL(ans_prohibited_funnrs_global))))))
      return every_pred_(ans_computable_term_pred__fn60,CDR(x));
    else
      return BOOL_F;
  }
  else {
    if(NUMBER_P(x))
      new_var2=SBOOL(x<=MAKINUM(65535));
    else
      new_var2=BOOL_F;
    if(NFALSEP(new_var2))
      return new_var2;
    else
      return NOT(memq(x,GLOBAL(ans_prohibited_constnrs_global)));
  }
}

SCM ans_computable_term_pred__fn60(y)
SCM y;
{
  return ans_computable_term_pred_(y,BOOL_F);
}

SCM sort_clause(clause,pair_flag)
SCM clause,pair_flag;
{
  return sort_clause_aux(clause,length(clause),pair_flag);
}

SCM sort_clause_aux(cl,len,pair_flag)
SCM cl,len,pair_flag;
{
  SCM l1,l2,s;

  if(len<MAKINUM(2))
    return cl;
  else
  if(len==MAKINUM(2)) {
    if(NFALSEP((NFALSEP(pair_flag) ? _grtr__fun_ordering_pred_(CAR(CDR(CAR(CDR(cl)))),CAR(CDR(CAR(cl)))) : _grtr__fun_ordering_pred_(CAR(CAR(CDR(cl))),CAR(CAR(cl))))))
      return cons(CAR(CDR(cl)),cons(CAR(cl),EOL));
    else
      return cl;
  }
  else {
    l1=MAKINUM(INUM(len)/2);
    l2=MAKINUM(INUM(len)-INUM(l1));
    s=split_list(cl,l1);
    return sort_merge_clauses(sort_clause_aux(CAR(s),l1,pair_flag),sort_clause_aux(CDR(s),l2,pair_flag),pair_flag);
  }
}

SCM sort_merge_clauses(cl1,cl2,pair_flag)
SCM cl1,cl2,pair_flag;
{
  if(NULL_P(cl1))
    return cl2;
  else
  if(NULL_P(cl2))
    return cl1;
  else
  if(NFALSEP(pair_flag)&&NFALSEP(_grtr__fun_ordering_pred_(CAR(CDR(CAR(cl1))),CAR(CDR(CAR(cl2))))))
    return cons(CAR(cl1),sort_merge_clauses(CDR(cl1),cl2,BOOL_T));
  else
  if(!(NFALSEP(pair_flag))&&NFALSEP(_grtr__fun_ordering_pred_(CAR(CAR(cl1)),CAR(CAR(cl2)))))
    return cons(CAR(cl1),sort_merge_clauses(CDR(cl1),cl2,BOOL_F));
  else
    return cons(CAR(cl2),sort_merge_clauses(cl1,CDR(cl2),pair_flag));
}

SCM lit_weight(lit)
SCM lit;
{
  if(!(NFALSEP(GLOBAL(classical_synth_stratflag_global)))&&NFALSEP(answer_pred_pred_(CAR(lit))))
    return MAKINUM(0);
  else
    return composite_weight(lit);
}

SCM answer_pred_pred_(pred)
SCM pred;
{
  return SBOOL(GLOBAL(ans_pred_nr_global)==(MAKINUM(534773760)&pred));
}

SCM countable_pred_pred_(pred)
SCM pred;
{
  if(NFALSEP(GLOBAL(classical_synth_stratflag_global)))
    return BOOL_T;
  else
    return NOT(answer_pred_pred_(pred));
}

SCM answer_lit_pred_(lit)
SCM lit;
{
  return SBOOL(GLOBAL(ans_pred_nr_global)==(MAKINUM(534773760)&CAR(lit)));
}

SCM composite_weight(comp)
SCM comp;
{
  SCM el,size;

  size=(MAKINUM(2016)&CAR(comp));
  if(MAKINUM(2016)==size) {
    size=MAKINUM(1);
    comp=CDR(comp);
    for(;!(NULL_P(comp));) {
      el=CAR(comp);
      if(NUMBER_P(el)) {
        size=MAKINUM(1+INUM(size));
      }
      else {
        size=MAKINUM(INUM(size)+INUM(composite_weight(el)));
      }
      comp=CDR(comp);
    }
    return size;
  }
  else
    return MAKINUM(INUM(size)>>5);
}

SCM predsymb_bit(pred)
SCM pred;
{
  return VECTOR_REF(GLOBAL(predsymb_bit_vector_global),MAKINUM(INUM(pred)>>21));
}

SCM make_raw_inf_cl_pair(xcl,ycl,xinf,yinf)
SCM xcl,ycl,xinf,yinf;
{
  SCM new_xrest,new_yrest;

  new_yrest=subst_deco_cl(ycl,yinf,MAKINUM(2),yvars_set_flag_global);
  if(NFALSEP(new_yrest)) {
    new_xrest=subst_deco_cl(xcl,xinf,MAKINUM(1),xvars_set_flag_global);
    if(NFALSEP(new_xrest))
      return cons(my_append_excl_(CAR(new_yrest),CAR(new_xrest)),my_append_excl_(CDR(new_yrest),CDR(new_xrest)));
    else
      return BOOL_F;
  }
  else
    return BOOL_F;
}

SCM make_rest_inf_cl(cl,lit,inf)
SCM cl,lit,inf;
{
  SCM clrest__2,passed_cl__1,clrest,infrest,passed_cl,passed_inf;

  if(NFALSEP(inf)) {
    if(NULL_P(CDR(cl)))
      return cons(EOL,EOL);
    else {
      passed_cl=EOL;
      passed_inf=EOL;
      for(clrest=cl,infrest=inf;
          !(CAR(clrest)==lit);
          clrest=CDR(clrest),infrest=CDR(infrest)) {
        passed_cl=cons(CAR(clrest),passed_cl);
        passed_inf=cons(CAR(infrest),passed_inf);
      }
      return cons(my_append_excl_(passed_inf,CDR(infrest)),my_append_excl_(passed_cl,CDR(clrest)));
    }
  }
  else
  if(NULL_P(CDR(cl)))
    return cons(EOL,EOL);
  else {
    passed_cl__1=EOL;
    for(clrest__2=cl;!(CAR(clrest__2)==lit);clrest__2=CDR(clrest__2)) {
      passed_cl__1=cons(CAR(clrest__2),passed_cl__1);
    }
    return cons(BOOL_F,my_append_excl_(passed_cl__1,CDR(clrest__2)));
  }
}

SCM subst_deco_cl(cl,clinf,nr,vars_set_flag)
SCM cl,clinf,nr,vars_set_flag;
{
  SCM clres,clresend,infres,infresend,changed_flag,lit,litinf,litinflstpart;

  if(NULL_P(cl))
    return cons(EOL,EOL);
  else {
    clres=cons(EOL,EOL);
    clresend=clres;
    infres=cons(EOL,EOL);
    infresend=infres;
    changed_flag=BOOL_T;
    lit=EOL;
    litinf=EOL;
    litinflstpart=clinf;
    for(;!(NULL_P(cl));) {
      lit=CAR(cl);
      if(NFALSEP(clinf)) {
        litinf=CAR(clinf);
      }
      else {
        litinf=EOL;
      }
      if((NFALSEP(vars_set_flag)&&ZERO_P(MAKINUM(65536)&CAR(lit)))||NFALSEP(GLOBAL(new_demodulators_flag_global))) {
        if(NFALSEP(answer_pred_pred_(CAR(lit)))) {
          lit=subst_deco_term_nodemodulate(lit,BOOL_T);
          changed_flag=BOOL_T;
        }
        else {
          lit=subst_deco_term(lit,BOOL_T);
          changed_flag=BOOL_T;
        }
      }
      else {
        lit=copy_nonground_term(lit);
        changed_flag=BOOL_F;
      }
      if(NFALSEP(lit)) {
        SET_CDR(clresend,cons(lit,EOL));
        clresend=CDR(clresend);
        if(NFALSEP(nr)) {
          SET_CDR(infresend,cons(cons(changed_flag,cons(nr,litinf)),EOL));
        }
        else {
          SET_CDR(infresend,cons(cons(changed_flag,CDR(litinf)),EOL));
        }
        infresend=CDR(infresend);
        cl=CDR(cl);
        if(NFALSEP(clinf)) {
          clinf=CDR(clinf);
        }
      }
      else {
        cl=EOL;
        clres=BOOL_F;
      }
    }
    if(NFALSEP(clres))
      return cons(CDR(infres),CDR(clres));
    else
      return BOOL_F;
  }
}

SCM tautology_pure_cl_pred_(list__1)
SCM list__1;
{
tailrecursion:
  if(NULL_P(list__1)||NULL_P(CDR(list__1)))
    return BOOL_F;
  else
  if(NFALSEP(member_polarity_lit(BOOL_F,CAR(list__1),CDR(list__1))))
    return BOOL_T;
  else {
    list__1=CDR(list__1);
    goto tailrecursion;
  }
}

SCM remove_double_lits_excl_(inf_list,lit_list,pos_only_flag)
SCM inf_list,lit_list,pos_only_flag;
{
  SCM lit_list_part,inf_list_part,tmp;

  if(NULL_P(lit_list))
    return cons(inf_list,lit_list);
  else {
    lit_list_part=lit_list;
    inf_list_part=inf_list;
    tmp=EOL;
    for(;!(NULL_P(CDR(lit_list_part)));) {
      tmp=CDR(lit_list_part);
      if((!(NFALSEP(pos_only_flag))||NFALSEP((!(NFALSEP(GLOBAL(neg_hyper_strategy_flag_global))) ? SBOOL(!(!(ZERO_P(MAKINUM(268435456)&CAR(CAR(tmp)))))) : SBOOL(!(ZERO_P(MAKINUM(268435456)&CAR(CAR(tmp))))))))&&NFALSEP(member_polarity_lit(BOOL_T,CAR(tmp),CDR(tmp)))) {
        SET_CDR(lit_list_part,CDR(tmp));
        SET_CDR(inf_list_part,CDR(CDR(inf_list_part)));
      }
      else {
        lit_list_part=tmp;
        inf_list_part=CDR(inf_list_part);
      }
    }
    if((!(NFALSEP(pos_only_flag))||NFALSEP((!(NFALSEP(GLOBAL(neg_hyper_strategy_flag_global))) ? SBOOL(!(!(ZERO_P(MAKINUM(268435456)&CAR(CAR(lit_list)))))) : SBOOL(!(ZERO_P(MAKINUM(268435456)&CAR(CAR(lit_list))))))))&&NFALSEP(member_polarity_lit(BOOL_T,CAR(lit_list),CDR(lit_list))))
      return cons(CDR(inf_list),CDR(lit_list));
    else
      return cons(inf_list,lit_list);
  }
}

SCM unit_handle_cl_excl_(inf_list,lit_list,history)
SCM inf_list,lit_list,history;
{
  SCM leafcl,leafclpure,leafclinf,rescdr,rescddr,part,tmp_lit_lst,lit,tmp_inf_list,inf,checkres,litnr,orig_lit_list,lit_list__1,inf_list__2,lit_list_part,inf_list_part,subsume_flag,foreign_checkres_flag,cut_flag;

  if(NULL_P(lit_list))
    return cons(history,cons(inf_list,lit_list));
  else {
    orig_lit_list=copy_list(lit_list);
    lit_list__1=cons(EOL,lit_list);
    inf_list__2=cons(EOL,inf_list);
    lit_list_part=lit_list__1;
    inf_list_part=inf_list__2;
    subsume_flag=BOOL_F;
    foreign_checkres_flag=BOOL_F;
    cut_flag=BOOL_F;
    GLOBAL(cut_clauses_global)=EOL;
    GLOBAL(used_demodulators_global)=EOL;
    for(litnr=MAKINUM(1);!(NULL_P(CDR(lit_list_part))||(NFALSEP(subsume_flag)&&NFALSEP(GLOBAL(discr_tree_subsume_stratflag_global))));litnr=MAKINUM(1+INUM(litnr))) {
      cut_flag=BOOL_F;
      foreign_checkres_flag=BOOL_F;
      tmp_lit_lst=CDR(lit_list_part);
      lit=CAR(tmp_lit_lst);
      tmp_inf_list=CDR(inf_list_part);
      inf=CAR(tmp_inf_list);
      checkres=BOOL_F;
      if(NFALSEP(answer_lit_pred_(lit))) {
        checkres=BOOL_F;
      }
      else {
        checkres=check_discr_tree(GLOBAL(discr_tree_global),lit);
      }
      if(!(NFALSEP(answer_lit_pred_(lit)))) {
        for(part=GLOBAL(discr_tree_list_global);!(NULL_P(part)||NFALSEP(checkres));part=CDR(part)) {
          checkres=check_discr_tree(CAR(part),lit);
          if(!(NFALSEP(checkres)&&(!(NULL_P(CDR(checkres)))&&(!(NULL_P(CDR(CDR(checkres))))&&!((MAKINUM(268435456)&CAR(lit))==(MAKINUM(268435456)&CAR(CAR(CDR(CAR(CDR(CDR(checkres)))))))))))) {
            checkres=BOOL_F;
          }
        }
        if(NFALSEP(checkres)) {
          foreign_checkres_flag=BOOL_T;
        }
      }
      if(!(NFALSEP(checkres))&&NFALSEP(commutative_fun_pred_(CAR(lit)))) {
        checkres=check_discr_tree(GLOBAL(discr_tree_global),cons(CAR(lit),cons(CAR(CDR(CDR(lit))),cons(CAR(CDR(lit)),CDR(CDR(CDR(lit)))))));
      }
      if(NFALSEP(checkres)) {
        rescdr=CDR(checkres);
        if(NULL_P(rescdr))
          rescddr=EOL;
        else
          rescddr=CDR(rescdr);
        if(NULL_P(rescddr)) {
          if(NFALSEP(CAR(inf))) {
            if(!(ZERO_P(MAKINUM(268435456)&CAR(lit)))) {
              if(NULL_P(rescdr)||NULL_P(CAR(rescdr))) {
                SET_CDR(lit,CDR(CAR(checkres)));
                SET_CDR(checkres,cons(lit,rescddr));
              }
              else {
                SET_CAR(tmp_lit_lst,CAR(rescdr));
              }
            }
            else
            if(NULL_P(CAR(checkres))) {
              SET_CDR(lit,CDR(CAR(rescdr)));
              SET_CAR(checkres,lit);
            }
            else {
              SET_CAR(tmp_lit_lst,CAR(checkres));
            }
          }
        }
        else {
          leafcl=CAR(rescddr);
          leafclpure=CDR(leafcl);
          leafclinf=CAR(leafcl);
          if((MAKINUM(268435456)&CAR(lit))==(MAKINUM(268435456)&CAR(CAR(leafclpure)))) {
            subsume_flag=BOOL_T;
            GLOBAL(subsuming_clause_global)=leafcl;
          }
          else {
            if(NFALSEP(GLOBAL(hyper_strategy_flag_global))) {
              if(!(ZERO_P(MAKINUM(268435456)&CAR(lit)))||NFALSEP(positive_cl_pred_(orig_lit_list))) {
                cut_flag=BOOL_T;
                GLOBAL(cut_clauses_global)=cons(leafcl,GLOBAL(cut_clauses_global));
              }
            }
            else {
              cut_flag=BOOL_T;
              GLOBAL(cut_clauses_global)=cons(leafcl,GLOBAL(cut_clauses_global));
            }
          }
        }
      }
      if(!(NFALSEP(subsume_flag))) {
        if(NFALSEP(cut_flag)) {
          SET_CDR(lit_list_part,CDR(tmp_lit_lst));
          SET_CDR(inf_list_part,CDR(tmp_inf_list));
          if(NFALSEP(GLOBAL(hyper_strategy_flag_global))||NFALSEP(GLOBAL(int_logic_flag_global))) {
            history=make_hyper_history(CDR(CAR(GLOBAL(cut_clauses_global))),orig_lit_list,CAR(CDR(CDR(CDR(CDR(CDR(CAR(CAR(GLOBAL(cut_clauses_global))))))))),history,cons(MAKINUM(1<<16)|MAKINUM(INUM(GLOBAL(litinf_ordernr_mask_global)&MAKINUM(0))^0),EOL),CDR(CDR(inf)),MAKINUM(1),litnr);
          }
          else {
            if(NULL_P(GLOBAL(used_demodulators_global)))
              history=cons(binres_symb,cons(MAKINUM(0),cons(cons(literal_symb,cons(CAR(CDR(CDR(CDR(CDR(CDR(CAR(CAR(GLOBAL(cut_clauses_global))))))))),cons(MAKINUM(1),EOL))),cons(cons(literal_symb,cons(history,cons(litnr,EOL))),EOL))));
            else
              history=cons(binres_symb,cons(MAKINUM(0),cons(cons(literal_symb,cons(CAR(CDR(CDR(CDR(CDR(CDR(CAR(CAR(GLOBAL(cut_clauses_global))))))))),cons(MAKINUM(1),EOL))),cons(cons(literal_symb,cons(history,cons(litnr,EOL))),cons(cons(demod_symb,GLOBAL(used_demodulators_global)),EOL)))));
          }
        }
        else {
          lit_list_part=tmp_lit_lst;
          inf_list_part=tmp_inf_list;
        }
      }
    }
    if(NFALSEP(subsume_flag)&&NFALSEP(GLOBAL(discr_tree_subsume_stratflag_global))) {
      GLOBAL(forward_subsumed_unit_nr_global)=MAKINUM(1+INUM(GLOBAL(forward_subsumed_unit_nr_global)));
      if(GLOBAL(display_info_level_global)>=MAKINUM(80)) {
        newline(cur_output_port());
        display(const_55,cur_output_port());
        newline(cur_output_port());
        print_clause(GLOBAL(subsuming_clause_global));
        newline(cur_output_port());
      }
      else
      if(NFALSEP(GLOBAL(display_info_char_flag_global)))
        display(const_56,cur_output_port());
      return BOOL_F;
    }
    else {
      if(!(NULL_P(GLOBAL(cut_clauses_global)))) {
        GLOBAL(simple_unit_cutoff_nr_global)=MAKINUM(1+INUM(GLOBAL(simple_unit_cutoff_nr_global)));
      }
      if(!(NULL_P(GLOBAL(cut_clauses_global)))&&(GLOBAL(display_info_level_global)>=MAKINUM(80))) {
        newline(cur_output_port());
        display(const_57,cur_output_port());
        newline(cur_output_port());
        for_each1(unit_handle_cl_excl__fn62,GLOBAL(cut_clauses_global));
      }
      return cons(history,cons(CDR(inf_list__2),CDR(lit_list__1)));
    }
  }
}

SCM unit_handle_cl_excl__fn62(x)
SCM x;
{
  print_clause(x);
  return newline(cur_output_port());
}

SCM full_unit_cutoff_excl_(inf_list,fullcl)
SCM inf_list,fullcl;
{
  SCM new_var2,clauseinf,lit_list,len,res,history;

  clauseinf=CAR(fullcl);
  lit_list=CDR(fullcl);
  len=MAKINUM(10000);
  res=EOL;
  history=CAR(CDR(CDR(CDR(CDR(CDR(clauseinf))))));
  len=length(lit_list);
  if(!(NFALSEP(GLOBAL(int_logic_flag_global)))&&(!(NFALSEP(GLOBAL(hyper_strategy_flag_global)))||NFALSEP(positive_cl_pred_(lit_list)))) {
    res=full_unit_cutoff_double_excl_(clauseinf,inf_list,lit_list,history);
    history=CAR(res);
    inf_list=CAR(CDR(res));
    lit_list=CDR(CDR(res));
  }
  if(!(len==length(lit_list))) {
    GLOBAL(double_unit_cutoff_nr_global)=MAKINUM(1+INUM(GLOBAL(double_unit_cutoff_nr_global)));
    clauseinf=make_clause_info(lit_list,history);
    fullcl=make_kept_clause(clauseinf,cons(inf_list,lit_list));
    clauseinf=CAR(fullcl);
    lit_list=CDR(fullcl);
  }
  len=MAKINUM(10000);
  for(;!((len==length(lit_list))||NFALSEP(empty_cl_pred_(lit_list)));) {
    len=length(lit_list);
    for_each1(rename_x_to_y_term_excl_,lit_list);
    res=full_unit_cutoff_aux_excl_(clauseinf,inf_list,lit_list,history);
    history=CAR(res);
    inf_list=CAR(CDR(res));
    lit_list=CDR(CDR(res));
    if(NFALSEP(empty_cl_pred_(lit_list))) {
      clauseinf=cons(MAKINUM(0),cons(MAKINUM(0),cons(EOL,cons(MAKINUM(0),cons(MAKINUM(0),cons(history,EOL))))));
    }
    else {
      new_var2=SBOOL(len==length(lit_list));
      if(NFALSEP(new_var2)) ;
      else {
        GLOBAL(full_unit_cutoff_nr_global)=MAKINUM(1+INUM(GLOBAL(full_unit_cutoff_nr_global)));
        clauseinf=make_clause_info(lit_list,history);
        fullcl=make_kept_clause(clauseinf,cons(inf_list,lit_list));
        clauseinf=CAR(fullcl);
        lit_list=CDR(fullcl);
      }
    }
  }
  for_each1(rename_y_to_x_term_excl_,lit_list);
  return cons(inf_list,cons(clauseinf,lit_list));
}

SCM full_unit_cutoff_aux_excl_(clauseinf,inf_list,lit_list,history)
SCM clauseinf,inf_list,lit_list,history;
{
  SCM i__3,i,xlit,xfun,part,new_var2,compl_yfunpure,cand_list,ylit,yinf,discr_testclause,commylit,yfun,tmp,cutflag,ylitnr,orig_lit_list,lit_list_part,inf_list_part,yclmaxvar,lit_list__1,inf_list__2,lit_list_beg,inf_list_beg,has_only_local_only_vars_flag,unit_flag,cut_flag;

  if(NFALSEP(empty_cl_pred_(lit_list))||NULL_P(GLOBAL(unit_alist_global)))
    return cons(history,cons(inf_list,lit_list));
  else {
    orig_lit_list=copy_list(lit_list);
    lit_list_part=lit_list;
    inf_list_part=inf_list;
    yclmaxvar=give_cl_maxvar(clauseinf);
    lit_list__1=cons(EOL,lit_list);
    inf_list__2=cons(EOL,inf_list);
    lit_list_beg=lit_list__1;
    inf_list_beg=inf_list__2;
    has_only_local_only_vars_flag=BOOL_F;
    unit_flag=unit_cl_pred_(lit_list_part);
    cut_flag=BOOL_F;
    for(ylitnr=MAKINUM(1);!(NULL_P(lit_list_part));ylitnr=MAKINUM(1+INUM(ylitnr))) {
      ylit=CAR(lit_list_part);
      yinf=CAR(inf_list_part);
      discr_testclause=EOL;
      commylit=EOL;
      yfun=CAR(ylit);
      tmp=EOL;
      cutflag=BOOL_F;
      if(NFALSEP(commutative_fun_pred_(yfun))) {
        commylit=cons(yfun,cons(CAR(CDR(CDR(ylit))),cons(CAR(CDR(ylit)),CDR(CDR(CDR(ylit))))));
      }
      if(NFALSEP(cutflag)||(NFALSEP(answer_lit_pred_(ylit))||((NFALSEP(GLOBAL(hyper_strategy_flag_global))&&(!(!(ZERO_P(MAKINUM(268435456)&yfun)))&&!(NFALSEP(positive_cl_pred_(orig_lit_list)))))||!(NFALSEP(has_some_local_only_vars_pred_(ylit)))))) {
        lit_list__1=lit_list_part;
        inf_list__2=inf_list_part;
        lit_list_part=CDR(lit_list_part);
        inf_list_part=CDR(inf_list_part);
      }
      else {
        compl_yfunpure=MAKINUM(268435456^INUM(MAKINUM(534773760)&yfun));
        cand_list=assq(compl_yfunpure,GLOBAL(unit_alist_global));
        if(NFALSEP(cand_list)) {
          cand_list=CDR(cand_list);
        }
        else {
          cand_list=EOL;
        }
        new_var2=unit_flag;
        if(NFALSEP(new_var2))
          has_only_local_only_vars_flag=new_var2;
        else
          has_only_local_only_vars_flag=has_only_local_only_vars_pred_(ylit);
        for(part=cand_list;!(NULL_P(part)||NFALSEP(cutflag));part=CDR(part)) {
          xlit=CAR(CDR(CAR(part)));
          xfun=CAR(xlit);
          if((NFALSEP(has_only_local_only_vars_flag)||ZERO_P(MAKINUM(65536)&xfun))&&NULL_P(CDR(CDR(CAR(part))))) {
            if(GLOBAL(display_info_level_global)>MAKINUM(110)) {
              newline(cur_output_port());
              display(const_59,cur_output_port());
              newline(cur_output_port());
              debug_print_lit(xlit);
              newline(cur_output_port());
              debug_print_lit(ylit);
              newline(cur_output_port());
              newline(cur_output_port());
              for(i=MAKINUM(1);!(i>MAKINUM(10));i=MAKINUM(1+INUM(i))) {
                display(i,cur_output_port());
                display(const_60,cur_output_port());
                display(STBL_VECTOR_REF(_star_var_val_table_star__velts0,i),cur_output_port());
                display(const_61,cur_output_port());
              }
              newline(cur_output_port());
              for(i__3=MAKINUM(1+256);!(INUM(i__3)>(11+256));i__3=MAKINUM(1+INUM(i__3))) {
                display(i__3,cur_output_port());
                display(const_62,cur_output_port());
                display(STBL_VECTOR_REF(_star_var_val_table_star__velts0,i__3),cur_output_port());
                display(const_63,cur_output_port());
              }
              newline(cur_output_port());
            }
            if(NFALSEP(resolve_unify_cutoff(xfun,yfun,xlit,ylit))) {
              GLOBAL(cut_clauses_global)=cons(CAR(part),GLOBAL(cut_clauses_global));
              cutflag=BOOL_T;
            }
            else
            if(!(NULL_P(commylit))) {
              if(NFALSEP(yvars_set_flag_global))
                clear_y_vars_excl_(yclmaxvar);
              if(NFALSEP(xvars_set_flag_global))
                clear_x_vars_excl_(give_cl_maxvar(CAR(CAR(part))));
              if(NFALSEP(resolve_unify_cutoff(xfun,yfun,xlit,ylit))) {
                GLOBAL(cut_clauses_global)=cons(CAR(part),GLOBAL(cut_clauses_global));
                part=GLOBAL(listofnull_global);
              }
            }
            if(NFALSEP(yvars_set_flag_global))
              clear_y_vars_excl_(yclmaxvar);
            if(NFALSEP(xvars_set_flag_global))
              clear_x_vars_excl_(give_cl_maxvar(CAR(CAR(part))));
          }
        }
        if(NFALSEP(cutflag)) {
          lit_list_part=CDR(lit_list_part);
          inf_list_part=CDR(inf_list_part);
          SET_CDR(lit_list__1,lit_list_part);
          SET_CDR(inf_list__2,inf_list_part);
          if(NFALSEP(GLOBAL(hyper_strategy_flag_global))||NFALSEP(GLOBAL(int_logic_flag_global))) {
            history=make_hyper_history(CDR(CAR(GLOBAL(cut_clauses_global))),orig_lit_list,CAR(CDR(CDR(CDR(CDR(CDR(CAR(CAR(GLOBAL(cut_clauses_global))))))))),history,cons(MAKINUM(1<<16)|MAKINUM(INUM(GLOBAL(litinf_ordernr_mask_global)&MAKINUM(0))^0),EOL),CDR(CDR(yinf)),MAKINUM(1),ylitnr);
          }
          else {
            if(NULL_P(GLOBAL(used_demodulators_global)))
              history=cons(binres_symb,cons(MAKINUM(0),cons(cons(literal_symb,cons(CAR(CDR(CDR(CDR(CDR(CDR(CAR(CAR(GLOBAL(cut_clauses_global))))))))),cons(MAKINUM(1),EOL))),cons(cons(literal_symb,cons(history,cons(ylitnr,EOL))),EOL))));
            else
              history=cons(binres_symb,cons(MAKINUM(0),cons(cons(literal_symb,cons(CAR(CDR(CDR(CDR(CDR(CDR(CAR(CAR(GLOBAL(cut_clauses_global))))))))),cons(MAKINUM(1),EOL))),cons(cons(literal_symb,cons(history,cons(ylitnr,EOL))),cons(cons(demod_symb,GLOBAL(used_demodulators_global)),EOL)))));
          }
        }
        else {
          lit_list__1=lit_list_part;
          inf_list__2=inf_list_part;
          lit_list_part=CDR(lit_list_part);
          inf_list_part=CDR(inf_list_part);
        }
      }
    }
    if(!(NULL_P(GLOBAL(cut_clauses_global)))&&(GLOBAL(display_info_level_global)>=MAKINUM(65))) {
      newline(cur_output_port());
      display(const_58,cur_output_port());
      newline(cur_output_port());
      for_each1(full_unit_cutoff_aux_excl__fn64,GLOBAL(cut_clauses_global));
    }
    return cons(history,cons(CDR(inf_list_beg),CDR(lit_list_beg)));
  }
}

SCM full_unit_cutoff_aux_excl__fn64(x)
SCM x;
{
  print_clause(x);
  return newline(cur_output_port());
}

SCM full_unit_cutoff_double_excl_(clauseinf,inf_list,lit_list,history)
SCM clauseinf,inf_list,lit_list,history;
{
  SCM ylit,yinf,discr_testclause,yfun,tmp,cutflag,ylitnr,orig_lit_list,lit_list_part,inf_list_part,yclmaxvar,lit_list__1,inf_list__2,lit_list_beg,inf_list_beg,unit_flag,passed_lits,cut_flag;

  if(NFALSEP(empty_cl_pred_(lit_list))||NULL_P(CDR(lit_list)))
    return cons(history,cons(inf_list,lit_list));
  else {
    orig_lit_list=copy_list(lit_list);
    lit_list_part=lit_list;
    inf_list_part=inf_list;
    yclmaxvar=give_cl_maxvar(clauseinf);
    lit_list__1=cons(EOL,lit_list);
    inf_list__2=cons(EOL,inf_list);
    lit_list_beg=lit_list__1;
    inf_list_beg=inf_list__2;
    unit_flag=unit_cl_pred_(lit_list_part);
    passed_lits=EOL;
    cut_flag=BOOL_F;
    for(ylitnr=MAKINUM(1);!(NULL_P(lit_list_part));ylitnr=MAKINUM(1+INUM(ylitnr))) {
      ylit=CAR(lit_list_part);
      yinf=CAR(inf_list_part);
      discr_testclause=EOL;
      yfun=CAR(ylit);
      tmp=EOL;
      cutflag=BOOL_F;
      if(NFALSEP(answer_lit_pred_(ylit))||(NFALSEP(GLOBAL(hyper_strategy_flag_global))&&(!(!(ZERO_P(MAKINUM(268435456)&yfun)))&&!(NFALSEP(positive_cl_pred_(orig_lit_list)))))) {
        passed_lits=cons(ylit,passed_lits);
        lit_list__1=lit_list_part;
        inf_list__2=inf_list_part;
        lit_list_part=CDR(lit_list_part);
        inf_list_part=CDR(inf_list_part);
      }
      else {
        discr_testclause=cons(cons(MAKINUM(268435456^INUM(MAKINUM(534773760)&yfun)),CDR(ylit)),cons(EOL,append2(passed_lits,CDR(lit_list_part))));
        GLOBAL(nonunit_discr_flag_global)=BOOL_T;
        GLOBAL(overdouble_discr_flag_global)=BOOL_F;
        if(NULL_P(CAR(GLOBAL(nonunit_discr_tree_global)))) {
          tmp=BOOL_F;
        }
        else {
          tmp=check_discr_tree_part(CDR(CAR(CAR(GLOBAL(nonunit_discr_tree_global)))),discr_testclause,EOL);
        }
        GLOBAL(nonunit_discr_flag_global)=BOOL_F;
        GLOBAL(overdouble_discr_flag_global)=BOOL_F;
        if(NFALSEP(tmp)) {
          cutflag=BOOL_T;
          GLOBAL(cut_clauses_global)=cons(CAR(tmp),GLOBAL(cut_clauses_global));
          lit_list_part=CDR(lit_list_part);
          inf_list_part=CDR(inf_list_part);
          SET_CDR(lit_list__1,lit_list_part);
          SET_CDR(inf_list__2,inf_list_part);
          if(NFALSEP(GLOBAL(hyper_strategy_flag_global))||NFALSEP(GLOBAL(int_logic_flag_global))) {
            history=make_hyper_history(CDR(CAR(GLOBAL(cut_clauses_global))),orig_lit_list,CAR(CDR(CDR(CDR(CDR(CDR(CAR(CAR(GLOBAL(cut_clauses_global))))))))),history,cons(MAKINUM(1<<16)|MAKINUM(INUM(GLOBAL(litinf_ordernr_mask_global)&MAKINUM(0))^0),EOL),CDR(CDR(yinf)),MAKINUM(1),ylitnr);
          }
          else {
            if(NULL_P(GLOBAL(used_demodulators_global)))
              history=cons(binres_symb,cons(MAKINUM(0),cons(cons(literal_symb,cons(CAR(CDR(CDR(CDR(CDR(CDR(CAR(CAR(GLOBAL(cut_clauses_global))))))))),cons(MAKINUM(1),EOL))),cons(cons(literal_symb,cons(history,cons(ylitnr,EOL))),EOL))));
            else
              history=cons(binres_symb,cons(MAKINUM(0),cons(cons(literal_symb,cons(CAR(CDR(CDR(CDR(CDR(CDR(CAR(CAR(GLOBAL(cut_clauses_global))))))))),cons(MAKINUM(1),EOL))),cons(cons(literal_symb,cons(history,cons(ylitnr,EOL))),cons(cons(demod_symb,GLOBAL(used_demodulators_global)),EOL)))));
          }
        }
        else {
          passed_lits=cons(ylit,passed_lits);
          lit_list__1=lit_list_part;
          inf_list__2=inf_list_part;
          lit_list_part=CDR(lit_list_part);
          inf_list_part=CDR(inf_list_part);
        }
      }
    }
    if(!(NULL_P(GLOBAL(cut_clauses_global)))&&(GLOBAL(display_info_level_global)>=MAKINUM(65))) {
      newline(cur_output_port());
      display(const_64,cur_output_port());
      newline(cur_output_port());
      for_each1(full_unit_cutoff_double_excl__fn66,GLOBAL(cut_clauses_global));
    }
    return cons(history,cons(CDR(inf_list_beg),CDR(lit_list_beg)));
  }
}

SCM full_unit_cutoff_double_excl__fn66(x)
SCM x;
{
  print_clause(x);
  return newline(cur_output_port());
}

SCM has_some_local_only_vars_pred_(cterm)
SCM cterm;
{
  SCM part,success_flag,el;

  success_flag=BOOL_F;
  el=EOL;
  if(ZERO_P(MAKINUM(65536)&CAR(cterm))) {
    for(part=CDR(cterm);!(NULL_P(part)||NFALSEP(success_flag));part=CDR(part)) {
      el=CAR(part);
      if(!(NUMBER_P(el))) {
        if(NFALSEP(has_some_local_only_vars_pred_(el))) {
          success_flag=BOOL_T;
        }
      }
      else
      if((MAKINUM(65535)>el)&&!(ZERO_P(MAKINUM(16384)&el))) {
        success_flag=BOOL_T;
      }
    }
    return success_flag;
  }
  else
    return BOOL_F;
}

SCM has_only_local_only_vars_pred_(cterm)
SCM cterm;
{
  SCM part,fail_flag,el;

  fail_flag=BOOL_F;
  el=EOL;
  if(ZERO_P(MAKINUM(65536)&CAR(cterm))) {
    for(part=CDR(cterm);!(NULL_P(part)||NFALSEP(fail_flag));part=CDR(part)) {
      el=CAR(part);
      if(!(NUMBER_P(el))) {
        if(!(NFALSEP(has_only_local_only_vars_pred_(el)))) {
          fail_flag=BOOL_T;
        }
      }
      else
      if((MAKINUM(65535)>el)&&ZERO_P(MAKINUM(16384)&el)) {
        fail_flag=BOOL_T;
      }
    }
    return NOT(fail_flag);
  }
  else
    return BOOL_T;
}

SCM member_polarity_lit(samesgn_flag,lit,lst)
SCM samesgn_flag,lit,lst;
{
  SCM fun,comm_flag,res;

  if(NULL_P(lst))
    return BOOL_F;
  else {
    if(NFALSEP(samesgn_flag))
      fun=(MAKINUM(534904831)&CAR(lit));
    else
      fun=(MAKINUM(534904831)&MAKINUM(268435456^INUM(CAR(lit))));
    comm_flag=commutative_fun_pred_(fun);
    res=BOOL_F;
    for(;!(NULL_P(lst));)
      if((fun==(MAKINUM(534904831)&CAR(CAR(lst))))&&(NFALSEP(term_list_equal_strong_pred_(CDR(lit),CDR(CAR(lst))))||(NFALSEP(comm_flag)&&NFALSEP(swapped_term_list_strong_equal_pred_(CDR(lit),CDR(CAR(lst))))))) {
        res=lst;
        lst=EOL;
      }
      else {
        lst=CDR(lst);
      }
    return res;
  }
}

SCM swapped_term_list_strong_equal_pred_(x,y)
SCM x,y;
{
  return term_list_equal_strong_pred_(cons(CAR(CDR(x)),cons(CAR(x),CDR(CDR(x)))),cons(CAR(CDR(y)),cons(CAR(y),CDR(CDR(y)))));
}

SCM insert_to_subsumption_list_excl_(len,strength,fullcl)
SCM len,strength,fullcl;
{
  SCM part,lenlist,place;

  lenlist=EOL;
  place=EOL;
  for(part=GLOBAL(subsumption_list_global);!(NULL_P(CDR(part))||(CAR(CAR(CDR(part)))>=len));part=CDR(part)) ;
  if(!(NULL_P(CDR(part)))&&(CAR(CAR(CDR(part)))==len)) {
    lenlist=CAR(CDR(part));
  }
  else {
    SET_CDR(part,cons(cons(len,EOL),CDR(part)));
    lenlist=CAR(CDR(part));
  }
  place=CDR(lenlist);
  for(;!(NULL_P(place)||((MAKINUM(131071)&CAR(CAR(CAR(place))))<=strength));) {
    lenlist=place;
    place=CDR(place);
  }
  SET_CDR(lenlist,cons(fullcl,place));
  return UNSPECIFIED;
}

SCM insert_unit_alist(fullcl)
SCM fullcl;
{
  SCM purepred,part;

  purepred=(MAKINUM(534773760)&CAR(CAR(CDR(fullcl))));
  part=assq(purepred,GLOBAL(unit_alist_global));
  if(NFALSEP(part)) {
    SET_CDR(part,cons(fullcl,CDR(part)));
    return UNSPECIFIED;
  }
  else {
    GLOBAL(unit_alist_global)=cons(cons(purepred,cons(fullcl,EOL)),GLOBAL(unit_alist_global));
    return UNSPECIFIED;
  }
}

SCM insert_partial_discr_tree_excl_(tree,term,funflag,endflag,depth)
SCM tree,term,funflag,endflag,depth;
{
  SCM place;

  if(NUMBER_P(term)) {
    place=EOL;
    if(NFALSEP(funflag)) {
      term=(MAKINUM(266338304)&term);
      place=assq(term,CAR(tree));
      if(!(NFALSEP(place))) {
        SET_CAR(tree,cons(cons(term,cons(EOL,EOL)),CAR(tree)));
        place=CAR(CAR(tree));
      }
    }
    else
    if(MAKINUM(65535)>term) {
      term=MAKINUM(0);
      if(NULL_P(CDR(tree))) {
        SET_CDR(tree,cons(EOL,EOL));
      }
      tree=CDR(tree);
      place=assq(term,CDR(tree));
      if(!(NFALSEP(place))) {
        SET_CDR(tree,cons(cons(term,cons(EOL,EOL)),CDR(tree)));
        place=CAR(CDR(tree));
      }
    }
    else {
      if(NULL_P(CDR(tree))) {
        SET_CDR(tree,cons(EOL,EOL));
      }
      tree=CDR(tree);
      place=assq(term,CAR(tree));
      if(!(NFALSEP(place))) {
        SET_CAR(tree,cons(cons(term,cons(EOL,EOL)),CAR(tree)));
        place=CAR(CAR(tree));
      }
    }
    if(NFALSEP(endflag))
      return apply(GLOBAL(insert_partial_discr_tree_leaf_excl_),CDR(place),listofnull);
    else
      return CDR(place);
  }
  else {
    tree=insert_partial_discr_tree_excl_(tree,CAR(term),BOOL_T,BOOL_F,depth);
    term=CDR(term);
    for(;!(NULL_P(term));) {
      tree=insert_partial_discr_tree_excl_(tree,CAR(term),BOOL_F,(NFALSEP(endflag) ? SBOOL(NULL_P(CDR(term))) : BOOL_F),MAKINUM(INUM(depth)-1));
      term=CDR(term);
    }
    return tree;
  }
}

SCM check_discr_tree(tree,lit)
SCM tree,lit;
{
  SCM fun,res;

  fun=CAR(lit);
  res=BOOL_F;
  GLOBAL(ground_check_res_global)=BOOL_F;
  GLOBAL(nonunit_discr_flag_global)=BOOL_F;
  tree=assq(MAKINUM(266338304)&fun,CAR(tree));
  if(NFALSEP(tree)) {
    res=check_discr_tree_part(CDR(tree),CDR(lit),EOL);
  }
  else {
    res=BOOL_F;
  }
  if(!(NFALSEP(res))&&NFALSEP(commutative_fun_pred_(fun))) {
    res=check_discr_tree_part(CDR(tree),cons(CAR(CDR(CDR(lit))),cons(CAR(CDR(lit)),CDR(CDR(CDR(lit))))),EOL);
  }
  if(NFALSEP(res))
    return res;
  else
    return GLOBAL(ground_check_res_global);
}

SCM insert_clause_discr_tree_excl_(tree,fullcl,litinfolist,insert_flag)
SCM tree,fullcl,litinfolist,insert_flag;
{
  SCM clpart__1,infpart__2,clpart,infpart,cl;

  cl=CDR(fullcl);
  if(NULL_P(CDR(cl))&&NFALSEP(insert_flag)) {
    GLOBAL(cur_lit_global)=CAR(cl);
    GLOBAL(cur_clause_global)=fullcl;
    insert_discr_tree_excl_(tree,GLOBAL(cur_lit_global),BOOL_F,BOOL_T,BOOL_T);
    SET_CAR(cl,GLOBAL(cur_lit_global));
    return UNSPECIFIED;
  }
  else
  if(!(NFALSEP(insert_flag))) {
    for(clpart=cl,infpart=litinfolist;
        !(NULL_P(clpart));
        clpart=CDR(clpart),infpart=CDR(infpart))
      if(NFALSEP(CAR(CAR(infpart)))&&(!(ZERO_P(MAKINUM(65536)&CAR(CAR(clpart))))&&!(NFALSEP(answer_pred_pred_(CAR(CAR(clpart))))))) {
        GLOBAL(cur_lit_global)=CAR(clpart);
        GLOBAL(cur_clause_global)=BOOL_F;
        insert_discr_tree_excl_(tree,GLOBAL(cur_lit_global),BOOL_F,BOOL_T,BOOL_T);
        SET_CAR(clpart,GLOBAL(cur_lit_global));
      }
    return UNSPECIFIED;
  }
  else {
    insert_discr_tree_nonunit_excl_(GLOBAL(nonunit_discr_tree_global),fullcl);
    for(clpart__1=cl,infpart__2=litinfolist;
        !(NULL_P(clpart__1));
        clpart__1=CDR(clpart__1),infpart__2=CDR(infpart__2))
      if(NFALSEP(CAR(CAR(infpart__2)))&&(!(ZERO_P(MAKINUM(65536)&CAR(CAR(clpart__1))))&&!(NFALSEP(answer_pred_pred_(CAR(CAR(clpart__1))))))) {
        GLOBAL(cur_lit_global)=CAR(clpart__1);
        GLOBAL(cur_clause_global)=BOOL_F;
        insert_discr_tree_excl_(tree,GLOBAL(cur_lit_global),BOOL_F,BOOL_T,BOOL_T);
        SET_CAR(clpart__1,GLOBAL(cur_lit_global));
      }
    return UNSPECIFIED;
  }
}

SCM insert_discr_tree_excl_(tree,term,funflag,endflag,unitflag)
SCM tree,term,funflag,endflag,unitflag;
{
  SCM place;

  if(NUMBER_P(term)) {
    place=EOL;
    if(NFALSEP(funflag)) {
      if(NFALSEP(unitflag)) {
        term=(MAKINUM(266338304)&term);
      }
      else {
        term=(MAKINUM(534773760)&term);
      }
      place=assq(term,CAR(tree));
      if(!(NFALSEP(place))) {
        SET_CAR(tree,cons(cons(term,cons(EOL,EOL)),CAR(tree)));
        place=CAR(CAR(tree));
      }
    }
    else
    if(MAKINUM(65535)>term) {
      term=(MAKINUM(8191)&term);
      if(NULL_P(CDR(tree))) {
        SET_CDR(tree,cons(EOL,EOL));
      }
      tree=CDR(tree);
      place=assq(term,CDR(tree));
      if(!(NFALSEP(place))) {
        SET_CDR(tree,cons(cons(term,cons(EOL,EOL)),CDR(tree)));
        place=CAR(CDR(tree));
      }
    }
    else {
      if(NULL_P(CDR(tree))) {
        SET_CDR(tree,cons(EOL,EOL));
      }
      tree=CDR(tree);
      place=assq(term,CAR(tree));
      if(!(NFALSEP(place))) {
        SET_CAR(tree,cons(cons(term,cons(EOL,EOL)),CAR(tree)));
        place=CAR(CAR(tree));
      }
    }
    if(NFALSEP(endflag)) {
      if(NFALSEP(unitflag))
        return insert_discr_tree_leaf_excl_(CDR(place));
      else
        return insert_nonunit_discr_tree_leaf_excl_(CDR(place));
    }
    else
      return CDR(place);
  }
  else {
    tree=insert_discr_tree_excl_(tree,CAR(term),BOOL_T,BOOL_F,unitflag);
    term=CDR(term);
    for(;!(NULL_P(term));) {
      tree=insert_discr_tree_excl_(tree,CAR(term),BOOL_F,(NFALSEP(endflag) ? SBOOL(NULL_P(CDR(term))) : BOOL_F),unitflag);
      term=CDR(term);
    }
    return tree;
  }
}

SCM insert_discr_tree_leaf_excl_(place)
SCM place;
{
  if(ZERO_P(MAKINUM(268435456)&CAR(GLOBAL(cur_lit_global)))) {
    if(!(NULL_P(CAR(place)))) {
      GLOBAL(cur_lit_global)=CAR(place);
    }
    if(NULL_P(CDR(place))) {
      if(NFALSEP(GLOBAL(cur_clause_global))) {
        SET_CDR(place,cons(EOL,cons(GLOBAL(cur_clause_global),EOL)));
      }
    }
    else {
      if(!(NULL_P(CAR(CDR(place))))) {
        if(!(ZERO_P(MAKINUM(65536)&CAR(CAR(CDR(place)))))) {
          SET_CDR(GLOBAL(cur_lit_global),CDR(CAR(CDR(place))));
        }
      }
      if(NFALSEP(GLOBAL(cur_clause_global))&&NULL_P(CDR(CDR(place)))) {
        SET_CDR(CDR(place),cons(GLOBAL(cur_clause_global),EOL));
      }
    }
    SET_CAR(place,GLOBAL(cur_lit_global));
    return UNSPECIFIED;
  }
  else {
    if(!(NULL_P(CAR(place)))) {
      if(!(ZERO_P(MAKINUM(65536)&CAR(CAR(place))))) {
        SET_CDR(GLOBAL(cur_lit_global),CDR(CAR(place)));
      }
    }
    if(NULL_P(CDR(place))) {
      if(NFALSEP(GLOBAL(cur_clause_global))) {
        SET_CDR(place,cons(GLOBAL(cur_lit_global),cons(GLOBAL(cur_clause_global),EOL)));
        return UNSPECIFIED;
      }
      else {
        SET_CDR(place,cons(GLOBAL(cur_lit_global),EOL));
        return UNSPECIFIED;
      }
    }
    else {
      if(NULL_P(CAR(CDR(place)))) {
        if(NFALSEP(GLOBAL(cur_clause_global))||!(ZERO_P(MAKINUM(65536)&CAR(GLOBAL(cur_lit_global))))) {
          SET_CAR(CDR(place),GLOBAL(cur_lit_global));
        }
      }
      else {
        GLOBAL(cur_lit_global)=CAR(CDR(place));
      }
      if(NFALSEP(GLOBAL(cur_clause_global))&&NULL_P(CDR(CDR(place)))) {
        SET_CDR(CDR(place),cons(GLOBAL(cur_clause_global),EOL));
        return UNSPECIFIED;
      }
      else
        return UNSPECIFIED;
    }
  }
}

SCM check_discr_tree_part(tree,part,cont)
SCM tree,part,cont;
{
  SCM tmp,el,vars,res,var,val,tmp_var1,tmp_var2,new_var2;

tailrecursion:
  if(NULL_P(part)) {
    if(NULL_P(cont))
      return check_discr_tree_leaf(tree);
    else
    if(NULL_P(CAR(cont))) {
      if(NULL_P(CDR(cont)))
        return BOOL_F;
      else {
        new_var2=check_discr_tree_part(tree,cons(CAR(CDR(cont)),EOL),EOL);
        if(NFALSEP(new_var2))
          return new_var2;
        else {
          tmp_var1=EOL;
          tmp_var2=cons(EOL,CDR(CDR(cont)));
          part=tmp_var1;
          cont=tmp_var2;
          goto tailrecursion;
        }
      }
    }
    else {
      tmp_var1=cont;
      tmp_var2=EOL;
      part=tmp_var1;
      cont=tmp_var2;
      goto tailrecursion;
    }
  }
  else {
    el=CAR(part);
    vars=CDR(tree);
    res=BOOL_F;
    var=BOOL_F;
    val=BOOL_F;
    if(!(NULL_P(vars))) {
      vars=CDR(vars);
    }
    if(NUMBER_P(el)) {
      if(MAKINUM(65535)>el) {
        el=(MAKINUM(8191)&el);
        for(;!(NULL_P(vars)||NFALSEP(res));) {
          var=CAR(CAR(vars));
          val=STBL_VECTOR_REF(_star_var_val_table_star__velts0,var);
          if(val==MAKINUM(99999999)) {
            STBL_VECTOR_SET(_star_var_val_table_star__velts0,var,el);
            res=check_discr_tree_part(CDR(CAR(vars)),CDR(part),cont);
            STBL_VECTOR_SET(_star_var_val_table_star__velts0,var,val);
          }
          else
          if(val==el) {
            res=check_discr_tree_part(CDR(CAR(vars)),CDR(part),cont);
          }
          vars=CDR(vars);
        }
        return res;
      }
      else {
        tree=CDR(tree);
        if(NULL_P(tree)) {
          tree=BOOL_F;
        }
        else {
          tree=assq(el,CAR(tree));
        }
        if(NFALSEP(tree)) {
          tree=check_discr_tree_part(CDR(tree),CDR(part),cont);
        }
        if(NFALSEP(GLOBAL(nonunit_discr_flag_global))) {
          if(NFALSEP(tree)&&!(NFALSEP(CAR(tree)))) {
            if(NFALSEP(GLOBAL(overdouble_discr_flag_global))) {
              GLOBAL(nonunit_res_global)=cons(CDR(tree),GLOBAL(nonunit_res_global));
            }
            tree=BOOL_F;
          }
        }
        else
        if(NFALSEP(tree)&&(NULL_P(CDR(tree))||NULL_P(CDR(CDR(tree))))) {
          GLOBAL(ground_check_res_global)=tree;
          tree=BOOL_F;
        }
        if(NFALSEP(tree))
          return tree;
        else {
          for(;!(NULL_P(vars)||NFALSEP(res));) {
            var=CAR(CAR(vars));
            val=STBL_VECTOR_REF(_star_var_val_table_star__velts0,var);
            if(val==MAKINUM(99999999)) {
              STBL_VECTOR_SET(_star_var_val_table_star__velts0,var,el);
              res=check_discr_tree_part(CDR(CAR(vars)),CDR(part),cont);
              STBL_VECTOR_SET(_star_var_val_table_star__velts0,var,val);
            }
            else
            if(val==el) {
              res=check_discr_tree_part(CDR(CAR(vars)),CDR(part),cont);
            }
            vars=CDR(vars);
          }
          return res;
        }
      }
    }
    else
    if(NULL_P(el)) {
      tmp_var1=EOL;
      tmp_var2=part;
      part=tmp_var1;
      cont=tmp_var2;
      goto tailrecursion;
    }
    else {
      if(NFALSEP(GLOBAL(discr_depth_first_global))) {
        tree=assq(MAKINUM(534773760)&CAR(el),CAR(tree));
        if(NFALSEP(tree)) {
          tmp=EOL;
          if(NULL_P(cont)) {
            tmp=CDR(part);
          }
          else {
            tmp=append2(CDR(part),cont);
          }
          tree=check_discr_tree_part(CDR(tree),CDR(el),tmp);
        }
      }
      else {
        tree=BOOL_F;
      }
      if(NFALSEP(GLOBAL(nonunit_discr_flag_global))) {
        if(NFALSEP(tree)&&!(NFALSEP(CAR(tree)))) {
          if(NFALSEP(GLOBAL(overdouble_discr_flag_global))) {
            GLOBAL(nonunit_res_global)=cons(CDR(tree),GLOBAL(nonunit_res_global));
          }
          tree=BOOL_F;
        }
      }
      else
      if(NFALSEP(tree)&&(NULL_P(CDR(tree))||NULL_P(CDR(CDR(tree))))) {
        GLOBAL(ground_check_res_global)=tree;
        tree=BOOL_F;
      }
      if(NFALSEP(tree))
        return tree;
      else {
        for(;!(NULL_P(vars)||NFALSEP(res));) {
          var=CAR(CAR(vars));
          val=STBL_VECTOR_REF(_star_var_val_table_star__velts0,var);
          if(val==MAKINUM(99999999)) {
            STBL_VECTOR_SET(_star_var_val_table_star__velts0,var,el);
            res=check_discr_tree_part(CDR(CAR(vars)),CDR(part),cont);
            STBL_VECTOR_SET(_star_var_val_table_star__velts0,var,val);
          }
          else
          if(NFALSEP(GLOBAL(nonunit_discr_flag_global))) {
            if(NFALSEP(term_equal_strong_pred_(val,el))) {
              res=check_discr_tree_part(CDR(CAR(vars)),CDR(part),cont);
            }
          }
          else
          if(NFALSEP(term_equal_pred_(val,el))) {
            res=check_discr_tree_part(CDR(CAR(vars)),CDR(part),cont);
          }
          vars=CDR(vars);
        }
        if(NFALSEP(GLOBAL(discr_depth_first_global))||NFALSEP(res))
          return res;
        else {
          tree=assq(MAKINUM(534773760)&CAR(el),CAR(tree));
          if(NFALSEP(tree)) {
            if(NULL_P(cont)) {
              cont=CDR(part);
            }
            else {
              cont=append2(CDR(part),cont);
            }
            tmp_var1=CDR(tree);
            tmp_var2=CDR(el);
            tree=tmp_var1;
            part=tmp_var2;
            goto tailrecursion;
          }
          else
            return UNSPECIFIED;
        }
      }
    }
  }
}

SCM check_discr_tree_leaf(tree)
SCM tree;
{
  if(NFALSEP(GLOBAL(prohibit_subs_clnr_global))&&NFALSEP((NFALSEP(GLOBAL(nonunit_discr_flag_global)) ? SBOOL(NFALSEP(CAR(tree))&&(CAR(CDR(CDR(CDR(CDR(CAR(CAR(tree)))))))==GLOBAL(prohibit_subs_clnr_global))) : SBOOL(NFALSEP(CAR(tree))&&(!(NULL_P(CDR(tree)))&&(!(NULL_P(CDR(CDR(tree))))&&(CAR(CDR(CDR(CDR(CDR(CAR(CAR(CDR(CDR(tree)))))))))==GLOBAL(prohibit_subs_clnr_global))))))))
    return BOOL_F;
  else
  if(NFALSEP(GLOBAL(nonunit_discr_flag_global))) {
    if(NFALSEP(tree)&&!(NFALSEP(CAR(tree)))) {
      if(NFALSEP(GLOBAL(overdouble_discr_flag_global))) {
        GLOBAL(nonunit_res_global)=cons(CDR(tree),GLOBAL(nonunit_res_global));
      }
      return BOOL_F;
    }
    else
      return tree;
  }
  else
    return tree;
}

SCM insert_discr_tree_nonunit_excl_(tree,fullcl)
SCM tree,fullcl;
{
  SCM info,purecl,object;

  info=CAR(fullcl);
  purecl=CDR(fullcl);
  object=cons(MAKINUM(0),cons(CAR(purecl),cons(CAR(CDR(purecl)),EOL)));
  GLOBAL(cur_clause_global)=fullcl;
  return insert_discr_tree_excl_(tree,object,BOOL_F,BOOL_T,BOOL_F);
}

SCM insert_nonunit_discr_tree_leaf_excl_(place)
SCM place;
{
  if(NULL_P(CDR(CDR(CDR(GLOBAL(cur_clause_global)))))) {
    SET_CAR(place,GLOBAL(cur_clause_global));
    return UNSPECIFIED;
  }
  else {
    SET_CAR(place,BOOL_F);
    SET_CDR(place,cons(cons(MAKINUM(0),GLOBAL(cur_clause_global)),CDR(place)));
    return UNSPECIFIED;
  }
}

SCM check_nonunit_discr_tree(tree,purecl)
SCM tree,purecl;
{
  SCM clpart,new_var2,res,tmp,passed;

  res=BOOL_F;
  tmp=EOL;
  passed=EOL;
  GLOBAL(nonunit_discr_flag_global)=BOOL_T;
  GLOBAL(nonunit_res_global)=EOL;
  if(NULL_P(CAR(tree))) {
    res=BOOL_F;
  }
  else
  if(NULL_P(CDR(CDR(purecl)))) {
    GLOBAL(overdouble_discr_flag_global)=BOOL_F;
    new_var2=check_discr_tree_part(CDR(CAR(CAR(tree))),purecl,EOL);
    if(NFALSEP(new_var2))
      res=new_var2;
    else
      res=check_discr_tree_part(CDR(CAR(CAR(tree))),cons(CAR(CDR(purecl)),cons(CAR(purecl),EOL)),EOL);
  }
  else {
    GLOBAL(overdouble_discr_flag_global)=BOOL_T;
    for(clpart=purecl;!(NFALSEP(res)||NULL_P(clpart));clpart=CDR(clpart)) {
      if(!(NULL_P(passed))) {
        tmp=cons(CAR(clpart),cons(EOL,append2(passed,CDR(clpart))));
      }
      else {
        tmp=cons(CAR(clpart),cons(EOL,CDR(clpart)));
      }
      res=check_discr_tree_part(CDR(CAR(CAR(tree))),tmp,EOL);
      passed=cons(CAR(clpart),passed);
    }
  }
  GLOBAL(nonunit_discr_flag_global)=BOOL_F;
  GLOBAL(overdouble_discr_flag_global)=BOOL_F;
  return res;
}

SCM order_prohibit_litinfos(litinfolst,purecl)
SCM litinfolst,purecl;
{
  if(NFALSEP(GLOBAL(hyper_strategy_flag_global))) {
    if(NFALSEP(positive_cl_pred_(purecl))) {
      if(NFALSEP(GLOBAL(name_order_strategy_flag_global)))
        return name_order_litinfo(litinfolst,purecl);
      else
        return vdepth_order_litinfo(litinfolst,purecl);
    }
    else
      return litinfolst;
  }
  else
  if(NFALSEP(GLOBAL(name_order_strategy_flag_global)))
    return name_order_litinfo(litinfolst,purecl);
  else
  if(NFALSEP(GLOBAL(poslitpref_order_strategy_flag_global)))
    return poslit_order_litinfo(litinfolst,purecl);
  else
  if(NFALSEP(GLOBAL(firstlitpref_order_strategy_flag_global)))
    return firstlitpref_order_litinfo(litinfolst,purecl);
  else
  if(NFALSEP(GLOBAL(posweight_order_strategy_flag_global)))
    return posweight_order_litinfo(litinfolst,purecl);
  else
    return vdepth_order_litinfo(litinfolst,purecl);
}

SCM vdepth_order_litinfo(litinfolst,purecl)
SCM litinfolst,purecl;
{
  if(NFALSEP(GLOBAL(order_strategy_flag_global)))
    return vdepth_order_litinfo_aux(litinfolst,purecl);
  else
  if(NFALSEP(GLOBAL(ordered_paramodulation_flag_global)))
    return vdepth_order_litinfo_eq_only(litinfolst,purecl);
  else
    return litinfolst;
}

SCM order_equality_litinfo(litinfonr,lit)
SCM litinfonr,lit;
{
  if(NFALSEP(GLOBAL(order_equality_lex_strat_global)))
    return order_equality_litinfo_lex(litinfonr,lit);
  else
    return order_equality_litinfo_depth(litinfonr,lit);
}

SCM order_equality_litinfo_depth(litinfonr,lit)
SCM litinfonr,lit;
{
  SCM left,right,leftvars,rightvars;

  if(NFALSEP(GLOBAL(type_theory_stratflag_global)))
    left=CAR(CDR(CAR(CDR(lit))));
  else
    left=CAR(CDR(lit));
  if(NFALSEP(GLOBAL(type_theory_stratflag_global)))
    right=CAR(CDR(CDR(CAR(CDR(lit)))));
  else
    right=CAR(CDR(CDR(lit)));
  leftvars=make_var_depth_info(left);
  rightvars=make_var_depth_info(right);
  if(NUMBER_P(left)&&NUMBER_P(right)) {
    if(NUMBER_P(left)&&(left<=MAKINUM(65535))) {
      if(NUMBER_P(right)&&(right<=MAKINUM(65535)))
        return prohibit_left_para(prohibit_right_para(litinfonr));
      else
        return prohibit_right_para(litinfonr);
    }
    else
    if(NUMBER_P(right)&&(right<=MAKINUM(65535)))
      return prohibit_left_para(litinfonr);
    else
      return litinfonr;
  }
  else
  if(NUMBER_P(right)) {
    if(!(NUMBER_P(right)&&(right<=MAKINUM(65535)))||NFALSEP(assq(MAKINUM(8191)&right,leftvars)))
      return prohibit_right_para(litinfonr);
    else
      return litinfonr;
  }
  else
  if(NUMBER_P(left)) {
    if(!(NUMBER_P(left)&&(left<=MAKINUM(65535)))||NFALSEP(assq(MAKINUM(8191)&left,rightvars)))
      return prohibit_left_para(litinfonr);
    else
      return litinfonr;
  }
  else
  if((NFALSEP(vdepth__grtr__varinfolit_pred_(cons(leftvars,left),cons(rightvars,right)))&&((MAKINUM(63488)&CAR(left))>(MAKINUM(63488)&CAR(right))))||(NULL_P(rightvars)&&((MAKINUM(63488)&CAR(left))>(MAKINUM(63488)&CAR(right)))))
    return prohibit_right_para(litinfonr);
  else
  if((NFALSEP(vdepth__grtr__varinfolit_pred_(cons(rightvars,right),cons(leftvars,left)))&&((MAKINUM(63488)&CAR(right))>(MAKINUM(63488)&CAR(left))))||(NULL_P(leftvars)&&((MAKINUM(63488)&CAR(right))>(MAKINUM(63488)&CAR(left)))))
    return prohibit_left_para(litinfonr);
  else
    return litinfonr;
}

SCM order_equality_litinfo_lex(litinfonr,lit)
SCM litinfonr,lit;
{
  SCM left,right,leftvars,rightvars;

  if(NFALSEP(GLOBAL(type_theory_stratflag_global)))
    left=CAR(CDR(CAR(CDR(lit))));
  else
    left=CAR(CDR(lit));
  if(NFALSEP(GLOBAL(type_theory_stratflag_global)))
    right=CAR(CDR(CDR(CAR(CDR(lit)))));
  else
    right=CAR(CDR(CDR(lit)));
  leftvars=make_var_depth_info(left);
  rightvars=make_var_depth_info(right);
  if(NUMBER_P(left)&&NUMBER_P(right)) {
    if(NUMBER_P(left)&&(left<=MAKINUM(65535))) {
      if(NUMBER_P(right)&&(right<=MAKINUM(65535)))
        return prohibit_left_para(prohibit_right_para(litinfonr));
      else
        return prohibit_right_para(litinfonr);
    }
    else
    if(NUMBER_P(right)&&(right<=MAKINUM(65535)))
      return prohibit_left_para(litinfonr);
    else
    if(NFALSEP(lex_bigger_pred_(left,right)))
      return prohibit_right_para(litinfonr);
    else
    if(NFALSEP(lex_bigger_pred_(right,left)))
      return prohibit_left_para(litinfonr);
    else
      return litinfonr;
  }
  else
  if(NUMBER_P(right)) {
    if(!(NUMBER_P(right)&&(right<=MAKINUM(65535)))||NFALSEP(assq(MAKINUM(8191)&right,leftvars)))
      return prohibit_right_para(litinfonr);
    else
      return litinfonr;
  }
  else
  if(NUMBER_P(left)) {
    if(!(NUMBER_P(left)&&(left<=MAKINUM(65535)))||NFALSEP(assq(MAKINUM(8191)&left,rightvars)))
      return prohibit_left_para(litinfonr);
    else
      return litinfonr;
  }
  else
  if((length(right)>length(left))&&(NFALSEP(vdepth_superset_varinfolit_pred_(cons(leftvars,left),cons(rightvars,right)))&&NFALSEP(lex_bigger_pred_(left,right))))
    return prohibit_right_para(litinfonr);
  else
  if((length(left)>length(right))&&(NFALSEP(vdepth_superset_varinfolit_pred_(cons(rightvars,right),cons(leftvars,left)))&&NFALSEP(lex_bigger_pred_(right,left))))
    return prohibit_left_para(litinfonr);
  else
  if(!(NFALSEP(equal(length(left),length(right)))))
    return litinfonr;
  else
  if((NFALSEP(vdepth__grtr__varinfolit_pred_(cons(leftvars,left),cons(rightvars,right)))&&(((MAKINUM(63488)&CAR(left))>(MAKINUM(63488)&CAR(right)))&&NFALSEP(lex_bigger_pred_(left,right))))||(NULL_P(rightvars)&&(((MAKINUM(63488)&CAR(left))>(MAKINUM(63488)&CAR(right)))&&NFALSEP(lex_bigger_pred_(left,right)))))
    return prohibit_right_para(litinfonr);
  else
  if((NFALSEP(vdepth__grtr__varinfolit_pred_(cons(rightvars,right),cons(leftvars,left)))&&(((MAKINUM(63488)&CAR(right))>(MAKINUM(63488)&CAR(left)))&&NFALSEP(lex_bigger_pred_(right,left))))||(NULL_P(leftvars)&&(((MAKINUM(63488)&CAR(right))>(MAKINUM(63488)&CAR(left)))&&NFALSEP(lex_bigger_pred_(right,left)))))
    return prohibit_left_para(litinfonr);
  else
  if(NFALSEP(vdepth_superset_varinfolit_pred_(cons(leftvars,left),cons(rightvars,right)))&&NFALSEP(lex_bigger_pred_(left,right)))
    return prohibit_right_para(litinfonr);
  else
  if(NFALSEP(vdepth_superset_varinfolit_pred_(cons(rightvars,right),cons(leftvars,left)))&&NFALSEP(lex_bigger_pred_(right,left)))
    return prohibit_left_para(litinfonr);
  else
    return litinfonr;
}

SCM lex_bigger_pred_(left,right)
SCM left,right;
{
  SCM new_var3,lp__1,rp__2,new_var2,foundflag,res,lp,rp;

  foundflag=BOOL_F;
  res=BOOL_F;
  lp=EOL;
  rp=EOL;
  if(NUMBER_P(left)&&NUMBER_P(right)) {
    if(NUMBER_P(left)&&(left<=MAKINUM(65535)))
      return BOOL_F;
    else
    if(NUMBER_P(right)&&(right<=MAKINUM(65535)))
      return BOOL_F;
    else
    if(NFALSEP(lex_symbol_bigger_pred_(left,right)))
      return BOOL_T;
    else
    if(NFALSEP(lex_symbol_bigger_pred_(right,left)))
      return BOOL_F;
    else
    if(left==right)
      return BOOL_F;
    else {
      make_lex_symbol_bigger_excl_(left,right);
      return BOOL_T;
    }
  }
  else
  if(NUMBER_P(right)) {
    new_var2=NOT(SBOOL(NUMBER_P(right)&&(right<=MAKINUM(65535))));
    if(NFALSEP(new_var2))
      return new_var2;
    else
      return lex_occur_check_pred_(right,left);
  }
  else
  if(NUMBER_P(left))
    return BOOL_F;
  else
  if((MAKINUM(534773760)&CAR(left))==(MAKINUM(534773760)&CAR(right))) {
    for(lp__1=CDR(left),rp__2=CDR(right);
        !(NULL_P(lp__1)||NFALSEP(foundflag));
        lp__1=CDR(lp__1),rp__2=CDR(rp__2))
      if(NFALSEP(lex_bigger_pred_(CAR(lp__1),CAR(rp__2)))) {
        foundflag=BOOL_T;
        res=BOOL_T;
      }
      else {
        new_var3=term_equal_pred_(CAR(lp__1),CAR(rp__2));
        if(NFALSEP(new_var3))
          new_var2=new_var3;
        else
        if(NUMBER_P(CAR(rp__2))&&(CAR(rp__2)<=MAKINUM(65535))) {
          if(!(NUMBER_P(CAR(lp__1))))
            new_var2=lex_occur_check_pred_(CAR(rp__2),CAR(lp__1));
          else
            new_var2=BOOL_F;
        }
        else
          new_var2=BOOL_F;
        if(NFALSEP(new_var2)) ;
        else {
          foundflag=BOOL_T;
          res=BOOL_F;
        }
      }
    if(NFALSEP(res))
      return lex_bigger_than_subterms_pred_(left,right);
    else
      return BOOL_F;
  }
  else
  if((length(right)>length(left))&&(NFALSEP(lex_symbol_bigger_pred_(CAR(left),CAR(right)))&&NFALSEP(lex_bigger_than_subterms_pred_(left,right))))
    return BOOL_T;
  else
  if(NFALSEP(lex_symbol_bigger_pred_(CAR(left),CAR(right))))
    return lex_bigger_than_subterms_pred_(left,right);
  else
  if(NFALSEP(lex_symbol_bigger_pred_(CAR(right),CAR(left))))
    return BOOL_F;
  else {
    make_lex_symbol_bigger_excl_(CAR(left),CAR(right));
    return lex_bigger_than_subterms_pred_(left,right);
  }
}

SCM lex_occur_check_pred_(var,composite)
SCM var,composite;
{
  SCM el;

  composite=CDR(composite);
  for(;!(NULL_P(composite));) {
    el=CAR(composite);
    if(NUMBER_P(el)) {
      if(MAKINUM(65535)>el) {
        if(((NUMBER_P(el)&&(el<=MAKINUM(65535)))&&(var==(MAKINUM(8191)&el)))||(!(NUMBER_P(el))&&(ZERO_P(MAKINUM(65536)&CAR(el))&&NFALSEP(lex_occur_check_pred_(var,el))))) {
          composite=EOL;
          var=BOOL_T;
        }
        else {
          composite=CDR(composite);
        }
      }
      else {
        composite=CDR(composite);
      }
    }
    else
    if(ZERO_P(MAKINUM(65536)&CAR(el))&&NFALSEP(lex_occur_check_pred_(var,el))) {
      composite=EOL;
      var=BOOL_T;
    }
    else {
      composite=CDR(composite);
    }
  }
  return SBOOL(var==BOOL_T);
}

SCM lex_bigger_than_subterms_pred_(left,right)
SCM left,right;
{
  SCM new_var2;

  new_var2=SBOOL(NUMBER_P(right));
  if(NFALSEP(new_var2))
    return new_var2;
  else
    return every_pred__inst1(left,lex_bigger_than_subterms_pred__fn68,CDR(right));
}

SCM lex_bigger_than_subterms_pred__fn68(left,x)
SCM left,x;
{
  return lex_bigger_pred_(left,x);
}

SCM lex_subterm_bigger_than(left,right)
SCM left,right;
{
  if(!(NUMBER_P(left)))
    return some_pred__inst2(right,lex_subterm_bigger_than_fn70,CDR(left));
  else
    return BOOL_F;
}

SCM lex_subterm_bigger_than_fn70(right,x)
SCM right,x;
{
  return lex_bigger_pred_(x,right);
}

SCM lex_symbol_bigger_pred_(left,right)
SCM left,right;
{
  SCM tmp;

  tmp=memq(MAKINUM(534773760)&right,GLOBAL(lex_symbol_orderlst_global));
  if(!(NFALSEP(tmp)))
    return BOOL_F;
  else
  if(NFALSEP(memq(MAKINUM(534773760)&left,CDR(tmp))))
    return BOOL_T;
  else
    return BOOL_F;
}

SCM make_lex_symbol_bigger_excl_(left,right)
SCM left,right;
{
  left=(MAKINUM(534773760)&left);
  right=(MAKINUM(534773760)&right);
  if(!(NFALSEP(memq(left,GLOBAL(lex_symbol_orderlst_global))))) {
    GLOBAL(lex_symbol_orderlst_global)=append2(GLOBAL(lex_symbol_orderlst_global),cons(left,EOL));
  }
  if(!(NFALSEP(memq(right,GLOBAL(lex_symbol_orderlst_global))))) {
    GLOBAL(lex_symbol_orderlst_global)=cons(right,GLOBAL(lex_symbol_orderlst_global));
    return UNSPECIFIED;
  }
  else
    return UNSPECIFIED;
}

SCM prohibit_right_para(litinfonr)
SCM litinfonr;
{
  return MAKINUM(32)|litinfonr;
}

SCM prohibit_left_para(litinfonr)
SCM litinfonr;
{
  return MAKINUM(16)|litinfonr;
}

SCM vdepth_order_litinfo_aux(litinfolst,purecl)
SCM litinfolst,purecl;
{
  SCM new_var5,new_var6,new_var2,new_var3,new_var4,smalllits,biglits,newlitinfnr,varinfo_purecl;

  smalllits=EOL;
  biglits=EOL;
  newlitinfnr=MAKINUM(0);
  varinfo_purecl=map1(vdepth_order_litinfo_aux_fn74,purecl);
  for(new_var5=litinfolst,new_var6=varinfo_purecl,new_var2=EOL,new_var3=EOL,new_var4=EOL;
      PAIR_P(new_var5)&&PAIR_P(new_var6);
      new_var5=CDR(new_var5),new_var6=CDR(new_var6)) {
    new_var4=vdepth_order_litinfo_aux_fn75(&newlitinfnr,varinfo_purecl,CAR(new_var5),CAR(new_var6));
    if(NULL_P(new_var2)) {
      new_var2=cons(new_var4,EOL);
      new_var3=new_var2;
    }
    else {
      SET_CDR(new_var3,cons(new_var4,EOL));
      new_var3=CDR(new_var3);
    }
  }
  return new_var2;
}

SCM vdepth_order_litinfo_aux_fn75(newlitinfnr,varinfo_purecl,litinf,varinfolit)
SCM *newlitinfnr;
SCM varinfo_purecl,litinf,varinfolit;
{
  if(NFALSEP(answer_lit_pred_(CDR(varinfolit)))||NFALSEP(some_pred__inst2(varinfolit,vdepth_order_litinfo_aux_fn76,varinfo_purecl))) {
    SET_CAR(varinfolit,EOL);
    return cons(CAR(litinf),cons(CAR(CDR(litinf)),cons(CAR(CDR(CDR(litinf)))|litinf_nouse_mask_global,CDR(CDR(CDR(litinf))))));
  }
  else {
    *newlitinfnr=MAKINUM(INUM(litinf_nouse_mask_global)^INUM(CAR(CDR(CDR(litinf)))|litinf_nouse_mask_global));
    if(NFALSEP(GLOBAL(ordered_paramodulation_flag_global))&&(((MAKINUM(534773760)&CAR(CDR(varinfolit)))==GLOBAL(eq_pred_nr_global))||(NFALSEP(GLOBAL(type_theory_stratflag_global))&&(!(NUMBER_P(CAR(CDR(CDR(varinfolit)))))&&(((MAKINUM(534773760)&CAR(CAR(CDR(CDR(varinfolit)))))==GLOBAL(eq_fun_nr_global))&&!(!(ZERO_P(MAKINUM(268435456)&CAR(CDR(varinfolit)))))))))) {
      *newlitinfnr=order_equality_litinfo(*newlitinfnr,CDR(varinfolit));
    }
    return cons(CAR(litinf),cons(CAR(CDR(litinf)),cons(*newlitinfnr,CDR(CDR(CDR(litinf))))));
  }
}

SCM vdepth_order_litinfo_aux_fn76(varinfolit,x)
SCM varinfolit,x;
{
  return SBOOL(!(x==varinfolit)&&((NFALSEP(GLOBAL(order_strategy_flag_global))||((MAKINUM(534773760)&CAR(CDR(x)))==GLOBAL(eq_pred_nr_global)))&&NFALSEP(vdepth__grtr__varinfolit_pred_(x,varinfolit))));
}

SCM vdepth_order_litinfo_aux_fn74(x)
SCM x;
{
  return cons(make_var_depth_info(x),x);
}

SCM name_order_litinfo(litinfolst,purecl)
SCM litinfolst,purecl;
{
  SCM new_var5,new_var6,new_var2,new_var3,new_var4,varinfo_purecl,newlitinfnr;

  varinfo_purecl=map1(name_order_litinfo_fn80,purecl);
  newlitinfnr=MAKINUM(0);
  for(new_var5=litinfolst,new_var6=varinfo_purecl,new_var2=EOL,new_var3=EOL,new_var4=EOL;
      PAIR_P(new_var5)&&PAIR_P(new_var6);
      new_var5=CDR(new_var5),new_var6=CDR(new_var6)) {
    new_var4=name_order_litinfo_fn81(&newlitinfnr,varinfo_purecl,CAR(new_var5),CAR(new_var6));
    if(NULL_P(new_var2)) {
      new_var2=cons(new_var4,EOL);
      new_var3=new_var2;
    }
    else {
      SET_CDR(new_var3,cons(new_var4,EOL));
      new_var3=CDR(new_var3);
    }
  }
  return new_var2;
}

SCM name_order_litinfo_fn81(newlitinfnr,varinfo_purecl,litinf,varinfolit)
SCM *newlitinfnr;
SCM varinfo_purecl,litinf,varinfolit;
{
  if(NFALSEP(answer_lit_pred_(CDR(varinfolit)))||NFALSEP(some_pred__inst2(varinfolit,name_order_litinfo_fn82,varinfo_purecl))) {
    SET_CAR(varinfolit,EOL);
    return cons(CAR(litinf),cons(CAR(CDR(litinf)),cons(CAR(CDR(CDR(litinf)))|litinf_nouse_mask_global,CDR(CDR(CDR(litinf))))));
  }
  else {
    *newlitinfnr=MAKINUM(INUM(litinf_nouse_mask_global)^INUM(CAR(CDR(CDR(litinf)))|litinf_nouse_mask_global));
    if(NFALSEP(GLOBAL(ordered_paramodulation_flag_global))&&(((MAKINUM(534773760)&CAR(CDR(varinfolit)))==GLOBAL(eq_pred_nr_global))||(NFALSEP(GLOBAL(type_theory_stratflag_global))&&(!(NUMBER_P(CAR(CDR(CDR(varinfolit)))))&&(((MAKINUM(534773760)&CAR(CAR(CDR(CDR(varinfolit)))))==GLOBAL(eq_fun_nr_global))&&!(!(ZERO_P(MAKINUM(268435456)&CAR(CDR(varinfolit)))))))))) {
      *newlitinfnr=order_equality_litinfo(*newlitinfnr,CDR(varinfolit));
    }
    return cons(CAR(litinf),cons(CAR(CDR(litinf)),cons(*newlitinfnr,CDR(CDR(CDR(litinf))))));
  }
}

SCM name_order_litinfo_fn82(varinfolit,x)
SCM varinfolit,x;
{
  return SBOOL(!(x==varinfolit)&&((MAKINUM(534773760)&CAR(CDR(varinfolit)))>(MAKINUM(534773760)&CAR(CDR(x)))));
}

SCM name_order_litinfo_fn80(x)
SCM x;
{
  return cons(BOOL_T,x);
}

SCM poslit_order_litinfo(litinfolst,purecl)
SCM litinfolst,purecl;
{
  SCM new_var5,new_var6,new_var2,new_var3,new_var4,varinfo_purecl,mix_flag,newlitinfnr;

  varinfo_purecl=map1(poslit_order_litinfo_fn85,purecl);
  mix_flag=mixed_cl_pred_(purecl);
  newlitinfnr=MAKINUM(0);
  for(new_var5=litinfolst,new_var6=varinfo_purecl,new_var2=EOL,new_var3=EOL,new_var4=EOL;
      PAIR_P(new_var5)&&PAIR_P(new_var6);
      new_var5=CDR(new_var5),new_var6=CDR(new_var6)) {
    new_var4=poslit_order_litinfo_fn86(&newlitinfnr,mix_flag,CAR(new_var5),CAR(new_var6));
    if(NULL_P(new_var2)) {
      new_var2=cons(new_var4,EOL);
      new_var3=new_var2;
    }
    else {
      SET_CDR(new_var3,cons(new_var4,EOL));
      new_var3=CDR(new_var3);
    }
  }
  return new_var2;
}

SCM poslit_order_litinfo_fn86(newlitinfnr,mix_flag,litinf,varinfolit)
SCM *newlitinfnr;
SCM mix_flag,litinf,varinfolit;
{
  if(NFALSEP(answer_lit_pred_(CDR(varinfolit)))||(NFALSEP(mix_flag)&&!(ZERO_P(MAKINUM(268435456)&CAR(CDR(varinfolit)))))) {
    SET_CAR(varinfolit,EOL);
    return cons(CAR(litinf),cons(CAR(CDR(litinf)),cons(CAR(CDR(CDR(litinf)))|litinf_nouse_mask_global,CDR(CDR(CDR(litinf))))));
  }
  else {
    *newlitinfnr=MAKINUM(INUM(litinf_nouse_mask_global)^INUM(CAR(CDR(CDR(litinf)))|litinf_nouse_mask_global));
    if(NFALSEP(GLOBAL(ordered_paramodulation_flag_global))&&(((MAKINUM(534773760)&CAR(CDR(varinfolit)))==GLOBAL(eq_pred_nr_global))||(NFALSEP(GLOBAL(type_theory_stratflag_global))&&(!(NUMBER_P(CAR(CDR(CDR(varinfolit)))))&&(((MAKINUM(534773760)&CAR(CAR(CDR(CDR(varinfolit)))))==GLOBAL(eq_fun_nr_global))&&!(!(ZERO_P(MAKINUM(268435456)&CAR(CDR(varinfolit)))))))))) {
      *newlitinfnr=order_equality_litinfo(*newlitinfnr,CDR(varinfolit));
    }
    return cons(CAR(litinf),cons(CAR(CDR(litinf)),cons(*newlitinfnr,CDR(CDR(CDR(litinf))))));
  }
}

SCM poslit_order_litinfo_fn85(x)
SCM x;
{
  return cons(BOOL_T,x);
}

SCM firstlitpref_order_litinfo(litinfolst,purecl)
SCM litinfolst,purecl;
{
  SCM new_var5,new_var6,new_var2,new_var3,new_var4,varinfo_purecl,newlitinfnr,first_flag;

  varinfo_purecl=map1(firstlitpref_order_litinfo_fn89,purecl);
  newlitinfnr=MAKINUM(0);
  first_flag=BOOL_T;
  for(new_var5=litinfolst,new_var6=varinfo_purecl,new_var2=EOL,new_var3=EOL,new_var4=EOL;
      PAIR_P(new_var5)&&PAIR_P(new_var6);
      new_var5=CDR(new_var5),new_var6=CDR(new_var6)) {
    new_var4=firstlitpref_order_litinfo_fn90(&first_flag,&newlitinfnr,CAR(new_var5),CAR(new_var6));
    if(NULL_P(new_var2)) {
      new_var2=cons(new_var4,EOL);
      new_var3=new_var2;
    }
    else {
      SET_CDR(new_var3,cons(new_var4,EOL));
      new_var3=CDR(new_var3);
    }
  }
  return new_var2;
}

SCM firstlitpref_order_litinfo_fn90(first_flag,newlitinfnr,litinf,varinfolit)
SCM *first_flag,*newlitinfnr;
SCM litinf,varinfolit;
{
  if(NFALSEP(answer_lit_pred_(CDR(varinfolit)))||!(NFALSEP(*first_flag))) {
    SET_CAR(varinfolit,EOL);
    return cons(CAR(litinf),cons(CAR(CDR(litinf)),cons(CAR(CDR(CDR(litinf)))|litinf_nouse_mask_global,CDR(CDR(CDR(litinf))))));
  }
  else {
    *first_flag=BOOL_F;
    *newlitinfnr=MAKINUM(INUM(litinf_nouse_mask_global)^INUM(CAR(CDR(CDR(litinf)))|litinf_nouse_mask_global));
    if(NFALSEP(GLOBAL(ordered_paramodulation_flag_global))&&(((MAKINUM(534773760)&CAR(CDR(varinfolit)))==GLOBAL(eq_pred_nr_global))||(NFALSEP(GLOBAL(type_theory_stratflag_global))&&(!(NUMBER_P(CAR(CDR(CDR(varinfolit)))))&&(((MAKINUM(534773760)&CAR(CAR(CDR(CDR(varinfolit)))))==GLOBAL(eq_fun_nr_global))&&!(!(ZERO_P(MAKINUM(268435456)&CAR(CDR(varinfolit)))))))))) {
      *newlitinfnr=order_equality_litinfo(*newlitinfnr,CDR(varinfolit));
    }
    return cons(CAR(litinf),cons(CAR(CDR(litinf)),cons(*newlitinfnr,CDR(CDR(CDR(litinf))))));
  }
}

SCM firstlitpref_order_litinfo_fn89(x)
SCM x;
{
  return cons(BOOL_T,x);
}

SCM posweight_order_litinfo(litinfolst,purecl)
SCM litinfolst,purecl;
{
  SCM new_var5,new_var6,new_var2,new_var3,new_var4,varinfo_purecl,newlitinfnr,first_flag;

  varinfo_purecl=map1(posweight_order_litinfo_fn93,purecl);
  newlitinfnr=MAKINUM(0);
  first_flag=BOOL_T;
  for(new_var5=litinfolst,new_var6=varinfo_purecl,new_var2=EOL,new_var3=EOL,new_var4=EOL;
      PAIR_P(new_var5)&&PAIR_P(new_var6);
      new_var5=CDR(new_var5),new_var6=CDR(new_var6)) {
    new_var4=posweight_order_litinfo_fn94(&first_flag,&newlitinfnr,CAR(new_var5),CAR(new_var6));
    if(NULL_P(new_var2)) {
      new_var2=cons(new_var4,EOL);
      new_var3=new_var2;
    }
    else {
      SET_CDR(new_var3,cons(new_var4,EOL));
      new_var3=CDR(new_var3);
    }
  }
  return new_var2;
}

SCM posweight_order_litinfo_fn94(first_flag,newlitinfnr,litinf,varinfolit)
SCM *first_flag,*newlitinfnr;
SCM litinf,varinfolit;
{
  if(NFALSEP(answer_lit_pred_(CDR(varinfolit)))||(!(NFALSEP(*first_flag))&&!(ZERO_P(MAKINUM(268435456)&CAR(CDR(varinfolit)))))) {
    SET_CAR(varinfolit,EOL);
    return cons(CAR(litinf),cons(CAR(CDR(litinf)),cons(CAR(CDR(CDR(litinf)))|litinf_nouse_mask_global,CDR(CDR(CDR(litinf))))));
  }
  else {
    if(!(ZERO_P(MAKINUM(268435456)&CAR(CDR(varinfolit))))) {
      *first_flag=BOOL_F;
    }
    *newlitinfnr=MAKINUM(INUM(litinf_nouse_mask_global)^INUM(CAR(CDR(CDR(litinf)))|litinf_nouse_mask_global));
    if(NFALSEP(GLOBAL(ordered_paramodulation_flag_global))&&(((MAKINUM(534773760)&CAR(CDR(varinfolit)))==GLOBAL(eq_pred_nr_global))||(NFALSEP(GLOBAL(type_theory_stratflag_global))&&(!(NUMBER_P(CAR(CDR(CDR(varinfolit)))))&&(((MAKINUM(534773760)&CAR(CAR(CDR(CDR(varinfolit)))))==GLOBAL(eq_fun_nr_global))&&!(!(ZERO_P(MAKINUM(268435456)&CAR(CDR(varinfolit)))))))))) {
      *newlitinfnr=order_equality_litinfo(*newlitinfnr,CDR(varinfolit));
    }
    return cons(CAR(litinf),cons(CAR(CDR(litinf)),cons(*newlitinfnr,CDR(CDR(CDR(litinf))))));
  }
}

SCM posweight_order_litinfo_fn93(x)
SCM x;
{
  return cons(BOOL_T,x);
}

SCM vdepth_order_litinfo_eq_only(litinfolst,purecl)
SCM litinfolst,purecl;
{
  SCM new_var5,new_var6,new_var2,new_var3,new_var4,newlitinfnr;

  newlitinfnr=MAKINUM(0);
  for(new_var5=litinfolst,new_var6=purecl,new_var2=EOL,new_var3=EOL,new_var4=EOL;
      PAIR_P(new_var5)&&PAIR_P(new_var6);
      new_var5=CDR(new_var5),new_var6=CDR(new_var6)) {
    new_var4=vdepth_order_litinfo_eq_only_fn96(&newlitinfnr,CAR(new_var5),CAR(new_var6));
    if(NULL_P(new_var2)) {
      new_var2=cons(new_var4,EOL);
      new_var3=new_var2;
    }
    else {
      SET_CDR(new_var3,cons(new_var4,EOL));
      new_var3=CDR(new_var3);
    }
  }
  return new_var2;
}

SCM vdepth_order_litinfo_eq_only_fn96(newlitinfnr,litinf,lit)
SCM *newlitinfnr;
SCM litinf,lit;
{
  if(((MAKINUM(534773760)&CAR(lit))==GLOBAL(eq_pred_nr_global))||(NFALSEP(GLOBAL(type_theory_stratflag_global))&&(!(NUMBER_P(CAR(CDR(lit))))&&(((MAKINUM(534773760)&CAR(CAR(CDR(lit))))==GLOBAL(eq_fun_nr_global))&&!(!(ZERO_P(MAKINUM(268435456)&CAR(lit)))))))) {
    *newlitinfnr=MAKINUM(INUM(litinf_nouse_mask_global)^INUM(CAR(CDR(CDR(litinf)))|litinf_nouse_mask_global));
    *newlitinfnr=order_equality_litinfo(*newlitinfnr,lit);
    return cons(CAR(litinf),cons(CAR(CDR(litinf)),cons(*newlitinfnr,CDR(CDR(CDR(litinf))))));
  }
  else
    return litinf;
}

SCM vdepth__grtr__varinfolit_pred_(alit,blit)
SCM alit,blit;
{
  if(!(NULL_P(CAR(blit))))
    return every_pred__inst1(alit,vdepth__grtr__varinfolit_pred__fn98,CAR(blit));
  else
    return BOOL_F;
}

SCM vdepth__grtr__varinfolit_pred__fn98(alit,pr)
SCM alit,pr;
{
  SCM tmp;

  tmp=assq(CAR(pr),CAR(alit));
  if(NFALSEP(tmp))
    return SBOOL(CDR(tmp)>CDR(pr));
  else
    return BOOL_F;
}

SCM vdepth_superset_varinfolit_pred_(alit,blit)
SCM alit,blit;
{
  SCM new_var2;

  new_var2=SBOOL(NULL_P(CAR(blit)));
  if(NFALSEP(new_var2))
    return new_var2;
  else
    return every_pred__inst1(alit,vdepth_superset_varinfolit_pred__fn100,CAR(blit));
}

SCM vdepth_superset_varinfolit_pred__fn100(alit,pr)
SCM alit,pr;
{
  return assq(CAR(pr),CAR(alit));
}

SCM make_var_depth_info(term)
SCM term;
{
  GLOBAL(tmp_var_depth_table_global)=EOL;
  if(!(NUMBER_P(term))&&(ZERO_P(MAKINUM(65536)&CAR(term))&&!(NFALSEP(answer_lit_pred_(term)))))
    make_var_depth_info_aux(term,MAKINUM(1));
  else
  if(NUMBER_P(term)&&(term<=MAKINUM(65535))) {
    GLOBAL(tmp_var_depth_table_global)=cons(MAKINUM(8191)&term,MAKINUM(0));
  }
  return GLOBAL(tmp_var_depth_table_global);
}

SCM make_var_depth_info_aux(term,depth)
SCM term,depth;
{
  SCM part,tmp;

  tmp=EOL;
  for(part=CDR(term);!(NULL_P(part));part=CDR(part)) {
    term=CAR(part);
    if(NUMBER_P(term)) {
      if(MAKINUM(65535)>term) {
        tmp=assq(MAKINUM(8191)&term,GLOBAL(tmp_var_depth_table_global));
        if(NFALSEP(tmp)) {
          if(depth>CDR(tmp)) {
            SET_CDR(tmp,depth);
          }
        }
        else {
          GLOBAL(tmp_var_depth_table_global)=cons(cons(MAKINUM(8191)&term,depth),GLOBAL(tmp_var_depth_table_global));
        }
      }
    }
    else
    if(ZERO_P(MAKINUM(65536)&CAR(term)))
      make_var_depth_info_aux(term,MAKINUM(1+INUM(depth)));
  }
  return UNSPECIFIED;
}

SCM show_history(history)
SCM history;
{
  if(!(NULL_P(GLOBAL(checkpoint_keptnrs_global)))&&(GLOBAL(display_info_level_global)>=MAKINUM(20))) {
    newline(cur_output_port());
    display(const_65,cur_output_port());
    print_list_as_term(cons(c_symb,reverse(GLOBAL(checkpoint_keptnrs_global))));
    newline(cur_output_port());
    newline(cur_output_port());
  }
  GLOBAL(otter_prepared_history_global)=EOL;
  GLOBAL(shown_clausenrs_global)=EOL;
  if(PAIR_P(history)&&(((hyper_symb==CAR(history))||((factor_symb==CAR(history))||(binres_symb==CAR(history))))&&ZERO_P(CAR(CDR(history))))) {
    history=cons(CAR(history),cons(MAKINUM(1+INUM(GLOBAL(kept_cl_nr_global))),CDR(CDR(history))));
  }
  otter_show_history_aux(history,BOOL_T);
  GLOBAL(otter_prepared_history_global)=sort_by_firstel(GLOBAL(otter_prepared_history_global));
  for_each1(show_history_fn102,GLOBAL(otter_prepared_history_global));
  newline(cur_output_port());
  return newline(cur_output_port());
}

SCM show_history_fn102(x)
SCM x;
{
  newline(cur_output_port());
  display(CAR(x),cur_output_port());
  display(const_66,cur_output_port());
  otter_show_history_printparents(but_last(CDR(x)));
  display(const_67,cur_output_port());
  if(PAIR_P(CAR(apply(GLOBAL(last_pair),x,listofnull))))
    return print_clause(CAR(apply(GLOBAL(last_pair),x,listofnull)));
  else
  if(_pred__symb==CAR(apply(GLOBAL(last_pair),x,listofnull)))
    return display(_pred__symb,cur_output_port());
  else
    return display(const_68,cur_output_port());
}

SCM otter_show_history_printparents(lst)
SCM lst;
{
  SCM new_var2;

tailrecursion:
  new_var2=SBOOL(NULL_P(lst));
  if(NFALSEP(new_var2))
    return new_var2;
  else
  if(SYMBOL_P(CAR(lst))) {
    display(CAR(lst),cur_output_port());
    if(!(NULL_P(CDR(lst))))
      display(const_69,cur_output_port());
    lst=CDR(lst);
    goto tailrecursion;
  }
  else
  if(PAIR_P(CAR(lst))) {
    otter_show_history_printparents_aux(CAR(lst));
    if(!(NULL_P(CDR(lst))))
      display(const_70,cur_output_port());
    lst=CDR(lst);
    goto tailrecursion;
  }
  else {
    display(CAR(lst),cur_output_port());
    if(!(NULL_P(CDR(lst))))
      display(const_71,cur_output_port());
    lst=CDR(lst);
    goto tailrecursion;
  }
}

SCM otter_show_history_printparents_aux(y)
SCM y;
{
tailrecursion:
  if(!(NULL_P(y))) {
    display(CAR(y),cur_output_port());
    if(!(NULL_P(CDR(y))))
      display(const_72,cur_output_port());
    y=CDR(y);
    goto tailrecursion;
  }
  else
    return UNSPECIFIED;
}

SCM otter_show_history_aux(history,pos)
SCM history,pos;
{
  SCM part__1,part,old_history,constr,dernr,premissnrs,clausepl,clause,res,b1,b2,newres,demods,tmp;

  old_history=history;
  constr=CAR(history);
  dernr=CAR(CDR(history));
  premissnrs=EOL;
  clausepl=EOL;
  clause=EOL;
  res=EOL;
  b1=EOL;
  b2=EOL;
  newres=EOL;
  demods=EOL;
  tmp=EOL;
  for(part=history;!(NULL_P(part));part=CDR(part))
    if(!(PAIR_P(CAR(part)))||!(demod_symb==CAR(CAR(part)))) {
      tmp=cons(CAR(part),tmp);
    }
  history=reverse(tmp);
  res=cons(dernr,res);
  if(factor_symb==constr) {
    b1=CAR(CDR(CAR(CDR(CDR(history)))));
  }
  if(binres_symb==constr) {
    b1=CAR(CDR(CAR(CDR(CAR(CDR(CDR(history)))))));
    b2=CAR(CDR(CAR(CDR(CAR(CDR(CDR(CDR(history))))))));
  }
  if(hyper_symb==constr) {
    b1=CAR(CDR(CAR(CDR(CAR(CDR(CDR(CDR(history))))))));
  }
  if((factor_symb==constr)&&((ZERO_P(b1)||(b1>=GLOBAL(one_pass_kept_clauses_firstnr_global)))&&!(NFALSEP(show_history_find_clausepl(b1))))) {
    tmp=otter_show_history_aux(append2(cons(CAR(CAR(CDR(CDR(history)))),cons(dernr,EOL)),CDR(CDR(CAR(CDR(CDR(history)))))),pos);
    res=append2(cons(factor_s_symb,EOL),CDR(tmp));
    res=cons(CAR(tmp),res);
  }
  else
  if((hyper_symb==constr)&&((ZERO_P(b1)||(b1>=GLOBAL(one_pass_kept_clauses_firstnr_global)))&&!(NFALSEP(show_history_find_clausepl(b1))))) {
    tmp=otter_show_history_aux(append2(cons(CAR(CAR(CDR(CAR(CDR(CDR(CDR(history))))))),cons(dernr,EOL)),CDR(CDR(CAR(CDR(CAR(CDR(CDR(CDR(history))))))))),pos);
    res=append2(cons(CAR(CDR(CAR(CDR(CDR(history))))),cons(hyper_s_symb,EOL)),CDR(tmp));
    res=cons(CAR(tmp),res);
    otter_show_history_aux(CAR(CDR(CDR(history))),BOOL_F);
  }
  else
  if((binres_symb==constr)&&(((ZERO_P(b1)||(b1>=GLOBAL(one_pass_kept_clauses_firstnr_global)))&&!(NFALSEP(show_history_find_clausepl(b1))))||((ZERO_P(b2)||(b2>=GLOBAL(one_pass_kept_clauses_firstnr_global)))&&!(NFALSEP(show_history_find_clausepl(b2)))))) {
    if(!(NFALSEP(show_history_find_clausepl(b1)))) {
      tmp=otter_show_history_aux(append2(cons(CAR(CAR(CDR(CAR(CDR(CDR(history)))))),cons(dernr,EOL)),CDR(CDR(CAR(CDR(CAR(CDR(CDR(history)))))))),pos);
      res=append2(cons(b2,cons(binary_s_symb,EOL)),CDR(tmp));
      res=cons(CAR(tmp),res);
      otter_show_history_aux(CAR(CDR(CAR(CDR(CDR(CDR(history)))))),BOOL_F);
    }
    else
    if(!(NFALSEP(show_history_find_clausepl(b2)))) {
      tmp=otter_show_history_aux(append2(cons(CAR(CAR(CDR(CAR(CDR(CDR(CDR(history))))))),cons(dernr,EOL)),CDR(CDR(CAR(CDR(CAR(CDR(CDR(CDR(history))))))))),pos);
      res=append2(cons(b1,cons(binary_s_symb,EOL)),CDR(tmp));
      res=cons(CAR(tmp),res);
      otter_show_history_aux(CAR(CDR(CAR(CDR(CDR(history))))),BOOL_F);
    }
  }
  else
  if(NUMBER_P(dernr)&&(dernr<GLOBAL(one_pass_kept_clauses_firstnr_global))) {
    if(!(NFALSEP(show_history_find_clausepl(dernr)))) {
      res=cons(_pred__symb,res);
      res=cons(_pred__symb,res);
    }
    else {
      if(!(input_symb==constr)) {
        res=cons(_pred__symb,cons(constr,res));
      }
      res=cons(otter_show_history_aux_aux(dernr,EOL,EOL),res);
    }
  }
  else
  if(binres_symb==constr) {
    res=cons(binary_symb,res);
    res=cons((!(MAKINUM(1)==CAR(CDR(CDR(CAR(CDR(CDR(history))))))) ? cons(show_history_clnr(CAR(CDR(CDR(history)))),cons(CAR(CDR(CDR(CAR(CDR(CDR(history)))))),EOL)) : show_history_clnr(CAR(CDR(CDR(history))))),res);
    res=cons((!(MAKINUM(1)==CAR(CDR(CDR(CAR(CDR(CDR(CDR(history)))))))) ? cons(show_history_clnr(CAR(CDR(CDR(CDR(history))))),cons(CAR(CDR(CDR(CAR(CDR(CDR(CDR(history))))))),EOL)) : show_history_clnr(CAR(CDR(CDR(CDR(history)))))),res);
    res=cons(otter_show_history_aux_aux(dernr,history,cons(CAR(CDR(CDR(history))),cons(CAR(CDR(CDR(CDR(history)))),EOL))),res);
  }
  else
  if(hyper_symb==constr) {
    res=cons(hyper_symb,res);
    res=cons(show_history_clnr(CAR(CDR(CDR(history)))),res);
    for_each1_inst1(&res,otter_show_history_aux_fn106,CDR(CDR(CDR(history))));
    res=cons(otter_show_history_aux_aux(dernr,history,CDR(CDR(history))),res);
  }
  else
  if(para_symb==constr) {
    res=append2(cons(show_history_clnr(CAR(CDR(CDR(CDR(history))))),cons(cons(show_history_clnr(CAR(CDR(CDR(history)))),CDR(CDR(CDR(CDR(history))))),cons(para_symb,EOL))),res);
    res=cons(otter_show_history_aux_aux(dernr,history,cons(CAR(CDR(CDR(history))),cons(CAR(CDR(CDR(CDR(history)))),EOL))),res);
  }
  else
  if(factor_symb==constr) {
    res=append2(cons(show_history_clnr(CAR(CDR(CDR(history)))),cons(factor_symb,EOL)),res);
    res=cons(otter_show_history_aux_aux(dernr,history,cons(CAR(CDR(CDR(history))),EOL)),res);
  }
  else
  if(input_symb==constr) {
    clausepl=show_history_find_clausepl(dernr);
    if(NFALSEP(clausepl)&&(old_symb==CAR(clausepl))) {
      clausepl=CDR(clausepl);
    }
    if(NFALSEP(clausepl)) {
      res=cons(CAR(clausepl),res);
      GLOBAL(shown_clausenrs_global)=cons(dernr,GLOBAL(shown_clausenrs_global));
    }
  }
  else
  if(backdemod_symb==constr) {
    res=append2(cons(show_history_clnr(CAR(CDR(CDR(history)))),cons(backdemod_symb,EOL)),res);
    res=cons(otter_show_history_aux_aux(dernr,history,cons(CAR(CDR(CDR(history))),EOL)),res);
  }
  else
  if(literal_symb==constr) {
    otter_show_history_aux(CAR(CDR(history)),pos);
    res=BOOL_F;
  }
  else
  if(NUMBER_P(pos)) {
    newline(cur_output_port());
    display_spaces(pos);
  }
  else
    report_error(const_73,cons(constr,EOL));
  if(NFALSEP(res)) {
    for(part__1=old_history;!(NULL_P(part__1));part__1=CDR(part__1))
      if(PAIR_P(CAR(part__1))&&(demod_symb==CAR(CAR(part__1)))) {
        demods=append2(CDR(CAR(part__1)),demods);
      }
    if(!(NULL_P(demods))) {
      res=cons(CAR(res),append2(map1(otter_show_history_aux_fn107,demods),cons(demod_symb,CDR(res))));
      for_each1_inst2(pos,otter_show_history_aux_fn108,demods);
    }
    tmp=assq(CAR(apply(GLOBAL(last_pair),res,listofnull)),GLOBAL(otter_prepared_history_global));
    if(!(NFALSEP(tmp))) {
      GLOBAL(otter_prepared_history_global)=cons(reverse(res),GLOBAL(otter_prepared_history_global));
    }
    else
    if(length(tmp)<length(res)) {
      SET_CDR(tmp,CDR(reverse(res)));
    }
  }
  return res;
}

SCM otter_show_history_aux_fn108(pos,x)
SCM pos,x;
{
  return otter_show_history_aux(CAR(CDR(CDR(CDR(CDR(CDR(CAR(x))))))),pos);
}

SCM otter_show_history_aux_fn107(x)
SCM x;
{
  return CAR(CDR(CDR(CDR(CDR(CAR(x))))));
}

SCM otter_show_history_aux_fn106(res,x)
SCM *res;
SCM x;
{
  *res=cons(show_history_clnr(x),*res);
  if(PAIR_P(x)&&((literal_symb==CAR(x))&&!(MAKINUM(1)==CAR(CDR(CDR(x)))))) {
    *res=cons(cons(CAR(CDR(CDR(x))),EOL),*res);
    return UNSPECIFIED;
  }
  else
    return UNSPECIFIED;
}

SCM sort_by_firstel(lst)
SCM lst;
{
  SCM part,res;

  res=EOL;
  for(part=lst;!(NULL_P(part));part=CDR(part))
    if(NULL_P(res)) {
      res=cons(CAR(part),EOL);
    }
    else
    if(CAR(CAR(part))<CAR(CAR(res))) {
      res=cons(CAR(part),res);
    }
    else
      insert_to_firstel_sorted_excl_(CAR(part),res);
  return res;
}

SCM insert_to_firstel_sorted_excl_(el,lst)
SCM el,lst;
{
tailrecursion:
  if(NULL_P(CDR(lst))||(CAR(el)<CAR(CAR(CDR(lst))))) {
    SET_CDR(lst,cons(el,CDR(lst)));
    return UNSPECIFIED;
  }
  else {
    lst=CDR(lst);
    goto tailrecursion;
  }
}

SCM otter_show_history_aux_aux(dernr,history,elements)
SCM dernr,history,elements;
{
  SCM tmp,res,clausepl,old_flag;

  tmp=EOL;
  res=EOL;
  clausepl=EOL;
  old_flag=BOOL_F;
  clausepl=show_history_find_clausepl(dernr);
  if(NFALSEP(clausepl)) {
    GLOBAL(shown_clausenrs_global)=cons(dernr,GLOBAL(shown_clausenrs_global));
    if(!(PAIR_P(CAR(clausepl)))) {
      res=BOOL_F;
    }
    else {
      res=CAR(clausepl);
    }
  }
  if(!(NFALSEP(old_flag)))
    for_each1_inst3(&tmp,&clausepl,otter_show_history_aux_aux_fn110,elements);
  return res;
}

SCM otter_show_history_aux_aux_fn110(tmp,clausepl,x)
SCM *tmp,*clausepl;
SCM x;
{
  *tmp=show_history_clnr(x);
  if(!(NFALSEP(member(*tmp,GLOBAL(shown_clausenrs_global))))) {
    *clausepl=show_history_find_clausepl(*tmp);
    if(NFALSEP(*clausepl))
      return otter_show_history_aux(CAR(CDR(CDR(CDR(CDR(CDR(CAR(CAR(*clausepl)))))))),BOOL_T);
    else
      return otter_show_history_aux(x,BOOL_T);
  }
  else
    return UNSPECIFIED;
}

SCM show_history_aux(history,pos)
SCM history,pos;
{
  SCM tmp_var1,tmp_var2,constr,dernr,premissnrs,clausepl,clause,tmp;

tailrecursion:
  constr=CAR(history);
  dernr=CAR(CDR(history));
  premissnrs=EOL;
  clausepl=EOL;
  clause=EOL;
  tmp=EOL;
  if(hyper_symb==constr) {
    newline(cur_output_port());
    display_spaces(pos);
    display(const_74,cur_output_port());
    display(constr,cur_output_port());
    display(const_75,cur_output_port());
    display(show_history_clnr(CAR(CDR(CDR(history)))),cur_output_port());
    display(const_76,cur_output_port());
    for_each1(show_history_aux_fn112,CDR(CDR(CDR(history))));
    return show_history_aux_aux(dernr,history,CDR(CDR(history)));
  }
  else
  if(binres_symb==constr) {
    newline(cur_output_port());
    display_spaces(pos);
    display(const_77,cur_output_port());
    display(show_history_clnr(CAR(CDR(CDR(history)))),cur_output_port());
    if(CAR(CDR(CDR(CAR(CDR(CDR(history))))))>MAKINUM(1)) {
      display(MAKICHR('('),cur_output_port());
      display(CAR(CDR(CDR(CAR(CDR(CDR(history)))))),cur_output_port());
      display(MAKICHR(')'),cur_output_port());
    }
    display(const_78,cur_output_port());
    display(show_history_clnr(CAR(CDR(CDR(CDR(history))))),cur_output_port());
    if(CAR(CDR(CDR(CAR(CDR(CDR(CDR(history)))))))>MAKINUM(1)) {
      display(MAKICHR('('),cur_output_port());
      display(CAR(CDR(CDR(CAR(CDR(CDR(CDR(history))))))),cur_output_port());
      display(MAKICHR(')'),cur_output_port());
    }
    return show_history_aux_aux(dernr,history,cons(CAR(CDR(CDR(history))),cons(CAR(CDR(CDR(CDR(history)))),EOL)));
  }
  else
  if(para_symb==constr) {
    newline(cur_output_port());
    display_spaces(pos);
    display(const_79,cur_output_port());
    display(show_history_clnr(CAR(CDR(CDR(history)))),cur_output_port());
    display(const_80,cur_output_port());
    display(show_history_clnr(CAR(CDR(CDR(CDR(history))))),cur_output_port());
    display(const_81,cur_output_port());
    display(CDR(CDR(CDR(CDR(history)))),cur_output_port());
    return show_history_aux_aux(dernr,history,cons(CAR(CDR(CDR(history))),cons(CAR(CDR(CDR(CDR(history)))),EOL)));
  }
  else
  if(factor_symb==constr) {
    newline(cur_output_port());
    display_spaces(pos);
    display(const_82,cur_output_port());
    display(show_history_clnr(CAR(CDR(CDR(history)))),cur_output_port());
    display(const_83,cur_output_port());
    display(MAKINUM(1+INUM(CAR(CDR(CDR(CDR(history)))))),cur_output_port());
    display(MAKICHR(' '),cur_output_port());
    display(MAKINUM(1+INUM(CAR(CDR(CDR(CDR(CDR(history))))))),cur_output_port());
    return show_history_aux_aux(dernr,history,cons(CAR(CDR(CDR(history))),EOL));
  }
  else
  if(input_symb==constr) {
    newline(cur_output_port());
    display_spaces(pos);
    display(const_84,cur_output_port());
    newline(cur_output_port());
    clausepl=show_history_find_clausepl(dernr);
    display(dernr,cur_output_port());
    display(const_85,cur_output_port());
    if(NFALSEP(clausepl)) {
      if(NFALSEP(GLOBAL(int_logic_flag_global)))
        apply(GLOBAL(print_full_int_clause),CAR(clausepl),listofnull);
      else
        print_full_clause(CAR(clausepl));
      GLOBAL(shown_clausenrs_global)=cons(dernr,GLOBAL(shown_clausenrs_global));
      return UNSPECIFIED;
    }
    else
      return UNSPECIFIED;
  }
  else
  if(literal_symb==constr) {
    tmp_var1=CAR(CDR(history));
    tmp_var2=MAKINUM(0);
    history=tmp_var1;
    pos=tmp_var2;
    goto tailrecursion;
  }
  else {
    newline(cur_output_port());
    display_spaces(pos);
    return report_error(const_86,cons(constr,EOL));
  }
}

SCM show_history_aux_fn112(x)
SCM x;
{
  display(show_history_clnr(x),cur_output_port());
  if(PAIR_P(x)&&((literal_symb==CAR(x))&&!(MAKINUM(1)==CAR(CDR(CDR(x)))))) {
    display(MAKICHR('('),cur_output_port());
    display(CAR(CDR(CDR(x))),cur_output_port());
    display(MAKICHR(')'),cur_output_port());
  }
  return display(MAKICHR(' '),cur_output_port());
}

SCM show_history_aux_aux(dernr,history,elements)
SCM dernr,history,elements;
{
  SCM tmp,clausepl;

  tmp=EOL;
  clausepl=EOL;
  display(const_87,cur_output_port());
  newline(cur_output_port());
  display(dernr,cur_output_port());
  display(const_88,cur_output_port());
  clausepl=show_history_find_clausepl(dernr);
  if(NFALSEP(clausepl)) {
    if(NFALSEP(GLOBAL(int_logic_flag_global)))
      apply(GLOBAL(print_full_int_clause),CAR(clausepl),listofnull);
    else
      print_full_clause(CAR(clausepl));
    GLOBAL(shown_clausenrs_global)=cons(dernr,GLOBAL(shown_clausenrs_global));
  }
  return for_each1_inst3(&tmp,&clausepl,show_history_aux_aux_fn114,elements);
}

SCM show_history_aux_aux_fn114(tmp,clausepl,x)
SCM *tmp,*clausepl;
SCM x;
{
  *tmp=show_history_clnr(x);
  if(!(NFALSEP(member(*tmp,GLOBAL(shown_clausenrs_global))))) {
    *clausepl=show_history_find_clausepl(*tmp);
    if(NFALSEP(*clausepl))
      return show_history_aux(CAR(CDR(CDR(CDR(CDR(CDR(CAR(CAR(*clausepl)))))))),MAKINUM(0));
    else
      return show_history_aux(x,MAKINUM(0));
  }
  else
    return UNSPECIFIED;
}

SCM show_history_find_clausepl(dernr)
SCM dernr;
{
  SCM clausepl;

  if(!(NUMBER_P(dernr))||ZERO_P(dernr))
    return BOOL_F;
  else {
    clausepl=BOOL_F;
    if(!(NFALSEP(clausepl))) {
      clausepl=member_if_inst1(dernr,show_history_find_clausepl_fn129,GLOBAL(sos_clauses_list_global));
    }
    if(!(NFALSEP(clausepl))&&!(NULL_P(GLOBAL(usable_clauses_list_global)))) {
      clausepl=member_if_inst1(dernr,show_history_find_clausepl_fn130,CDR(GLOBAL(usable_clauses_list_global)));
    }
    if(!(NFALSEP(clausepl))&&!(NULL_P(GLOBAL(unit_alist_global)))) {
      clausepl=some_pred__inst2(dernr,show_history_find_clausepl_fn131,GLOBAL(unit_alist_global));
    }
    if(!(NFALSEP(clausepl))&&!(NULL_P(GLOBAL(unit_alist_list_global)))) {
      clausepl=some_pred__inst2(dernr,show_history_find_clausepl_fn133,GLOBAL(unit_alist_list_global));
    }
    if(!(NFALSEP(clausepl))&&!(NULL_P(GLOBAL(sos_clauses_list_list_global)))) {
      clausepl=some_pred__inst2(dernr,show_history_find_clausepl_fn136,GLOBAL(sos_clauses_list_list_global));
    }
    if(!(NFALSEP(clausepl))&&!(NULL_P(GLOBAL(usable_clauses_list_list_global)))) {
      clausepl=some_pred__inst2(dernr,show_history_find_clausepl_fn138,GLOBAL(usable_clauses_list_list_global));
    }
    if(NFALSEP(GLOBAL(int_logic_flag_global))&&!(NFALSEP(clausepl))) {
      clausepl=member_if_inst1(dernr,show_history_find_clausepl_fn140,GLOBAL(mult_rule_clauses_list_global));
    }
    if(NFALSEP(GLOBAL(int_logic_flag_global))&&!(NFALSEP(clausepl))) {
      clausepl=member_if_inst1(dernr,show_history_find_clausepl_fn141,GLOBAL(single_rule_clauses_list_global));
    }
    if(NFALSEP(GLOBAL(int_logic_flag_global))&&!(NFALSEP(clausepl))) {
      clausepl=member_if_inst1(dernr,show_history_find_clausepl_fn142,GLOBAL(single_reduction_rule_clauses_list_global));
    }
    return clausepl;
  }
}

SCM show_history_find_clausepl_fn142(dernr,x)
SCM dernr,x;
{
  return SBOOL(dernr==CAR(CDR(CDR(CDR(CDR(CAR(x)))))));
}

SCM show_history_find_clausepl_fn141(dernr,x)
SCM dernr,x;
{
  return SBOOL(dernr==CAR(CDR(CDR(CDR(CDR(CAR(x)))))));
}

SCM show_history_find_clausepl_fn140(dernr,x)
SCM dernr,x;
{
  return SBOOL(dernr==CAR(CDR(CDR(CDR(CDR(CAR(x)))))));
}

SCM show_history_find_clausepl_fn138(dernr,x)
SCM dernr,x;
{
  return member_if_inst1(dernr,show_history_find_clausepl_fn139,x);
}

SCM show_history_find_clausepl_fn139(dernr,y)
SCM dernr,y;
{
  if(PAIR_P(y))
    return SBOOL(dernr==CAR(CDR(CDR(CDR(CDR(CAR(y)))))));
  else
    return BOOL_F;
}

SCM show_history_find_clausepl_fn136(dernr,x)
SCM dernr,x;
{
  return member_if_inst1(dernr,show_history_find_clausepl_fn137,x);
}

SCM show_history_find_clausepl_fn137(dernr,y)
SCM dernr,y;
{
  if(PAIR_P(y))
    return SBOOL(dernr==CAR(CDR(CDR(CDR(CDR(CAR(y)))))));
  else
    return BOOL_F;
}

SCM show_history_find_clausepl_fn133(dernr,x)
SCM dernr,x;
{
  return some_pred__inst2(dernr,show_history_find_clausepl_fn134,x);
}

SCM show_history_find_clausepl_fn134(dernr,y)
SCM dernr,y;
{
  return member_if_inst1(dernr,show_history_find_clausepl_fn135,CDR(y));
}

SCM show_history_find_clausepl_fn135(dernr,x__1)
SCM dernr,x__1;
{
  return SBOOL(dernr==CAR(CDR(CDR(CDR(CDR(CAR(x__1)))))));
}

SCM show_history_find_clausepl_fn131(dernr,y)
SCM dernr,y;
{
  return member_if_inst1(dernr,show_history_find_clausepl_fn132,CDR(y));
}

SCM show_history_find_clausepl_fn132(dernr,x)
SCM dernr,x;
{
  return SBOOL(dernr==CAR(CDR(CDR(CDR(CDR(CAR(x)))))));
}

SCM show_history_find_clausepl_fn130(dernr,x)
SCM dernr,x;
{
  return SBOOL(dernr==CAR(CDR(CDR(CDR(CDR(CAR(x)))))));
}

SCM show_history_find_clausepl_fn129(dernr,x)
SCM dernr,x;
{
  return SBOOL(dernr==CAR(CDR(CDR(CDR(CDR(CAR(x)))))));
}

SCM show_history_clnr(premiss)
SCM premiss;
{
  if(!(PAIR_P(premiss)))
    return _pred__symb;
  else
  if(CAR(premiss)==literal_symb)
    return CAR(CDR(CAR(CDR(premiss))));
  else
  if(CAR(premiss)==input_symb)
    return CAR(CDR(premiss));
  else
  if(CAR(premiss)==hyper_symb)
    return CAR(CDR(premiss));
  else
  if(CAR(premiss)==binres_symb)
    return CAR(CDR(premiss));
  else
  if(CAR(premiss)==factor_symb)
    return CAR(CDR(premiss));
  else
  if(CAR(premiss)==para_symb)
    return CAR(CDR(premiss));
  else
    return _pred__pred__symb;
}

SCM display_spaces(nr)
SCM nr;
{
  SCM i;

  for(i=MAKINUM(0);!(i>=nr);i=MAKINUM(1+INUM(i)))
    display(MAKICHR(' '),cur_output_port());
  return UNSPECIFIED;
}

SCM history__grtr_answer(history)
SCM history;
{
  SCM res;

  clear_x_vars_and_touched_excl_(MAKINUM(255));
  clear_y_vars_and_touched_excl_(MAKINUM(255));
  clear_z_vars_and_touched_excl_(MAKINUM(255));
  res=history__grtr_answer_step(history);
  clear_x_vars_and_touched_excl_(MAKINUM(255));
  clear_y_vars_and_touched_excl_(MAKINUM(255));
  clear_z_vars_and_touched_excl_(MAKINUM(255));
  return make_readable_cl(CDR(res));
}

SCM history__grtr_answer_step(history)
SCM history;
{
  SCM fromcl,tocl,fromlitnr,tolitnr,left_used_flag,path,frompurecl,res__1,argspart,litnr,ans_nucleon,litlst,res,tmp,arg,constr,dernr,orig_cl,ans_cl;

  constr=CAR(history);
  dernr=CAR(CDR(history));
  orig_cl=EOL;
  ans_cl=EOL;
  if(input_symb==constr) {
    ans_cl=input_ans_clause(dernr);
    return ans_cl;
  }
  else
  if(hyper_symb==constr) {
    ans_nucleon=history__grtr_answer_step(CAR(CDR(CDR(history))));
    litlst=CAR(CDR(CDR(CAR(ans_nucleon))));
    res=ans_nucleon;
    tmp=EOL;
    arg=EOL;
    for(argspart=CDR(CDR(CDR(history))),litnr=MAKINUM(1);
        !(NULL_P(argspart));
        argspart=CDR(argspart),litnr=MAKINUM(1+INUM(litnr))) {
      res=cons(CAR(res),map1(rename_x_to_y_term,CDR(res)));
      arg=history__grtr_answer_step(CAR(CDR(CAR(argspart))));
      res=history__grtr_answer_binstep(CDR(arg),CDR(res),CAR(arg),CAR(res),CAR(CDR(CDR(CAR(argspart)))),litnr,history,BOOL_T,EOL);
    }
    return res;
  }
  else
  if(para_symb==constr) {
    fromcl=history__grtr_answer_step(CAR(CDR(CDR(history))));
    tocl=history__grtr_answer_step(CAR(CDR(CDR(CDR(history)))));
    fromlitnr=CAR(CDR(CDR(CDR(CDR(history)))));
    tolitnr=CAR(CDR(CDR(CDR(CDR(CDR(history))))));
    left_used_flag=CAR(CDR(CDR(CDR(CDR(CDR(CDR(history)))))));
    path=CAR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(history))))))));
    frompurecl=map1(rename_x_to_y_term,CDR(fromcl));
    res__1=EOL;
    res__1=history__grtr_answer_binstep(CDR(tocl),frompurecl,CAR(tocl),CAR(fromcl),tolitnr,fromlitnr,history,left_used_flag,path);
    return res__1;
  }
  else
    return UNSPECIFIED;
}

SCM input_ans_clause(dernr)
SCM dernr;
{
  SCM place;

  place=member_if_inst1(dernr,input_ans_clause_fn144,GLOBAL(ans_input_sos_global));
  if(!(NFALSEP(place)))
    return report_error(const_89,cons(dernr,EOL));
  else
    return CAR(place);
}

SCM input_ans_clause_fn144(dernr,x)
SCM dernr,x;
{
  return SBOOL(CAR(CDR(CDR(CDR(CDR(CAR(x))))))==dernr);
}

SCM history__grtr_answer_binstep(xcl,ycl,xinf,yinf,xlitnr,ylitnr,derhistory,left_used_flag,path)
SCM xcl,ycl,xinf,yinf,xlitnr,ylitnr,derhistory,left_used_flag,path;
{
  SCM ytmp,xtmp,res,ylit,yfun,xlit,xfun,ylitcurinf,compl_yfunpure,lxpart,lxlitinfpart,litnr__1,lypart,lylitinfpart,litnr,xlitinf,ylitinf,yclmaxvar,ypart,ylitinfpart,xpart,xlitinfpart,subterm,tmpres;

  xlitinf=CAR(CDR(CDR(xinf)));
  ylitinf=CAR(CDR(CDR(yinf)));
  yclmaxvar=give_cl_maxvar(yinf);
  ypart=EOL;
  ylitinfpart=EOL;
  xpart=EOL;
  xlitinfpart=EOL;
  subterm=EOL;
  tmpres=EOL;
  for(lypart=ycl,lylitinfpart=ylitinf,litnr=MAKINUM(1);
      !(NFALSEP(((hyper_symb==CAR(derhistory)) ? SBOOL(MAKINUM(INUM(GLOBAL(litinf_ordernr_mask_global)&CAR(CAR(lylitinfpart)))>>16)==ylitnr) : SBOOL((litnr==ylitnr)&&!(NFALSEP(answer_lit_pred_(CAR(lypart))))))));
      lypart=CDR(lypart),lylitinfpart=CDR(lylitinfpart),litnr=MAKINUM(1+INUM(litnr)))
    if(NFALSEP(answer_lit_pred_(CAR(lypart)))) {
      litnr=MAKINUM(INUM(litnr)-1);
    }
  ypart=lypart;
  ylitinfpart=lylitinfpart;
  for(lxpart=xcl,lxlitinfpart=xlitinf,litnr__1=MAKINUM(1);
      !((litnr__1==xlitnr)&&!(NFALSEP(answer_lit_pred_(CAR(lxpart)))));
      lxpart=CDR(lxpart),lxlitinfpart=CDR(lxlitinfpart),litnr__1=MAKINUM(1+INUM(litnr__1)))
    if(NFALSEP(answer_lit_pred_(CAR(lxpart)))) {
      litnr__1=MAKINUM(INUM(litnr__1)-1);
    }
  xpart=lxpart;
  xlitinfpart=lxlitinfpart;
  ylit=CAR(ypart);
  yfun=CAR(ylit);
  xlit=CAR(xpart);
  xfun=CAR(xlit);
  ylitcurinf=CAR(ylitinfpart);
  compl_yfunpure=MAKINUM(268435456^INUM(MAKINUM(534773760)&yfun));
  if(para_symb==CAR(derhistory)) {
    GLOBAL(param_tolit_global)=xlit;
    GLOBAL(param_eqlit_global)=ylit;
    GLOBAL(param_tocl_global)=xcl;
    GLOBAL(param_fromcl_global)=ycl;
    GLOBAL(param_left_arg_global)=CAR(CDR(CAR(CDR(ylit))));
    GLOBAL(param_right_arg_global)=CAR(CDR(CDR(CAR(CDR(ylit)))));
    GLOBAL(param_toinf_global)=xlitinf;
    GLOBAL(param_frominf_global)=ylitinf;
    GLOBAL(param_from_is_y_flag_global)=BOOL_T;
    GLOBAL(param_yclmaxvar_global)=yclmaxvar;
    GLOBAL(param_xclmaxvar_global)=give_cl_maxvar(xinf);
    GLOBAL(param_fromhist_global)=EOL;
    GLOBAL(param_tohist_global)=EOL;
    GLOBAL(param_fromlitnr_global)=ylitnr;
    GLOBAL(param_tolitnr_global)=xlitnr;
    param_use_left_flag_global=left_used_flag;
    if(!(NFALSEP(param_use_left_flag_global))) {
      GLOBAL(param_left_arg_global)=CAR(CDR(CDR(CAR(CDR(ylit)))));
      GLOBAL(param_right_arg_global)=CAR(CDR(CAR(CDR(ylit))));
    }
    subterm=subterm_at_path(GLOBAL(param_tolit_global),path);
    if(!(NUMBER_P(GLOBAL(param_left_arg_global)))) {
      GLOBAL(compare_ground_litcdr_equal_flag_global)=BOOL_T;
      if(!((MAKINUM(534773760)&CAR(subterm))==(MAKINUM(534773760)&CAR(GLOBAL(param_left_arg_global))))||!(NFALSEP(resolve_unify_ordinary(CAR(subterm),CAR(GLOBAL(param_left_arg_global)),subterm,GLOBAL(param_left_arg_global)))))
        report_error(const_90,cons(cons(subterm,cons(GLOBAL(param_left_arg_global),EOL)),EOL));
      GLOBAL(compare_ground_litcdr_equal_flag_global)=BOOL_F;
    }
    else
    if(MAKINUM(65535)>GLOBAL(param_left_arg_global)) {
      STBL_VECTOR_SET(_star_var_val_table_star__velts0,MAKINUM(8191)&GLOBAL(param_left_arg_global),subterm);
      xvars_set_flag_global=BOOL_F;
      yvars_set_flag_global=BOOL_T;
    }
    else
    if(!(GLOBAL(param_left_arg_global)==subterm))
      report_error(const_91,cons(cons(subterm,cons(GLOBAL(param_left_arg_global),EOL)),EOL));
    else {
      xvars_set_flag_global=BOOL_F;
      yvars_set_flag_global=BOOL_F;
    }
    tmpres=paramodulate_into_term_aux_typet(path,GLOBAL(param_right_arg_global),left_used_flag);
    return tmpres;
  }
  else
  if(hyper_symb==CAR(derhistory)) {
    GLOBAL(compare_ground_litcdr_equal_flag_global)=BOOL_T;
    if(!((compl_yfunpure==(MAKINUM(534773760)&xfun))&&NFALSEP(resolve_unify_ordinary(xfun,yfun,xlit,ylit))))
      report_error(const_92,cons(cons(xlit,cons(ylit,EOL)),EOL));
    GLOBAL(compare_ground_litcdr_equal_flag_global)=BOOL_F;
    ytmp=make_rest_inf_cl(ycl,ylit,CAR(CDR(CDR(yinf))));
    xtmp=make_rest_inf_cl(xcl,xlit,CAR(CDR(CDR(xinf))));
    res=make_raw_inf_cl_pair_typet_hyper(CAR(ylitinfpart),BOOL_T,CDR(xtmp),CDR(ytmp),CAR(xtmp),CAR(ytmp));
    clear_y_vars_and_touched_excl_(yclmaxvar);
    clear_x_vars_and_touched_excl_(give_cl_maxvar(xinf));
    res=history__grtr_ans_handle_derived_inf_cl_pair(res,cons(dummy_symb,cons(MAKINUM(0),EOL)),BOOL_F);
    return res;
  }
  else
    return UNSPECIFIED;
}

SCM history__grtr_ans_handle_derived_inf_cl_pair(pr,history,fac_gen_flag)
SCM pr,history,fac_gen_flag;
{
  SCM cl,inf,clauseinf,tmp_pr,kept_cl,litinfolst;

  cl=CDR(pr);
  inf=CAR(pr);
  clauseinf=EOL;
  tmp_pr=EOL;
  kept_cl=EOL;
  litinfolst=EOL;
  tmp_pr=remove_double_lits_excl_(inf,cl,GLOBAL(hyper_strategy_flag_global));
  tmp_pr=sort_clause(history__grtr_ans_handle_derived_inf_cl_pair_aux290(tmp_pr),BOOL_T);
  tmp_pr=cons(map1(history__grtr_ans_handle_derived_inf_cl_pair_fn148,tmp_pr),map1(history__grtr_ans_handle_derived_inf_cl_pair_fn149,tmp_pr));
  clauseinf=make_clause_info(CDR(tmp_pr),history);
  kept_cl=make_kept_clause(clauseinf,tmp_pr);
  litinfolst=map1(history__grtr_ans_handle_derived_inf_cl_pair_fn150,CAR(tmp_pr));
  SET_CAR(CDR(CDR(CAR(kept_cl))),litinfolst);
  return kept_cl;
}

SCM history__grtr_ans_handle_derived_inf_cl_pair_aux290(tmp_pr)
SCM tmp_pr;
{
  SCM new_var5,new_var6,new_var2,new_var3,new_var4;

  for(new_var5=CAR(tmp_pr),new_var6=CDR(tmp_pr),new_var2=EOL,new_var3=EOL,new_var4=EOL;
      PAIR_P(new_var5)&&PAIR_P(new_var6);
      new_var5=CDR(new_var5),new_var6=CDR(new_var6)) {
    new_var4=cons(CAR(new_var5),CAR(new_var6));
    if(NULL_P(new_var2)) {
      new_var2=cons(new_var4,EOL);
      new_var3=new_var2;
    }
    else {
      SET_CDR(new_var3,cons(new_var4,EOL));
      new_var3=CDR(new_var3);
    }
  }
  return new_var2;
}

SCM history__grtr_ans_handle_derived_inf_cl_pair_fn150(x)
SCM x;
{
  return CDR(CDR(x));
}

SCM history__grtr_ans_handle_derived_inf_cl_pair_fn149(x)
SCM x;
{
  return CDR(x);
}

SCM history__grtr_ans_handle_derived_inf_cl_pair_fn148(x)
SCM x;
{
  return CAR(x);
}

SCM make_raw_inf_cl_pair_typet_hyper(litinfel,nuc_is_y_flag,xcl,ycl,xinf,yinf)
SCM litinfel,nuc_is_y_flag,xcl,ycl,xinf,yinf;
{
  SCM nuc_ans_lit,elec_ans_lit,new_nuc_ans_lit,new_xrest,new_yrest;

  new_yrest=subst_deco_cl(ycl,yinf,MAKINUM(2),yvars_set_flag_global);
  GLOBAL(used_demodulators_global)=EOL;
  if(NFALSEP(new_yrest)) {
    new_xrest=subst_deco_cl(xcl,xinf,MAKINUM(1),xvars_set_flag_global);
    GLOBAL(used_demodulators_global)=EOL;
    if(NFALSEP(new_xrest)) {
      nuc_ans_lit=member_ans_lit((NFALSEP(nuc_is_y_flag) ? CDR(new_yrest) : CDR(new_xrest)));
      elec_ans_lit=member_ans_lit((NFALSEP(nuc_is_y_flag) ? CDR(new_xrest) : CDR(new_yrest)));
      new_nuc_ans_lit=EOL;
      if(NFALSEP(nuc_ans_lit)&&NFALSEP(elec_ans_lit)) {
        new_nuc_ans_lit=replace_subterm(CAR(nuc_ans_lit),cons(MAKINUM(1),cons(MAKINUM(INUM(GLOBAL(litinf_ordernr_mask_global)&CAR(litinfel))>>16),EOL)),CAR(CDR(CAR(elec_ans_lit))));
        if(NFALSEP(nuc_is_y_flag)) {
          new_yrest=cons(CAR(new_yrest),replace_one_eq(CAR(nuc_ans_lit),new_nuc_ans_lit,CDR(new_yrest)));
          new_xrest=make_rest_inf_cl(CDR(new_xrest),CAR(elec_ans_lit),CAR(new_xrest));
        }
        else {
          new_xrest=cons(CAR(new_xrest),replace_one_eq(CAR(nuc_ans_lit),new_nuc_ans_lit,CDR(new_xrest)));
          new_yrest=make_rest_inf_cl(CDR(new_yrest),CAR(elec_ans_lit),CAR(new_yrest));
        }
      }
      return cons(my_append_excl_(CAR(new_yrest),CAR(new_xrest)),my_append_excl_(CDR(new_yrest),CDR(new_xrest)));
    }
    else
      return BOOL_F;
  }
  else
    return BOOL_F;
}

SCM paramodulate_into_term_aux_typet(path,replterm,left_used_flag)
SCM path,replterm,left_used_flag;
{
  SCM newtype,lambdalit,lambdabody,newleft,newright,newlit,tmpto1,tmpfrom1,to_ans_lit_lst,from_ans_lit_lst,to_ans_lit,from_ans_lit,tmpto,tmpfrom,res1,res,subst_applic,new_ans_lit;

  GLOBAL(compare_ground_litcdr_equal_flag_global)=BOOL_F;
  newtype=subst_deco_term(CAR(CDR(CDR(CDR(CAR(CDR(GLOBAL(param_eqlit_global))))))),BOOL_F);
  lambdalit=subst_deco_replace_term(GLOBAL(param_tolit_global),path,GLOBAL(lambda_dummypar_nr_global),BOOL_T);
  lambdabody=map1(paramodulate_into_term_aux_typet_fn152,remove_ans_literals(replace_one_eq(GLOBAL(param_tolit_global),lambdalit,GLOBAL(param_tocl_global))));
  newleft=subst_deco_term(GLOBAL(param_left_arg_global),BOOL_F);
  newright=subst_deco_term(GLOBAL(param_right_arg_global),BOOL_F);
  newlit=subst_deco_replace_term(GLOBAL(param_tolit_global),path,replterm,BOOL_T);
  tmpto1=make_rest_inf_cl(GLOBAL(param_tocl_global),GLOBAL(param_tolit_global),GLOBAL(param_toinf_global));
  tmpfrom1=make_rest_inf_cl(GLOBAL(param_fromcl_global),GLOBAL(param_eqlit_global),GLOBAL(param_frominf_global));
  to_ans_lit_lst=member_ans_lit(CDR(tmpto1));
  from_ans_lit_lst=member_ans_lit(CDR(tmpfrom1));
  if(NFALSEP(to_ans_lit_lst))
    to_ans_lit=subst_deco_term(CAR(to_ans_lit_lst),BOOL_T);
  else
    to_ans_lit=BOOL_F;
  if(NFALSEP(from_ans_lit_lst))
    from_ans_lit=subst_deco_term(CAR(from_ans_lit_lst),BOOL_T);
  else
    from_ans_lit=BOOL_F;
  if(NFALSEP(to_ans_lit_lst))
    tmpto=make_rest_inf_cl(CDR(tmpto1),CAR(to_ans_lit_lst),CAR(tmpto1));
  else
    tmpto=tmpto1;
  if(NFALSEP(from_ans_lit_lst))
    tmpfrom=make_rest_inf_cl(CDR(tmpfrom1),CAR(from_ans_lit_lst),CAR(tmpfrom1));
  else
    tmpfrom=tmpfrom1;
  res1=make_raw_inf_cl_pair(CDR(tmpto1),CDR(tmpfrom1),CAR(tmpto1),CAR(tmpfrom1));
  res=make_raw_inf_cl_pair(CDR(tmpto),CDR(tmpfrom),CAR(tmpto),CAR(tmpfrom));
  subst_applic=EOL;
  new_ans_lit=EOL;
  clear_y_vars_and_touched_excl_(GLOBAL(param_yclmaxvar_global));
  clear_x_vars_and_touched_excl_(GLOBAL(param_xclmaxvar_global));
  if(!(NFALSEP(to_ans_lit)&&NFALSEP(from_ans_lit))) {
    res=cons(cons(cons(BOOL_T,cons(BOOL_F,cons(MAKINUM(0),EOL))),CAR(res1)),cons(newlit,CDR(res1)));
  }
  else {
    subst_applic=deco_leading_fun(cons(GLOBAL(ans_pred_nr_global),cons(deco_leading_fun(cons((NFALSEP(param_use_left_flag_global) ? GLOBAL(subst_fun_nr_global) : GLOBAL(subst_prim_fun_nr_global)),cons(newtype,cons(deco_leading_fun(cons(GLOBAL(lambda_fun_nr_global),cons(GLOBAL(lambda_dummypar_nr_global),lambdabody))),cons(newleft,cons(newright,cons(CAR(CDR(to_ans_lit)),cons(CAR(CDR(from_ans_lit)),EOL)))))))),EOL)));
    res=cons(cons(cons(BOOL_T,cons(BOOL_T,cons(MAKINUM(0),EOL))),CAR(res)),cons(newlit,CDR(res)));
    res=cons(cons(cons(BOOL_T,cons(BOOL_T,cons(GLOBAL(answer_litinf_global),EOL))),CAR(res)),cons(subst_applic,CDR(res)));
  }
  res=history__grtr_ans_handle_derived_inf_cl_pair(res,cons(dummy_symb,cons(MAKINUM(0),EOL)),BOOL_F);
  return res;
}

SCM paramodulate_into_term_aux_typet_fn152(x)
SCM x;
{
  if(x==GLOBAL(param_tolit_global))
    return CAR(CDR(x));
  else
    return CAR(CDR(subst_deco_term(x,BOOL_T)));
}

SCM make_input_clause(cl)
SCM cl;
{
  SCM lit,fun,clpart,strengthint,len,predsymbsint,weight,clinfo,litinfolst,tmp;

  cl=remove_duplicates(cl);
  litinfolst=make_input_litinfolst(cl);
  tmp=EOL;
  set_x_vars_selfref_touched_excl_(MAKINUM(255));
  cl=map1(make_input_clause_fn158,cl);
  GLOBAL(used_demodulators_global)=EOL;
  tmp=sort_clause(make_input_clause_aux291(litinfolst,cl),BOOL_T);
  cl=map1(make_input_clause_fn159,tmp);
  litinfolst=map1(make_input_clause_fn160,tmp);
  clause_var_nr_global=MAKINUM(0);
  if(NFALSEP(pure_clause_may_cont_vars_pred_(cl))) {
    cl=copy_list(cl);
    make_varinfo_lst_excl_(cl,cons(EOL,EOL));
    GLOBAL(new_var_names_global)=EOL;
    make_fulldeco_clause_excl_(cl);
  }
  strengthint=MAKINUM(0);
  len=MAKINUM(0);
  predsymbsint=MAKINUM(0);
  weight=MAKINUM(0);
  clinfo=EOL;
  for(clpart=cl;!(NULL_P(clpart));clpart=CDR(clpart)) {
    lit=CAR(clpart);
    fun=CAR(lit);
    if(NFALSEP(countable_pred_pred_(fun))) {
      if(ZERO_P(strengthint)) {
        strengthint=(MAKINUM(131071)&fun);
      }
      else {
        strengthint=sum_fun_strengths(fun,strengthint);
      }
      if(!(ZERO_P(predsymb_bit(fun)&predsymbsint))) {
        predsymbsint=(MAKINUM(134217728)|predsymbsint);
      }
      predsymbsint=(predsymb_bit(fun)|predsymbsint);
      len=MAKINUM(1+INUM(len));
      weight=MAKINUM(INUM(weight)+INUM(lit_weight(lit)));
    }
  }
  if(len>MAKINUM(63)) {
    len=MAKINUM(63);
  }
  if(clause_var_nr_global>MAKINUM(63)) {
    clause_var_nr_global=MAKINUM(63);
  }
  strengthint=((MAKINUM(INUM(len)<<17)|MAKINUM(INUM(clause_var_nr_global)<<23))|strengthint);
  GLOBAL(kept_cl_nr_global)=MAKINUM(1+INUM(GLOBAL(kept_cl_nr_global)));
  if(NFALSEP(GLOBAL(order_strategy_flag_global))||(NFALSEP(GLOBAL(name_order_strategy_flag_global))||(NFALSEP(GLOBAL(firstlitpref_order_strategy_flag_global))||(NFALSEP(GLOBAL(posweight_order_strategy_flag_global))||NFALSEP(GLOBAL(ordered_paramodulation_flag_global)))))) {
    litinfolst=map1(make_input_clause_fn161,order_prohibit_litinfos(map1(make_input_clause_fn162,litinfolst),cl));
  }
  clinfo=cons(strengthint,cons(predsymbsint,cons(litinfolst,cons(weight,cons(GLOBAL(kept_cl_nr_global),cons(cons(input_symb,cons(GLOBAL(kept_cl_nr_global),EOL)),EOL))))));
  tmp=cons(clinfo,cl);
  if(NFALSEP(GLOBAL(dynamic_demodulation_flag_global)))
    attempt_to_make_a_demodulator(tmp);
  return tmp;
}

SCM make_input_clause_aux291(litinfolst,cl)
SCM litinfolst,cl;
{
  SCM new_var5,new_var6,new_var2,new_var3,new_var4;

  for(new_var5=litinfolst,new_var6=cl,new_var2=EOL,new_var3=EOL,new_var4=EOL;
      PAIR_P(new_var5)&&PAIR_P(new_var6);
      new_var5=CDR(new_var5),new_var6=CDR(new_var6)) {
    new_var4=cons(CAR(new_var5),CAR(new_var6));
    if(NULL_P(new_var2)) {
      new_var2=cons(new_var4,EOL);
      new_var3=new_var2;
    }
    else {
      SET_CDR(new_var3,cons(new_var4,EOL));
      new_var3=CDR(new_var3);
    }
  }
  return new_var2;
}

SCM make_input_clause_fn162(x)
SCM x;
{
  return cons(EOL,cons(EOL,x));
}

SCM make_input_clause_fn161(x)
SCM x;
{
  return CDR(CDR(x));
}

SCM make_input_clause_fn160(x)
SCM x;
{
  return CAR(x);
}

SCM make_input_clause_fn159(x)
SCM x;
{
  return CDR(x);
}

SCM make_input_clause_fn158(x)
SCM x;
{
  return subst_deco_term(x,BOOL_T);
}

SCM remove_duplicates(lst)
SCM lst;
{
tailrecursion:
  if(NULL_P(lst))
    return EOL;
  else
  if(NFALSEP(member(CAR(lst),CDR(lst)))) {
    lst=CDR(lst);
    goto tailrecursion;
  }
  else
    return cons(CAR(lst),remove_duplicates(CDR(lst)));
}

SCM make_input_litinfolst(cl)
SCM cl;
{
  SCM clpart,nr,res;

  if(!(NFALSEP(GLOBAL(hyper_strategy_flag_global))))
    return make_input_litinfolist_aux(cl);
  else
  if(NFALSEP(positive_cl_pred_(cl)))
    return make_input_litinfolist_aux(cl);
  else {
    nr=MAKINUM(1);
    res=EOL;
    for(clpart=cl;!(NULL_P(clpart));clpart=CDR(clpart))
      if(!(ZERO_P(MAKINUM(268435456)&CAR(CAR(clpart))))) {
        res=cons(cons(MAKINUM(INUM(nr)<<16)|MAKINUM(INUM(GLOBAL(litinf_ordernr_mask_global)&MAKINUM(8))^8),EOL),res);
        nr=MAKINUM(1+INUM(nr));
      }
      else {
        res=cons(make_pos_lit_litinfo(CAR(clpart)),res);
      }
    return reverse(res);
  }
}

SCM make_input_litinfolist_aux(cl)
SCM cl;
{
  return map1(make_pos_lit_litinfo,cl);
}

SCM make_pos_lit_litinfo(x)
SCM x;
{
  if(NFALSEP(answer_lit_pred_(x)))
    return cons(GLOBAL(answer_litinf_global),EOL);
  else
  if((GLOBAL(eq_pred_nr_global)==(MAKINUM(534773760)&CAR(x)))&&NFALSEP(equal(CAR(CDR(x)),CAR(CDR(CDR(x))))))
    return cons(MAKINUM(8)|(MAKINUM(16)|MAKINUM(32)),EOL);
  else
  if(!(NUMBER_P(CAR(CDR(x))))&&((GLOBAL(eq_fun_nr_global)==(MAKINUM(534773760)&CAR(CAR(CDR(x)))))&&NFALSEP(equal(CAR(CDR(CAR(CDR(x)))),CAR(CDR(CDR(CAR(CDR(x)))))))))
    return cons(MAKINUM(8)|(MAKINUM(16)|MAKINUM(32)),EOL);
  else
    return cons(MAKINUM(0),EOL);
}

SCM make_varinfo_lst_excl_(cl,prevars)
SCM cl,prevars;
{
  SCM lit,fun,lcvars,follvars;

  if(NULL_P(cl))
    return EOL;
  else {
    lit=CAR(cl);
    fun=CAR(lit);
    if(ZERO_P(MAKINUM(65536)&fun))
      lcvars=collect_vars_composite_excl_(lit);
    else
      lcvars=cons(EOL,EOL);
    follvars=EOL;
    if(NFALSEP(answer_pred_pred_(fun))) {
      follvars=make_varinfo_lst_excl_(CDR(cl),cons(EOL,prevars));
    }
    else {
      follvars=make_varinfo_lst_excl_(CDR(cl),cons(CDR(lcvars),prevars));
    }
    if(ZERO_P(MAKINUM(65536)&fun)) {
      SET_CAR(cl,cons(lit,cons(CAR(lcvars),cons(CDR(lcvars),cons(append2(prevars,follvars),cons(follvars,EOL))))));
    }
    else {
      SET_CAR(cl,cons(lit,EOL));
    }
    if(NFALSEP(answer_pred_pred_(fun)))
      return cons(EOL,follvars);
    else
      return cons(CDR(lcvars),follvars);
  }
}

SCM make_fulldeco_clause_excl_(reslst)
SCM reslst;
{
  SCM el;

tailrecursion:
  if(!(NULL_P(reslst))) {
    el=CAR(reslst);
    if(ZERO_P(MAKINUM(65536)&CAR(CAR(el))))
      decorate_vars_lit_excl_(CAR(el),CAR(CDR(el)),CAR(CDR(CDR(el))),CAR(CDR(CDR(CDR(el)))),CAR(CDR(CDR(CDR(CDR(el))))));
    SET_CAR(reslst,CAR(el));
    reslst=CDR(reslst);
    goto tailrecursion;
  }
  else
    return UNSPECIFIED;
}

SCM pos_eq_pred_pred_(fn)
SCM fn;
{
  return SBOOL(GLOBAL(eq_pred_nr_global)==fn);
}

SCM pos_eq_fun_pred_(fn)
SCM fn;
{
  return SBOOL(GLOBAL(eq_fun_nr_global)==fn);
}

SCM fill_predsymb_bit_vector_excl_()
{
  SCM part,n,a,e,ef,cf,ifs,intlabel;

  a=assq(GLOBAL(ans_symbol_global),GLOBAL(pred_num_table_global));
  e=assq(GLOBAL(eq_symbol_global),GLOBAL(pred_num_table_global));
  ef=assq(GLOBAL(eq_fun_symbol_global),GLOBAL(fun_num_table_global));
  cf=assq(GLOBAL(case_fun_symbol_global),GLOBAL(fun_num_table_global));
  ifs=assq(GLOBAL(if_fun_symbol_global),GLOBAL(fun_num_table_global));
  if(NFALSEP(GLOBAL(int_logic_flag_global)))
    intlabel=assq(GLOBAL(int_outmost_symb_labelfun_global),GLOBAL(pred_num_table_global));
  else
    intlabel=BOOL_F;
  GLOBAL(ans_pred_nr_global)=MAKINUM(0);
  GLOBAL(eq_pred_nr_global)=MAKINUM(0);
  GLOBAL(eq_fun_nr_global)=MAKINUM(0);
  GLOBAL(case_fun_nr_global)=MAKINUM(0);
  GLOBAL(if_fun_nr_global)=MAKINUM(0);
  GLOBAL(int_outmost_label_fun_nr_global)=MAKINUM(0);
  if(NFALSEP(e)) {
    GLOBAL(pred_num_table_global)=cons(e,remove_eq(e,GLOBAL(pred_num_table_global)));
    GLOBAL(eq_pred_nr_global)=CDR(e);
  }
  if(NFALSEP(a)) {
    GLOBAL(pred_num_table_global)=cons(a,remove_eq(a,GLOBAL(pred_num_table_global)));
    GLOBAL(ans_pred_nr_global)=CDR(a);
  }
  if(NFALSEP(ef)) {
    GLOBAL(eq_fun_nr_global)=CDR(ef);
  }
  if(NFALSEP(cf)) {
    GLOBAL(case_fun_nr_global)=CDR(cf);
  }
  if(NFALSEP(ifs)) {
    GLOBAL(if_fun_nr_global)=CDR(ifs);
  }
  if(NFALSEP(intlabel)) {
    GLOBAL(int_outmost_label_fun_nr_global)=CDR(intlabel);
  }
  for(part=GLOBAL(pred_num_table_global),n=MAKINUM(1);
      !(NULL_P(part));
      part=CDR(part),n=((n<MAKINUM(4096)) ? MAKINUM(INUM(n)<<1) : MAKINUM(67108864))) {
    VECTOR_SET(GLOBAL(predsymb_bit_vector_global),MAKINUM(INUM(CDR(CAR(part)))>>21),n);
    VECTOR_SET(GLOBAL(predsymb_bit_vector_global),MAKINUM(INUM(MAKINUM(268435456)|CDR(CAR(part)))>>21),((n==MAKINUM(67108864)) ? MAKINUM(67108864) : MAKINUM(INUM(n)<<13)));
  }
  return UNSPECIFIED;
}

SCM turn_on_demodulation()
{
  GLOBAL(demodulate_flag_global)=BOOL_T;
  GLOBAL(dynamic_demodulation_flag_global)=BOOL_T;
  GLOBAL(new_demodulators_flag_global)=BOOL_T;
  GLOBAL(demodulate_constants_flag_global)=BOOL_F;
  GLOBAL(ordered_paramodulation_flag_global)=BOOL_T;
  return UNSPECIFIED;
}

SCM turn_off_demodulation()
{
  GLOBAL(demodulate_flag_global)=BOOL_F;
  GLOBAL(dynamic_demodulation_flag_global)=BOOL_F;
  GLOBAL(new_demodulators_flag_global)=BOOL_F;
  GLOBAL(demodulate_constants_flag_global)=BOOL_F;
  return UNSPECIFIED;
}

SCM init_binres_strat()
{
  GLOBAL(unit_strategy_flag_global)=BOOL_F;
  GLOBAL(user_criterias_post_flag_global)=BOOL_F;
  GLOBAL(factors_stratflag_global)=BOOL_T;
  GLOBAL(ordered_factor_flag_global)=BOOL_F;
  GLOBAL(name_order_strategy_flag_global)=BOOL_F;
  GLOBAL(firstlitpref_order_strategy_flag_global)=BOOL_F;
  GLOBAL(remove_identical_lit_stratflag_global)=BOOL_T;
  GLOBAL(paramodulation_allowed_flag_global)=BOOL_T;
  GLOBAL(hyper_strategy_flag_global)=BOOL_F;
  GLOBAL(type_theory_stratflag_global)=BOOL_F;
  GLOBAL(para_pos_unit_strategy_global)=BOOL_F;
  return UNSPECIFIED;
}

SCM init_binary_hyper_sos_strat()
{
  init_binres_strat();
  GLOBAL(binary_hyper_sos_strategy_global)=BOOL_T;
  return UNSPECIFIED;
}

SCM init_unit_strat()
{
  init_binres_strat();
  GLOBAL(unit_strategy_flag_global)=BOOL_T;
  return UNSPECIFIED;
}

SCM init_posweight_ordered_unit_strat()
{
  init_unit_strat();
  GLOBAL(posweight_order_strategy_flag_global)=BOOL_T;
  GLOBAL(ordered_factor_flag_global)=BOOL_F;
  return UNSPECIFIED;
}

SCM init_ordered_binres_strat()
{
  init_binres_strat();
  GLOBAL(order_strategy_flag_global)=BOOL_T;
  GLOBAL(name_order_strategy_flag_global)=BOOL_F;
  GLOBAL(ordered_factor_flag_global)=BOOL_F;
  return UNSPECIFIED;
}

SCM init_name_ordered_binres_strat()
{
  init_binres_strat();
  GLOBAL(order_strategy_flag_global)=BOOL_F;
  GLOBAL(name_order_strategy_flag_global)=BOOL_T;
  GLOBAL(ordered_factor_flag_global)=BOOL_F;
  return UNSPECIFIED;
}

SCM init_weight_ordered_binres_strat()
{
  init_binres_strat();
  GLOBAL(firstlitpref_order_strategy_flag_global)=BOOL_T;
  GLOBAL(ordered_factor_flag_global)=BOOL_F;
  return UNSPECIFIED;
}

SCM init_posweight_ordered_binres_strat()
{
  init_binres_strat();
  GLOBAL(posweight_order_strategy_flag_global)=BOOL_T;
  GLOBAL(ordered_factor_flag_global)=BOOL_F;
  return UNSPECIFIED;
}

SCM init_hyper_strat()
{
  GLOBAL(unit_strategy_flag_global)=BOOL_F;
  GLOBAL(user_criterias_post_flag_global)=BOOL_F;
  GLOBAL(factors_stratflag_global)=BOOL_T;
  GLOBAL(ordered_factor_flag_global)=BOOL_F;
  GLOBAL(name_order_strategy_flag_global)=BOOL_F;
  GLOBAL(remove_identical_lit_stratflag_global)=BOOL_T;
  GLOBAL(paramodulation_allowed_flag_global)=BOOL_T;
  GLOBAL(hyper_strategy_flag_global)=BOOL_T;
  GLOBAL(type_theory_stratflag_global)=BOOL_F;
  GLOBAL(para_pos_unit_strategy_global)=BOOL_T;
  return UNSPECIFIED;
}

SCM init_hyper_wos_strat()
{
  init_hyper_strat();
  GLOBAL(hyper_wos_strategy_flag_global)=BOOL_T;
  return UNSPECIFIED;
}

SCM init_ordered_hyper_strat()
{
  init_hyper_strat();
  GLOBAL(order_strategy_flag_global)=BOOL_T;
  return UNSPECIFIED;
}

SCM init_typet_strat()
{
  GLOBAL(user_criterias_post_flag_global)=BOOL_F;
  GLOBAL(factors_stratflag_global)=BOOL_F;
  GLOBAL(remove_identical_lit_stratflag_global)=BOOL_F;
  GLOBAL(paramodulation_allowed_flag_global)=BOOL_T;
  GLOBAL(hyper_strategy_flag_global)=BOOL_T;
  GLOBAL(type_theory_stratflag_global)=BOOL_T;
  GLOBAL(para_pos_unit_strategy_global)=BOOL_T;
  return UNSPECIFIED;
}

SCM init_synth_strat()
{
  GLOBAL(user_criterias_post_flag_global)=BOOL_F;
  GLOBAL(factors_stratflag_global)=BOOL_T;
  GLOBAL(ordered_factor_flag_global)=BOOL_F;
  GLOBAL(paramodulation_allowed_flag_global)=BOOL_T;
  GLOBAL(remove_identical_lit_stratflag_global)=BOOL_T;
  GLOBAL(hyper_strategy_flag_global)=BOOL_F;
  GLOBAL(type_theory_stratflag_global)=BOOL_F;
  GLOBAL(para_pos_unit_strategy_global)=BOOL_F;
  GLOBAL(classical_synth_stratflag_global)=BOOL_T;
  return UNSPECIFIED;
}

SCM init_binary_unit_depth_backdemod()
{
  init_binres_strat();
  turn_on_demodulation();
  GLOBAL(unit_equality_strat_global)=BOOL_T;
  GLOBAL(back_demodulate_flag_global)=BOOL_T;
  GLOBAL(order_equality_lex_strat_global)=BOOL_F;
  GLOBAL(sos_preference_ratio_global)=MAKINUM(0);
  return UNSPECIFIED;
}

SCM init_binary_unit_depth()
{
  init_binres_strat();
  turn_on_demodulation();
  GLOBAL(unit_equality_strat_global)=BOOL_T;
  GLOBAL(back_demodulate_flag_global)=BOOL_F;
  GLOBAL(order_equality_lex_strat_global)=BOOL_F;
  GLOBAL(sos_preference_ratio_global)=MAKINUM(0);
  return UNSPECIFIED;
}

SCM init_binary_unit_depth_sospref()
{
  init_binres_strat();
  turn_on_demodulation();
  GLOBAL(unit_equality_strat_global)=BOOL_T;
  GLOBAL(back_demodulate_flag_global)=BOOL_F;
  GLOBAL(order_equality_lex_strat_global)=BOOL_F;
  GLOBAL(sos_preference_ratio_global)=MAKINUM(0);
  return UNSPECIFIED;
}

SCM init_binary_unit_lex()
{
  init_binres_strat();
  turn_on_demodulation();
  GLOBAL(unit_equality_strat_global)=BOOL_T;
  GLOBAL(back_demodulate_flag_global)=BOOL_F;
  GLOBAL(order_equality_lex_strat_global)=BOOL_T;
  return UNSPECIFIED;
}

SCM init_binary_unit_lex_backdemod()
{
  init_binres_strat();
  turn_on_demodulation();
  GLOBAL(unit_equality_strat_global)=BOOL_T;
  GLOBAL(back_demodulate_flag_global)=BOOL_T;
  GLOBAL(order_equality_lex_strat_global)=BOOL_T;
  return UNSPECIFIED;
}

SCM init_one_pass_strategical_flags()
{
  GLOBAL(sos_preference_ratio_global)=MAKINUM(5);
  GLOBAL(split_strategy_flag_global)=BOOL_F;
  GLOBAL(sos_strategy_flag_global)=BOOL_T;
  GLOBAL(binary_hyper_sos_strategy_global)=BOOL_F;
  GLOBAL(hyper_wos_strategy_flag_global)=BOOL_F;
  GLOBAL(remove_all_tautologies_stratflag_global)=BOOL_T;
  GLOBAL(hyper_contradiction_strategy_global)=BOOL_F;
  GLOBAL(unit_clash_flag_global)=BOOL_F;
  GLOBAL(factors_stratflag_global)=BOOL_F;
  GLOBAL(back_subsume_stratflag_global)=BOOL_T;
  GLOBAL(remove_identical_lit_stratflag_global)=BOOL_T;
  GLOBAL(paramodulation_allowed_flag_global)=BOOL_T;
  GLOBAL(paramodulation_strategy_flag_global)=BOOL_T;
  GLOBAL(paramodulate_from_vars_stratflag_global)=BOOL_F;
  GLOBAL(para_pos_unit_strategy_global)=BOOL_F;
  GLOBAL(unit_strategy_flag_global)=BOOL_F;
  GLOBAL(hyper_strategy_flag_global)=BOOL_F;
  GLOBAL(order_strategy_flag_global)=BOOL_F;
  GLOBAL(name_order_strategy_flag_global)=BOOL_F;
  GLOBAL(firstlitpref_order_strategy_flag_global)=BOOL_F;
  GLOBAL(poslitpref_order_strategy_flag_global)=BOOL_F;
  GLOBAL(posweight_order_strategy_flag_global)=BOOL_F;
  GLOBAL(ordered_factor_flag_global)=BOOL_F;
  GLOBAL(neg_hyper_strategy_flag_global)=BOOL_F;
  GLOBAL(type_theory_stratflag_global)=BOOL_F;
  GLOBAL(int_logic_flag_global)=BOOL_F;
  GLOBAL(int_use_binres_flag_global)=BOOL_F;
  GLOBAL(classical_synth_stratflag_global)=BOOL_F;
  GLOBAL(int_use_hyperres_flag_global)=BOOL_F;
  GLOBAL(discr_tree_subsume_stratflag_global)=BOOL_T;
  GLOBAL(discr_depth_first_global)=BOOL_T;
  GLOBAL(ordered_paramodulation_flag_global)=BOOL_T;
  GLOBAL(unit_equality_strat_global)=BOOL_F;
  GLOBAL(back_demodulate_flag_global)=BOOL_F;
  GLOBAL(order_equality_lex_strat_global)=BOOL_F;
  GLOBAL(user_criterias_post_flag_global)=BOOL_F;
  GLOBAL(user_criterias_pre_flag_global)=BOOL_F;
  GLOBAL(clause_keepdepth_limit_global)=MAKINUM(0);
  GLOBAL(clause_keeplength_limit_global)=MAKINUM(0);
  GLOBAL(clause_uselength_limit_global)=MAKINUM(0);
  GLOBAL(clause_usenr_limits_global)=EOL;
  GLOBAL(special_insertion_place_global)=EOL;
  GLOBAL(clause_usedepth_limits_global)=EOL;
  GLOBAL(clause_usestruct_limits_global)=EOL;
  return UNSPECIFIED;
}

SCM empty_cl_pred_(cl)
SCM cl;
{
  SCM clpart,resflag,new_var2;

  if(NFALSEP(GLOBAL(int_logic_flag_global))) {
    new_var2=SBOOL(NULL_P(cl));
    if(NFALSEP(new_var2))
      return new_var2;
    else
    if(NULL_P(CDR(cl)))
      return SBOOL(GLOBAL(int_outmost_label_fun_nr_global)==(MAKINUM(534773760)&CAR(CAR(cl))));
    else
      return BOOL_F;
  }
  else {
    resflag=BOOL_T;
    for(clpart=cl;!(NULL_P(clpart)||!(NFALSEP(resflag)));clpart=CDR(clpart))
      if(!(NFALSEP(answer_pred_pred_(CAR(CAR(clpart)))))) {
        resflag=BOOL_F;
      }
    return resflag;
  }
}

SCM unit_cl_pred_(cl)
SCM cl;
{
  SCM clpart,count;

  if(NFALSEP(GLOBAL(classical_synth_stratflag_global)))
    return SBOOL(NULL_P(CDR(cl)));
  else {
    count=MAKINUM(0);
    for(clpart=cl;!(NULL_P(clpart)||(count==MAKINUM(2)));clpart=CDR(clpart))
      if(!(NFALSEP(answer_pred_pred_(CAR(CAR(clpart)))))) {
        if(count==MAKINUM(0)) {
          count=MAKINUM(1);
        }
        else {
          count=MAKINUM(2);
        }
      }
    return NOT(SBOOL(count==MAKINUM(2)));
  }
}

SCM first_nonans_lit(cl)
SCM cl;
{
  SCM clpart;

  for(clpart=cl;NFALSEP(answer_pred_pred_(CAR(CAR(clpart))));clpart=CDR(clpart)) ;
  return CAR(clpart);
}

SCM member_nonans_lit(cl)
SCM cl;
{
  SCM clpart;

  for(clpart=cl;NFALSEP(answer_pred_pred_(CAR(CAR(clpart))));clpart=CDR(clpart)) ;
  return clpart;
}

SCM member_ans_lit(cl)
SCM cl;
{
  SCM clpart;

  for(clpart=cl;!(NFALSEP(answer_pred_pred_(CAR(CAR(clpart)))));clpart=CDR(clpart)) ;
  return clpart;
}

SCM remove_ans_literals(cl)
SCM cl;
{
  SCM clpart,res,resend;

  res=cons(EOL,EOL);
  resend=res;
  for(clpart=cl;!(NULL_P(clpart));clpart=CDR(clpart))
    if(!(NFALSEP(answer_pred_pred_(CAR(CAR(clpart)))))) {
      SET_CDR(resend,cons(CAR(clpart),EOL));
      resend=CDR(resend);
    }
  return CDR(res);
}

SCM ground_fullcl_pred_(fullcl)
SCM fullcl;
{
  return NOT(SBOOL(ZERO_P(CAR(CAR(fullcl))&GLOBAL(cl_ground_flag_global))));
}

SCM positive_cl_pred_(cl)
SCM cl;
{
  SCM clpart,resflag;

  resflag=BOOL_T;
  for(clpart=cl;!(NULL_P(clpart)||!(NFALSEP(resflag)));clpart=CDR(clpart))
    if(!(ZERO_P(MAKINUM(268435456)&CAR(CAR(clpart))))) {
      resflag=BOOL_F;
    }
  return resflag;
}

SCM negative_cl_pred_(cl)
SCM cl;
{
  SCM clpart,resflag;

  resflag=BOOL_T;
  for(clpart=cl;!(NULL_P(clpart)||!(NFALSEP(resflag)));clpart=CDR(clpart))
    if(!(!(ZERO_P(MAKINUM(268435456)&CAR(CAR(clpart)))))) {
      resflag=BOOL_F;
    }
  return resflag;
}

SCM mixed_cl_pred_(cl)
SCM cl;
{
  SCM clpart,negflag,posflag;

  negflag=BOOL_F;
  posflag=BOOL_F;
  for(clpart=cl;!(NULL_P(clpart)||(NFALSEP(negflag)&&NFALSEP(posflag)));clpart=CDR(clpart))
    if(!(ZERO_P(MAKINUM(268435456)&CAR(CAR(clpart))))) {
      negflag=BOOL_T;
    }
    else {
      posflag=BOOL_T;
    }
  if(NFALSEP(negflag))
    return posflag;
  else
    return BOOL_F;
}

SCM has_single_hyper_premiss_pred_(cl)
SCM cl;
{
  SCM clpart,count;

  count=MAKINUM(0);
  for(clpart=cl;!(NULL_P(clpart)||(count==MAKINUM(2)));clpart=CDR(clpart))
    if(NFALSEP((NFALSEP(GLOBAL(neg_hyper_strategy_flag_global)) ? SBOOL(ZERO_P(MAKINUM(268435456)&CAR(CAR(clpart)))&&!(NFALSEP(answer_pred_pred_(CAR(CAR(clpart)))))) : SBOOL(!(ZERO_P(MAKINUM(268435456)&CAR(CAR(clpart)))))))) {
      if(count==MAKINUM(0)) {
        count=MAKINUM(1);
      }
      else {
        count=MAKINUM(2);
      }
    }
  return NOT(SBOOL(count==MAKINUM(2)));
}

SCM first_hyper_premiss_lit(cl)
SCM cl;
{
  SCM clpart;

  for(clpart=cl;!(NFALSEP((NFALSEP(GLOBAL(neg_hyper_strategy_flag_global)) ? SBOOL(ZERO_P(MAKINUM(268435456)&CAR(CAR(clpart)))&&!(NFALSEP(answer_pred_pred_(CAR(CAR(clpart)))))) : SBOOL(!(ZERO_P(MAKINUM(268435456)&CAR(CAR(clpart))))))));clpart=CDR(clpart)) ;
  return CAR(clpart);
}

SCM first_neg_lit(cl)
SCM cl;
{
  SCM clpart;

  for(clpart=cl;ZERO_P(MAKINUM(268435456)&CAR(CAR(clpart)));clpart=CDR(clpart)) ;
  return CAR(clpart);
}

SCM contains_eqlit_cl_pred_(cl)
SCM cl;
{
  SCM clpart;

  for(clpart=cl;!(NULL_P(clpart)||(GLOBAL(eq_pred_nr_global)==(MAKINUM(534773760)&CAR(CAR(clpart)))));clpart=CDR(clpart)) ;
  return NOT(SBOOL(NULL_P(clpart)));
}

SCM contains_eqorneg_cl_pred_(cl)
SCM cl;
{
  SCM clpart;

  for(clpart=cl;!(NULL_P(clpart)||(!(ZERO_P(MAKINUM(268435456)&CAR(CAR(clpart))))||(GLOBAL(eq_pred_nr_global)==(MAKINUM(534773760)&CAR(CAR(clpart))))));clpart=CDR(clpart)) ;
  return NOT(SBOOL(NULL_P(clpart)));
}

SCM commutative_fun_pred_(fun)
SCM fun;
{
  return BOOL_F;
}

SCM reflexive_fun_pred_(fun)
SCM fun;
{
  return BOOL_F;
}

SCM removable_tautology_pr_pred_(litinfcl_pr)
SCM litinfcl_pr;
{
  if(NFALSEP(GLOBAL(remove_all_tautologies_stratflag_global))&&NFALSEP(tautology_pure_cl_pred_(CDR(litinfcl_pr)))) {
    if(GLOBAL(display_info_level_global)>=MAKINUM(80)) {
      newline(cur_output_port());
      display(const_93,cur_output_port());
    }
    else
    if(NFALSEP(GLOBAL(display_info_char_flag_global)))
      display(const_94,cur_output_port());
    return BOOL_T;
  }
  else
    return BOOL_F;
}

SCM clause_pass_user_limits_post_pred_(purecl)
SCM purecl;
{
  SCM new_var2;

  if(ZERO_P(GLOBAL(clause_keepsize_limit_global))||NFALSEP(pass_keepsize_limit_pred_(purecl))) {
    if(ZERO_P(GLOBAL(clause_keepdepth_limit_global))||NFALSEP(pass_keepdepth_limit_pred_(purecl))) {
      new_var2=SBOOL(ZERO_P(GLOBAL(clause_keeplength_limit_global)));
      if(NFALSEP(new_var2))
        return new_var2;
      else
        return pass_keeplength_limit_pred_(purecl);
    }
    else
      return BOOL_F;
  }
  else
    return BOOL_F;
}

SCM pass_keepdepth_limit_pred_(purecl)
SCM purecl;
{
  return every_pred_(pass_keepdepth_limit_pred__fn164,purecl);
}

SCM pass_keepdepth_limit_pred__fn164(lit)
SCM lit;
{
  return SBOOL((INUM(MAKINUM(63488)&CAR(lit))>>11)<=INUM(GLOBAL(clause_keepdepth_limit_global)));
}

SCM pass_keepsize_limit_pred_(purecl)
SCM purecl;
{
  SCM part,sum_nonkeyword;

  sum_nonkeyword=MAKINUM(0);
  for(part=purecl;!(NULL_P(part)||(sum_nonkeyword>GLOBAL(clause_keepsize_limit_global)));part=CDR(part)) {
    sum_nonkeyword=MAKINUM(INUM(sum_nonkeyword)+(INUM(MAKINUM(2016)&CAR(CAR(part)))>>5));
  }
  return SBOOL(sum_nonkeyword<=GLOBAL(clause_keepsize_limit_global));
}

SCM pass_keeplength_limit_pred_(purecl)
SCM purecl;
{
  return SBOOL(length(purecl)<=GLOBAL(clause_keeplength_limit_global));
}

SCM clause_pass_user_crit_post_pred_(inflist,purecl,hist)
SCM inflist,purecl,hist;
{
  SCM new_var2;

  if(NULL_P(GLOBAL(clause_usenr_limits_global))||NFALSEP(hist_pass_usenr_limits_pred_(hist))) {
    if(NULL_P(GLOBAL(clause_usedepth_limits_global))||NFALSEP(hist_pass_usedepth_limits_pred_(hist))) {
      new_var2=SBOOL(NULL_P(GLOBAL(clause_usestruct_limits_global)));
      if(NFALSEP(new_var2))
        return new_var2;
      else
        return hist_pass_usestruct_limits_pred_(hist);
    }
    else
      return BOOL_F;
  }
  else
    return BOOL_F;
}

SCM hist_pass_usenr_limits_pred_(hist)
SCM hist;
{
  SCM countlst;

  countlst=map1(hist_pass_usenr_limits_pred__fn166,GLOBAL(clause_usenr_limits_global));
  return hist_count_check(countlst,hist);
}

SCM hist_pass_usenr_limits_pred__fn166(x)
SCM x;
{
  return cons(CAR(x),cons(MAKINUM(0),cons(CAR(CDR(x)),EOL)));
}

SCM hist_count_check(countlst,hist)
SCM countlst,hist;
{
  SCM constr;

tailrecursion:
  if(PAIR_P(hist)) {
    constr=CAR(hist);
    if(constr==hyper_symb) {
      if(NFALSEP(hist_count_check(countlst,CAR(CDR(CDR(hist))))))
        return every_pred__inst1(countlst,hist_count_check_fn168,CDR(CDR(CDR(hist))));
      else
        return BOOL_F;
    }
    else
    if(constr==literal_symb) {
      hist=CAR(CDR(hist));
      goto tailrecursion;
    }
    else
    if(constr==input_symb) {
      constr=assoc_memq(CAR(CDR(hist)),countlst);
      if(NFALSEP(constr)) {
        if(CAR(CDR(constr))==CAR(CDR(CDR(constr))))
          return BOOL_F;
        else {
          SET_CAR(CDR(constr),MAKINUM(1+INUM(CAR(CDR(constr)))));
          return BOOL_T;
        }
      }
      else
        return BOOL_T;
    }
    else
      return BOOL_T;
  }
  else
    return BOOL_T;
}

SCM hist_count_check_fn168(countlst,x)
SCM countlst,x;
{
  return hist_count_check(countlst,x);
}

SCM hist_pass_usedepth_limits_pred_(hist)
SCM hist;
{
  SCM constr,given,limit1,limit2;

  constr=CAR(hist);
  given=EOL;
  limit1=EOL;
  limit2=EOL;
  if(constr==para_symb) {
    limit1=CAR(CDR(CDR(hist)));
    limit2=CAR(CDR(CDR(CDR(hist))));
    if((input_symb==CAR(limit1))&&(NFALSEP((given=assq(CAR(CDR(limit1)),GLOBAL(clause_usedepth_limits_global)),UNSPECIFIED,given))&&NFALSEP(apply(GLOBAL(greater_clause_occ_depth_pred_),CAR(CDR(limit1)),cons(CDR(given),cons(limit2,listofnull))))))
      return BOOL_F;
    else
    if((input_symb==CAR(limit2))&&(NFALSEP((given=assq(CAR(CDR(limit2)),GLOBAL(clause_usedepth_limits_global)),UNSPECIFIED,given))&&NFALSEP(apply(GLOBAL(greater_clause_occ_depth_pred_),CAR(CDR(limit1)),cons(CDR(given),cons(limit1,listofnull))))))
      return BOOL_F;
    else
      return BOOL_T;
  }
  else
  if(constr==hyper_symb) {
    given=assq(CAR(CDR(CDR(hist))),GLOBAL(clause_usedepth_limits_global));
    if(!(NFALSEP(given)))
      return BOOL_T;
    else
      return NOT(apply(GLOBAL(greater_clause_occ_depth_pred_),CAR(CDR(CDR(hist))),cons(CDR(given),listofnull)));
  }
  else
    return UNSPECIFIED;
}

SCM hist_pass_usestruct_limits_pred_(hist)
SCM hist;
{
  SCM place,constr,res,one_found,tmp;

  constr=CAR(hist);
  res=BOOL_F;
  one_found=BOOL_F;
  tmp=EOL;
  if(constr==hyper_symb) {
    tmp=CAR(CDR(CAR(CDR(CDR(hist)))));
    for(place=member_if_inst1(tmp,hist_pass_usestruct_limits_pred__fn171,GLOBAL(clause_usestruct_limits_global));!(NULL_P(place)||(!(NFALSEP(place))||NFALSEP(res)));place=member_if_inst1(tmp,hist_pass_usestruct_limits_pred__fn172,CDR(place))) {
      one_found=BOOL_T;
      if(NFALSEP(hist_pass_usestruct_limits_hyper_pred_(hist,CAR(place)))) {
        res=BOOL_T;
      }
    }
    if(NFALSEP(res))
      return BOOL_T;
    else
      return NOT(one_found);
  }
  else
    return BOOL_T;
}

SCM hist_pass_usestruct_limits_pred__fn172(tmp,x)
SCM tmp,x;
{
  return SBOOL(CAR(x)==tmp);
}

SCM hist_pass_usestruct_limits_pred__fn171(tmp,x)
SCM tmp,x;
{
  return SBOOL(CAR(x)==tmp);
}

SCM hist_pass_usestruct_limits_hyper_pred_(hist,limitcase)
SCM hist,limitcase;
{
  SCM els,nr,res,tmp;

  nr=CAR(CDR(CAR(CDR(CDR(hist)))));
  res=BOOL_T;
  tmp=EOL;
  for(els=CDR(CDR(CDR(hist)));!(NULL_P(els)||!(NFALSEP(res)));els=CDR(els))
    if(PAIR_P(CAR(els))&&NFALSEP((tmp=get_hyper_hist_el_limitnr(CAR(els)),UNSPECIFIED,SBOOL(!(NFALSEP(some_pred__inst2(tmp,hist_pass_usestruct_limits_hyper_pred__fn174,CDR(limitcase)))))))) {
      res=BOOL_F;
    }
  return res;
}

SCM hist_pass_usestruct_limits_hyper_pred__fn174(tmp,x)
SCM tmp,x;
{
  return SBOOL((x==tmp)||(PAIR_P(x)&&(CAR(x)==tmp)));
}

SCM get_hyper_hist_el_limitnr(hist)
SCM hist;
{
tailrecursion:
  if(literal_symb==CAR(hist)) {
    hist=CAR(CDR(hist));
    goto tailrecursion;
  }
  else
  if(input_symb==CAR(hist))
    return CAR(CDR(hist));
  else
  if((hyper_symb==CAR(hist))||(fact_symb==CAR(hist))) {
    hist=CAR(CDR(CDR(hist)));
    goto tailrecursion;
  }
  else
    return MAKINUM(0);
}

SCM init_globals()
{
  init_one_pass_globals();
  GLOBAL(unit_equality_strat_global)=BOOL_F;
  GLOBAL(back_demodulate_flag_global)=BOOL_F;
  GLOBAL(order_equality_lex_strat_global)=BOOL_F;
  GLOBAL(use_real_time_global)=BOOL_F;
  GLOBAL(keep_all_old_clauses_flag_global)=BOOL_F;
  GLOBAL(timelimit_global)=BOOL_F;
  GLOBAL(foundflag_global)=BOOL_F;
  GLOBAL(given_checkpoint_keptnrs_global)=EOL;
  GLOBAL(checkpoint_keptnrs_global)=EOL;
  GLOBAL(sos_strategy_flag_global)=BOOL_T;
  GLOBAL(ans_prohibited_funsymbs_global)=EOL;
  GLOBAL(ans_prohibited_constsymbs_global)=EOL;
  GLOBAL(ans_prohibited_predsymbs_global)=EOL;
  GLOBAL(ans_prohibited_funnrs_global)=EOL;
  GLOBAL(ans_prohibited_constnrs_global)=EOL;
  GLOBAL(ans_prohibited_prednrs_global)=EOL;
  GLOBAL(discr_tree_list_global)=EOL;
  GLOBAL(unit_alist_list_global)=EOL;
  GLOBAL(sos_clauses_list_list_global)=EOL;
  GLOBAL(usable_clauses_list_list_global)=EOL;
  GLOBAL(lex_symbol_orderlst_global)=EOL;
  GLOBAL(unit_alist_global)=EOL;
  GLOBAL(clause_keepsize_limit_global)=MAKINUM(0);
  GLOBAL(clause_keepdepth_limit_global)=MAKINUM(0);
  GLOBAL(clause_keeplength_limit_global)=MAKINUM(0);
  GLOBAL(clause_uselength_limit_global)=MAKINUM(0);
  GLOBAL(prolog_style_variables_global)=BOOL_F;
  GLOBAL(const_num_table_global)=EOL;
  GLOBAL(const_num_global)=MAKINUM(0);
  GLOBAL(min_const_num_sub1_global)=MAKINUM(100000);
  GLOBAL(fun_num_table_global)=EOL;
  GLOBAL(fun_num_global)=MAKINUM(0);
  GLOBAL(min_fun_num_sub1_global)=MAKINUM(0);
  GLOBAL(max_nr_of_funs_global)=MAKINUM(255);
  GLOBAL(pred_num_table_global)=EOL;
  GLOBAL(pred_num_global)=MAKINUM(0);
  GLOBAL(min_pred_num_sub1_global)=MAKINUM(0);
  GLOBAL(max_nr_of_preds_global)=MAKINUM(127);
  GLOBAL(var_num_table_global)=EOL;
  GLOBAL(var_num_global)=MAKINUM(0);
  GLOBAL(min_var_num_sub1_global)=MAKINUM(0);
  GLOBAL(max_nr_of_vars_in_clause_global)=MAKINUM(255);
  return UNSPECIFIED;
}

SCM init_one_pass_globals()
{
  GLOBAL(hyper_contradiction_strategy_global)=BOOL_F;
  GLOBAL(clause_usenr_limits_global)=EOL;
  GLOBAL(clause_usedepth_limits_global)=EOL;
  GLOBAL(clause_usestruct_limits_global)=EOL;
  GLOBAL(one_pass_kept_clauses_firstnr_global)=MAKINUM(1+INUM(GLOBAL(kept_clauses_nr_global)));
  GLOBAL(foundflag_global)=BOOL_F;
  GLOBAL(answer_cl_global)=EOL;
  GLOBAL(answer_history_global)=EOL;
  GLOBAL(too_many_vars_flag_global)=BOOL_F;
  GLOBAL(lex_symbol_orderlst_global)=EOL;
  GLOBAL(sos_clauses_list_global)=EOL;
  GLOBAL(sos_clauses_list_end_global)=EOL;
  GLOBAL(ans_input_sos_global)=EOL;
  GLOBAL(usable_clauses_list_global)=EOL;
  GLOBAL(usable_clauses_list_end_global)=EOL;
  GLOBAL(subsumption_list_global)=cons(cons(MAKINUM(0),EOL),EOL);
  GLOBAL(unit_alist_global)=EOL;
  GLOBAL(discr_tree_global)=cons(EOL,EOL);
  GLOBAL(nonunit_discr_tree_global)=cons(EOL,EOL);
  GLOBAL(discr_tree_demod_terms_global)=cons(EOL,EOL);
  GLOBAL(discr_tree_demod_atoms_global)=cons(EOL,EOL);
  GLOBAL(sos_clauses_list_list_global)=EOL;
  GLOBAL(usable_clauses_list_list_global)=EOL;
  return UNSPECIFIED;
}

SCM init_stats()
{
  GLOBAL(given_clause_nr_global)=MAKINUM(0);
  GLOBAL(derived_clauses_nr_global)=MAKINUM(0);
  GLOBAL(kept_clauses_nr_global)=MAKINUM(0);
  GLOBAL(last_usable_cl_nr_global)=MAKINUM(0);
  GLOBAL(kept_mid_nucleus_nr_global)=MAKINUM(0);
  GLOBAL(kept_new_demodulators_nr_global)=MAKINUM(0);
  GLOBAL(forward_subsumed_unit_nr_global)=MAKINUM(0);
  GLOBAL(forward_subsumed_nonunit_nr_global)=MAKINUM(0);
  GLOBAL(forward_subsumed_double_nr_global)=MAKINUM(0);
  GLOBAL(forward_subsumed_overdouble_nr_global)=MAKINUM(0);
  GLOBAL(back_subsumed_nr_global)=MAKINUM(0);
  GLOBAL(havealready_timecounter_global)=MAKINUM(0);
  GLOBAL(simple_unit_cutoff_nr_global)=MAKINUM(0);
  GLOBAL(full_unit_cutoff_nr_global)=MAKINUM(0);
  GLOBAL(double_unit_cutoff_nr_global)=MAKINUM(0);
  GLOBAL(proof_start_real_time_global)=apply(GLOBAL(get_internal_real_time),EOL,EOL);
  GLOBAL(proof_start_run_time_global)=my_time();
  GLOBAL(subs_tried_nr_global)=MAKINUM(0);
  GLOBAL(subs_length_fail_nr_global)=MAKINUM(0);
  GLOBAL(subs_strength_fail_nr_global)=MAKINUM(0);
  GLOBAL(subs_aux_strength_fail_nr_global)=MAKINUM(0);
  GLOBAL(subs_gclpreds_fail_nr_global)=MAKINUM(0);
  GLOBAL(subs_funlist_fail_nr_global)=MAKINUM(0);
  GLOBAL(subs_reg_subs_tried_nr_global)=MAKINUM(0);
  GLOBAL(subs_reg_subs_fail_nr_global)=MAKINUM(0);
  return UNSPECIFIED;
}

SCM show_stats()
{
  show_main_stats();
  return show_subsumption_stats();
}

SCM show_main_stats()
{
  newline(cur_output_port());
  display(const_95,cur_output_port());
  newline(cur_output_port());
  display(const_96,cur_output_port());
  display(GLOBAL(given_clause_nr_global),cur_output_port());
  newline(cur_output_port());
  display(const_97,cur_output_port());
  display(GLOBAL(derived_clauses_nr_global),cur_output_port());
  newline(cur_output_port());
  display(const_98,cur_output_port());
  display(GLOBAL(kept_clauses_nr_global),cur_output_port());
  newline(cur_output_port());
  display(const_99,cur_output_port());
  display(GLOBAL(kept_mid_nucleus_nr_global),cur_output_port());
  newline(cur_output_port());
  display(const_100,cur_output_port());
  display(GLOBAL(kept_new_demodulators_nr_global),cur_output_port());
  newline(cur_output_port());
  display(const_101,cur_output_port());
  display(GLOBAL(forward_subsumed_unit_nr_global),cur_output_port());
  newline(cur_output_port());
  display(const_102,cur_output_port());
  display(GLOBAL(forward_subsumed_double_nr_global),cur_output_port());
  newline(cur_output_port());
  display(const_103,cur_output_port());
  display(GLOBAL(forward_subsumed_overdouble_nr_global),cur_output_port());
  newline(cur_output_port());
  display(const_104,cur_output_port());
  display(GLOBAL(back_subsumed_nr_global),cur_output_port());
  newline(cur_output_port());
  display(const_105,cur_output_port());
  display(GLOBAL(simple_unit_cutoff_nr_global),cur_output_port());
  newline(cur_output_port());
  display(const_106,cur_output_port());
  display(GLOBAL(full_unit_cutoff_nr_global),cur_output_port());
  newline(cur_output_port());
  display(const_107,cur_output_port());
  display(GLOBAL(double_unit_cutoff_nr_global),cur_output_port());
  newline(cur_output_port());
  display(const_108,cur_output_port());
  display_time_seconds(MAKINUM(INUM(apply(GLOBAL(get_internal_real_time),EOL,EOL))-INUM(GLOBAL(proof_start_real_time_global))));
  newline(cur_output_port());
  display(const_109,cur_output_port());
  display_time_seconds(MAKINUM(INUM(my_time())-INUM(GLOBAL(proof_start_run_time_global))));
  return newline(cur_output_port());
}

SCM show_subsumption_stats()
{
  display(const_110,cur_output_port());
  newline(cur_output_port());
  display(const_111,cur_output_port());
  display(GLOBAL(subs_tried_nr_global),cur_output_port());
  newline(cur_output_port());
  display(const_112,cur_output_port());
  display(GLOBAL(subs_length_fail_nr_global),cur_output_port());
  newline(cur_output_port());
  display(const_113,cur_output_port());
  display(GLOBAL(subs_strength_fail_nr_global),cur_output_port());
  newline(cur_output_port());
  display(const_114,cur_output_port());
  display(GLOBAL(subs_gclpreds_fail_nr_global),cur_output_port());
  newline(cur_output_port());
  display(const_115,cur_output_port());
  display(GLOBAL(subs_aux_strength_fail_nr_global),cur_output_port());
  newline(cur_output_port());
  display(const_116,cur_output_port());
  display(GLOBAL(subs_funlist_fail_nr_global),cur_output_port());
  newline(cur_output_port());
  display(const_117,cur_output_port());
  display(GLOBAL(subs_reg_subs_tried_nr_global),cur_output_port());
  newline(cur_output_port());
  display(const_118,cur_output_port());
  display(GLOBAL(subs_reg_subs_fail_nr_global),cur_output_port());
  return newline(cur_output_port());
}

SCM display_time_seconds(units)
SCM units;
{
  SCM full,rest;

  full=MAKINUM(INUM(units)/INUM(GLOBAL(internal_time_units_per_second)));
  rest=MAKINUM(INUM(units)%INUM(GLOBAL(internal_time_units_per_second)));
  display(full,cur_output_port());
  display(MAKICHR('.'),cur_output_port());
  return display(rest,cur_output_port());
}

SCM fprove(filename)
SCM filename;
{
  SCM tmpname,rawlst,clauselst,readylst,res;

  init_globals();
  GLOBAL(auto_mode_flag_global)=BOOL_T;
  GLOBAL(display_info_level_global)=MAKINUM(40);
  preprocess_otter_file(filename);
  tmpname=GLOBAL(otter_tmpfile_global);
  rawlst=read_processed_otter_file(tmpname);
  clauselst=read_otter_list_clauses(rawlst);
  readylst=EOL;
  res=BOOL_F;
  GLOBAL(ans_prohibited_constsymbs_global)=EOL;
  GLOBAL(ans_prohibited_predsymbs_global)=EOL;
  GLOBAL(ans_prohibited_funsymbs_global)=EOL;
  readylst=sort_out_otter_list_clauses(clauselst);
  res=prove(readylst,MAKINUM(99999999),MAKINUM(50));
  if(NFALSEP(res)) {
    if(GLOBAL(display_info_level_global)>=MAKINUM(30)) {
      newline(cur_output_port());
      if(!(NULL_P(GLOBAL(answer_cl_global)))) {
        display(const_119,cur_output_port());
        print_pure_clause(GLOBAL(answer_cl_global));
        newline(cur_output_port());
      }
      show_history(GLOBAL(answer_history_global));
      BOOL_T;
    }
    else
      BOOL_T;
  }
  else
  if(GLOBAL(display_info_level_global)>=MAKINUM(30)) {
    if(GLOBAL(answer_history_global)==not_enough_time_symb) {
      newline(cur_output_port());
      display(const_120,cur_output_port());
      newline(cur_output_port());
      BOOL_F;
    }
    else {
      newline(cur_output_port());
      display(const_121,cur_output_port());
      newline(cur_output_port());
      BOOL_F;
    }
  }
  else
    BOOL_F;
  if(GLOBAL(display_info_level_global)>=MAKINUM(35))
    show_stats();
  if(NFALSEP(res))
    return BOOL_T;
  else
    return BOOL_F;
}

SCM use_input_settings(raw_input)
SCM raw_input;
{
  SCM setlist,clearlist,assignlist;

  setlist=assq(set_symb,raw_input);
  clearlist=assq(clear_symb,raw_input);
  assignlist=assq(assign_symb,raw_input);
  if(!(NFALSEP(setlist))) {
    setlist=EOL;
  }
  if(!(NFALSEP(clearlist))) {
    clearlist=EOL;
  }
  if(!(NFALSEP(assignlist))) {
    assignlist=EOL;
  }
  for_each1(use_input_settings_fn178,setlist);
  for_each1(use_input_settings_fn179,clearlist);
  return for_each1(use_input_settings_fn180,assignlist);
}

SCM use_input_settings_fn180(el)
SCM el;
{
  SCM new_var2;

  new_var2=NOT(SBOOL(PAIR_P(el)));
  if(NFALSEP(new_var2))
    return new_var2;
  else {
    new_var2=NOT(SBOOL(PAIR_P(CDR(el))));
    if(NFALSEP(new_var2))
      return new_var2;
    else
    if(checkpoints_symb==CAR(el)) {
      GLOBAL(given_checkpoint_keptnrs_global)=CDR(CAR(CDR(el)));
      return UNSPECIFIED;
    }
    else
    if(max_kept_symb==CAR(el)) {
      GLOBAL(max_kept_clauses_nr_global)=CAR(CDR(el));
      return UNSPECIFIED;
    }
    else
    if(max_seconds_symb==CAR(el)) {
      GLOBAL(timelimit_global)=number2string(CAR(CDR(el)),MAKINUM(10));
      return UNSPECIFIED;
    }
    else
    if(print_level_symb==CAR(el)) {
      GLOBAL(display_info_level_global)=CAR(CDR(el));
      return UNSPECIFIED;
    }
    else
    if(max_literals_symb==CAR(el)) {
      GLOBAL(clause_keeplength_limit_global)=CAR(CDR(el));
      return UNSPECIFIED;
    }
    else
    if(max_weight_symb==CAR(el)) {
      GLOBAL(clause_keepsize_limit_global)=CAR(CDR(el));
      return UNSPECIFIED;
    }
    else
    if(max_depth_symb==CAR(el)) {
      GLOBAL(clause_keepdepth_limit_global)=CAR(CDR(el));
      return UNSPECIFIED;
    }
    else
      return UNSPECIFIED;
  }
}

SCM use_input_settings_fn179(el)
SCM el;
{
  SCM new_var2;

  new_var2=NOT(SBOOL(PAIR_P(el)));
  if(NFALSEP(new_var2))
    return new_var2;
  else {
    new_var2=NOT(SBOOL(PAIR_P(CDR(el))));
    if(NFALSEP(new_var2))
      return new_var2;
    else
    if(el==GLOBAL(paramodulate)) {
      GLOBAL(paramodulation_allowed_flag_global)=BOOL_F;
      return UNSPECIFIED;
    }
    else
    if(el==demodulate_symb)
      return turn_off_demodulation();
    else
      return UNSPECIFIED;
  }
}

SCM use_input_settings_fn178(el)
SCM el;
{
  if(el==auto_symb) {
    GLOBAL(auto_mode_flag_global)=BOOL_T;
    return UNSPECIFIED;
  }
  else
  if(el==hyper_res_symb) {
    GLOBAL(auto_mode_flag_global)=BOOL_F;
    return init_hyper_strat();
  }
  else
  if(el==hyper_order_res_symb) {
    GLOBAL(auto_mode_flag_global)=BOOL_F;
    return init_ordered_hyper_strat();
  }
  else
  if(el==binary_res_symb) {
    GLOBAL(auto_mode_flag_global)=BOOL_F;
    return init_binres_strat();
  }
  else
  if(el==binary_order_res_symb) {
    GLOBAL(auto_mode_flag_global)=BOOL_F;
    return init_ordered_binres_strat();
  }
  else
  if(el==binary_nameorder_res_symb) {
    GLOBAL(auto_mode_flag_global)=BOOL_F;
    return init_name_ordered_binres_strat();
  }
  else
  if(el==binary_weightorder_res_symb) {
    GLOBAL(auto_mode_flag_global)=BOOL_F;
    return init_weight_ordered_binres_strat();
  }
  else
  if(el==binary_posweightorder_res_symb) {
    GLOBAL(auto_mode_flag_global)=BOOL_F;
    return init_posweight_ordered_binres_strat();
  }
  else
  if(el==binary_hypersos_res_symb) {
    GLOBAL(auto_mode_flag_global)=BOOL_F;
    return init_binary_hyper_sos_strat();
  }
  else
  if(el==binary_unit_res_symb) {
    GLOBAL(auto_mode_flag_global)=BOOL_F;
    return init_unit_strat();
  }
  else
  if(el==binary_posweightunit_res_symb) {
    GLOBAL(auto_mode_flag_global)=BOOL_F;
    return init_posweight_ordered_unit_strat();
  }
  else
  if(el==binary_synth_res_symb) {
    GLOBAL(auto_mode_flag_global)=BOOL_F;
    return init_synth_strat();
  }
  else
  if(el==eq_order_lex_symb) {
    GLOBAL(order_equality_lex_strat_global)=BOOL_T;
    return UNSPECIFIED;
  }
  else
  if(el==eq_order_depth_symb) {
    GLOBAL(order_equality_lex_strat_global)=BOOL_F;
    return UNSPECIFIED;
  }
  else
  if(el==check_hypercontra_symb) {
    GLOBAL(hyper_contradiction_strategy_global)=BOOL_T;
    return UNSPECIFIED;
  }
  else
  if(el==demodulate_symb)
    return turn_on_demodulation();
  else
  if(el==back_demodulate_symb) {
    turn_on_demodulation();
    GLOBAL(back_demodulate_flag_global)=BOOL_T;
    return UNSPECIFIED;
  }
  else
  if(el==split_symb) {
    GLOBAL(split_strategy_flag_global)=BOOL_T;
    return UNSPECIFIED;
  }
  else
  if(el==wall_time_symb) {
    GLOBAL(use_real_time_global)=BOOL_T;
    return UNSPECIFIED;
  }
  else
  if(print_tracechar_symb==el) {
    GLOBAL(display_info_char_flag_global)=BOOL_T;
    return UNSPECIFIED;
  }
  else
  if(print_debug_symb==el) {
    GLOBAL(display_debug_info_flag_global)=BOOL_T;
    return UNSPECIFIED;
  }
  else
  if(el==prolog_style_variables_symb) {
    GLOBAL(prolog_style_variables_global)=BOOL_T;
    return UNSPECIFIED;
  }
  else
    return UNSPECIFIED;
}

SCM mtest()
{
  SCM lst,res;

  preprocess_otter_file(const_122);
  lst=read_processed_otter_file(const_123);
  res=read_otter_list_clauses(lst);
  newline(cur_output_port());
  return for_each1(mtest_fn182,res);
}

SCM mtest_fn182(x)
SCM x;
{
  display(x,cur_output_port());
  return newline(cur_output_port());
}

SCM sort_out_otter_list_clauses(otterlst)
SCM otterlst;
{
  SCM part,soslist,usablelist,axiomslist,demodlist,commandlist,setlist,clearlist,assignlist,cl,curlist,eol_reached,res;

  soslist=EOL;
  usablelist=EOL;
  axiomslist=EOL;
  demodlist=EOL;
  commandlist=EOL;
  setlist=EOL;
  clearlist=EOL;
  assignlist=EOL;
  cl=EOL;
  curlist=EOL;
  eol_reached=BOOL_T;
  res=EOL;
  for(part=otterlst;!(NULL_P(part));part=CDR(part)) {
    cl=CAR(part);
    if(!(PAIR_P(cl)))
      report_error(const_124,cons(cl,EOL));
    else
    if(CAR(cl)==end_of_list_symb) {
      eol_reached=BOOL_T;
      curlist=BOOL_F;
    }
    else
    if(!(PAIR_P(CAR(cl))))
      report_error(const_125,cons(cl,EOL));
    else
    if(prohibit_ans_pred_symb==CAR(CAR(cl))) {
      GLOBAL(ans_prohibited_predsymbs_global)=CAR(CDR(CAR(cl)));
    }
    else
    if(prohibit_ans_fun_symb==CAR(CAR(cl))) {
      GLOBAL(ans_prohibited_funsymbs_global)=CAR(CDR(CAR(cl)));
    }
    else
    if(prohibit_ans_const_symb==CAR(CAR(cl))) {
      GLOBAL(ans_prohibited_constsymbs_global)=CAR(CDR(CAR(cl)));
    }
    else
    if(NULL_P(CDR(cl))&&(NFALSEP(eol_reached)&&((list_symb==CAR(CAR(cl)))&&(sos_symb==CAR(CDR(CAR(cl))))))) {
      eol_reached=BOOL_F;
      curlist=sos_symb;
    }
    else
    if(NULL_P(CDR(cl))&&(NFALSEP(eol_reached)&&((list_symb==CAR(CAR(cl)))&&(usable_symb==CAR(CDR(CAR(cl))))))) {
      eol_reached=BOOL_F;
      curlist=usable_symb;
    }
    else
    if(NULL_P(CDR(cl))&&(NFALSEP(eol_reached)&&((list_symb==CAR(CAR(cl)))&&(axioms_symb==CAR(CDR(CAR(cl))))))) {
      eol_reached=BOOL_F;
      curlist=axioms_symb;
    }
    else
    if(NULL_P(CDR(cl))&&(NFALSEP(eol_reached)&&((list_symb==CAR(CAR(cl)))&&(demodulators_symb==CAR(CDR(CAR(cl))))))) {
      eol_reached=BOOL_F;
      curlist=demodulators_symb;
    }
    else
    if(curlist==sos_symb) {
      soslist=cons(cl,soslist);
    }
    else
    if(curlist==usable_symb) {
      usablelist=cons(cl,usablelist);
    }
    else
    if(curlist==axioms_symb) {
      axiomslist=cons(cl,axiomslist);
    }
    else
    if(curlist==demodulators_symb) {
      demodlist=cons(cl,demodlist);
    }
    else
    if(set_symb==CAR(CAR(cl))) {
      if(!(PAIR_P(CDR(CAR(cl)))))
        report_error(const_126,cons(cl,EOL));
      setlist=cons(CAR(CDR(CAR(cl))),setlist);
    }
    else
    if(clear_symb==CAR(CAR(cl))) {
      if(!(PAIR_P(CDR(CAR(cl)))))
        report_error(const_127,cons(cl,EOL));
      clearlist=cons(CAR(CDR(CAR(cl))),clearlist);
    }
    else
    if(assign_symb==CAR(CAR(cl))) {
      if(!(PAIR_P(CDR(CAR(cl))))||!(PAIR_P(CDR(CDR(CAR(cl))))))
        report_error(const_128,cons(cl,EOL));
      assignlist=cons(CDR(CAR(cl)),assignlist);
    }
    else {
      commandlist=cons(cl,commandlist);
    }
  }
  if(!(NULL_P(soslist))) {
    res=cons(cons(sos_symb,reverse(prop_conv(soslist))),res);
  }
  if(!(NULL_P(usablelist))) {
    res=cons(cons(usable_symb,reverse(prop_conv(usablelist))),res);
  }
  if(!(NULL_P(axiomslist))) {
    res=cons(cons(axioms_symb,reverse(axiomslist)),res);
  }
  if(!(NULL_P(demodlist))) {
    res=cons(cons(demodulators_symb,reverse(demodlist)),res);
  }
  if(!(NULL_P(setlist))) {
    res=cons(cons(set_symb,setlist),res);
  }
  if(!(NULL_P(clearlist))) {
    res=cons(cons(clear_symb,clearlist),res);
  }
  if(!(NULL_P(assignlist))) {
    res=cons(cons(assign_symb,assignlist),res);
  }
  if(!(NULL_P(commandlist))) {
    res=cons(cons(command_symb,commandlist),res);
  }
  return res;
}

SCM prop_conv(lst)
SCM lst;
{
  return map1(prop_conv_fn185,lst);
}

SCM prop_conv_fn185(cl)
SCM cl;
{
  return map1(prop_conv_fn186,cl);
}

SCM prop_conv_fn186(lit)
SCM lit;
{
  if(PAIR_P(lit))
    return lit;
  else
    return cons(lit,cons(MAKINUM(0),EOL));
}

SCM read_otter_list_clauses(otterlst)
SCM otterlst;
{
  SCM part,clause_rest,res;

  part=otterlst;
  clause_rest=EOL;
  res=EOL;
  for(;!(NULL_P(part));) {
    clause_rest=parse_otter_clause(part);
    res=cons(CAR(clause_rest),res);
    part=CDR(clause_rest);
  }
  return reverse(res);
}

SCM parse_otter_clause(lst)
SCM lst;
{
  SCM tmp,new_var2,part,res,endflag,tmp1;

  part=lst;
  res=EOL;
  endflag=BOOL_F;
  tmp1=EOL;
  for(;!(NFALSEP(endflag));) {
    if(PAIR_P(part)&&(PAIR_P(CDR(part))&&(PAIR_P(CDR(CDR(part)))&&((_equal__symb==CAR(CDR(part)))||(_excl__equal__symb==CAR(CDR(part))))))) {
      if(_excl__equal__symb==CAR(CDR(part))) {
        tmp1=string2symbol(st_append(cons(const_129,cons(symbol2string(GLOBAL(eq_symbol_global)),EOL))));
      }
      else {
        tmp1=GLOBAL(eq_symbol_global);
      }
      part=append2(cons(tmp1,cons(cons(CAR(part),cons(_excl__symb,cons(CAR(CDR(CDR(part))),EOL))),EOL)),CDR(CDR(CDR(part))));
    }
    if(GLOBAL(otter_dot_repl_global)==CAR(part)) {
      endflag=BOOL_T;
    }
    else {
      new_var2=SBOOL(GLOBAL(otter_or_symbol_global)==CAR(part));
      if(NFALSEP(new_var2)) ;
      else
      if(SYMBOL_P(CAR(part))||NUMBER_P(CAR(part))) {
        if(NULL_P(CDR(part)))
          report_error(const_130,EOL);
        else
        if(GLOBAL(otter_dot_repl_global)==CAR(CDR(part))) {
          res=cons(CAR(part),res);
        }
        else
        if(GLOBAL(otter_or_symbol_global)==CAR(CDR(part))) {
          if(NULL_P(CDR(CDR(part))))
            report_error(const_131,EOL);
          else {
            res=cons(CAR(part),res);
          }
        }
        else
        if(!(PAIR_P(CAR(CDR(part)))))
          report_error(const_132,EOL);
        else {
          tmp=parse_otter_explist(CAR(CDR(part)));
          res=cons(cons(CAR(part),tmp),res);
          part=CDR(part);
        }
      }
      else
      if(PAIR_P(CAR(part)))
        report_error(const_133,EOL);
    }
    if(!(NULL_P(part))) {
      part=CDR(part);
    }
  }
  return cons(reverse(res),part);
}

SCM prepare_read_eqsymb(eqlit,posflag)
SCM eqlit,posflag;
{
  SCM eqsymb,neweqsymb,tmp;

  if(NFALSEP(posflag))
    eqsymb=_equal__symb;
  else
    eqsymb=_excl__equal__symb;
  if(NFALSEP(posflag))
    neweqsymb=GLOBAL(eq_symbol_global);
  else
    neweqsymb=string2symbol(st_append(cons(const_134,cons(symbol2string(GLOBAL(eq_symbol_global)),EOL))));
  tmp=replace_one_eq(eqsymb,_excl__symb,eqlit);
  return cons(neweqsymb,cons(tmp,EOL));
}

SCM prepare_read_eqlit(eqlit,posflag)
SCM eqlit,posflag;
{
  SCM eqsymb,neweqsymb,tmp;

  if(NFALSEP(posflag))
    eqsymb=_equal__symb;
  else
    eqsymb=_excl__equal__symb;
  if(NFALSEP(posflag))
    neweqsymb=GLOBAL(eq_symbol_global);
  else
    neweqsymb=string2symbol(st_append(cons(const_135,cons(symbol2string(GLOBAL(eq_symbol_global)),EOL))));
  tmp=replace_one_eq(eqsymb,_excl__symb,eqlit);
  return cons(neweqsymb,cons(tmp,EOL));
}

SCM parse_otter_explist(exp_nonkeyword)
SCM exp_nonkeyword;
{
  SCM tmp,new_var2,part,res;

  part=exp_nonkeyword;
  res=EOL;
  for(;!(NULL_P(part));) {
    new_var2=SBOOL(GLOBAL(otter_comma_repl_global)==CAR(part));
    if(NFALSEP(new_var2)) ;
    else
    if(SYMBOL_P(CAR(part))||NUMBER_P(CAR(part))) {
      if(NULL_P(CDR(part))) {
        res=cons(CAR(part),res);
      }
      else
      if(GLOBAL(otter_comma_repl_global)==CAR(CDR(part))) {
        if(NULL_P(CDR(CDR(part))))
          report_error(const_136,EOL);
        else {
          res=cons(CAR(part),res);
        }
      }
      else
      if(!(PAIR_P(CAR(CDR(part)))))
        report_error(const_137,EOL);
      else {
        tmp=parse_otter_explist(CAR(CDR(part)));
        res=cons(cons(CAR(part),tmp),res);
        part=CDR(part);
      }
    }
    else
    if(PAIR_P(CAR(part))) {
      res=cons(parse_otter_explist(CAR(part)),res);
    }
    if(!(NULL_P(part))) {
      part=CDR(part);
    }
  }
  return reverse(res);
}

SCM preprocess_otter_file(filename)
SCM filename;
{
  SCM char_nonkeyword,oport,iport;

  iport=open_file(filename,const_138);
  if(NFALSEP(iport)) {
    oport=open_file(GLOBAL(otter_tmpfile_global),const_139);
    if(NFALSEP(oport)) {
      for(char_nonkeyword=read_char(iport);!(NFALSEP(eof_objectp(char_nonkeyword)));char_nonkeyword=read_char(iport))
        if(char_nonkeyword==MAKICHR(',')) {
          write_char(MAKICHR(' '),oport);
          lwrite(GLOBAL(otter_comma_repl_global),oport);
          write_char(MAKICHR(' '),oport);
        }
        else
        if(char_nonkeyword==MAKICHR('%'))
          write_char(MAKICHR(';'),oport);
        else
        if(char_nonkeyword==MAKICHR('.')) {
          write_char(MAKICHR(' '),oport);
          lwrite(GLOBAL(otter_dot_repl_global),oport);
          write_char(MAKICHR(' '),oport);
        }
        else
        if(char_nonkeyword==MAKICHR('|')) {
          write_char(MAKICHR(' '),oport);
          write_char(MAKICHR('|'),oport);
          write_char(MAKICHR(' '),oport);
        }
        else
        if((char_nonkeyword==MAKICHR('!'))&&(peek_char(iport)==MAKICHR('='))) {
          read_char(iport);
          write_char(MAKICHR(' '),oport);
          write_char(MAKICHR('!'),oport);
          write_char(MAKICHR('='),oport);
          write_char(MAKICHR(' '),oport);
        }
        else
        if(char_nonkeyword==MAKICHR('=')) {
          write_char(MAKICHR(' '),oport);
          write_char(MAKICHR('='),oport);
          if(peek_char(iport)==MAKICHR('>')) {
            write_char(MAKICHR('>'),oport);
            write_char(MAKICHR(' '),oport);
            read_char(iport);
          }
          else
            write_char(MAKICHR(' '),oport);
        }
        else
        if(NFALSEP(CHAR_ALPHAP(char_nonkeyword))&&NFALSEP(CHAR_UPPERP(char_nonkeyword))) {
          write_char(GLOBAL(otter_uppercase_prefix_global),oport);
          write_char(char_nonkeyword,oport);
        }
        else
          write_char(char_nonkeyword,oport);
      return close_port(oport);
    }
    else {
      close_port(iport);
      report_error(const_140,cons(GLOBAL(otter_tmpfile_global),EOL));
      return BOOL_F;
    }
  }
  else {
    report_error(const_141,cons(filename,EOL));
    return BOOL_F;
  }
}

SCM read_processed_otter_file(filename)
SCM filename;
{
  SCM obj,iport,lst,lst_end;

  iport=open_file(filename,const_142);
  lst=EOL;
  lst_end=EOL;
  lst=cons(EOL,EOL);
  lst_end=lst;
  for(obj=lread(iport);!(NFALSEP(eof_objectp(obj)));obj=lread(iport)) {
    SET_CDR(lst_end,cons(obj,EOL));
    lst_end=CDR(lst_end);
  }
  close_port(iport);
  lst=CDR(lst);
  return lst;
}

SCM numerify_clause_list(clauses)
SCM clauses;
{
  init_numerify_clause_list();
  return map1(numerify_clause,clauses);
}

SCM init_numerify_clause_list()
{
  GLOBAL(const_num_table_global)=EOL;
  GLOBAL(fun_num_table_global)=EOL;
  GLOBAL(pred_num_table_global)=EOL;
  GLOBAL(const_num_global)=MAKINUM(65536-1);
  GLOBAL(fun_num_global)=GLOBAL(min_fun_num_sub1_global);
  GLOBAL(pred_num_global)=GLOBAL(min_pred_num_sub1_global);
  GLOBAL(ans_prohibited_funnrs_global)=EOL;
  GLOBAL(ans_prohibited_prednrs_global)=EOL;
  GLOBAL(ans_prohibited_constnrs_global)=EOL;
  if(NFALSEP(GLOBAL(type_theory_stratflag_global)))
    numerify_literal(GLOBAL(typet_speclit_global));
  if(NFALSEP(GLOBAL(classical_synth_stratflag_global))) {
    numerify_literal(GLOBAL(classicsynth_speclit_global));
    GLOBAL(ans_prohibited_prednrs_global)=map1(init_numerify_clause_list_fn189,GLOBAL(ans_prohibited_predsymbs_global));
    GLOBAL(ans_prohibited_funnrs_global)=map1(init_numerify_clause_list_fn190,GLOBAL(ans_prohibited_funsymbs_global));
    GLOBAL(ans_prohibited_constnrs_global)=map1(numerify_term,GLOBAL(ans_prohibited_constsymbs_global));
    return UNSPECIFIED;
  }
  else
    return UNSPECIFIED;
}

SCM init_numerify_clause_list_fn190(x)
SCM x;
{
  return CAR(numerify_term(cons(x,EOL)));
}

SCM init_numerify_clause_list_fn189(x)
SCM x;
{
  return CAR(numerify_literal(cons(x,EOL)));
}

SCM numerify_clause(clause)
SCM clause;
{
  GLOBAL(var_num_table_global)=EOL;
  GLOBAL(var_num_global)=GLOBAL(min_var_num_sub1_global);
  return map1(numerify_literal,clause);
}

SCM numerify_literal(lit)
SCM lit;
{
  SCM pred,predstr,polarity,purepred,place,resnr;

  pred=CAR(lit);
  predstr=symbol2string(pred);
  if(MAKICHR('-')==ST_REF(predstr,MAKINUM(0)))
    polarity=BOOL_F;
  else
    polarity=BOOL_T;
  if(NFALSEP(polarity))
    purepred=pred;
  else
    purepred=string2symbol(substring(predstr,MAKINUM(1),ST_LENGTH(predstr)));
  place=assq(purepred,GLOBAL(pred_num_table_global));
  if(NFALSEP(place))
    resnr=polarize_pred_nr(CDR(place),polarity);
  else {
    GLOBAL(pred_num_global)=MAKINUM(1+INUM(GLOBAL(pred_num_global)));
    if(GLOBAL(pred_num_global)>GLOBAL(max_nr_of_preds_global))
      report_error(const_143,cons(BOOL_T,EOL));
    GLOBAL(pred_num_table_global)=cons(cons(purepred,MAKINUM(INUM(GLOBAL(pred_num_global))<<21)),GLOBAL(pred_num_table_global));
    resnr=polarize_pred_nr(MAKINUM(INUM(GLOBAL(pred_num_global))<<21),polarity);
  }
  return cons(resnr,map1(numerify_term,CDR(lit)));
}

SCM polarize_pred_nr(nr,boolsgn)
SCM nr,boolsgn;
{
  if(NFALSEP(boolsgn))
    return nr;
  else
    return MAKINUM(268435456)|nr;
}

SCM numerify_term(term)
SCM term;
{
  SCM place__2,place__1,fun,nr,place;

  if(PAIR_P(term)) {
    fun=CAR(term);
    nr=MAKINUM(0);
    place=assq(fun,GLOBAL(fun_num_table_global));
    if(NFALSEP(place)) {
      nr=CDR(place);
    }
    else {
      GLOBAL(fun_num_global)=MAKINUM(1+INUM(GLOBAL(fun_num_global)));
      if(GLOBAL(fun_num_global)>GLOBAL(max_nr_of_funs_global))
        report_error(const_144,cons(BOOL_T,EOL));
      GLOBAL(fun_num_table_global)=cons(cons(fun,MAKINUM(INUM(GLOBAL(fun_num_global))<<21)),GLOBAL(fun_num_table_global));
      nr=MAKINUM(INUM(GLOBAL(fun_num_global))<<21);
    }
    return cons(nr,map1(numerify_term,CDR(term)));
  }
  else
  if(NFALSEP(var_symbol_pred_(term))) {
    place__1=assq(term,GLOBAL(var_num_table_global));
    if(NFALSEP(place__1))
      return CDR(place__1);
    else {
      GLOBAL(var_num_global)=MAKINUM(1+INUM(GLOBAL(var_num_global)));
      if(GLOBAL(var_num_global)>MAKINUM(255))
        report_error(const_145,cons(BOOL_T,EOL));
      GLOBAL(var_num_table_global)=cons(cons(term,GLOBAL(var_num_global)),GLOBAL(var_num_table_global));
      return GLOBAL(var_num_global);
    }
  }
  else {
    place__2=assq(term,GLOBAL(const_num_table_global));
    if(NFALSEP(place__2))
      return CDR(place__2);
    else {
      GLOBAL(const_num_global)=MAKINUM(1+INUM(GLOBAL(const_num_global)));
      GLOBAL(const_num_table_global)=cons(cons(term,GLOBAL(const_num_global)),GLOBAL(const_num_table_global));
      return GLOBAL(const_num_global);
    }
  }
}

SCM var_symbol_pred_(symb)
SCM symb;
{
  SCM char1;

  if(SYMBOL_P(symb)) {
    char1=ST_REF(symbol2string(symb),MAKINUM(0));
    if(NFALSEP(GLOBAL(prolog_style_variables_global)))
      return SBOOL(char1==MAKICHR('^'));
    else
      return member(char1,const_146);
  }
  else
    return BOOL_F;
}

SCM print_full_clause(fullcl)
SCM fullcl;
{
  SCM new_var2,new_var3,new,nr,tmp,otherlst;

  if(NFALSEP(GLOBAL(hyper_strategy_flag_global))&&NFALSEP((NFALSEP(GLOBAL(neg_hyper_strategy_flag_global)) ? SBOOL(!(NFALSEP(negative_cl_pred_(CDR(fullcl))))) : SBOOL(!(NFALSEP(positive_cl_pred_(CDR(fullcl)))))))) {
    new=map1(print_full_clause_fn194,CDR(fullcl));
    nr=MAKINUM(0);
    tmp=EOL;
    otherlst=EOL;
    for(new_var2=CAR(CDR(CDR(CAR(fullcl)))),new_var3=CDR(fullcl);
        PAIR_P(new_var2)&&PAIR_P(new_var3);
        new_var2=CDR(new_var2),new_var3=CDR(new_var3))
      print_full_clause_fn195(&nr,&otherlst,new,CAR(new_var2),CAR(new_var3));
    if(!(NULL_P(otherlst))) {
      new=map1_inst1(&tmp,&otherlst,print_full_clause_fn196,new);
    }
    return print_pure_clause(new);
  }
  else
    return print_pure_clause(CDR(fullcl));
}

SCM print_full_clause_fn196(tmp,otherlst,lit)
SCM *tmp,*otherlst;
SCM lit;
{
  if(NULL_P(lit)) {
    *tmp=CAR(*otherlst);
    *otherlst=CDR(*otherlst);
    return *tmp;
  }
  else
    return lit;
}

SCM print_full_clause_fn195(nr,otherlst,new,inf,lit)
SCM *nr,*otherlst;
SCM new,inf,lit;
{
  *nr=MAKINUM(INUM(GLOBAL(litinf_ordernr_mask_global)&CAR(inf))>>16);
  if(!(*nr==MAKINUM(0))) {
    SET_CAR(nth_cdr(MAKINUM(INUM(*nr)-1),new),lit);
    return UNSPECIFIED;
  }
  else {
    *otherlst=cons(lit,*otherlst);
    return UNSPECIFIED;
  }
}

SCM print_full_clause_fn194(x)
SCM x;
{
  return EOL;
}

SCM print_clause(fullcl)
SCM fullcl;
{
  return print_pure_clause(CDR(fullcl));
}

SCM print_pure_clause(pureclause)
SCM pureclause;
{
  SCM part__1,part;

  if(NULL_P(pureclause)) {
    if(NFALSEP(GLOBAL(list_output_global)))
      return display(EOL,cur_output_port());
    else
      return display(const_147,cur_output_port());
  }
  else
  if(NFALSEP(GLOBAL(list_output_global))) {
    display(MAKICHR('('),cur_output_port());
    for(part=pureclause;!(NULL_P(part));part=CDR(part)) {
      print_lit(CAR(part));
      if(!(NULL_P(CDR(part))))
        display(MAKICHR(' '),cur_output_port());
    }
    return display(MAKICHR(')'),cur_output_port());
  }
  else {
    for(part__1=pureclause;!(NULL_P(part__1));part__1=CDR(part__1)) {
      print_lit(CAR(part__1));
      if(!(NULL_P(CDR(part__1))))
        display(const_148,cur_output_port());
    }
    return display(MAKICHR('.'),cur_output_port());
  }
}

SCM print_lit(lit)
SCM lit;
{
  SCM part__1,part;

  if(NFALSEP(GLOBAL(list_output_global))) {
    display(MAKICHR('('),cur_output_port());
    print_pred(CAR(lit));
    if(!(NULL_P(CDR(lit))))
      display(MAKICHR(' '),cur_output_port());
    for(part=CDR(lit);!(NULL_P(part));part=CDR(part)) {
      print_term(CAR(part));
      if(!(NULL_P(CDR(part))))
        display(MAKICHR(' '),cur_output_port());
    }
    return display(MAKICHR(')'),cur_output_port());
  }
  else {
    print_pred(CAR(lit));
    display(MAKICHR('('),cur_output_port());
    for(part__1=CDR(lit);!(NULL_P(part__1));part__1=CDR(part__1)) {
      print_term(CAR(part__1));
      if(!(NULL_P(CDR(part__1)))) {
        if(NFALSEP(GLOBAL(comma_output_global)))
          display(MAKICHR(','),cur_output_port());
        else
          display(MAKICHR(' '),cur_output_port());
      }
    }
    return display(MAKICHR(')'),cur_output_port());
  }
}

SCM print_term(term)
SCM term;
{
  SCM part__1,part;

  if(!(NUMBER_P(term))) {
    if(NFALSEP(GLOBAL(list_output_global))) {
      display(MAKICHR('('),cur_output_port());
      print_fun(CAR(term));
      if(!(NULL_P(CDR(term))))
        display(MAKICHR(' '),cur_output_port());
      if(GLOBAL(if_fun_nr_global)==(MAKINUM(534773760)&CAR(term))) {
        print_lit(CAR(CDR(term)));
        display(MAKICHR(' '),cur_output_port());
        term=CDR(term);
      }
      for(part=CDR(term);!(NULL_P(part));part=CDR(part)) {
        print_term(CAR(part));
        if(!(NULL_P(CDR(part))))
          display(MAKICHR(' '),cur_output_port());
      }
      return display(MAKICHR(')'),cur_output_port());
    }
    else {
      print_fun(CAR(term));
      display(MAKICHR('('),cur_output_port());
      if(GLOBAL(if_fun_nr_global)==(MAKINUM(534773760)&CAR(term))) {
        print_lit(CAR(CDR(term)));
        if(NFALSEP(GLOBAL(comma_output_global)))
          display(MAKICHR(','),cur_output_port());
        else
          display(MAKICHR(' '),cur_output_port());
        term=CDR(term);
      }
      for(part__1=CDR(term);!(NULL_P(part__1));part__1=CDR(part__1)) {
        print_term(CAR(part__1));
        if(!(NULL_P(CDR(part__1)))) {
          if(NFALSEP(GLOBAL(comma_output_global)))
            display(MAKICHR(','),cur_output_port());
          else
            display(MAKICHR(' '),cur_output_port());
        }
      }
      return display(MAKICHR(')'),cur_output_port());
    }
  }
  else
  if(NUMBER_P(term)&&(term<=MAKINUM(65535)))
    return print_var(term);
  else
    return print_const(term);
}

SCM print_pred(prednum)
SCM prednum;
{
  if(!(ZERO_P(MAKINUM(268435456)&prednum)))
    display(MAKICHR('-'),cur_output_port());
  return display(CAR(rassq(MAKINUM(266338304)&prednum,GLOBAL(pred_num_table_global))),cur_output_port());
}

SCM print_fun(funnum)
SCM funnum;
{
  return display(CAR(rassq(MAKINUM(534773760)&funnum,GLOBAL(fun_num_table_global))),cur_output_port());
}

SCM print_const(constnum)
SCM constnum;
{
  return display(CAR(rassq(constnum,GLOBAL(const_num_table_global))),cur_output_port());
}

SCM print_var(varnr)
SCM varnr;
{
  SCM try,yflg;

  yflg=BOOL_F;
  if(!(ZERO_P(MAKINUM(256)&varnr))) {
    yflg=BOOL_T;
    varnr=MAKINUM(256^INUM(varnr));
  }
  varnr=(MAKINUM(8191)&varnr);
  try=assq(varnr,GLOBAL(nr_var_table_global));
  if(NFALSEP(yflg))
    display(MAKICHR(39),cur_output_port());
  if(NFALSEP(try))
    return display(CDR(try),cur_output_port());
  else {
    display(MAKICHR('x'),cur_output_port());
    return display(MAKINUM(INUM(varnr)-6),cur_output_port());
  }
}

SCM print_list_as_term(lst)
SCM lst;
{
  SCM part;

  if(NFALSEP(listp(lst))&&!(NULL_P(lst))) {
    display(CAR(lst),cur_output_port());
    display(const_149,cur_output_port());
    for(part=CDR(lst);!(NULL_P(part));part=CDR(part)) {
      print_list_as_term(CAR(part));
      if(!(NULL_P(CDR(part))))
        display(const_151,cur_output_port());
    }
    return display(const_150,cur_output_port());
  }
  else
    return display(lst,cur_output_port());
}

SCM show_discr_tree(tree,litflag)
SCM tree,litflag;
{
  return apply(GLOBAL(pretty_print),((PAIR_P(tree)&&!(NULL_P(CAR(tree))&&NULL_P(CDR(tree)))) ? (NFALSEP(tree_debug_leaf_pred_(tree)) ? make_readable_discr_leaf(tree) : make_readable_discr_tree(tree,litflag)) : tree),listofnull);
}

SCM make_readable_discr_tree(tree,litflag)
SCM tree,litflag;
{
  SCM el1,el2,rst;

  el1=map1_inst2(litflag,make_readable_discr_tree_fn200,CAR(tree));
  if(!(NULL_P(CDR(tree)))&&PAIR_P(CDR(tree)))
    el2=map1(make_readable_discr_tree_fn201,CAR(CDR(tree)));
  else
    el2=EOL;
  if(!(NULL_P(CDR(tree))))
    rst=map1(make_readable_discr_tree_fn202,CDR(CDR(tree)));
  else
    rst=EOL;
  return cons(el1,((!(NULL_P(el2))||!(NULL_P(rst))) ? cons(el2,rst) : EOL));
}

SCM make_readable_discr_tree_fn202(x)
SCM x;
{
  SCM tmp__4,funnum__5,fn__6;

  tmp__4=EOL;
  funnum__5=CAR(x);
  fn__6=string2symbol(st_append(cons(const_152,cons(number2string(MAKINUM(8191)&funnum__5,MAKINUM(10)),EOL))));
  if(NFALSEP(tree_debug_leaf_pred_(CDR(x)))) {
    tmp__4=make_readable_discr_leaf(CDR(x));
  }
  else {
    tmp__4=make_readable_discr_tree(CDR(x),BOOL_F);
  }
  return cons(fn__6,tmp__4);
}

SCM make_readable_discr_tree_fn201(x)
SCM x;
{
  SCM tmp__1,funnum__2,fn__3;

  tmp__1=EOL;
  funnum__2=CAR(x);
  fn__3=CAR(rassq(funnum__2,GLOBAL(const_num_table_global)));
  if(NFALSEP(tree_debug_leaf_pred_(CDR(x)))) {
    tmp__1=make_readable_discr_leaf(CDR(x));
  }
  else {
    tmp__1=make_readable_discr_tree(CDR(x),BOOL_F);
  }
  return cons(fn__3,tmp__1);
}

SCM make_readable_discr_tree_fn200(litflag,x)
SCM litflag,x;
{
  SCM tmp,funnum,fn;

  tmp=EOL;
  funnum=CAR(x);
  if(NFALSEP(litflag))
    fn=CAR(rassq(funnum,GLOBAL(pred_num_table_global)));
  else
    fn=CAR(rassq(funnum,GLOBAL(fun_num_table_global)));
  if(NFALSEP(tree_debug_leaf_pred_(CDR(x)))) {
    tmp=make_readable_discr_leaf(CDR(x));
  }
  else {
    tmp=make_readable_discr_tree(CDR(x),BOOL_F);
  }
  return cons(fn,tmp);
}

SCM tree_debug_leaf_pred_(tree)
SCM tree;
{
  SCM new_var2;

  new_var2=SBOOL(NULL_P(tree));
  if(NFALSEP(new_var2))
    return new_var2;
  else {
    if(PAIR_P(CAR(tree)))
      new_var2=NOT(SBOOL(PAIR_P(CAR(CAR(tree)))));
    else
      new_var2=BOOL_F;
    if(NFALSEP(new_var2))
      return new_var2;
    else {
      if(PAIR_P(CDR(tree))) {
        if(PAIR_P(CAR(CDR(tree))))
          new_var2=NOT(SBOOL(PAIR_P(CAR(CAR(CDR(tree))))));
        else
          new_var2=BOOL_F;
      }
      else
        new_var2=BOOL_F;
      if(NFALSEP(new_var2))
        return new_var2;
      else
      if(PAIR_P(CDR(tree))) {
        if(PAIR_P(CDR(CDR(tree))))
          return SBOOL(PAIR_P(CAR(CAR(CDR(CDR(tree))))));
        else
          return BOOL_F;
      }
      else
        return BOOL_F;
    }
  }
}

SCM make_readable_discr_leaf(leaf)
SCM leaf;
{
  SCM el1,el2,el3;

  if(NFALSEP(GLOBAL(nonunit_discr_flag_global)))
    return leaf;
  else {
    if(PAIR_P(CAR(leaf)))
      el1=make_readable_lit(CAR(leaf));
    else
      el1=EOL;
    if(!(NULL_P(CDR(leaf)))&&PAIR_P(CAR(CDR(leaf))))
      el2=make_readable_lit(CAR(CDR(leaf)));
    else
      el2=EOL;
    if(!(NULL_P(CDR(leaf)))&&!(NULL_P(CDR(CDR(leaf)))))
      el3=make_readable_fullcl(CAR(CDR(CDR(leaf))));
    else
      el3=EOL;
    return cons(el1,((!(NULL_P(el2))||!(NULL_P(el3))) ? cons(el2,(!(NULL_P(el3)) ? cons(el3,EOL) : EOL)) : EOL));
  }
}

SCM make_readable_fullcl(fullcl)
SCM fullcl;
{
  return cons(cons(CAR(CAR(fullcl)),cons(CAR(CDR(CAR(fullcl))),EOL)),map1(make_readable_lit,CDR(fullcl)));
}

SCM make_readable_cl(cl)
SCM cl;
{
  return map1(make_readable_lit,cl);
}

SCM make_readable_lit(lit)
SCM lit;
{
  SCM funnum;

  funnum=CAR(lit);
  return cons((!(ZERO_P(MAKINUM(268435456)&funnum)) ? string2symbol(st_append(cons(const_153,cons(symbol2string(CAR(rassq(MAKINUM(266338304)&funnum,GLOBAL(pred_num_table_global)))),EOL)))) : CAR(rassq(MAKINUM(266338304)&funnum,GLOBAL(pred_num_table_global)))),((GLOBAL(lambda_fun_nr_global)==(MAKINUM(534773760)&funnum)) ? cons(make_readable_term(CAR(CDR(lit))),map1(make_readable_term,CDR(CDR(lit)))) : map1(make_readable_term,CDR(lit))));
}

SCM make_readable_term(term)
SCM term;
{
  if(PAIR_P(term))
    return cons(CAR(rassq(MAKINUM(534773760)&CAR(term),GLOBAL(fun_num_table_global))),((GLOBAL(lambda_fun_nr_global)==(MAKINUM(534773760)&CAR(term))) ? cons(make_readable_term(CAR(CDR(term))),map1(make_readable_term,CDR(CDR(term)))) : map1(make_readable_term,CDR(term))));
  else
  if(NUMBER_P(term)&&(term<=MAKINUM(65535)))
    return string2symbol(st_append(cons(const_154,cons(number2string(MAKINUM(8191)&term,MAKINUM(10)),EOL))));
  else
    return CAR(rassq(term,GLOBAL(const_num_table_global)));
}

SCM debug_print_clause(cl)
SCM cl;
{
  SCM info,pure,num;

  newline(cur_output_port());
  info=CAR(cl);
  pure=CDR(cl);
  num=CAR(info);
  display(vector(cons(MAKINUM(INUM(MAKINUM(528482304)&num)>>23),cons(MAKINUM(INUM(MAKINUM(8257536)&num)>>17),cons(MAKINUM(INUM(MAKINUM(65536)&num)>>16),cons(MAKINUM(INUM(MAKINUM(63488)&num)>>11),cons(MAKINUM(INUM(MAKINUM(2016)&num)>>5),cons(MAKINUM(31)&num,EOL))))))),cur_output_port());
  display(MAKICHR(' '),cur_output_port());
  display(number2string(CAR(CDR(info)),MAKINUM(2)),cur_output_port());
  display(MAKICHR(' '),cur_output_port());
  newline(cur_output_port());
  display(map1(debug_print_clause_fn204,CAR(CDR(CDR(info)))),cur_output_port());
  newline(cur_output_port());
  display(CDR(CDR(CDR(info))),cur_output_port());
  return debug_print_pure_clause(pure);
}

SCM debug_print_clause_fn204(el)
SCM el;
{
  if(!(PAIR_P(el)))
    return el;
  else
    return cons(vector(cons(get_litinfo_classnr(CAR(el)),cons(MAKINUM(INUM(GLOBAL(litinf_ordernr_mask_global)&CAR(el))>>16),cons(SBOOL(ZERO_P(MAKINUM(512)&CAR(el))),cons(SBOOL(ZERO_P(MAKINUM(256)&CAR(el))),cons(SBOOL(ZERO_P(MAKINUM(128)&CAR(el))),cons(SBOOL(ZERO_P(MAKINUM(64)&CAR(el))),cons(SBOOL(ZERO_P(MAKINUM(32)&CAR(el))),cons(SBOOL(ZERO_P(MAKINUM(16)&CAR(el))),cons(SBOOL(ZERO_P(MAKINUM(8)&CAR(el))),cons(SBOOL(ZERO_P(MAKINUM(4)&CAR(el))),cons(SBOOL(ZERO_P(MAKINUM(2)&CAR(el))),cons(SBOOL(ZERO_P(MAKINUM(1)&CAR(el))),EOL))))))))))))),CDR(el));
}

SCM debug_print_pure_clause(cl)
SCM cl;
{
  newline(cur_output_port());
  display(MAKICHR('{'),cur_output_port());
  for_each1(debug_print_pure_clause_fn206,cl);
  display(MAKICHR('}'),cur_output_port());
  return newline(cur_output_port());
}

SCM debug_print_pure_clause_fn206(x)
SCM x;
{
  debug_print_lit(x);
  return display(MAKICHR(' '),cur_output_port());
}

SCM debug_print_lit(term)
SCM term;
{
  SCM part;

  display(MAKICHR('['),cur_output_port());
  debug_print_pred(CAR(term));
  if(!(NULL_P(CDR(term))))
    display(MAKICHR(' '),cur_output_port());
  for(part=CDR(term);!(NULL_P(part));part=CDR(part)) {
    debug_print_term(CAR(part));
    if(!(NULL_P(CDR(part))))
      display(MAKICHR(' '),cur_output_port());
  }
  return display(MAKICHR(']'),cur_output_port());
}

SCM debug_print_term(term)
SCM term;
{
  SCM part;

  if(!(NUMBER_P(term))) {
    display(MAKICHR('('),cur_output_port());
    debug_print_fun(CAR(term));
    if(!(NULL_P(CDR(term))))
      display(MAKICHR(' '),cur_output_port());
    for(part=CDR(term);!(NULL_P(part));part=CDR(part)) {
      debug_print_term(CAR(part));
      if(!(NULL_P(CDR(part))))
        display(MAKICHR(' '),cur_output_port());
    }
    return display(MAKICHR(')'),cur_output_port());
  }
  else
  if(NUMBER_P(term)&&(term<=MAKINUM(65535)))
    return debug_print_var(term);
  else
    return debug_print_const(term);
}

SCM debug_print_pred(funnum)
SCM funnum;
{
  if(!(ZERO_P(MAKINUM(268435456)&funnum)))
    display(MAKICHR('-'),cur_output_port());
  return display(vector(cons(CAR(rassq(MAKINUM(266338304)&funnum,GLOBAL(pred_num_table_global))),cons(MAKINUM(INUM(MAKINUM(1835008)&funnum)>>18),cons(MAKINUM(INUM(MAKINUM(131072)&funnum)>>17),cons(MAKINUM(INUM(MAKINUM(65536)&funnum)>>16),cons(MAKINUM(INUM(MAKINUM(63488)&funnum)>>11),cons(MAKINUM(INUM(MAKINUM(2016)&funnum)>>5),cons(MAKINUM(31)&funnum,EOL)))))))),cur_output_port());
}

SCM debug_print_fun(funnum)
SCM funnum;
{
  return display(vector(cons(CAR(rassq(MAKINUM(534773760)&funnum,GLOBAL(fun_num_table_global))),cons(MAKINUM(INUM(MAKINUM(1835008)&funnum)>>18),cons(MAKINUM(INUM(MAKINUM(131072)&funnum)>>17),cons(MAKINUM(INUM(MAKINUM(65536)&funnum)>>16),cons(MAKINUM(INUM(MAKINUM(63488)&funnum)>>11),cons(MAKINUM(INUM(MAKINUM(2016)&funnum)>>5),cons(MAKINUM(31)&funnum,EOL)))))))),cur_output_port());
}

SCM debug_print_const(constnum)
SCM constnum;
{
  if(constnum==MAKINUM(99999999))
    return display(const_155,cur_output_port());
  else
    return display(CAR(rassq(constnum,GLOBAL(const_num_table_global))),cur_output_port());
}

SCM debug_print_var(varnr)
SCM varnr;
{
  SCM try,yflg;

  yflg=BOOL_F;
  if(!(ZERO_P(MAKINUM(256)&varnr))) {
    yflg=BOOL_T;
    varnr=MAKINUM(256^INUM(varnr));
  }
  return display(st_append(cons(number2string(MAKINUM(INUM(MAKINUM(32768)&varnr)>>15),MAKINUM(10)),cons(number2string(MAKINUM(INUM(MAKINUM(16384)&varnr)>>14),MAKINUM(10)),cons(number2string(MAKINUM(INUM(MAKINUM(8192)&varnr)>>13),MAKINUM(10)),cons((try=assq(MAKINUM(8191)&varnr,GLOBAL(nr_var_table_global)),(NFALSEP(try) ? (NFALSEP(yflg) ? st_append(cons(const_156,cons(symbol2string(CDR(try)),EOL))) : symbol2string(CDR(try))) : (NFALSEP(yflg) ? st_append(cons(const_157,cons(number2string(MAKINUM(INUM(MAKINUM(8191)&varnr)-6),MAKINUM(10)),EOL))) : st_append(cons(const_158,cons(number2string(MAKINUM(INUM(MAKINUM(8191)&varnr)-6),MAKINUM(10)),EOL)))))),EOL))))),cur_output_port());
}

SCM debug_print_xvars(var)
SCM var;
{
  newline(cur_output_port());
  display(const_159,cur_output_port());
  newline(cur_output_port());
  for(;!(ZERO_P(var));) {
    debug_print_var(var);
    display(const_160,cur_output_port());
    debug_print_term(STBL_VECTOR_REF(_star_var_val_table_star__velts0,var));
    display(const_161,cur_output_port());
    display(STBL_VECTOR_REF(_star_var_touched_table_star__velts0,var),cur_output_port());
    newline(cur_output_port());
    var=MAKINUM(INUM(var)-1);
  }
  return UNSPECIFIED;
}

SCM debug_print_yvars(var)
SCM var;
{
  newline(cur_output_port());
  display(const_162,cur_output_port());
  newline(cur_output_port());
  var=(MAKINUM(256)|var);
  for(;!(MAKINUM(256)==var);) {
    debug_print_var(var);
    display(const_163,cur_output_port());
    debug_print_term(STBL_VECTOR_REF(_star_var_val_table_star__velts0,var));
    display(const_164,cur_output_port());
    display(STBL_VECTOR_REF(_star_var_touched_table_star__velts0,var),cur_output_port());
    newline(cur_output_port());
    var=MAKINUM(INUM(var)-1);
  }
  return UNSPECIFIED;
}

SCM debug_print_zvars(var)
SCM var;
{
  newline(cur_output_port());
  display(const_165,cur_output_port());
  newline(cur_output_port());
  var=(MAKINUM(512)|var);
  for(;!(MAKINUM(512)==var);) {
    debug_print_var(var);
    display(const_166,cur_output_port());
    debug_print_term(STBL_VECTOR_REF(_star_var_val_table_star__velts0,var));
    newline(cur_output_port());
    var=MAKINUM(INUM(var)-1);
  }
  return UNSPECIFIED;
}

SCM report_error(str,obj)
SCM str,obj;
{
  newline(cur_output_port());
  display(const_167,cur_output_port());
  display(str,cur_output_port());
  display(const_168,cur_output_port());
  for_each1(report_error_fn208,obj);
  newline(cur_output_port());
  return quit(1);
}

SCM report_error_fn208(x)
SCM x;
{
  return display(x,cur_output_port());
}

SCM get_time()
{
  if(NFALSEP(GLOBAL(use_real_time_global)))
    return apply(GLOBAL(get_internal_real_time),EOL,EOL);
  else
    return my_time();
}

SCM get_check_time(x)
SCM x;
{
  SCM tmp;

  tmp=MAKINUM(0);
  if(NULL_P(GLOBAL(given_checkpoint_keptnrs_global))) {
    GLOBAL(last_got_time_global)=get_time();
    return GLOBAL(last_got_time_global);
  }
  else
  if((GLOBAL(kept_cl_nr_global)>=CAR(GLOBAL(given_checkpoint_keptnrs_global)))&&(x==CAR(CDR(GLOBAL(given_checkpoint_keptnrs_global))))) {
    GLOBAL(last_got_time_global)=CAR(CDR(CDR(GLOBAL(given_checkpoint_keptnrs_global))));
    GLOBAL(given_checkpoint_keptnrs_global)=CDR(CDR(CDR(GLOBAL(given_checkpoint_keptnrs_global))));
    return GLOBAL(last_got_time_global);
  }
  else {
    GLOBAL(last_got_time_global)=MAKINUM(0);
    return MAKINUM(0);
  }
}

SCM store_time_checkpoint_excl_(x)
SCM x;
{
  GLOBAL(checkpoint_keptnrs_global)=cons(GLOBAL(last_got_time_global),cons(x,cons(GLOBAL(kept_cl_nr_global),GLOBAL(checkpoint_keptnrs_global))));
  return UNSPECIFIED;
}

SCM prove(raw_input,stop_real_time,display_info_level)
SCM raw_input,stop_real_time,display_info_level;
{
  SCM part,new_var2,compl_lit_demodulators,demodulators,lit_demodulators,sos,usable,tmp;

  init_stats();
  init_globals();
  GLOBAL(internal_time_units_per_second_global)=GLOBAL(internal_time_units_per_second);
  use_input_settings(raw_input);
  GLOBAL(total_time_start_global)=get_time();
  if(NFALSEP(GLOBAL(timelimit_global))) {
    GLOBAL(total_time_given_global)=MAKINUM(INUM(GLOBAL(internal_time_units_per_second_global))*INUM(string2number(GLOBAL(timelimit_global),MAKINUM(10))));
  }
  else {
    GLOBAL(total_time_given_global)=BOOL_F;
  }
  GLOBAL(overdouble_discr_flag_global)=BOOL_F;
  GLOBAL(nonunit_discr_flag_global)=BOOL_F;
  compl_lit_demodulators=EOL;
  demodulators=assq(GLOBAL(demodulator_list_symbol_global),raw_input);
  lit_demodulators=assq(GLOBAL(lit_demodulator_list_symbol_global),raw_input);
  sos=assq(GLOBAL(sos_list_symbol_global),raw_input);
  usable=assq(GLOBAL(usable_list_symbol_global),raw_input);
  tmp=EOL;
  GLOBAL(stop_res_real_time_global)=stop_real_time;
  if(NFALSEP(demodulators)) {
    demodulators=CDR(demodulators);
    GLOBAL(demodulate_flag_global)=BOOL_T;
    GLOBAL(new_demodulators_flag_global)=BOOL_T;
    GLOBAL(demodulate_constants_flag_global)=BOOL_T;
    if(NFALSEP(GLOBAL(display_debug_info_flag_global))) {
      newline(cur_output_port());
      display(const_169,cur_output_port());
      newline(cur_output_port());
      for_each1(prove_fn214,demodulators);
    }
  }
  if(NFALSEP(lit_demodulators)) {
    lit_demodulators=CDR(lit_demodulators);
    GLOBAL(demodulate_lit_flag_global)=BOOL_T;
    GLOBAL(new_demodulators_flag_global)=BOOL_T;
    if(NFALSEP(GLOBAL(display_debug_info_flag_global))) {
      newline(cur_output_port());
      display(const_170,cur_output_port());
      newline(cur_output_port());
      for_each1(prove_fn215,lit_demodulators);
    }
  }
  else {
    GLOBAL(demodulate_lit_flag_global)=BOOL_F;
  }
  if(NFALSEP(sos)) {
    sos=CDR(sos);
    if(NFALSEP(GLOBAL(display_debug_info_flag_global))) {
      newline(cur_output_port());
      display(const_171,cur_output_port());
      newline(cur_output_port());
      for_each1(prove_fn216,sos);
    }
  }
  if(NFALSEP(usable)) {
    usable=CDR(usable);
    if(NFALSEP(GLOBAL(display_debug_info_flag_global))) {
      newline(cur_output_port());
      display(const_172,cur_output_port());
      newline(cur_output_port());
      for_each1(prove_fn217,usable);
    }
  }
  if(NFALSEP(sos))
    new_var2=NOT(usable);
  else
    new_var2=BOOL_F;
  if(NFALSEP(new_var2)) ;
  else
  if(NFALSEP(usable)&&!(NFALSEP(sos))) {
    sos=usable;
    usable=BOOL_F;
  }
  GLOBAL(sos_clauses_list_global)=EOL;
  GLOBAL(usable_clauses_list_global)=EOL;
  GLOBAL(subsumption_list_global)=cons(cons(MAKINUM(0),EOL),EOL);
  GLOBAL(unit_alist_global)=EOL;
  GLOBAL(discr_tree_global)=cons(EOL,EOL);
  GLOBAL(nonunit_discr_tree_global)=cons(EOL,EOL);
  GLOBAL(discr_tree_demod_terms_global)=cons(EOL,EOL);
  GLOBAL(discr_tree_demod_atoms_global)=cons(EOL,EOL);
  GLOBAL(kept_cl_nr_global)=MAKINUM(0);
  init_numerify_clause_list();
  if(NFALSEP(demodulators)) {
    if(NFALSEP(GLOBAL(type_theory_stratflag_global))) {
      demodulators=map1(prove_fn218,demodulators);
    }
    demodulators=map1(numerify_clause,demodulators);
  }
  if(NFALSEP(lit_demodulators)) {
    lit_demodulators=map1(numerify_clause,lit_demodulators);
  }
  if(NFALSEP(usable)) {
    usable=map1(numerify_clause,usable);
  }
  if(NFALSEP(sos)) {
    sos=map1(numerify_clause,sos);
  }
  if(!(NFALSEP(usable))&&NFALSEP(GLOBAL(auto_mode_flag_global))) {
    tmp=EOL;
    usable=EOL;
    for(part=sos;!(NULL_P(part));part=CDR(part))
      if(NFALSEP(negative_cl_pred_(CAR(part)))) {
        tmp=cons(CAR(part),tmp);
      }
      else {
        usable=cons(CAR(part),usable);
      }
    sos=reverse(tmp);
  }
  if(NFALSEP(GLOBAL(type_theory_stratflag_global))) {
    GLOBAL(subst_fun_nr_global)=CDR(assq(GLOBAL(subst_fun_symbol_global),GLOBAL(fun_num_table_global)));
    GLOBAL(subst_prim_fun_nr_global)=CDR(assq(GLOBAL(subst_prim_fun_symbol_global),GLOBAL(fun_num_table_global)));
    GLOBAL(lambda_fun_nr_global)=CDR(assq(GLOBAL(lambda_fun_symbol_global),GLOBAL(fun_num_table_global)));
    GLOBAL(lambda_dummypar_nr_global)=CDR(assq(GLOBAL(lambda_dummypar_symbol_global),GLOBAL(const_num_table_global)));
  }
  fill_predsymb_bit_vector_excl_();
  GLOBAL(strat_list_global)=const_173;
  return prove_all_passes(usable,sos,demodulators,lit_demodulators,compl_lit_demodulators);
}

SCM prove_fn218(x)
SCM x;
{
  return add_typet_demod_ans(x);
}

SCM prove_fn217(x)
SCM x;
{
  display(x,cur_output_port());
  return newline(cur_output_port());
}

SCM prove_fn216(x)
SCM x;
{
  display(x,cur_output_port());
  return newline(cur_output_port());
}

SCM prove_fn215(x)
SCM x;
{
  display(x,cur_output_port());
  return newline(cur_output_port());
}

SCM prove_fn214(x)
SCM x;
{
  display(x,cur_output_port());
  return newline(cur_output_port());
}

SCM prove_make_initial_clauses(usable,sos,demodulators,lit_demodulators,compl_lit_demodulators)
SCM usable,sos,demodulators,lit_demodulators,compl_lit_demodulators;
{
  if(NFALSEP(demodulators)) {
    demodulators=map1(make_input_clause,demodulators);
    for_each1(modify_to_demod_inf_excl_,demodulators);
    for_each1(intern_fullclause,demodulators);
    for_each1(prove_make_initial_clauses_fn225,(NFALSEP(GLOBAL(type_theory_stratflag_global)) ? map1(remove_typet_demod_ans,demodulators) : demodulators));
  }
  if(NFALSEP(lit_demodulators)) {
    compl_lit_demodulators=map1(prove_make_initial_clauses_fn226,lit_demodulators);
    lit_demodulators=map1(make_input_clause,lit_demodulators);
    compl_lit_demodulators=map1(make_input_clause,compl_lit_demodulators);
    for_each1(intern_fullclause,lit_demodulators);
    for_each1(intern_fullclause,compl_lit_demodulators);
    for_each1(prove_make_initial_clauses_fn228,lit_demodulators);
  }
  if(NFALSEP(GLOBAL(display_debug_info_flag_global))) {
    newline(cur_output_port());
    display(const_174,cur_output_port());
    newline(cur_output_port());
    newline(cur_output_port());
    for_each1(prove_make_initial_clauses_fn229,sos);
  }
  if(NFALSEP(sos)) {
    if(NFALSEP(usable)) {
      usable=map1(make_input_clause,usable);
    }
    else {
      usable=EOL;
    }
    GLOBAL(last_usable_cl_nr_global)=GLOBAL(kept_cl_nr_global);
    sos=map1(make_input_clause,sos);
    if((GLOBAL(display_info_level_global)>=MAKINUM(40))&&NFALSEP(GLOBAL(display_debug_info_flag_global))) {
      newline(cur_output_port());
      display(const_175,cur_output_port());
      newline(cur_output_port());
      newline(cur_output_port());
      for_each1(prove_make_initial_clauses_fn230,append2(usable,sos));
    }
    if(NFALSEP(GLOBAL(type_theory_stratflag_global))) {
      GLOBAL(ans_input_sos_global)=append2(demodulators,sos);
      sos=remove_ans_from_clauses(sos);
    }
    for_each1(intern_fullclause,usable);
    for_each1(intern_fullclause,sos);
  }
  else {
    newline(cur_output_port());
    display(const_176,cur_output_port());
    newline(cur_output_port());
    quit(1);
  }
  GLOBAL(demodulate_constants_flag_global)=BOOL_F;
  if(!(NFALSEP(demodulators))) {
    demodulators=EOL;
  }
  if(!(NFALSEP(sos))) {
    sos=EOL;
  }
  if(!(NFALSEP(lit_demodulators))) {
    lit_demodulators=EOL;
  }
  if(!(NFALSEP(compl_lit_demodulators))) {
    compl_lit_demodulators=EOL;
  }
  if(NFALSEP(GLOBAL(type_theory_stratflag_global))) {
    GLOBAL(sos_clauses_list_global)=append2(append2(append2(remove_ans_from_clauses(demodulators),compl_lit_demodulators),usable),sos);
  }
  else {
    GLOBAL(usable_clauses_list_global)=usable;
    GLOBAL(sos_clauses_list_global)=sos;
  }
  return cons(usable,cons(sos,cons(demodulators,cons(lit_demodulators,cons(compl_lit_demodulators,EOL)))));
}

SCM prove_make_initial_clauses_fn230(x)
SCM x;
{
  display(x,cur_output_port());
  newline(cur_output_port());
  debug_print_clause(x);
  return newline(cur_output_port());
}

SCM prove_make_initial_clauses_fn229(x)
SCM x;
{
  display(x,cur_output_port());
  newline(cur_output_port());
  debug_print_pure_clause(x);
  return newline(cur_output_port());
}

SCM prove_make_initial_clauses_fn228(x)
SCM x;
{
  GLOBAL(cur_clause_global)=cons(CAR(x),map1(rename_x_to_z_term,CDR(x)));
  if(!(ZERO_P(MAKINUM(268435456)&CAR(CAR(CDR(GLOBAL(cur_clause_global))))))) {
    GLOBAL(cur_clause_global)=cons(CAR(GLOBAL(cur_clause_global)),cons(CAR(CDR(CDR(GLOBAL(cur_clause_global)))),cons(CAR(CDR(GLOBAL(cur_clause_global))),EOL)));
  }
  GLOBAL(cur_lit_global)=CAR(CDR(GLOBAL(cur_clause_global)));
  return insert_discr_tree_excl_(GLOBAL(discr_tree_demod_atoms_global),GLOBAL(cur_lit_global),BOOL_F,BOOL_T,BOOL_T);
}

SCM prove_make_initial_clauses_fn226(x)
SCM x;
{
  return map1(prove_make_initial_clauses_fn227,x);
}

SCM prove_make_initial_clauses_fn227(y)
SCM y;
{
  return cons(MAKINUM(268435456^INUM(CAR(y))),CDR(y));
}

SCM prove_make_initial_clauses_fn225(x)
SCM x;
{
  GLOBAL(cur_clause_global)=cons(CAR(x),map1(rename_x_to_z_term,CDR(x)));
  GLOBAL(cur_lit_global)=CAR(CDR(GLOBAL(cur_clause_global)));
  return insert_discr_tree_excl_(GLOBAL(discr_tree_demod_terms_global),CAR(CDR(GLOBAL(cur_lit_global))),BOOL_F,BOOL_T,BOOL_T);
}

SCM prove_show_input_clauses(usable,sos,demodulators,lit_demodulators,compl_lit_demodulators)
SCM usable,sos,demodulators,lit_demodulators,compl_lit_demodulators;
{
  if((GLOBAL(display_info_level_global)>=MAKINUM(40))&&!(NULL_P(demodulators))) {
    newline(cur_output_port());
    display(const_177,cur_output_port());
    newline(cur_output_port());
    for_each1(prove_show_input_clauses_fn239,demodulators);
    if(NFALSEP(GLOBAL(display_debug_info_flag_global))) {
      newline(cur_output_port());
      display(const_178,cur_output_port());
      newline(cur_output_port());
      for_each1(prove_show_input_clauses_fn240,demodulators);
    }
  }
  if((GLOBAL(display_info_level_global)>=MAKINUM(40))&&!(NULL_P(lit_demodulators))) {
    newline(cur_output_port());
    display(const_179,cur_output_port());
    newline(cur_output_port());
    for_each1(prove_show_input_clauses_fn241,lit_demodulators);
    if(NFALSEP(GLOBAL(display_debug_info_flag_global))) {
      newline(cur_output_port());
      display(const_180,cur_output_port());
      newline(cur_output_port());
      for_each1(prove_show_input_clauses_fn242,lit_demodulators);
    }
  }
  if((GLOBAL(display_info_level_global)>=MAKINUM(40))&&!(NULL_P(usable))) {
    newline(cur_output_port());
    display(const_181,cur_output_port());
    newline(cur_output_port());
    for_each1(prove_show_input_clauses_fn243,usable);
    if(NFALSEP(GLOBAL(display_debug_info_flag_global))) {
      newline(cur_output_port());
      display(const_182,cur_output_port());
      newline(cur_output_port());
      for_each1(prove_show_input_clauses_fn244,sos);
    }
  }
  if((GLOBAL(display_info_level_global)>=MAKINUM(40))&&!(NULL_P(sos))) {
    newline(cur_output_port());
    display(const_183,cur_output_port());
    newline(cur_output_port());
    for_each1(prove_show_input_clauses_fn245,sos);
    if(NFALSEP(GLOBAL(display_debug_info_flag_global))) {
      newline(cur_output_port());
      display(const_184,cur_output_port());
      newline(cur_output_port());
      return for_each1(prove_show_input_clauses_fn246,sos);
    }
    else
      return UNSPECIFIED;
  }
  else
    return UNSPECIFIED;
}

SCM prove_show_input_clauses_fn246(x)
SCM x;
{
  debug_print_clause(x);
  return newline(cur_output_port());
}

SCM prove_show_input_clauses_fn245(x)
SCM x;
{
  print_pure_clause(CDR(x));
  return newline(cur_output_port());
}

SCM prove_show_input_clauses_fn244(x)
SCM x;
{
  debug_print_clause(x);
  return newline(cur_output_port());
}

SCM prove_show_input_clauses_fn243(x)
SCM x;
{
  print_pure_clause(CDR(x));
  return newline(cur_output_port());
}

SCM prove_show_input_clauses_fn242(x)
SCM x;
{
  debug_print_clause(x);
  return newline(cur_output_port());
}

SCM prove_show_input_clauses_fn241(x)
SCM x;
{
  print_pure_clause(CDR(x));
  return newline(cur_output_port());
}

SCM prove_show_input_clauses_fn240(x)
SCM x;
{
  debug_print_clause(x);
  return newline(cur_output_port());
}

SCM prove_show_input_clauses_fn239(x)
SCM x;
{
  print_pure_clause(CDR(x));
  return newline(cur_output_port());
}

SCM prove_all_passes(usable,sos,demodulators,lit_demodulators,compl_lit_demodulators)
SCM usable,sos,demodulators,lit_demodulators,compl_lit_demodulators;
{
  SCM tmp;

  tmp=EOL;
  GLOBAL(no_passes_started_global)=BOOL_T;
  GLOBAL(strat_list_global)=const_185;
  if(!(NFALSEP(GLOBAL(auto_mode_flag_global)))) {
    if(NFALSEP(GLOBAL(total_time_given_global))) {
      GLOBAL(one_pass_time_global)=GLOBAL(total_time_given_global);
    }
    else {
      GLOBAL(one_pass_time_global)=MAKINUM(1000000);
    }
    tmp=prove_one_pass(usable,sos,demodulators,lit_demodulators,compl_lit_demodulators);
    get_check_time(MAKINUM(20));
    store_time_checkpoint_excl_(MAKINUM(20));
    return tmp;
  }
  else {
    if(NFALSEP(GLOBAL(total_time_given_global))) {
      GLOBAL(all_passes_time_global)=MAKINUM(INUM(GLOBAL(total_time_given_global))/INUM(GLOBAL(internal_time_units_per_second_global)));
    }
    else {
      GLOBAL(all_passes_time_global)=MAKINUM(180);
    }
    GLOBAL(strat_list_global)=cons(const_186,EOL);
    for(;!(NFALSEP(GLOBAL(foundflag_global))||(NULL_P(GLOBAL(strat_list_global))||(NFALSEP(GLOBAL(total_time_given_global))&&((INUM(get_check_time(MAKINUM(10)))-INUM(GLOBAL(total_time_start_global)))>INUM(GLOBAL(total_time_given_global))))));) {
      init_one_pass_strategical_flags();
      pick_strat_from_list();
      prove_one_pass(usable,sos,demodulators,lit_demodulators,compl_lit_demodulators);
    }
    if(!(NFALSEP(GLOBAL(foundflag_global)))&&!(NULL_P(GLOBAL(strat_list_global))))
      store_time_checkpoint_excl_(MAKINUM(10));
    get_check_time(MAKINUM(30));
    store_time_checkpoint_excl_(MAKINUM(30));
    return GLOBAL(foundflag_global);
  }
}

SCM pick_strat_from_list()
{
  SCM el;

  el=CAR(GLOBAL(strat_list_global));
  if(CAR(el)==binary_hyper_sos_symb)
    init_binary_hyper_sos_strat();
  else
  if(CAR(el)==hyper_symb)
    init_hyper_strat();
  else
  if(CAR(el)==hyper_order_symb)
    init_ordered_hyper_strat();
  else
  if(CAR(el)==hyper_wos_symb)
    init_hyper_wos_strat();
  else
  if(CAR(el)==binary_symb)
    init_binres_strat();
  else
  if(CAR(el)==binary_unit_symb)
    init_unit_strat();
  else
  if(CAR(el)==binary_order_symb)
    init_ordered_binres_strat();
  else
  if(CAR(el)==binary_nameorder_symb)
    init_name_ordered_binres_strat();
  else
  if(CAR(el)==binary_unit_depth_symb)
    init_binary_unit_depth();
  else
  if(CAR(el)==binary_unit_depth_sospref_symb)
    init_binary_unit_depth_sospref();
  else
  if(CAR(el)==binary_unit_depth_backdemod_symb)
    init_binary_unit_depth_backdemod();
  else
  if(CAR(el)==binary_unit_lex_backdemod_symb)
    init_binary_unit_lex_backdemod();
  else
  if(CAR(el)==binary_unit_lex_symb)
    init_binary_unit_lex();
  else
    init_binres_strat();
  el=CDR(el);
  GLOBAL(one_pass_time_global)=MAKINUM(INUM(GLOBAL(internal_time_units_per_second_global))*INUM(CAR(el)));
  el=CDR(el);
  GLOBAL(sos_strategy_flag_global)=CAR(el);
  el=CDR(el);
  if(!(NULL_P(el))) {
    GLOBAL(clause_keepdepth_limit_global)=CAR(el);
    el=CDR(el);
  }
  if(!(NULL_P(el))) {
    GLOBAL(clause_keeplength_limit_global)=CAR(el);
    el=CDR(el);
  }
  GLOBAL(strat_list_global)=CDR(GLOBAL(strat_list_global));
  return UNSPECIFIED;
}

SCM prove_one_pass(usable,sos,demodulators,lit_demodulators,compl_lit_demodulators)
SCM usable,sos,demodulators,lit_demodulators,compl_lit_demodulators;
{
  SCM part,tmp,nr;

  tmp=EOL;
  nr=MAKINUM(0);
  init_one_pass_globals();
  tmp=prove_make_initial_clauses(usable,sos,demodulators,lit_demodulators,compl_lit_demodulators);
  usable=CAR(tmp);
  tmp=CDR(tmp);
  sos=CAR(tmp);
  tmp=CDR(tmp);
  demodulators=CAR(tmp);
  tmp=CDR(tmp);
  lit_demodulators=CAR(tmp);
  tmp=CDR(tmp);
  compl_lit_demodulators=CAR(tmp);
  tmp=CDR(tmp);
  if(NFALSEP(GLOBAL(no_passes_started_global))) {
    prove_show_input_clauses(usable,sos,demodulators,lit_demodulators,compl_lit_demodulators);
    analyse_input(usable,sos);
    if(NFALSEP(GLOBAL(auto_mode_flag_global))) {
      select_initial_strategy();
      init_one_pass_strategical_flags();
      pick_strat_from_list();
    }
    GLOBAL(no_passes_started_global)=BOOL_F;
  }
  if(!(NFALSEP(GLOBAL(sos_strategy_flag_global)))) {
    sos=append2(usable,sos);
    usable=EOL;
  }
  if(NFALSEP(GLOBAL(hyper_strategy_flag_global)))
    for_each1(prove_one_pass_fn253,append2(usable,sos));
  if(NFALSEP(GLOBAL(hyper_strategy_flag_global))&&!(NFALSEP(GLOBAL(sos_strategy_flag_global)))) {
    for(part=sos;!(NULL_P(part));part=CDR(part))
      if(PAIR_P(CAR(part))&&NFALSEP(positive_cl_pred_(CDR(CAR(part))))) {
        sos=cons(CAR(part),sos);
      }
      else {
        tmp=cons(CAR(part),tmp);
      }
    usable=reverse(tmp);
  }
  if(NFALSEP(GLOBAL(order_strategy_flag_global))||(NFALSEP(GLOBAL(name_order_strategy_flag_global))||(NFALSEP(GLOBAL(firstlitpref_order_strategy_flag_global))||(NFALSEP(GLOBAL(posweight_order_strategy_flag_global))||NFALSEP(GLOBAL(ordered_paramodulation_flag_global))))))
    for_each1(prove_one_pass_fn254,append2(usable,sos));
  show_one_pass_strategy();
  if(NFALSEP(GLOBAL(type_theory_stratflag_global)))
    enumerate_sos_literals(sos);
  GLOBAL(sos_clauses_list_global)=sos;
  GLOBAL(usable_clauses_list_global)=usable;
  tmp=given_clause_slow_loop();
  GLOBAL(discr_tree_list_global)=cons(GLOBAL(discr_tree_global),GLOBAL(discr_tree_list_global));
  GLOBAL(unit_alist_list_global)=cons(GLOBAL(unit_alist_global),GLOBAL(unit_alist_list_global));
  if(NFALSEP(GLOBAL(keep_all_old_clauses_flag_global))) {
    GLOBAL(sos_clauses_list_list_global)=cons(GLOBAL(sos_clauses_list_global),GLOBAL(sos_clauses_list_list_global));
    GLOBAL(usable_clauses_list_list_global)=cons(GLOBAL(usable_clauses_list_global),GLOBAL(usable_clauses_list_list_global));
  }
  nr=MAKINUM(0);
  for_each1_inst1(&nr,prove_one_pass_fn257,GLOBAL(unit_alist_list_global));
  if(!(NFALSEP(GLOBAL(keep_all_old_clauses_flag_global)))&&((2*INUM(nr))>INUM(GLOBAL(max_kept_clauses_nr_global)))) {
    if(GLOBAL(display_info_level_global)>=MAKINUM(38)) {
      newline(cur_output_port());
      display(const_187,cur_output_port());
      newline(cur_output_port());
    }
    GLOBAL(discr_tree_list_global)=EOL;
    GLOBAL(unit_alist_list_global)=EOL;
    GLOBAL(sos_clauses_list_list_global)=EOL;
    GLOBAL(usable_clauses_list_list_global)=EOL;
  }
  return tmp;
}

SCM prove_one_pass_fn257(nr,alist)
SCM *nr;
SCM alist;
{
  return for_each1_inst2(nr,prove_one_pass_fn258,alist);
}

SCM prove_one_pass_fn258(nr,el)
SCM *nr;
SCM el;
{
  *nr=MAKINUM(INUM(length(CDR(el)))+INUM(*nr));
  return UNSPECIFIED;
}

SCM prove_one_pass_fn254(cl)
SCM cl;
{
  SET_CAR(CDR(CDR(CAR(cl))),map1(prove_one_pass_fn255,order_prohibit_litinfos(map1(prove_one_pass_fn256,CAR(CDR(CDR(CAR(cl))))),CDR(cl))));
  return UNSPECIFIED;
}

SCM prove_one_pass_fn256(x)
SCM x;
{
  return cons(MAKINUM(0),cons(MAKINUM(0),x));
}

SCM prove_one_pass_fn255(x)
SCM x;
{
  return CDR(CDR(x));
}

SCM prove_one_pass_fn253(cl)
SCM cl;
{
  if(!(NFALSEP(positive_cl_pred_(CDR(cl))))) {
    SET_CAR(CDR(CDR(CAR(cl))),make_input_litinfolst(CDR(cl)));
    return UNSPECIFIED;
  }
  else
    return UNSPECIFIED;
}

SCM show_one_pass_strategy()
{
  if(GLOBAL(display_info_level_global)>MAKINUM(38)) {
    if(NFALSEP(GLOBAL(hyper_strategy_flag_global))) {
      newline(cur_output_port());
      display(const_188,cur_output_port());
    }
    else {
      newline(cur_output_port());
      display(const_189,cur_output_port());
    }
    newline(cur_output_port());
    if(NFALSEP(GLOBAL(order_strategy_flag_global))) {
      display(const_190,cur_output_port());
      newline(cur_output_port());
    }
    if(NFALSEP(GLOBAL(name_order_strategy_flag_global))) {
      display(const_191,cur_output_port());
      newline(cur_output_port());
    }
    if(NFALSEP(GLOBAL(sos_strategy_flag_global))) {
      display(const_192,cur_output_port());
      newline(cur_output_port());
    }
    if(NFALSEP(GLOBAL(unit_strategy_flag_global))) {
      display(const_193,cur_output_port());
      newline(cur_output_port());
    }
    if(NFALSEP(GLOBAL(dynamic_demodulation_flag_global))) {
      display(const_194,cur_output_port());
      newline(cur_output_port());
    }
    if(NFALSEP(GLOBAL(unit_equality_strat_global))) {
      display(const_195,cur_output_port());
      newline(cur_output_port());
    }
    if(NFALSEP(GLOBAL(back_demodulate_flag_global))) {
      display(const_196,cur_output_port());
      newline(cur_output_port());
    }
    if(NFALSEP(GLOBAL(order_equality_lex_strat_global))) {
      display(const_197,cur_output_port());
      newline(cur_output_port());
    }
    if(!(ZERO_P(GLOBAL(clause_keeplength_limit_global)))) {
      display(const_198,cur_output_port());
      display(GLOBAL(clause_keeplength_limit_global),cur_output_port());
      newline(cur_output_port());
    }
    if(!(ZERO_P(GLOBAL(clause_keepdepth_limit_global)))) {
      display(const_199,cur_output_port());
      display(GLOBAL(clause_keepdepth_limit_global),cur_output_port());
      newline(cur_output_port());
    }
    if(!(NFALSEP(equal(GLOBAL(sos_preference_ratio_global),MAKINUM(5))))) {
      display(const_200,cur_output_port());
      display(GLOBAL(sos_preference_ratio_global),cur_output_port());
      newline(cur_output_port());
    }
    return newline(cur_output_port());
  }
  else
    return UNSPECIFIED;
}

SCM eq_lit_in_sos_pred_(sos)
SCM sos;
{
  return some_pred_(eq_lit_in_sos_pred__fn261,sos);
}

SCM eq_lit_in_sos_pred__fn261(cl)
SCM cl;
{
  return some_pred_(eq_lit_in_sos_pred__fn262,CDR(cl));
}

SCM eq_lit_in_sos_pred__fn262(lit)
SCM lit;
{
  SCM new_var2;

  new_var2=SBOOL(GLOBAL(eq_pred_nr_global)==(MAKINUM(534773760)&CAR(lit)));
  if(NFALSEP(new_var2))
    return new_var2;
  else
  if(NFALSEP(GLOBAL(type_theory_stratflag_global))) {
    if(!(NUMBER_P(CAR(CDR(lit)))))
      return SBOOL(GLOBAL(eq_fun_nr_global)==(MAKINUM(534773760)&CAR(CAR(CDR(lit)))));
    else
      return BOOL_F;
  }
  else
    return BOOL_F;
}

SCM add_typet_demod_ans(cl)
SCM cl;
{
  SCM eqlit,eqtype,eqarg1;

  eqlit=CAR(cl);
  eqtype=CAR(CDR(CDR(CDR(eqlit))));
  eqarg1=CAR(CDR(eqlit));
  return cons(cons(GLOBAL(ans_symbol_global),cons(cons(GLOBAL(id_refl_fun_symbol_global),cons(eqtype,cons(eqarg1,EOL))),EOL)),cons(cons(GLOBAL(inhabited_symbol_global),cons(CAR(cl),EOL)),EOL));
}

SCM remove_typet_demod_ans(cl)
SCM cl;
{
  SCM litlst,newcl,newlit;

  litlst=remove_if(remove_typet_demod_ans_fn264,CAR(CDR(CDR(CAR(cl)))));
  newcl=remove_ans_literals(CDR(cl));
  newlit=CAR(CDR(CAR(newcl)));
  return cons(cons(CAR(CAR(cl)),cons(CAR(CDR(CAR(cl))),cons(litlst,CDR(CDR(CDR(CAR(cl))))))),cons(newlit,EOL));
}

SCM remove_typet_demod_ans_fn264(y)
SCM y;
{
  return NOT(SBOOL(ZERO_P(MAKINUM(4)&CAR(y))));
}

SCM remove_ans_from_clauses(cllist)
SCM cllist;
{
  SCM new_var5,new_var2,new_var3,new_var4;

  for(new_var5=cllist,new_var2=EOL,new_var3=EOL,new_var4=EOL;
      PAIR_P(new_var5);
      new_var5=CDR(new_var5)) {
    new_var4=remove_ans_from_clauses_fn267(CAR(new_var5));
    if(NULL_P(new_var2)) {
      new_var2=cons(new_var4,EOL);
      new_var3=new_var2;
    }
    else {
      SET_CDR(new_var3,cons(new_var4,EOL));
      new_var3=CDR(new_var3);
    }
  }
  return new_var2;
}

SCM remove_ans_from_clauses_fn267(x)
SCM x;
{
  SCM litlst,cl;

  litlst=remove_if(remove_ans_from_clauses_fn268,CAR(CDR(CDR(CAR(x)))));
  cl=remove_ans_literals(CDR(x));
  return cons(cons(CAR(CAR(x)),cons(CAR(CDR(CAR(x))),cons(litlst,CDR(CDR(CDR(CAR(x))))))),cl);
}

SCM remove_ans_from_clauses_fn268(y)
SCM y;
{
  return NOT(SBOOL(ZERO_P(MAKINUM(4)&CAR(y))));
}

SCM enumerate_sos_literals(sos)
SCM sos;
{
  GLOBAL(enumerate_sos_literals_nr_global)=MAKINUM(0);
  return for_each1(enumerate_sos_literals_fn271,sos);
}

SCM enumerate_sos_literals_fn271(cl)
SCM cl;
{
  SCM litinfolst;

  litinfolst=CAR(CDR(CDR(CAR(cl))));
  SET_CAR(CDR(CDR(CAR(cl))),map1(enumerate_sos_literals_fn272,litinfolst));
  return UNSPECIFIED;
}

SCM enumerate_sos_literals_fn272(litinf)
SCM litinf;
{
  GLOBAL(enumerate_sos_literals_nr_global)=MAKINUM(1+INUM(GLOBAL(enumerate_sos_literals_nr_global)));
  return append2(litinf,cons(GLOBAL(enumerate_sos_literals_nr_global),EOL));
}

SCM analyse_input(usable,sos)
SCM usable,sos;
{
  SCM clauselstpart,tmp,cl,clinf,purecl,litinfolst,tmplitinfolst,prohibitlitnr,newlitinf,litnr,ndepth,pdepth,depth,poslitnr,neglitnr;

  GLOBAL(input_cl_nr_global)=MAKINUM(0);
  GLOBAL(input_unitcl_nr_global)=MAKINUM(0);
  GLOBAL(input_negcl_nr_global)=MAKINUM(0);
  GLOBAL(input_poscl_nr_global)=MAKINUM(0);
  GLOBAL(input_mixcl_nr_global)=MAKINUM(0);
  GLOBAL(input_horncl_nr_global)=MAKINUM(0);
  GLOBAL(input_invhorncl_nr_global)=MAKINUM(0);
  GLOBAL(input_negdhorncl_nr_global)=MAKINUM(0);
  GLOBAL(input_wellorderedcl_nr_global)=MAKINUM(0);
  GLOBAL(input_somewhat_ordered_nr_global)=MAKINUM(0);
  GLOBAL(input_wellhyper_nr_global)=MAKINUM(0);
  GLOBAL(input_maxlen_nr_global)=MAKINUM(0);
  GLOBAL(input_maxdepth_nr_global)=MAKINUM(0);
  GLOBAL(input_contains_eq_global)=BOOL_F;
  GLOBAL(input_negun_d_global)=MAKINUM(0);
  GLOBAL(input_posun_d_global)=MAKINUM(0);
  if(NFALSEP(eq_lit_in_sos_pred_(sos))||NFALSEP(eq_lit_in_sos_pred_(usable))) {
    GLOBAL(input_contains_eq_global)=BOOL_T;
  }
  else {
    GLOBAL(input_contains_eq_global)=BOOL_F;
  }
  tmp=EOL;
  cl=EOL;
  clinf=EOL;
  purecl=EOL;
  litinfolst=EOL;
  tmplitinfolst=EOL;
  prohibitlitnr=MAKINUM(0);
  newlitinf=EOL;
  litnr=MAKINUM(0);
  ndepth=MAKINUM(0);
  pdepth=MAKINUM(0);
  depth=MAKINUM(0);
  poslitnr=MAKINUM(0);
  neglitnr=MAKINUM(0);
  for(clauselstpart=append2(usable,sos);!(NULL_P(clauselstpart));clauselstpart=CDR(clauselstpart)) {
    cl=CAR(clauselstpart);
    clinf=CAR(cl);
    purecl=CDR(cl);
    litinfolst=CAR(CDR(CDR(clinf)));
    tmplitinfolst=map1(analyse_input_fn276,litinfolst);
    GLOBAL(input_cl_nr_global)=MAKINUM(1+INUM(GLOBAL(input_cl_nr_global)));
    litnr=MAKINUM(0);
    neglitnr=MAKINUM(0);
    poslitnr=MAKINUM(0);
    ndepth=MAKINUM(0);
    pdepth=MAKINUM(0);
    for_each1_inst4(&litnr,&neglitnr,&ndepth,&poslitnr,&pdepth,analyse_input_fn277,purecl);
    if(ndepth>pdepth) {
      depth=ndepth;
    }
    else {
      depth=pdepth;
    }
    if(depth>GLOBAL(input_maxdepth_nr_global)) {
      GLOBAL(input_maxdepth_nr_global)=depth;
    }
    if(litnr>GLOBAL(input_maxlen_nr_global)) {
      GLOBAL(input_maxlen_nr_global)=litnr;
    }
    if(litnr==MAKINUM(1)) {
      if(!(ZERO_P(MAKINUM(268435456)&CAR(CAR(purecl))))&&(fun_real_depth(CAR(CAR(purecl)))>GLOBAL(input_negun_d_global))) {
        GLOBAL(input_negun_d_global)=fun_real_depth(CAR(CAR(purecl)));
      }
      if(ZERO_P(MAKINUM(268435456)&CAR(CAR(purecl)))&&(fun_real_depth(CAR(CAR(purecl)))>GLOBAL(input_posun_d_global))) {
        GLOBAL(input_posun_d_global)=fun_real_depth(CAR(CAR(purecl)));
      }
      GLOBAL(input_unitcl_nr_global)=MAKINUM(1+INUM(GLOBAL(input_unitcl_nr_global)));
    }
    if(ZERO_P(poslitnr)) {
      GLOBAL(input_negcl_nr_global)=MAKINUM(1+INUM(GLOBAL(input_negcl_nr_global)));
    }
    else
    if(ZERO_P(neglitnr)) {
      GLOBAL(input_poscl_nr_global)=MAKINUM(1+INUM(GLOBAL(input_poscl_nr_global)));
    }
    else {
      GLOBAL(input_mixcl_nr_global)=MAKINUM(1+INUM(GLOBAL(input_mixcl_nr_global)));
    }
    if((litnr>MAKINUM(1))&&(poslitnr<=MAKINUM(1))) {
      GLOBAL(input_horncl_nr_global)=MAKINUM(1+INUM(GLOBAL(input_horncl_nr_global)));
      if(pdepth>ndepth) {
        GLOBAL(input_negdhorncl_nr_global)=MAKINUM(1+INUM(GLOBAL(input_negdhorncl_nr_global)));
      }
    }
    if((litnr>MAKINUM(1))&&(neglitnr<=MAKINUM(1))) {
      GLOBAL(input_invhorncl_nr_global)=MAKINUM(1+INUM(GLOBAL(input_invhorncl_nr_global)));
    }
    if((litnr>MAKINUM(1))&&((2*INUM(neglitnr))>=INUM(poslitnr))) {
      GLOBAL(input_wellhyper_nr_global)=MAKINUM(1+INUM(GLOBAL(input_wellhyper_nr_global)));
    }
    prohibitlitnr=MAKINUM(0);
    if(!(NULL_P(CDR(purecl)))) {
      tmp=GLOBAL(order_strategy_flag_global);
      GLOBAL(order_strategy_flag_global)=BOOL_T;
      newlitinf=vdepth_order_litinfo_aux(tmplitinfolst,purecl);
      GLOBAL(order_strategy_flag_global)=tmp;
      for_each1_inst1(&prohibitlitnr,analyse_input_fn278,newlitinf);
      if((2*INUM(prohibitlitnr))>=INUM(litnr)) {
        GLOBAL(input_wellorderedcl_nr_global)=MAKINUM(1+INUM(GLOBAL(input_wellorderedcl_nr_global)));
      }
      if(prohibitlitnr>MAKINUM(0)) {
        GLOBAL(input_somewhat_ordered_nr_global)=MAKINUM(1+INUM(GLOBAL(input_somewhat_ordered_nr_global)));
      }
    }
  }
  return UNSPECIFIED;
}

SCM analyse_input_fn278(prohibitlitnr,inf)
SCM *prohibitlitnr;
SCM inf;
{
  if(!(!(litinf_nobinrespara_mask_global==(litinf_nobinrespara_mask_global&CAR(CDR(CDR(inf))))))) {
    *prohibitlitnr=MAKINUM(1+INUM(*prohibitlitnr));
    return UNSPECIFIED;
  }
  else
    return UNSPECIFIED;
}

SCM analyse_input_fn277(litnr,neglitnr,ndepth,poslitnr,pdepth,lit)
SCM *litnr,*neglitnr,*ndepth,*poslitnr,*pdepth;
SCM lit;
{
  *litnr=MAKINUM(1+INUM(*litnr));
  if(!(ZERO_P(MAKINUM(268435456)&CAR(lit)))) {
    *neglitnr=MAKINUM(1+INUM(*neglitnr));
    if(fun_real_depth(CAR(lit))>*ndepth) {
      *ndepth=fun_real_depth(CAR(lit));
      return UNSPECIFIED;
    }
    else
      return UNSPECIFIED;
  }
  else {
    *poslitnr=MAKINUM(1+INUM(*poslitnr));
    if(fun_real_depth(CAR(lit))>*pdepth) {
      *pdepth=fun_real_depth(CAR(lit));
      return UNSPECIFIED;
    }
    else
      return UNSPECIFIED;
  }
}

SCM analyse_input_fn276(x)
SCM x;
{
  return cons(MAKINUM(0),cons(MAKINUM(0),x));
}

SCM select_initial_strategy()
{
  SCM res,tmp;

  res=EOL;
  tmp=EOL;
  res=apply(GLOBAL(copy_tree),select_initial_strategy_aux(),listofnull);
  res=map1(select_initial_strategy_fn280,res);
  tmp=apply(GLOBAL(last_pair),res,listofnull);
  SET_CAR(CDR(CAR(tmp)),MAKINUM(100000));
  if(GLOBAL(display_info_level_global)>=MAKINUM(30)) {
    newline(cur_output_port());
    display(const_201,cur_output_port());
    newline(cur_output_port());
    display(res,cur_output_port());
    newline(cur_output_port());
  }
  GLOBAL(strat_list_global)=res;
  if(NFALSEP(GLOBAL(input_contains_eq_global))&&NFALSEP(GLOBAL(paramodulation_allowed_flag_global))) {
    if(GLOBAL(display_info_level_global)>=MAKINUM(35)) {
      newline(cur_output_port());
      display(const_202,cur_output_port());
      newline(cur_output_port());
    }
    GLOBAL(paramodulation_strategy_flag_global)=BOOL_T;
    turn_on_demodulation();
  }
  else {
    if(GLOBAL(display_info_level_global)>=MAKINUM(35)) {
      newline(cur_output_port());
      display(const_203,cur_output_port());
      newline(cur_output_port());
    }
    GLOBAL(paramodulation_strategy_flag_global)=BOOL_F;
    turn_off_demodulation();
  }
  return res;
}

SCM select_initial_strategy_fn280(x)
SCM x;
{
  return cons(CAR(x),cons(MAKINUM((INUM(GLOBAL(all_passes_time_global))*INUM(CAR(CDR(x))))/100),CDR(CDR(x))));
}

SCM select_initial_strategy_aux()
{
  SCM tmp,res,maxtime,incrlen;

  tmp=EOL;
  res=EOL;
  maxtime=MAKINUM(150);
  incrlen=MAKINUM(0);
  if(GLOBAL(display_info_level_global)>=MAKINUM(50)) {
    newline(cur_output_port());
    display(const_204,cur_output_port());
    newline(cur_output_port());
    display(const_205,cur_output_port());
    display(GLOBAL(input_cl_nr_global),cur_output_port());
    newline(cur_output_port());
    display(const_206,cur_output_port());
    display(GLOBAL(input_unitcl_nr_global),cur_output_port());
    newline(cur_output_port());
    display(const_207,cur_output_port());
    display(GLOBAL(input_negcl_nr_global),cur_output_port());
    newline(cur_output_port());
    display(const_208,cur_output_port());
    display(GLOBAL(input_poscl_nr_global),cur_output_port());
    newline(cur_output_port());
    display(const_209,cur_output_port());
    display(GLOBAL(input_mixcl_nr_global),cur_output_port());
    newline(cur_output_port());
    display(const_210,cur_output_port());
    display(GLOBAL(input_horncl_nr_global),cur_output_port());
    newline(cur_output_port());
    display(const_211,cur_output_port());
    display(GLOBAL(input_invhorncl_nr_global),cur_output_port());
    newline(cur_output_port());
    display(const_212,cur_output_port());
    display(GLOBAL(input_negdhorncl_nr_global),cur_output_port());
    newline(cur_output_port());
    display(const_213,cur_output_port());
    display(GLOBAL(input_wellorderedcl_nr_global),cur_output_port());
    newline(cur_output_port());
    display(const_214,cur_output_port());
    display(GLOBAL(input_wellhyper_nr_global),cur_output_port());
    newline(cur_output_port());
    display(const_215,cur_output_port());
    display(GLOBAL(input_somewhat_ordered_nr_global),cur_output_port());
    newline(cur_output_port());
    display(const_216,cur_output_port());
    display(GLOBAL(input_maxlen_nr_global),cur_output_port());
    newline(cur_output_port());
    display(const_217,cur_output_port());
    display(GLOBAL(input_maxdepth_nr_global),cur_output_port());
    newline(cur_output_port());
    display(const_218,cur_output_port());
    display(GLOBAL(input_contains_eq_global),cur_output_port());
    newline(cur_output_port());
    display(const_219,cur_output_port());
    newline(cur_output_port());
  }
  incrlen=MAKINUM((2*INUM(GLOBAL(input_maxlen_nr_global)))-1);
  if(GLOBAL(input_cl_nr_global)==GLOBAL(input_unitcl_nr_global)) {
    res=cons(cons(binary_unit_depth_backdemod_symb,cons(MAKINUM(10),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(MAKINUM(1),EOL))))),cons(cons(binary_unit_depth_sospref_symb,cons(MAKINUM(20),cons(BOOL_T,EOL))),cons(cons(binary_unit_depth_backdemod_symb,cons(MAKINUM(30),cons(BOOL_F,EOL))),cons(cons(binary_unit_lex_backdemod_symb,cons(MAKINUM(40),cons(BOOL_F,EOL))),EOL))));
  }
  else
  if(INUM(GLOBAL(input_horncl_nr_global))==(INUM(GLOBAL(input_cl_nr_global))-INUM(GLOBAL(input_unitcl_nr_global)))) {
    if(((9*INUM(GLOBAL(input_horncl_nr_global)))<=(10*INUM(GLOBAL(input_negdhorncl_nr_global))))&&!(NFALSEP(GLOBAL(input_contains_eq_global)))) {
      if(GLOBAL(input_cl_nr_global)>MAKINUM(100)) {
        res=cons(cons(hyper_symb,cons(MAKINUM(5),cons(BOOL_T,EOL))),cons(cons(binary_unit_symb,cons(MAKINUM(15),cons(BOOL_T,EOL))),cons(cons(binary_symb,cons(MAKINUM(10),cons(BOOL_T,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_symb,cons(MAKINUM(30),cons(BOOL_T,EOL))),cons(cons(hyper_symb,cons(MAKINUM(10),cons(BOOL_F,EOL))),cons(cons(binary_nameorder_symb,cons(MAKINUM(10),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_nameorder_symb,cons(MAKINUM(5),cons(BOOL_F,EOL))),cons(cons(binary_unit_symb,cons(MAKINUM(15),cons(BOOL_F,EOL))),EOL))))))));
      }
      else
      if(GLOBAL(input_cl_nr_global)>MAKINUM(20)) {
        res=cons(cons(hyper_symb,cons(MAKINUM(2),cons(BOOL_T,EOL))),cons(cons(binary_unit_symb,cons(MAKINUM(10),cons(BOOL_T,EOL))),cons(cons(binary_symb,cons(MAKINUM(10),cons(BOOL_T,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_symb,cons(MAKINUM(20),cons(BOOL_T,EOL))),cons(cons(hyper_symb,cons(MAKINUM(10),cons(BOOL_F,EOL))),cons(cons(binary_nameorder_symb,cons(MAKINUM(10),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_nameorder_symb,cons(MAKINUM(5),cons(BOOL_F,EOL))),cons(cons(binary_unit_symb,cons(MAKINUM(28),cons(BOOL_F,EOL))),EOL))))))));
      }
      else {
        res=cons(cons(binary_symb,cons(MAKINUM(3),cons(BOOL_T,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_symb,cons(MAKINUM(7),cons(BOOL_T,EOL))),cons(cons(hyper_symb,cons(MAKINUM(20),cons(BOOL_F,EOL))),cons(cons(binary_nameorder_symb,cons(MAKINUM(20),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_nameorder_symb,cons(MAKINUM(10),cons(BOOL_F,EOL))),cons(cons(binary_unit_symb,cons(MAKINUM(40),cons(BOOL_F,EOL))),EOL))))));
      }
    }
    else
    if((GLOBAL(input_negcl_nr_global)==MAKINUM(1))&&((GLOBAL(input_negun_d_global)>MAKINUM(0))&&(GLOBAL(input_negun_d_global)>GLOBAL(input_posun_d_global)))) {
      if(GLOBAL(input_cl_nr_global)>MAKINUM(100)) {
        res=cons(cons(hyper_symb,cons(MAKINUM(5),cons(BOOL_T,EOL))),cons(cons(binary_unit_symb,cons(MAKINUM(15),cons(BOOL_T,EOL))),cons(cons(binary_symb,cons(MAKINUM(10),cons(BOOL_T,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_symb,cons(MAKINUM(30),cons(BOOL_T,EOL))),cons(cons(hyper_symb,cons(MAKINUM(20),cons(BOOL_F,EOL))),cons(cons(binary_unit_symb,cons(MAKINUM(20),cons(BOOL_F,EOL))),EOL))))));
      }
      else
      if(GLOBAL(input_cl_nr_global)>MAKINUM(20)) {
        res=cons(cons(hyper_symb,cons(MAKINUM(2),cons(BOOL_T,EOL))),cons(cons(binary_unit_symb,cons(MAKINUM(10),cons(BOOL_T,EOL))),cons(cons(binary_symb,cons(MAKINUM(10),cons(BOOL_T,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_symb,cons(MAKINUM(20),cons(BOOL_T,EOL))),cons(cons(hyper_symb,cons(MAKINUM(20),cons(BOOL_F,EOL))),cons(cons(binary_order_symb,cons(MAKINUM(8),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_unit_symb,cons(MAKINUM(30),cons(BOOL_F,EOL))),EOL)))))));
      }
      else {
        res=cons(cons(hyper_symb,cons(MAKINUM(30),cons(BOOL_F,EOL))),cons(cons(binary_symb,cons(MAKINUM(3),cons(BOOL_T,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_symb,cons(MAKINUM(7),cons(BOOL_T,EOL))),cons(cons(binary_nameorder_symb,cons(MAKINUM(5),cons(BOOL_F,EOL))),cons(cons(binary_order_symb,cons(MAKINUM(5),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_unit_symb,cons(MAKINUM(55),cons(BOOL_F,EOL))),EOL))))));
      }
    }
    else
    if(GLOBAL(input_cl_nr_global)>MAKINUM(100)) {
      res=cons(cons(hyper_symb,cons(MAKINUM(5),cons(BOOL_T,EOL))),cons(cons(binary_unit_symb,cons(MAKINUM(15),cons(BOOL_T,EOL))),cons(cons(binary_symb,cons(MAKINUM(10),cons(BOOL_T,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_symb,cons(MAKINUM(35),cons(BOOL_T,EOL))),cons(cons(binary_unit_symb,cons(MAKINUM(15),cons(BOOL_F,EOL))),cons(cons(hyper_symb,cons(MAKINUM(20),cons(BOOL_F,EOL))),EOL))))));
    }
    else
    if(GLOBAL(input_cl_nr_global)>MAKINUM(20)) {
      res=cons(cons(hyper_symb,cons(MAKINUM(5),cons(BOOL_T,EOL))),cons(cons(binary_unit_symb,cons(MAKINUM(10),cons(BOOL_T,EOL))),cons(cons(binary_symb,cons(MAKINUM(10),cons(BOOL_T,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_symb,cons(MAKINUM(20),cons(BOOL_T,EOL))),cons(cons(binary_order_symb,cons(MAKINUM(5),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_unit_symb,cons(MAKINUM(15),cons(BOOL_F,EOL))),cons(cons(hyper_symb,cons(MAKINUM(35),cons(BOOL_F,EOL))),EOL)))))));
    }
    else {
      res=cons(cons(binary_symb,cons(MAKINUM(10),cons(BOOL_T,EOL))),cons(cons(binary_unit_symb,cons(MAKINUM(30),cons(BOOL_F,EOL))),cons(cons(binary_order_symb,cons(MAKINUM(5),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(hyper_symb,cons(MAKINUM(55),cons(BOOL_F,EOL))),EOL))));
    }
  }
  else
  if(INUM(GLOBAL(input_invhorncl_nr_global))==(INUM(GLOBAL(input_cl_nr_global))-INUM(GLOBAL(input_unitcl_nr_global)))) {
    if(GLOBAL(input_cl_nr_global)>MAKINUM(100)) {
      res=cons(cons(hyper_symb,cons(MAKINUM(5),cons(BOOL_T,EOL))),cons(cons(binary_unit_symb,cons(MAKINUM(15),cons(BOOL_T,EOL))),cons(cons(binary_symb,cons(MAKINUM(10),cons(BOOL_T,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_symb,cons(MAKINUM(30),cons(BOOL_T,EOL))),cons(cons(binary_unit_symb,cons(MAKINUM(25),cons(BOOL_F,EOL))),cons(cons(binary_nameorder_symb,cons(MAKINUM(15),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),EOL))))));
    }
    else
    if(GLOBAL(input_cl_nr_global)>MAKINUM(20)) {
      res=cons(cons(hyper_symb,cons(MAKINUM(2),cons(BOOL_T,EOL))),cons(cons(binary_unit_symb,cons(MAKINUM(10),cons(BOOL_T,EOL))),cons(cons(binary_symb,cons(MAKINUM(10),cons(BOOL_T,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_symb,cons(MAKINUM(20),cons(BOOL_T,EOL))),cons(cons(binary_unit_symb,cons(MAKINUM(30),cons(BOOL_F,EOL))),cons(cons(binary_order_symb,cons(MAKINUM(5),cons(BOOL_F,EOL))),cons(cons(binary_nameorder_symb,cons(MAKINUM(10),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_nameorder_symb,cons(MAKINUM(13),cons(BOOL_F,EOL))),EOL))))))));
    }
    else {
      res=cons(cons(binary_symb,cons(MAKINUM(10),cons(BOOL_T,EOL))),cons(cons(binary_unit_symb,cons(MAKINUM(30),cons(BOOL_F,EOL))),cons(cons(hyper_symb,cons(MAKINUM(10),cons(BOOL_F,EOL))),cons(cons(binary_order_symb,cons(MAKINUM(5),cons(BOOL_F,EOL))),cons(cons(binary_nameorder_symb,cons(MAKINUM(20),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_nameorder_symb,cons(MAKINUM(25),cons(BOOL_F,EOL))),EOL))))));
    }
  }
  else
  if((10*INUM(GLOBAL(input_wellorderedcl_nr_global)))>=(8*(INUM(GLOBAL(input_cl_nr_global))-INUM(GLOBAL(input_unitcl_nr_global))))) {
    if(GLOBAL(input_cl_nr_global)>MAKINUM(100)) {
      res=cons(cons(hyper_symb,cons(MAKINUM(5),cons(BOOL_T,EOL))),cons(cons(binary_unit_symb,cons(MAKINUM(15),cons(BOOL_T,EOL))),cons(cons(binary_symb,cons(MAKINUM(15),cons(BOOL_T,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_symb,cons(MAKINUM(35),cons(BOOL_T,EOL))),cons(cons(binary_nameorder_symb,cons(MAKINUM(10),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_order_symb,cons(MAKINUM(20),cons(BOOL_F,EOL))),EOL))))));
    }
    else
    if(GLOBAL(input_cl_nr_global)>MAKINUM(20)) {
      res=cons(cons(hyper_symb,cons(MAKINUM(2),cons(BOOL_T,EOL))),cons(cons(binary_unit_symb,cons(MAKINUM(10),cons(BOOL_T,EOL))),cons(cons(binary_symb,cons(MAKINUM(10),cons(BOOL_T,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_symb,cons(MAKINUM(20),cons(BOOL_T,EOL))),cons(cons(binary_unit_symb,cons(MAKINUM(10),cons(BOOL_F,EOL))),cons(cons(binary_order_symb,cons(MAKINUM(10),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_order_symb,cons(MAKINUM(10),cons(BOOL_F,EOL))),cons(cons(binary_nameorder_symb,cons(MAKINUM(10),cons(BOOL_F,EOL))),EOL))))))));
    }
    else {
      res=cons(cons(binary_symb,cons(MAKINUM(10),cons(BOOL_T,EOL))),cons(cons(binary_unit_symb,cons(MAKINUM(20),cons(BOOL_F,EOL))),cons(cons(hyper_symb,cons(MAKINUM(20),cons(BOOL_F,EOL))),cons(cons(binary_order_symb,cons(MAKINUM(10),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_order_symb,cons(MAKINUM(30),cons(BOOL_F,EOL))),cons(cons(binary_nameorder_symb,cons(MAKINUM(10),cons(BOOL_F,EOL))),EOL))))));
    }
  }
  else
  if((4*INUM(GLOBAL(input_horncl_nr_global)))>=(3*(INUM(GLOBAL(input_cl_nr_global))-INUM(GLOBAL(input_unitcl_nr_global))))) {
    if(GLOBAL(input_cl_nr_global)>MAKINUM(100)) {
      res=cons(cons(hyper_symb,cons(MAKINUM(5),cons(BOOL_T,EOL))),cons(cons(binary_unit_symb,cons(MAKINUM(15),cons(BOOL_T,EOL))),cons(cons(binary_symb,cons(MAKINUM(10),cons(BOOL_T,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_symb,cons(MAKINUM(30),cons(BOOL_T,EOL))),cons(cons(binary_unit_symb,cons(MAKINUM(15),cons(BOOL_F,EOL))),cons(cons(hyper_order_symb,cons(MAKINUM(25),cons(BOOL_F,EOL))),EOL))))));
    }
    else
    if(GLOBAL(input_cl_nr_global)>MAKINUM(20)) {
      res=cons(cons(hyper_symb,cons(MAKINUM(5),cons(BOOL_T,EOL))),cons(cons(binary_unit_symb,cons(MAKINUM(10),cons(BOOL_T,EOL))),cons(cons(binary_symb,cons(MAKINUM(10),cons(BOOL_T,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_symb,cons(MAKINUM(20),cons(BOOL_T,EOL))),cons(cons(binary_order_symb,cons(MAKINUM(5),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_unit_symb,cons(MAKINUM(15),cons(BOOL_F,EOL))),cons(cons(hyper_order_symb,cons(MAKINUM(35),cons(BOOL_F,EOL))),EOL)))))));
    }
    else {
      res=cons(cons(binary_symb,cons(MAKINUM(10),cons(BOOL_T,EOL))),cons(cons(binary_unit_symb,cons(MAKINUM(30),cons(BOOL_F,EOL))),cons(cons(binary_order_symb,cons(MAKINUM(10),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_order_symb,cons(MAKINUM(10),cons(BOOL_F,EOL))),cons(cons(hyper_order_symb,cons(MAKINUM(40),cons(BOOL_F,EOL))),EOL)))));
    }
  }
  else
  if(GLOBAL(input_cl_nr_global)>MAKINUM(100)) {
    res=cons(cons(hyper_symb,cons(MAKINUM(5),cons(BOOL_T,EOL))),cons(cons(binary_unit_symb,cons(MAKINUM(15),cons(BOOL_T,EOL))),cons(cons(binary_symb,cons(MAKINUM(10),cons(BOOL_T,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_symb,cons(MAKINUM(25),cons(BOOL_T,EOL))),cons(cons(binary_unit_symb,cons(MAKINUM(10),cons(BOOL_F,EOL))),cons(cons(binary_order_symb,cons(MAKINUM(15),cons(BOOL_F,EOL))),cons(cons(hyper_order_symb,cons(MAKINUM(20),cons(BOOL_F,EOL))),EOL)))))));
  }
  else
  if(GLOBAL(input_cl_nr_global)>MAKINUM(20)) {
    res=cons(cons(hyper_symb,cons(MAKINUM(2),cons(BOOL_T,EOL))),cons(cons(binary_unit_symb,cons(MAKINUM(5),cons(BOOL_T,EOL))),cons(cons(binary_symb,cons(MAKINUM(10),cons(BOOL_T,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_symb,cons(MAKINUM(23),cons(BOOL_T,EOL))),cons(cons(binary_unit_symb,cons(MAKINUM(15),cons(BOOL_F,EOL))),cons(cons(binary_order_symb,cons(MAKINUM(7),cons(BOOL_F,EOL))),cons(cons(binary_nameorder_symb,cons(MAKINUM(8),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_nameorder_symb,cons(MAKINUM(10),cons(BOOL_F,EOL))),cons(cons(hyper_order_symb,cons(MAKINUM(20),cons(BOOL_F,EOL))),EOL)))))))));
  }
  else {
    res=cons(cons(binary_symb,cons(MAKINUM(5),cons(BOOL_T,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_symb,cons(MAKINUM(15),cons(BOOL_T,EOL))),cons(cons(binary_unit_symb,cons(MAKINUM(15),cons(BOOL_F,EOL))),cons(cons(binary_order_symb,cons(MAKINUM(8),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_order_symb,cons(MAKINUM(12),cons(BOOL_F,EOL))),cons(cons(binary_nameorder_symb,cons(MAKINUM(15),cons(BOOL_F,EOL))),cons(cons(hyper_order_symb,cons(MAKINUM(30),cons(BOOL_F,EOL))),EOL)))))));
  }
  return res;
}

SCM break_nonkeyword()
{
  SCM tmp,flag;

  flag=BOOL_F;
  for(;!(NFALSEP(flag));) {
    newline(cur_output_port());
    display(const_220,cur_output_port());
    tmp=eval(lread(cur_input_port()));
    if(tmp==quit_symb) {
      flag=BOOL_T;
    }
    else
      display(tmp,cur_output_port());
    newline(cur_output_port());
  }
  return UNSPECIFIED;
}

SCM hprove(x,y,z)
SCM x,y,z;
{
  init_hyper_strat();
  return prove(x,y,z);
}

SCM hfprove(x,y)
SCM x,y;
{
  init_hyper_strat();
  return fprove(x);
}

SCM init()
{
  return init_hyper_strat();
}

SCM go()
{
  init_binres_strat();
  return fprove(const_221);
}

SCM abs_path_part(path)
SCM path;
{
  return substring(path,MAKINUM(0),MAKINUM(INUM(ST_LENGTH(path))-INUM(ST_LENGTH(const_222))));
}

SCM show_old_units()
{
  return for_each1(show_old_units_fn284,GLOBAL(unit_alist_list_global));
}

SCM show_old_units_fn284(x)
SCM x;
{
  display(const_223,cur_output_port());
  newline(cur_output_port());
  return for_each1(show_old_units_fn285,x);
}

SCM show_old_units_fn285(sublist)
SCM sublist;
{
  return for_each1(show_old_units_fn286,CDR(sublist));
}

SCM show_old_units_fn286(el)
SCM el;
{
  print_clause(el);
  return newline(cur_output_port());
}

SCM hyper_contradiction_pred_(fullcl)
SCM fullcl;
{
  SCM results_part,ycl,yinf,ylitinf,one_step_results;

  if(!(NFALSEP(GLOBAL(foundflag_global)))&&(!(NFALSEP(empty_cl_pred_(CDR(fullcl))))&&(!(NFALSEP(unit_cl_pred_(CDR(fullcl))))&&NFALSEP(every_pred_(hyper_contradiction_pred__fn288,CDR(fullcl)))))) {
    if(GLOBAL(display_info_level_global)>=MAKINUM(70)) {
      newline(cur_output_port());
      display(const_224,cur_output_port());
      print_full_clause(fullcl);
      newline(cur_output_port());
    }
    GLOBAL(unit_clash_flag_global)=BOOL_T;
    ycl=map1(rename_x_to_y_term,CDR(fullcl));
    yinf=CAR(fullcl);
    ylitinf=CAR(CDR(CDR(yinf)));
    one_step_results=one_step_for_hyper(cons(yinf,ycl));
    for(results_part=one_step_results;!(NULL_P(results_part)||(NFALSEP(GLOBAL(foundflag_global))||NFALSEP(GLOBAL(stop_fast_loop_flag_global))));results_part=CDR(results_part))
      hyper_contradiction_pred_(CAR(results_part));
    GLOBAL(unit_clash_flag_global)=BOOL_F;
    return GLOBAL(foundflag_global);
  }
  else
    return BOOL_F;
}

SCM hyper_contradiction_pred__fn288(lit)
SCM lit;
{
  return SBOOL(ZERO_P(MAKINUM(65536)&CAR(lit)));
}

SCM full_hyper_contradiction_pred_(fullcl)
SCM fullcl;
{
  SCM results_part,ycl,yinf,ylitinf,one_step_results;

  if(!(NFALSEP(GLOBAL(foundflag_global)))&&(!(NFALSEP(empty_cl_pred_(CDR(fullcl))))&&!(NFALSEP(unit_cl_pred_(CDR(fullcl)))))) {
    if(GLOBAL(display_info_level_global)>=MAKINUM(70)) {
      newline(cur_output_port());
      display(const_225,cur_output_port());
      print_full_clause(fullcl);
      newline(cur_output_port());
    }
    GLOBAL(unit_clash_flag_global)=BOOL_T;
    ycl=map1(rename_x_to_y_term,CDR(fullcl));
    yinf=CAR(fullcl);
    ylitinf=CAR(CDR(CDR(yinf)));
    one_step_results=one_step_for_hyper(cons(yinf,ycl));
    for(results_part=one_step_results;!(NULL_P(results_part)||(NFALSEP(GLOBAL(foundflag_global))||NFALSEP(GLOBAL(stop_fast_loop_flag_global))));results_part=CDR(results_part))
      hyper_contradiction_pred_(CAR(results_part));
    GLOBAL(unit_clash_flag_global)=BOOL_F;
    return GLOBAL(foundflag_global);
  }
  else
    return BOOL_F;
}

SCM start_binary_hypercheck_strategy()
{
  SCM part__1,part;

  for(part=GLOBAL(usable_clauses_list_global);!(NULL_P(part)||(NFALSEP(GLOBAL(foundflag_global))||NFALSEP(GLOBAL(stop_fast_loop_flag_global))));part=CDR(part))
    if(PAIR_P(CAR(part))&&!(NFALSEP(unit_cl_pred_(CAR(part)))))
      full_hyper_contradiction_pred_(CAR(part));
  for(part__1=GLOBAL(sos_clauses_list_global);!(NULL_P(part__1)||(NFALSEP(GLOBAL(foundflag_global))||NFALSEP(GLOBAL(stop_fast_loop_flag_global))));part__1=CDR(part__1))
    if(PAIR_P(CAR(part__1))&&!(NFALSEP(unit_cl_pred_(CAR(part__1)))))
      full_hyper_contradiction_pred_(CAR(part__1));
  GLOBAL(hyper_contradiction_strategy_global)=BOOL_T;
  return UNSPECIFIED;
}

SCM start_backward_hyper_analysis()
{
  SCM part__1,new_var2,part,newsos,newusable,cl;

  newsos=EOL;
  newusable=EOL;
  cl=EOL;
  init_binres_strat();
  GLOBAL(hyper_contradiction_strategy_global)=BOOL_T;
  GLOBAL(unit_strategy_flag_global)=BOOL_F;
  GLOBAL(factors_stratflag_global)=BOOL_T;
  GLOBAL(ordered_factor_flag_global)=BOOL_F;
  GLOBAL(order_strategy_flag_global)=BOOL_F;
  GLOBAL(poslitpref_order_strategy_flag_global)=BOOL_T;
  GLOBAL(name_order_strategy_flag_global)=BOOL_F;
  GLOBAL(paramodulation_allowed_flag_global)=BOOL_T;
  GLOBAL(remove_identical_lit_stratflag_global)=BOOL_T;
  GLOBAL(sos_preference_cur_ratio_global)=MAKINUM(2);
  GLOBAL(nonunit_discr_tree_global)=cons(EOL,EOL);
  for(part=GLOBAL(usable_clauses_list_global);!(NFALSEP(GLOBAL(foundflag_global))||NULL_P(part));part=CDR(part)) {
    cl=CAR(part);
    if(PAIR_P(cl))
      make_poslit_preferred_excl_(cl);
    new_var2=NOT(SBOOL(PAIR_P(cl)));
    if(NFALSEP(new_var2)) ;
    else
    if(NFALSEP(negative_cl_pred_(CDR(cl)))) {
      hyper_contradiction_pred_(cl);
      newsos=cons(cl,newsos);
    }
    else {
      newusable=cons(cl,newusable);
    }
  }
  GLOBAL(usable_clauses_list_global)=newusable;
  for(part__1=GLOBAL(sos_clauses_list_global);!(NFALSEP(GLOBAL(foundflag_global))||NULL_P(part__1));part__1=CDR(part__1)) {
    cl=CAR(part__1);
    if(PAIR_P(cl))
      make_poslit_preferred_excl_(cl);
    new_var2=NOT(SBOOL(PAIR_P(cl)));
    if(NFALSEP(new_var2)) ;
    else
    if(NFALSEP(negative_cl_pred_(CDR(cl)))) {
      hyper_contradiction_pred_(cl);
      newsos=cons(cl,newsos);
    }
    else {
      GLOBAL(usable_clauses_list_global)=cons(cl,GLOBAL(usable_clauses_list_global));
    }
  }
  GLOBAL(sos_clauses_list_global)=newsos;
  if(!(NFALSEP(GLOBAL(int_logic_flag_global)))) {
    GLOBAL(sos_clauses_list_end_global)=my_last_pair(GLOBAL(sos_clauses_list_global));
  }
  GLOBAL(usable_clauses_list_end_global)=my_last_pair(GLOBAL(usable_clauses_list_global));
  return UNSPECIFIED;
}

SCM make_all_resolvable_excl_(fullcl)
SCM fullcl;
{
  SCM lit_part,tmp,x;

  tmp=MAKINUM(0);
  x=MAKINUM(0);
  for(lit_part=CAR(CDR(CDR(CAR(fullcl))));!(NULL_P(lit_part));lit_part=CDR(lit_part)) {
    x=CAR(lit_part);
    if(ZERO_P(MAKINUM(4)&CAR(x))) {
      tmp=MAKINUM(INUM(litinf_nouse_mask_global)^INUM(litinf_nouse_mask_global|CAR(x)));
      SET_CAR(x,tmp);
    }
  }
  return UNSPECIFIED;
}

SCM make_poslit_preferred_excl_(fullcl)
SCM fullcl;
{
  SCM info_part,lit_part;

  if(!(NFALSEP(mixed_cl_pred_(CDR(fullcl)))))
    return make_all_resolvable_excl_(fullcl);
  else {
    for(info_part=CAR(CDR(CDR(CAR(fullcl)))),lit_part=CDR(fullcl);
        !(NULL_P(info_part));
        info_part=CDR(info_part),lit_part=CDR(lit_part))
      if(ZERO_P(MAKINUM(4)&CAR(CAR(info_part)))) {
        if(!(ZERO_P(MAKINUM(268435456)&CAR(CAR(lit_part))))) {
          SET_CAR(CAR(info_part),litinf_nouse_mask_global|CAR(CAR(info_part)));
        }
        else {
          SET_CAR(CAR(info_part),MAKINUM(INUM(litinf_nouse_mask_global)^INUM(litinf_nouse_mask_global|CAR(CAR(info_part)))));
        }
      }
    return UNSPECIFIED;
  }
}

SCM top_actions_resbase()
{
  make_subr((char *)"shiftleft",tc7_subr_2,shiftleft);
  make_subr((char *)"shiftright",tc7_subr_2,shiftright);
  GLOBAL(max_nr_of_vars_in_clause_global)=MAKINUM(255);
  GLOBAL(maxvar_global)=MAKINUM(65535);
  GLOBAL(max_x_var_global)=MAKINUM(256);
  GLOBAL(max_y_var_global)=MAKINUM(512);
  GLOBAL(minconst_global)=MAKINUM(65536);
  GLOBAL(maxconst_global)=MAKINUM(99999998);
  GLOBAL(unassigned_global)=MAKINUM(99999999);
  GLOBAL(timelimit_global)=BOOL_F;
  GLOBAL(listofnull_global)=const_226;
  GLOBAL(foundflag_global)=BOOL_F;
  GLOBAL(answer_cl_global)=EOL;
  GLOBAL(answer_history_global)=EOL;
  GLOBAL(too_many_vars_flag_global)=BOOL_F;
  occurcheck_flag_global=BOOL_F;
  repeatedvars_flag_global=BOOL_F;
  var_set_flag_global=BOOL_F;
  alt_var_set_flag_global=BOOL_F;
  clause_var_nr_global=MAKINUM(0);
  GLOBAL(new_var_names_global)=EOL;
  xvars_set_flag_global=BOOL_F;
  yvars_set_flag_global=BOOL_F;
  fac_vars_set_global=BOOL_F;
  GLOBAL(cut_clauses_global)=EOL;
  gcl_maxvar_global=MAKINUM(0);
  GLOBAL(gcl_varsstack_global)=EOL;
  GLOBAL(collected_vars_global)=EOL;
  GLOBAL(subsuming_clause_global)=EOL;
  GLOBAL(stopsubsuming_flag_global)=BOOL_F;
  GLOBAL(prohibit_subs_clnr_global)=BOOL_F;
  GLOBAL(subs_factor_derived_flag_global)=BOOL_F;
  GLOBAL(subsumed_clauses_global)=EOL;
  GLOBAL(used_demodulators_global)=EOL;
  GLOBAL(ground_check_res_global)=EOL;
  GLOBAL(compare_ground_litcdr_equal_flag_global)=BOOL_F;
  GLOBAL(one_step_hyper_phase_global)=BOOL_F;
  GLOBAL(noncomputable_ans_funs_global)=EOL;
  GLOBAL(noncomputable_ans_preds_global)=EOL;
  GLOBAL(cur_lit_global)=EOL;
  GLOBAL(cur_clause_global)=BOOL_F;
  GLOBAL(overdouble_discr_flag_global)=BOOL_F;
  GLOBAL(nonunit_discr_flag_global)=BOOL_F;
  GLOBAL(nonunit_res_global)=EOL;
  GLOBAL(param_tolit_global)=EOL;
  GLOBAL(param_eqlit_global)=EOL;
  GLOBAL(param_tocl_global)=EOL;
  GLOBAL(param_fromcl_global)=EOL;
  GLOBAL(param_left_arg_global)=EOL;
  GLOBAL(param_right_arg_global)=EOL;
  param_use_left_flag_global=BOOL_F;
  param_use_right_flag_global=BOOL_F;
  GLOBAL(param_toinf_global)=EOL;
  GLOBAL(param_frominf_global)=EOL;
  GLOBAL(param_from_is_y_flag_global)=BOOL_F;
  GLOBAL(param_yclmaxvar_global)=EOL;
  GLOBAL(param_xclmaxvar_global)=EOL;
  GLOBAL(param_fromhist_global)=EOL;
  GLOBAL(param_tohist_global)=EOL;
  GLOBAL(param_fromlitnr_global)=EOL;
  GLOBAL(param_tolitnr_global)=EOL;
  GLOBAL(var_info_mask_global)=MAKINUM(57344);
  GLOBAL(single_occ_lit_var_mask_global)=MAKINUM(32768);
  GLOBAL(no_occ_otherlit_var_mask_global)=MAKINUM(16384);
  GLOBAL(single_occ_clause_var_mask_global)=MAKINUM(49152);
  GLOBAL(no_occ_folllit_var_mask_global)=MAKINUM(8192);
  GLOBAL(var_nr_mask_global)=MAKINUM(8191);
  GLOBAL(y_var_mask_global)=MAKINUM(256);
  GLOBAL(z_var_mask_global)=MAKINUM(512);
  GLOBAL(var_val_table_global)=make_vector(MAKINUM(1+INUM(MAKINUM(255)|MAKINUM(512))),MAKINUM(99999999));
  GLOBAL(var_touched_table_global)=make_vector(MAKINUM(1+INUM(MAKINUM(255)|MAKINUM(512))),BOOL_F);
  GLOBAL(sgn_mask_global)=MAKINUM(268435456);
  GLOBAL(signedfnsymb_mask_global)=MAKINUM(534773760);
  GLOBAL(fnsymb_mask_global)=MAKINUM(534773760);
  GLOBAL(fnsymb_shift_global)=MAKINUM(21);
  GLOBAL(predsymb_mask_global)=MAKINUM(266338304);
  GLOBAL(maxvar_mask_global)=MAKINUM(1835008);
  GLOBAL(fun_except_varinf_mask_global)=MAKINUM(534904831);
  GLOBAL(repeated_vars_mask_global)=MAKINUM(131072);
  GLOBAL(ground_mask_global)=MAKINUM(65536);
  GLOBAL(strength_mask_global)=MAKINUM(131071);
  GLOBAL(term_depth_strength_mask_global)=MAKINUM(65535);
  GLOBAL(term_depth_mask_global)=MAKINUM(63488);
  GLOBAL(term_depth_max_global)=MAKINUM(31);
  GLOBAL(term_depth_max_shift_global)=MAKINUM(63488);
  GLOBAL(term_depth_shift_global)=MAKINUM(11);
  GLOBAL(term_depth_1_shift_global)=MAKINUM(2048);
  GLOBAL(term_size_strength_mask_global)=MAKINUM(2047);
  GLOBAL(term_size_mask_global)=MAKINUM(2016);
  GLOBAL(term_size_shift_global)=MAKINUM(5);
  GLOBAL(term_size_max_global)=MAKINUM(63);
  GLOBAL(term_size_max_shift_global)=MAKINUM(2016);
  GLOBAL(term_size_1_shift_global)=MAKINUM(32);
  GLOBAL(const_number_mask_global)=MAKINUM(31);
  GLOBAL(const_number_max_global)=MAKINUM(31);
  GLOBAL(g_and_const_mask_global)=(MAKINUM(65536)|MAKINUM(31));
  GLOBAL(var_strength_global)=MAKINUM(32);
  GLOBAL(const_strength_global)=(MAKINUM(65536)|(MAKINUM(32)|MAKINUM(1)));
  GLOBAL(cl_strength_mask_global)=MAKINUM(8388607);
  GLOBAL(cl_maxvar_global)=MAKINUM(63);
  GLOBAL(cl_ground_flag_global)=MAKINUM(65536);
  GLOBAL(cl_maxvar_shift_global)=MAKINUM(23);
  GLOBAL(cl_maxvar_mask_global)=MAKINUM(528482304);
  GLOBAL(cl_maxlen_global)=MAKINUM(63);
  GLOBAL(cl_len_shift_global)=MAKINUM(17);
  GLOBAL(cl_len_mask_global)=MAKINUM(8257536);
  GLOBAL(predsymb_bit_vector_global)=make_vector(MAKINUM(255),MAKINUM(0));
  GLOBAL(cl_rep_predsymbs_mask_global)=MAKINUM(134217728);
  GLOBAL(cl_pred_overflow_mask_global)=MAKINUM(67108864);
  GLOBAL(cl_predsymbs_area_mask_global)=MAKINUM(67108863);
  GLOBAL(cl_predsymbs_neg_shift_global)=MAKINUM(13);
  GLOBAL(cl_predsymbs_neg_mask_global)=MAKINUM(67100672);
  GLOBAL(cl_predsymbs_pos_max_global)=MAKINUM(4096);
  GLOBAL(cl_predsymbs_pos_mask_global)=MAKINUM(8191);
  GLOBAL(kept_cl_nr_global)=MAKINUM(0);
  GLOBAL(last_usable_cl_nr_global)=MAKINUM(0);
  make_subr((char *)"clinfo-history-sublist",tc7_subr_1,clinfo_history_sublist);
  make_subr((char *)"clinfo-clnumber-sublist",tc7_subr_1,clinfo_clnumber_sublist);
  GLOBAL(litinf_noresolve_mask_global)=MAKINUM(1);
  GLOBAL(litinf_nofactor_mask_global)=MAKINUM(2);
  GLOBAL(litinf_isanswer_mask_global)=MAKINUM(4);
  GLOBAL(litinf_noparainto_mask_global)=MAKINUM(8);
  GLOBAL(litinf_noparafromleft_mask_global)=MAKINUM(16);
  GLOBAL(litinf_noparafromright_mask_global)=MAKINUM(32);
  GLOBAL(litinf_rulelit_mask_global)=MAKINUM(64);
  GLOBAL(litinf_leftorrulelit_mask_global)=MAKINUM(128);
  GLOBAL(litinf_rightimplrulelit_mask_global)=MAKINUM(256);
  GLOBAL(litinf_reductionrulelit_mask_global)=MAKINUM(512);
  litinf_nouse_mask_global=(MAKINUM(1)|(MAKINUM(2)|(MAKINUM(8)|(MAKINUM(16)|MAKINUM(32)))));
  litinf_nobinrespara_mask_global=(MAKINUM(1)|(MAKINUM(8)|(MAKINUM(16)|MAKINUM(32))));
  GLOBAL(litinf_ordernr_mask_global)=MAKINUM(INUM(string2number(const_227,MAKINUM(2)))<<16);
  make_subr((char *)"get-litinfo-ordernr",tc7_subr_1,get_litinfo_ordernr);
  make_subr((char *)"put-litinfo-ordernr",tc7_subr_2,put_litinfo_ordernr);
  GLOBAL(litinf_classnr_mask_global)=MAKINUM(INUM(string2number(const_228,MAKINUM(2)))<<24);
  make_subr((char *)"get-litinfo-classnr",tc7_subr_1,get_litinfo_classnr);
  make_subr((char *)"put-litinfo-classnr",tc7_subr_2,put_litinfo_classnr);
  GLOBAL(sos_clauses_list_global)=EOL;
  GLOBAL(sos_clauses_list_end_global)=EOL;
  GLOBAL(ans_input_sos_global)=EOL;
  GLOBAL(usable_clauses_list_global)=EOL;
  GLOBAL(usable_clauses_list_end_global)=EOL;
  GLOBAL(subsumption_list_global)=const_229;
  GLOBAL(unit_alist_global)=EOL;
  GLOBAL(unit_alist_list_global)=EOL;
  GLOBAL(sos_clauses_list_list_global)=EOL;
  GLOBAL(usable_clauses_list_list_global)=EOL;
  GLOBAL(discr_tree_global)=const_230;
  GLOBAL(nonunit_discr_tree_global)=const_231;
  GLOBAL(discr_tree_list_global)=EOL;
  GLOBAL(discr_tree_demod_terms_global)=const_232;
  GLOBAL(discr_tree_demod_atoms_global)=const_233;
  make_subr((char *)"composite?",tc7_subr_1,composite_pred_);
  make_subr((char *)"non-composite?",tc7_subr_1,non_composite_pred_);
  make_subr((char *)"var?",tc7_subr_1,var_pred_);
  make_subr((char *)"non-composite:-var?",tc7_subr_1,non_composite_colon__var_pred_);
  make_subr((char *)"const?",tc7_subr_1,const_pred_);
  make_subr((char *)"single-occ-lit-var?",tc7_subr_1,single_occ_lit_var_pred_);
  make_subr((char *)"repeated-occ-lit-var?",tc7_subr_1,repeated_occ_lit_var_pred_);
  make_subr((char *)"later-occurrences-var?",tc7_subr_1,later_occurrences_var_pred_);
  make_subr((char *)"term-may-cont-vars?",tc7_subr_1,term_may_cont_vars_pred_);
  make_subr((char *)"fun-may-cont-vars?",tc7_subr_1,fun_may_cont_vars_pred_);
  make_subr((char *)"fun-may-cont-repeatedvars?",tc7_subr_1,fun_may_cont_repeatedvars_pred_);
  make_subr((char *)"pure-fun",tc7_subr_1,pure_fun);
  make_subr((char *)"pure-unsigned-fun",tc7_subr_1,pure_unsigned_fun);
  make_subr((char *)"fun-depth-strength",tc7_subr_1,fun_depth_strength);
  make_subr((char *)"fun-depth",tc7_subr_1,fun_depth);
  make_subr((char *)"fun-real-depth",tc7_subr_1,fun_real_depth);
  make_subr((char *)"neg-fun?",tc7_subr_1,neg_fun_pred_);
  make_subr((char *)"pos-fun?",tc7_subr_1,pos_fun_pred_);
  make_subr((char *)"complementary-fun?",tc7_subr_1,complementary_fun_pred_);
  make_subr((char *)"fun-can-subsume?",tc7_subr_2,fun_can_subsume_pred_);
  make_subr((char *)"ground-lit-equal?",tc7_subr_2,ground_lit_equal_pred_);
  make_subr((char *)"term-equal?",tc7_subr_2,term_equal_pred_);
  make_subr((char *)"composite-equal?",tc7_subr_2,composite_equal_pred_);
  make_subr((char *)"term-equal-strong?",tc7_subr_2,term_equal_strong_pred_);
  make_subr((char *)"composite-equal-strong?",tc7_subr_2,composite_equal_strong_pred_);
  make_subr((char *)"term-list-equal?",tc7_subr_2,term_list_equal_pred_);
  make_subr((char *)"swapped-term-list-equal?",tc7_subr_2,swapped_term_list_equal_pred_);
  make_subr((char *)"term-list-equal-strong?",tc7_subr_2,term_list_equal_strong_pred_);
  make_subr((char *)"swapped-term-list-equal-strong?",tc7_subr_2,swapped_term_list_equal_strong_pred_);
  make_subr((char *)"clause-can-subsume?",tc7_subr_3,clause_can_subsume_pred_);
  make_subr((char *)"pure-clause-may-cont-vars?",tc7_subr_1,pure_clause_may_cont_vars_pred_);
  make_subr((char *)"var-nr",tc7_subr_1,var_nr);
  make_subr((char *)"y-var?",tc7_subr_1,y_var_pred_);
  make_subr((char *)"x-var?",tc7_subr_1,x_var_pred_);
  make_subr((char *)"unassigned-val?",tc7_subr_1,unassigned_val_pred_);
  make_subr((char *)"touched-var?",tc7_subr_1,touched_var_pred_);
  make_subr((char *)"set-var-touched!",tc7_subr_2,set_var_touched_excl_);
  make_subr((char *)"var-ref",tc7_subr_1,var_ref);
  make_subr((char *)"set-var-ref!",tc7_subr_2,set_var_ref_excl_);
  make_subr((char *)"var-val",tc7_subr_1,var_val);
  make_subr((char *)"dereference-var",tc7_subr_1,dereference_var);
  make_subr((char *)"dereference-copy-term",tc7_subr_1,dereference_copy_term);
  make_subr((char *)"dereference-copy-aux",tc7_subr_1,dereference_copy_aux);
  make_subr((char *)"clear-x-vars!",tc7_subr_1,clear_x_vars_excl_);
  make_subr((char *)"clear-x-vars-and-touched!",tc7_subr_1,clear_x_vars_and_touched_excl_);
  make_subr((char *)"clear-y-vars!",tc7_subr_1,clear_y_vars_excl_);
  make_subr((char *)"clear-y-vars-and-touched!",tc7_subr_1,clear_y_vars_and_touched_excl_);
  make_subr((char *)"clear-z-vars!",tc7_subr_1,clear_z_vars_excl_);
  make_subr((char *)"clear-z-vars-and-touched!",tc7_subr_1,clear_z_vars_and_touched_excl_);
  make_subr((char *)"set-x-vars-selfref-touched!",tc7_subr_1,set_x_vars_selfref_touched_excl_);
  make_subr((char *)"clear-gcl-vars",tc7_subr_0,clear_gcl_vars);
  make_subr((char *)"restore-gcl-vars",tc7_subr_0,restore_gcl_vars);
  make_subr((char *)"save-gcl-vars",tc7_subr_0,save_gcl_vars);
  make_subr((char *)"pop-gcl-vars-stack",tc7_subr_0,pop_gcl_vars_stack);
  make_subr((char *)"copy-nonground-term",tc7_subr_1,copy_nonground_term);
  make_subr((char *)"rename-x-to-y-term",tc7_subr_1,rename_x_to_y_term);
  make_subr((char *)"rename-y-to-x-term",tc7_subr_1,rename_y_to_x_term);
  make_subr((char *)"rename-x-to-z-term",tc7_subr_1,rename_x_to_z_term);
  make_subr((char *)"rename-x-to-y-term!",tc7_subr_1,rename_x_to_y_term_excl_);
  make_subr((char *)"rename-y-to-x-term!",tc7_subr_1,rename_y_to_x_term_excl_);
  make_subr((char *)"subst-deco-term",tc7_subr_2,subst_deco_term);
  make_subr((char *)"deco-leading-fun",tc7_subr_1,deco_leading_fun);
  make_subr((char *)"subst-deco-term-nodemodulate",tc7_subr_2,subst_deco_term_nodemodulate);
  make_subr((char *)"subst-deco-case-term",tc7_subr_1,subst_deco_case_term);
  make_subr((char *)"clear-varlist",tc7_subr_1,clear_varlist);
  make_subr((char *)"subst-deco-term-nodemodulate-spec",tc7_subr_1,subst_deco_term_nodemodulate_spec);
  make_subr((char *)"subst-deco-replace-term",tc7_lsubr,subst_deco_replace_term_wrapper);
  make_subr((char *)"subst-deco-replace-term-nodemodulate",tc7_lsubr,subst_deco_replace_term_nodemodulate_wrapper);
  make_subr((char *)"replace-subterm",tc7_subr_3,replace_subterm);
  make_subr((char *)"subterm-at-path",tc7_subr_2,subterm_at_path);
  make_subr((char *)"subst-deco-weight-term",tc7_subr_3,subst_deco_weight_term);
  make_subr((char *)"compute-term-weight",tc7_subr_3,compute_term_weight);
  make_subr((char *)"sum-fun-strengths",tc7_subr_2,sum_fun_strengths);
  make_subr((char *)"create-new-fun-pos-object",tc7_subr_2,create_new_fun_pos_object);
  make_subr((char *)"collect-vars-composite!",tc7_subr_1,collect_vars_composite_excl_);
  GLOBAL(intersection_tmp_global)=EOL;
  make_subr((char *)"intersection-union",tc7_lsubr,intersection_union_wrapper);
  make_subr((char *)"intersection-union-aux",tc7_subr_2,intersection_union_aux);
  make_subr((char *)"decorate-vars-lit!",tc7_lsubr,decorate_vars_lit_excl__wrapper);
  make_subr((char *)"decorate-vars-composite!",tc7_subr_2,decorate_vars_composite_excl_);
  make_subr((char *)"resolve-unify-ordinary",tc7_lsubr,resolve_unify_ordinary_wrapper);
  make_subr((char *)"resolve-unify-cutoff",tc7_lsubr,resolve_unify_cutoff_wrapper);
  make_subr((char *)"factor-unify-ordinary",tc7_subr_2,factor_unify_ordinary);
  make_subr((char *)"resolve-unify-ordinary-aux",tc7_subr_2,resolve_unify_ordinary_aux);
  make_subr((char *)"resolve-unify-cutoff-aux",tc7_subr_2,resolve_unify_cutoff_aux);
  make_subr((char *)"factor-unify-ordinary-aux",tc7_subr_2,factor_unify_ordinary_aux);
  make_subr((char *)"occur-check?",tc7_subr_2,occur_check_pred_);
  make_subr((char *)"factor-occur-check?",tc7_subr_2,factor_occur_check_pred_);
  make_subr((char *)"havealready-clause?",tc7_subr_2,havealready_clause_pred_);
  make_subr((char *)"subsumed-clause?",tc7_subr_2,subsumed_clause_pred_);
  make_subr((char *)"subsumed-literal?",tc7_subr_3,subsumed_literal_pred_);
  make_subr((char *)"subsumed-clause-aux?",tc7_lsubr,subsumed_clause_aux_pred__wrapper);
  make_subr((char *)"back-subsume",tc7_subr_2,back_subsume);
  make_subr((char *)"bigger-strength?",tc7_subr_2,bigger_strength_pred_);
  make_subr((char *)"bigger-strength-aux?",tc7_subr_2,bigger_strength_aux_pred_);
  make_subr((char *)"bigger-strength-aux-aux?",tc7_subr_2,bigger_strength_aux_aux_pred_);
  make_subr((char *)"funlist-can-subsume?",tc7_lsubr,funlist_can_subsume_pred__wrapper);
  make_subr((char *)"funlist-can-subsume-aux?",tc7_subr_2,funlist_can_subsume_aux_pred_);
  make_subr((char *)">-fun-ordering?",tc7_subr_2,_grtr__fun_ordering_pred_);
  make_subr((char *)">-fun-ordering-aux?",tc7_subr_2,_grtr__fun_ordering_aux_pred_);
  make_subr((char *)"subsumed-pure-clause-ans?",tc7_subr_2,subsumed_pure_clause_ans_pred_);
  make_subr((char *)"subsumed-pure-clause-aux?",tc7_lsubr,subsumed_pure_clause_aux_pred__wrapper);
  make_subr((char *)"same-or-nonground-fun?",tc7_subr_2,same_or_nonground_fun_pred_);
  make_subr((char *)"subsumed-term-ordinary?",tc7_subr_2,subsumed_term_ordinary_pred_);
  make_subr((char *)"subsumed-term-ordinary-collectvars?",tc7_subr_2,subsumed_term_ordinary_collectvars_pred_);
  make_subr((char *)"subsumed-term-ordinary-collectvars-aux?",tc7_subr_2,subsumed_term_ordinary_collectvars_aux_pred_);
  make_subr((char *)"subsumed-term-list-ordinary?",tc7_subr_2,subsumed_term_list_ordinary_pred_);
  make_subr((char *)"swapped-subsumed-term-list-ordinary?",tc7_subr_2,swapped_subsumed_term_list_ordinary_pred_);
  make_subr((char *)"not-zero?",tc7_subr_1,not_zero_pred_);
  make_subr((char *)"mymax",tc7_subr_2,mymax);
  make_subr((char *)"maxplus",tc7_subr_3,maxplus);
  make_subr((char *)"rassq",tc7_subr_2,rassq);
  make_subr((char *)"adjoin",tc7_subr_2,adjoin);
  make_subr((char *)"union",tc7_subr_2,union_nonkeyword);
  make_subr((char *)"list-union",tc7_subr_1,list_union);
  make_subr((char *)"member-memq?",tc7_subr_2,member_memq_pred_);
  make_subr((char *)"assoc-memq",tc7_subr_2,assoc_memq);
  make_subr((char *)"nth-cdr",tc7_subr_2,nth_cdr);
  make_subr((char *)"pos-in-list",tc7_subr_2,pos_in_list);
  make_subr((char *)"pos-in-list-aux",tc7_subr_3,pos_in_list_aux);
  make_subr((char *)"split-list",tc7_subr_2,split_list);
  make_subr((char *)"split-if",tc7_subr_2,split_if_exporthof);
  make_subr((char *)"my-last-pair",tc7_subr_1,my_last_pair);
  make_subr((char *)"my-last-pair-aux",tc7_subr_1,my_last_pair_aux);
  make_subr((char *)"my-append!",tc7_subr_2,my_append_excl_);
  make_subr((char *)"but-last",tc7_subr_1,but_last);
  make_subr((char *)"map!",tc7_subr_2,map_excl__exporthof);
  make_subr((char *)"some?",tc7_subr_2,some_pred__exporthof);
  make_subr((char *)"every?",tc7_subr_2,every_pred__exporthof);
  make_subr((char *)"member-if",tc7_subr_2,member_if_exporthof);
  make_subr((char *)"remove-if",tc7_subr_2,remove_if_exporthof);
  make_subr((char *)"filter-map",tc7_subr_2,filter_map_exporthof);
  make_subr((char *)"copy-list",tc7_subr_1,copy_list);
  make_subr((char *)"sum-list",tc7_subr_1,sum_list);
  make_subr((char *)"remove-one-equal",tc7_subr_2,remove_one_equal);
  make_subr((char *)"remove-eq",tc7_subr_2,remove_eq);
  make_subr((char *)"remove-at-place",tc7_subr_2,remove_at_place);
  make_subr((char *)"replace-one-eq",tc7_subr_3,replace_one_eq);
  make_subr((char *)"replace-nth",tc7_subr_3,replace_nth);
  make_subr((char *)"remove-at-place!",tc7_subr_2,remove_at_place_excl_);
  GLOBAL(make_inside_subset_tmp_global)=EOL;
  GLOBAL(make_inside_subset_tmp_lst_global)=EOL;
  make_subr((char *)"make-inside-subset",tc7_subr_2,make_inside_subset);
  make_subr((char *)"make-inside-subset-aux!",tc7_subr_1,make_inside_subset_aux_excl_);
  GLOBAL(sos_preference_ratio_global)=MAKINUM(5);
  GLOBAL(sos_preference_cur_ratio_global)=MAKINUM(0);
  GLOBAL(given_clause_nr_global)=MAKINUM(0);
  make_subr((char *)"display-kept-nr",tc7_subr_0,display_kept_nr);
  GLOBAL(new_demodulators_list_global)=EOL;
  GLOBAL(slow_start_time_global)=MAKINUM(0);
  GLOBAL(slow_passed_time_global)=MAKINUM(0);
  make_subr((char *)"given-clause-slow-loop",tc7_subr_0,given_clause_slow_loop);
  GLOBAL(last_best_weight_global)=MAKINUM(0);
  make_subr((char *)"select-given-cl-place",tc7_subr_1,select_given_cl_place);
  make_subr((char *)"given-cl-havealready?",tc7_subr_1,given_cl_havealready_pred_);
  GLOBAL(stop_fast_loop_flag_global)=BOOL_F;
  make_subr((char *)"usable-clauses-fast-loop",tc7_subr_2,usable_clauses_fast_loop);
  make_subr((char *)"two-clause-binres-loop",tc7_lsubr,two_clause_binres_loop_wrapper);
  make_subr((char *)"final-nuc-res",tc7_lsubr,final_nuc_res_wrapper);
  make_subr((char *)"unit-and-final-nuc-res",tc7_lsubr,unit_and_final_nuc_res_wrapper);
  make_subr((char *)"two-posunits-typet-para",tc7_lsubr,two_posunits_typet_para_wrapper);
  make_subr((char *)"one-step-for-hyper",tc7_subr_1,one_step_for_hyper);
  make_subr((char *)"make-hyper-history",tc7_lsubr,make_hyper_history_wrapper);
  make_subr((char *)"make-hyper-history-aux",tc7_lsubr,make_hyper_history_aux_wrapper);
  make_subr((char *)"make-binres-history",tc7_lsubr,make_binres_history_wrapper);
  make_subr((char *)"fresh-nucleus-hist?",tc7_subr_1,fresh_nucleus_hist_pred_);
  make_subr((char *)"make-null-neg-list",tc7_subr_1,make_null_neg_list);
  make_subr((char *)"paramodulate-into-ycl",tc7_lsubr,paramodulate_into_ycl_wrapper);
  make_subr((char *)"paramodulate-into-term",tc7_subr_3,paramodulate_into_term);
  make_subr((char *)"paramodulate-into-term-aux",tc7_subr_3,paramodulate_into_term_aux);
  make_subr((char *)"give-cl-maxvar",tc7_subr_1,give_cl_maxvar);
  make_subr((char *)"handle-derived-inf-cl-pair",tc7_lsubr,handle_derived_inf_cl_pair_wrapper);
  make_subr((char *)"too-many-kept?",tc7_subr_2,too_many_kept_pred_);
  make_subr((char *)"handle-derived-inf-cl-pair-aux",tc7_subr_2,handle_derived_inf_cl_pair_aux);
  make_subr((char *)"attempt-to-make-a-demodulator",tc7_subr_1,attempt_to_make_a_demodulator);
  make_subr((char *)"make-kept-clause",tc7_subr_2,make_kept_clause);
  make_subr((char *)"make-kept-litinflist",tc7_subr_2,make_kept_litinflist);
  make_subr((char *)"litinf-binrespara?",tc7_subr_1,litinf_binrespara_pred_);
  make_subr((char *)"litinf-use?",tc7_subr_1,litinf_use_pred_);
  make_subr((char *)"litinf-left-para?",tc7_subr_1,litinf_left_para_pred_);
  make_subr((char *)"litinf-right-para?",tc7_subr_1,litinf_right_para_pred_);
  make_subr((char *)"litinf-parainto?",tc7_subr_1,litinf_parainto_pred_);
  make_subr((char *)"modify-to-demod-inf!",tc7_subr_1,modify_to_demod_inf_excl_);
  make_subr((char *)"make-clause-info",tc7_subr_2,make_clause_info);
  make_subr((char *)"intern-fullclause",tc7_subr_1,intern_fullclause);
  make_subr((char *)"back-demodulate-usable",tc7_subr_0,back_demodulate_usable);
  make_subr((char *)"demodulate-clause",tc7_subr_1,demodulate_clause);
  make_subr((char *)"demodulate-composite",tc7_subr_1,demodulate_composite);
  make_subr((char *)"demodulate-lit",tc7_subr_1,demodulate_lit);
  make_subr((char *)"demodulate-constant",tc7_subr_1,demodulate_constant);
  make_subr((char *)"demodulate-fully",tc7_subr_3,demodulate_fully);
  make_subr((char *)"may-be-demodulated?",tc7_subr_1,may_be_demodulated_pred_);
  make_subr((char *)"eq-lit-arg1",tc7_subr_1,eq_lit_arg1);
  make_subr((char *)"eq-lit-arg2",tc7_subr_1,eq_lit_arg2);
  make_subr((char *)"eq-lit-type",tc7_subr_1,eq_lit_type);
  make_subr((char *)"demodulate-fully-lit",tc7_subr_1,demodulate_fully_lit);
  GLOBAL(locfactorpool_global)=EOL;
  GLOBAL(factorpool_global)=EOL;
  make_subr((char *)"factor-sos",tc7_subr_1,factor_sos);
  GLOBAL(factor_clproc0)=make_subr((char *)"factor_clproc0",tc7_subr_2,factor);
  make_subr((char *)"factor-aux",tc7_subr_2,factor_aux);
  make_subr((char *)"merge-infos",tc7_subr_3,merge_infos);
  make_subr((char *)"make-unique-answer-pair",tc7_subr_3,make_unique_answer_pair);
  make_subr((char *)"several-answer-literals?",tc7_subr_1,several_answer_literals_pred_);
  make_subr((char *)"ans-computable-lit?",tc7_subr_1,ans_computable_lit_pred_);
  make_subr((char *)"ans-computable-term?",tc7_subr_2,ans_computable_term_pred_);
  make_subr((char *)"sort-clause",tc7_subr_2,sort_clause);
  make_subr((char *)"sort-clause-aux",tc7_subr_3,sort_clause_aux);
  make_subr((char *)"sort-merge-clauses",tc7_subr_3,sort_merge_clauses);
  make_subr((char *)"lit-weight",tc7_subr_1,lit_weight);
  make_subr((char *)"answer-pred?",tc7_subr_1,answer_pred_pred_);
  make_subr((char *)"countable-pred?",tc7_subr_1,countable_pred_pred_);
  make_subr((char *)"answer-lit?",tc7_subr_1,answer_lit_pred_);
  make_subr((char *)"composite-weight",tc7_subr_1,composite_weight);
  make_subr((char *)"predsymb-bit",tc7_subr_1,predsymb_bit);
  make_subr((char *)"make-raw-inf-cl-pair",tc7_lsubr,make_raw_inf_cl_pair_wrapper);
  make_subr((char *)"make-rest-inf-cl",tc7_subr_3,make_rest_inf_cl);
  make_subr((char *)"subst-deco-cl",tc7_lsubr,subst_deco_cl_wrapper);
  make_subr((char *)"tautology-pure-cl?",tc7_subr_1,tautology_pure_cl_pred_);
  make_subr((char *)"remove-double-lits!",tc7_subr_3,remove_double_lits_excl_);
  make_subr((char *)"unit-handle-cl!",tc7_subr_3,unit_handle_cl_excl_);
  make_subr((char *)"full-unit-cutoff!",tc7_subr_2,full_unit_cutoff_excl_);
  make_subr((char *)"full-unit-cutoff-aux!",tc7_lsubr,full_unit_cutoff_aux_excl__wrapper);
  make_subr((char *)"full-unit-cutoff-double!",tc7_lsubr,full_unit_cutoff_double_excl__wrapper);
  make_subr((char *)"has-some-local-only-vars?",tc7_subr_1,has_some_local_only_vars_pred_);
  make_subr((char *)"has-only-local-only-vars?",tc7_subr_1,has_only_local_only_vars_pred_);
  make_subr((char *)"member-polarity-lit",tc7_subr_3,member_polarity_lit);
  make_subr((char *)"swapped-term-list-strong-equal?",tc7_subr_2,swapped_term_list_strong_equal_pred_);
  make_subr((char *)"insert-to-subsumption-list!",tc7_subr_3,insert_to_subsumption_list_excl_);
  make_subr((char *)"insert-unit-alist",tc7_subr_1,insert_unit_alist);
  make_subr((char *)"insert-partial-discr-tree!",tc7_lsubr,insert_partial_discr_tree_excl__wrapper);
  make_subr((char *)"check-discr-tree",tc7_subr_2,check_discr_tree);
  make_subr((char *)"insert-clause-discr-tree!",tc7_lsubr,insert_clause_discr_tree_excl__wrapper);
  make_subr((char *)"insert-discr-tree!",tc7_lsubr,insert_discr_tree_excl__wrapper);
  make_subr((char *)"insert-discr-tree-leaf!",tc7_subr_1,insert_discr_tree_leaf_excl_);
  make_subr((char *)"check-discr-tree-part",tc7_subr_3,check_discr_tree_part);
  make_subr((char *)"check-discr-tree-leaf",tc7_subr_1,check_discr_tree_leaf);
  make_subr((char *)"insert-discr-tree-nonunit!",tc7_subr_2,insert_discr_tree_nonunit_excl_);
  make_subr((char *)"insert-nonunit-discr-tree-leaf!",tc7_subr_1,insert_nonunit_discr_tree_leaf_excl_);
  make_subr((char *)"check-nonunit-discr-tree",tc7_subr_2,check_nonunit_discr_tree);
  make_subr((char *)"order-prohibit-litinfos",tc7_subr_2,order_prohibit_litinfos);
  make_subr((char *)"vdepth-order-litinfo",tc7_subr_2,vdepth_order_litinfo);
  make_subr((char *)"order-equality-litinfo",tc7_subr_2,order_equality_litinfo);
  make_subr((char *)"order-equality-litinfo-depth",tc7_subr_2,order_equality_litinfo_depth);
  make_subr((char *)"order-equality-litinfo-lex",tc7_subr_2,order_equality_litinfo_lex);
  GLOBAL(lex_symbol_orderlst_global)=EOL;
  make_subr((char *)"lex-bigger?",tc7_subr_2,lex_bigger_pred_);
  make_subr((char *)"lex-occur-check?",tc7_subr_2,lex_occur_check_pred_);
  make_subr((char *)"lex-bigger-than-subterms?",tc7_subr_2,lex_bigger_than_subterms_pred_);
  make_subr((char *)"lex-subterm-bigger-than",tc7_subr_2,lex_subterm_bigger_than);
  make_subr((char *)"lex-symbol-bigger?",tc7_subr_2,lex_symbol_bigger_pred_);
  make_subr((char *)"make-lex-symbol-bigger!",tc7_subr_2,make_lex_symbol_bigger_excl_);
  make_subr((char *)"prohibit-right-para",tc7_subr_1,prohibit_right_para);
  make_subr((char *)"prohibit-left-para",tc7_subr_1,prohibit_left_para);
  make_subr((char *)"vdepth-order-litinfo-aux",tc7_subr_2,vdepth_order_litinfo_aux);
  make_subr((char *)"name-order-litinfo",tc7_subr_2,name_order_litinfo);
  make_subr((char *)"poslit-order-litinfo",tc7_subr_2,poslit_order_litinfo);
  make_subr((char *)"firstlitpref-order-litinfo",tc7_subr_2,firstlitpref_order_litinfo);
  make_subr((char *)"posweight-order-litinfo",tc7_subr_2,posweight_order_litinfo);
  make_subr((char *)"vdepth-order-litinfo-eq-only",tc7_subr_2,vdepth_order_litinfo_eq_only);
  make_subr((char *)"vdepth->-varinfolit?",tc7_subr_2,vdepth__grtr__varinfolit_pred_);
  make_subr((char *)"vdepth-superset-varinfolit?",tc7_subr_2,vdepth_superset_varinfolit_pred_);
  GLOBAL(tmp_var_depth_table_global)=EOL;
  make_subr((char *)"make-var-depth-info",tc7_subr_1,make_var_depth_info);
  make_subr((char *)"make-var-depth-info-aux",tc7_subr_2,make_var_depth_info_aux);
  GLOBAL(shown_clausenrs_global)=EOL;
  GLOBAL(otter_prepared_history_global)=EOL;
  make_subr((char *)"show-history",tc7_subr_1,show_history);
  make_subr((char *)"otter-show-history-printparents",tc7_subr_1,otter_show_history_printparents);
  make_subr((char *)"otter-show-history-printparents-aux",tc7_subr_1,otter_show_history_printparents_aux);
  make_subr((char *)"otter-show-history-aux",tc7_subr_2,otter_show_history_aux);
  make_subr((char *)"sort-by-firstel",tc7_subr_1,sort_by_firstel);
  make_subr((char *)"insert-to-firstel-sorted!",tc7_subr_2,insert_to_firstel_sorted_excl_);
  make_subr((char *)"otter-show-history-aux-aux",tc7_subr_3,otter_show_history_aux_aux);
  make_subr((char *)"show-history-aux",tc7_subr_2,show_history_aux);
  make_subr((char *)"show-history-aux-aux",tc7_subr_3,show_history_aux_aux);
  make_subr((char *)"show-history-find-clausepl",tc7_subr_1,show_history_find_clausepl);
  make_subr((char *)"show-history-clnr",tc7_subr_1,show_history_clnr);
  make_subr((char *)"display-spaces",tc7_subr_1,display_spaces);
  make_subr((char *)"history->answer",tc7_subr_1,history__grtr_answer);
  make_subr((char *)"history->answer-step",tc7_subr_1,history__grtr_answer_step);
  make_subr((char *)"input-ans-clause",tc7_subr_1,input_ans_clause);
  make_subr((char *)"history->answer-binstep",tc7_lsubr,history__grtr_answer_binstep_wrapper);
  make_subr((char *)"history->ans-handle-derived-inf-cl-pair",tc7_subr_3,history__grtr_ans_handle_derived_inf_cl_pair);
  make_subr((char *)"make-raw-inf-cl-pair-typet-hyper",tc7_lsubr,make_raw_inf_cl_pair_typet_hyper_wrapper);
  make_subr((char *)"paramodulate-into-term-aux-typet",tc7_subr_3,paramodulate_into_term_aux_typet);
  make_subr((char *)"make-input-clause",tc7_subr_1,make_input_clause);
  make_subr((char *)"remove-duplicates",tc7_subr_1,remove_duplicates);
  make_subr((char *)"make-input-litinfolst",tc7_subr_1,make_input_litinfolst);
  make_subr((char *)"make-input-litinfolist-aux",tc7_subr_1,make_input_litinfolist_aux);
  make_subr((char *)"make-pos-lit-litinfo",tc7_subr_1,make_pos_lit_litinfo);
  make_subr((char *)"make-varinfo-lst!",tc7_subr_2,make_varinfo_lst_excl_);
  make_subr((char *)"make-fulldeco-clause!",tc7_subr_1,make_fulldeco_clause_excl_);
  GLOBAL(ans_pred_nr_global)=MAKINUM(0);
  GLOBAL(eq_pred_nr_global)=MAKINUM(0);
  GLOBAL(eq_fun_nr_global)=MAKINUM(0);
  GLOBAL(case_fun_nr_global)=MAKINUM(0);
  GLOBAL(if_fun_nr_global)=MAKINUM(0);
  GLOBAL(subst_fun_nr_global)=MAKINUM(0);
  GLOBAL(subst_prim_fun_nr_global)=MAKINUM(0);
  GLOBAL(lambda_fun_nr_global)=MAKINUM(0);
  GLOBAL(lambda_dummypar_nr_global)=MAKINUM(0);
  GLOBAL(int_outmost_symb_labelfun_global)=EOL;
  GLOBAL(int_outmost_label_fun_nr_global)=MAKINUM(0);
  make_subr((char *)"pos-eq-pred?",tc7_subr_1,pos_eq_pred_pred_);
  make_subr((char *)"pos-eq-fun?",tc7_subr_1,pos_eq_fun_pred_);
  make_subr((char *)"fill-predsymb-bit-vector!",tc7_subr_0,fill_predsymb_bit_vector_excl_);
  make_subr((char *)"turn-on-demodulation",tc7_subr_0,turn_on_demodulation);
  make_subr((char *)"turn-off-demodulation",tc7_subr_0,turn_off_demodulation);
  make_subr((char *)"init-binres-strat",tc7_subr_0,init_binres_strat);
  make_subr((char *)"init-binary-hyper-sos-strat",tc7_subr_0,init_binary_hyper_sos_strat);
  make_subr((char *)"init-unit-strat",tc7_subr_0,init_unit_strat);
  make_subr((char *)"init-posweight-ordered-unit-strat",tc7_subr_0,init_posweight_ordered_unit_strat);
  make_subr((char *)"init-ordered-binres-strat",tc7_subr_0,init_ordered_binres_strat);
  make_subr((char *)"init-name-ordered-binres-strat",tc7_subr_0,init_name_ordered_binres_strat);
  make_subr((char *)"init-weight-ordered-binres-strat",tc7_subr_0,init_weight_ordered_binres_strat);
  make_subr((char *)"init-posweight-ordered-binres-strat",tc7_subr_0,init_posweight_ordered_binres_strat);
  make_subr((char *)"init-hyper-strat",tc7_subr_0,init_hyper_strat);
  make_subr((char *)"init-hyper-wos-strat",tc7_subr_0,init_hyper_wos_strat);
  make_subr((char *)"init-ordered-hyper-strat",tc7_subr_0,init_ordered_hyper_strat);
  make_subr((char *)"init-typet-strat",tc7_subr_0,init_typet_strat);
  make_subr((char *)"init-synth-strat",tc7_subr_0,init_synth_strat);
  make_subr((char *)"init-binary-unit-depth-backdemod",tc7_subr_0,init_binary_unit_depth_backdemod);
  make_subr((char *)"init-binary-unit-depth",tc7_subr_0,init_binary_unit_depth);
  make_subr((char *)"init-binary-unit-depth-sospref",tc7_subr_0,init_binary_unit_depth_sospref);
  make_subr((char *)"init-binary-unit-lex",tc7_subr_0,init_binary_unit_lex);
  make_subr((char *)"init-binary-unit-lex-backdemod",tc7_subr_0,init_binary_unit_lex_backdemod);
  GLOBAL(split_strategy_flag_global)=BOOL_F;
  GLOBAL(unit_equality_strat_global)=BOOL_F;
  GLOBAL(order_equality_lex_strat_global)=BOOL_F;
  GLOBAL(sos_strategy_flag_global)=BOOL_T;
  GLOBAL(keep_all_old_clauses_flag_global)=BOOL_F;
  GLOBAL(auto_mode_flag_global)=BOOL_F;
  GLOBAL(stop_res_real_time_global)=MAKINUM(0);
  GLOBAL(max_kept_clauses_nr_global)=MAKINUM(20000);
  GLOBAL(display_info_level_global)=MAKINUM(50);
  GLOBAL(display_info_char_flag_global)=BOOL_F;
  GLOBAL(display_debug_info_flag_global)=BOOL_F;
  GLOBAL(remove_all_tautologies_stratflag_global)=BOOL_T;
  GLOBAL(hyper_wos_strategy_flag_global)=BOOL_F;
  GLOBAL(binary_hyper_sos_strategy_global)=BOOL_F;
  GLOBAL(hyper_contradiction_strategy_global)=BOOL_F;
  GLOBAL(unit_clash_flag_global)=BOOL_F;
  GLOBAL(factors_stratflag_global)=BOOL_F;
  GLOBAL(back_subsume_stratflag_global)=BOOL_T;
  GLOBAL(havealready_timecounter_global)=MAKINUM(0);
  GLOBAL(remove_identical_lit_stratflag_global)=BOOL_T;
  GLOBAL(paramodulation_allowed_flag_global)=BOOL_T;
  GLOBAL(paramodulation_strategy_flag_global)=BOOL_T;
  GLOBAL(paramodulate_from_vars_stratflag_global)=BOOL_F;
  GLOBAL(para_pos_unit_strategy_global)=BOOL_F;
  GLOBAL(unit_strategy_flag_global)=BOOL_F;
  GLOBAL(hyper_strategy_flag_global)=BOOL_F;
  GLOBAL(order_strategy_flag_global)=BOOL_F;
  GLOBAL(name_order_strategy_flag_global)=BOOL_F;
  GLOBAL(firstlitpref_order_strategy_flag_global)=BOOL_F;
  GLOBAL(poslitpref_order_strategy_flag_global)=BOOL_F;
  GLOBAL(posweight_order_strategy_flag_global)=BOOL_F;
  GLOBAL(ordered_factor_flag_global)=BOOL_F;
  GLOBAL(neg_hyper_strategy_flag_global)=BOOL_F;
  GLOBAL(type_theory_stratflag_global)=BOOL_F;
  GLOBAL(int_logic_flag_global)=BOOL_F;
  GLOBAL(int_use_binres_flag_global)=BOOL_F;
  GLOBAL(classical_synth_stratflag_global)=BOOL_F;
  GLOBAL(int_use_hyperres_flag_global)=BOOL_F;
  GLOBAL(discr_tree_subsume_stratflag_global)=BOOL_T;
  GLOBAL(discr_depth_first_global)=BOOL_T;
  GLOBAL(ordered_paramodulation_flag_global)=BOOL_T;
  GLOBAL(dynamic_demodulation_flag_global)=BOOL_F;
  GLOBAL(demodulate_lit_flag_global)=BOOL_F;
  GLOBAL(back_demodulate_flag_global)=BOOL_F;
  GLOBAL(demodulate_flag_global)=BOOL_F;
  GLOBAL(demodulate_constants_flag_global)=BOOL_F;
  GLOBAL(new_demodulators_flag_global)=BOOL_F;
  GLOBAL(user_criterias_post_flag_global)=BOOL_F;
  GLOBAL(user_criterias_pre_flag_global)=BOOL_F;
  GLOBAL(clause_usenr_limits_global)=EOL;
  GLOBAL(clause_usedepth_limits_global)=EOL;
  GLOBAL(clause_usestruct_limits_global)=EOL;
  GLOBAL(clause_keepsize_limit_global)=MAKINUM(0);
  GLOBAL(clause_keepdepth_limit_global)=MAKINUM(0);
  GLOBAL(clause_uselength_limit_global)=MAKINUM(0);
  GLOBAL(clause_keeplength_limit_global)=MAKINUM(0);
  GLOBAL(special_insertion_place_global)=EOL;
  make_subr((char *)"init-one-pass-strategical-flags",tc7_subr_0,init_one_pass_strategical_flags);
  GLOBAL(answer_litinf_global)=(MAKINUM(1)|(MAKINUM(8)|MAKINUM(4)));
  make_subr((char *)"empty-cl?",tc7_subr_1,empty_cl_pred_);
  make_subr((char *)"unit-cl?",tc7_subr_1,unit_cl_pred_);
  make_subr((char *)"first-nonans-lit",tc7_subr_1,first_nonans_lit);
  make_subr((char *)"member-nonans-lit",tc7_subr_1,member_nonans_lit);
  make_subr((char *)"member-ans-lit",tc7_subr_1,member_ans_lit);
  make_subr((char *)"remove-ans-literals",tc7_subr_1,remove_ans_literals);
  make_subr((char *)"ground-fullcl?",tc7_subr_1,ground_fullcl_pred_);
  make_subr((char *)"positive-cl?",tc7_subr_1,positive_cl_pred_);
  make_subr((char *)"negative-cl?",tc7_subr_1,negative_cl_pred_);
  make_subr((char *)"mixed-cl?",tc7_subr_1,mixed_cl_pred_);
  make_subr((char *)"has-single-hyper-premiss?",tc7_subr_1,has_single_hyper_premiss_pred_);
  make_subr((char *)"first-hyper-premiss-lit",tc7_subr_1,first_hyper_premiss_lit);
  make_subr((char *)"first-neg-lit",tc7_subr_1,first_neg_lit);
  make_subr((char *)"contains-eqlit-cl?",tc7_subr_1,contains_eqlit_cl_pred_);
  make_subr((char *)"contains-eqorneg-cl?",tc7_subr_1,contains_eqorneg_cl_pred_);
  make_subr((char *)"commutative-fun?",tc7_subr_1,commutative_fun_pred_);
  make_subr((char *)"reflexive-fun?",tc7_subr_1,reflexive_fun_pred_);
  make_subr((char *)"removable-tautology-pr?",tc7_subr_1,removable_tautology_pr_pred_);
  make_subr((char *)"clause-pass-user-limits-post?",tc7_subr_1,clause_pass_user_limits_post_pred_);
  make_subr((char *)"pass-keepdepth-limit?",tc7_subr_1,pass_keepdepth_limit_pred_);
  make_subr((char *)"pass-keepsize-limit?",tc7_subr_1,pass_keepsize_limit_pred_);
  make_subr((char *)"pass-keeplength-limit?",tc7_subr_1,pass_keeplength_limit_pred_);
  make_subr((char *)"clause-pass-user-crit-post?",tc7_subr_3,clause_pass_user_crit_post_pred_);
  make_subr((char *)"hist-pass-usenr-limits?",tc7_subr_1,hist_pass_usenr_limits_pred_);
  make_subr((char *)"hist-count-check",tc7_subr_2,hist_count_check);
  make_subr((char *)"hist-pass-usedepth-limits?",tc7_subr_1,hist_pass_usedepth_limits_pred_);
  make_subr((char *)"hist-pass-usestruct-limits?",tc7_subr_1,hist_pass_usestruct_limits_pred_);
  make_subr((char *)"hist-pass-usestruct-limits-hyper?",tc7_subr_2,hist_pass_usestruct_limits_hyper_pred_);
  make_subr((char *)"get-hyper-hist-el-limitnr",tc7_subr_1,get_hyper_hist_el_limitnr);
  make_subr((char *)"init-globals",tc7_subr_0,init_globals);
  GLOBAL(one_pass_kept_clauses_firstnr_global)=MAKINUM(1);
  make_subr((char *)"init-one-pass-globals",tc7_subr_0,init_one_pass_globals);
  GLOBAL(derived_clauses_nr_global)=MAKINUM(0);
  GLOBAL(kept_clauses_nr_global)=MAKINUM(0);
  GLOBAL(kept_mid_nucleus_nr_global)=MAKINUM(0);
  GLOBAL(kept_new_demodulators_nr_global)=MAKINUM(0);
  GLOBAL(forward_subsumed_unit_nr_global)=MAKINUM(0);
  GLOBAL(forward_subsumed_double_nr_global)=MAKINUM(0);
  GLOBAL(forward_subsumed_overdouble_nr_global)=MAKINUM(0);
  GLOBAL(forward_subsumed_nonunit_nr_global)=MAKINUM(0);
  GLOBAL(back_subsumed_nr_global)=MAKINUM(0);
  GLOBAL(simple_unit_cutoff_nr_global)=MAKINUM(0);
  GLOBAL(full_unit_cutoff_nr_global)=MAKINUM(0);
  GLOBAL(double_unit_cutoff_nr_global)=MAKINUM(0);
  GLOBAL(proof_start_real_time_global)=MAKINUM(0);
  GLOBAL(proof_start_run_time_global)=MAKINUM(0);
  GLOBAL(subs_tried_nr_global)=MAKINUM(0);
  GLOBAL(subs_length_fail_nr_global)=MAKINUM(0);
  GLOBAL(subs_strength_fail_nr_global)=MAKINUM(0);
  GLOBAL(subs_aux_strength_fail_nr_global)=MAKINUM(0);
  GLOBAL(subs_gclpreds_fail_nr_global)=MAKINUM(0);
  GLOBAL(subs_funlist_fail_nr_global)=MAKINUM(0);
  GLOBAL(subs_reg_subs_tried_nr_global)=MAKINUM(0);
  GLOBAL(subs_reg_subs_fail_nr_global)=MAKINUM(0);
  make_subr((char *)"init-stats",tc7_subr_0,init_stats);
  make_subr((char *)"show-stats",tc7_subr_0,show_stats);
  make_subr((char *)"show-main-stats",tc7_subr_0,show_main_stats);
  make_subr((char *)"show-subsumption-stats",tc7_subr_0,show_subsumption_stats);
  make_subr((char *)"display-time-seconds",tc7_subr_1,display_time_seconds);
  make_subr((char *)"fprove",tc7_subr_1,fprove);
  make_subr((char *)"use-input-settings",tc7_subr_1,use_input_settings);
  make_subr((char *)"mtest",tc7_subr_0,mtest);
  make_subr((char *)"sort-out-otter-list-clauses",tc7_subr_1,sort_out_otter_list_clauses);
  make_subr((char *)"prop-conv",tc7_subr_1,prop_conv);
  make_subr((char *)"read-otter-list-clauses",tc7_subr_1,read_otter_list_clauses);
  GLOBAL(otter_or_symbol_global)=string2symbol(const_234);
  make_subr((char *)"parse-otter-clause",tc7_subr_1,parse_otter_clause);
  make_subr((char *)"prepare-read-eqsymb",tc7_subr_2,prepare_read_eqsymb);
  make_subr((char *)"prepare-read-eqlit",tc7_subr_2,prepare_read_eqlit);
  make_subr((char *)"parse-otter-explist",tc7_subr_1,parse_otter_explist);
  GLOBAL(otter_uppercase_prefix_global)=MAKICHR('^');
  GLOBAL(otter_comma_repl_global)=_excl__symb;
  GLOBAL(otter_dot_repl_global)=_dot__dot__dot__symb;
  GLOBAL(otter_tmpfile_global)=const_235;
  GLOBAL(otter_tmpfile_suffix_global)=const_236;
  GLOBAL(otter_tmpfile_prefix_global)=const_237;
  GLOBAL(otter_outputfile_suffix_global)=const_238;
  make_subr((char *)"preprocess-otter-file",tc7_subr_1,preprocess_otter_file);
  make_subr((char *)"read-processed-otter-file",tc7_subr_1,read_processed_otter_file);
  GLOBAL(ans_symbol_global)=ans_symb;
  GLOBAL(eq_symbol_global)=equal_symb;
  GLOBAL(eq_fun_symbol_global)=eq_symb;
  GLOBAL(case_fun_symbol_global)=case_symb;
  GLOBAL(if_fun_symbol_global)=if_symb;
  GLOBAL(inhabited_symbol_global)=inh_symb;
  GLOBAL(subst_fun_symbol_global)=idsubst_symb;
  GLOBAL(subst_prim_fun_symbol_global)=idsubst_prim_symb;
  GLOBAL(id_refl_fun_symbol_global)=idrefl_symb;
  GLOBAL(lambda_fun_symbol_global)=lambda_symb;
  GLOBAL(lambda_dummypar_symbol_global)=_star__symb;
  GLOBAL(typet_speclit_global)=cons(GLOBAL(ans_symbol_global),cons(cons(GLOBAL(lambda_fun_symbol_global),cons(cons(GLOBAL(subst_prim_fun_symbol_global),cons(GLOBAL(lambda_dummypar_symbol_global),EOL)),cons(cons(GLOBAL(subst_fun_symbol_global),cons(GLOBAL(lambda_dummypar_symbol_global),EOL)),EOL))),EOL));
  GLOBAL(classicsynth_speclit_global)=cons(GLOBAL(ans_symbol_global),cons(cons(GLOBAL(if_fun_symbol_global),cons(MAKINUM(1),cons(MAKINUM(2),cons(MAKINUM(3),EOL)))),EOL));
  GLOBAL(demodulator_list_symbol_global)=demodulators_symb;
  GLOBAL(lit_demodulator_list_symbol_global)=lit_demodulators_symb;
  GLOBAL(sos_list_symbol_global)=sos_symb;
  GLOBAL(usable_list_symbol_global)=usable_symb;
  GLOBAL(ans_prohibited_funsymbs_global)=EOL;
  GLOBAL(ans_prohibited_constsymbs_global)=EOL;
  GLOBAL(ans_prohibited_predsymbs_global)=EOL;
  GLOBAL(ans_prohibited_funnrs_global)=EOL;
  GLOBAL(ans_prohibited_constnrs_global)=EOL;
  GLOBAL(ans_prohibited_prednrs_global)=EOL;
  GLOBAL(prolog_style_variables_global)=BOOL_F;
  GLOBAL(const_num_table_global)=EOL;
  GLOBAL(const_num_global)=MAKINUM(0);
  GLOBAL(min_const_num_sub1_global)=MAKINUM(100000);
  GLOBAL(fun_num_table_global)=EOL;
  GLOBAL(fun_num_global)=MAKINUM(0);
  GLOBAL(min_fun_num_sub1_global)=MAKINUM(0);
  GLOBAL(max_nr_of_funs_global)=MAKINUM(255);
  GLOBAL(pred_num_table_global)=EOL;
  GLOBAL(pred_num_global)=MAKINUM(0);
  GLOBAL(min_pred_num_sub1_global)=MAKINUM(0);
  GLOBAL(max_nr_of_preds_global)=MAKINUM(127);
  GLOBAL(var_num_table_global)=EOL;
  GLOBAL(var_num_global)=MAKINUM(0);
  GLOBAL(min_var_num_sub1_global)=MAKINUM(0);
  make_subr((char *)"numerify-clause-list",tc7_subr_1,numerify_clause_list);
  make_subr((char *)"init-numerify-clause-list",tc7_subr_0,init_numerify_clause_list);
  make_subr((char *)"numerify-clause",tc7_subr_1,numerify_clause);
  make_subr((char *)"numerify-literal",tc7_subr_1,numerify_literal);
  make_subr((char *)"polarize-pred-nr",tc7_subr_2,polarize_pred_nr);
  make_subr((char *)"numerify-term",tc7_subr_1,numerify_term);
  make_subr((char *)"var-symbol?",tc7_subr_1,var_symbol_pred_);
  GLOBAL(list_output_global)=BOOL_F;
  GLOBAL(comma_output_global)=BOOL_T;
  make_subr((char *)"print-full-clause",tc7_subr_1,print_full_clause);
  make_subr((char *)"print-clause",tc7_subr_1,print_clause);
  make_subr((char *)"print-pure-clause",tc7_subr_1,print_pure_clause);
  make_subr((char *)"print-lit",tc7_subr_1,print_lit);
  make_subr((char *)"print-term",tc7_subr_1,print_term);
  make_subr((char *)"print-pred",tc7_subr_1,print_pred);
  make_subr((char *)"print-fun",tc7_subr_1,print_fun);
  make_subr((char *)"print-const",tc7_subr_1,print_const);
  GLOBAL(nr_var_table_global)=const_239;
  make_subr((char *)"print-var",tc7_subr_1,print_var);
  make_subr((char *)"print-list-as-term",tc7_subr_1,print_list_as_term);
  make_subr((char *)"show-discr-tree",tc7_subr_2,show_discr_tree);
  make_subr((char *)"make-readable-discr-tree",tc7_subr_2,make_readable_discr_tree);
  make_subr((char *)"tree-debug-leaf?",tc7_subr_1,tree_debug_leaf_pred_);
  make_subr((char *)"make-readable-discr-leaf",tc7_subr_1,make_readable_discr_leaf);
  make_subr((char *)"make-readable-fullcl",tc7_subr_1,make_readable_fullcl);
  make_subr((char *)"make-readable-cl",tc7_subr_1,make_readable_cl);
  make_subr((char *)"make-readable-lit",tc7_subr_1,make_readable_lit);
  make_subr((char *)"make-readable-term",tc7_subr_1,make_readable_term);
  make_subr((char *)"debug-print-clause",tc7_subr_1,debug_print_clause);
  make_subr((char *)"debug-print-pure-clause",tc7_subr_1,debug_print_pure_clause);
  make_subr((char *)"debug-print-lit",tc7_subr_1,debug_print_lit);
  make_subr((char *)"debug-print-term",tc7_subr_1,debug_print_term);
  make_subr((char *)"debug-print-pred",tc7_subr_1,debug_print_pred);
  make_subr((char *)"debug-print-fun",tc7_subr_1,debug_print_fun);
  make_subr((char *)"debug-print-const",tc7_subr_1,debug_print_const);
  make_subr((char *)"debug-print-var",tc7_subr_1,debug_print_var);
  make_subr((char *)"debug-print-xvars",tc7_subr_1,debug_print_xvars);
  make_subr((char *)"debug-print-yvars",tc7_subr_1,debug_print_yvars);
  make_subr((char *)"debug-print-zvars",tc7_subr_1,debug_print_zvars);
  make_subr((char *)"report-error",tc7_lsubr,report_error_wrapper);
  GLOBAL(internal_time_units_per_second_global)=MAKINUM(100);
  GLOBAL(total_time_start_global)=MAKINUM(0);
  GLOBAL(total_time_given_global)=BOOL_F;
  GLOBAL(one_pass_time_global)=MAKINUM(0);
  GLOBAL(strat_list_global)=EOL;
  GLOBAL(given_checkpoint_keptnrs_global)=EOL;
  GLOBAL(checkpoint_keptnrs_global)=EOL;
  GLOBAL(last_got_time_global)=MAKINUM(0);
  GLOBAL(use_real_time_global)=BOOL_F;
  make_subr((char *)"get-time",tc7_subr_0,get_time);
  make_subr((char *)"get-check-time",tc7_subr_1,get_check_time);
  make_subr((char *)"store-time-checkpoint!",tc7_subr_1,store_time_checkpoint_excl_);
  make_subr((char *)"prove",tc7_subr_3,prove);
  make_subr((char *)"prove-make-initial-clauses",tc7_lsubr,prove_make_initial_clauses_wrapper);
  make_subr((char *)"prove-show-input-clauses",tc7_lsubr,prove_show_input_clauses_wrapper);
  GLOBAL(no_passes_started_global)=BOOL_T;
  GLOBAL(all_passes_time_global)=MAKINUM(0);
  make_subr((char *)"prove-all-passes",tc7_lsubr,prove_all_passes_wrapper);
  make_subr((char *)"pick-strat-from-list",tc7_subr_0,pick_strat_from_list);
  make_subr((char *)"prove-one-pass",tc7_lsubr,prove_one_pass_wrapper);
  make_subr((char *)"show-one-pass-strategy",tc7_subr_0,show_one_pass_strategy);
  make_subr((char *)"eq-lit-in-sos?",tc7_subr_1,eq_lit_in_sos_pred_);
  make_subr((char *)"add-typet-demod-ans",tc7_subr_1,add_typet_demod_ans);
  make_subr((char *)"remove-typet-demod-ans",tc7_subr_1,remove_typet_demod_ans);
  make_subr((char *)"remove-ans-from-clauses",tc7_subr_1,remove_ans_from_clauses);
  GLOBAL(enumerate_sos_literals_nr_global)=MAKINUM(0);
  make_subr((char *)"enumerate-sos-literals",tc7_subr_1,enumerate_sos_literals);
  GLOBAL(input_cl_nr_global)=MAKINUM(0);
  GLOBAL(input_unitcl_nr_global)=MAKINUM(0);
  GLOBAL(input_negcl_nr_global)=MAKINUM(0);
  GLOBAL(input_poscl_nr_global)=MAKINUM(0);
  GLOBAL(input_mixcl_nr_global)=MAKINUM(0);
  GLOBAL(input_horncl_nr_global)=MAKINUM(0);
  GLOBAL(input_invhorncl_nr_global)=MAKINUM(0);
  GLOBAL(input_negdhorncl_nr_global)=MAKINUM(0);
  GLOBAL(input_wellorderedcl_nr_global)=MAKINUM(0);
  GLOBAL(input_somewhat_ordered_nr_global)=MAKINUM(0);
  GLOBAL(input_wellhyper_nr_global)=MAKINUM(0);
  GLOBAL(input_maxlen_nr_global)=MAKINUM(0);
  GLOBAL(input_maxdepth_nr_global)=MAKINUM(0);
  GLOBAL(input_contains_eq_global)=BOOL_F;
  GLOBAL(input_negun_d_global)=MAKINUM(0);
  GLOBAL(input_posun_d_global)=MAKINUM(0);
  make_subr((char *)"analyse-input",tc7_subr_2,analyse_input);
  make_subr((char *)"select-initial-strategy",tc7_subr_0,select_initial_strategy);
  make_subr((char *)"select-initial-strategy-aux",tc7_subr_0,select_initial_strategy_aux);
  make_subr((char *)"break",tc7_subr_0,break_nonkeyword);
  make_subr((char *)"hprove",tc7_subr_3,hprove);
  make_subr((char *)"hfprove",tc7_subr_2,hfprove);
  make_subr((char *)"init",tc7_subr_0,init);
  make_subr((char *)"go",tc7_subr_0,go);
  make_subr((char *)"abs-path-part",tc7_subr_1,abs_path_part);
  GLOBAL(batch)=top_actions_resbase_cl1_clproc0;
  GLOBAL(batch)=top_actions_resbase_cl2_clproc0;
  make_subr((char *)"show-old-units",tc7_subr_0,show_old_units);
  make_subr((char *)"hyper-contradiction?",tc7_subr_1,hyper_contradiction_pred_);
  make_subr((char *)"full-hyper-contradiction?",tc7_subr_1,full_hyper_contradiction_pred_);
  make_subr((char *)"start-binary-hypercheck-strategy",tc7_subr_0,start_binary_hypercheck_strategy);
  make_subr((char *)"start-backward-hyper-analysis",tc7_subr_0,start_backward_hyper_analysis);
  make_subr((char *)"make-all-resolvable!",tc7_subr_1,make_all_resolvable_excl_);
  return make_subr((char *)"make-poslit-preferred!",tc7_subr_1,make_poslit_preferred_excl_);
}

SCM top_actions_resbase_cl2()
{
  if(NULL_P(CDR(apply(GLOBAL(program_arguments),EOL,EOL)))) {
    display(const_240,cur_output_port());
    newline(cur_output_port());
    abrt();
    return quit(1);
  }
  else {
    if(NULL_P(CDR(CDR(apply(GLOBAL(program_arguments),EOL,EOL))))) {
      GLOBAL(timelimit_global)=BOOL_F;
      fprove(CAR(CDR(apply(GLOBAL(program_arguments),EOL,EOL))));
    }
    else {
      GLOBAL(timelimit_global)=CAR(CDR(CDR(apply(GLOBAL(program_arguments),EOL,EOL))));
      fprove(CAR(CDR(apply(GLOBAL(program_arguments),EOL,EOL))));
    }
    newline(cur_output_port());
    return quit(1);
  }
}

SCM top_actions_resbase_cl1()
{
  display(apply(GLOBAL(program_arguments),EOL,EOL),cur_output_port());
  return fprove(const_241);
}

SCM map1(fn,lst)
SCM (*fn)();
SCM lst;
{
  SCM res,res_end;

  res=EOL;
  res_end=res;
  for(;PAIR_P(lst);) {
    if(NULL_P(res)) {
      res=cons((*fn)(CAR(lst)),EOL);
      res_end=res;
    }
    else {
      SET_CDR(res_end,cons((*fn)(CAR(lst)),EOL));
      res_end=CDR(res_end);
    }
    lst=CDR(lst);
  }
  return res;
}

SCM map1_inst2(npar__12,fn,lst)
SCM (*fn)();
SCM npar__12,lst;
{
  SCM res,res_end;

  res=EOL;
  res_end=res;
  for(;PAIR_P(lst);) {
    if(NULL_P(res)) {
      res=cons((*fn)(npar__12,CAR(lst)),EOL);
      res_end=res;
    }
    else {
      SET_CDR(res_end,cons((*fn)(npar__12,CAR(lst)),EOL));
      res_end=CDR(res_end);
    }
    lst=CDR(lst);
  }
  return res;
}

SCM map1_inst1(npar__10,npar__11,fn,lst)
SCM *npar__10,*npar__11;
SCM (*fn)();
SCM lst;
{
  SCM res,res_end;

  res=EOL;
  res_end=res;
  for(;PAIR_P(lst);) {
    if(NULL_P(res)) {
      res=cons((*fn)(npar__10,npar__11,CAR(lst)),EOL);
      res_end=res;
    }
    else {
      SET_CDR(res_end,cons((*fn)(npar__10,npar__11,CAR(lst)),EOL));
      res_end=CDR(res_end);
    }
    lst=CDR(lst);
  }
  return res;
}

SCM for_each1(fn,lst)
SCM (*fn)();
SCM lst;
{
  for(;PAIR_P(lst);) {
    (*fn)(CAR(lst));
    lst=CDR(lst);
  }
  return UNSPECIFIED;
}

SCM for_each1_inst4(npar__13,npar__14,npar__15,npar__16,npar__17,fn,lst)
SCM *npar__13,*npar__14,*npar__15,*npar__16,*npar__17;
SCM (*fn)();
SCM lst;
{
  for(;PAIR_P(lst);) {
    (*fn)(npar__13,npar__14,npar__15,npar__16,npar__17,CAR(lst));
    lst=CDR(lst);
  }
  return UNSPECIFIED;
}

SCM for_each1_inst3(npar__8,npar__9,fn,lst)
SCM *npar__8,*npar__9;
SCM (*fn)();
SCM lst;
{
  for(;PAIR_P(lst);) {
    (*fn)(npar__8,npar__9,CAR(lst));
    lst=CDR(lst);
  }
  return UNSPECIFIED;
}

SCM for_each1_inst2(npar__7,fn,lst)
SCM (*fn)();
SCM npar__7,lst;
{
  for(;PAIR_P(lst);) {
    (*fn)(npar__7,CAR(lst));
    lst=CDR(lst);
  }
  return UNSPECIFIED;
}

SCM for_each1_inst1(npar__6,fn,lst)
SCM *npar__6;
SCM (*fn)();
SCM lst;
{
  for(;PAIR_P(lst);) {
    (*fn)(npar__6,CAR(lst));
    lst=CDR(lst);
  }
  return UNSPECIFIED;
}

SCM prove_one_pass_wrapper(x)
SCM x;
{
  return prove_one_pass(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))),CAR(CDR(CDR(CDR(CDR(x))))));
}

SCM prove_all_passes_wrapper(x)
SCM x;
{
  return prove_all_passes(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))),CAR(CDR(CDR(CDR(CDR(x))))));
}

SCM prove_show_input_clauses_wrapper(x)
SCM x;
{
  return prove_show_input_clauses(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))),CAR(CDR(CDR(CDR(CDR(x))))));
}

SCM prove_make_initial_clauses_wrapper(x)
SCM x;
{
  return prove_make_initial_clauses(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))),CAR(CDR(CDR(CDR(CDR(x))))));
}

SCM report_error_wrapper(x)
SCM x;
{
  return report_error(CAR(x),CDR(x));
}

SCM make_raw_inf_cl_pair_typet_hyper_wrapper(x)
SCM x;
{
  return make_raw_inf_cl_pair_typet_hyper(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))),CAR(CDR(CDR(CDR(CDR(x))))),CAR(CDR(CDR(CDR(CDR(CDR(x)))))));
}

SCM history__grtr_answer_binstep_wrapper(x)
SCM x;
{
  return history__grtr_answer_binstep(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))),CAR(CDR(CDR(CDR(CDR(x))))),CAR(CDR(CDR(CDR(CDR(CDR(x)))))),CAR(CDR(CDR(CDR(CDR(CDR(CDR(x))))))),CAR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(x)))))))),CAR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(x))))))))));
}

SCM insert_discr_tree_excl__wrapper(x)
SCM x;
{
  return insert_discr_tree_excl_(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))),CAR(CDR(CDR(CDR(CDR(x))))));
}

SCM insert_clause_discr_tree_excl__wrapper(x)
SCM x;
{
  return insert_clause_discr_tree_excl_(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))));
}

SCM insert_partial_discr_tree_excl__wrapper(x)
SCM x;
{
  return insert_partial_discr_tree_excl_(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))),CAR(CDR(CDR(CDR(CDR(x))))));
}

SCM full_unit_cutoff_double_excl__wrapper(x)
SCM x;
{
  return full_unit_cutoff_double_excl_(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))));
}

SCM full_unit_cutoff_aux_excl__wrapper(x)
SCM x;
{
  return full_unit_cutoff_aux_excl_(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))));
}

SCM subst_deco_cl_wrapper(x)
SCM x;
{
  return subst_deco_cl(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))));
}

SCM make_raw_inf_cl_pair_wrapper(x)
SCM x;
{
  return make_raw_inf_cl_pair(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))));
}

SCM handle_derived_inf_cl_pair_wrapper(x)
SCM x;
{
  return handle_derived_inf_cl_pair(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))));
}

SCM paramodulate_into_ycl_wrapper(x)
SCM x;
{
  return paramodulate_into_ycl(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))),CAR(CDR(CDR(CDR(CDR(x))))),CAR(CDR(CDR(CDR(CDR(CDR(x)))))),CAR(CDR(CDR(CDR(CDR(CDR(CDR(x))))))),CAR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(x)))))))),CAR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(x))))))))),CAR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(x)))))))))),CAR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(x))))))))))),CAR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(x)))))))))))),CAR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(x))))))))))))));
}

SCM make_binres_history_wrapper(x)
SCM x;
{
  return make_binres_history(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))),CAR(CDR(CDR(CDR(CDR(x))))),CAR(CDR(CDR(CDR(CDR(CDR(x)))))));
}

SCM make_hyper_history_aux_wrapper(x)
SCM x;
{
  return make_hyper_history_aux(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))),CAR(CDR(CDR(CDR(CDR(x))))),CAR(CDR(CDR(CDR(CDR(CDR(x)))))),CAR(CDR(CDR(CDR(CDR(CDR(CDR(x))))))),CAR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(x)))))))));
}

SCM make_hyper_history_wrapper(x)
SCM x;
{
  return make_hyper_history(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))),CAR(CDR(CDR(CDR(CDR(x))))),CAR(CDR(CDR(CDR(CDR(CDR(x)))))),CAR(CDR(CDR(CDR(CDR(CDR(CDR(x))))))),CAR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(x)))))))));
}

SCM two_posunits_typet_para_wrapper(x)
SCM x;
{
  return two_posunits_typet_para(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))),CAR(CDR(CDR(CDR(CDR(x))))),CAR(CDR(CDR(CDR(CDR(CDR(x)))))));
}

SCM unit_and_final_nuc_res_wrapper(x)
SCM x;
{
  return unit_and_final_nuc_res(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))),CAR(CDR(CDR(CDR(CDR(x))))),CAR(CDR(CDR(CDR(CDR(CDR(x)))))),CAR(CDR(CDR(CDR(CDR(CDR(CDR(x))))))),CAR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(x)))))))),CAR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(x))))))))),CAR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(x)))))))))));
}

SCM final_nuc_res_wrapper(x)
SCM x;
{
  return final_nuc_res(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))),CAR(CDR(CDR(CDR(CDR(x))))),CAR(CDR(CDR(CDR(CDR(CDR(x)))))),CAR(CDR(CDR(CDR(CDR(CDR(CDR(x))))))),CAR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(x)))))))));
}

SCM two_clause_binres_loop_wrapper(x)
SCM x;
{
  return two_clause_binres_loop(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))),CAR(CDR(CDR(CDR(CDR(x))))),CAR(CDR(CDR(CDR(CDR(CDR(x)))))));
}

SCM subsumed_pure_clause_aux_pred__wrapper(x)
SCM x;
{
  return subsumed_pure_clause_aux_pred_(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))),CAR(CDR(CDR(CDR(CDR(x))))));
}

SCM funlist_can_subsume_pred__wrapper(x)
SCM x;
{
  return funlist_can_subsume_pred_(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))));
}

SCM subsumed_clause_aux_pred__wrapper(x)
SCM x;
{
  return subsumed_clause_aux_pred_(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))),CAR(CDR(CDR(CDR(CDR(x))))),CAR(CDR(CDR(CDR(CDR(CDR(x)))))),CAR(CDR(CDR(CDR(CDR(CDR(CDR(x))))))));
}

SCM resolve_unify_cutoff_wrapper(x)
SCM x;
{
  return resolve_unify_cutoff(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))));
}

SCM resolve_unify_ordinary_wrapper(x)
SCM x;
{
  return resolve_unify_ordinary(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))));
}

SCM decorate_vars_lit_excl__wrapper(x)
SCM x;
{
  return decorate_vars_lit_excl_(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))),CAR(CDR(CDR(CDR(CDR(x))))));
}

SCM intersection_union_wrapper(x)
SCM x;
{
  return intersection_union(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))));
}

SCM subst_deco_replace_term_nodemodulate_wrapper(x)
SCM x;
{
  return subst_deco_replace_term_nodemodulate(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))));
}

SCM subst_deco_replace_term_wrapper(x)
SCM x;
{
  return subst_deco_replace_term(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))));
}

SCM init_resbase()
{
  top_actions_resbase_cl2_clproc0=make_subr((char *)"top_actions_resbase_cl2",tc7_subr_0,top_actions_resbase_cl2);
  top_actions_resbase_cl1_clproc0=make_subr((char *)"top_actions_resbase_cl1",tc7_subr_0,top_actions_resbase_cl1);
  program_arguments=&CDR(intern((char *)"program-arguments",17));
  batch=&CDR(intern((char *)"batch",5));
  pretty_print=&CDR(intern((char *)"pretty-print",12));
  paramodulate=&CDR(intern((char *)"paramodulate",12));
  internal_time_units_per_second=&CDR(intern((char *)"internal-time-units-per-second",30));
  get_internal_real_time=&CDR(intern((char *)"get-internal-real-time",22));
  greater_clause_occ_depth_pred_=&CDR(intern((char *)"greater-clause-occ-depth?",25));
  single_reduction_rule_clauses_list_global=&CDR(intern((char *)"*single-reduction-rule-clauses-list*",36));
  single_rule_clauses_list_global=&CDR(intern((char *)"*single-rule-clauses-list*",26));
  mult_rule_clauses_list_global=&CDR(intern((char *)"*mult-rule-clauses-list*",24));
  print_full_int_clause=&CDR(intern((char *)"print-full-int-clause",21));
  insert_partial_discr_tree_leaf_excl_=&CDR(intern((char *)"insert-partial-discr-tree-leaf!",31));
  res=&CDR(intern((char *)"res",3));
  factor_clproc0=&CDR(intern((char *)"factor",6));
  use_all_single_premiss_rules=&CDR(intern((char *)"use-all-single-premiss-rules",28));
  int_prohibited_pr_pred_=&CDR(intern((char *)"int-prohibited-pr?",18));
  last_pair=&CDR(intern((char *)"last-pair",9));
  copy_tree=&CDR(intern((char *)"copy-tree",9));
  int_usable_clauses_fast_loop=&CDR(intern((char *)"int-usable-clauses-fast-loop",28));
  input_posun_d_global=&CDR(intern((char *)"*input-posun-d*",15));
  input_negun_d_global=&CDR(intern((char *)"*input-negun-d*",15));
  input_contains_eq_global=&CDR(intern((char *)"*input-contains-eq*",19));
  input_maxdepth_nr_global=&CDR(intern((char *)"*input-maxdepth-nr*",19));
  input_maxlen_nr_global=&CDR(intern((char *)"*input-maxlen-nr*",17));
  input_wellhyper_nr_global=&CDR(intern((char *)"*input-wellhyper-nr*",20));
  input_somewhat_ordered_nr_global=&CDR(intern((char *)"*input-somewhat-ordered-nr*",27));
  input_wellorderedcl_nr_global=&CDR(intern((char *)"*input-wellorderedcl-nr*",24));
  input_negdhorncl_nr_global=&CDR(intern((char *)"*input-negdhorncl-nr*",21));
  input_invhorncl_nr_global=&CDR(intern((char *)"*input-invhorncl-nr*",20));
  input_horncl_nr_global=&CDR(intern((char *)"*input-horncl-nr*",17));
  input_mixcl_nr_global=&CDR(intern((char *)"*input-mixcl-nr*",16));
  input_poscl_nr_global=&CDR(intern((char *)"*input-poscl-nr*",16));
  input_negcl_nr_global=&CDR(intern((char *)"*input-negcl-nr*",16));
  input_unitcl_nr_global=&CDR(intern((char *)"*input-unitcl-nr*",17));
  input_cl_nr_global=&CDR(intern((char *)"*input-cl-nr*",13));
  enumerate_sos_literals_nr_global=&CDR(intern((char *)"*enumerate-sos-literals-nr*",27));
  all_passes_time_global=&CDR(intern((char *)"*all-passes-time*",17));
  no_passes_started_global=&CDR(intern((char *)"*no-passes-started*",19));
  use_real_time_global=&CDR(intern((char *)"*use-real-time*",15));
  last_got_time_global=&CDR(intern((char *)"*last-got-time*",15));
  checkpoint_keptnrs_global=&CDR(intern((char *)"*checkpoint-keptnrs*",20));
  given_checkpoint_keptnrs_global=&CDR(intern((char *)"*given-checkpoint-keptnrs*",26));
  strat_list_global=&CDR(intern((char *)"*strat-list*",12));
  one_pass_time_global=&CDR(intern((char *)"*one-pass-time*",15));
  total_time_given_global=&CDR(intern((char *)"*total-time-given*",18));
  total_time_start_global=&CDR(intern((char *)"*total-time-start*",18));
  internal_time_units_per_second_global=&CDR(intern((char *)"*internal-time-units-per-second*",32));
  nr_var_table_global=&CDR(intern((char *)"*nr-var-table*",14));
  comma_output_global=&CDR(intern((char *)"*comma-output*",14));
  list_output_global=&CDR(intern((char *)"*list-output*",13));
  min_var_num_sub1_global=&CDR(intern((char *)"*min-var-num-sub1*",18));
  var_num_global=&CDR(intern((char *)"*var-num*",9));
  var_num_table_global=&CDR(intern((char *)"*var-num-table*",15));
  max_nr_of_preds_global=&CDR(intern((char *)"*max-nr-of-preds*",17));
  min_pred_num_sub1_global=&CDR(intern((char *)"*min-pred-num-sub1*",19));
  pred_num_global=&CDR(intern((char *)"*pred-num*",10));
  pred_num_table_global=&CDR(intern((char *)"*pred-num-table*",16));
  max_nr_of_funs_global=&CDR(intern((char *)"*max-nr-of-funs*",16));
  min_fun_num_sub1_global=&CDR(intern((char *)"*min-fun-num-sub1*",18));
  fun_num_global=&CDR(intern((char *)"*fun-num*",9));
  fun_num_table_global=&CDR(intern((char *)"*fun-num-table*",15));
  min_const_num_sub1_global=&CDR(intern((char *)"*min-const-num-sub1*",20));
  const_num_global=&CDR(intern((char *)"*const-num*",11));
  const_num_table_global=&CDR(intern((char *)"*const-num-table*",17));
  prolog_style_variables_global=&CDR(intern((char *)"*prolog-style-variables*",24));
  ans_prohibited_prednrs_global=&CDR(intern((char *)"*ans-prohibited-prednrs*",24));
  ans_prohibited_constnrs_global=&CDR(intern((char *)"*ans-prohibited-constnrs*",25));
  ans_prohibited_funnrs_global=&CDR(intern((char *)"*ans-prohibited-funnrs*",23));
  ans_prohibited_predsymbs_global=&CDR(intern((char *)"*ans-prohibited-predsymbs*",26));
  ans_prohibited_constsymbs_global=&CDR(intern((char *)"*ans-prohibited-constsymbs*",27));
  ans_prohibited_funsymbs_global=&CDR(intern((char *)"*ans-prohibited-funsymbs*",25));
  usable_list_symbol_global=&CDR(intern((char *)"*usable-list-symbol*",20));
  sos_list_symbol_global=&CDR(intern((char *)"*sos-list-symbol*",17));
  lit_demodulator_list_symbol_global=&CDR(intern((char *)"*lit-demodulator-list-symbol*",29));
  demodulator_list_symbol_global=&CDR(intern((char *)"*demodulator-list-symbol*",25));
  classicsynth_speclit_global=&CDR(intern((char *)"*classicsynth-speclit*",22));
  typet_speclit_global=&CDR(intern((char *)"*typet-speclit*",15));
  lambda_dummypar_symbol_global=&CDR(intern((char *)"*lambda-dummypar-symbol*",24));
  lambda_fun_symbol_global=&CDR(intern((char *)"*lambda-fun-symbol*",19));
  id_refl_fun_symbol_global=&CDR(intern((char *)"*id-refl-fun-symbol*",20));
  subst_prim_fun_symbol_global=&CDR(intern((char *)"*subst-prim-fun-symbol*",23));
  subst_fun_symbol_global=&CDR(intern((char *)"*subst-fun-symbol*",18));
  inhabited_symbol_global=&CDR(intern((char *)"*inhabited-symbol*",18));
  if_fun_symbol_global=&CDR(intern((char *)"*if-fun-symbol*",15));
  case_fun_symbol_global=&CDR(intern((char *)"*case-fun-symbol*",17));
  eq_fun_symbol_global=&CDR(intern((char *)"*eq-fun-symbol*",15));
  eq_symbol_global=&CDR(intern((char *)"*eq-symbol*",11));
  ans_symbol_global=&CDR(intern((char *)"*ans-symbol*",12));
  otter_outputfile_suffix_global=&CDR(intern((char *)"*otter-outputfile-suffix*",25));
  otter_tmpfile_prefix_global=&CDR(intern((char *)"*otter-tmpfile-prefix*",22));
  otter_tmpfile_suffix_global=&CDR(intern((char *)"*otter-tmpfile-suffix*",22));
  otter_tmpfile_global=&CDR(intern((char *)"*otter-tmpfile*",15));
  otter_dot_repl_global=&CDR(intern((char *)"*otter-dot-repl*",16));
  otter_comma_repl_global=&CDR(intern((char *)"*otter-comma-repl*",18));
  otter_uppercase_prefix_global=&CDR(intern((char *)"*otter-uppercase-prefix*",24));
  otter_or_symbol_global=&CDR(intern((char *)"*otter-or-symbol*",17));
  subs_reg_subs_fail_nr_global=&CDR(intern((char *)"*subs-reg-subs-fail-nr*",23));
  subs_reg_subs_tried_nr_global=&CDR(intern((char *)"*subs-reg-subs-tried-nr*",24));
  subs_funlist_fail_nr_global=&CDR(intern((char *)"*subs-funlist-fail-nr*",22));
  subs_gclpreds_fail_nr_global=&CDR(intern((char *)"*subs-gclpreds-fail-nr*",23));
  subs_aux_strength_fail_nr_global=&CDR(intern((char *)"*subs-aux-strength-fail-nr*",27));
  subs_strength_fail_nr_global=&CDR(intern((char *)"*subs-strength-fail-nr*",23));
  subs_length_fail_nr_global=&CDR(intern((char *)"*subs-length-fail-nr*",21));
  subs_tried_nr_global=&CDR(intern((char *)"*subs-tried-nr*",15));
  proof_start_run_time_global=&CDR(intern((char *)"*proof-start-run-time*",22));
  proof_start_real_time_global=&CDR(intern((char *)"*proof-start-real-time*",23));
  double_unit_cutoff_nr_global=&CDR(intern((char *)"*double-unit-cutoff-nr*",23));
  full_unit_cutoff_nr_global=&CDR(intern((char *)"*full-unit-cutoff-nr*",21));
  simple_unit_cutoff_nr_global=&CDR(intern((char *)"*simple-unit-cutoff-nr*",23));
  back_subsumed_nr_global=&CDR(intern((char *)"*back-subsumed-nr*",18));
  forward_subsumed_nonunit_nr_global=&CDR(intern((char *)"*forward-subsumed-nonunit-nr*",29));
  forward_subsumed_overdouble_nr_global=&CDR(intern((char *)"*forward-subsumed-overdouble-nr*",32));
  forward_subsumed_double_nr_global=&CDR(intern((char *)"*forward-subsumed-double-nr*",28));
  forward_subsumed_unit_nr_global=&CDR(intern((char *)"*forward-subsumed-unit-nr*",26));
  kept_new_demodulators_nr_global=&CDR(intern((char *)"*kept-new-demodulators-nr*",26));
  kept_mid_nucleus_nr_global=&CDR(intern((char *)"*kept-mid-nucleus-nr*",21));
  kept_clauses_nr_global=&CDR(intern((char *)"*kept-clauses-nr*",17));
  derived_clauses_nr_global=&CDR(intern((char *)"*derived-clauses-nr*",20));
  one_pass_kept_clauses_firstnr_global=&CDR(intern((char *)"*one-pass-kept-clauses-firstnr*",31));
  answer_litinf_global=&CDR(intern((char *)"*answer-litinf*",15));
  special_insertion_place_global=&CDR(intern((char *)"*special-insertion-place*",25));
  clause_keeplength_limit_global=&CDR(intern((char *)"*clause-keeplength-limit*",25));
  clause_uselength_limit_global=&CDR(intern((char *)"*clause-uselength-limit*",24));
  clause_keepdepth_limit_global=&CDR(intern((char *)"*clause-keepdepth-limit*",24));
  clause_keepsize_limit_global=&CDR(intern((char *)"*clause-keepsize-limit*",23));
  clause_usestruct_limits_global=&CDR(intern((char *)"*clause-usestruct-limits*",25));
  clause_usedepth_limits_global=&CDR(intern((char *)"*clause-usedepth-limits*",24));
  clause_usenr_limits_global=&CDR(intern((char *)"*clause-usenr-limits*",21));
  user_criterias_pre_flag_global=&CDR(intern((char *)"*user-criterias-pre-flag*",25));
  user_criterias_post_flag_global=&CDR(intern((char *)"*user-criterias-post-flag*",26));
  new_demodulators_flag_global=&CDR(intern((char *)"*new-demodulators-flag*",23));
  demodulate_constants_flag_global=&CDR(intern((char *)"*demodulate-constants-flag*",27));
  demodulate_flag_global=&CDR(intern((char *)"*demodulate-flag*",17));
  back_demodulate_flag_global=&CDR(intern((char *)"*back-demodulate-flag*",22));
  demodulate_lit_flag_global=&CDR(intern((char *)"*demodulate-lit-flag*",21));
  dynamic_demodulation_flag_global=&CDR(intern((char *)"*dynamic-demodulation-flag*",27));
  ordered_paramodulation_flag_global=&CDR(intern((char *)"*ordered-paramodulation-flag*",29));
  discr_depth_first_global=&CDR(intern((char *)"*discr-depth-first*",19));
  discr_tree_subsume_stratflag_global=&CDR(intern((char *)"*discr-tree-subsume-stratflag*",30));
  int_use_hyperres_flag_global=&CDR(intern((char *)"*int-use-hyperres-flag*",23));
  classical_synth_stratflag_global=&CDR(intern((char *)"*classical-synth-stratflag*",27));
  int_use_binres_flag_global=&CDR(intern((char *)"*int-use-binres-flag*",21));
  int_logic_flag_global=&CDR(intern((char *)"*int-logic-flag*",16));
  type_theory_stratflag_global=&CDR(intern((char *)"*type-theory-stratflag*",23));
  neg_hyper_strategy_flag_global=&CDR(intern((char *)"*neg-hyper-strategy-flag*",25));
  ordered_factor_flag_global=&CDR(intern((char *)"*ordered-factor-flag*",21));
  posweight_order_strategy_flag_global=&CDR(intern((char *)"*posweight-order-strategy-flag*",31));
  poslitpref_order_strategy_flag_global=&CDR(intern((char *)"*poslitpref-order-strategy-flag*",32));
  firstlitpref_order_strategy_flag_global=&CDR(intern((char *)"*firstlitpref-order-strategy-flag*",34));
  name_order_strategy_flag_global=&CDR(intern((char *)"*name-order-strategy-flag*",26));
  order_strategy_flag_global=&CDR(intern((char *)"*order-strategy-flag*",21));
  hyper_strategy_flag_global=&CDR(intern((char *)"*hyper-strategy-flag*",21));
  unit_strategy_flag_global=&CDR(intern((char *)"*unit-strategy-flag*",20));
  para_pos_unit_strategy_global=&CDR(intern((char *)"*para-pos-unit-strategy*",24));
  paramodulate_from_vars_stratflag_global=&CDR(intern((char *)"*paramodulate-from-vars-stratflag*",34));
  paramodulation_strategy_flag_global=&CDR(intern((char *)"*paramodulation-strategy-flag*",30));
  paramodulation_allowed_flag_global=&CDR(intern((char *)"*paramodulation-allowed-flag*",29));
  remove_identical_lit_stratflag_global=&CDR(intern((char *)"*remove-identical-lit-stratflag*",32));
  havealready_timecounter_global=&CDR(intern((char *)"*havealready-timecounter*",25));
  back_subsume_stratflag_global=&CDR(intern((char *)"*back-subsume-stratflag*",24));
  factors_stratflag_global=&CDR(intern((char *)"*factors-stratflag*",19));
  unit_clash_flag_global=&CDR(intern((char *)"*unit-clash-flag*",17));
  hyper_contradiction_strategy_global=&CDR(intern((char *)"*hyper-contradiction-strategy*",30));
  binary_hyper_sos_strategy_global=&CDR(intern((char *)"*binary-hyper-sos-strategy*",27));
  hyper_wos_strategy_flag_global=&CDR(intern((char *)"*hyper-wos-strategy-flag*",25));
  remove_all_tautologies_stratflag_global=&CDR(intern((char *)"*remove-all-tautologies-stratflag*",34));
  display_debug_info_flag_global=&CDR(intern((char *)"*display-debug-info-flag*",25));
  display_info_char_flag_global=&CDR(intern((char *)"*display-info-char-flag*",24));
  display_info_level_global=&CDR(intern((char *)"*display-info-level*",20));
  max_kept_clauses_nr_global=&CDR(intern((char *)"*max-kept-clauses-nr*",21));
  stop_res_real_time_global=&CDR(intern((char *)"*stop-res-real-time*",20));
  auto_mode_flag_global=&CDR(intern((char *)"*auto-mode-flag*",16));
  keep_all_old_clauses_flag_global=&CDR(intern((char *)"*keep-all-old-clauses-flag*",27));
  sos_strategy_flag_global=&CDR(intern((char *)"*sos-strategy-flag*",19));
  order_equality_lex_strat_global=&CDR(intern((char *)"*order-equality-lex-strat*",26));
  unit_equality_strat_global=&CDR(intern((char *)"*unit-equality-strat*",21));
  split_strategy_flag_global=&CDR(intern((char *)"*split-strategy-flag*",21));
  int_outmost_label_fun_nr_global=&CDR(intern((char *)"*int-outmost-label-fun-nr*",26));
  int_outmost_symb_labelfun_global=&CDR(intern((char *)"*int-outmost-symb-labelfun*",27));
  lambda_dummypar_nr_global=&CDR(intern((char *)"*lambda-dummypar-nr*",20));
  lambda_fun_nr_global=&CDR(intern((char *)"*lambda-fun-nr*",15));
  subst_prim_fun_nr_global=&CDR(intern((char *)"*subst-prim-fun-nr*",19));
  subst_fun_nr_global=&CDR(intern((char *)"*subst-fun-nr*",14));
  if_fun_nr_global=&CDR(intern((char *)"*if-fun-nr*",11));
  case_fun_nr_global=&CDR(intern((char *)"*case-fun-nr*",13));
  eq_fun_nr_global=&CDR(intern((char *)"*eq-fun-nr*",11));
  eq_pred_nr_global=&CDR(intern((char *)"*eq-pred-nr*",12));
  ans_pred_nr_global=&CDR(intern((char *)"*ans-pred-nr*",13));
  otter_prepared_history_global=&CDR(intern((char *)"*otter-prepared-history*",24));
  shown_clausenrs_global=&CDR(intern((char *)"*shown-clausenrs*",17));
  tmp_var_depth_table_global=&CDR(intern((char *)"*tmp-var-depth-table*",21));
  lex_symbol_orderlst_global=&CDR(intern((char *)"*lex-symbol-orderlst*",21));
  factorpool_global=&CDR(intern((char *)"*factorpool*",12));
  locfactorpool_global=&CDR(intern((char *)"*locfactorpool*",15));
  stop_fast_loop_flag_global=&CDR(intern((char *)"*stop-fast-loop-flag*",21));
  last_best_weight_global=&CDR(intern((char *)"*last-best-weight*",18));
  slow_passed_time_global=&CDR(intern((char *)"*slow-passed-time*",18));
  slow_start_time_global=&CDR(intern((char *)"*slow-start-time*",17));
  new_demodulators_list_global=&CDR(intern((char *)"*new-demodulators-list*",23));
  given_clause_nr_global=&CDR(intern((char *)"*given-clause-nr*",17));
  sos_preference_cur_ratio_global=&CDR(intern((char *)"*sos-preference-cur-ratio*",26));
  sos_preference_ratio_global=&CDR(intern((char *)"*sos-preference-ratio*",22));
  make_inside_subset_tmp_lst_global=&CDR(intern((char *)"*make-inside-subset-tmp-lst*",28));
  make_inside_subset_tmp_global=&CDR(intern((char *)"*make-inside-subset-tmp*",24));
  intersection_tmp_global=&CDR(intern((char *)"*intersection-tmp*",18));
  discr_tree_demod_atoms_global=&CDR(intern((char *)"*discr-tree-demod-atoms*",24));
  discr_tree_demod_terms_global=&CDR(intern((char *)"*discr-tree-demod-terms*",24));
  discr_tree_list_global=&CDR(intern((char *)"*discr-tree-list*",17));
  nonunit_discr_tree_global=&CDR(intern((char *)"*nonunit-discr-tree*",20));
  discr_tree_global=&CDR(intern((char *)"*discr-tree*",12));
  usable_clauses_list_list_global=&CDR(intern((char *)"*usable-clauses-list-list*",26));
  sos_clauses_list_list_global=&CDR(intern((char *)"*sos-clauses-list-list*",23));
  unit_alist_list_global=&CDR(intern((char *)"*unit-alist-list*",17));
  unit_alist_global=&CDR(intern((char *)"*unit-alist*",12));
  subsumption_list_global=&CDR(intern((char *)"*subsumption-list*",18));
  usable_clauses_list_end_global=&CDR(intern((char *)"*usable-clauses-list-end*",25));
  usable_clauses_list_global=&CDR(intern((char *)"*usable-clauses-list*",21));
  ans_input_sos_global=&CDR(intern((char *)"*ans-input-sos*",15));
  sos_clauses_list_end_global=&CDR(intern((char *)"*sos-clauses-list-end*",22));
  sos_clauses_list_global=&CDR(intern((char *)"*sos-clauses-list*",18));
  litinf_classnr_mask_global=&CDR(intern((char *)"*litinf-classnr-mask*",21));
  litinf_ordernr_mask_global=&CDR(intern((char *)"*litinf-ordernr-mask*",21));
  litinf_reductionrulelit_mask_global=&CDR(intern((char *)"*litinf-reductionrulelit-mask*",30));
  litinf_rightimplrulelit_mask_global=&CDR(intern((char *)"*litinf-rightimplrulelit-mask*",30));
  litinf_leftorrulelit_mask_global=&CDR(intern((char *)"*litinf-leftorrulelit-mask*",27));
  litinf_rulelit_mask_global=&CDR(intern((char *)"*litinf-rulelit-mask*",21));
  litinf_noparafromright_mask_global=&CDR(intern((char *)"*litinf-noparafromright-mask*",29));
  litinf_noparafromleft_mask_global=&CDR(intern((char *)"*litinf-noparafromleft-mask*",28));
  litinf_noparainto_mask_global=&CDR(intern((char *)"*litinf-noparainto-mask*",24));
  litinf_isanswer_mask_global=&CDR(intern((char *)"*litinf-isanswer-mask*",22));
  litinf_nofactor_mask_global=&CDR(intern((char *)"*litinf-nofactor-mask*",22));
  litinf_noresolve_mask_global=&CDR(intern((char *)"*litinf-noresolve-mask*",23));
  last_usable_cl_nr_global=&CDR(intern((char *)"*last-usable-cl-nr*",19));
  kept_cl_nr_global=&CDR(intern((char *)"*kept-cl-nr*",12));
  cl_predsymbs_pos_mask_global=&CDR(intern((char *)"*cl-predsymbs-pos-mask*",23));
  cl_predsymbs_pos_max_global=&CDR(intern((char *)"*cl-predsymbs-pos-max*",22));
  cl_predsymbs_neg_mask_global=&CDR(intern((char *)"*cl-predsymbs-neg-mask*",23));
  cl_predsymbs_neg_shift_global=&CDR(intern((char *)"*cl-predsymbs-neg-shift*",24));
  cl_predsymbs_area_mask_global=&CDR(intern((char *)"*cl-predsymbs-area-mask*",24));
  cl_pred_overflow_mask_global=&CDR(intern((char *)"*cl-pred-overflow-mask*",23));
  cl_rep_predsymbs_mask_global=&CDR(intern((char *)"*cl-rep-predsymbs-mask*",23));
  predsymb_bit_vector_global=&CDR(intern((char *)"*predsymb-bit-vector*",21));
  cl_len_mask_global=&CDR(intern((char *)"*cl-len-mask*",13));
  cl_len_shift_global=&CDR(intern((char *)"*cl-len-shift*",14));
  cl_maxlen_global=&CDR(intern((char *)"*cl-maxlen*",11));
  cl_maxvar_mask_global=&CDR(intern((char *)"*cl-maxvar-mask*",16));
  cl_maxvar_shift_global=&CDR(intern((char *)"*cl-maxvar-shift*",17));
  cl_ground_flag_global=&CDR(intern((char *)"*cl-ground-flag*",16));
  cl_maxvar_global=&CDR(intern((char *)"*cl-maxvar*",11));
  cl_strength_mask_global=&CDR(intern((char *)"*cl-strength-mask*",18));
  const_strength_global=&CDR(intern((char *)"*const-strength*",16));
  var_strength_global=&CDR(intern((char *)"*var-strength*",14));
  g_and_const_mask_global=&CDR(intern((char *)"*g-and-const-mask*",18));
  const_number_max_global=&CDR(intern((char *)"*const-number-max*",18));
  const_number_mask_global=&CDR(intern((char *)"*const-number-mask*",19));
  term_size_1_shift_global=&CDR(intern((char *)"*term-size-1-shift*",19));
  term_size_max_shift_global=&CDR(intern((char *)"*term-size-max-shift*",21));
  term_size_max_global=&CDR(intern((char *)"*term-size-max*",15));
  term_size_shift_global=&CDR(intern((char *)"*term-size-shift*",17));
  term_size_mask_global=&CDR(intern((char *)"*term-size-mask*",16));
  term_size_strength_mask_global=&CDR(intern((char *)"*term-size-strength-mask*",25));
  term_depth_1_shift_global=&CDR(intern((char *)"*term-depth-1-shift*",20));
  term_depth_shift_global=&CDR(intern((char *)"*term-depth-shift*",18));
  term_depth_max_shift_global=&CDR(intern((char *)"*term-depth-max-shift*",22));
  term_depth_max_global=&CDR(intern((char *)"*term-depth-max*",16));
  term_depth_mask_global=&CDR(intern((char *)"*term-depth-mask*",17));
  term_depth_strength_mask_global=&CDR(intern((char *)"*term-depth-strength-mask*",26));
  strength_mask_global=&CDR(intern((char *)"*strength-mask*",15));
  ground_mask_global=&CDR(intern((char *)"*ground-mask*",13));
  repeated_vars_mask_global=&CDR(intern((char *)"*repeated-vars-mask*",20));
  fun_except_varinf_mask_global=&CDR(intern((char *)"*fun-except-varinf-mask*",24));
  maxvar_mask_global=&CDR(intern((char *)"*maxvar-mask*",13));
  predsymb_mask_global=&CDR(intern((char *)"*predsymb-mask*",15));
  fnsymb_shift_global=&CDR(intern((char *)"*fnsymb-shift*",14));
  fnsymb_mask_global=&CDR(intern((char *)"*fnsymb-mask*",13));
  signedfnsymb_mask_global=&CDR(intern((char *)"*signedfnsymb-mask*",19));
  sgn_mask_global=&CDR(intern((char *)"*sgn-mask*",10));
  var_touched_table_global=&CDR(intern((char *)"*var-touched-table*",19));
  var_val_table_global=&CDR(intern((char *)"*var-val-table*",15));
  z_var_mask_global=&CDR(intern((char *)"*z-var-mask*",12));
  y_var_mask_global=&CDR(intern((char *)"*y-var-mask*",12));
  var_nr_mask_global=&CDR(intern((char *)"*var-nr-mask*",13));
  no_occ_folllit_var_mask_global=&CDR(intern((char *)"*no-occ-folllit-var-mask*",25));
  single_occ_clause_var_mask_global=&CDR(intern((char *)"*single-occ-clause-var-mask*",28));
  no_occ_otherlit_var_mask_global=&CDR(intern((char *)"*no-occ-otherlit-var-mask*",26));
  single_occ_lit_var_mask_global=&CDR(intern((char *)"*single-occ-lit-var-mask*",25));
  var_info_mask_global=&CDR(intern((char *)"*var-info-mask*",15));
  param_tolitnr_global=&CDR(intern((char *)"*param-tolitnr*",15));
  param_fromlitnr_global=&CDR(intern((char *)"*param-fromlitnr*",17));
  param_tohist_global=&CDR(intern((char *)"*param-tohist*",14));
  param_fromhist_global=&CDR(intern((char *)"*param-fromhist*",16));
  param_xclmaxvar_global=&CDR(intern((char *)"*param-xclmaxvar*",17));
  param_yclmaxvar_global=&CDR(intern((char *)"*param-yclmaxvar*",17));
  param_from_is_y_flag_global=&CDR(intern((char *)"*param-from-is-y-flag*",22));
  param_frominf_global=&CDR(intern((char *)"*param-frominf*",15));
  param_toinf_global=&CDR(intern((char *)"*param-toinf*",13));
  param_right_arg_global=&CDR(intern((char *)"*param-right-arg*",17));
  param_left_arg_global=&CDR(intern((char *)"*param-left-arg*",16));
  param_fromcl_global=&CDR(intern((char *)"*param-fromcl*",14));
  param_tocl_global=&CDR(intern((char *)"*param-tocl*",12));
  param_eqlit_global=&CDR(intern((char *)"*param-eqlit*",13));
  param_tolit_global=&CDR(intern((char *)"*param-tolit*",13));
  nonunit_res_global=&CDR(intern((char *)"*nonunit-res*",13));
  nonunit_discr_flag_global=&CDR(intern((char *)"*nonunit-discr-flag*",20));
  overdouble_discr_flag_global=&CDR(intern((char *)"*overdouble-discr-flag*",23));
  cur_clause_global=&CDR(intern((char *)"*cur-clause*",12));
  cur_lit_global=&CDR(intern((char *)"*cur-lit*",9));
  noncomputable_ans_preds_global=&CDR(intern((char *)"*noncomputable-ans-preds*",25));
  noncomputable_ans_funs_global=&CDR(intern((char *)"*noncomputable-ans-funs*",24));
  one_step_hyper_phase_global=&CDR(intern((char *)"*one-step-hyper-phase*",22));
  compare_ground_litcdr_equal_flag_global=&CDR(intern((char *)"*compare-ground-litcdr-equal-flag*",34));
  ground_check_res_global=&CDR(intern((char *)"*ground-check-res*",18));
  used_demodulators_global=&CDR(intern((char *)"*used-demodulators*",19));
  subsumed_clauses_global=&CDR(intern((char *)"*subsumed-clauses*",18));
  subs_factor_derived_flag_global=&CDR(intern((char *)"*subs-factor-derived-flag*",26));
  prohibit_subs_clnr_global=&CDR(intern((char *)"*prohibit-subs-clnr*",20));
  stopsubsuming_flag_global=&CDR(intern((char *)"*stopsubsuming-flag*",20));
  subsuming_clause_global=&CDR(intern((char *)"*subsuming-clause*",18));
  collected_vars_global=&CDR(intern((char *)"*collected-vars*",16));
  gcl_varsstack_global=&CDR(intern((char *)"*gcl-varsstack*",15));
  cut_clauses_global=&CDR(intern((char *)"*cut-clauses*",13));
  new_var_names_global=&CDR(intern((char *)"*new-var-names*",15));
  too_many_vars_flag_global=&CDR(intern((char *)"*too-many-vars-flag*",20));
  answer_history_global=&CDR(intern((char *)"*answer-history*",16));
  answer_cl_global=&CDR(intern((char *)"*answer-cl*",11));
  foundflag_global=&CDR(intern((char *)"*foundflag*",11));
  listofnull_global=&CDR(intern((char *)"*listofnull*",12));
  timelimit_global=&CDR(intern((char *)"*timelimit*",11));
  unassigned_global=&CDR(intern((char *)"*unassigned*",12));
  maxconst_global=&CDR(intern((char *)"*maxconst*",10));
  minconst_global=&CDR(intern((char *)"*minconst*",10));
  max_y_var_global=&CDR(intern((char *)"*max-y-var*",11));
  max_x_var_global=&CDR(intern((char *)"*max-x-var*",11));
  maxvar_global=&CDR(intern((char *)"*maxvar*",8));
  max_nr_of_vars_in_clause_global=&CDR(intern((char *)"*max-nr-of-vars-in-clause*",26));
  not_enough_time_symb=CAR(intern((char *)"not-enough-time",15));
  binres_symb=CAR(intern((char *)"binres",6));
  literal_symb=CAR(intern((char *)"literal",7));
  demod_symb=CAR(intern((char *)"demod",5));
  hyper_symb=CAR(intern((char *)"hyper",5));
  input_symb=CAR(intern((char *)"input",5));
  para_symb=CAR(intern((char *)"para",4));
  unknown_symb=CAR(intern((char *)"unknown",7));
  backdemod_symb=CAR(intern((char *)"backdemod",9));
  factor_symb=CAR(intern((char *)"factor",6));
  c_symb=CAR(intern((char *)"c",1));
  _pred__symb=CAR(intern((char *)"?",1));
  factor_s_symb=CAR(intern((char *)"factor_s",8));
  hyper_s_symb=CAR(intern((char *)"hyper_s",7));
  binary_s_symb=CAR(intern((char *)"binary_s",8));
  binary_symb=CAR(intern((char *)"binary",6));
  old_symb=CAR(intern((char *)"old",3));
  _pred__pred__symb=CAR(intern((char *)"??",2));
  dummy_symb=CAR(intern((char *)"dummy",5));
  fact_symb=CAR(intern((char *)"fact",4));
  set_symb=CAR(intern((char *)"set",3));
  clear_symb=CAR(intern((char *)"clear",5));
  assign_symb=CAR(intern((char *)"assign",6));
  checkpoints_symb=CAR(intern((char *)"checkpoints",11));
  max_kept_symb=CAR(intern((char *)"max_kept",8));
  max_seconds_symb=CAR(intern((char *)"max_seconds",11));
  print_level_symb=CAR(intern((char *)"print_level",11));
  max_literals_symb=CAR(intern((char *)"max_literals",12));
  max_weight_symb=CAR(intern((char *)"max_weight",10));
  max_depth_symb=CAR(intern((char *)"max_depth",9));
  demodulate_symb=CAR(intern((char *)"demodulate",10));
  auto_symb=CAR(intern((char *)"auto",4));
  hyper_res_symb=CAR(intern((char *)"hyper_res",9));
  hyper_order_res_symb=CAR(intern((char *)"hyper_order_res",15));
  binary_res_symb=CAR(intern((char *)"binary_res",10));
  binary_order_res_symb=CAR(intern((char *)"binary_order_res",16));
  binary_nameorder_res_symb=CAR(intern((char *)"binary_nameorder_res",20));
  binary_weightorder_res_symb=CAR(intern((char *)"binary_weightorder_res",22));
  binary_posweightorder_res_symb=CAR(intern((char *)"binary_posweightorder_res",25));
  binary_hypersos_res_symb=CAR(intern((char *)"binary_hypersos_res",19));
  binary_unit_res_symb=CAR(intern((char *)"binary_unit_res",15));
  binary_posweightunit_res_symb=CAR(intern((char *)"binary_posweightunit_res",24));
  binary_synth_res_symb=CAR(intern((char *)"binary_synth_res",16));
  eq_order_lex_symb=CAR(intern((char *)"eq_order_lex",12));
  eq_order_depth_symb=CAR(intern((char *)"eq_order_depth",14));
  check_hypercontra_symb=CAR(intern((char *)"check_hypercontra",17));
  back_demodulate_symb=CAR(intern((char *)"back_demodulate",15));
  split_symb=CAR(intern((char *)"split",5));
  wall_time_symb=CAR(intern((char *)"wall_time",9));
  print_tracechar_symb=CAR(intern((char *)"print_tracechar",15));
  print_debug_symb=CAR(intern((char *)"print_debug",11));
  prolog_style_variables_symb=CAR(intern((char *)"prolog_style_variables",22));
  sos_symb=CAR(intern((char *)"sos",3));
  usable_symb=CAR(intern((char *)"usable",6));
  axioms_symb=CAR(intern((char *)"axioms",6));
  demodulators_symb=CAR(intern((char *)"demodulators",12));
  command_symb=CAR(intern((char *)"command",7));
  end_of_list_symb=CAR(intern((char *)"end_of_list",11));
  prohibit_ans_pred_symb=CAR(intern((char *)"prohibit_ans_pred",17));
  prohibit_ans_fun_symb=CAR(intern((char *)"prohibit_ans_fun",16));
  prohibit_ans_const_symb=CAR(intern((char *)"prohibit_ans_const",18));
  list_symb=CAR(intern((char *)"list",4));
  _equal__symb=CAR(intern((char *)"=",1));
  _excl__equal__symb=CAR(intern((char *)"!=",2));
  _excl__symb=CAR(intern((char *)"!",1));
  binary_unit_symb=CAR(intern((char *)"binary-unit",11));
  binary_order_symb=CAR(intern((char *)"binary-order",12));
  binary_nameorder_symb=CAR(intern((char *)"binary-nameorder",16));
  hyper_order_symb=CAR(intern((char *)"hyper-order",11));
  binary_hyper_sos_symb=CAR(intern((char *)"binary-hyper-sos",16));
  hyper_wos_symb=CAR(intern((char *)"hyper-wos",9));
  binary_unit_depth_symb=CAR(intern((char *)"binary-unit-depth",17));
  binary_unit_depth_sospref_symb=CAR(intern((char *)"binary-unit-depth-sospref",25));
  binary_unit_depth_backdemod_symb=CAR(intern((char *)"binary-unit-depth-backdemod",27));
  binary_unit_lex_backdemod_symb=CAR(intern((char *)"binary-unit-lex-backdemod",25));
  binary_unit_lex_symb=CAR(intern((char *)"binary-unit-lex",15));
  quit_symb=CAR(intern((char *)"quit",4));
  _dot__dot__dot__symb=CAR(intern((char *)"...",3));
  ans_symb=CAR(intern((char *)"ans",3));
  equal_symb=CAR(intern((char *)"equal",5));
  eq_symb=CAR(intern((char *)"eq",2));
  case_symb=CAR(intern((char *)"case",4));
  if_symb=CAR(intern((char *)"if",2));
  inh_symb=CAR(intern((char *)"inh",3));
  idsubst_symb=CAR(intern((char *)"idsubst",7));
  idsubst_prim_symb=CAR(intern((char *)"idsubst-prim",12));
  idrefl_symb=CAR(intern((char *)"idrefl",6));
  lambda_symb=CAR(intern((char *)"lambda",6));
  _star__symb=CAR(intern((char *)"*",1));
  lit_demodulators_symb=CAR(intern((char *)"lit-demodulators",16));
  x_symb=CAR(intern((char *)"x",1));
  y_symb=CAR(intern((char *)"y",1));
  z_symb=CAR(intern((char *)"z",1));
  u_symb=CAR(intern((char *)"u",1));
  v_symb=CAR(intern((char *)"v",1));
  w_symb=CAR(intern((char *)"w",1));
  protect_constants_resbase=&CDR(intern((char *)"protect_constants_resbase",25));
  GLOBAL(protect_constants_resbase)=EOL;
  const_1=makfromstr((char *)"clauses back-subsumed:",22);
  GLOBAL(protect_constants_resbase)=cons(const_1,GLOBAL(protect_constants_resbase));
  const_2=makfromstr((char *)"*",1);
  GLOBAL(protect_constants_resbase)=cons(const_2,GLOBAL(protect_constants_resbase));
  const_3=makfromstr((char *)"!!!!!!! ",8);
  GLOBAL(protect_constants_resbase)=cons(const_3,GLOBAL(protect_constants_resbase));
  const_4=makfromstr((char *)"!!!!!!! ",8);
  GLOBAL(protect_constants_resbase)=cons(const_4,GLOBAL(protect_constants_resbase));
  const_5=makfromstr((char *)"proof attempt stopped: time limit",33);
  GLOBAL(protect_constants_resbase)=cons(const_5,GLOBAL(protect_constants_resbase));
  const_6=makfromstr((char *)"proof attempt stopped: sos exhausted",36);
  GLOBAL(protect_constants_resbase)=cons(const_6,GLOBAL(protect_constants_resbase));
  const_7=makfromstr((char *)"switching to mixed prefer-short strategy",40);
  GLOBAL(protect_constants_resbase)=cons(const_7,GLOBAL(protect_constants_resbase));
  const_8=makfromstr((char *)"switching to pure prefer-short strategy",39);
  GLOBAL(protect_constants_resbase)=cons(const_8,GLOBAL(protect_constants_resbase));
  const_9=makfromstr((char *)"switching to hyper-sos strategy",31);
  GLOBAL(protect_constants_resbase)=cons(const_9,GLOBAL(protect_constants_resbase));
  const_10=makfromstr((char *)"switching to unit restriction, pure short pref",46);
  GLOBAL(protect_constants_resbase)=cons(const_10,GLOBAL(protect_constants_resbase));
  const_11=makfromstr((char *)"switching to backward hyper-analysis",36);
  GLOBAL(protect_constants_resbase)=cons(const_11,GLOBAL(protect_constants_resbase));
  const_12=makfromstr((char *)"switching to full hyper-contradiction-check",43);
  GLOBAL(protect_constants_resbase)=cons(const_12,GLOBAL(protect_constants_resbase));
  const_13=makfromstr((char *)"continuing search with hyper-contradiction-check",48);
  GLOBAL(protect_constants_resbase)=cons(const_13,GLOBAL(protect_constants_resbase));
  const_14=makfromstr((char *)"******* ",8);
  GLOBAL(protect_constants_resbase)=cons(const_14,GLOBAL(protect_constants_resbase));
  const_15=makfromstr((char *)"-th given clause: ",18);
  GLOBAL(protect_constants_resbase)=cons(const_15,GLOBAL(protect_constants_resbase));
  const_16=makfromstr((char *)"++++++ given clause in debug form: ",35);
  GLOBAL(protect_constants_resbase)=cons(const_16,GLOBAL(protect_constants_resbase));
  const_17=cons(cons(cons(MAKINUM(0),EOL),EOL),EOL);
  GLOBAL(protect_constants_resbase)=cons(const_17,GLOBAL(protect_constants_resbase));
  const_18=makfromstr((char *)"Given cl candidate ",19);
  GLOBAL(protect_constants_resbase)=cons(const_18,GLOBAL(protect_constants_resbase));
  const_19=makfromstr((char *)" is subsumed by ",16);
  GLOBAL(protect_constants_resbase)=cons(const_19,GLOBAL(protect_constants_resbase));
  const_20=makfromstr((char *)"...... usable clause in pure form: ",35);
  GLOBAL(protect_constants_resbase)=cons(const_20,GLOBAL(protect_constants_resbase));
  const_21=makfromstr((char *)",,,,,, usable  clause in debug form: ",37);
  GLOBAL(protect_constants_resbase)=cons(const_21,GLOBAL(protect_constants_resbase));
  const_22=makfromstr((char *)"raw cl by binary; parents: ",27);
  GLOBAL(protect_constants_resbase)=cons(const_22,GLOBAL(protect_constants_resbase));
  const_23=makfromstr((char *)"raw cl by binary; parents: ",27);
  GLOBAL(protect_constants_resbase)=cons(const_23,GLOBAL(protect_constants_resbase));
  const_24=makfromstr((char *)"vars after one-step res:",24);
  GLOBAL(protect_constants_resbase)=cons(const_24,GLOBAL(protect_constants_resbase));
  const_25=makfromstr((char *)"raw prepcl by hyper: parents: ",30);
  GLOBAL(protect_constants_resbase)=cons(const_25,GLOBAL(protect_constants_resbase));
  const_26=makfromstr((char *)"raw clause derived by param; ",29);
  GLOBAL(protect_constants_resbase)=cons(const_26,GLOBAL(protect_constants_resbase));
  const_27=makfromstr((char *)"to and from parents, fromlit:",29);
  GLOBAL(protect_constants_resbase)=cons(const_27,GLOBAL(protect_constants_resbase));
  const_28=makfromstr((char *)"handle-derived-inf-cl-pair entered with:",40);
  GLOBAL(protect_constants_resbase)=cons(const_28,GLOBAL(protect_constants_resbase));
  const_29=makfromstr((char *)"********* EMPTY CLAUSE DERIVED *********",40);
  GLOBAL(protect_constants_resbase)=cons(const_29,GLOBAL(protect_constants_resbase));
  const_30=makfromstr((char *)"after exiting unit-handle-cl!:",30);
  GLOBAL(protect_constants_resbase)=cons(const_30,GLOBAL(protect_constants_resbase));
  const_31=makfromstr((char *)"removed for failing user limits",31);
  GLOBAL(protect_constants_resbase)=cons(const_31,GLOBAL(protect_constants_resbase));
  const_32=makfromstr((char *)"********* EMPTY CLAUSE DERIVED *********",40);
  GLOBAL(protect_constants_resbase)=cons(const_32,GLOBAL(protect_constants_resbase));
  const_33=makfromstr((char *)"derived clause after 2-nd order deco:",37);
  GLOBAL(protect_constants_resbase)=cons(const_33,GLOBAL(protect_constants_resbase));
  const_34=makfromstr((char *)"**** EMPTY CLAUSE DERIVED ****",30);
  GLOBAL(protect_constants_resbase)=cons(const_34,GLOBAL(protect_constants_resbase));
  const_35=makfromstr((char *)"remaining part of nucleon in pure form:",39);
  GLOBAL(protect_constants_resbase)=cons(const_35,GLOBAL(protect_constants_resbase));
  const_36=makfromstr((char *)"kept clause in debug form:",26);
  GLOBAL(protect_constants_resbase)=cons(const_36,GLOBAL(protect_constants_resbase));
  const_37=makfromstr((char *)"kept clause in pure form:",25);
  GLOBAL(protect_constants_resbase)=cons(const_37,GLOBAL(protect_constants_resbase));
  const_38=makfromstr((char *)"kept clause in debug form:",26);
  GLOBAL(protect_constants_resbase)=cons(const_38,GLOBAL(protect_constants_resbase));
  const_39=makfromstr((char *)"equality produces a new demodulator:",36);
  GLOBAL(protect_constants_resbase)=cons(const_39,GLOBAL(protect_constants_resbase));
  const_40=makfromstr((char *)"demodulator in debug form:",26);
  GLOBAL(protect_constants_resbase)=cons(const_40,GLOBAL(protect_constants_resbase));
  const_41=cons(EOL,EOL);
  GLOBAL(protect_constants_resbase)=cons(const_41,GLOBAL(protect_constants_resbase));
  const_42=makfromstr((char *)"splittable clause: ",19);
  GLOBAL(protect_constants_resbase)=cons(const_42,GLOBAL(protect_constants_resbase));
  const_43=makfromstr((char *)"back-demodulate-usable started",30);
  GLOBAL(protect_constants_resbase)=cons(const_43,GLOBAL(protect_constants_resbase));
  const_44=makfromstr((char *)"back-demodulate-usable ended",28);
  GLOBAL(protect_constants_resbase)=cons(const_44,GLOBAL(protect_constants_resbase));
  const_45=makfromstr((char *)"back-demodulation parent: ",26);
  GLOBAL(protect_constants_resbase)=cons(const_45,GLOBAL(protect_constants_resbase));
  const_46=makfromstr((char *)"back-demodulation result: ",26);
  GLOBAL(protect_constants_resbase)=cons(const_46,GLOBAL(protect_constants_resbase));
  const_47=makfromstr((char *)"used demodulators: ",19);
  GLOBAL(protect_constants_resbase)=cons(const_47,GLOBAL(protect_constants_resbase));
  const_48=makfromstr((char *)"backdemod result in debug form:",31);
  GLOBAL(protect_constants_resbase)=cons(const_48,GLOBAL(protect_constants_resbase));
  const_49=makfromstr((char *)"******* starting to factor input sos ******",43);
  GLOBAL(protect_constants_resbase)=cons(const_49,GLOBAL(protect_constants_resbase));
  const_50=makfromstr((char *)"******* input sos has been factored ******",42);
  GLOBAL(protect_constants_resbase)=cons(const_50,GLOBAL(protect_constants_resbase));
  const_51=cons(EOL,BOOL_F);
  GLOBAL(protect_constants_resbase)=cons(const_51,GLOBAL(protect_constants_resbase));
  const_52=cons(EOL,BOOL_F);
  GLOBAL(protect_constants_resbase)=cons(const_52,GLOBAL(protect_constants_resbase));
  const_53=cons(EOL,BOOL_F);
  GLOBAL(protect_constants_resbase)=cons(const_53,GLOBAL(protect_constants_resbase));
  const_54=cons(EOL,BOOL_F);
  GLOBAL(protect_constants_resbase)=cons(const_54,GLOBAL(protect_constants_resbase));
  const_55=makfromstr((char *)"the derived clause subsumed by unit:",36);
  GLOBAL(protect_constants_resbase)=cons(const_55,GLOBAL(protect_constants_resbase));
  const_56=makfromstr((char *)"_",1);
  GLOBAL(protect_constants_resbase)=cons(const_56,GLOBAL(protect_constants_resbase));
  const_57=makfromstr((char *)"discr tree used for unit cutoff:",32);
  GLOBAL(protect_constants_resbase)=cons(const_57,GLOBAL(protect_constants_resbase));
  const_58=makfromstr((char *)"proper unit cutoff with the following unit(s):",46);
  GLOBAL(protect_constants_resbase)=cons(const_58,GLOBAL(protect_constants_resbase));
  const_59=makfromstr((char *)"starting resolve-unify-cutoff with:",35);
  GLOBAL(protect_constants_resbase)=cons(const_59,GLOBAL(protect_constants_resbase));
  const_60=makfromstr((char *)":",1);
  GLOBAL(protect_constants_resbase)=cons(const_60,GLOBAL(protect_constants_resbase));
  const_61=makfromstr((char *)" ",1);
  GLOBAL(protect_constants_resbase)=cons(const_61,GLOBAL(protect_constants_resbase));
  const_62=makfromstr((char *)":",1);
  GLOBAL(protect_constants_resbase)=cons(const_62,GLOBAL(protect_constants_resbase));
  const_63=makfromstr((char *)" ",1);
  GLOBAL(protect_constants_resbase)=cons(const_63,GLOBAL(protect_constants_resbase));
  const_64=makfromstr((char *)"double cutoff with the following cls:",37);
  GLOBAL(protect_constants_resbase)=cons(const_64,GLOBAL(protect_constants_resbase));
  const_65=makfromstr((char *)"timer checkpoints: ",19);
  GLOBAL(protect_constants_resbase)=cons(const_65,GLOBAL(protect_constants_resbase));
  const_66=makfromstr((char *)" [",2);
  GLOBAL(protect_constants_resbase)=cons(const_66,GLOBAL(protect_constants_resbase));
  const_67=makfromstr((char *)"] ",2);
  GLOBAL(protect_constants_resbase)=cons(const_67,GLOBAL(protect_constants_resbase));
  const_68=makfromstr((char *)"contradiction.",14);
  GLOBAL(protect_constants_resbase)=cons(const_68,GLOBAL(protect_constants_resbase));
  const_69=makfromstr((char *)",",1);
  GLOBAL(protect_constants_resbase)=cons(const_69,GLOBAL(protect_constants_resbase));
  const_70=makfromstr((char *)",",1);
  GLOBAL(protect_constants_resbase)=cons(const_70,GLOBAL(protect_constants_resbase));
  const_71=makfromstr((char *)",",1);
  GLOBAL(protect_constants_resbase)=cons(const_71,GLOBAL(protect_constants_resbase));
  const_72=makfromstr((char *)".",1);
  GLOBAL(protect_constants_resbase)=cons(const_72,GLOBAL(protect_constants_resbase));
  const_73=makfromstr((char *)"unknown history-constructor: ",29);
  GLOBAL(protect_constants_resbase)=cons(const_73,GLOBAL(protect_constants_resbase));
  const_74=makfromstr((char *)"by ",3);
  GLOBAL(protect_constants_resbase)=cons(const_74,GLOBAL(protect_constants_resbase));
  const_75=makfromstr((char *)" from ",6);
  GLOBAL(protect_constants_resbase)=cons(const_75,GLOBAL(protect_constants_resbase));
  const_76=makfromstr((char *)" with ",6);
  GLOBAL(protect_constants_resbase)=cons(const_76,GLOBAL(protect_constants_resbase));
  const_77=makfromstr((char *)"by binary from ",15);
  GLOBAL(protect_constants_resbase)=cons(const_77,GLOBAL(protect_constants_resbase));
  const_78=makfromstr((char *)" and ",5);
  GLOBAL(protect_constants_resbase)=cons(const_78,GLOBAL(protect_constants_resbase));
  const_79=makfromstr((char *)"by para from ",13);
  GLOBAL(protect_constants_resbase)=cons(const_79,GLOBAL(protect_constants_resbase));
  const_80=makfromstr((char *)" into ",6);
  GLOBAL(protect_constants_resbase)=cons(const_80,GLOBAL(protect_constants_resbase));
  const_81=makfromstr((char *)" at place ",10);
  GLOBAL(protect_constants_resbase)=cons(const_81,GLOBAL(protect_constants_resbase));
  const_82=makfromstr((char *)"by factor from ",15);
  GLOBAL(protect_constants_resbase)=cons(const_82,GLOBAL(protect_constants_resbase));
  const_83=makfromstr((char *)" literals ",10);
  GLOBAL(protect_constants_resbase)=cons(const_83,GLOBAL(protect_constants_resbase));
  const_84=makfromstr((char *)"input: ",7);
  GLOBAL(protect_constants_resbase)=cons(const_84,GLOBAL(protect_constants_resbase));
  const_85=makfromstr((char *)": ",2);
  GLOBAL(protect_constants_resbase)=cons(const_85,GLOBAL(protect_constants_resbase));
  const_86=makfromstr((char *)"unknown history-constructor: ",29);
  GLOBAL(protect_constants_resbase)=cons(const_86,GLOBAL(protect_constants_resbase));
  const_87=makfromstr((char *)" we get:",8);
  GLOBAL(protect_constants_resbase)=cons(const_87,GLOBAL(protect_constants_resbase));
  const_88=makfromstr((char *)": ",2);
  GLOBAL(protect_constants_resbase)=cons(const_88,GLOBAL(protect_constants_resbase));
  const_89=makfromstr((char *)"input clause not found: ",24);
  GLOBAL(protect_constants_resbase)=cons(const_89,GLOBAL(protect_constants_resbase));
  const_90=makfromstr((char *)"cannot unify for paramodulation:",32);
  GLOBAL(protect_constants_resbase)=cons(const_90,GLOBAL(protect_constants_resbase));
  const_91=makfromstr((char *)"cannot unify for paramodulation:",32);
  GLOBAL(protect_constants_resbase)=cons(const_91,GLOBAL(protect_constants_resbase));
  const_92=makfromstr((char *)"unification during answer-construction failed:",46);
  GLOBAL(protect_constants_resbase)=cons(const_92,GLOBAL(protect_constants_resbase));
  const_93=makfromstr((char *)"the derived clause removed as a tautology",41);
  GLOBAL(protect_constants_resbase)=cons(const_93,GLOBAL(protect_constants_resbase));
  const_94=makfromstr((char *)"T",1);
  GLOBAL(protect_constants_resbase)=cons(const_94,GLOBAL(protect_constants_resbase));
  const_95=makfromstr((char *)"statistics: ---------------------------",39);
  GLOBAL(protect_constants_resbase)=cons(const_95,GLOBAL(protect_constants_resbase));
  const_96=makfromstr((char *)" given clauses:    ",19);
  GLOBAL(protect_constants_resbase)=cons(const_96,GLOBAL(protect_constants_resbase));
  const_97=makfromstr((char *)" derived clauses:   ",20);
  GLOBAL(protect_constants_resbase)=cons(const_97,GLOBAL(protect_constants_resbase));
  const_98=makfromstr((char *)" kept clauses:      ",20);
  GLOBAL(protect_constants_resbase)=cons(const_98,GLOBAL(protect_constants_resbase));
  const_99=makfromstr((char *)" kept mid-nuclei:   ",20);
  GLOBAL(protect_constants_resbase)=cons(const_99,GLOBAL(protect_constants_resbase));
  const_100=makfromstr((char *)" kept new demods:   ",20);
  GLOBAL(protect_constants_resbase)=cons(const_100,GLOBAL(protect_constants_resbase));
  const_101=makfromstr((char *)" forw unit-subs:    ",20);
  GLOBAL(protect_constants_resbase)=cons(const_101,GLOBAL(protect_constants_resbase));
  const_102=makfromstr((char *)" forw double-subs: ",19);
  GLOBAL(protect_constants_resbase)=cons(const_102,GLOBAL(protect_constants_resbase));
  const_103=makfromstr((char *)" forw overdouble-subs: ",23);
  GLOBAL(protect_constants_resbase)=cons(const_103,GLOBAL(protect_constants_resbase));
  const_104=makfromstr((char *)" backward subs:     ",20);
  GLOBAL(protect_constants_resbase)=cons(const_104,GLOBAL(protect_constants_resbase));
  const_105=makfromstr((char *)" fast unit cutoff:  ",20);
  GLOBAL(protect_constants_resbase)=cons(const_105,GLOBAL(protect_constants_resbase));
  const_106=makfromstr((char *)" full unit cutoff:  ",20);
  GLOBAL(protect_constants_resbase)=cons(const_106,GLOBAL(protect_constants_resbase));
  const_107=makfromstr((char *)" dbl  unit cutoff:  ",20);
  GLOBAL(protect_constants_resbase)=cons(const_107,GLOBAL(protect_constants_resbase));
  const_108=makfromstr((char *)" real runtime    :  ",20);
  GLOBAL(protect_constants_resbase)=cons(const_108,GLOBAL(protect_constants_resbase));
  const_109=makfromstr((char *)" process. runtime:  ",20);
  GLOBAL(protect_constants_resbase)=cons(const_109,GLOBAL(protect_constants_resbase));
  const_110=makfromstr((char *)"specific non-discr-tree subsumption statistics: ",48);
  GLOBAL(protect_constants_resbase)=cons(const_110,GLOBAL(protect_constants_resbase));
  const_111=makfromstr((char *)" tried:           ",18);
  GLOBAL(protect_constants_resbase)=cons(const_111,GLOBAL(protect_constants_resbase));
  const_112=makfromstr((char *)" length fails:    ",18);
  GLOBAL(protect_constants_resbase)=cons(const_112,GLOBAL(protect_constants_resbase));
  const_113=makfromstr((char *)" strength fails:  ",18);
  GLOBAL(protect_constants_resbase)=cons(const_113,GLOBAL(protect_constants_resbase));
  const_114=makfromstr((char *)" predlist fails:  ",18);
  GLOBAL(protect_constants_resbase)=cons(const_114,GLOBAL(protect_constants_resbase));
  const_115=makfromstr((char *)" aux str. fails:  ",18);
  GLOBAL(protect_constants_resbase)=cons(const_115,GLOBAL(protect_constants_resbase));
  const_116=makfromstr((char *)" by-lit fails:    ",18);
  GLOBAL(protect_constants_resbase)=cons(const_116,GLOBAL(protect_constants_resbase));
  const_117=makfromstr((char *)" full subs tried: ",18);
  GLOBAL(protect_constants_resbase)=cons(const_117,GLOBAL(protect_constants_resbase));
  const_118=makfromstr((char *)" full subs fail:  ",18);
  GLOBAL(protect_constants_resbase)=cons(const_118,GLOBAL(protect_constants_resbase));
  const_119=makfromstr((char *)"answer-clause: ",15);
  GLOBAL(protect_constants_resbase)=cons(const_119,GLOBAL(protect_constants_resbase));
  const_120=makfromstr((char *)"time limit exhausted: proof search terminated.",46);
  GLOBAL(protect_constants_resbase)=cons(const_120,GLOBAL(protect_constants_resbase));
  const_121=makfromstr((char *)"search space exhausted.",23);
  GLOBAL(protect_constants_resbase)=cons(const_121,GLOBAL(protect_constants_resbase));
  const_122=makfromstr((char *)"jama.in",7);
  GLOBAL(protect_constants_resbase)=cons(const_122,GLOBAL(protect_constants_resbase));
  const_123=makfromstr((char *)"jama.in.tmp",11);
  GLOBAL(protect_constants_resbase)=cons(const_123,GLOBAL(protect_constants_resbase));
  const_124=makfromstr((char *)"syntax error in input file",26);
  GLOBAL(protect_constants_resbase)=cons(const_124,GLOBAL(protect_constants_resbase));
  const_125=makfromstr((char *)"syntax error in input file",26);
  GLOBAL(protect_constants_resbase)=cons(const_125,GLOBAL(protect_constants_resbase));
  const_126=makfromstr((char *)"syntax error in input file",26);
  GLOBAL(protect_constants_resbase)=cons(const_126,GLOBAL(protect_constants_resbase));
  const_127=makfromstr((char *)"syntax error in input file",26);
  GLOBAL(protect_constants_resbase)=cons(const_127,GLOBAL(protect_constants_resbase));
  const_128=makfromstr((char *)"syntax error in input file",26);
  GLOBAL(protect_constants_resbase)=cons(const_128,GLOBAL(protect_constants_resbase));
  const_129=makfromstr((char *)"-",1);
  GLOBAL(protect_constants_resbase)=cons(const_129,GLOBAL(protect_constants_resbase));
  const_130=makfromstr((char *)"syntax error in input file",26);
  GLOBAL(protect_constants_resbase)=cons(const_130,GLOBAL(protect_constants_resbase));
  const_131=makfromstr((char *)"syntax error in input file",26);
  GLOBAL(protect_constants_resbase)=cons(const_131,GLOBAL(protect_constants_resbase));
  const_132=makfromstr((char *)"syntax error in input file",26);
  GLOBAL(protect_constants_resbase)=cons(const_132,GLOBAL(protect_constants_resbase));
  const_133=makfromstr((char *)"syntax error in input file",26);
  GLOBAL(protect_constants_resbase)=cons(const_133,GLOBAL(protect_constants_resbase));
  const_134=makfromstr((char *)"-",1);
  GLOBAL(protect_constants_resbase)=cons(const_134,GLOBAL(protect_constants_resbase));
  const_135=makfromstr((char *)"-",1);
  GLOBAL(protect_constants_resbase)=cons(const_135,GLOBAL(protect_constants_resbase));
  const_136=makfromstr((char *)"syntax error in input file",26);
  GLOBAL(protect_constants_resbase)=cons(const_136,GLOBAL(protect_constants_resbase));
  const_137=makfromstr((char *)"syntax error in input file",26);
  GLOBAL(protect_constants_resbase)=cons(const_137,GLOBAL(protect_constants_resbase));
  const_138=makfromstr((char *)"r",1);
  GLOBAL(protect_constants_resbase)=cons(const_138,GLOBAL(protect_constants_resbase));
  const_139=makfromstr((char *)"w",1);
  GLOBAL(protect_constants_resbase)=cons(const_139,GLOBAL(protect_constants_resbase));
  const_140=makfromstr((char *)"could not open file: ",21);
  GLOBAL(protect_constants_resbase)=cons(const_140,GLOBAL(protect_constants_resbase));
  const_141=makfromstr((char *)"could not open file: ",21);
  GLOBAL(protect_constants_resbase)=cons(const_141,GLOBAL(protect_constants_resbase));
  const_142=makfromstr((char *)"r",1);
  GLOBAL(protect_constants_resbase)=cons(const_142,GLOBAL(protect_constants_resbase));
  const_143=makfromstr((char *)"Too many predicate symbs in the clause set",42);
  GLOBAL(protect_constants_resbase)=cons(const_143,GLOBAL(protect_constants_resbase));
  const_144=makfromstr((char *)"Too many function symbs in the clause set",41);
  GLOBAL(protect_constants_resbase)=cons(const_144,GLOBAL(protect_constants_resbase));
  const_145=makfromstr((char *)"Too many vars in the encountered clause",39);
  GLOBAL(protect_constants_resbase)=cons(const_145,GLOBAL(protect_constants_resbase));
  const_146=cons(MAKICHR('x'),cons(MAKICHR('y'),cons(MAKICHR('z'),cons(MAKICHR('u'),cons(MAKICHR('v'),cons(MAKICHR('w'),EOL))))));
  GLOBAL(protect_constants_resbase)=cons(const_146,GLOBAL(protect_constants_resbase));
  const_147=makfromstr((char *)"EMPTY CLAUSE.",13);
  GLOBAL(protect_constants_resbase)=cons(const_147,GLOBAL(protect_constants_resbase));
  const_148=makfromstr((char *)" | ",3);
  GLOBAL(protect_constants_resbase)=cons(const_148,GLOBAL(protect_constants_resbase));
  const_149=makfromstr((char *)"(",1);
  GLOBAL(protect_constants_resbase)=cons(const_149,GLOBAL(protect_constants_resbase));
  const_150=makfromstr((char *)")",1);
  GLOBAL(protect_constants_resbase)=cons(const_150,GLOBAL(protect_constants_resbase));
  const_151=makfromstr((char *)",",1);
  GLOBAL(protect_constants_resbase)=cons(const_151,GLOBAL(protect_constants_resbase));
  const_152=makfromstr((char *)"v",1);
  GLOBAL(protect_constants_resbase)=cons(const_152,GLOBAL(protect_constants_resbase));
  const_153=makfromstr((char *)"-",1);
  GLOBAL(protect_constants_resbase)=cons(const_153,GLOBAL(protect_constants_resbase));
  const_154=makfromstr((char *)"v",1);
  GLOBAL(protect_constants_resbase)=cons(const_154,GLOBAL(protect_constants_resbase));
  const_155=makfromstr((char *)"*unassigned*",12);
  GLOBAL(protect_constants_resbase)=cons(const_155,GLOBAL(protect_constants_resbase));
  const_156=makfromstr((char *)"'",1);
  GLOBAL(protect_constants_resbase)=cons(const_156,GLOBAL(protect_constants_resbase));
  const_157=makfromstr((char *)"'x",2);
  GLOBAL(protect_constants_resbase)=cons(const_157,GLOBAL(protect_constants_resbase));
  const_158=makfromstr((char *)"x",1);
  GLOBAL(protect_constants_resbase)=cons(const_158,GLOBAL(protect_constants_resbase));
  const_159=makfromstr((char *)"xvars and immediate refs and touched/not:",41);
  GLOBAL(protect_constants_resbase)=cons(const_159,GLOBAL(protect_constants_resbase));
  const_160=makfromstr((char *)" : ",3);
  GLOBAL(protect_constants_resbase)=cons(const_160,GLOBAL(protect_constants_resbase));
  const_161=makfromstr((char *)" : ",3);
  GLOBAL(protect_constants_resbase)=cons(const_161,GLOBAL(protect_constants_resbase));
  const_162=makfromstr((char *)"yvars and immediate refs and touched/not:",41);
  GLOBAL(protect_constants_resbase)=cons(const_162,GLOBAL(protect_constants_resbase));
  const_163=makfromstr((char *)" : ",3);
  GLOBAL(protect_constants_resbase)=cons(const_163,GLOBAL(protect_constants_resbase));
  const_164=makfromstr((char *)" : ",3);
  GLOBAL(protect_constants_resbase)=cons(const_164,GLOBAL(protect_constants_resbase));
  const_165=makfromstr((char *)"zvars and immediate refs:",25);
  GLOBAL(protect_constants_resbase)=cons(const_165,GLOBAL(protect_constants_resbase));
  const_166=makfromstr((char *)" : ",3);
  GLOBAL(protect_constants_resbase)=cons(const_166,GLOBAL(protect_constants_resbase));
  const_167=makfromstr((char *)"ERROR: ",7);
  GLOBAL(protect_constants_resbase)=cons(const_167,GLOBAL(protect_constants_resbase));
  const_168=makfromstr((char *)" ",1);
  GLOBAL(protect_constants_resbase)=cons(const_168,GLOBAL(protect_constants_resbase));
  const_169=makfromstr((char *)"input demodulators: ",20);
  GLOBAL(protect_constants_resbase)=cons(const_169,GLOBAL(protect_constants_resbase));
  const_170=makfromstr((char *)"input literal demodulators: ",28);
  GLOBAL(protect_constants_resbase)=cons(const_170,GLOBAL(protect_constants_resbase));
  const_171=makfromstr((char *)"input sos: ",11);
  GLOBAL(protect_constants_resbase)=cons(const_171,GLOBAL(protect_constants_resbase));
  const_172=makfromstr((char *)"input usable: ",14);
  GLOBAL(protect_constants_resbase)=cons(const_172,GLOBAL(protect_constants_resbase));
  const_173=cons(cons(hyper_symb,cons(MAKINUM(3),EOL)),cons(cons(binary_symb,cons(MAKINUM(4),EOL)),EOL));
  GLOBAL(protect_constants_resbase)=cons(const_173,GLOBAL(protect_constants_resbase));
  const_174=makfromstr((char *)"starting to make-input-clause on sos:",37);
  GLOBAL(protect_constants_resbase)=cons(const_174,GLOBAL(protect_constants_resbase));
  const_175=makfromstr((char *)"finished make-input-clause:",27);
  GLOBAL(protect_constants_resbase)=cons(const_175,GLOBAL(protect_constants_resbase));
  const_176=makfromstr((char *)"Error: no sos-list given.",25);
  GLOBAL(protect_constants_resbase)=cons(const_176,GLOBAL(protect_constants_resbase));
  const_177=makfromstr((char *)"demodulators: ",14);
  GLOBAL(protect_constants_resbase)=cons(const_177,GLOBAL(protect_constants_resbase));
  const_178=makfromstr((char *)"demodulators in debug form: ",28);
  GLOBAL(protect_constants_resbase)=cons(const_178,GLOBAL(protect_constants_resbase));
  const_179=makfromstr((char *)"literal demodulators: ",22);
  GLOBAL(protect_constants_resbase)=cons(const_179,GLOBAL(protect_constants_resbase));
  const_180=makfromstr((char *)"literal demodulators in debug form: ",36);
  GLOBAL(protect_constants_resbase)=cons(const_180,GLOBAL(protect_constants_resbase));
  const_181=makfromstr((char *)"clauses in usable: ",19);
  GLOBAL(protect_constants_resbase)=cons(const_181,GLOBAL(protect_constants_resbase));
  const_182=makfromstr((char *)"usable in debug form: ",22);
  GLOBAL(protect_constants_resbase)=cons(const_182,GLOBAL(protect_constants_resbase));
  const_183=makfromstr((char *)"clauses in sos: ",16);
  GLOBAL(protect_constants_resbase)=cons(const_183,GLOBAL(protect_constants_resbase));
  const_184=makfromstr((char *)"sos in debug form: ",19);
  GLOBAL(protect_constants_resbase)=cons(const_184,GLOBAL(protect_constants_resbase));
  const_185=cons(cons(hyper_symb,cons(MAKINUM(5),cons(BOOL_T,EOL))),cons(cons(binary_symb,cons(MAKINUM(10),cons(BOOL_T,EOL))),cons(cons(binary_unit_symb,cons(MAKINUM(10),cons(BOOL_T,EOL))),cons(cons(binary_unit_symb,cons(MAKINUM(10),cons(BOOL_F,EOL))),cons(cons(binary_order_symb,cons(MAKINUM(10),cons(BOOL_F,EOL))),cons(cons(binary_nameorder_symb,cons(MAKINUM(10),cons(BOOL_F,EOL))),cons(cons(hyper_order_symb,cons(MAKINUM(30),cons(BOOL_F,EOL))),cons(cons(binary_symb,cons(MAKINUM(30),cons(BOOL_T,EOL))),cons(cons(binary_symb,cons(MAKINUM(50),cons(BOOL_F,EOL))),EOL)))))))));
  GLOBAL(protect_constants_resbase)=cons(const_185,GLOBAL(protect_constants_resbase));
  const_186=cons(binary_symb,cons(MAKINUM(5),cons(BOOL_T,EOL)));
  GLOBAL(protect_constants_resbase)=cons(const_186,GLOBAL(protect_constants_resbase));
  const_187=makfromstr((char *)"old unit clauses discarded",26);
  GLOBAL(protect_constants_resbase)=cons(const_187,GLOBAL(protect_constants_resbase));
  const_188=makfromstr((char *)"using hyperresolution",21);
  GLOBAL(protect_constants_resbase)=cons(const_188,GLOBAL(protect_constants_resbase));
  const_189=makfromstr((char *)"using binary resolution",23);
  GLOBAL(protect_constants_resbase)=cons(const_189,GLOBAL(protect_constants_resbase));
  const_190=makfromstr((char *)"using term-depth-order strategy",31);
  GLOBAL(protect_constants_resbase)=cons(const_190,GLOBAL(protect_constants_resbase));
  const_191=makfromstr((char *)"using pred-name-order strategy",30);
  GLOBAL(protect_constants_resbase)=cons(const_191,GLOBAL(protect_constants_resbase));
  const_192=makfromstr((char *)"using sos strategy",18);
  GLOBAL(protect_constants_resbase)=cons(const_192,GLOBAL(protect_constants_resbase));
  const_193=makfromstr((char *)"using unit strategy",19);
  GLOBAL(protect_constants_resbase)=cons(const_193,GLOBAL(protect_constants_resbase));
  const_194=makfromstr((char *)"using dynamic demodulation",26);
  GLOBAL(protect_constants_resbase)=cons(const_194,GLOBAL(protect_constants_resbase));
  const_195=makfromstr((char *)"using unit equality specials",28);
  GLOBAL(protect_constants_resbase)=cons(const_195,GLOBAL(protect_constants_resbase));
  const_196=makfromstr((char *)"using back demodulation",23);
  GLOBAL(protect_constants_resbase)=cons(const_196,GLOBAL(protect_constants_resbase));
  const_197=makfromstr((char *)"using lex for equality ordering",31);
  GLOBAL(protect_constants_resbase)=cons(const_197,GLOBAL(protect_constants_resbase));
  const_198=makfromstr((char *)"clause length limited to ",25);
  GLOBAL(protect_constants_resbase)=cons(const_198,GLOBAL(protect_constants_resbase));
  const_199=makfromstr((char *)"clause depth limited to ",24);
  GLOBAL(protect_constants_resbase)=cons(const_199,GLOBAL(protect_constants_resbase));
  const_200=makfromstr((char *)"initial sos preference ratio is ",32);
  GLOBAL(protect_constants_resbase)=cons(const_200,GLOBAL(protect_constants_resbase));
  const_201=makfromstr((char *)"strategies selected: ",21);
  GLOBAL(protect_constants_resbase)=cons(const_201,GLOBAL(protect_constants_resbase));
  const_202=makfromstr((char *)"using equality",14);
  GLOBAL(protect_constants_resbase)=cons(const_202,GLOBAL(protect_constants_resbase));
  const_203=makfromstr((char *)"not using equality",18);
  GLOBAL(protect_constants_resbase)=cons(const_203,GLOBAL(protect_constants_resbase));
  const_204=makfromstr((char *)"========= stats concerning the input clauses: =========",55);
  GLOBAL(protect_constants_resbase)=cons(const_204,GLOBAL(protect_constants_resbase));
  const_205=makfromstr((char *)"*input-cl-nr* ",14);
  GLOBAL(protect_constants_resbase)=cons(const_205,GLOBAL(protect_constants_resbase));
  const_206=makfromstr((char *)"*input-unitcl-nr* ",18);
  GLOBAL(protect_constants_resbase)=cons(const_206,GLOBAL(protect_constants_resbase));
  const_207=makfromstr((char *)"*input-negcl-nr* ",17);
  GLOBAL(protect_constants_resbase)=cons(const_207,GLOBAL(protect_constants_resbase));
  const_208=makfromstr((char *)"*input-poscl-nr* ",17);
  GLOBAL(protect_constants_resbase)=cons(const_208,GLOBAL(protect_constants_resbase));
  const_209=makfromstr((char *)"*input-mixcl-nr* ",17);
  GLOBAL(protect_constants_resbase)=cons(const_209,GLOBAL(protect_constants_resbase));
  const_210=makfromstr((char *)"*input-horncl-nr* ",18);
  GLOBAL(protect_constants_resbase)=cons(const_210,GLOBAL(protect_constants_resbase));
  const_211=makfromstr((char *)"*input-invhorncl-nr* ",21);
  GLOBAL(protect_constants_resbase)=cons(const_211,GLOBAL(protect_constants_resbase));
  const_212=makfromstr((char *)"*input-negdhorncl-nr* ",22);
  GLOBAL(protect_constants_resbase)=cons(const_212,GLOBAL(protect_constants_resbase));
  const_213=makfromstr((char *)"*input-wellorderedcl-nr* ",25);
  GLOBAL(protect_constants_resbase)=cons(const_213,GLOBAL(protect_constants_resbase));
  const_214=makfromstr((char *)"*input-wellhyper-nr* ",21);
  GLOBAL(protect_constants_resbase)=cons(const_214,GLOBAL(protect_constants_resbase));
  const_215=makfromstr((char *)"*input-somewhat-ordered-nr* ",28);
  GLOBAL(protect_constants_resbase)=cons(const_215,GLOBAL(protect_constants_resbase));
  const_216=makfromstr((char *)"*input-maxlen-nr* ",18);
  GLOBAL(protect_constants_resbase)=cons(const_216,GLOBAL(protect_constants_resbase));
  const_217=makfromstr((char *)"*input-maxdepth-nr* ",20);
  GLOBAL(protect_constants_resbase)=cons(const_217,GLOBAL(protect_constants_resbase));
  const_218=makfromstr((char *)"*input-contains-eq* ",20);
  GLOBAL(protect_constants_resbase)=cons(const_218,GLOBAL(protect_constants_resbase));
  const_219=makfromstr((char *)"=======================",23);
  GLOBAL(protect_constants_resbase)=cons(const_219,GLOBAL(protect_constants_resbase));
  const_220=makfromstr((char *)"|",1);
  GLOBAL(protect_constants_resbase)=cons(const_220,GLOBAL(protect_constants_resbase));
  const_221=makfromstr((char *)"SYN/SYN353-1+eq_stfp.in",23);
  GLOBAL(protect_constants_resbase)=cons(const_221,GLOBAL(protect_constants_resbase));
  const_222=makfromstr((char *)"gandalf",7);
  GLOBAL(protect_constants_resbase)=cons(const_222,GLOBAL(protect_constants_resbase));
  const_223=makfromstr((char *)"--------------------------",26);
  GLOBAL(protect_constants_resbase)=cons(const_223,GLOBAL(protect_constants_resbase));
  const_224=makfromstr((char *)"hyper-contradiction? entered: ",30);
  GLOBAL(protect_constants_resbase)=cons(const_224,GLOBAL(protect_constants_resbase));
  const_225=makfromstr((char *)"full-hyper-contradiction? entered: ",35);
  GLOBAL(protect_constants_resbase)=cons(const_225,GLOBAL(protect_constants_resbase));
  const_226=cons(EOL,EOL);
  GLOBAL(protect_constants_resbase)=cons(const_226,GLOBAL(protect_constants_resbase));
  const_227=makfromstr((char *)"11111111",8);
  GLOBAL(protect_constants_resbase)=cons(const_227,GLOBAL(protect_constants_resbase));
  const_228=makfromstr((char *)"1111",4);
  GLOBAL(protect_constants_resbase)=cons(const_228,GLOBAL(protect_constants_resbase));
  const_229=cons(cons(MAKINUM(0),EOL),EOL);
  GLOBAL(protect_constants_resbase)=cons(const_229,GLOBAL(protect_constants_resbase));
  const_230=cons(EOL,EOL);
  GLOBAL(protect_constants_resbase)=cons(const_230,GLOBAL(protect_constants_resbase));
  const_231=cons(EOL,EOL);
  GLOBAL(protect_constants_resbase)=cons(const_231,GLOBAL(protect_constants_resbase));
  const_232=cons(EOL,EOL);
  GLOBAL(protect_constants_resbase)=cons(const_232,GLOBAL(protect_constants_resbase));
  const_233=cons(EOL,EOL);
  GLOBAL(protect_constants_resbase)=cons(const_233,GLOBAL(protect_constants_resbase));
  const_234=makfromstr((char *)"|",1);
  GLOBAL(protect_constants_resbase)=cons(const_234,GLOBAL(protect_constants_resbase));
  const_235=makfromstr((char *)"/home/tanel/gandalf/gandalf.tmp",31);
  GLOBAL(protect_constants_resbase)=cons(const_235,GLOBAL(protect_constants_resbase));
  const_236=makfromstr((char *)".tmp",4);
  GLOBAL(protect_constants_resbase)=cons(const_236,GLOBAL(protect_constants_resbase));
  const_237=makfromstr((char *)"/users/cs/tammet/gandalf/",25);
  GLOBAL(protect_constants_resbase)=cons(const_237,GLOBAL(protect_constants_resbase));
  const_238=makfromstr((char *)".res",4);
  GLOBAL(protect_constants_resbase)=cons(const_238,GLOBAL(protect_constants_resbase));
  const_239=cons(cons(MAKINUM(1),x_symb),cons(cons(MAKINUM(2),y_symb),cons(cons(MAKINUM(3),z_symb),cons(cons(MAKINUM(4),u_symb),cons(cons(MAKINUM(5),v_symb),cons(cons(MAKINUM(6),w_symb),EOL))))));
  GLOBAL(protect_constants_resbase)=cons(const_239,GLOBAL(protect_constants_resbase));
  const_240=makfromstr((char *)"No argument file name given: going interactive.",47);
  GLOBAL(protect_constants_resbase)=cons(const_240,GLOBAL(protect_constants_resbase));
  const_241=makfromstr((char *)"tmp2.in",7);
  GLOBAL(protect_constants_resbase)=cons(const_241,GLOBAL(protect_constants_resbase));
  top_actions_resbase();
  _star_var_val_table_star__velts0=VELTS(GLOBAL(var_val_table_global));
  _star_var_touched_table_star__velts0=VELTS(GLOBAL(var_touched_table_global));
}

